#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 12
#define STATE_COUNT 3677
#define LARGE_STATE_COUNT 657
#define SYMBOL_COUNT 335
#define ALIAS_COUNT 7
#define TOKEN_COUNT 152
#define EXTERNAL_TOKEN_COUNT 4
#define FIELD_COUNT 39
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_BANG = 19,
  anon_sym_else = 20,
  anon_sym_if = 21,
  anon_sym_switch = 22,
  anon_sym_for = 23,
  anon_sym_LPAREN = 24,
  anon_sym_RPAREN = 25,
  anon_sym_await = 26,
  anon_sym_in = 27,
  anon_sym_of = 28,
  anon_sym_while = 29,
  anon_sym_do = 30,
  anon_sym_try = 31,
  anon_sym_with = 32,
  anon_sym_break = 33,
  anon_sym_continue = 34,
  anon_sym_debugger = 35,
  anon_sym_return = 36,
  anon_sym_throw = 37,
  anon_sym_SEMI = 38,
  anon_sym_COLON = 39,
  anon_sym_case = 40,
  anon_sym_catch = 41,
  anon_sym_finally = 42,
  anon_sym_yield = 43,
  anon_sym_LBRACK = 44,
  anon_sym_RBRACK = 45,
  anon_sym_LT = 46,
  anon_sym_GT = 47,
  anon_sym_SLASH = 48,
  sym_jsx_text = 49,
  sym_jsx_identifier = 50,
  anon_sym_DOT = 51,
  anon_sym_class = 52,
  anon_sym_async = 53,
  anon_sym_function = 54,
  anon_sym_EQ_GT = 55,
  anon_sym_QMARK_DOT = 56,
  anon_sym_new = 57,
  anon_sym_PLUS_EQ = 58,
  anon_sym_DASH_EQ = 59,
  anon_sym_STAR_EQ = 60,
  anon_sym_SLASH_EQ = 61,
  anon_sym_PERCENT_EQ = 62,
  anon_sym_CARET_EQ = 63,
  anon_sym_AMP_EQ = 64,
  anon_sym_PIPE_EQ = 65,
  anon_sym_GT_GT_EQ = 66,
  anon_sym_GT_GT_GT_EQ = 67,
  anon_sym_LT_LT_EQ = 68,
  anon_sym_STAR_STAR_EQ = 69,
  anon_sym_AMP_AMP_EQ = 70,
  anon_sym_PIPE_PIPE_EQ = 71,
  anon_sym_QMARK_QMARK_EQ = 72,
  anon_sym_DOT_DOT_DOT = 73,
  anon_sym_QMARK = 74,
  anon_sym_AMP_AMP = 75,
  anon_sym_PIPE_PIPE = 76,
  anon_sym_GT_GT = 77,
  anon_sym_GT_GT_GT = 78,
  anon_sym_LT_LT = 79,
  anon_sym_AMP = 80,
  anon_sym_CARET = 81,
  anon_sym_PIPE = 82,
  anon_sym_PLUS = 83,
  anon_sym_DASH = 84,
  anon_sym_PERCENT = 85,
  anon_sym_STAR_STAR = 86,
  anon_sym_LT_EQ = 87,
  anon_sym_EQ_EQ = 88,
  anon_sym_EQ_EQ_EQ = 89,
  anon_sym_BANG_EQ = 90,
  anon_sym_BANG_EQ_EQ = 91,
  anon_sym_GT_EQ = 92,
  anon_sym_QMARK_QMARK = 93,
  anon_sym_instanceof = 94,
  anon_sym_TILDE = 95,
  anon_sym_void = 96,
  anon_sym_delete = 97,
  anon_sym_PLUS_PLUS = 98,
  anon_sym_DASH_DASH = 99,
  anon_sym_DQUOTE = 100,
  aux_sym_string_token1 = 101,
  anon_sym_SQUOTE = 102,
  aux_sym_string_token2 = 103,
  sym_escape_sequence = 104,
  sym_comment = 105,
  anon_sym_BQUOTE = 106,
  anon_sym_DOLLAR_LBRACE = 107,
  anon_sym_SLASH2 = 108,
  sym_regex_pattern = 109,
  sym_regex_flags = 110,
  sym_number = 111,
  anon_sym_target = 112,
  sym_this = 113,
  sym_super = 114,
  sym_true = 115,
  sym_false = 116,
  sym_null = 117,
  sym_undefined = 118,
  anon_sym_AT = 119,
  anon_sym_static = 120,
  anon_sym_abstract = 121,
  anon_sym_get = 122,
  anon_sym_set = 123,
  anon_sym_declare = 124,
  anon_sym_public = 125,
  anon_sym_private = 126,
  anon_sym_protected = 127,
  anon_sym_module = 128,
  anon_sym_any = 129,
  anon_sym_number = 130,
  anon_sym_boolean = 131,
  anon_sym_string = 132,
  anon_sym_symbol = 133,
  anon_sym_require = 134,
  anon_sym_implements = 135,
  anon_sym_global = 136,
  anon_sym_interface = 137,
  anon_sym_extends = 138,
  anon_sym_enum = 139,
  sym_readonly = 140,
  anon_sym_DASH_QMARK_COLON = 141,
  anon_sym_QMARK_COLON = 142,
  anon_sym_asserts = 143,
  anon_sym_is = 144,
  anon_sym_infer = 145,
  anon_sym_keyof = 146,
  anon_sym_LBRACE_PIPE = 147,
  anon_sym_PIPE_RBRACE = 148,
  sym__automatic_semicolon = 149,
  sym__template_chars = 150,
  sym__function_signature_automatic_semicolon = 151,
  sym_program = 152,
  sym_export_statement = 153,
  sym_export_clause = 154,
  sym__import_export_specifier = 155,
  sym__declaration = 156,
  sym_import = 157,
  sym_import_statement = 158,
  sym_import_clause = 159,
  sym__from_clause = 160,
  sym_namespace_import = 161,
  sym_named_imports = 162,
  sym_expression_statement = 163,
  sym_variable_declaration = 164,
  sym_lexical_declaration = 165,
  sym_variable_declarator = 166,
  sym_statement_block = 167,
  sym_else_clause = 168,
  sym_if_statement = 169,
  sym_switch_statement = 170,
  sym_for_statement = 171,
  sym_for_in_statement = 172,
  sym__for_header = 173,
  sym_while_statement = 174,
  sym_do_statement = 175,
  sym_try_statement = 176,
  sym_with_statement = 177,
  sym_break_statement = 178,
  sym_continue_statement = 179,
  sym_debugger_statement = 180,
  sym_return_statement = 181,
  sym_throw_statement = 182,
  sym_empty_statement = 183,
  sym_labeled_statement = 184,
  sym_switch_body = 185,
  sym_switch_case = 186,
  sym_switch_default = 187,
  sym_catch_clause = 188,
  sym_finally_clause = 189,
  sym_parenthesized_expression = 190,
  sym__expression = 191,
  sym_yield_expression = 192,
  sym_object = 193,
  sym_assignment_pattern = 194,
  sym_array = 195,
  sym_jsx_element = 196,
  sym_jsx_fragment = 197,
  sym_jsx_expression = 198,
  sym_jsx_opening_element = 199,
  sym_nested_identifier = 200,
  sym_jsx_namespace_name = 201,
  sym_jsx_closing_element = 202,
  sym_jsx_self_closing_element = 203,
  sym_jsx_attribute = 204,
  sym_class = 205,
  sym_class_declaration = 206,
  sym_class_heritage = 207,
  sym_function = 208,
  sym_function_declaration = 209,
  sym_generator_function = 210,
  sym_generator_function_declaration = 211,
  sym_arrow_function = 212,
  sym__call_signature = 213,
  sym_call_expression = 214,
  sym_new_expression = 215,
  sym_await_expression = 216,
  sym_member_expression = 217,
  sym_subscript_expression = 218,
  sym_assignment_expression = 219,
  sym__augmented_assignment_lhs = 220,
  sym_augmented_assignment_expression = 221,
  sym__initializer = 222,
  sym_spread_element = 223,
  sym_ternary_expression = 224,
  sym_binary_expression = 225,
  sym_unary_expression = 226,
  sym_update_expression = 227,
  sym_sequence_expression = 228,
  sym_string = 229,
  sym_template_string = 230,
  sym_template_substitution = 231,
  sym_regex = 232,
  sym_meta_property = 233,
  sym_arguments = 234,
  sym_decorator = 235,
  sym_decorator_member_expression = 236,
  sym_decorator_call_expression = 237,
  sym_class_body = 238,
  sym_public_field_definition = 239,
  sym_formal_parameters = 240,
  sym_rest_parameter = 241,
  sym_method_definition = 242,
  sym_pair = 243,
  sym__property_name = 244,
  sym_computed_property_name = 245,
  sym_non_null_expression = 246,
  sym_method_signature = 247,
  sym_abstract_method_signature = 248,
  sym_function_signature = 249,
  sym_as_expression = 250,
  sym_import_require_clause = 251,
  sym_implements_clause = 252,
  sym_ambient_declaration = 253,
  sym_abstract_class_declaration = 254,
  sym_module = 255,
  sym_internal_module = 256,
  sym__module = 257,
  sym_import_alias = 258,
  sym_nested_type_identifier = 259,
  sym_interface_declaration = 260,
  sym_extends_clause = 261,
  sym_enum_declaration = 262,
  sym_enum_body = 263,
  sym_enum_assignment = 264,
  sym_type_alias_declaration = 265,
  sym_accessibility_modifier = 266,
  sym_required_parameter = 267,
  sym_optional_parameter = 268,
  sym__parameter_name = 269,
  sym__rest_identifier = 270,
  sym_rest_identifier = 271,
  sym_omitting_type_annotation = 272,
  sym_opting_type_annotation = 273,
  sym_type_annotation = 274,
  sym_asserts = 275,
  sym__type = 276,
  sym_optional_identifier = 277,
  sym__tuple_type_identifier = 278,
  sym_labeled_tuple_type_member = 279,
  sym__tuple_type_member = 280,
  sym_constructor_type = 281,
  sym__primary_type = 282,
  sym_infer_type = 283,
  sym_conditional_type = 284,
  sym_generic_type = 285,
  sym_type_predicate = 286,
  sym_type_predicate_annotation = 287,
  sym_type_query = 288,
  sym_index_type_query = 289,
  sym_lookup_type = 290,
  sym_mapped_type_clause = 291,
  sym_literal_type = 292,
  sym__number = 293,
  sym_existential_type = 294,
  sym_flow_maybe_type = 295,
  sym_parenthesized_type = 296,
  sym_predefined_type = 297,
  sym_type_arguments = 298,
  sym_object_type = 299,
  sym_call_signature = 300,
  sym_property_signature = 301,
  sym_type_parameters = 302,
  sym_type_parameter = 303,
  sym_default_type = 304,
  sym_constraint = 305,
  sym_construct_signature = 306,
  sym_index_signature = 307,
  sym_array_type = 308,
  sym__tuple_type_body = 309,
  sym_tuple_type = 310,
  sym_union_type = 311,
  sym_intersection_type = 312,
  sym_function_type = 313,
  aux_sym_program_repeat1 = 314,
  aux_sym_export_statement_repeat1 = 315,
  aux_sym_export_clause_repeat1 = 316,
  aux_sym_named_imports_repeat1 = 317,
  aux_sym_variable_declaration_repeat1 = 318,
  aux_sym_switch_body_repeat1 = 319,
  aux_sym_object_repeat1 = 320,
  aux_sym_array_repeat1 = 321,
  aux_sym_jsx_element_repeat1 = 322,
  aux_sym_string_repeat1 = 323,
  aux_sym_string_repeat2 = 324,
  aux_sym_template_string_repeat1 = 325,
  aux_sym_class_body_repeat1 = 326,
  aux_sym_formal_parameters_repeat1 = 327,
  aux_sym__jsx_start_opening_element_repeat1 = 328,
  aux_sym_implements_clause_repeat1 = 329,
  aux_sym_extends_clause_repeat1 = 330,
  aux_sym_enum_body_repeat1 = 331,
  aux_sym_object_type_repeat1 = 332,
  aux_sym_type_parameters_repeat1 = 333,
  aux_sym__tuple_type_body_repeat1 = 334,
  alias_sym_array_pattern = 335,
  alias_sym_import_specifier = 336,
  alias_sym_object_pattern = 337,
  alias_sym_property_identifier = 338,
  alias_sym_shorthand_property_identifier = 339,
  alias_sym_statement_identifier = 340,
  alias_sym_type_identifier = 341,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [sym_jsx_text] = "jsx_text",
  [sym_jsx_identifier] = "identifier",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "\?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [sym_readonly] = "readonly",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_asserts] = "asserts",
  [anon_sym_is] = "is",
  [anon_sym_infer] = "infer",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym__function_signature_automatic_semicolon] = "_function_signature_automatic_semicolon",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_jsx_element] = "jsx_element",
  [sym_jsx_fragment] = "jsx_fragment",
  [sym_jsx_expression] = "jsx_expression",
  [sym_jsx_opening_element] = "jsx_opening_element",
  [sym_nested_identifier] = "nested_identifier",
  [sym_jsx_namespace_name] = "jsx_namespace_name",
  [sym_jsx_closing_element] = "jsx_closing_element",
  [sym_jsx_self_closing_element] = "jsx_self_closing_element",
  [sym_jsx_attribute] = "jsx_attribute",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym__rest_identifier] = "_rest_identifier",
  [sym_rest_identifier] = "rest_identifier",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym_asserts] = "asserts",
  [sym__type] = "_type",
  [sym_optional_identifier] = "optional_identifier",
  [sym__tuple_type_identifier] = "_tuple_type_identifier",
  [sym_labeled_tuple_type_member] = "labeled_tuple_type_member",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_infer_type] = "infer_type",
  [sym_conditional_type] = "conditional_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym__tuple_type_body] = "_tuple_type_body",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_jsx_element_repeat1] = "jsx_element_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym__jsx_start_opening_element_repeat1] = "_jsx_start_opening_element_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym__tuple_type_body_repeat1] = "_tuple_type_body_repeat1",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [sym_jsx_text] = sym_jsx_text,
  [sym_jsx_identifier] = sym_identifier,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_enum] = anon_sym_enum,
  [sym_readonly] = sym_readonly,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_asserts] = anon_sym_asserts,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym__declaration] = sym__declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__expression] = sym__expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_array] = sym_array,
  [sym_jsx_element] = sym_jsx_element,
  [sym_jsx_fragment] = sym_jsx_fragment,
  [sym_jsx_expression] = sym_jsx_expression,
  [sym_jsx_opening_element] = sym_jsx_opening_element,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_jsx_namespace_name] = sym_jsx_namespace_name,
  [sym_jsx_closing_element] = sym_jsx_closing_element,
  [sym_jsx_self_closing_element] = sym_jsx_self_closing_element,
  [sym_jsx_attribute] = sym_jsx_attribute,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_rest_parameter] = sym_rest_parameter,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_as_expression] = sym_as_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_clause] = sym_extends_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym__rest_identifier] = sym__rest_identifier,
  [sym_rest_identifier] = sym_rest_identifier,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym_asserts] = sym_asserts,
  [sym__type] = sym__type,
  [sym_optional_identifier] = sym_optional_identifier,
  [sym__tuple_type_identifier] = sym__tuple_type_identifier,
  [sym_labeled_tuple_type_member] = sym_labeled_tuple_type_member,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_infer_type] = sym_infer_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym__tuple_type_body] = sym__tuple_type_body,
  [sym_tuple_type] = sym_tuple_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_jsx_element_repeat1] = aux_sym_jsx_element_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym__jsx_start_opening_element_repeat1] = aux_sym__jsx_start_opening_element_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym__tuple_type_body_repeat1] = aux_sym__tuple_type_body_repeat1,
  [alias_sym_array_pattern] = alias_sym_array_pattern,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_object_pattern] = alias_sym_object_pattern,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_jsx_text] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym__function_signature_automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_opening_element] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_self_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym__rest_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_rest_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_labeled_tuple_type_member] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_infer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_body] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__jsx_start_opening_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__tuple_type_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_close_tag = 7,
  field_condition = 8,
  field_consequence = 9,
  field_constructor = 10,
  field_declaration = 11,
  field_decorator = 12,
  field_finalizer = 13,
  field_flags = 14,
  field_function = 15,
  field_handler = 16,
  field_increment = 17,
  field_index = 18,
  field_initializer = 19,
  field_key = 20,
  field_label = 21,
  field_left = 22,
  field_module = 23,
  field_name = 24,
  field_object = 25,
  field_open_tag = 26,
  field_operator = 27,
  field_parameter = 28,
  field_parameters = 29,
  field_pattern = 30,
  field_property = 31,
  field_return_type = 32,
  field_right = 33,
  field_sign = 34,
  field_source = 35,
  field_type = 36,
  field_type_arguments = 37,
  field_type_parameters = 38,
  field_value = 39,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[208] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 3, .length = 1},
  [10] = {.index = 3, .length = 1},
  [13] = {.index = 8, .length = 1},
  [15] = {.index = 9, .length = 1},
  [16] = {.index = 9, .length = 1},
  [17] = {.index = 10, .length = 2},
  [18] = {.index = 12, .length = 2},
  [19] = {.index = 14, .length = 2},
  [20] = {.index = 16, .length = 2},
  [21] = {.index = 18, .length = 2},
  [22] = {.index = 20, .length = 2},
  [23] = {.index = 22, .length = 2},
  [24] = {.index = 24, .length = 1},
  [25] = {.index = 25, .length = 2},
  [26] = {.index = 27, .length = 2},
  [27] = {.index = 29, .length = 2},
  [28] = {.index = 31, .length = 2},
  [30] = {.index = 33, .length = 2},
  [31] = {.index = 35, .length = 2},
  [32] = {.index = 33, .length = 2},
  [33] = {.index = 35, .length = 2},
  [34] = {.index = 33, .length = 2},
  [35] = {.index = 35, .length = 2},
  [36] = {.index = 37, .length = 2},
  [37] = {.index = 39, .length = 2},
  [38] = {.index = 41, .length = 3},
  [42] = {.index = 44, .length = 1},
  [43] = {.index = 45, .length = 2},
  [44] = {.index = 47, .length = 2},
  [45] = {.index = 49, .length = 2},
  [46] = {.index = 51, .length = 2},
  [47] = {.index = 53, .length = 1},
  [48] = {.index = 54, .length = 1},
  [49] = {.index = 55, .length = 1},
  [50] = {.index = 56, .length = 1},
  [51] = {.index = 57, .length = 2},
  [53] = {.index = 59, .length = 1},
  [54] = {.index = 60, .length = 2},
  [55] = {.index = 62, .length = 4},
  [56] = {.index = 66, .length = 2},
  [57] = {.index = 68, .length = 2},
  [58] = {.index = 66, .length = 2},
  [59] = {.index = 68, .length = 2},
  [60] = {.index = 25, .length = 2},
  [61] = {.index = 29, .length = 2},
  [62] = {.index = 22, .length = 2},
  [63] = {.index = 27, .length = 2},
  [64] = {.index = 57, .length = 2},
  [65] = {.index = 70, .length = 3},
  [66] = {.index = 73, .length = 2},
  [67] = {.index = 75, .length = 3},
  [68] = {.index = 22, .length = 2},
  [69] = {.index = 22, .length = 2},
  [70] = {.index = 78, .length = 2},
  [71] = {.index = 80, .length = 4},
  [72] = {.index = 84, .length = 3},
  [73] = {.index = 87, .length = 2},
  [74] = {.index = 89, .length = 1},
  [75] = {.index = 90, .length = 1},
  [76] = {.index = 91, .length = 1},
  [77] = {.index = 92, .length = 2},
  [78] = {.index = 94, .length = 3},
  [79] = {.index = 22, .length = 2},
  [80] = {.index = 97, .length = 2},
  [81] = {.index = 99, .length = 5},
  [82] = {.index = 104, .length = 2},
  [83] = {.index = 106, .length = 1},
  [84] = {.index = 107, .length = 2},
  [85] = {.index = 109, .length = 3},
  [86] = {.index = 109, .length = 3},
  [87] = {.index = 109, .length = 3},
  [88] = {.index = 112, .length = 2},
  [89] = {.index = 114, .length = 3},
  [90] = {.index = 117, .length = 3},
  [94] = {.index = 120, .length = 1},
  [95] = {.index = 121, .length = 3},
  [96] = {.index = 124, .length = 2},
  [97] = {.index = 126, .length = 2},
  [98] = {.index = 128, .length = 2},
  [99] = {.index = 130, .length = 2},
  [100] = {.index = 132, .length = 4},
  [101] = {.index = 136, .length = 2},
  [102] = {.index = 138, .length = 3},
  [103] = {.index = 141, .length = 3},
  [104] = {.index = 144, .length = 2},
  [105] = {.index = 146, .length = 2},
  [106] = {.index = 148, .length = 4},
  [107] = {.index = 146, .length = 2},
  [108] = {.index = 152, .length = 4},
  [109] = {.index = 156, .length = 4},
  [110] = {.index = 160, .length = 5},
  [111] = {.index = 165, .length = 3},
  [112] = {.index = 165, .length = 3},
  [113] = {.index = 92, .length = 2},
  [114] = {.index = 94, .length = 3},
  [115] = {.index = 112, .length = 2},
  [116] = {.index = 168, .length = 3},
  [117] = {.index = 171, .length = 2},
  [118] = {.index = 173, .length = 3},
  [119] = {.index = 176, .length = 2},
  [120] = {.index = 104, .length = 2},
  [121] = {.index = 178, .length = 2},
  [122] = {.index = 180, .length = 5},
  [123] = {.index = 185, .length = 2},
  [124] = {.index = 187, .length = 1},
  [125] = {.index = 188, .length = 1},
  [126] = {.index = 189, .length = 1},
  [127] = {.index = 190, .length = 1},
  [128] = {.index = 191, .length = 2},
  [129] = {.index = 193, .length = 3},
  [130] = {.index = 196, .length = 1},
  [131] = {.index = 197, .length = 2},
  [132] = {.index = 199, .length = 2},
  [133] = {.index = 201, .length = 2},
  [134] = {.index = 203, .length = 4},
  [135] = {.index = 207, .length = 3},
  [136] = {.index = 210, .length = 2},
  [137] = {.index = 212, .length = 4},
  [138] = {.index = 216, .length = 4},
  [139] = {.index = 220, .length = 5},
  [140] = {.index = 178, .length = 2},
  [141] = {.index = 225, .length = 2},
  [142] = {.index = 227, .length = 3},
  [143] = {.index = 230, .length = 3},
  [144] = {.index = 233, .length = 2},
  [145] = {.index = 235, .length = 3},
  [146] = {.index = 238, .length = 4},
  [147] = {.index = 242, .length = 3},
  [148] = {.index = 245, .length = 3},
  [149] = {.index = 248, .length = 2},
  [150] = {.index = 250, .length = 5},
  [151] = {.index = 255, .length = 3},
  [152] = {.index = 258, .length = 2},
  [153] = {.index = 258, .length = 2},
  [154] = {.index = 260, .length = 3},
  [155] = {.index = 258, .length = 2},
  [156] = {.index = 258, .length = 2},
  [157] = {.index = 263, .length = 2},
  [158] = {.index = 265, .length = 4},
  [159] = {.index = 269, .length = 2},
  [160] = {.index = 271, .length = 2},
  [161] = {.index = 273, .length = 2},
  [162] = {.index = 275, .length = 2},
  [163] = {.index = 277, .length = 3},
  [164] = {.index = 280, .length = 3},
  [165] = {.index = 283, .length = 1},
  [166] = {.index = 284, .length = 5},
  [167] = {.index = 289, .length = 3},
  [169] = {.index = 292, .length = 4},
  [170] = {.index = 296, .length = 3},
  [171] = {.index = 299, .length = 4},
  [172] = {.index = 303, .length = 5},
  [173] = {.index = 308, .length = 2},
  [174] = {.index = 308, .length = 2},
  [175] = {.index = 308, .length = 2},
  [176] = {.index = 308, .length = 2},
  [177] = {.index = 310, .length = 4},
  [178] = {.index = 314, .length = 2},
  [179] = {.index = 314, .length = 2},
  [180] = {.index = 314, .length = 2},
  [181] = {.index = 316, .length = 4},
  [182] = {.index = 320, .length = 4},
  [183] = {.index = 324, .length = 2},
  [184] = {.index = 326, .length = 2},
  [185] = {.index = 328, .length = 3},
  [186] = {.index = 331, .length = 3},
  [187] = {.index = 334, .length = 2},
  [188] = {.index = 336, .length = 2},
  [189] = {.index = 338, .length = 4},
  [190] = {.index = 342, .length = 5},
  [191] = {.index = 347, .length = 5},
  [192] = {.index = 352, .length = 1},
  [193] = {.index = 353, .length = 4},
  [194] = {.index = 357, .length = 4},
  [195] = {.index = 361, .length = 3},
  [196] = {.index = 364, .length = 2},
  [197] = {.index = 366, .length = 2},
  [198] = {.index = 368, .length = 3},
  [199] = {.index = 371, .length = 5},
  [200] = {.index = 376, .length = 5},
  [201] = {.index = 381, .length = 4},
  [202] = {.index = 385, .length = 4},
  [203] = {.index = 389, .length = 3},
  [204] = {.index = 392, .length = 4},
  [205] = {.index = 396, .length = 5},
  [206] = {.index = 352, .length = 1},
  [207] = {.index = 401, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_body, 1},
  [9] =
    {field_constructor, 1},
  [10] =
    {field_argument, 0},
    {field_operator, 1},
  [12] =
    {field_arguments, 1},
    {field_function, 0},
  [14] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [16] =
    {field_parameters, 0},
    {field_return_type, 1},
  [18] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [20] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [22] =
    {field_left, 0},
    {field_right, 2},
  [24] =
    {field_label, 0},
  [25] =
    {field_object, 0},
    {field_property, 2},
  [27] =
    {field_body, 2},
    {field_parameter, 0},
  [29] =
    {field_arguments, 2},
    {field_function, 0},
  [31] =
    {field_body, 1},
    {field_name, 0},
  [33] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [35] =
    {field_name, 0},
    {field_type, 1},
  [37] =
    {field_condition, 1},
    {field_consequence, 2},
  [39] =
    {field_body, 2},
    {field_value, 1},
  [41] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [44] =
    {field_value, 1, .inherited = true},
  [45] =
    {field_body, 2},
    {field_condition, 1},
  [47] =
    {field_body, 1},
    {field_handler, 2},
  [49] =
    {field_body, 1},
    {field_finalizer, 2},
  [51] =
    {field_body, 2},
    {field_object, 1},
  [53] =
    {field_label, 1},
  [54] =
    {field_name, 1},
  [55] =
    {field_attribute, 0},
  [56] =
    {field_pattern, 1},
  [57] =
    {field_body, 2},
    {field_name, 1},
  [59] =
    {field_body, 2},
  [60] =
    {field_body, 2},
    {field_type_parameters, 1},
  [62] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [66] =
    {field_arguments, 2},
    {field_constructor, 1},
  [68] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [70] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [73] =
    {field_argument, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [75] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [78] =
    {field_close_tag, 2},
    {field_open_tag, 0},
  [80] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [84] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [87] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [89] =
    {field_source, 1},
  [90] =
    {field_source, 2, .inherited = true},
  [91] =
    {field_value, 2},
  [92] =
    {field_index, 2},
    {field_object, 0},
  [94] =
    {field_arguments, 3},
    {field_function, 0},
    {field_type_arguments, 2},
  [97] =
    {field_key, 0},
    {field_value, 2},
  [99] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [104] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [106] =
    {field_value, 1},
  [107] =
    {field_name, 0},
    {field_type, 2},
  [109] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [112] =
    {field_body, 3},
    {field_name, 2},
  [114] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [117] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [120] =
    {field_value, 2, .inherited = true},
  [121] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [124] =
    {field_attribute, 2, .inherited = true},
    {field_name, 1},
  [126] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
  [128] =
    {field_name, 1},
    {field_type_arguments, 2},
  [130] =
    {field_flags, 3},
    {field_pattern, 1},
  [132] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [136] =
    {field_body, 3},
    {field_name, 1},
  [138] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [141] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [144] =
    {field_body, 3},
    {field_type_parameters, 1},
  [146] =
    {field_body, 3},
    {field_parameter, 1},
  [148] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [152] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [156] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [160] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [165] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [168] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [171] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [173] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [176] =
    {field_alias, 2},
    {field_name, 0},
  [178] =
    {field_index, 3},
    {field_object, 0},
  [180] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [185] =
    {field_name, 1},
    {field_value, 3},
  [187] =
    {field_source, 3, .inherited = true},
  [188] =
    {field_decorator, 1, .inherited = true},
  [189] =
    {field_decorator, 2, .inherited = true},
  [190] =
    {field_value, 3, .inherited = true},
  [191] =
    {field_body, 1},
    {field_condition, 3},
  [193] =
    {field_attribute, 3, .inherited = true},
    {field_name, 1},
    {field_type_arguments, 2},
  [196] =
    {field_name, 2},
  [197] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [199] =
    {field_name, 1},
    {field_type, 2},
  [201] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [203] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [207] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [210] =
    {field_module, 0},
    {field_name, 2},
  [212] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [216] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [220] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [225] =
    {field_body, 4},
    {field_name, 2},
  [227] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [230] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [233] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [235] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [238] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [242] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [245] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [248] =
    {field_alias, 3},
    {field_name, 1},
  [250] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [255] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [258] =
    {field_left, 1},
    {field_right, 3},
  [260] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [263] =
    {field_decorator, 1, .inherited = true},
    {field_decorator, 3, .inherited = true},
  [265] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [269] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [271] =
    {field_name, 2},
    {field_type, 3},
  [273] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [275] =
    {field_name, 1},
    {field_type, 3},
  [277] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [280] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [283] =
    {field_name, 3},
  [284] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [289] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [292] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [296] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [299] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [303] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [308] =
    {field_left, 2},
    {field_right, 4},
  [310] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [314] =
    {field_body, 4},
    {field_parameter, 2},
  [316] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [320] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [324] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [326] =
    {field_name, 2},
    {field_type, 4},
  [328] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [331] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [334] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [336] =
    {field_name, 3},
    {field_type, 4},
  [338] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [342] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [347] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [352] =
    {field_sign, 0},
  [353] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [357] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [361] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [364] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [366] =
    {field_name, 3},
    {field_type, 5},
  [368] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [371] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [376] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [381] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [385] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [389] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [392] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [396] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [401] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
};

static TSSymbol ts_alias_sequences[208][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [9] = {
    [0] = alias_sym_object_pattern,
  },
  [10] = {
    [0] = alias_sym_array_pattern,
  },
  [11] = {
    [0] = alias_sym_object_pattern,
  },
  [12] = {
    [0] = alias_sym_array_pattern,
  },
  [14] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [1] = sym_identifier,
  },
  [23] = {
    [0] = sym_identifier,
  },
  [24] = {
    [0] = alias_sym_statement_identifier,
  },
  [25] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [26] = {
    [0] = sym_identifier,
  },
  [27] = {
    [0] = sym_identifier,
  },
  [29] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [32] = {
    [0] = alias_sym_object_pattern,
  },
  [33] = {
    [0] = alias_sym_object_pattern,
  },
  [34] = {
    [0] = alias_sym_array_pattern,
  },
  [35] = {
    [0] = alias_sym_array_pattern,
  },
  [39] = {
    [1] = sym_identifier,
  },
  [40] = {
    [1] = alias_sym_object_pattern,
  },
  [41] = {
    [1] = alias_sym_array_pattern,
  },
  [47] = {
    [1] = alias_sym_statement_identifier,
  },
  [51] = {
    [1] = alias_sym_type_identifier,
  },
  [52] = {
    [1] = alias_sym_type_identifier,
  },
  [56] = {
    [1] = sym_identifier,
  },
  [57] = {
    [1] = sym_identifier,
  },
  [60] = {
    [2] = alias_sym_property_identifier,
  },
  [68] = {
    [0] = alias_sym_object_pattern,
  },
  [69] = {
    [0] = alias_sym_array_pattern,
  },
  [77] = {
    [0] = sym_identifier,
  },
  [78] = {
    [0] = sym_identifier,
  },
  [79] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [82] = {
    [1] = alias_sym_import_specifier,
  },
  [86] = {
    [0] = alias_sym_object_pattern,
  },
  [87] = {
    [0] = alias_sym_array_pattern,
  },
  [91] = {
    [2] = sym_identifier,
  },
  [92] = {
    [2] = alias_sym_object_pattern,
  },
  [93] = {
    [2] = alias_sym_array_pattern,
  },
  [101] = {
    [1] = alias_sym_type_identifier,
  },
  [102] = {
    [1] = alias_sym_type_identifier,
  },
  [105] = {
    [1] = sym_identifier,
  },
  [111] = {
    [1] = sym_identifier,
  },
  [115] = {
    [2] = alias_sym_type_identifier,
  },
  [116] = {
    [2] = alias_sym_type_identifier,
  },
  [121] = {
    [0] = sym_identifier,
  },
  [123] = {
    [1] = alias_sym_type_identifier,
  },
  [135] = {
    [1] = alias_sym_type_identifier,
  },
  [136] = {
    [2] = alias_sym_type_identifier,
  },
  [141] = {
    [2] = alias_sym_type_identifier,
  },
  [142] = {
    [2] = alias_sym_type_identifier,
  },
  [145] = {
    [2] = alias_sym_type_identifier,
  },
  [146] = {
    [2] = alias_sym_type_identifier,
  },
  [148] = {
    [3] = alias_sym_type_identifier,
  },
  [151] = {
    [1] = alias_sym_type_identifier,
  },
  [152] = {
    [1] = sym_identifier,
  },
  [155] = {
    [1] = alias_sym_object_pattern,
  },
  [156] = {
    [1] = alias_sym_array_pattern,
  },
  [167] = {
    [2] = alias_sym_type_identifier,
  },
  [168] = {
    [3] = alias_sym_property_identifier,
  },
  [169] = {
    [2] = alias_sym_type_identifier,
  },
  [170] = {
    [3] = alias_sym_type_identifier,
  },
  [171] = {
    [3] = alias_sym_type_identifier,
  },
  [173] = {
    [2] = sym_identifier,
  },
  [175] = {
    [2] = alias_sym_object_pattern,
  },
  [176] = {
    [2] = alias_sym_array_pattern,
  },
  [179] = {
    [2] = alias_sym_object_pattern,
  },
  [180] = {
    [2] = alias_sym_array_pattern,
  },
  [189] = {
    [3] = alias_sym_type_identifier,
  },
  [206] = {
    [3] = sym_identifier,
  },
};

static uint16_t ts_non_terminal_alias_map[] = {
  sym__import_export_specifier, 2,
    sym__import_export_specifier,
    alias_sym_import_specifier,
  sym_object, 2,
    sym_object,
    alias_sym_object_pattern,
  sym_array, 2,
    sym_array,
    alias_sym_array_pattern,
  0,
};

static inline bool sym_identifier_character_set_1(int32_t lookahead) {
  return
    lookahead == 0 ||
    (0 <= lookahead && lookahead <= '#') ||
    ('%' <= lookahead && lookahead <= '/') ||
    (':' <= lookahead && lookahead <= '@') ||
    ('[' <= lookahead && lookahead <= '^') ||
    lookahead == '`' ||
    ('{' <= lookahead && lookahead <= '~') ||
    lookahead == 160 ||
    lookahead == 8203 ||
    lookahead == 8288 ||
    lookahead == 65279;
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(173);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '$') ADVANCE(213);
      if (lookahead == '%') ADVANCE(159);
      if (lookahead == '&') ADVANCE(141);
      if (lookahead == '\'') ADVANCE(180);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(153);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(157);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '/') ADVANCE(198);
      if (lookahead == '0') ADVANCE(203);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(96);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(147);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(69)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(204);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead)) ADVANCE(214);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(19)
      if (lookahead == '"') ADVANCE(173);
      if (lookahead == '/') ADVANCE(175);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(178);
      if (lookahead != 0) ADVANCE(179);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(174);
      if (lookahead == '\r') ADVANCE(188);
      if (lookahead == 'u') ADVANCE(42);
      if (lookahead == 'x') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(192);
      if (lookahead != 0) ADVANCE(187);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(23)
      if (lookahead == '\'') ADVANCE(180);
      if (lookahead == '/') ADVANCE(182);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(185);
      if (lookahead != 0) ADVANCE(186);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(181);
      if (lookahead == '\r') ADVANCE(189);
      if (lookahead == 'u') ADVANCE(42);
      if (lookahead == 'x') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(192);
      if (lookahead != 0) ADVANCE(187);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(29)
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '[') ADVANCE(35);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(199);
      if (lookahead != 0) ADVANCE(200);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(173);
      if (lookahead == '%') ADVANCE(159);
      if (lookahead == '&') ADVANCE(141);
      if (lookahead == '\'') ADVANCE(180);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(153);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(156);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(99);
      if (lookahead == '0') ADVANCE(203);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(96);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(147);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(204);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          lookahead != '~') ADVANCE(214);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(173);
      if (lookahead == '%') ADVANCE(159);
      if (lookahead == '&') ADVANCE(141);
      if (lookahead == '\'') ADVANCE(180);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(153);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(156);
      if (lookahead == '.') ADVANCE(106);
      if (lookahead == '/') ADVANCE(99);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(96);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(146);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '0' || '9' < lookahead) &&
          lookahead != '~') ADVANCE(214);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(173);
      if (lookahead == '%') ADVANCE(158);
      if (lookahead == '&') ADVANCE(142);
      if (lookahead == '\'') ADVANCE(180);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(152);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(203);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == '<') ADVANCE(94);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(97);
      if (lookahead == '?') ADVANCE(129);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '^') ADVANCE(143);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(148);
      if (lookahead == '~') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(204);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(214);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '%') ADVANCE(158);
      if (lookahead == '&') ADVANCE(142);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(152);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(106);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(94);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(97);
      if (lookahead == '?') ADVANCE(129);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(143);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(148);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(201);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(214);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '%') ADVANCE(158);
      if (lookahead == '&') ADVANCE(142);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(152);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(106);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(94);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(97);
      if (lookahead == '?') ADVANCE(129);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(143);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(148);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(214);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '%') ADVANCE(158);
      if (lookahead == '&') ADVANCE(142);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(152);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(106);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '<') ADVANCE(94);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(97);
      if (lookahead == '?') ADVANCE(129);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '^') ADVANCE(143);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(148);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(201);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(214);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '%') ADVANCE(158);
      if (lookahead == '&') ADVANCE(142);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(152);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(106);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '<') ADVANCE(94);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(97);
      if (lookahead == '?') ADVANCE(129);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '^') ADVANCE(143);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(148);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(214);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(73);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(173);
      if (lookahead == '&') ADVANCE(140);
      if (lookahead == '\'') ADVANCE(180);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(152);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(203);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(145);
      if (lookahead == '~') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(14)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(204);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(214);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(173);
      if (lookahead == '&') ADVANCE(140);
      if (lookahead == '\'') ADVANCE(180);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(151);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(154);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(198);
      if (lookahead == '0') ADVANCE(203);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '=') ADVANCE(77);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(150);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(204);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          lookahead != '%' &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(214);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(173);
      if (lookahead == '&') ADVANCE(140);
      if (lookahead == '\'') ADVANCE(180);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(151);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(154);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '0') ADVANCE(203);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '=') ADVANCE(77);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(150);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(204);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          lookahead != '%' &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(214);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(173);
      if (lookahead == '&') ADVANCE(140);
      if (lookahead == '\'') ADVANCE(180);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(151);
      if (lookahead == '-') ADVANCE(154);
      if (lookahead == '.') ADVANCE(51);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(203);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(145);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(204);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(212);
      if (lookahead != 0 &&
          (lookahead < 0 || '~' < lookahead)) ADVANCE(214);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(180);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(154);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '0') ADVANCE(203);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(45);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(18)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(204);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(214);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(173);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      END_STATE();
    case 20:
      if (lookahead == '$') ADVANCE(39);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '\\') ADVANCE(38);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(21)
      END_STATE();
    case 21:
      if (lookahead == '$') ADVANCE(39);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(21)
      END_STATE();
    case 22:
      if (lookahead == '&') ADVANCE(140);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(34);
      if (lookahead == '.') ADVANCE(106);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '=') ADVANCE(77);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead == '?') ADVANCE(32);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(145);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(22)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(212);
      if (lookahead != 0 &&
          (lookahead < 0 || '~' < lookahead)) ADVANCE(214);
      END_STATE();
    case 23:
      if (lookahead == '\'') ADVANCE(180);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(23)
      END_STATE();
    case 24:
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(195);
      END_STATE();
    case 25:
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(193);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == '*') ADVANCE(25);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(210);
      END_STATE();
    case 28:
      if (lookahead == '.') ADVANCE(126);
      END_STATE();
    case 29:
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(29)
      END_STATE();
    case 30:
      if (lookahead == '/') ADVANCE(100);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}') ADVANCE(104);
      END_STATE();
    case 31:
      if (lookahead == ':') ADVANCE(216);
      END_STATE();
    case 32:
      if (lookahead == ':') ADVANCE(217);
      END_STATE();
    case 33:
      if (lookahead == '=') ADVANCE(163);
      END_STATE();
    case 34:
      if (lookahead == '?') ADVANCE(31);
      END_STATE();
    case 35:
      if (lookahead == '\\') ADVANCE(67);
      if (lookahead == ']') ADVANCE(200);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(35);
      END_STATE();
    case 36:
      if (lookahead == 'u') ADVANCE(40);
      if (lookahead == 'x') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(192);
      if (lookahead != 0) ADVANCE(187);
      END_STATE();
    case 37:
      if (lookahead == 'u') ADVANCE(41);
      END_STATE();
    case 38:
      if (lookahead == 'u') ADVANCE(42);
      if (lookahead == 'x') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(192);
      if (lookahead != 0) ADVANCE(187);
      END_STATE();
    case 39:
      if (lookahead == '{') ADVANCE(197);
      END_STATE();
    case 40:
      if (lookahead == '{') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 41:
      if (lookahead == '{') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 42:
      if (lookahead == '{') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 43:
      if (lookahead == '}') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 44:
      if (lookahead == '}') ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 45:
      if (lookahead == '}') ADVANCE(219);
      END_STATE();
    case 46:
      if (lookahead == '}') ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 47:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      END_STATE();
    case 48:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(205);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(206);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(204);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(210);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(208);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(214);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(187);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(207);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(190);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 67:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(35);
      END_STATE();
    case 68:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(200);
      END_STATE();
    case 69:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(173);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '$') ADVANCE(213);
      if (lookahead == '%') ADVANCE(159);
      if (lookahead == '&') ADVANCE(141);
      if (lookahead == '\'') ADVANCE(180);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(153);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(157);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(203);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(93);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(96);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(81);
      if (lookahead == '|') ADVANCE(147);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(69)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(204);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead)) ADVANCE(214);
      END_STATE();
    case 70:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(85);
      if (lookahead == '"') ADVANCE(173);
      if (lookahead == '%') ADVANCE(158);
      if (lookahead == '&') ADVANCE(142);
      if (lookahead == '\'') ADVANCE(180);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(152);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(203);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(94);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(97);
      if (lookahead == '?') ADVANCE(129);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '^') ADVANCE(143);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(149);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(70)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(204);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead)) ADVANCE(214);
      END_STATE();
    case 71:
      if (eof) ADVANCE(72);
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(173);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '&') ADVANCE(140);
      if (lookahead == '\'') ADVANCE(180);
      if (lookahead == '(') ADVANCE(86);
      if (lookahead == ')') ADVANCE(87);
      if (lookahead == '*') ADVANCE(74);
      if (lookahead == '+') ADVANCE(152);
      if (lookahead == ',') ADVANCE(82);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(203);
      if (lookahead == ':') ADVANCE(89);
      if (lookahead == ';') ADVANCE(88);
      if (lookahead == '<') ADVANCE(92);
      if (lookahead == '=') ADVANCE(79);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead == '?') ADVANCE(127);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(90);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == ']') ADVANCE(91);
      if (lookahead == '`') ADVANCE(196);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(150);
      if (lookahead == '}') ADVANCE(83);
      if (lookahead == '~') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(71)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(204);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead) &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(214);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(73);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(161);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(160);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(163);
      if (lookahead == '>') ADVANCE(109);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(109);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(218);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(165);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(139);
      if (lookahead == '=') ADVANCE(162);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(138);
      if (lookahead == '=') ADVANCE(162);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(167);
      if (lookahead == '>') ADVANCE(134);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(167);
      if (lookahead == '>') ADVANCE(135);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(195);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(195);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(102);
      if (lookahead == '/') ADVANCE(194);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(104);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(101);
      if (lookahead == '/') ADVANCE(193);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(26);
      if (lookahead != 0) ADVANCE(102);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(101);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(26);
      if (lookahead != 0) ADVANCE(102);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '/') ADVANCE(100);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(104);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(104);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_jsx_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(105);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(210);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(210);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(110);
      if (lookahead == '?') ADVANCE(169);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(110);
      if (lookahead == '?') ADVANCE(168);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == '>') ADVANCE(137);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(136);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(131);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(130);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(118);
      if (lookahead == '|') ADVANCE(133);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(118);
      if (lookahead == '|') ADVANCE(133);
      if (lookahead == '}') ADVANCE(219);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(132);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '}') ADVANCE(219);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(219);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(171);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(171);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(172);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(172);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(172);
      if (lookahead == '=') ADVANCE(112);
      if (lookahead == '?') ADVANCE(31);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(164);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(166);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(177);
      if (lookahead == '/') ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(179);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(176);
      if (lookahead == '/') ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(178);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(179);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(184);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(186);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(183);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(184);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(183);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(184);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(182);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(186);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(186);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(174);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(181);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(37);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(214);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(187);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(191);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(195);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(195);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(195);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '[') ADVANCE(35);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(199);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(200);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(35);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(200);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(37);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(201);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(214);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(211);
      if (lookahead == '0') ADVANCE(208);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(48);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(49);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(56);
      if (lookahead == '_') ADVANCE(52);
      if (lookahead == 'n') ADVANCE(202);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(204);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(211);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (lookahead == '_') ADVANCE(50);
      if (lookahead == 'n') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'n') ADVANCE(202);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(205);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(49);
      if (lookahead == 'n') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(206);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(56);
      if (lookahead == 'n') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(207);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(52);
      if (lookahead == 'n') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(208);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (lookahead == '_') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(210);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(210);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(212);
      if (lookahead != 0 &&
          (lookahead < 0 || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(214);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '{') ADVANCE(197);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(214);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(37);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(214);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      if (lookahead == 'w') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(74);
      if (lookahead == 'y') ADVANCE(75);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(76);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(79);
      if (lookahead == 't') ADVANCE(80);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(81);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(82);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(83);
      if (lookahead == 'c') ADVANCE(84);
      if (lookahead == 'f') ADVANCE(85);
      if (lookahead == 'l') ADVANCE(86);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(87);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(88);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(89);
      if (lookahead == 't') ADVANCE(90);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(91);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(92);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(93);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(94);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(95);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(96);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(98);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(99);
      if (lookahead == 's') ADVANCE(100);
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(102);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(104);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(105);
      END_STATE();
    case 51:
      if (lookahead == 'w') ADVANCE(106);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(107);
      if (lookahead == 'm') ADVANCE(108);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(109);
      if (lookahead == 'o') ADVANCE(110);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(111);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(112);
      if (lookahead == 'q') ADVANCE(113);
      if (lookahead == 't') ADVANCE(114);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(115);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(116);
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(118);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(119);
      END_STATE();
    case 61:
      if (lookahead == 'm') ADVANCE(120);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(122);
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(124);
      if (lookahead == 'y') ADVANCE(125);
      END_STATE();
    case 65:
      if (lookahead == 'p') ADVANCE(126);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(127);
      END_STATE();
    case 67:
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(129);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(130);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(134);
      END_STATE();
    case 75:
      if (lookahead == 'n') ADVANCE(135);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(136);
      END_STATE();
    case 77:
      if (lookahead == 'l') ADVANCE(137);
      END_STATE();
    case 78:
      if (lookahead == 'a') ADVANCE(138);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(139);
      END_STATE();
    case 80:
      if (lookahead == 'c') ADVANCE(140);
      END_STATE();
    case 81:
      if (lookahead == 's') ADVANCE(141);
      END_STATE();
    case 82:
      if (lookahead == 's') ADVANCE(142);
      if (lookahead == 't') ADVANCE(143);
      END_STATE();
    case 83:
      if (lookahead == 'u') ADVANCE(144);
      END_STATE();
    case 84:
      if (lookahead == 'l') ADVANCE(145);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(146);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(147);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 88:
      if (lookahead == 'm') ADVANCE(149);
      END_STATE();
    case 89:
      if (lookahead == 'o') ADVANCE(150);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 91:
      if (lookahead == 's') ADVANCE(152);
      END_STATE();
    case 92:
      if (lookahead == 'a') ADVANCE(153);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 94:
      if (lookahead == 'm') ADVANCE(154);
      END_STATE();
    case 95:
      if (lookahead == 'c') ADVANCE(155);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 97:
      if (lookahead == 'b') ADVANCE(156);
      END_STATE();
    case 98:
      if (lookahead == 'l') ADVANCE(157);
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 100:
      if (lookahead == 't') ADVANCE(160);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(161);
      END_STATE();
    case 102:
      if (lookahead == 'o') ADVANCE(162);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 104:
      if (lookahead == 'u') ADVANCE(163);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 107:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 108:
      if (lookahead == 'b') ADVANCE(166);
      END_STATE();
    case 109:
      if (lookahead == 'v') ADVANCE(167);
      END_STATE();
    case 110:
      if (lookahead == 't') ADVANCE(168);
      END_STATE();
    case 111:
      if (lookahead == 'l') ADVANCE(169);
      END_STATE();
    case 112:
      if (lookahead == 'd') ADVANCE(170);
      END_STATE();
    case 113:
      if (lookahead == 'u') ADVANCE(171);
      END_STATE();
    case 114:
      if (lookahead == 'u') ADVANCE(172);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 117:
      if (lookahead == 'i') ADVANCE(174);
      END_STATE();
    case 118:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 119:
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 120:
      if (lookahead == 'b') ADVANCE(177);
      END_STATE();
    case 121:
      if (lookahead == 'g') ADVANCE(178);
      END_STATE();
    case 122:
      if (lookahead == 's') ADVANCE(179);
      END_STATE();
    case 123:
      if (lookahead == 'o') ADVANCE(180);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(181);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 126:
      if (lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 127:
      if (lookahead == 'e') ADVANCE(183);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 129:
      if (lookahead == 'd') ADVANCE(184);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(185);
      END_STATE();
    case 131:
      if (lookahead == 'h') ADVANCE(186);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(187);
      END_STATE();
    case 133:
      if (lookahead == 'r') ADVANCE(188);
      END_STATE();
    case 134:
      if (lookahead == 'r') ADVANCE(189);
      END_STATE();
    case 135:
      if (lookahead == 'c') ADVANCE(190);
      END_STATE();
    case 136:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(192);
      END_STATE();
    case 138:
      if (lookahead == 'k') ADVANCE(193);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 140:
      if (lookahead == 'h') ADVANCE(194);
      END_STATE();
    case 141:
      if (lookahead == 's') ADVANCE(195);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 143:
      if (lookahead == 'i') ADVANCE(197);
      END_STATE();
    case 144:
      if (lookahead == 'g') ADVANCE(198);
      END_STATE();
    case 145:
      if (lookahead == 'a') ADVANCE(199);
      END_STATE();
    case 146:
      if (lookahead == 'u') ADVANCE(200);
      END_STATE();
    case 147:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 150:
      if (lookahead == 'r') ADVANCE(202);
      END_STATE();
    case 151:
      if (lookahead == 'n') ADVANCE(203);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 153:
      if (lookahead == 'l') ADVANCE(205);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 155:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(207);
      END_STATE();
    case 157:
      if (lookahead == 'e') ADVANCE(208);
      END_STATE();
    case 158:
      if (lookahead == 'r') ADVANCE(209);
      END_STATE();
    case 159:
      if (lookahead == 'r') ADVANCE(210);
      END_STATE();
    case 160:
      if (lookahead == 'a') ADVANCE(211);
      END_STATE();
    case 161:
      if (lookahead == 'r') ADVANCE(212);
      END_STATE();
    case 162:
      if (lookahead == 'f') ADVANCE(213);
      END_STATE();
    case 163:
      if (lookahead == 'l') ADVANCE(214);
      END_STATE();
    case 164:
      if (lookahead == 's') ADVANCE(215);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 166:
      if (lookahead == 'e') ADVANCE(216);
      END_STATE();
    case 167:
      if (lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 168:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(219);
      END_STATE();
    case 170:
      if (lookahead == 'o') ADVANCE(220);
      END_STATE();
    case 171:
      if (lookahead == 'i') ADVANCE(221);
      END_STATE();
    case 172:
      if (lookahead == 'r') ADVANCE(222);
      END_STATE();
    case 173:
      if (lookahead == 'i') ADVANCE(223);
      END_STATE();
    case 174:
      if (lookahead == 'n') ADVANCE(224);
      END_STATE();
    case 175:
      if (lookahead == 'r') ADVANCE(225);
      END_STATE();
    case 176:
      if (lookahead == 'c') ADVANCE(226);
      END_STATE();
    case 177:
      if (lookahead == 'o') ADVANCE(227);
      END_STATE();
    case 178:
      if (lookahead == 'e') ADVANCE(228);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 180:
      if (lookahead == 'w') ADVANCE(229);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(230);
      END_STATE();
    case 183:
      if (lookahead == 'f') ADVANCE(231);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 185:
      if (lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 187:
      if (lookahead == 'd') ADVANCE(233);
      END_STATE();
    case 188:
      if (lookahead == 'a') ADVANCE(234);
      END_STATE();
    case 189:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 192:
      if (lookahead == 'a') ADVANCE(236);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 197:
      if (lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 198:
      if (lookahead == 'g') ADVANCE(238);
      END_STATE();
    case 199:
      if (lookahead == 'r') ADVANCE(239);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(240);
      END_STATE();
    case 201:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(242);
      END_STATE();
    case 203:
      if (lookahead == 'd') ADVANCE(243);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 205:
      if (lookahead == 'l') ADVANCE(244);
      END_STATE();
    case 206:
      if (lookahead == 'i') ADVANCE(245);
      END_STATE();
    case 207:
      if (lookahead == 'l') ADVANCE(246);
      END_STATE();
    case 208:
      if (lookahead == 'm') ADVANCE(247);
      END_STATE();
    case 209:
      if (lookahead == 't') ADVANCE(248);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 211:
      if (lookahead == 'n') ADVANCE(249);
      END_STATE();
    case 212:
      if (lookahead == 'f') ADVANCE(250);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 214:
      if (lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 215:
      if (lookahead == 'p') ADVANCE(252);
      END_STATE();
    case 216:
      if (lookahead == 'r') ADVANCE(253);
      END_STATE();
    case 217:
      if (lookahead == 't') ADVANCE(254);
      END_STATE();
    case 218:
      if (lookahead == 'c') ADVANCE(255);
      END_STATE();
    case 219:
      if (lookahead == 'c') ADVANCE(256);
      END_STATE();
    case 220:
      if (lookahead == 'n') ADVANCE(257);
      END_STATE();
    case 221:
      if (lookahead == 'r') ADVANCE(258);
      END_STATE();
    case 222:
      if (lookahead == 'n') ADVANCE(259);
      END_STATE();
    case 223:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 224:
      if (lookahead == 'g') ADVANCE(261);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 226:
      if (lookahead == 'h') ADVANCE(262);
      END_STATE();
    case 227:
      if (lookahead == 'l') ADVANCE(263);
      END_STATE();
    case 228:
      if (lookahead == 't') ADVANCE(264);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 230:
      if (lookahead == 'f') ADVANCE(265);
      END_STATE();
    case 231:
      if (lookahead == 'i') ADVANCE(266);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 234:
      if (lookahead == 'c') ADVANCE(267);
      END_STATE();
    case 235:
      if (lookahead == 's') ADVANCE(268);
      END_STATE();
    case 236:
      if (lookahead == 'n') ADVANCE(269);
      END_STATE();
    case 237:
      if (lookahead == 'u') ADVANCE(270);
      END_STATE();
    case 238:
      if (lookahead == 'e') ADVANCE(271);
      END_STATE();
    case 239:
      if (lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 240:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 243:
      if (lookahead == 's') ADVANCE(274);
      END_STATE();
    case 244:
      if (lookahead == 'y') ADVANCE(275);
      END_STATE();
    case 245:
      if (lookahead == 'o') ADVANCE(276);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(277);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 249:
      if (lookahead == 'c') ADVANCE(278);
      END_STATE();
    case 250:
      if (lookahead == 'a') ADVANCE(279);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 252:
      if (lookahead == 'a') ADVANCE(280);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 254:
      if (lookahead == 'e') ADVANCE(281);
      END_STATE();
    case 255:
      if (lookahead == 't') ADVANCE(282);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 257:
      if (lookahead == 'l') ADVANCE(283);
      END_STATE();
    case 258:
      if (lookahead == 'e') ADVANCE(284);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 266:
      if (lookahead == 'n') ADVANCE(285);
      END_STATE();
    case 267:
      if (lookahead == 't') ADVANCE(286);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(287);
      END_STATE();
    case 271:
      if (lookahead == 'r') ADVANCE(288);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 276:
      if (lookahead == 'n') ADVANCE(289);
      END_STATE();
    case 277:
      if (lookahead == 'n') ADVANCE(290);
      END_STATE();
    case 278:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 279:
      if (lookahead == 'c') ADVANCE(292);
      END_STATE();
    case 280:
      if (lookahead == 'c') ADVANCE(293);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 282:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 283:
      if (lookahead == 'y') ADVANCE(295);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(296);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 290:
      if (lookahead == 't') ADVANCE(297);
      END_STATE();
    case 291:
      if (lookahead == 'o') ADVANCE(298);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(299);
      END_STATE();
    case 293:
      if (lookahead == 'e') ADVANCE(300);
      END_STATE();
    case 294:
      if (lookahead == 'd') ADVANCE(301);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 296:
      if (lookahead == 'd') ADVANCE(302);
      END_STATE();
    case 297:
      if (lookahead == 's') ADVANCE(303);
      END_STATE();
    case 298:
      if (lookahead == 'f') ADVANCE(304);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 71},
  [2] = {.lex_state = 71},
  [3] = {.lex_state = 71},
  [4] = {.lex_state = 71},
  [5] = {.lex_state = 71},
  [6] = {.lex_state = 71},
  [7] = {.lex_state = 71},
  [8] = {.lex_state = 71},
  [9] = {.lex_state = 71},
  [10] = {.lex_state = 71},
  [11] = {.lex_state = 71},
  [12] = {.lex_state = 71},
  [13] = {.lex_state = 71},
  [14] = {.lex_state = 71},
  [15] = {.lex_state = 71},
  [16] = {.lex_state = 71},
  [17] = {.lex_state = 71},
  [18] = {.lex_state = 71},
  [19] = {.lex_state = 71},
  [20] = {.lex_state = 71},
  [21] = {.lex_state = 71},
  [22] = {.lex_state = 71},
  [23] = {.lex_state = 71},
  [24] = {.lex_state = 71},
  [25] = {.lex_state = 71},
  [26] = {.lex_state = 71},
  [27] = {.lex_state = 71},
  [28] = {.lex_state = 71},
  [29] = {.lex_state = 71},
  [30] = {.lex_state = 71},
  [31] = {.lex_state = 71},
  [32] = {.lex_state = 71},
  [33] = {.lex_state = 71},
  [34] = {.lex_state = 71},
  [35] = {.lex_state = 71},
  [36] = {.lex_state = 71},
  [37] = {.lex_state = 71},
  [38] = {.lex_state = 71},
  [39] = {.lex_state = 71},
  [40] = {.lex_state = 71},
  [41] = {.lex_state = 71},
  [42] = {.lex_state = 71},
  [43] = {.lex_state = 71},
  [44] = {.lex_state = 71},
  [45] = {.lex_state = 71},
  [46] = {.lex_state = 71},
  [47] = {.lex_state = 71},
  [48] = {.lex_state = 71},
  [49] = {.lex_state = 71},
  [50] = {.lex_state = 71},
  [51] = {.lex_state = 71},
  [52] = {.lex_state = 71},
  [53] = {.lex_state = 71},
  [54] = {.lex_state = 71},
  [55] = {.lex_state = 71},
  [56] = {.lex_state = 71},
  [57] = {.lex_state = 14},
  [58] = {.lex_state = 14},
  [59] = {.lex_state = 14},
  [60] = {.lex_state = 14},
  [61] = {.lex_state = 14},
  [62] = {.lex_state = 14},
  [63] = {.lex_state = 14},
  [64] = {.lex_state = 14},
  [65] = {.lex_state = 14},
  [66] = {.lex_state = 14},
  [67] = {.lex_state = 14},
  [68] = {.lex_state = 70, .external_lex_state = 2},
  [69] = {.lex_state = 70, .external_lex_state = 3},
  [70] = {.lex_state = 70, .external_lex_state = 2},
  [71] = {.lex_state = 6, .external_lex_state = 2},
  [72] = {.lex_state = 8, .external_lex_state = 2},
  [73] = {.lex_state = 70, .external_lex_state = 2},
  [74] = {.lex_state = 70, .external_lex_state = 3},
  [75] = {.lex_state = 6, .external_lex_state = 2},
  [76] = {.lex_state = 6, .external_lex_state = 3},
  [77] = {.lex_state = 70, .external_lex_state = 3},
  [78] = {.lex_state = 70, .external_lex_state = 3},
  [79] = {.lex_state = 70, .external_lex_state = 3},
  [80] = {.lex_state = 6, .external_lex_state = 2},
  [81] = {.lex_state = 70, .external_lex_state = 3},
  [82] = {.lex_state = 70, .external_lex_state = 3},
  [83] = {.lex_state = 70, .external_lex_state = 3},
  [84] = {.lex_state = 70, .external_lex_state = 3},
  [85] = {.lex_state = 70, .external_lex_state = 3},
  [86] = {.lex_state = 70, .external_lex_state = 3},
  [87] = {.lex_state = 70, .external_lex_state = 3},
  [88] = {.lex_state = 70, .external_lex_state = 3},
  [89] = {.lex_state = 6, .external_lex_state = 2},
  [90] = {.lex_state = 70, .external_lex_state = 3},
  [91] = {.lex_state = 70, .external_lex_state = 3},
  [92] = {.lex_state = 70, .external_lex_state = 3},
  [93] = {.lex_state = 70, .external_lex_state = 3},
  [94] = {.lex_state = 70, .external_lex_state = 3},
  [95] = {.lex_state = 70, .external_lex_state = 3},
  [96] = {.lex_state = 70, .external_lex_state = 3},
  [97] = {.lex_state = 6, .external_lex_state = 2},
  [98] = {.lex_state = 70, .external_lex_state = 3},
  [99] = {.lex_state = 70, .external_lex_state = 3},
  [100] = {.lex_state = 70, .external_lex_state = 3},
  [101] = {.lex_state = 70, .external_lex_state = 3},
  [102] = {.lex_state = 70, .external_lex_state = 3},
  [103] = {.lex_state = 70, .external_lex_state = 3},
  [104] = {.lex_state = 70, .external_lex_state = 3},
  [105] = {.lex_state = 70, .external_lex_state = 3},
  [106] = {.lex_state = 70, .external_lex_state = 3},
  [107] = {.lex_state = 6, .external_lex_state = 3},
  [108] = {.lex_state = 71},
  [109] = {.lex_state = 6, .external_lex_state = 2},
  [110] = {.lex_state = 71},
  [111] = {.lex_state = 71},
  [112] = {.lex_state = 71},
  [113] = {.lex_state = 71},
  [114] = {.lex_state = 71},
  [115] = {.lex_state = 71},
  [116] = {.lex_state = 71},
  [117] = {.lex_state = 71},
  [118] = {.lex_state = 71},
  [119] = {.lex_state = 71},
  [120] = {.lex_state = 71},
  [121] = {.lex_state = 71},
  [122] = {.lex_state = 71},
  [123] = {.lex_state = 71},
  [124] = {.lex_state = 71},
  [125] = {.lex_state = 71},
  [126] = {.lex_state = 71},
  [127] = {.lex_state = 71},
  [128] = {.lex_state = 71, .external_lex_state = 4},
  [129] = {.lex_state = 71},
  [130] = {.lex_state = 71},
  [131] = {.lex_state = 71},
  [132] = {.lex_state = 71},
  [133] = {.lex_state = 71},
  [134] = {.lex_state = 71},
  [135] = {.lex_state = 71},
  [136] = {.lex_state = 71},
  [137] = {.lex_state = 71},
  [138] = {.lex_state = 71},
  [139] = {.lex_state = 71},
  [140] = {.lex_state = 7, .external_lex_state = 3},
  [141] = {.lex_state = 7, .external_lex_state = 3},
  [142] = {.lex_state = 71},
  [143] = {.lex_state = 71},
  [144] = {.lex_state = 71},
  [145] = {.lex_state = 71},
  [146] = {.lex_state = 7, .external_lex_state = 3},
  [147] = {.lex_state = 71},
  [148] = {.lex_state = 71},
  [149] = {.lex_state = 71},
  [150] = {.lex_state = 71},
  [151] = {.lex_state = 71},
  [152] = {.lex_state = 71},
  [153] = {.lex_state = 71},
  [154] = {.lex_state = 71},
  [155] = {.lex_state = 71},
  [156] = {.lex_state = 71},
  [157] = {.lex_state = 71},
  [158] = {.lex_state = 71},
  [159] = {.lex_state = 71},
  [160] = {.lex_state = 7, .external_lex_state = 3},
  [161] = {.lex_state = 71},
  [162] = {.lex_state = 71},
  [163] = {.lex_state = 71},
  [164] = {.lex_state = 71},
  [165] = {.lex_state = 71},
  [166] = {.lex_state = 71},
  [167] = {.lex_state = 7, .external_lex_state = 3},
  [168] = {.lex_state = 71},
  [169] = {.lex_state = 71},
  [170] = {.lex_state = 71},
  [171] = {.lex_state = 6, .external_lex_state = 3},
  [172] = {.lex_state = 6, .external_lex_state = 3},
  [173] = {.lex_state = 6, .external_lex_state = 3},
  [174] = {.lex_state = 7, .external_lex_state = 3},
  [175] = {.lex_state = 71},
  [176] = {.lex_state = 71},
  [177] = {.lex_state = 71, .external_lex_state = 4},
  [178] = {.lex_state = 71},
  [179] = {.lex_state = 71},
  [180] = {.lex_state = 71},
  [181] = {.lex_state = 71},
  [182] = {.lex_state = 71},
  [183] = {.lex_state = 71},
  [184] = {.lex_state = 71},
  [185] = {.lex_state = 71},
  [186] = {.lex_state = 71},
  [187] = {.lex_state = 71},
  [188] = {.lex_state = 71},
  [189] = {.lex_state = 6, .external_lex_state = 3},
  [190] = {.lex_state = 71},
  [191] = {.lex_state = 71},
  [192] = {.lex_state = 71},
  [193] = {.lex_state = 71},
  [194] = {.lex_state = 71},
  [195] = {.lex_state = 71},
  [196] = {.lex_state = 71},
  [197] = {.lex_state = 71},
  [198] = {.lex_state = 71},
  [199] = {.lex_state = 71},
  [200] = {.lex_state = 71},
  [201] = {.lex_state = 71},
  [202] = {.lex_state = 71},
  [203] = {.lex_state = 71},
  [204] = {.lex_state = 71},
  [205] = {.lex_state = 71},
  [206] = {.lex_state = 71},
  [207] = {.lex_state = 71},
  [208] = {.lex_state = 71},
  [209] = {.lex_state = 71},
  [210] = {.lex_state = 71},
  [211] = {.lex_state = 71},
  [212] = {.lex_state = 71},
  [213] = {.lex_state = 71},
  [214] = {.lex_state = 71},
  [215] = {.lex_state = 71},
  [216] = {.lex_state = 71},
  [217] = {.lex_state = 71},
  [218] = {.lex_state = 71},
  [219] = {.lex_state = 71},
  [220] = {.lex_state = 71},
  [221] = {.lex_state = 71},
  [222] = {.lex_state = 71},
  [223] = {.lex_state = 71},
  [224] = {.lex_state = 6, .external_lex_state = 3},
  [225] = {.lex_state = 71},
  [226] = {.lex_state = 71},
  [227] = {.lex_state = 71},
  [228] = {.lex_state = 71},
  [229] = {.lex_state = 71},
  [230] = {.lex_state = 71},
  [231] = {.lex_state = 71},
  [232] = {.lex_state = 71},
  [233] = {.lex_state = 71},
  [234] = {.lex_state = 71},
  [235] = {.lex_state = 71},
  [236] = {.lex_state = 71},
  [237] = {.lex_state = 71},
  [238] = {.lex_state = 71},
  [239] = {.lex_state = 71},
  [240] = {.lex_state = 71},
  [241] = {.lex_state = 71},
  [242] = {.lex_state = 71},
  [243] = {.lex_state = 71},
  [244] = {.lex_state = 71},
  [245] = {.lex_state = 71},
  [246] = {.lex_state = 71},
  [247] = {.lex_state = 71},
  [248] = {.lex_state = 71},
  [249] = {.lex_state = 71},
  [250] = {.lex_state = 71},
  [251] = {.lex_state = 71},
  [252] = {.lex_state = 71},
  [253] = {.lex_state = 71},
  [254] = {.lex_state = 71},
  [255] = {.lex_state = 71},
  [256] = {.lex_state = 71},
  [257] = {.lex_state = 71},
  [258] = {.lex_state = 71},
  [259] = {.lex_state = 71},
  [260] = {.lex_state = 71},
  [261] = {.lex_state = 71},
  [262] = {.lex_state = 6, .external_lex_state = 3},
  [263] = {.lex_state = 71},
  [264] = {.lex_state = 71},
  [265] = {.lex_state = 71},
  [266] = {.lex_state = 71},
  [267] = {.lex_state = 71},
  [268] = {.lex_state = 71},
  [269] = {.lex_state = 71},
  [270] = {.lex_state = 71},
  [271] = {.lex_state = 71},
  [272] = {.lex_state = 71},
  [273] = {.lex_state = 71},
  [274] = {.lex_state = 71},
  [275] = {.lex_state = 71},
  [276] = {.lex_state = 71},
  [277] = {.lex_state = 71},
  [278] = {.lex_state = 71},
  [279] = {.lex_state = 71},
  [280] = {.lex_state = 71},
  [281] = {.lex_state = 71},
  [282] = {.lex_state = 71},
  [283] = {.lex_state = 71},
  [284] = {.lex_state = 71},
  [285] = {.lex_state = 71},
  [286] = {.lex_state = 71},
  [287] = {.lex_state = 71},
  [288] = {.lex_state = 71},
  [289] = {.lex_state = 71},
  [290] = {.lex_state = 71},
  [291] = {.lex_state = 71},
  [292] = {.lex_state = 71},
  [293] = {.lex_state = 71},
  [294] = {.lex_state = 71},
  [295] = {.lex_state = 71},
  [296] = {.lex_state = 71},
  [297] = {.lex_state = 71},
  [298] = {.lex_state = 71},
  [299] = {.lex_state = 71},
  [300] = {.lex_state = 71},
  [301] = {.lex_state = 71},
  [302] = {.lex_state = 71},
  [303] = {.lex_state = 71},
  [304] = {.lex_state = 71},
  [305] = {.lex_state = 71},
  [306] = {.lex_state = 71},
  [307] = {.lex_state = 71},
  [308] = {.lex_state = 71},
  [309] = {.lex_state = 71},
  [310] = {.lex_state = 71},
  [311] = {.lex_state = 71},
  [312] = {.lex_state = 71},
  [313] = {.lex_state = 71},
  [314] = {.lex_state = 71},
  [315] = {.lex_state = 71},
  [316] = {.lex_state = 71},
  [317] = {.lex_state = 71},
  [318] = {.lex_state = 71},
  [319] = {.lex_state = 71},
  [320] = {.lex_state = 71},
  [321] = {.lex_state = 71},
  [322] = {.lex_state = 71},
  [323] = {.lex_state = 71},
  [324] = {.lex_state = 71},
  [325] = {.lex_state = 71},
  [326] = {.lex_state = 71},
  [327] = {.lex_state = 71},
  [328] = {.lex_state = 71},
  [329] = {.lex_state = 71},
  [330] = {.lex_state = 71},
  [331] = {.lex_state = 71},
  [332] = {.lex_state = 71},
  [333] = {.lex_state = 71},
  [334] = {.lex_state = 71},
  [335] = {.lex_state = 71},
  [336] = {.lex_state = 71},
  [337] = {.lex_state = 71},
  [338] = {.lex_state = 71},
  [339] = {.lex_state = 71},
  [340] = {.lex_state = 71},
  [341] = {.lex_state = 71},
  [342] = {.lex_state = 71},
  [343] = {.lex_state = 71},
  [344] = {.lex_state = 71},
  [345] = {.lex_state = 71},
  [346] = {.lex_state = 71},
  [347] = {.lex_state = 71},
  [348] = {.lex_state = 71},
  [349] = {.lex_state = 71},
  [350] = {.lex_state = 71},
  [351] = {.lex_state = 71},
  [352] = {.lex_state = 71},
  [353] = {.lex_state = 71},
  [354] = {.lex_state = 71},
  [355] = {.lex_state = 71},
  [356] = {.lex_state = 71},
  [357] = {.lex_state = 71},
  [358] = {.lex_state = 71},
  [359] = {.lex_state = 71},
  [360] = {.lex_state = 71},
  [361] = {.lex_state = 71},
  [362] = {.lex_state = 71},
  [363] = {.lex_state = 71},
  [364] = {.lex_state = 71},
  [365] = {.lex_state = 71},
  [366] = {.lex_state = 71},
  [367] = {.lex_state = 71},
  [368] = {.lex_state = 71},
  [369] = {.lex_state = 71},
  [370] = {.lex_state = 71},
  [371] = {.lex_state = 71},
  [372] = {.lex_state = 71},
  [373] = {.lex_state = 71},
  [374] = {.lex_state = 71},
  [375] = {.lex_state = 71},
  [376] = {.lex_state = 71},
  [377] = {.lex_state = 71},
  [378] = {.lex_state = 71},
  [379] = {.lex_state = 71},
  [380] = {.lex_state = 71},
  [381] = {.lex_state = 71},
  [382] = {.lex_state = 71},
  [383] = {.lex_state = 71},
  [384] = {.lex_state = 71},
  [385] = {.lex_state = 71},
  [386] = {.lex_state = 71},
  [387] = {.lex_state = 71},
  [388] = {.lex_state = 71},
  [389] = {.lex_state = 71},
  [390] = {.lex_state = 71},
  [391] = {.lex_state = 71},
  [392] = {.lex_state = 71},
  [393] = {.lex_state = 71},
  [394] = {.lex_state = 71},
  [395] = {.lex_state = 71},
  [396] = {.lex_state = 71},
  [397] = {.lex_state = 71},
  [398] = {.lex_state = 71},
  [399] = {.lex_state = 71},
  [400] = {.lex_state = 71},
  [401] = {.lex_state = 71},
  [402] = {.lex_state = 71},
  [403] = {.lex_state = 71},
  [404] = {.lex_state = 71},
  [405] = {.lex_state = 71},
  [406] = {.lex_state = 71},
  [407] = {.lex_state = 71},
  [408] = {.lex_state = 71},
  [409] = {.lex_state = 71},
  [410] = {.lex_state = 71},
  [411] = {.lex_state = 71},
  [412] = {.lex_state = 71},
  [413] = {.lex_state = 71},
  [414] = {.lex_state = 71},
  [415] = {.lex_state = 71},
  [416] = {.lex_state = 71},
  [417] = {.lex_state = 71},
  [418] = {.lex_state = 71},
  [419] = {.lex_state = 71},
  [420] = {.lex_state = 71},
  [421] = {.lex_state = 71},
  [422] = {.lex_state = 71},
  [423] = {.lex_state = 6, .external_lex_state = 3},
  [424] = {.lex_state = 71},
  [425] = {.lex_state = 6, .external_lex_state = 3},
  [426] = {.lex_state = 6, .external_lex_state = 3},
  [427] = {.lex_state = 71},
  [428] = {.lex_state = 71},
  [429] = {.lex_state = 71},
  [430] = {.lex_state = 71},
  [431] = {.lex_state = 71},
  [432] = {.lex_state = 71},
  [433] = {.lex_state = 71},
  [434] = {.lex_state = 71},
  [435] = {.lex_state = 71},
  [436] = {.lex_state = 71},
  [437] = {.lex_state = 71},
  [438] = {.lex_state = 71},
  [439] = {.lex_state = 71},
  [440] = {.lex_state = 71},
  [441] = {.lex_state = 71},
  [442] = {.lex_state = 71},
  [443] = {.lex_state = 71},
  [444] = {.lex_state = 71},
  [445] = {.lex_state = 71},
  [446] = {.lex_state = 71},
  [447] = {.lex_state = 71},
  [448] = {.lex_state = 71},
  [449] = {.lex_state = 71},
  [450] = {.lex_state = 71},
  [451] = {.lex_state = 71},
  [452] = {.lex_state = 71},
  [453] = {.lex_state = 71},
  [454] = {.lex_state = 71},
  [455] = {.lex_state = 71},
  [456] = {.lex_state = 71},
  [457] = {.lex_state = 71},
  [458] = {.lex_state = 71},
  [459] = {.lex_state = 71},
  [460] = {.lex_state = 71},
  [461] = {.lex_state = 71},
  [462] = {.lex_state = 71},
  [463] = {.lex_state = 6, .external_lex_state = 3},
  [464] = {.lex_state = 6, .external_lex_state = 3},
  [465] = {.lex_state = 6, .external_lex_state = 3},
  [466] = {.lex_state = 6, .external_lex_state = 3},
  [467] = {.lex_state = 6, .external_lex_state = 3},
  [468] = {.lex_state = 6, .external_lex_state = 3},
  [469] = {.lex_state = 6, .external_lex_state = 3},
  [470] = {.lex_state = 6, .external_lex_state = 3},
  [471] = {.lex_state = 6, .external_lex_state = 3},
  [472] = {.lex_state = 6, .external_lex_state = 2},
  [473] = {.lex_state = 15},
  [474] = {.lex_state = 15},
  [475] = {.lex_state = 6, .external_lex_state = 3},
  [476] = {.lex_state = 15},
  [477] = {.lex_state = 15},
  [478] = {.lex_state = 15},
  [479] = {.lex_state = 15},
  [480] = {.lex_state = 6, .external_lex_state = 3},
  [481] = {.lex_state = 7, .external_lex_state = 2},
  [482] = {.lex_state = 6, .external_lex_state = 2},
  [483] = {.lex_state = 6, .external_lex_state = 2},
  [484] = {.lex_state = 6, .external_lex_state = 3},
  [485] = {.lex_state = 6, .external_lex_state = 3},
  [486] = {.lex_state = 6, .external_lex_state = 2},
  [487] = {.lex_state = 6, .external_lex_state = 3},
  [488] = {.lex_state = 71},
  [489] = {.lex_state = 6, .external_lex_state = 3},
  [490] = {.lex_state = 6, .external_lex_state = 3},
  [491] = {.lex_state = 71},
  [492] = {.lex_state = 6, .external_lex_state = 3},
  [493] = {.lex_state = 71},
  [494] = {.lex_state = 6, .external_lex_state = 3},
  [495] = {.lex_state = 6, .external_lex_state = 3},
  [496] = {.lex_state = 7, .external_lex_state = 2},
  [497] = {.lex_state = 6, .external_lex_state = 2},
  [498] = {.lex_state = 6, .external_lex_state = 2},
  [499] = {.lex_state = 6, .external_lex_state = 2},
  [500] = {.lex_state = 71, .external_lex_state = 4},
  [501] = {.lex_state = 7, .external_lex_state = 2},
  [502] = {.lex_state = 7, .external_lex_state = 2},
  [503] = {.lex_state = 71},
  [504] = {.lex_state = 71},
  [505] = {.lex_state = 71},
  [506] = {.lex_state = 71},
  [507] = {.lex_state = 71, .external_lex_state = 4},
  [508] = {.lex_state = 6, .external_lex_state = 2},
  [509] = {.lex_state = 71},
  [510] = {.lex_state = 6, .external_lex_state = 2},
  [511] = {.lex_state = 71, .external_lex_state = 4},
  [512] = {.lex_state = 71},
  [513] = {.lex_state = 6, .external_lex_state = 3},
  [514] = {.lex_state = 71, .external_lex_state = 4},
  [515] = {.lex_state = 71, .external_lex_state = 4},
  [516] = {.lex_state = 71, .external_lex_state = 4},
  [517] = {.lex_state = 71, .external_lex_state = 4},
  [518] = {.lex_state = 71},
  [519] = {.lex_state = 71},
  [520] = {.lex_state = 6, .external_lex_state = 3},
  [521] = {.lex_state = 71, .external_lex_state = 4},
  [522] = {.lex_state = 71},
  [523] = {.lex_state = 71},
  [524] = {.lex_state = 6, .external_lex_state = 3},
  [525] = {.lex_state = 71},
  [526] = {.lex_state = 6, .external_lex_state = 2},
  [527] = {.lex_state = 6, .external_lex_state = 2},
  [528] = {.lex_state = 6, .external_lex_state = 2},
  [529] = {.lex_state = 7, .external_lex_state = 2},
  [530] = {.lex_state = 71},
  [531] = {.lex_state = 6, .external_lex_state = 2},
  [532] = {.lex_state = 71},
  [533] = {.lex_state = 7, .external_lex_state = 2},
  [534] = {.lex_state = 71},
  [535] = {.lex_state = 71, .external_lex_state = 4},
  [536] = {.lex_state = 71, .external_lex_state = 4},
  [537] = {.lex_state = 71},
  [538] = {.lex_state = 71, .external_lex_state = 4},
  [539] = {.lex_state = 71},
  [540] = {.lex_state = 71},
  [541] = {.lex_state = 71, .external_lex_state = 4},
  [542] = {.lex_state = 71},
  [543] = {.lex_state = 71, .external_lex_state = 4},
  [544] = {.lex_state = 71},
  [545] = {.lex_state = 71},
  [546] = {.lex_state = 71, .external_lex_state = 4},
  [547] = {.lex_state = 71},
  [548] = {.lex_state = 71, .external_lex_state = 4},
  [549] = {.lex_state = 71, .external_lex_state = 4},
  [550] = {.lex_state = 71, .external_lex_state = 4},
  [551] = {.lex_state = 71, .external_lex_state = 4},
  [552] = {.lex_state = 71, .external_lex_state = 4},
  [553] = {.lex_state = 71, .external_lex_state = 4},
  [554] = {.lex_state = 71},
  [555] = {.lex_state = 71},
  [556] = {.lex_state = 71},
  [557] = {.lex_state = 71},
  [558] = {.lex_state = 71},
  [559] = {.lex_state = 71},
  [560] = {.lex_state = 71},
  [561] = {.lex_state = 71},
  [562] = {.lex_state = 71},
  [563] = {.lex_state = 71},
  [564] = {.lex_state = 71},
  [565] = {.lex_state = 71},
  [566] = {.lex_state = 15},
  [567] = {.lex_state = 71},
  [568] = {.lex_state = 71},
  [569] = {.lex_state = 71},
  [570] = {.lex_state = 71},
  [571] = {.lex_state = 71},
  [572] = {.lex_state = 71},
  [573] = {.lex_state = 71},
  [574] = {.lex_state = 71},
  [575] = {.lex_state = 71},
  [576] = {.lex_state = 71},
  [577] = {.lex_state = 71},
  [578] = {.lex_state = 71},
  [579] = {.lex_state = 71},
  [580] = {.lex_state = 71},
  [581] = {.lex_state = 71},
  [582] = {.lex_state = 71},
  [583] = {.lex_state = 71},
  [584] = {.lex_state = 71},
  [585] = {.lex_state = 71},
  [586] = {.lex_state = 71},
  [587] = {.lex_state = 71},
  [588] = {.lex_state = 71},
  [589] = {.lex_state = 71},
  [590] = {.lex_state = 71},
  [591] = {.lex_state = 71},
  [592] = {.lex_state = 71},
  [593] = {.lex_state = 71},
  [594] = {.lex_state = 71},
  [595] = {.lex_state = 71},
  [596] = {.lex_state = 71},
  [597] = {.lex_state = 71},
  [598] = {.lex_state = 71},
  [599] = {.lex_state = 71},
  [600] = {.lex_state = 71},
  [601] = {.lex_state = 71},
  [602] = {.lex_state = 71},
  [603] = {.lex_state = 71},
  [604] = {.lex_state = 71},
  [605] = {.lex_state = 71},
  [606] = {.lex_state = 71},
  [607] = {.lex_state = 71},
  [608] = {.lex_state = 71},
  [609] = {.lex_state = 71},
  [610] = {.lex_state = 71},
  [611] = {.lex_state = 71},
  [612] = {.lex_state = 71},
  [613] = {.lex_state = 71},
  [614] = {.lex_state = 71},
  [615] = {.lex_state = 71},
  [616] = {.lex_state = 71},
  [617] = {.lex_state = 71},
  [618] = {.lex_state = 71},
  [619] = {.lex_state = 71},
  [620] = {.lex_state = 71},
  [621] = {.lex_state = 71},
  [622] = {.lex_state = 71},
  [623] = {.lex_state = 71},
  [624] = {.lex_state = 71},
  [625] = {.lex_state = 71},
  [626] = {.lex_state = 71},
  [627] = {.lex_state = 71},
  [628] = {.lex_state = 71},
  [629] = {.lex_state = 71},
  [630] = {.lex_state = 71},
  [631] = {.lex_state = 71},
  [632] = {.lex_state = 71},
  [633] = {.lex_state = 71},
  [634] = {.lex_state = 71},
  [635] = {.lex_state = 71},
  [636] = {.lex_state = 71},
  [637] = {.lex_state = 71},
  [638] = {.lex_state = 71},
  [639] = {.lex_state = 71},
  [640] = {.lex_state = 71},
  [641] = {.lex_state = 71},
  [642] = {.lex_state = 71},
  [643] = {.lex_state = 71},
  [644] = {.lex_state = 71},
  [645] = {.lex_state = 71},
  [646] = {.lex_state = 71},
  [647] = {.lex_state = 71},
  [648] = {.lex_state = 71},
  [649] = {.lex_state = 6, .external_lex_state = 2},
  [650] = {.lex_state = 6, .external_lex_state = 3},
  [651] = {.lex_state = 6, .external_lex_state = 3},
  [652] = {.lex_state = 6, .external_lex_state = 3},
  [653] = {.lex_state = 6, .external_lex_state = 3},
  [654] = {.lex_state = 6, .external_lex_state = 3},
  [655] = {.lex_state = 6, .external_lex_state = 3},
  [656] = {.lex_state = 6, .external_lex_state = 3},
  [657] = {.lex_state = 6, .external_lex_state = 2},
  [658] = {.lex_state = 6, .external_lex_state = 2},
  [659] = {.lex_state = 6, .external_lex_state = 2},
  [660] = {.lex_state = 7, .external_lex_state = 2},
  [661] = {.lex_state = 6, .external_lex_state = 3},
  [662] = {.lex_state = 6, .external_lex_state = 3},
  [663] = {.lex_state = 6, .external_lex_state = 3},
  [664] = {.lex_state = 6, .external_lex_state = 3},
  [665] = {.lex_state = 6, .external_lex_state = 3},
  [666] = {.lex_state = 6, .external_lex_state = 3},
  [667] = {.lex_state = 6, .external_lex_state = 3},
  [668] = {.lex_state = 6, .external_lex_state = 3},
  [669] = {.lex_state = 6, .external_lex_state = 3},
  [670] = {.lex_state = 7, .external_lex_state = 2},
  [671] = {.lex_state = 6, .external_lex_state = 2},
  [672] = {.lex_state = 6, .external_lex_state = 2},
  [673] = {.lex_state = 6, .external_lex_state = 2},
  [674] = {.lex_state = 6, .external_lex_state = 2},
  [675] = {.lex_state = 6, .external_lex_state = 2},
  [676] = {.lex_state = 6, .external_lex_state = 3},
  [677] = {.lex_state = 15},
  [678] = {.lex_state = 7, .external_lex_state = 2},
  [679] = {.lex_state = 6, .external_lex_state = 2},
  [680] = {.lex_state = 6, .external_lex_state = 2},
  [681] = {.lex_state = 6, .external_lex_state = 3},
  [682] = {.lex_state = 7, .external_lex_state = 2},
  [683] = {.lex_state = 7, .external_lex_state = 2},
  [684] = {.lex_state = 6, .external_lex_state = 2},
  [685] = {.lex_state = 7, .external_lex_state = 2},
  [686] = {.lex_state = 6, .external_lex_state = 2},
  [687] = {.lex_state = 6, .external_lex_state = 3},
  [688] = {.lex_state = 6, .external_lex_state = 3},
  [689] = {.lex_state = 7, .external_lex_state = 2},
  [690] = {.lex_state = 7, .external_lex_state = 2},
  [691] = {.lex_state = 6, .external_lex_state = 3},
  [692] = {.lex_state = 6, .external_lex_state = 3},
  [693] = {.lex_state = 6, .external_lex_state = 3},
  [694] = {.lex_state = 7, .external_lex_state = 2},
  [695] = {.lex_state = 6, .external_lex_state = 2},
  [696] = {.lex_state = 7, .external_lex_state = 2},
  [697] = {.lex_state = 7, .external_lex_state = 2},
  [698] = {.lex_state = 7, .external_lex_state = 2},
  [699] = {.lex_state = 6, .external_lex_state = 2},
  [700] = {.lex_state = 7, .external_lex_state = 2},
  [701] = {.lex_state = 7, .external_lex_state = 2},
  [702] = {.lex_state = 6, .external_lex_state = 2},
  [703] = {.lex_state = 6, .external_lex_state = 2},
  [704] = {.lex_state = 6, .external_lex_state = 2},
  [705] = {.lex_state = 6, .external_lex_state = 3},
  [706] = {.lex_state = 6, .external_lex_state = 3},
  [707] = {.lex_state = 15},
  [708] = {.lex_state = 6, .external_lex_state = 3},
  [709] = {.lex_state = 15},
  [710] = {.lex_state = 15},
  [711] = {.lex_state = 15},
  [712] = {.lex_state = 15},
  [713] = {.lex_state = 6, .external_lex_state = 3},
  [714] = {.lex_state = 6, .external_lex_state = 3},
  [715] = {.lex_state = 6, .external_lex_state = 3},
  [716] = {.lex_state = 6, .external_lex_state = 3},
  [717] = {.lex_state = 6, .external_lex_state = 3},
  [718] = {.lex_state = 6, .external_lex_state = 2},
  [719] = {.lex_state = 6, .external_lex_state = 3},
  [720] = {.lex_state = 6, .external_lex_state = 3},
  [721] = {.lex_state = 15},
  [722] = {.lex_state = 6, .external_lex_state = 3},
  [723] = {.lex_state = 6, .external_lex_state = 2},
  [724] = {.lex_state = 15},
  [725] = {.lex_state = 6, .external_lex_state = 3},
  [726] = {.lex_state = 15},
  [727] = {.lex_state = 6, .external_lex_state = 2},
  [728] = {.lex_state = 15},
  [729] = {.lex_state = 15},
  [730] = {.lex_state = 15},
  [731] = {.lex_state = 6, .external_lex_state = 3},
  [732] = {.lex_state = 7, .external_lex_state = 2},
  [733] = {.lex_state = 15},
  [734] = {.lex_state = 6, .external_lex_state = 3},
  [735] = {.lex_state = 7, .external_lex_state = 2},
  [736] = {.lex_state = 15},
  [737] = {.lex_state = 6, .external_lex_state = 2},
  [738] = {.lex_state = 6, .external_lex_state = 2},
  [739] = {.lex_state = 6, .external_lex_state = 2},
  [740] = {.lex_state = 18},
  [741] = {.lex_state = 7, .external_lex_state = 2},
  [742] = {.lex_state = 6, .external_lex_state = 2},
  [743] = {.lex_state = 6, .external_lex_state = 2},
  [744] = {.lex_state = 18},
  [745] = {.lex_state = 15},
  [746] = {.lex_state = 15},
  [747] = {.lex_state = 6, .external_lex_state = 3},
  [748] = {.lex_state = 6, .external_lex_state = 3},
  [749] = {.lex_state = 15},
  [750] = {.lex_state = 6, .external_lex_state = 2},
  [751] = {.lex_state = 6, .external_lex_state = 2},
  [752] = {.lex_state = 15},
  [753] = {.lex_state = 15},
  [754] = {.lex_state = 15},
  [755] = {.lex_state = 6, .external_lex_state = 3},
  [756] = {.lex_state = 15},
  [757] = {.lex_state = 15},
  [758] = {.lex_state = 15},
  [759] = {.lex_state = 15},
  [760] = {.lex_state = 15},
  [761] = {.lex_state = 15},
  [762] = {.lex_state = 15},
  [763] = {.lex_state = 6, .external_lex_state = 3},
  [764] = {.lex_state = 18},
  [765] = {.lex_state = 15},
  [766] = {.lex_state = 18},
  [767] = {.lex_state = 18},
  [768] = {.lex_state = 6, .external_lex_state = 2},
  [769] = {.lex_state = 6, .external_lex_state = 2},
  [770] = {.lex_state = 15},
  [771] = {.lex_state = 18},
  [772] = {.lex_state = 15},
  [773] = {.lex_state = 15},
  [774] = {.lex_state = 18},
  [775] = {.lex_state = 15},
  [776] = {.lex_state = 15},
  [777] = {.lex_state = 6, .external_lex_state = 3},
  [778] = {.lex_state = 7, .external_lex_state = 2},
  [779] = {.lex_state = 6, .external_lex_state = 3},
  [780] = {.lex_state = 15},
  [781] = {.lex_state = 15},
  [782] = {.lex_state = 6, .external_lex_state = 2},
  [783] = {.lex_state = 7, .external_lex_state = 2},
  [784] = {.lex_state = 17},
  [785] = {.lex_state = 6, .external_lex_state = 2},
  [786] = {.lex_state = 6, .external_lex_state = 3},
  [787] = {.lex_state = 15},
  [788] = {.lex_state = 15},
  [789] = {.lex_state = 15},
  [790] = {.lex_state = 15},
  [791] = {.lex_state = 15},
  [792] = {.lex_state = 15},
  [793] = {.lex_state = 7, .external_lex_state = 2},
  [794] = {.lex_state = 15},
  [795] = {.lex_state = 6, .external_lex_state = 3},
  [796] = {.lex_state = 15},
  [797] = {.lex_state = 6, .external_lex_state = 3},
  [798] = {.lex_state = 15},
  [799] = {.lex_state = 15},
  [800] = {.lex_state = 15},
  [801] = {.lex_state = 15},
  [802] = {.lex_state = 15},
  [803] = {.lex_state = 15},
  [804] = {.lex_state = 15},
  [805] = {.lex_state = 15},
  [806] = {.lex_state = 15},
  [807] = {.lex_state = 15},
  [808] = {.lex_state = 15},
  [809] = {.lex_state = 15},
  [810] = {.lex_state = 15},
  [811] = {.lex_state = 15},
  [812] = {.lex_state = 15},
  [813] = {.lex_state = 6, .external_lex_state = 3},
  [814] = {.lex_state = 15},
  [815] = {.lex_state = 15},
  [816] = {.lex_state = 15},
  [817] = {.lex_state = 6, .external_lex_state = 2},
  [818] = {.lex_state = 15},
  [819] = {.lex_state = 15},
  [820] = {.lex_state = 15},
  [821] = {.lex_state = 15},
  [822] = {.lex_state = 15},
  [823] = {.lex_state = 15},
  [824] = {.lex_state = 6, .external_lex_state = 2},
  [825] = {.lex_state = 15},
  [826] = {.lex_state = 15},
  [827] = {.lex_state = 15},
  [828] = {.lex_state = 15},
  [829] = {.lex_state = 15},
  [830] = {.lex_state = 6, .external_lex_state = 3},
  [831] = {.lex_state = 15},
  [832] = {.lex_state = 15},
  [833] = {.lex_state = 15},
  [834] = {.lex_state = 15},
  [835] = {.lex_state = 15},
  [836] = {.lex_state = 15},
  [837] = {.lex_state = 15},
  [838] = {.lex_state = 15},
  [839] = {.lex_state = 15},
  [840] = {.lex_state = 15},
  [841] = {.lex_state = 15},
  [842] = {.lex_state = 15},
  [843] = {.lex_state = 15},
  [844] = {.lex_state = 15},
  [845] = {.lex_state = 6, .external_lex_state = 2},
  [846] = {.lex_state = 15},
  [847] = {.lex_state = 15},
  [848] = {.lex_state = 15},
  [849] = {.lex_state = 15},
  [850] = {.lex_state = 15},
  [851] = {.lex_state = 15},
  [852] = {.lex_state = 15},
  [853] = {.lex_state = 15},
  [854] = {.lex_state = 15},
  [855] = {.lex_state = 15},
  [856] = {.lex_state = 15},
  [857] = {.lex_state = 15},
  [858] = {.lex_state = 15},
  [859] = {.lex_state = 15},
  [860] = {.lex_state = 15},
  [861] = {.lex_state = 15},
  [862] = {.lex_state = 15},
  [863] = {.lex_state = 15},
  [864] = {.lex_state = 15},
  [865] = {.lex_state = 6, .external_lex_state = 3},
  [866] = {.lex_state = 15},
  [867] = {.lex_state = 15},
  [868] = {.lex_state = 15},
  [869] = {.lex_state = 6, .external_lex_state = 3},
  [870] = {.lex_state = 15},
  [871] = {.lex_state = 15},
  [872] = {.lex_state = 15},
  [873] = {.lex_state = 15},
  [874] = {.lex_state = 15},
  [875] = {.lex_state = 15},
  [876] = {.lex_state = 15},
  [877] = {.lex_state = 6, .external_lex_state = 2},
  [878] = {.lex_state = 15},
  [879] = {.lex_state = 15},
  [880] = {.lex_state = 6, .external_lex_state = 3},
  [881] = {.lex_state = 15},
  [882] = {.lex_state = 15},
  [883] = {.lex_state = 15},
  [884] = {.lex_state = 15},
  [885] = {.lex_state = 15},
  [886] = {.lex_state = 6, .external_lex_state = 3},
  [887] = {.lex_state = 6, .external_lex_state = 3},
  [888] = {.lex_state = 15},
  [889] = {.lex_state = 15},
  [890] = {.lex_state = 15},
  [891] = {.lex_state = 15},
  [892] = {.lex_state = 15},
  [893] = {.lex_state = 15},
  [894] = {.lex_state = 15},
  [895] = {.lex_state = 15},
  [896] = {.lex_state = 15},
  [897] = {.lex_state = 6, .external_lex_state = 2},
  [898] = {.lex_state = 15},
  [899] = {.lex_state = 6, .external_lex_state = 2},
  [900] = {.lex_state = 15},
  [901] = {.lex_state = 6, .external_lex_state = 3},
  [902] = {.lex_state = 15},
  [903] = {.lex_state = 15},
  [904] = {.lex_state = 15},
  [905] = {.lex_state = 6, .external_lex_state = 2},
  [906] = {.lex_state = 15},
  [907] = {.lex_state = 15},
  [908] = {.lex_state = 15},
  [909] = {.lex_state = 15},
  [910] = {.lex_state = 6, .external_lex_state = 3},
  [911] = {.lex_state = 15},
  [912] = {.lex_state = 15},
  [913] = {.lex_state = 15},
  [914] = {.lex_state = 6, .external_lex_state = 3},
  [915] = {.lex_state = 15},
  [916] = {.lex_state = 15},
  [917] = {.lex_state = 6, .external_lex_state = 3},
  [918] = {.lex_state = 15},
  [919] = {.lex_state = 15},
  [920] = {.lex_state = 15},
  [921] = {.lex_state = 15},
  [922] = {.lex_state = 15},
  [923] = {.lex_state = 6, .external_lex_state = 3},
  [924] = {.lex_state = 15},
  [925] = {.lex_state = 15},
  [926] = {.lex_state = 6, .external_lex_state = 2},
  [927] = {.lex_state = 6, .external_lex_state = 3},
  [928] = {.lex_state = 15},
  [929] = {.lex_state = 15},
  [930] = {.lex_state = 15},
  [931] = {.lex_state = 6, .external_lex_state = 3},
  [932] = {.lex_state = 6, .external_lex_state = 3},
  [933] = {.lex_state = 6, .external_lex_state = 3},
  [934] = {.lex_state = 6, .external_lex_state = 3},
  [935] = {.lex_state = 15},
  [936] = {.lex_state = 6, .external_lex_state = 3},
  [937] = {.lex_state = 15},
  [938] = {.lex_state = 15},
  [939] = {.lex_state = 6, .external_lex_state = 3},
  [940] = {.lex_state = 15},
  [941] = {.lex_state = 6, .external_lex_state = 3},
  [942] = {.lex_state = 6, .external_lex_state = 2},
  [943] = {.lex_state = 6, .external_lex_state = 3},
  [944] = {.lex_state = 6, .external_lex_state = 3},
  [945] = {.lex_state = 15},
  [946] = {.lex_state = 15},
  [947] = {.lex_state = 15},
  [948] = {.lex_state = 15},
  [949] = {.lex_state = 15},
  [950] = {.lex_state = 15},
  [951] = {.lex_state = 7, .external_lex_state = 2},
  [952] = {.lex_state = 15},
  [953] = {.lex_state = 15},
  [954] = {.lex_state = 15},
  [955] = {.lex_state = 15},
  [956] = {.lex_state = 6, .external_lex_state = 3},
  [957] = {.lex_state = 15},
  [958] = {.lex_state = 15},
  [959] = {.lex_state = 15},
  [960] = {.lex_state = 15},
  [961] = {.lex_state = 15},
  [962] = {.lex_state = 6, .external_lex_state = 3},
  [963] = {.lex_state = 6, .external_lex_state = 2},
  [964] = {.lex_state = 6, .external_lex_state = 2},
  [965] = {.lex_state = 6, .external_lex_state = 3},
  [966] = {.lex_state = 6, .external_lex_state = 2},
  [967] = {.lex_state = 6, .external_lex_state = 2},
  [968] = {.lex_state = 6, .external_lex_state = 2},
  [969] = {.lex_state = 7, .external_lex_state = 2},
  [970] = {.lex_state = 6, .external_lex_state = 2},
  [971] = {.lex_state = 6, .external_lex_state = 3},
  [972] = {.lex_state = 6, .external_lex_state = 2},
  [973] = {.lex_state = 6, .external_lex_state = 2},
  [974] = {.lex_state = 6, .external_lex_state = 2},
  [975] = {.lex_state = 6, .external_lex_state = 2},
  [976] = {.lex_state = 6, .external_lex_state = 2},
  [977] = {.lex_state = 6, .external_lex_state = 3},
  [978] = {.lex_state = 6, .external_lex_state = 2},
  [979] = {.lex_state = 6, .external_lex_state = 3},
  [980] = {.lex_state = 6, .external_lex_state = 2},
  [981] = {.lex_state = 6, .external_lex_state = 3},
  [982] = {.lex_state = 6, .external_lex_state = 2},
  [983] = {.lex_state = 7, .external_lex_state = 2},
  [984] = {.lex_state = 6, .external_lex_state = 2},
  [985] = {.lex_state = 6, .external_lex_state = 2},
  [986] = {.lex_state = 6, .external_lex_state = 2},
  [987] = {.lex_state = 18},
  [988] = {.lex_state = 7, .external_lex_state = 2},
  [989] = {.lex_state = 6, .external_lex_state = 2},
  [990] = {.lex_state = 6, .external_lex_state = 2},
  [991] = {.lex_state = 6, .external_lex_state = 2},
  [992] = {.lex_state = 6, .external_lex_state = 2},
  [993] = {.lex_state = 6, .external_lex_state = 2},
  [994] = {.lex_state = 6, .external_lex_state = 2},
  [995] = {.lex_state = 6, .external_lex_state = 2},
  [996] = {.lex_state = 6, .external_lex_state = 2},
  [997] = {.lex_state = 6, .external_lex_state = 2},
  [998] = {.lex_state = 6, .external_lex_state = 2},
  [999] = {.lex_state = 7, .external_lex_state = 2},
  [1000] = {.lex_state = 6, .external_lex_state = 3},
  [1001] = {.lex_state = 6, .external_lex_state = 2},
  [1002] = {.lex_state = 6, .external_lex_state = 3},
  [1003] = {.lex_state = 6, .external_lex_state = 2},
  [1004] = {.lex_state = 6, .external_lex_state = 2},
  [1005] = {.lex_state = 6, .external_lex_state = 3},
  [1006] = {.lex_state = 18},
  [1007] = {.lex_state = 6, .external_lex_state = 2},
  [1008] = {.lex_state = 6, .external_lex_state = 2},
  [1009] = {.lex_state = 6, .external_lex_state = 2},
  [1010] = {.lex_state = 7, .external_lex_state = 2},
  [1011] = {.lex_state = 6, .external_lex_state = 2},
  [1012] = {.lex_state = 6, .external_lex_state = 2},
  [1013] = {.lex_state = 6, .external_lex_state = 2},
  [1014] = {.lex_state = 6, .external_lex_state = 2},
  [1015] = {.lex_state = 6, .external_lex_state = 3},
  [1016] = {.lex_state = 6, .external_lex_state = 3},
  [1017] = {.lex_state = 6, .external_lex_state = 2},
  [1018] = {.lex_state = 6, .external_lex_state = 2},
  [1019] = {.lex_state = 6, .external_lex_state = 2},
  [1020] = {.lex_state = 6, .external_lex_state = 2},
  [1021] = {.lex_state = 6, .external_lex_state = 2},
  [1022] = {.lex_state = 6, .external_lex_state = 2},
  [1023] = {.lex_state = 70, .external_lex_state = 3},
  [1024] = {.lex_state = 71, .external_lex_state = 4},
  [1025] = {.lex_state = 71, .external_lex_state = 4},
  [1026] = {.lex_state = 71, .external_lex_state = 4},
  [1027] = {.lex_state = 15},
  [1028] = {.lex_state = 15},
  [1029] = {.lex_state = 15},
  [1030] = {.lex_state = 15},
  [1031] = {.lex_state = 15},
  [1032] = {.lex_state = 71, .external_lex_state = 4},
  [1033] = {.lex_state = 15},
  [1034] = {.lex_state = 71, .external_lex_state = 4},
  [1035] = {.lex_state = 71, .external_lex_state = 4},
  [1036] = {.lex_state = 15},
  [1037] = {.lex_state = 15},
  [1038] = {.lex_state = 15},
  [1039] = {.lex_state = 15},
  [1040] = {.lex_state = 15},
  [1041] = {.lex_state = 15},
  [1042] = {.lex_state = 15},
  [1043] = {.lex_state = 15},
  [1044] = {.lex_state = 15},
  [1045] = {.lex_state = 15},
  [1046] = {.lex_state = 15},
  [1047] = {.lex_state = 15},
  [1048] = {.lex_state = 15},
  [1049] = {.lex_state = 15},
  [1050] = {.lex_state = 15},
  [1051] = {.lex_state = 15},
  [1052] = {.lex_state = 15},
  [1053] = {.lex_state = 15},
  [1054] = {.lex_state = 70, .external_lex_state = 3},
  [1055] = {.lex_state = 70, .external_lex_state = 2},
  [1056] = {.lex_state = 70, .external_lex_state = 2},
  [1057] = {.lex_state = 70, .external_lex_state = 3},
  [1058] = {.lex_state = 70, .external_lex_state = 2},
  [1059] = {.lex_state = 70, .external_lex_state = 2},
  [1060] = {.lex_state = 70, .external_lex_state = 2},
  [1061] = {.lex_state = 70, .external_lex_state = 2},
  [1062] = {.lex_state = 70, .external_lex_state = 2},
  [1063] = {.lex_state = 70, .external_lex_state = 2},
  [1064] = {.lex_state = 70, .external_lex_state = 2},
  [1065] = {.lex_state = 15},
  [1066] = {.lex_state = 70, .external_lex_state = 2},
  [1067] = {.lex_state = 70, .external_lex_state = 2},
  [1068] = {.lex_state = 70, .external_lex_state = 2},
  [1069] = {.lex_state = 15},
  [1070] = {.lex_state = 15},
  [1071] = {.lex_state = 70, .external_lex_state = 2},
  [1072] = {.lex_state = 70, .external_lex_state = 2},
  [1073] = {.lex_state = 15},
  [1074] = {.lex_state = 70, .external_lex_state = 2},
  [1075] = {.lex_state = 15},
  [1076] = {.lex_state = 70, .external_lex_state = 2},
  [1077] = {.lex_state = 70, .external_lex_state = 2},
  [1078] = {.lex_state = 15},
  [1079] = {.lex_state = 70, .external_lex_state = 3},
  [1080] = {.lex_state = 70, .external_lex_state = 2},
  [1081] = {.lex_state = 70, .external_lex_state = 2},
  [1082] = {.lex_state = 15},
  [1083] = {.lex_state = 70, .external_lex_state = 2},
  [1084] = {.lex_state = 70, .external_lex_state = 2},
  [1085] = {.lex_state = 70, .external_lex_state = 2},
  [1086] = {.lex_state = 70, .external_lex_state = 2},
  [1087] = {.lex_state = 70, .external_lex_state = 2},
  [1088] = {.lex_state = 70, .external_lex_state = 2},
  [1089] = {.lex_state = 70, .external_lex_state = 2},
  [1090] = {.lex_state = 70, .external_lex_state = 2},
  [1091] = {.lex_state = 70, .external_lex_state = 2},
  [1092] = {.lex_state = 70, .external_lex_state = 2},
  [1093] = {.lex_state = 70, .external_lex_state = 2},
  [1094] = {.lex_state = 70, .external_lex_state = 2},
  [1095] = {.lex_state = 70, .external_lex_state = 2},
  [1096] = {.lex_state = 70, .external_lex_state = 2},
  [1097] = {.lex_state = 70, .external_lex_state = 2},
  [1098] = {.lex_state = 70, .external_lex_state = 2},
  [1099] = {.lex_state = 70, .external_lex_state = 2},
  [1100] = {.lex_state = 70, .external_lex_state = 2},
  [1101] = {.lex_state = 70, .external_lex_state = 3},
  [1102] = {.lex_state = 70, .external_lex_state = 2},
  [1103] = {.lex_state = 70, .external_lex_state = 2},
  [1104] = {.lex_state = 70, .external_lex_state = 2},
  [1105] = {.lex_state = 70, .external_lex_state = 2},
  [1106] = {.lex_state = 70, .external_lex_state = 2},
  [1107] = {.lex_state = 70, .external_lex_state = 3},
  [1108] = {.lex_state = 70, .external_lex_state = 2},
  [1109] = {.lex_state = 70, .external_lex_state = 3},
  [1110] = {.lex_state = 70, .external_lex_state = 3},
  [1111] = {.lex_state = 70, .external_lex_state = 2},
  [1112] = {.lex_state = 70, .external_lex_state = 2},
  [1113] = {.lex_state = 70, .external_lex_state = 2},
  [1114] = {.lex_state = 70, .external_lex_state = 2},
  [1115] = {.lex_state = 70, .external_lex_state = 2},
  [1116] = {.lex_state = 70, .external_lex_state = 2},
  [1117] = {.lex_state = 70, .external_lex_state = 2},
  [1118] = {.lex_state = 70, .external_lex_state = 2},
  [1119] = {.lex_state = 70, .external_lex_state = 2},
  [1120] = {.lex_state = 70, .external_lex_state = 2},
  [1121] = {.lex_state = 70, .external_lex_state = 2},
  [1122] = {.lex_state = 70, .external_lex_state = 2},
  [1123] = {.lex_state = 70, .external_lex_state = 2},
  [1124] = {.lex_state = 70, .external_lex_state = 2},
  [1125] = {.lex_state = 70, .external_lex_state = 2},
  [1126] = {.lex_state = 70, .external_lex_state = 2},
  [1127] = {.lex_state = 70, .external_lex_state = 2},
  [1128] = {.lex_state = 70, .external_lex_state = 2},
  [1129] = {.lex_state = 70, .external_lex_state = 2},
  [1130] = {.lex_state = 70, .external_lex_state = 2},
  [1131] = {.lex_state = 70, .external_lex_state = 2},
  [1132] = {.lex_state = 70, .external_lex_state = 2},
  [1133] = {.lex_state = 70, .external_lex_state = 2},
  [1134] = {.lex_state = 70, .external_lex_state = 2},
  [1135] = {.lex_state = 70, .external_lex_state = 2},
  [1136] = {.lex_state = 70, .external_lex_state = 2},
  [1137] = {.lex_state = 70, .external_lex_state = 2},
  [1138] = {.lex_state = 70, .external_lex_state = 2},
  [1139] = {.lex_state = 70, .external_lex_state = 2},
  [1140] = {.lex_state = 70, .external_lex_state = 2},
  [1141] = {.lex_state = 70, .external_lex_state = 3},
  [1142] = {.lex_state = 70, .external_lex_state = 2},
  [1143] = {.lex_state = 70, .external_lex_state = 2},
  [1144] = {.lex_state = 70, .external_lex_state = 2},
  [1145] = {.lex_state = 70, .external_lex_state = 2},
  [1146] = {.lex_state = 70, .external_lex_state = 2},
  [1147] = {.lex_state = 70, .external_lex_state = 2},
  [1148] = {.lex_state = 70, .external_lex_state = 2},
  [1149] = {.lex_state = 70, .external_lex_state = 2},
  [1150] = {.lex_state = 70, .external_lex_state = 2},
  [1151] = {.lex_state = 70, .external_lex_state = 2},
  [1152] = {.lex_state = 70, .external_lex_state = 2},
  [1153] = {.lex_state = 70, .external_lex_state = 2},
  [1154] = {.lex_state = 70, .external_lex_state = 2},
  [1155] = {.lex_state = 70, .external_lex_state = 2},
  [1156] = {.lex_state = 70, .external_lex_state = 2},
  [1157] = {.lex_state = 70, .external_lex_state = 2},
  [1158] = {.lex_state = 70, .external_lex_state = 2},
  [1159] = {.lex_state = 70, .external_lex_state = 2},
  [1160] = {.lex_state = 70, .external_lex_state = 2},
  [1161] = {.lex_state = 70, .external_lex_state = 2},
  [1162] = {.lex_state = 70, .external_lex_state = 2},
  [1163] = {.lex_state = 70, .external_lex_state = 3},
  [1164] = {.lex_state = 70, .external_lex_state = 2},
  [1165] = {.lex_state = 70, .external_lex_state = 2},
  [1166] = {.lex_state = 70, .external_lex_state = 2},
  [1167] = {.lex_state = 70, .external_lex_state = 2},
  [1168] = {.lex_state = 70, .external_lex_state = 2},
  [1169] = {.lex_state = 70, .external_lex_state = 3},
  [1170] = {.lex_state = 70, .external_lex_state = 2},
  [1171] = {.lex_state = 70, .external_lex_state = 2},
  [1172] = {.lex_state = 70, .external_lex_state = 2},
  [1173] = {.lex_state = 70, .external_lex_state = 2},
  [1174] = {.lex_state = 70, .external_lex_state = 2},
  [1175] = {.lex_state = 70, .external_lex_state = 2},
  [1176] = {.lex_state = 70, .external_lex_state = 2},
  [1177] = {.lex_state = 70, .external_lex_state = 2},
  [1178] = {.lex_state = 70, .external_lex_state = 3},
  [1179] = {.lex_state = 70, .external_lex_state = 2},
  [1180] = {.lex_state = 70, .external_lex_state = 2},
  [1181] = {.lex_state = 70, .external_lex_state = 2},
  [1182] = {.lex_state = 70, .external_lex_state = 2},
  [1183] = {.lex_state = 70, .external_lex_state = 2},
  [1184] = {.lex_state = 70, .external_lex_state = 3},
  [1185] = {.lex_state = 70, .external_lex_state = 3},
  [1186] = {.lex_state = 70, .external_lex_state = 2},
  [1187] = {.lex_state = 70, .external_lex_state = 2},
  [1188] = {.lex_state = 70, .external_lex_state = 2},
  [1189] = {.lex_state = 70, .external_lex_state = 2},
  [1190] = {.lex_state = 70, .external_lex_state = 3},
  [1191] = {.lex_state = 70, .external_lex_state = 2},
  [1192] = {.lex_state = 70, .external_lex_state = 2},
  [1193] = {.lex_state = 70, .external_lex_state = 2},
  [1194] = {.lex_state = 70, .external_lex_state = 3},
  [1195] = {.lex_state = 70, .external_lex_state = 2},
  [1196] = {.lex_state = 70, .external_lex_state = 2},
  [1197] = {.lex_state = 70, .external_lex_state = 3},
  [1198] = {.lex_state = 70, .external_lex_state = 2},
  [1199] = {.lex_state = 70, .external_lex_state = 2},
  [1200] = {.lex_state = 70, .external_lex_state = 3},
  [1201] = {.lex_state = 70, .external_lex_state = 2},
  [1202] = {.lex_state = 70, .external_lex_state = 2},
  [1203] = {.lex_state = 70, .external_lex_state = 2},
  [1204] = {.lex_state = 70, .external_lex_state = 2},
  [1205] = {.lex_state = 70, .external_lex_state = 2},
  [1206] = {.lex_state = 70, .external_lex_state = 3},
  [1207] = {.lex_state = 70, .external_lex_state = 3},
  [1208] = {.lex_state = 70, .external_lex_state = 2},
  [1209] = {.lex_state = 70, .external_lex_state = 2},
  [1210] = {.lex_state = 70, .external_lex_state = 2},
  [1211] = {.lex_state = 70, .external_lex_state = 2},
  [1212] = {.lex_state = 70, .external_lex_state = 2},
  [1213] = {.lex_state = 70, .external_lex_state = 2},
  [1214] = {.lex_state = 70, .external_lex_state = 2},
  [1215] = {.lex_state = 70, .external_lex_state = 2},
  [1216] = {.lex_state = 70, .external_lex_state = 2},
  [1217] = {.lex_state = 70, .external_lex_state = 3},
  [1218] = {.lex_state = 70, .external_lex_state = 3},
  [1219] = {.lex_state = 70, .external_lex_state = 3},
  [1220] = {.lex_state = 70, .external_lex_state = 3},
  [1221] = {.lex_state = 70, .external_lex_state = 2},
  [1222] = {.lex_state = 70, .external_lex_state = 2},
  [1223] = {.lex_state = 70, .external_lex_state = 3},
  [1224] = {.lex_state = 70, .external_lex_state = 2},
  [1225] = {.lex_state = 70, .external_lex_state = 2},
  [1226] = {.lex_state = 70, .external_lex_state = 2},
  [1227] = {.lex_state = 70, .external_lex_state = 3},
  [1228] = {.lex_state = 70, .external_lex_state = 3},
  [1229] = {.lex_state = 70, .external_lex_state = 2},
  [1230] = {.lex_state = 70, .external_lex_state = 2},
  [1231] = {.lex_state = 70, .external_lex_state = 2},
  [1232] = {.lex_state = 70, .external_lex_state = 2},
  [1233] = {.lex_state = 70, .external_lex_state = 2},
  [1234] = {.lex_state = 70, .external_lex_state = 2},
  [1235] = {.lex_state = 70, .external_lex_state = 2},
  [1236] = {.lex_state = 70, .external_lex_state = 2},
  [1237] = {.lex_state = 70, .external_lex_state = 3},
  [1238] = {.lex_state = 70, .external_lex_state = 2},
  [1239] = {.lex_state = 70, .external_lex_state = 2},
  [1240] = {.lex_state = 70, .external_lex_state = 2},
  [1241] = {.lex_state = 70, .external_lex_state = 3},
  [1242] = {.lex_state = 70, .external_lex_state = 3},
  [1243] = {.lex_state = 70, .external_lex_state = 3},
  [1244] = {.lex_state = 70, .external_lex_state = 2},
  [1245] = {.lex_state = 70, .external_lex_state = 3},
  [1246] = {.lex_state = 70, .external_lex_state = 3},
  [1247] = {.lex_state = 70, .external_lex_state = 3},
  [1248] = {.lex_state = 70, .external_lex_state = 2},
  [1249] = {.lex_state = 70, .external_lex_state = 3},
  [1250] = {.lex_state = 70, .external_lex_state = 3},
  [1251] = {.lex_state = 70, .external_lex_state = 3},
  [1252] = {.lex_state = 70, .external_lex_state = 3},
  [1253] = {.lex_state = 70, .external_lex_state = 3},
  [1254] = {.lex_state = 70, .external_lex_state = 3},
  [1255] = {.lex_state = 70, .external_lex_state = 2},
  [1256] = {.lex_state = 70, .external_lex_state = 3},
  [1257] = {.lex_state = 70, .external_lex_state = 3},
  [1258] = {.lex_state = 70, .external_lex_state = 3},
  [1259] = {.lex_state = 70, .external_lex_state = 3},
  [1260] = {.lex_state = 70, .external_lex_state = 2},
  [1261] = {.lex_state = 70, .external_lex_state = 3},
  [1262] = {.lex_state = 8, .external_lex_state = 2},
  [1263] = {.lex_state = 70, .external_lex_state = 2},
  [1264] = {.lex_state = 70, .external_lex_state = 2},
  [1265] = {.lex_state = 70, .external_lex_state = 2},
  [1266] = {.lex_state = 70, .external_lex_state = 2},
  [1267] = {.lex_state = 70, .external_lex_state = 3},
  [1268] = {.lex_state = 70, .external_lex_state = 2},
  [1269] = {.lex_state = 70, .external_lex_state = 3},
  [1270] = {.lex_state = 70, .external_lex_state = 2},
  [1271] = {.lex_state = 70, .external_lex_state = 2},
  [1272] = {.lex_state = 70, .external_lex_state = 3},
  [1273] = {.lex_state = 70, .external_lex_state = 2},
  [1274] = {.lex_state = 70, .external_lex_state = 3},
  [1275] = {.lex_state = 70, .external_lex_state = 2},
  [1276] = {.lex_state = 70, .external_lex_state = 3},
  [1277] = {.lex_state = 70, .external_lex_state = 3},
  [1278] = {.lex_state = 70, .external_lex_state = 2},
  [1279] = {.lex_state = 70, .external_lex_state = 2},
  [1280] = {.lex_state = 70, .external_lex_state = 2},
  [1281] = {.lex_state = 70, .external_lex_state = 2},
  [1282] = {.lex_state = 70, .external_lex_state = 3},
  [1283] = {.lex_state = 70, .external_lex_state = 3},
  [1284] = {.lex_state = 70, .external_lex_state = 2},
  [1285] = {.lex_state = 8, .external_lex_state = 2},
  [1286] = {.lex_state = 8, .external_lex_state = 2},
  [1287] = {.lex_state = 8, .external_lex_state = 2},
  [1288] = {.lex_state = 8, .external_lex_state = 2},
  [1289] = {.lex_state = 70, .external_lex_state = 2},
  [1290] = {.lex_state = 70, .external_lex_state = 2},
  [1291] = {.lex_state = 70, .external_lex_state = 3},
  [1292] = {.lex_state = 70, .external_lex_state = 3},
  [1293] = {.lex_state = 70, .external_lex_state = 2},
  [1294] = {.lex_state = 8, .external_lex_state = 2},
  [1295] = {.lex_state = 70, .external_lex_state = 3},
  [1296] = {.lex_state = 70, .external_lex_state = 2},
  [1297] = {.lex_state = 70, .external_lex_state = 2},
  [1298] = {.lex_state = 70, .external_lex_state = 3},
  [1299] = {.lex_state = 70, .external_lex_state = 3},
  [1300] = {.lex_state = 8, .external_lex_state = 2},
  [1301] = {.lex_state = 70, .external_lex_state = 2},
  [1302] = {.lex_state = 8, .external_lex_state = 2},
  [1303] = {.lex_state = 70, .external_lex_state = 2},
  [1304] = {.lex_state = 70, .external_lex_state = 3},
  [1305] = {.lex_state = 70, .external_lex_state = 3},
  [1306] = {.lex_state = 8, .external_lex_state = 2},
  [1307] = {.lex_state = 8, .external_lex_state = 2},
  [1308] = {.lex_state = 8, .external_lex_state = 2},
  [1309] = {.lex_state = 8, .external_lex_state = 2},
  [1310] = {.lex_state = 70, .external_lex_state = 2},
  [1311] = {.lex_state = 70, .external_lex_state = 2},
  [1312] = {.lex_state = 70, .external_lex_state = 2},
  [1313] = {.lex_state = 70, .external_lex_state = 2},
  [1314] = {.lex_state = 70, .external_lex_state = 2},
  [1315] = {.lex_state = 8, .external_lex_state = 2},
  [1316] = {.lex_state = 70, .external_lex_state = 2},
  [1317] = {.lex_state = 70, .external_lex_state = 2},
  [1318] = {.lex_state = 70, .external_lex_state = 2},
  [1319] = {.lex_state = 9, .external_lex_state = 2},
  [1320] = {.lex_state = 8, .external_lex_state = 2},
  [1321] = {.lex_state = 70, .external_lex_state = 3},
  [1322] = {.lex_state = 70, .external_lex_state = 2},
  [1323] = {.lex_state = 70, .external_lex_state = 2},
  [1324] = {.lex_state = 70, .external_lex_state = 3},
  [1325] = {.lex_state = 70, .external_lex_state = 3},
  [1326] = {.lex_state = 70, .external_lex_state = 2},
  [1327] = {.lex_state = 8, .external_lex_state = 2},
  [1328] = {.lex_state = 70, .external_lex_state = 2},
  [1329] = {.lex_state = 70, .external_lex_state = 2},
  [1330] = {.lex_state = 70, .external_lex_state = 2},
  [1331] = {.lex_state = 70, .external_lex_state = 2},
  [1332] = {.lex_state = 70, .external_lex_state = 3},
  [1333] = {.lex_state = 70, .external_lex_state = 3},
  [1334] = {.lex_state = 70, .external_lex_state = 2},
  [1335] = {.lex_state = 70, .external_lex_state = 2},
  [1336] = {.lex_state = 70, .external_lex_state = 2},
  [1337] = {.lex_state = 70, .external_lex_state = 2},
  [1338] = {.lex_state = 70, .external_lex_state = 2},
  [1339] = {.lex_state = 70, .external_lex_state = 2},
  [1340] = {.lex_state = 70, .external_lex_state = 2},
  [1341] = {.lex_state = 70, .external_lex_state = 2},
  [1342] = {.lex_state = 70, .external_lex_state = 2},
  [1343] = {.lex_state = 70, .external_lex_state = 2},
  [1344] = {.lex_state = 70, .external_lex_state = 2},
  [1345] = {.lex_state = 70, .external_lex_state = 2},
  [1346] = {.lex_state = 70, .external_lex_state = 3},
  [1347] = {.lex_state = 70, .external_lex_state = 2},
  [1348] = {.lex_state = 70, .external_lex_state = 3},
  [1349] = {.lex_state = 70, .external_lex_state = 2},
  [1350] = {.lex_state = 8, .external_lex_state = 2},
  [1351] = {.lex_state = 70, .external_lex_state = 2},
  [1352] = {.lex_state = 70, .external_lex_state = 2},
  [1353] = {.lex_state = 70, .external_lex_state = 2},
  [1354] = {.lex_state = 70, .external_lex_state = 2},
  [1355] = {.lex_state = 70, .external_lex_state = 2},
  [1356] = {.lex_state = 70, .external_lex_state = 2},
  [1357] = {.lex_state = 70, .external_lex_state = 3},
  [1358] = {.lex_state = 8, .external_lex_state = 2},
  [1359] = {.lex_state = 70, .external_lex_state = 2},
  [1360] = {.lex_state = 70, .external_lex_state = 2},
  [1361] = {.lex_state = 70, .external_lex_state = 2},
  [1362] = {.lex_state = 70, .external_lex_state = 2},
  [1363] = {.lex_state = 70, .external_lex_state = 2},
  [1364] = {.lex_state = 70, .external_lex_state = 2},
  [1365] = {.lex_state = 70, .external_lex_state = 2},
  [1366] = {.lex_state = 70, .external_lex_state = 3},
  [1367] = {.lex_state = 70, .external_lex_state = 3},
  [1368] = {.lex_state = 70, .external_lex_state = 2},
  [1369] = {.lex_state = 70, .external_lex_state = 2},
  [1370] = {.lex_state = 8, .external_lex_state = 2},
  [1371] = {.lex_state = 8, .external_lex_state = 2},
  [1372] = {.lex_state = 8, .external_lex_state = 2},
  [1373] = {.lex_state = 8, .external_lex_state = 2},
  [1374] = {.lex_state = 70, .external_lex_state = 2},
  [1375] = {.lex_state = 70, .external_lex_state = 2},
  [1376] = {.lex_state = 70, .external_lex_state = 3},
  [1377] = {.lex_state = 8, .external_lex_state = 2},
  [1378] = {.lex_state = 70, .external_lex_state = 2},
  [1379] = {.lex_state = 70, .external_lex_state = 2},
  [1380] = {.lex_state = 70, .external_lex_state = 3},
  [1381] = {.lex_state = 70, .external_lex_state = 3},
  [1382] = {.lex_state = 8, .external_lex_state = 2},
  [1383] = {.lex_state = 8, .external_lex_state = 2},
  [1384] = {.lex_state = 70, .external_lex_state = 3},
  [1385] = {.lex_state = 70, .external_lex_state = 2},
  [1386] = {.lex_state = 70, .external_lex_state = 2},
  [1387] = {.lex_state = 70, .external_lex_state = 2},
  [1388] = {.lex_state = 70, .external_lex_state = 2},
  [1389] = {.lex_state = 70, .external_lex_state = 3},
  [1390] = {.lex_state = 8, .external_lex_state = 2},
  [1391] = {.lex_state = 70, .external_lex_state = 2},
  [1392] = {.lex_state = 8, .external_lex_state = 2},
  [1393] = {.lex_state = 8, .external_lex_state = 2},
  [1394] = {.lex_state = 70, .external_lex_state = 3},
  [1395] = {.lex_state = 70, .external_lex_state = 2},
  [1396] = {.lex_state = 70, .external_lex_state = 2},
  [1397] = {.lex_state = 70, .external_lex_state = 2},
  [1398] = {.lex_state = 70, .external_lex_state = 3},
  [1399] = {.lex_state = 70, .external_lex_state = 3},
  [1400] = {.lex_state = 70, .external_lex_state = 3},
  [1401] = {.lex_state = 8, .external_lex_state = 2},
  [1402] = {.lex_state = 70, .external_lex_state = 2},
  [1403] = {.lex_state = 8, .external_lex_state = 2},
  [1404] = {.lex_state = 70, .external_lex_state = 2},
  [1405] = {.lex_state = 70, .external_lex_state = 3},
  [1406] = {.lex_state = 70, .external_lex_state = 2},
  [1407] = {.lex_state = 70, .external_lex_state = 2},
  [1408] = {.lex_state = 70, .external_lex_state = 3},
  [1409] = {.lex_state = 8, .external_lex_state = 2},
  [1410] = {.lex_state = 70, .external_lex_state = 2},
  [1411] = {.lex_state = 70, .external_lex_state = 2},
  [1412] = {.lex_state = 70, .external_lex_state = 3},
  [1413] = {.lex_state = 70, .external_lex_state = 3},
  [1414] = {.lex_state = 70, .external_lex_state = 3},
  [1415] = {.lex_state = 70, .external_lex_state = 2},
  [1416] = {.lex_state = 70, .external_lex_state = 3},
  [1417] = {.lex_state = 70, .external_lex_state = 3},
  [1418] = {.lex_state = 70, .external_lex_state = 3},
  [1419] = {.lex_state = 70, .external_lex_state = 2},
  [1420] = {.lex_state = 70, .external_lex_state = 3},
  [1421] = {.lex_state = 70, .external_lex_state = 3},
  [1422] = {.lex_state = 70, .external_lex_state = 3},
  [1423] = {.lex_state = 70, .external_lex_state = 2},
  [1424] = {.lex_state = 70, .external_lex_state = 3},
  [1425] = {.lex_state = 70, .external_lex_state = 3},
  [1426] = {.lex_state = 70, .external_lex_state = 3},
  [1427] = {.lex_state = 70, .external_lex_state = 3},
  [1428] = {.lex_state = 70, .external_lex_state = 3},
  [1429] = {.lex_state = 70, .external_lex_state = 3},
  [1430] = {.lex_state = 70, .external_lex_state = 2},
  [1431] = {.lex_state = 70, .external_lex_state = 3},
  [1432] = {.lex_state = 70, .external_lex_state = 3},
  [1433] = {.lex_state = 8, .external_lex_state = 3},
  [1434] = {.lex_state = 70, .external_lex_state = 3},
  [1435] = {.lex_state = 70, .external_lex_state = 3},
  [1436] = {.lex_state = 70, .external_lex_state = 3},
  [1437] = {.lex_state = 70, .external_lex_state = 3},
  [1438] = {.lex_state = 70, .external_lex_state = 3},
  [1439] = {.lex_state = 70, .external_lex_state = 3},
  [1440] = {.lex_state = 70, .external_lex_state = 3},
  [1441] = {.lex_state = 70, .external_lex_state = 3},
  [1442] = {.lex_state = 70, .external_lex_state = 3},
  [1443] = {.lex_state = 70, .external_lex_state = 2},
  [1444] = {.lex_state = 70, .external_lex_state = 3},
  [1445] = {.lex_state = 70, .external_lex_state = 3},
  [1446] = {.lex_state = 70, .external_lex_state = 3},
  [1447] = {.lex_state = 70, .external_lex_state = 3},
  [1448] = {.lex_state = 70, .external_lex_state = 2},
  [1449] = {.lex_state = 70, .external_lex_state = 3},
  [1450] = {.lex_state = 8, .external_lex_state = 2},
  [1451] = {.lex_state = 70, .external_lex_state = 3},
  [1452] = {.lex_state = 70, .external_lex_state = 3},
  [1453] = {.lex_state = 70, .external_lex_state = 3},
  [1454] = {.lex_state = 70, .external_lex_state = 3},
  [1455] = {.lex_state = 70, .external_lex_state = 2},
  [1456] = {.lex_state = 70, .external_lex_state = 3},
  [1457] = {.lex_state = 70, .external_lex_state = 3},
  [1458] = {.lex_state = 70, .external_lex_state = 3},
  [1459] = {.lex_state = 70, .external_lex_state = 3},
  [1460] = {.lex_state = 70, .external_lex_state = 3},
  [1461] = {.lex_state = 70, .external_lex_state = 2},
  [1462] = {.lex_state = 70, .external_lex_state = 3},
  [1463] = {.lex_state = 70, .external_lex_state = 3},
  [1464] = {.lex_state = 8, .external_lex_state = 2},
  [1465] = {.lex_state = 70, .external_lex_state = 3},
  [1466] = {.lex_state = 70, .external_lex_state = 3},
  [1467] = {.lex_state = 70, .external_lex_state = 2},
  [1468] = {.lex_state = 70, .external_lex_state = 2},
  [1469] = {.lex_state = 70, .external_lex_state = 3},
  [1470] = {.lex_state = 70, .external_lex_state = 3},
  [1471] = {.lex_state = 70, .external_lex_state = 3},
  [1472] = {.lex_state = 70, .external_lex_state = 3},
  [1473] = {.lex_state = 70, .external_lex_state = 3},
  [1474] = {.lex_state = 70, .external_lex_state = 2},
  [1475] = {.lex_state = 70, .external_lex_state = 3},
  [1476] = {.lex_state = 70, .external_lex_state = 3},
  [1477] = {.lex_state = 70, .external_lex_state = 3},
  [1478] = {.lex_state = 70, .external_lex_state = 3},
  [1479] = {.lex_state = 70, .external_lex_state = 3},
  [1480] = {.lex_state = 70, .external_lex_state = 3},
  [1481] = {.lex_state = 70, .external_lex_state = 3},
  [1482] = {.lex_state = 70, .external_lex_state = 3},
  [1483] = {.lex_state = 70, .external_lex_state = 3},
  [1484] = {.lex_state = 70, .external_lex_state = 2},
  [1485] = {.lex_state = 70, .external_lex_state = 3},
  [1486] = {.lex_state = 70, .external_lex_state = 3},
  [1487] = {.lex_state = 8, .external_lex_state = 2},
  [1488] = {.lex_state = 70, .external_lex_state = 2},
  [1489] = {.lex_state = 8, .external_lex_state = 2},
  [1490] = {.lex_state = 70, .external_lex_state = 3},
  [1491] = {.lex_state = 70, .external_lex_state = 2},
  [1492] = {.lex_state = 70, .external_lex_state = 2},
  [1493] = {.lex_state = 70, .external_lex_state = 2},
  [1494] = {.lex_state = 70, .external_lex_state = 3},
  [1495] = {.lex_state = 70, .external_lex_state = 2},
  [1496] = {.lex_state = 70, .external_lex_state = 3},
  [1497] = {.lex_state = 70, .external_lex_state = 2},
  [1498] = {.lex_state = 70, .external_lex_state = 2},
  [1499] = {.lex_state = 70, .external_lex_state = 2},
  [1500] = {.lex_state = 70, .external_lex_state = 3},
  [1501] = {.lex_state = 70, .external_lex_state = 2},
  [1502] = {.lex_state = 8, .external_lex_state = 2},
  [1503] = {.lex_state = 70, .external_lex_state = 2},
  [1504] = {.lex_state = 70, .external_lex_state = 3},
  [1505] = {.lex_state = 8, .external_lex_state = 2},
  [1506] = {.lex_state = 70, .external_lex_state = 2},
  [1507] = {.lex_state = 70, .external_lex_state = 2},
  [1508] = {.lex_state = 8, .external_lex_state = 2},
  [1509] = {.lex_state = 70, .external_lex_state = 2},
  [1510] = {.lex_state = 70, .external_lex_state = 2},
  [1511] = {.lex_state = 70, .external_lex_state = 3},
  [1512] = {.lex_state = 70, .external_lex_state = 3},
  [1513] = {.lex_state = 70, .external_lex_state = 2},
  [1514] = {.lex_state = 70, .external_lex_state = 2},
  [1515] = {.lex_state = 70, .external_lex_state = 3},
  [1516] = {.lex_state = 70, .external_lex_state = 3},
  [1517] = {.lex_state = 70, .external_lex_state = 3},
  [1518] = {.lex_state = 70, .external_lex_state = 3},
  [1519] = {.lex_state = 70, .external_lex_state = 3},
  [1520] = {.lex_state = 70, .external_lex_state = 3},
  [1521] = {.lex_state = 70, .external_lex_state = 3},
  [1522] = {.lex_state = 70, .external_lex_state = 3},
  [1523] = {.lex_state = 70, .external_lex_state = 3},
  [1524] = {.lex_state = 70, .external_lex_state = 3},
  [1525] = {.lex_state = 70, .external_lex_state = 3},
  [1526] = {.lex_state = 70, .external_lex_state = 3},
  [1527] = {.lex_state = 70, .external_lex_state = 3},
  [1528] = {.lex_state = 70, .external_lex_state = 3},
  [1529] = {.lex_state = 70, .external_lex_state = 3},
  [1530] = {.lex_state = 70, .external_lex_state = 3},
  [1531] = {.lex_state = 70, .external_lex_state = 2},
  [1532] = {.lex_state = 70, .external_lex_state = 2},
  [1533] = {.lex_state = 8, .external_lex_state = 2},
  [1534] = {.lex_state = 70, .external_lex_state = 2},
  [1535] = {.lex_state = 8, .external_lex_state = 2},
  [1536] = {.lex_state = 70, .external_lex_state = 2},
  [1537] = {.lex_state = 70, .external_lex_state = 2},
  [1538] = {.lex_state = 9, .external_lex_state = 3},
  [1539] = {.lex_state = 70, .external_lex_state = 2},
  [1540] = {.lex_state = 70, .external_lex_state = 3},
  [1541] = {.lex_state = 70, .external_lex_state = 2},
  [1542] = {.lex_state = 70, .external_lex_state = 3},
  [1543] = {.lex_state = 70, .external_lex_state = 2},
  [1544] = {.lex_state = 70, .external_lex_state = 3},
  [1545] = {.lex_state = 70, .external_lex_state = 3},
  [1546] = {.lex_state = 70, .external_lex_state = 3},
  [1547] = {.lex_state = 70, .external_lex_state = 3},
  [1548] = {.lex_state = 70, .external_lex_state = 3},
  [1549] = {.lex_state = 70, .external_lex_state = 3},
  [1550] = {.lex_state = 70, .external_lex_state = 3},
  [1551] = {.lex_state = 70, .external_lex_state = 2},
  [1552] = {.lex_state = 70, .external_lex_state = 2},
  [1553] = {.lex_state = 70, .external_lex_state = 3},
  [1554] = {.lex_state = 70, .external_lex_state = 3},
  [1555] = {.lex_state = 70, .external_lex_state = 3},
  [1556] = {.lex_state = 70, .external_lex_state = 3},
  [1557] = {.lex_state = 70, .external_lex_state = 2},
  [1558] = {.lex_state = 70, .external_lex_state = 2},
  [1559] = {.lex_state = 70, .external_lex_state = 3},
  [1560] = {.lex_state = 71},
  [1561] = {.lex_state = 15},
  [1562] = {.lex_state = 70, .external_lex_state = 3},
  [1563] = {.lex_state = 8, .external_lex_state = 2},
  [1564] = {.lex_state = 70, .external_lex_state = 2},
  [1565] = {.lex_state = 8, .external_lex_state = 2},
  [1566] = {.lex_state = 8, .external_lex_state = 2},
  [1567] = {.lex_state = 70, .external_lex_state = 2},
  [1568] = {.lex_state = 8, .external_lex_state = 2},
  [1569] = {.lex_state = 70, .external_lex_state = 3},
  [1570] = {.lex_state = 8, .external_lex_state = 2},
  [1571] = {.lex_state = 70, .external_lex_state = 2},
  [1572] = {.lex_state = 70, .external_lex_state = 3},
  [1573] = {.lex_state = 8, .external_lex_state = 2},
  [1574] = {.lex_state = 70, .external_lex_state = 3},
  [1575] = {.lex_state = 8, .external_lex_state = 2},
  [1576] = {.lex_state = 70, .external_lex_state = 3},
  [1577] = {.lex_state = 70, .external_lex_state = 3},
  [1578] = {.lex_state = 8, .external_lex_state = 2},
  [1579] = {.lex_state = 8, .external_lex_state = 2},
  [1580] = {.lex_state = 70, .external_lex_state = 3},
  [1581] = {.lex_state = 70, .external_lex_state = 3},
  [1582] = {.lex_state = 8, .external_lex_state = 2},
  [1583] = {.lex_state = 70, .external_lex_state = 3},
  [1584] = {.lex_state = 8, .external_lex_state = 2},
  [1585] = {.lex_state = 8, .external_lex_state = 2},
  [1586] = {.lex_state = 8, .external_lex_state = 2},
  [1587] = {.lex_state = 70, .external_lex_state = 3},
  [1588] = {.lex_state = 70, .external_lex_state = 3},
  [1589] = {.lex_state = 15},
  [1590] = {.lex_state = 8, .external_lex_state = 2},
  [1591] = {.lex_state = 15},
  [1592] = {.lex_state = 8, .external_lex_state = 2},
  [1593] = {.lex_state = 70, .external_lex_state = 3},
  [1594] = {.lex_state = 70, .external_lex_state = 3},
  [1595] = {.lex_state = 8, .external_lex_state = 2},
  [1596] = {.lex_state = 8, .external_lex_state = 2},
  [1597] = {.lex_state = 8, .external_lex_state = 2},
  [1598] = {.lex_state = 70, .external_lex_state = 2},
  [1599] = {.lex_state = 70, .external_lex_state = 3},
  [1600] = {.lex_state = 8, .external_lex_state = 2},
  [1601] = {.lex_state = 8, .external_lex_state = 2},
  [1602] = {.lex_state = 70, .external_lex_state = 3},
  [1603] = {.lex_state = 70, .external_lex_state = 3},
  [1604] = {.lex_state = 15},
  [1605] = {.lex_state = 15},
  [1606] = {.lex_state = 70, .external_lex_state = 3},
  [1607] = {.lex_state = 8, .external_lex_state = 2},
  [1608] = {.lex_state = 8, .external_lex_state = 2},
  [1609] = {.lex_state = 8, .external_lex_state = 2},
  [1610] = {.lex_state = 8, .external_lex_state = 2},
  [1611] = {.lex_state = 71},
  [1612] = {.lex_state = 8, .external_lex_state = 2},
  [1613] = {.lex_state = 70, .external_lex_state = 3},
  [1614] = {.lex_state = 15},
  [1615] = {.lex_state = 8, .external_lex_state = 2},
  [1616] = {.lex_state = 70, .external_lex_state = 3},
  [1617] = {.lex_state = 15},
  [1618] = {.lex_state = 71},
  [1619] = {.lex_state = 70, .external_lex_state = 2},
  [1620] = {.lex_state = 8, .external_lex_state = 3},
  [1621] = {.lex_state = 8, .external_lex_state = 2},
  [1622] = {.lex_state = 70, .external_lex_state = 3},
  [1623] = {.lex_state = 70, .external_lex_state = 3},
  [1624] = {.lex_state = 70, .external_lex_state = 3},
  [1625] = {.lex_state = 15},
  [1626] = {.lex_state = 70, .external_lex_state = 2},
  [1627] = {.lex_state = 15},
  [1628] = {.lex_state = 70, .external_lex_state = 3},
  [1629] = {.lex_state = 8, .external_lex_state = 2},
  [1630] = {.lex_state = 15},
  [1631] = {.lex_state = 8, .external_lex_state = 2},
  [1632] = {.lex_state = 71},
  [1633] = {.lex_state = 8, .external_lex_state = 2},
  [1634] = {.lex_state = 70, .external_lex_state = 3},
  [1635] = {.lex_state = 70, .external_lex_state = 2},
  [1636] = {.lex_state = 70, .external_lex_state = 3},
  [1637] = {.lex_state = 8, .external_lex_state = 2},
  [1638] = {.lex_state = 70, .external_lex_state = 3},
  [1639] = {.lex_state = 70, .external_lex_state = 3},
  [1640] = {.lex_state = 8, .external_lex_state = 2},
  [1641] = {.lex_state = 70, .external_lex_state = 3},
  [1642] = {.lex_state = 70, .external_lex_state = 3},
  [1643] = {.lex_state = 8, .external_lex_state = 2},
  [1644] = {.lex_state = 8, .external_lex_state = 2},
  [1645] = {.lex_state = 8, .external_lex_state = 2},
  [1646] = {.lex_state = 70, .external_lex_state = 3},
  [1647] = {.lex_state = 70, .external_lex_state = 3},
  [1648] = {.lex_state = 8, .external_lex_state = 2},
  [1649] = {.lex_state = 8, .external_lex_state = 2},
  [1650] = {.lex_state = 70, .external_lex_state = 2},
  [1651] = {.lex_state = 70, .external_lex_state = 2},
  [1652] = {.lex_state = 70, .external_lex_state = 3},
  [1653] = {.lex_state = 70, .external_lex_state = 3},
  [1654] = {.lex_state = 8, .external_lex_state = 2},
  [1655] = {.lex_state = 70, .external_lex_state = 3},
  [1656] = {.lex_state = 8, .external_lex_state = 2},
  [1657] = {.lex_state = 8, .external_lex_state = 2},
  [1658] = {.lex_state = 8, .external_lex_state = 3},
  [1659] = {.lex_state = 8, .external_lex_state = 2},
  [1660] = {.lex_state = 70, .external_lex_state = 3},
  [1661] = {.lex_state = 70, .external_lex_state = 3},
  [1662] = {.lex_state = 8, .external_lex_state = 2},
  [1663] = {.lex_state = 70, .external_lex_state = 2},
  [1664] = {.lex_state = 70, .external_lex_state = 3},
  [1665] = {.lex_state = 70, .external_lex_state = 3},
  [1666] = {.lex_state = 8, .external_lex_state = 2},
  [1667] = {.lex_state = 70, .external_lex_state = 2},
  [1668] = {.lex_state = 70, .external_lex_state = 3},
  [1669] = {.lex_state = 70, .external_lex_state = 3},
  [1670] = {.lex_state = 8, .external_lex_state = 2},
  [1671] = {.lex_state = 15},
  [1672] = {.lex_state = 8, .external_lex_state = 2},
  [1673] = {.lex_state = 70, .external_lex_state = 2},
  [1674] = {.lex_state = 8, .external_lex_state = 2},
  [1675] = {.lex_state = 8, .external_lex_state = 2},
  [1676] = {.lex_state = 15},
  [1677] = {.lex_state = 70, .external_lex_state = 3},
  [1678] = {.lex_state = 70, .external_lex_state = 2},
  [1679] = {.lex_state = 70, .external_lex_state = 2},
  [1680] = {.lex_state = 8, .external_lex_state = 2},
  [1681] = {.lex_state = 8, .external_lex_state = 2},
  [1682] = {.lex_state = 70, .external_lex_state = 3},
  [1683] = {.lex_state = 70, .external_lex_state = 3},
  [1684] = {.lex_state = 70, .external_lex_state = 2},
  [1685] = {.lex_state = 15},
  [1686] = {.lex_state = 70, .external_lex_state = 3},
  [1687] = {.lex_state = 70, .external_lex_state = 3},
  [1688] = {.lex_state = 8, .external_lex_state = 2},
  [1689] = {.lex_state = 8, .external_lex_state = 2},
  [1690] = {.lex_state = 71},
  [1691] = {.lex_state = 70, .external_lex_state = 2},
  [1692] = {.lex_state = 70, .external_lex_state = 3},
  [1693] = {.lex_state = 70, .external_lex_state = 2},
  [1694] = {.lex_state = 70, .external_lex_state = 3},
  [1695] = {.lex_state = 70, .external_lex_state = 2},
  [1696] = {.lex_state = 70, .external_lex_state = 3},
  [1697] = {.lex_state = 70, .external_lex_state = 3},
  [1698] = {.lex_state = 70, .external_lex_state = 3},
  [1699] = {.lex_state = 70, .external_lex_state = 3},
  [1700] = {.lex_state = 70, .external_lex_state = 3},
  [1701] = {.lex_state = 8, .external_lex_state = 2},
  [1702] = {.lex_state = 70, .external_lex_state = 3},
  [1703] = {.lex_state = 70, .external_lex_state = 3},
  [1704] = {.lex_state = 70, .external_lex_state = 3},
  [1705] = {.lex_state = 70, .external_lex_state = 3},
  [1706] = {.lex_state = 70, .external_lex_state = 3},
  [1707] = {.lex_state = 8, .external_lex_state = 2},
  [1708] = {.lex_state = 70, .external_lex_state = 3},
  [1709] = {.lex_state = 70, .external_lex_state = 3},
  [1710] = {.lex_state = 8, .external_lex_state = 2},
  [1711] = {.lex_state = 8, .external_lex_state = 2},
  [1712] = {.lex_state = 70, .external_lex_state = 3},
  [1713] = {.lex_state = 8, .external_lex_state = 2},
  [1714] = {.lex_state = 70, .external_lex_state = 3},
  [1715] = {.lex_state = 70, .external_lex_state = 2},
  [1716] = {.lex_state = 9, .external_lex_state = 2},
  [1717] = {.lex_state = 8, .external_lex_state = 2},
  [1718] = {.lex_state = 70, .external_lex_state = 3},
  [1719] = {.lex_state = 8, .external_lex_state = 2},
  [1720] = {.lex_state = 8, .external_lex_state = 2},
  [1721] = {.lex_state = 70, .external_lex_state = 3},
  [1722] = {.lex_state = 11, .external_lex_state = 2},
  [1723] = {.lex_state = 70, .external_lex_state = 3},
  [1724] = {.lex_state = 8, .external_lex_state = 2},
  [1725] = {.lex_state = 70, .external_lex_state = 2},
  [1726] = {.lex_state = 71, .external_lex_state = 4},
  [1727] = {.lex_state = 8, .external_lex_state = 2},
  [1728] = {.lex_state = 8, .external_lex_state = 2},
  [1729] = {.lex_state = 70, .external_lex_state = 2},
  [1730] = {.lex_state = 8, .external_lex_state = 2},
  [1731] = {.lex_state = 8, .external_lex_state = 2},
  [1732] = {.lex_state = 8, .external_lex_state = 2},
  [1733] = {.lex_state = 8, .external_lex_state = 2},
  [1734] = {.lex_state = 8, .external_lex_state = 2},
  [1735] = {.lex_state = 8, .external_lex_state = 2},
  [1736] = {.lex_state = 8, .external_lex_state = 2},
  [1737] = {.lex_state = 70, .external_lex_state = 3},
  [1738] = {.lex_state = 8, .external_lex_state = 2},
  [1739] = {.lex_state = 8, .external_lex_state = 2},
  [1740] = {.lex_state = 8, .external_lex_state = 2},
  [1741] = {.lex_state = 71, .external_lex_state = 4},
  [1742] = {.lex_state = 8, .external_lex_state = 2},
  [1743] = {.lex_state = 71, .external_lex_state = 4},
  [1744] = {.lex_state = 71, .external_lex_state = 4},
  [1745] = {.lex_state = 8, .external_lex_state = 2},
  [1746] = {.lex_state = 8, .external_lex_state = 2},
  [1747] = {.lex_state = 8, .external_lex_state = 2},
  [1748] = {.lex_state = 8, .external_lex_state = 2},
  [1749] = {.lex_state = 8, .external_lex_state = 2},
  [1750] = {.lex_state = 8, .external_lex_state = 2},
  [1751] = {.lex_state = 8, .external_lex_state = 2},
  [1752] = {.lex_state = 8, .external_lex_state = 2},
  [1753] = {.lex_state = 8, .external_lex_state = 2},
  [1754] = {.lex_state = 8, .external_lex_state = 2},
  [1755] = {.lex_state = 8, .external_lex_state = 2},
  [1756] = {.lex_state = 70, .external_lex_state = 2},
  [1757] = {.lex_state = 8, .external_lex_state = 2},
  [1758] = {.lex_state = 71, .external_lex_state = 4},
  [1759] = {.lex_state = 8, .external_lex_state = 2},
  [1760] = {.lex_state = 71, .external_lex_state = 4},
  [1761] = {.lex_state = 71, .external_lex_state = 4},
  [1762] = {.lex_state = 8, .external_lex_state = 2},
  [1763] = {.lex_state = 8, .external_lex_state = 2},
  [1764] = {.lex_state = 8, .external_lex_state = 2},
  [1765] = {.lex_state = 8, .external_lex_state = 2},
  [1766] = {.lex_state = 8, .external_lex_state = 2},
  [1767] = {.lex_state = 8, .external_lex_state = 2},
  [1768] = {.lex_state = 8, .external_lex_state = 2},
  [1769] = {.lex_state = 8, .external_lex_state = 2},
  [1770] = {.lex_state = 8, .external_lex_state = 2},
  [1771] = {.lex_state = 8, .external_lex_state = 2},
  [1772] = {.lex_state = 8, .external_lex_state = 2},
  [1773] = {.lex_state = 8, .external_lex_state = 2},
  [1774] = {.lex_state = 8, .external_lex_state = 2},
  [1775] = {.lex_state = 8, .external_lex_state = 2},
  [1776] = {.lex_state = 70, .external_lex_state = 3},
  [1777] = {.lex_state = 8, .external_lex_state = 2},
  [1778] = {.lex_state = 71, .external_lex_state = 4},
  [1779] = {.lex_state = 71, .external_lex_state = 4},
  [1780] = {.lex_state = 8, .external_lex_state = 2},
  [1781] = {.lex_state = 8, .external_lex_state = 2},
  [1782] = {.lex_state = 8, .external_lex_state = 2},
  [1783] = {.lex_state = 8, .external_lex_state = 2},
  [1784] = {.lex_state = 8, .external_lex_state = 2},
  [1785] = {.lex_state = 8, .external_lex_state = 2},
  [1786] = {.lex_state = 8, .external_lex_state = 2},
  [1787] = {.lex_state = 8, .external_lex_state = 2},
  [1788] = {.lex_state = 8, .external_lex_state = 2},
  [1789] = {.lex_state = 8, .external_lex_state = 2},
  [1790] = {.lex_state = 70, .external_lex_state = 2},
  [1791] = {.lex_state = 8, .external_lex_state = 2},
  [1792] = {.lex_state = 8, .external_lex_state = 2},
  [1793] = {.lex_state = 8, .external_lex_state = 2},
  [1794] = {.lex_state = 71},
  [1795] = {.lex_state = 71, .external_lex_state = 4},
  [1796] = {.lex_state = 8, .external_lex_state = 2},
  [1797] = {.lex_state = 8, .external_lex_state = 2},
  [1798] = {.lex_state = 8, .external_lex_state = 2},
  [1799] = {.lex_state = 8, .external_lex_state = 2},
  [1800] = {.lex_state = 71, .external_lex_state = 4},
  [1801] = {.lex_state = 8, .external_lex_state = 2},
  [1802] = {.lex_state = 71, .external_lex_state = 4},
  [1803] = {.lex_state = 8, .external_lex_state = 2},
  [1804] = {.lex_state = 8, .external_lex_state = 2},
  [1805] = {.lex_state = 8, .external_lex_state = 2},
  [1806] = {.lex_state = 8, .external_lex_state = 2},
  [1807] = {.lex_state = 8, .external_lex_state = 2},
  [1808] = {.lex_state = 8, .external_lex_state = 2},
  [1809] = {.lex_state = 8, .external_lex_state = 2},
  [1810] = {.lex_state = 8, .external_lex_state = 2},
  [1811] = {.lex_state = 71, .external_lex_state = 4},
  [1812] = {.lex_state = 71, .external_lex_state = 4},
  [1813] = {.lex_state = 71, .external_lex_state = 4},
  [1814] = {.lex_state = 71, .external_lex_state = 4},
  [1815] = {.lex_state = 70, .external_lex_state = 2},
  [1816] = {.lex_state = 70, .external_lex_state = 2},
  [1817] = {.lex_state = 70, .external_lex_state = 2},
  [1818] = {.lex_state = 71, .external_lex_state = 4},
  [1819] = {.lex_state = 70, .external_lex_state = 2},
  [1820] = {.lex_state = 71, .external_lex_state = 4},
  [1821] = {.lex_state = 71, .external_lex_state = 4},
  [1822] = {.lex_state = 71, .external_lex_state = 4},
  [1823] = {.lex_state = 71, .external_lex_state = 4},
  [1824] = {.lex_state = 71, .external_lex_state = 4},
  [1825] = {.lex_state = 71, .external_lex_state = 4},
  [1826] = {.lex_state = 71, .external_lex_state = 4},
  [1827] = {.lex_state = 71, .external_lex_state = 4},
  [1828] = {.lex_state = 71, .external_lex_state = 4},
  [1829] = {.lex_state = 71, .external_lex_state = 4},
  [1830] = {.lex_state = 71, .external_lex_state = 4},
  [1831] = {.lex_state = 71, .external_lex_state = 4},
  [1832] = {.lex_state = 71, .external_lex_state = 4},
  [1833] = {.lex_state = 71, .external_lex_state = 4},
  [1834] = {.lex_state = 71, .external_lex_state = 4},
  [1835] = {.lex_state = 71, .external_lex_state = 4},
  [1836] = {.lex_state = 71, .external_lex_state = 4},
  [1837] = {.lex_state = 71, .external_lex_state = 4},
  [1838] = {.lex_state = 71, .external_lex_state = 4},
  [1839] = {.lex_state = 71, .external_lex_state = 4},
  [1840] = {.lex_state = 71, .external_lex_state = 4},
  [1841] = {.lex_state = 71, .external_lex_state = 4},
  [1842] = {.lex_state = 71, .external_lex_state = 4},
  [1843] = {.lex_state = 71, .external_lex_state = 4},
  [1844] = {.lex_state = 71, .external_lex_state = 4},
  [1845] = {.lex_state = 71, .external_lex_state = 4},
  [1846] = {.lex_state = 71, .external_lex_state = 4},
  [1847] = {.lex_state = 71, .external_lex_state = 4},
  [1848] = {.lex_state = 71, .external_lex_state = 4},
  [1849] = {.lex_state = 71},
  [1850] = {.lex_state = 71},
  [1851] = {.lex_state = 71, .external_lex_state = 4},
  [1852] = {.lex_state = 71},
  [1853] = {.lex_state = 71},
  [1854] = {.lex_state = 71, .external_lex_state = 4},
  [1855] = {.lex_state = 71},
  [1856] = {.lex_state = 71},
  [1857] = {.lex_state = 71},
  [1858] = {.lex_state = 18},
  [1859] = {.lex_state = 71},
  [1860] = {.lex_state = 71, .external_lex_state = 4},
  [1861] = {.lex_state = 71},
  [1862] = {.lex_state = 71},
  [1863] = {.lex_state = 71, .external_lex_state = 4},
  [1864] = {.lex_state = 71, .external_lex_state = 4},
  [1865] = {.lex_state = 71},
  [1866] = {.lex_state = 71},
  [1867] = {.lex_state = 71, .external_lex_state = 4},
  [1868] = {.lex_state = 71, .external_lex_state = 4},
  [1869] = {.lex_state = 71},
  [1870] = {.lex_state = 71},
  [1871] = {.lex_state = 71},
  [1872] = {.lex_state = 71},
  [1873] = {.lex_state = 71},
  [1874] = {.lex_state = 71, .external_lex_state = 4},
  [1875] = {.lex_state = 71, .external_lex_state = 4},
  [1876] = {.lex_state = 71, .external_lex_state = 4},
  [1877] = {.lex_state = 71, .external_lex_state = 4},
  [1878] = {.lex_state = 71, .external_lex_state = 4},
  [1879] = {.lex_state = 71},
  [1880] = {.lex_state = 71},
  [1881] = {.lex_state = 71, .external_lex_state = 4},
  [1882] = {.lex_state = 71},
  [1883] = {.lex_state = 71},
  [1884] = {.lex_state = 71, .external_lex_state = 4},
  [1885] = {.lex_state = 71},
  [1886] = {.lex_state = 71},
  [1887] = {.lex_state = 71, .external_lex_state = 4},
  [1888] = {.lex_state = 71},
  [1889] = {.lex_state = 71},
  [1890] = {.lex_state = 71, .external_lex_state = 4},
  [1891] = {.lex_state = 71},
  [1892] = {.lex_state = 71, .external_lex_state = 4},
  [1893] = {.lex_state = 71},
  [1894] = {.lex_state = 71},
  [1895] = {.lex_state = 71, .external_lex_state = 4},
  [1896] = {.lex_state = 71, .external_lex_state = 4},
  [1897] = {.lex_state = 71},
  [1898] = {.lex_state = 71},
  [1899] = {.lex_state = 71},
  [1900] = {.lex_state = 71, .external_lex_state = 4},
  [1901] = {.lex_state = 71},
  [1902] = {.lex_state = 71},
  [1903] = {.lex_state = 71},
  [1904] = {.lex_state = 71},
  [1905] = {.lex_state = 71},
  [1906] = {.lex_state = 71},
  [1907] = {.lex_state = 71},
  [1908] = {.lex_state = 18},
  [1909] = {.lex_state = 71},
  [1910] = {.lex_state = 71},
  [1911] = {.lex_state = 71},
  [1912] = {.lex_state = 71},
  [1913] = {.lex_state = 71},
  [1914] = {.lex_state = 71},
  [1915] = {.lex_state = 71},
  [1916] = {.lex_state = 71},
  [1917] = {.lex_state = 71},
  [1918] = {.lex_state = 71},
  [1919] = {.lex_state = 71},
  [1920] = {.lex_state = 71},
  [1921] = {.lex_state = 71},
  [1922] = {.lex_state = 18},
  [1923] = {.lex_state = 71},
  [1924] = {.lex_state = 18},
  [1925] = {.lex_state = 71},
  [1926] = {.lex_state = 71},
  [1927] = {.lex_state = 71},
  [1928] = {.lex_state = 18},
  [1929] = {.lex_state = 18},
  [1930] = {.lex_state = 18},
  [1931] = {.lex_state = 71},
  [1932] = {.lex_state = 15, .external_lex_state = 4},
  [1933] = {.lex_state = 71},
  [1934] = {.lex_state = 15, .external_lex_state = 4},
  [1935] = {.lex_state = 15, .external_lex_state = 4},
  [1936] = {.lex_state = 15, .external_lex_state = 4},
  [1937] = {.lex_state = 15, .external_lex_state = 4},
  [1938] = {.lex_state = 15, .external_lex_state = 4},
  [1939] = {.lex_state = 71},
  [1940] = {.lex_state = 71},
  [1941] = {.lex_state = 15, .external_lex_state = 4},
  [1942] = {.lex_state = 71},
  [1943] = {.lex_state = 15, .external_lex_state = 4},
  [1944] = {.lex_state = 71},
  [1945] = {.lex_state = 15, .external_lex_state = 4},
  [1946] = {.lex_state = 15, .external_lex_state = 4},
  [1947] = {.lex_state = 71},
  [1948] = {.lex_state = 15, .external_lex_state = 4},
  [1949] = {.lex_state = 15, .external_lex_state = 4},
  [1950] = {.lex_state = 15, .external_lex_state = 4},
  [1951] = {.lex_state = 15, .external_lex_state = 4},
  [1952] = {.lex_state = 71},
  [1953] = {.lex_state = 15, .external_lex_state = 4},
  [1954] = {.lex_state = 15, .external_lex_state = 4},
  [1955] = {.lex_state = 15, .external_lex_state = 4},
  [1956] = {.lex_state = 71},
  [1957] = {.lex_state = 71},
  [1958] = {.lex_state = 71},
  [1959] = {.lex_state = 71},
  [1960] = {.lex_state = 71},
  [1961] = {.lex_state = 71},
  [1962] = {.lex_state = 71},
  [1963] = {.lex_state = 71},
  [1964] = {.lex_state = 71},
  [1965] = {.lex_state = 71},
  [1966] = {.lex_state = 71},
  [1967] = {.lex_state = 71},
  [1968] = {.lex_state = 71},
  [1969] = {.lex_state = 71},
  [1970] = {.lex_state = 71},
  [1971] = {.lex_state = 71},
  [1972] = {.lex_state = 71},
  [1973] = {.lex_state = 71},
  [1974] = {.lex_state = 71},
  [1975] = {.lex_state = 71},
  [1976] = {.lex_state = 71},
  [1977] = {.lex_state = 71},
  [1978] = {.lex_state = 15},
  [1979] = {.lex_state = 71},
  [1980] = {.lex_state = 71},
  [1981] = {.lex_state = 71},
  [1982] = {.lex_state = 71},
  [1983] = {.lex_state = 71},
  [1984] = {.lex_state = 71},
  [1985] = {.lex_state = 71},
  [1986] = {.lex_state = 71},
  [1987] = {.lex_state = 71},
  [1988] = {.lex_state = 71},
  [1989] = {.lex_state = 71},
  [1990] = {.lex_state = 71},
  [1991] = {.lex_state = 71},
  [1992] = {.lex_state = 71},
  [1993] = {.lex_state = 71},
  [1994] = {.lex_state = 71},
  [1995] = {.lex_state = 71},
  [1996] = {.lex_state = 71},
  [1997] = {.lex_state = 71},
  [1998] = {.lex_state = 71},
  [1999] = {.lex_state = 71},
  [2000] = {.lex_state = 71},
  [2001] = {.lex_state = 71},
  [2002] = {.lex_state = 71},
  [2003] = {.lex_state = 71},
  [2004] = {.lex_state = 71},
  [2005] = {.lex_state = 71},
  [2006] = {.lex_state = 71},
  [2007] = {.lex_state = 71},
  [2008] = {.lex_state = 71},
  [2009] = {.lex_state = 71},
  [2010] = {.lex_state = 71},
  [2011] = {.lex_state = 71},
  [2012] = {.lex_state = 71},
  [2013] = {.lex_state = 71},
  [2014] = {.lex_state = 71},
  [2015] = {.lex_state = 71},
  [2016] = {.lex_state = 71},
  [2017] = {.lex_state = 71},
  [2018] = {.lex_state = 22},
  [2019] = {.lex_state = 22},
  [2020] = {.lex_state = 22},
  [2021] = {.lex_state = 71},
  [2022] = {.lex_state = 71},
  [2023] = {.lex_state = 71},
  [2024] = {.lex_state = 71},
  [2025] = {.lex_state = 71},
  [2026] = {.lex_state = 71, .external_lex_state = 4},
  [2027] = {.lex_state = 71},
  [2028] = {.lex_state = 71, .external_lex_state = 4},
  [2029] = {.lex_state = 71},
  [2030] = {.lex_state = 71},
  [2031] = {.lex_state = 6},
  [2032] = {.lex_state = 6},
  [2033] = {.lex_state = 6},
  [2034] = {.lex_state = 6},
  [2035] = {.lex_state = 6},
  [2036] = {.lex_state = 6},
  [2037] = {.lex_state = 71},
  [2038] = {.lex_state = 71, .external_lex_state = 4},
  [2039] = {.lex_state = 71, .external_lex_state = 4},
  [2040] = {.lex_state = 71, .external_lex_state = 4},
  [2041] = {.lex_state = 22},
  [2042] = {.lex_state = 71, .external_lex_state = 4},
  [2043] = {.lex_state = 71, .external_lex_state = 4},
  [2044] = {.lex_state = 71, .external_lex_state = 4},
  [2045] = {.lex_state = 71, .external_lex_state = 4},
  [2046] = {.lex_state = 71, .external_lex_state = 4},
  [2047] = {.lex_state = 71, .external_lex_state = 4},
  [2048] = {.lex_state = 71, .external_lex_state = 4},
  [2049] = {.lex_state = 22},
  [2050] = {.lex_state = 71, .external_lex_state = 4},
  [2051] = {.lex_state = 71, .external_lex_state = 4},
  [2052] = {.lex_state = 71, .external_lex_state = 4},
  [2053] = {.lex_state = 71, .external_lex_state = 4},
  [2054] = {.lex_state = 22},
  [2055] = {.lex_state = 71, .external_lex_state = 4},
  [2056] = {.lex_state = 71, .external_lex_state = 4},
  [2057] = {.lex_state = 71, .external_lex_state = 4},
  [2058] = {.lex_state = 71, .external_lex_state = 4},
  [2059] = {.lex_state = 71, .external_lex_state = 4},
  [2060] = {.lex_state = 71, .external_lex_state = 4},
  [2061] = {.lex_state = 71, .external_lex_state = 4},
  [2062] = {.lex_state = 71, .external_lex_state = 4},
  [2063] = {.lex_state = 71},
  [2064] = {.lex_state = 71, .external_lex_state = 4},
  [2065] = {.lex_state = 22},
  [2066] = {.lex_state = 71},
  [2067] = {.lex_state = 71, .external_lex_state = 4},
  [2068] = {.lex_state = 71, .external_lex_state = 4},
  [2069] = {.lex_state = 71, .external_lex_state = 4},
  [2070] = {.lex_state = 22},
  [2071] = {.lex_state = 71, .external_lex_state = 4},
  [2072] = {.lex_state = 71, .external_lex_state = 4},
  [2073] = {.lex_state = 22},
  [2074] = {.lex_state = 71, .external_lex_state = 4},
  [2075] = {.lex_state = 71, .external_lex_state = 4},
  [2076] = {.lex_state = 71, .external_lex_state = 4},
  [2077] = {.lex_state = 71, .external_lex_state = 5},
  [2078] = {.lex_state = 71, .external_lex_state = 4},
  [2079] = {.lex_state = 71, .external_lex_state = 4},
  [2080] = {.lex_state = 71, .external_lex_state = 4},
  [2081] = {.lex_state = 71, .external_lex_state = 4},
  [2082] = {.lex_state = 71, .external_lex_state = 4},
  [2083] = {.lex_state = 71},
  [2084] = {.lex_state = 22},
  [2085] = {.lex_state = 22},
  [2086] = {.lex_state = 71, .external_lex_state = 4},
  [2087] = {.lex_state = 71, .external_lex_state = 4},
  [2088] = {.lex_state = 71, .external_lex_state = 4},
  [2089] = {.lex_state = 71, .external_lex_state = 4},
  [2090] = {.lex_state = 71, .external_lex_state = 4},
  [2091] = {.lex_state = 71, .external_lex_state = 4},
  [2092] = {.lex_state = 71, .external_lex_state = 4},
  [2093] = {.lex_state = 71, .external_lex_state = 4},
  [2094] = {.lex_state = 71, .external_lex_state = 4},
  [2095] = {.lex_state = 71, .external_lex_state = 4},
  [2096] = {.lex_state = 71, .external_lex_state = 4},
  [2097] = {.lex_state = 71, .external_lex_state = 4},
  [2098] = {.lex_state = 71, .external_lex_state = 4},
  [2099] = {.lex_state = 71, .external_lex_state = 4},
  [2100] = {.lex_state = 71, .external_lex_state = 4},
  [2101] = {.lex_state = 71, .external_lex_state = 4},
  [2102] = {.lex_state = 71, .external_lex_state = 4},
  [2103] = {.lex_state = 71, .external_lex_state = 4},
  [2104] = {.lex_state = 71, .external_lex_state = 4},
  [2105] = {.lex_state = 71, .external_lex_state = 4},
  [2106] = {.lex_state = 71, .external_lex_state = 4},
  [2107] = {.lex_state = 71, .external_lex_state = 4},
  [2108] = {.lex_state = 71, .external_lex_state = 4},
  [2109] = {.lex_state = 71, .external_lex_state = 4},
  [2110] = {.lex_state = 71, .external_lex_state = 4},
  [2111] = {.lex_state = 71, .external_lex_state = 4},
  [2112] = {.lex_state = 71, .external_lex_state = 5},
  [2113] = {.lex_state = 71, .external_lex_state = 4},
  [2114] = {.lex_state = 71, .external_lex_state = 5},
  [2115] = {.lex_state = 71, .external_lex_state = 4},
  [2116] = {.lex_state = 71, .external_lex_state = 4},
  [2117] = {.lex_state = 71, .external_lex_state = 4},
  [2118] = {.lex_state = 71, .external_lex_state = 4},
  [2119] = {.lex_state = 71, .external_lex_state = 4},
  [2120] = {.lex_state = 71, .external_lex_state = 4},
  [2121] = {.lex_state = 71, .external_lex_state = 4},
  [2122] = {.lex_state = 71, .external_lex_state = 4},
  [2123] = {.lex_state = 71, .external_lex_state = 4},
  [2124] = {.lex_state = 71, .external_lex_state = 4},
  [2125] = {.lex_state = 71, .external_lex_state = 5},
  [2126] = {.lex_state = 71, .external_lex_state = 4},
  [2127] = {.lex_state = 71, .external_lex_state = 4},
  [2128] = {.lex_state = 71, .external_lex_state = 4},
  [2129] = {.lex_state = 71, .external_lex_state = 4},
  [2130] = {.lex_state = 71, .external_lex_state = 4},
  [2131] = {.lex_state = 71, .external_lex_state = 4},
  [2132] = {.lex_state = 71, .external_lex_state = 4},
  [2133] = {.lex_state = 71, .external_lex_state = 4},
  [2134] = {.lex_state = 71, .external_lex_state = 4},
  [2135] = {.lex_state = 71},
  [2136] = {.lex_state = 22},
  [2137] = {.lex_state = 30},
  [2138] = {.lex_state = 71},
  [2139] = {.lex_state = 71, .external_lex_state = 4},
  [2140] = {.lex_state = 71},
  [2141] = {.lex_state = 71, .external_lex_state = 4},
  [2142] = {.lex_state = 22},
  [2143] = {.lex_state = 71, .external_lex_state = 5},
  [2144] = {.lex_state = 30},
  [2145] = {.lex_state = 71},
  [2146] = {.lex_state = 30},
  [2147] = {.lex_state = 71},
  [2148] = {.lex_state = 71},
  [2149] = {.lex_state = 71, .external_lex_state = 5},
  [2150] = {.lex_state = 30},
  [2151] = {.lex_state = 71},
  [2152] = {.lex_state = 71},
  [2153] = {.lex_state = 30},
  [2154] = {.lex_state = 71},
  [2155] = {.lex_state = 71, .external_lex_state = 5},
  [2156] = {.lex_state = 30},
  [2157] = {.lex_state = 30},
  [2158] = {.lex_state = 71, .external_lex_state = 5},
  [2159] = {.lex_state = 71, .external_lex_state = 4},
  [2160] = {.lex_state = 71},
  [2161] = {.lex_state = 71},
  [2162] = {.lex_state = 30},
  [2163] = {.lex_state = 30},
  [2164] = {.lex_state = 71},
  [2165] = {.lex_state = 71},
  [2166] = {.lex_state = 22},
  [2167] = {.lex_state = 71, .external_lex_state = 4},
  [2168] = {.lex_state = 22},
  [2169] = {.lex_state = 71},
  [2170] = {.lex_state = 30},
  [2171] = {.lex_state = 22},
  [2172] = {.lex_state = 71},
  [2173] = {.lex_state = 71},
  [2174] = {.lex_state = 71},
  [2175] = {.lex_state = 22},
  [2176] = {.lex_state = 30},
  [2177] = {.lex_state = 71, .external_lex_state = 4},
  [2178] = {.lex_state = 22},
  [2179] = {.lex_state = 22},
  [2180] = {.lex_state = 71},
  [2181] = {.lex_state = 30},
  [2182] = {.lex_state = 71},
  [2183] = {.lex_state = 30},
  [2184] = {.lex_state = 30},
  [2185] = {.lex_state = 71},
  [2186] = {.lex_state = 30},
  [2187] = {.lex_state = 30},
  [2188] = {.lex_state = 71, .external_lex_state = 4},
  [2189] = {.lex_state = 71},
  [2190] = {.lex_state = 30},
  [2191] = {.lex_state = 71},
  [2192] = {.lex_state = 22},
  [2193] = {.lex_state = 22},
  [2194] = {.lex_state = 22},
  [2195] = {.lex_state = 71},
  [2196] = {.lex_state = 71},
  [2197] = {.lex_state = 22},
  [2198] = {.lex_state = 71},
  [2199] = {.lex_state = 71},
  [2200] = {.lex_state = 71, .external_lex_state = 5},
  [2201] = {.lex_state = 22},
  [2202] = {.lex_state = 22},
  [2203] = {.lex_state = 22},
  [2204] = {.lex_state = 22},
  [2205] = {.lex_state = 71},
  [2206] = {.lex_state = 71},
  [2207] = {.lex_state = 71, .external_lex_state = 4},
  [2208] = {.lex_state = 71},
  [2209] = {.lex_state = 22},
  [2210] = {.lex_state = 71},
  [2211] = {.lex_state = 71},
  [2212] = {.lex_state = 71},
  [2213] = {.lex_state = 71},
  [2214] = {.lex_state = 22},
  [2215] = {.lex_state = 71},
  [2216] = {.lex_state = 71},
  [2217] = {.lex_state = 71},
  [2218] = {.lex_state = 30},
  [2219] = {.lex_state = 22},
  [2220] = {.lex_state = 22},
  [2221] = {.lex_state = 22},
  [2222] = {.lex_state = 22},
  [2223] = {.lex_state = 71},
  [2224] = {.lex_state = 22},
  [2225] = {.lex_state = 30},
  [2226] = {.lex_state = 71},
  [2227] = {.lex_state = 22},
  [2228] = {.lex_state = 71},
  [2229] = {.lex_state = 71},
  [2230] = {.lex_state = 30},
  [2231] = {.lex_state = 22},
  [2232] = {.lex_state = 71, .external_lex_state = 5},
  [2233] = {.lex_state = 71, .external_lex_state = 4},
  [2234] = {.lex_state = 71},
  [2235] = {.lex_state = 22},
  [2236] = {.lex_state = 30},
  [2237] = {.lex_state = 71},
  [2238] = {.lex_state = 71},
  [2239] = {.lex_state = 71},
  [2240] = {.lex_state = 71},
  [2241] = {.lex_state = 71},
  [2242] = {.lex_state = 71, .external_lex_state = 5},
  [2243] = {.lex_state = 71, .external_lex_state = 5},
  [2244] = {.lex_state = 71, .external_lex_state = 5},
  [2245] = {.lex_state = 71, .external_lex_state = 4},
  [2246] = {.lex_state = 71, .external_lex_state = 5},
  [2247] = {.lex_state = 71, .external_lex_state = 5},
  [2248] = {.lex_state = 71, .external_lex_state = 5},
  [2249] = {.lex_state = 71, .external_lex_state = 5},
  [2250] = {.lex_state = 71},
  [2251] = {.lex_state = 71, .external_lex_state = 5},
  [2252] = {.lex_state = 71},
  [2253] = {.lex_state = 71, .external_lex_state = 5},
  [2254] = {.lex_state = 71, .external_lex_state = 5},
  [2255] = {.lex_state = 71, .external_lex_state = 4},
  [2256] = {.lex_state = 71, .external_lex_state = 5},
  [2257] = {.lex_state = 71, .external_lex_state = 5},
  [2258] = {.lex_state = 71, .external_lex_state = 5},
  [2259] = {.lex_state = 71, .external_lex_state = 5},
  [2260] = {.lex_state = 71, .external_lex_state = 5},
  [2261] = {.lex_state = 71, .external_lex_state = 5},
  [2262] = {.lex_state = 71, .external_lex_state = 5},
  [2263] = {.lex_state = 71, .external_lex_state = 5},
  [2264] = {.lex_state = 71, .external_lex_state = 5},
  [2265] = {.lex_state = 71, .external_lex_state = 5},
  [2266] = {.lex_state = 22},
  [2267] = {.lex_state = 71},
  [2268] = {.lex_state = 71, .external_lex_state = 5},
  [2269] = {.lex_state = 71},
  [2270] = {.lex_state = 71, .external_lex_state = 5},
  [2271] = {.lex_state = 71, .external_lex_state = 5},
  [2272] = {.lex_state = 71, .external_lex_state = 5},
  [2273] = {.lex_state = 71, .external_lex_state = 5},
  [2274] = {.lex_state = 71, .external_lex_state = 5},
  [2275] = {.lex_state = 71, .external_lex_state = 5},
  [2276] = {.lex_state = 71, .external_lex_state = 5},
  [2277] = {.lex_state = 71, .external_lex_state = 5},
  [2278] = {.lex_state = 71, .external_lex_state = 5},
  [2279] = {.lex_state = 71, .external_lex_state = 5},
  [2280] = {.lex_state = 71, .external_lex_state = 5},
  [2281] = {.lex_state = 71, .external_lex_state = 5},
  [2282] = {.lex_state = 71, .external_lex_state = 5},
  [2283] = {.lex_state = 71, .external_lex_state = 4},
  [2284] = {.lex_state = 71, .external_lex_state = 4},
  [2285] = {.lex_state = 71, .external_lex_state = 4},
  [2286] = {.lex_state = 71, .external_lex_state = 5},
  [2287] = {.lex_state = 71, .external_lex_state = 5},
  [2288] = {.lex_state = 71},
  [2289] = {.lex_state = 71},
  [2290] = {.lex_state = 71, .external_lex_state = 5},
  [2291] = {.lex_state = 71, .external_lex_state = 5},
  [2292] = {.lex_state = 71, .external_lex_state = 5},
  [2293] = {.lex_state = 71, .external_lex_state = 5},
  [2294] = {.lex_state = 71, .external_lex_state = 5},
  [2295] = {.lex_state = 71, .external_lex_state = 4},
  [2296] = {.lex_state = 71},
  [2297] = {.lex_state = 71},
  [2298] = {.lex_state = 71, .external_lex_state = 4},
  [2299] = {.lex_state = 71},
  [2300] = {.lex_state = 0, .external_lex_state = 4},
  [2301] = {.lex_state = 71},
  [2302] = {.lex_state = 71},
  [2303] = {.lex_state = 71},
  [2304] = {.lex_state = 71, .external_lex_state = 4},
  [2305] = {.lex_state = 71, .external_lex_state = 4},
  [2306] = {.lex_state = 71, .external_lex_state = 4},
  [2307] = {.lex_state = 71},
  [2308] = {.lex_state = 14},
  [2309] = {.lex_state = 71},
  [2310] = {.lex_state = 71, .external_lex_state = 4},
  [2311] = {.lex_state = 71},
  [2312] = {.lex_state = 71},
  [2313] = {.lex_state = 71},
  [2314] = {.lex_state = 71, .external_lex_state = 4},
  [2315] = {.lex_state = 71},
  [2316] = {.lex_state = 71, .external_lex_state = 4},
  [2317] = {.lex_state = 71, .external_lex_state = 4},
  [2318] = {.lex_state = 71, .external_lex_state = 4},
  [2319] = {.lex_state = 71},
  [2320] = {.lex_state = 71, .external_lex_state = 4},
  [2321] = {.lex_state = 71, .external_lex_state = 4},
  [2322] = {.lex_state = 71},
  [2323] = {.lex_state = 71},
  [2324] = {.lex_state = 71},
  [2325] = {.lex_state = 71, .external_lex_state = 4},
  [2326] = {.lex_state = 71, .external_lex_state = 4},
  [2327] = {.lex_state = 71},
  [2328] = {.lex_state = 71, .external_lex_state = 4},
  [2329] = {.lex_state = 71},
  [2330] = {.lex_state = 71},
  [2331] = {.lex_state = 71},
  [2332] = {.lex_state = 71, .external_lex_state = 4},
  [2333] = {.lex_state = 0, .external_lex_state = 4},
  [2334] = {.lex_state = 71},
  [2335] = {.lex_state = 14},
  [2336] = {.lex_state = 71},
  [2337] = {.lex_state = 71},
  [2338] = {.lex_state = 71},
  [2339] = {.lex_state = 71, .external_lex_state = 4},
  [2340] = {.lex_state = 71},
  [2341] = {.lex_state = 71},
  [2342] = {.lex_state = 71},
  [2343] = {.lex_state = 71},
  [2344] = {.lex_state = 0, .external_lex_state = 4},
  [2345] = {.lex_state = 0, .external_lex_state = 4},
  [2346] = {.lex_state = 71},
  [2347] = {.lex_state = 71},
  [2348] = {.lex_state = 71, .external_lex_state = 4},
  [2349] = {.lex_state = 71},
  [2350] = {.lex_state = 71},
  [2351] = {.lex_state = 71},
  [2352] = {.lex_state = 71},
  [2353] = {.lex_state = 71},
  [2354] = {.lex_state = 71, .external_lex_state = 4},
  [2355] = {.lex_state = 71},
  [2356] = {.lex_state = 71, .external_lex_state = 5},
  [2357] = {.lex_state = 0, .external_lex_state = 4},
  [2358] = {.lex_state = 71},
  [2359] = {.lex_state = 71},
  [2360] = {.lex_state = 71, .external_lex_state = 5},
  [2361] = {.lex_state = 22},
  [2362] = {.lex_state = 71},
  [2363] = {.lex_state = 71},
  [2364] = {.lex_state = 71},
  [2365] = {.lex_state = 71},
  [2366] = {.lex_state = 22},
  [2367] = {.lex_state = 22},
  [2368] = {.lex_state = 71},
  [2369] = {.lex_state = 71},
  [2370] = {.lex_state = 0, .external_lex_state = 4},
  [2371] = {.lex_state = 71},
  [2372] = {.lex_state = 0, .external_lex_state = 4},
  [2373] = {.lex_state = 71},
  [2374] = {.lex_state = 71, .external_lex_state = 4},
  [2375] = {.lex_state = 71, .external_lex_state = 5},
  [2376] = {.lex_state = 22},
  [2377] = {.lex_state = 0, .external_lex_state = 4},
  [2378] = {.lex_state = 71},
  [2379] = {.lex_state = 71},
  [2380] = {.lex_state = 71},
  [2381] = {.lex_state = 17},
  [2382] = {.lex_state = 71},
  [2383] = {.lex_state = 0, .external_lex_state = 4},
  [2384] = {.lex_state = 0},
  [2385] = {.lex_state = 71},
  [2386] = {.lex_state = 0, .external_lex_state = 4},
  [2387] = {.lex_state = 71},
  [2388] = {.lex_state = 71},
  [2389] = {.lex_state = 71},
  [2390] = {.lex_state = 71},
  [2391] = {.lex_state = 71},
  [2392] = {.lex_state = 17},
  [2393] = {.lex_state = 71},
  [2394] = {.lex_state = 71},
  [2395] = {.lex_state = 71},
  [2396] = {.lex_state = 22},
  [2397] = {.lex_state = 71},
  [2398] = {.lex_state = 0, .external_lex_state = 4},
  [2399] = {.lex_state = 0, .external_lex_state = 4},
  [2400] = {.lex_state = 0, .external_lex_state = 4},
  [2401] = {.lex_state = 71, .external_lex_state = 4},
  [2402] = {.lex_state = 71},
  [2403] = {.lex_state = 22},
  [2404] = {.lex_state = 0, .external_lex_state = 4},
  [2405] = {.lex_state = 71},
  [2406] = {.lex_state = 71},
  [2407] = {.lex_state = 71},
  [2408] = {.lex_state = 71},
  [2409] = {.lex_state = 0, .external_lex_state = 4},
  [2410] = {.lex_state = 71},
  [2411] = {.lex_state = 71},
  [2412] = {.lex_state = 17},
  [2413] = {.lex_state = 22},
  [2414] = {.lex_state = 0, .external_lex_state = 4},
  [2415] = {.lex_state = 71},
  [2416] = {.lex_state = 0, .external_lex_state = 4},
  [2417] = {.lex_state = 0, .external_lex_state = 4},
  [2418] = {.lex_state = 0, .external_lex_state = 4},
  [2419] = {.lex_state = 71},
  [2420] = {.lex_state = 71, .external_lex_state = 4},
  [2421] = {.lex_state = 0, .external_lex_state = 4},
  [2422] = {.lex_state = 71},
  [2423] = {.lex_state = 71},
  [2424] = {.lex_state = 71, .external_lex_state = 4},
  [2425] = {.lex_state = 71},
  [2426] = {.lex_state = 71},
  [2427] = {.lex_state = 71},
  [2428] = {.lex_state = 71},
  [2429] = {.lex_state = 22},
  [2430] = {.lex_state = 17},
  [2431] = {.lex_state = 71},
  [2432] = {.lex_state = 71},
  [2433] = {.lex_state = 20, .external_lex_state = 6},
  [2434] = {.lex_state = 71},
  [2435] = {.lex_state = 0, .external_lex_state = 4},
  [2436] = {.lex_state = 71},
  [2437] = {.lex_state = 71},
  [2438] = {.lex_state = 0, .external_lex_state = 4},
  [2439] = {.lex_state = 71},
  [2440] = {.lex_state = 0, .external_lex_state = 4},
  [2441] = {.lex_state = 71},
  [2442] = {.lex_state = 71},
  [2443] = {.lex_state = 0, .external_lex_state = 4},
  [2444] = {.lex_state = 71},
  [2445] = {.lex_state = 71},
  [2446] = {.lex_state = 71},
  [2447] = {.lex_state = 71},
  [2448] = {.lex_state = 14},
  [2449] = {.lex_state = 71},
  [2450] = {.lex_state = 71},
  [2451] = {.lex_state = 0, .external_lex_state = 4},
  [2452] = {.lex_state = 71},
  [2453] = {.lex_state = 0, .external_lex_state = 4},
  [2454] = {.lex_state = 0, .external_lex_state = 4},
  [2455] = {.lex_state = 22},
  [2456] = {.lex_state = 22},
  [2457] = {.lex_state = 20, .external_lex_state = 6},
  [2458] = {.lex_state = 0, .external_lex_state = 4},
  [2459] = {.lex_state = 71},
  [2460] = {.lex_state = 0, .external_lex_state = 4},
  [2461] = {.lex_state = 71},
  [2462] = {.lex_state = 71},
  [2463] = {.lex_state = 71},
  [2464] = {.lex_state = 71},
  [2465] = {.lex_state = 22},
  [2466] = {.lex_state = 71},
  [2467] = {.lex_state = 71},
  [2468] = {.lex_state = 71},
  [2469] = {.lex_state = 20, .external_lex_state = 6},
  [2470] = {.lex_state = 71},
  [2471] = {.lex_state = 71},
  [2472] = {.lex_state = 71},
  [2473] = {.lex_state = 20, .external_lex_state = 6},
  [2474] = {.lex_state = 71},
  [2475] = {.lex_state = 17},
  [2476] = {.lex_state = 71},
  [2477] = {.lex_state = 71},
  [2478] = {.lex_state = 71},
  [2479] = {.lex_state = 17},
  [2480] = {.lex_state = 71},
  [2481] = {.lex_state = 71},
  [2482] = {.lex_state = 17},
  [2483] = {.lex_state = 17},
  [2484] = {.lex_state = 17},
  [2485] = {.lex_state = 71},
  [2486] = {.lex_state = 17},
  [2487] = {.lex_state = 17},
  [2488] = {.lex_state = 71},
  [2489] = {.lex_state = 71},
  [2490] = {.lex_state = 20, .external_lex_state = 6},
  [2491] = {.lex_state = 17},
  [2492] = {.lex_state = 0, .external_lex_state = 4},
  [2493] = {.lex_state = 20, .external_lex_state = 6},
  [2494] = {.lex_state = 71},
  [2495] = {.lex_state = 71},
  [2496] = {.lex_state = 71},
  [2497] = {.lex_state = 71},
  [2498] = {.lex_state = 71},
  [2499] = {.lex_state = 71},
  [2500] = {.lex_state = 71},
  [2501] = {.lex_state = 0, .external_lex_state = 4},
  [2502] = {.lex_state = 0, .external_lex_state = 4},
  [2503] = {.lex_state = 17},
  [2504] = {.lex_state = 71},
  [2505] = {.lex_state = 22},
  [2506] = {.lex_state = 22},
  [2507] = {.lex_state = 71},
  [2508] = {.lex_state = 71},
  [2509] = {.lex_state = 71},
  [2510] = {.lex_state = 0, .external_lex_state = 4},
  [2511] = {.lex_state = 71},
  [2512] = {.lex_state = 22},
  [2513] = {.lex_state = 22},
  [2514] = {.lex_state = 71},
  [2515] = {.lex_state = 71},
  [2516] = {.lex_state = 71},
  [2517] = {.lex_state = 71},
  [2518] = {.lex_state = 71},
  [2519] = {.lex_state = 71},
  [2520] = {.lex_state = 17},
  [2521] = {.lex_state = 71},
  [2522] = {.lex_state = 17},
  [2523] = {.lex_state = 71},
  [2524] = {.lex_state = 17},
  [2525] = {.lex_state = 71},
  [2526] = {.lex_state = 17},
  [2527] = {.lex_state = 20, .external_lex_state = 6},
  [2528] = {.lex_state = 71},
  [2529] = {.lex_state = 17},
  [2530] = {.lex_state = 71},
  [2531] = {.lex_state = 71},
  [2532] = {.lex_state = 0, .external_lex_state = 4},
  [2533] = {.lex_state = 0, .external_lex_state = 4},
  [2534] = {.lex_state = 0, .external_lex_state = 4},
  [2535] = {.lex_state = 71},
  [2536] = {.lex_state = 0, .external_lex_state = 4},
  [2537] = {.lex_state = 71},
  [2538] = {.lex_state = 71},
  [2539] = {.lex_state = 71, .external_lex_state = 4},
  [2540] = {.lex_state = 71},
  [2541] = {.lex_state = 0, .external_lex_state = 4},
  [2542] = {.lex_state = 0, .external_lex_state = 4},
  [2543] = {.lex_state = 71, .external_lex_state = 4},
  [2544] = {.lex_state = 71, .external_lex_state = 5},
  [2545] = {.lex_state = 0, .external_lex_state = 4},
  [2546] = {.lex_state = 0, .external_lex_state = 4},
  [2547] = {.lex_state = 71},
  [2548] = {.lex_state = 71},
  [2549] = {.lex_state = 71},
  [2550] = {.lex_state = 71, .external_lex_state = 4},
  [2551] = {.lex_state = 22},
  [2552] = {.lex_state = 22},
  [2553] = {.lex_state = 0, .external_lex_state = 4},
  [2554] = {.lex_state = 71},
  [2555] = {.lex_state = 71},
  [2556] = {.lex_state = 71, .external_lex_state = 5},
  [2557] = {.lex_state = 0, .external_lex_state = 4},
  [2558] = {.lex_state = 0, .external_lex_state = 4},
  [2559] = {.lex_state = 22},
  [2560] = {.lex_state = 0, .external_lex_state = 4},
  [2561] = {.lex_state = 0, .external_lex_state = 4},
  [2562] = {.lex_state = 71, .external_lex_state = 4},
  [2563] = {.lex_state = 0, .external_lex_state = 4},
  [2564] = {.lex_state = 14},
  [2565] = {.lex_state = 71},
  [2566] = {.lex_state = 0, .external_lex_state = 4},
  [2567] = {.lex_state = 0, .external_lex_state = 4},
  [2568] = {.lex_state = 0, .external_lex_state = 4},
  [2569] = {.lex_state = 71},
  [2570] = {.lex_state = 0, .external_lex_state = 4},
  [2571] = {.lex_state = 0, .external_lex_state = 4},
  [2572] = {.lex_state = 0, .external_lex_state = 4},
  [2573] = {.lex_state = 0, .external_lex_state = 4},
  [2574] = {.lex_state = 0},
  [2575] = {.lex_state = 71},
  [2576] = {.lex_state = 71, .external_lex_state = 5},
  [2577] = {.lex_state = 0},
  [2578] = {.lex_state = 0, .external_lex_state = 4},
  [2579] = {.lex_state = 0, .external_lex_state = 4},
  [2580] = {.lex_state = 0, .external_lex_state = 4},
  [2581] = {.lex_state = 0, .external_lex_state = 4},
  [2582] = {.lex_state = 0, .external_lex_state = 4},
  [2583] = {.lex_state = 71, .external_lex_state = 5},
  [2584] = {.lex_state = 0, .external_lex_state = 4},
  [2585] = {.lex_state = 0, .external_lex_state = 4},
  [2586] = {.lex_state = 71},
  [2587] = {.lex_state = 0, .external_lex_state = 4},
  [2588] = {.lex_state = 0, .external_lex_state = 4},
  [2589] = {.lex_state = 0, .external_lex_state = 4},
  [2590] = {.lex_state = 0, .external_lex_state = 4},
  [2591] = {.lex_state = 0, .external_lex_state = 4},
  [2592] = {.lex_state = 71},
  [2593] = {.lex_state = 0, .external_lex_state = 4},
  [2594] = {.lex_state = 71},
  [2595] = {.lex_state = 0, .external_lex_state = 4},
  [2596] = {.lex_state = 71, .external_lex_state = 5},
  [2597] = {.lex_state = 0},
  [2598] = {.lex_state = 0, .external_lex_state = 4},
  [2599] = {.lex_state = 71},
  [2600] = {.lex_state = 0, .external_lex_state = 4},
  [2601] = {.lex_state = 71, .external_lex_state = 4},
  [2602] = {.lex_state = 22},
  [2603] = {.lex_state = 71, .external_lex_state = 5},
  [2604] = {.lex_state = 0, .external_lex_state = 4},
  [2605] = {.lex_state = 71},
  [2606] = {.lex_state = 0, .external_lex_state = 4},
  [2607] = {.lex_state = 71, .external_lex_state = 4},
  [2608] = {.lex_state = 22},
  [2609] = {.lex_state = 71, .external_lex_state = 5},
  [2610] = {.lex_state = 0, .external_lex_state = 4},
  [2611] = {.lex_state = 22},
  [2612] = {.lex_state = 71, .external_lex_state = 4},
  [2613] = {.lex_state = 22},
  [2614] = {.lex_state = 0, .external_lex_state = 4},
  [2615] = {.lex_state = 0, .external_lex_state = 4},
  [2616] = {.lex_state = 0},
  [2617] = {.lex_state = 0, .external_lex_state = 4},
  [2618] = {.lex_state = 71},
  [2619] = {.lex_state = 0, .external_lex_state = 4},
  [2620] = {.lex_state = 22},
  [2621] = {.lex_state = 71},
  [2622] = {.lex_state = 0, .external_lex_state = 4},
  [2623] = {.lex_state = 0, .external_lex_state = 4},
  [2624] = {.lex_state = 71},
  [2625] = {.lex_state = 71},
  [2626] = {.lex_state = 71, .external_lex_state = 4},
  [2627] = {.lex_state = 0, .external_lex_state = 4},
  [2628] = {.lex_state = 71},
  [2629] = {.lex_state = 71, .external_lex_state = 5},
  [2630] = {.lex_state = 0, .external_lex_state = 4},
  [2631] = {.lex_state = 0, .external_lex_state = 4},
  [2632] = {.lex_state = 0},
  [2633] = {.lex_state = 0, .external_lex_state = 4},
  [2634] = {.lex_state = 71},
  [2635] = {.lex_state = 71},
  [2636] = {.lex_state = 0, .external_lex_state = 4},
  [2637] = {.lex_state = 0, .external_lex_state = 4},
  [2638] = {.lex_state = 0},
  [2639] = {.lex_state = 0},
  [2640] = {.lex_state = 0, .external_lex_state = 4},
  [2641] = {.lex_state = 71},
  [2642] = {.lex_state = 0, .external_lex_state = 4},
  [2643] = {.lex_state = 0, .external_lex_state = 4},
  [2644] = {.lex_state = 0, .external_lex_state = 4},
  [2645] = {.lex_state = 71, .external_lex_state = 5},
  [2646] = {.lex_state = 71},
  [2647] = {.lex_state = 0},
  [2648] = {.lex_state = 71},
  [2649] = {.lex_state = 0, .external_lex_state = 4},
  [2650] = {.lex_state = 71, .external_lex_state = 4},
  [2651] = {.lex_state = 0},
  [2652] = {.lex_state = 0, .external_lex_state = 4},
  [2653] = {.lex_state = 71},
  [2654] = {.lex_state = 71},
  [2655] = {.lex_state = 71},
  [2656] = {.lex_state = 14},
  [2657] = {.lex_state = 0, .external_lex_state = 4},
  [2658] = {.lex_state = 71},
  [2659] = {.lex_state = 71, .external_lex_state = 4},
  [2660] = {.lex_state = 71},
  [2661] = {.lex_state = 71},
  [2662] = {.lex_state = 17},
  [2663] = {.lex_state = 71, .external_lex_state = 5},
  [2664] = {.lex_state = 0, .external_lex_state = 4},
  [2665] = {.lex_state = 71},
  [2666] = {.lex_state = 0, .external_lex_state = 4},
  [2667] = {.lex_state = 71, .external_lex_state = 4},
  [2668] = {.lex_state = 71},
  [2669] = {.lex_state = 22},
  [2670] = {.lex_state = 0, .external_lex_state = 4},
  [2671] = {.lex_state = 0, .external_lex_state = 4},
  [2672] = {.lex_state = 0, .external_lex_state = 4},
  [2673] = {.lex_state = 0, .external_lex_state = 4},
  [2674] = {.lex_state = 0},
  [2675] = {.lex_state = 71, .external_lex_state = 5},
  [2676] = {.lex_state = 71},
  [2677] = {.lex_state = 71},
  [2678] = {.lex_state = 14},
  [2679] = {.lex_state = 71, .external_lex_state = 4},
  [2680] = {.lex_state = 71},
  [2681] = {.lex_state = 0, .external_lex_state = 4},
  [2682] = {.lex_state = 0},
  [2683] = {.lex_state = 0, .external_lex_state = 4},
  [2684] = {.lex_state = 71, .external_lex_state = 4},
  [2685] = {.lex_state = 71},
  [2686] = {.lex_state = 71},
  [2687] = {.lex_state = 0, .external_lex_state = 4},
  [2688] = {.lex_state = 22},
  [2689] = {.lex_state = 71},
  [2690] = {.lex_state = 0},
  [2691] = {.lex_state = 71},
  [2692] = {.lex_state = 0, .external_lex_state = 4},
  [2693] = {.lex_state = 22},
  [2694] = {.lex_state = 71},
  [2695] = {.lex_state = 71},
  [2696] = {.lex_state = 0, .external_lex_state = 4},
  [2697] = {.lex_state = 0, .external_lex_state = 4},
  [2698] = {.lex_state = 0, .external_lex_state = 4},
  [2699] = {.lex_state = 71},
  [2700] = {.lex_state = 71},
  [2701] = {.lex_state = 0, .external_lex_state = 4},
  [2702] = {.lex_state = 71},
  [2703] = {.lex_state = 71},
  [2704] = {.lex_state = 71},
  [2705] = {.lex_state = 0, .external_lex_state = 4},
  [2706] = {.lex_state = 71},
  [2707] = {.lex_state = 0, .external_lex_state = 4},
  [2708] = {.lex_state = 0, .external_lex_state = 4},
  [2709] = {.lex_state = 0, .external_lex_state = 4},
  [2710] = {.lex_state = 71},
  [2711] = {.lex_state = 22},
  [2712] = {.lex_state = 0, .external_lex_state = 4},
  [2713] = {.lex_state = 71},
  [2714] = {.lex_state = 71, .external_lex_state = 5},
  [2715] = {.lex_state = 71},
  [2716] = {.lex_state = 0, .external_lex_state = 4},
  [2717] = {.lex_state = 71},
  [2718] = {.lex_state = 22},
  [2719] = {.lex_state = 71},
  [2720] = {.lex_state = 0, .external_lex_state = 4},
  [2721] = {.lex_state = 71, .external_lex_state = 4},
  [2722] = {.lex_state = 71, .external_lex_state = 5},
  [2723] = {.lex_state = 71, .external_lex_state = 5},
  [2724] = {.lex_state = 71},
  [2725] = {.lex_state = 71},
  [2726] = {.lex_state = 0, .external_lex_state = 4},
  [2727] = {.lex_state = 71},
  [2728] = {.lex_state = 71},
  [2729] = {.lex_state = 71, .external_lex_state = 4},
  [2730] = {.lex_state = 71},
  [2731] = {.lex_state = 71},
  [2732] = {.lex_state = 0, .external_lex_state = 4},
  [2733] = {.lex_state = 71},
  [2734] = {.lex_state = 0, .external_lex_state = 4},
  [2735] = {.lex_state = 0},
  [2736] = {.lex_state = 71},
  [2737] = {.lex_state = 71},
  [2738] = {.lex_state = 71},
  [2739] = {.lex_state = 71},
  [2740] = {.lex_state = 71},
  [2741] = {.lex_state = 0, .external_lex_state = 4},
  [2742] = {.lex_state = 0, .external_lex_state = 4},
  [2743] = {.lex_state = 0, .external_lex_state = 4},
  [2744] = {.lex_state = 0, .external_lex_state = 4},
  [2745] = {.lex_state = 71},
  [2746] = {.lex_state = 0, .external_lex_state = 4},
  [2747] = {.lex_state = 0, .external_lex_state = 4},
  [2748] = {.lex_state = 71},
  [2749] = {.lex_state = 71},
  [2750] = {.lex_state = 22},
  [2751] = {.lex_state = 0, .external_lex_state = 4},
  [2752] = {.lex_state = 71},
  [2753] = {.lex_state = 0, .external_lex_state = 4},
  [2754] = {.lex_state = 71, .external_lex_state = 4},
  [2755] = {.lex_state = 71},
  [2756] = {.lex_state = 71},
  [2757] = {.lex_state = 0, .external_lex_state = 4},
  [2758] = {.lex_state = 0, .external_lex_state = 4},
  [2759] = {.lex_state = 0, .external_lex_state = 4},
  [2760] = {.lex_state = 22},
  [2761] = {.lex_state = 71},
  [2762] = {.lex_state = 0, .external_lex_state = 4},
  [2763] = {.lex_state = 71},
  [2764] = {.lex_state = 0, .external_lex_state = 4},
  [2765] = {.lex_state = 71},
  [2766] = {.lex_state = 71, .external_lex_state = 5},
  [2767] = {.lex_state = 71},
  [2768] = {.lex_state = 71, .external_lex_state = 5},
  [2769] = {.lex_state = 71},
  [2770] = {.lex_state = 71},
  [2771] = {.lex_state = 0, .external_lex_state = 4},
  [2772] = {.lex_state = 0},
  [2773] = {.lex_state = 22},
  [2774] = {.lex_state = 71},
  [2775] = {.lex_state = 0, .external_lex_state = 4},
  [2776] = {.lex_state = 71},
  [2777] = {.lex_state = 71, .external_lex_state = 5},
  [2778] = {.lex_state = 0, .external_lex_state = 4},
  [2779] = {.lex_state = 71},
  [2780] = {.lex_state = 71},
  [2781] = {.lex_state = 0, .external_lex_state = 4},
  [2782] = {.lex_state = 71},
  [2783] = {.lex_state = 71},
  [2784] = {.lex_state = 71},
  [2785] = {.lex_state = 0, .external_lex_state = 4},
  [2786] = {.lex_state = 71},
  [2787] = {.lex_state = 71},
  [2788] = {.lex_state = 0, .external_lex_state = 4},
  [2789] = {.lex_state = 0, .external_lex_state = 4},
  [2790] = {.lex_state = 71},
  [2791] = {.lex_state = 0, .external_lex_state = 4},
  [2792] = {.lex_state = 14},
  [2793] = {.lex_state = 17},
  [2794] = {.lex_state = 0, .external_lex_state = 4},
  [2795] = {.lex_state = 71, .external_lex_state = 5},
  [2796] = {.lex_state = 0, .external_lex_state = 4},
  [2797] = {.lex_state = 0, .external_lex_state = 4},
  [2798] = {.lex_state = 0, .external_lex_state = 4},
  [2799] = {.lex_state = 71},
  [2800] = {.lex_state = 0, .external_lex_state = 4},
  [2801] = {.lex_state = 0, .external_lex_state = 4},
  [2802] = {.lex_state = 0, .external_lex_state = 4},
  [2803] = {.lex_state = 0, .external_lex_state = 4},
  [2804] = {.lex_state = 71},
  [2805] = {.lex_state = 0},
  [2806] = {.lex_state = 1},
  [2807] = {.lex_state = 71},
  [2808] = {.lex_state = 71},
  [2809] = {.lex_state = 71},
  [2810] = {.lex_state = 71},
  [2811] = {.lex_state = 71},
  [2812] = {.lex_state = 71, .external_lex_state = 5},
  [2813] = {.lex_state = 3},
  [2814] = {.lex_state = 3},
  [2815] = {.lex_state = 1},
  [2816] = {.lex_state = 17},
  [2817] = {.lex_state = 71},
  [2818] = {.lex_state = 1},
  [2819] = {.lex_state = 71},
  [2820] = {.lex_state = 71},
  [2821] = {.lex_state = 71},
  [2822] = {.lex_state = 3},
  [2823] = {.lex_state = 71},
  [2824] = {.lex_state = 71},
  [2825] = {.lex_state = 71},
  [2826] = {.lex_state = 71},
  [2827] = {.lex_state = 0, .external_lex_state = 4},
  [2828] = {.lex_state = 0, .external_lex_state = 4},
  [2829] = {.lex_state = 0},
  [2830] = {.lex_state = 71},
  [2831] = {.lex_state = 71},
  [2832] = {.lex_state = 71},
  [2833] = {.lex_state = 71},
  [2834] = {.lex_state = 17},
  [2835] = {.lex_state = 71},
  [2836] = {.lex_state = 0},
  [2837] = {.lex_state = 17},
  [2838] = {.lex_state = 3},
  [2839] = {.lex_state = 1},
  [2840] = {.lex_state = 71},
  [2841] = {.lex_state = 71},
  [2842] = {.lex_state = 0},
  [2843] = {.lex_state = 71},
  [2844] = {.lex_state = 3},
  [2845] = {.lex_state = 71},
  [2846] = {.lex_state = 0},
  [2847] = {.lex_state = 71},
  [2848] = {.lex_state = 71},
  [2849] = {.lex_state = 71},
  [2850] = {.lex_state = 71},
  [2851] = {.lex_state = 71},
  [2852] = {.lex_state = 1},
  [2853] = {.lex_state = 1},
  [2854] = {.lex_state = 71},
  [2855] = {.lex_state = 3},
  [2856] = {.lex_state = 71},
  [2857] = {.lex_state = 1},
  [2858] = {.lex_state = 3},
  [2859] = {.lex_state = 71},
  [2860] = {.lex_state = 71},
  [2861] = {.lex_state = 71},
  [2862] = {.lex_state = 71, .external_lex_state = 5},
  [2863] = {.lex_state = 71},
  [2864] = {.lex_state = 71},
  [2865] = {.lex_state = 0},
  [2866] = {.lex_state = 1},
  [2867] = {.lex_state = 71},
  [2868] = {.lex_state = 3},
  [2869] = {.lex_state = 71},
  [2870] = {.lex_state = 71},
  [2871] = {.lex_state = 71},
  [2872] = {.lex_state = 0},
  [2873] = {.lex_state = 3},
  [2874] = {.lex_state = 17},
  [2875] = {.lex_state = 0},
  [2876] = {.lex_state = 71},
  [2877] = {.lex_state = 0, .external_lex_state = 4},
  [2878] = {.lex_state = 71},
  [2879] = {.lex_state = 71},
  [2880] = {.lex_state = 17},
  [2881] = {.lex_state = 0, .external_lex_state = 4},
  [2882] = {.lex_state = 0},
  [2883] = {.lex_state = 71},
  [2884] = {.lex_state = 71},
  [2885] = {.lex_state = 71},
  [2886] = {.lex_state = 71},
  [2887] = {.lex_state = 0, .external_lex_state = 4},
  [2888] = {.lex_state = 71},
  [2889] = {.lex_state = 71},
  [2890] = {.lex_state = 71},
  [2891] = {.lex_state = 0},
  [2892] = {.lex_state = 71},
  [2893] = {.lex_state = 71, .external_lex_state = 4},
  [2894] = {.lex_state = 71, .external_lex_state = 5},
  [2895] = {.lex_state = 71},
  [2896] = {.lex_state = 71},
  [2897] = {.lex_state = 0},
  [2898] = {.lex_state = 1},
  [2899] = {.lex_state = 3},
  [2900] = {.lex_state = 1},
  [2901] = {.lex_state = 71},
  [2902] = {.lex_state = 1},
  [2903] = {.lex_state = 3},
  [2904] = {.lex_state = 71},
  [2905] = {.lex_state = 71},
  [2906] = {.lex_state = 1},
  [2907] = {.lex_state = 3},
  [2908] = {.lex_state = 71},
  [2909] = {.lex_state = 71},
  [2910] = {.lex_state = 71},
  [2911] = {.lex_state = 71},
  [2912] = {.lex_state = 71},
  [2913] = {.lex_state = 1},
  [2914] = {.lex_state = 3},
  [2915] = {.lex_state = 20, .external_lex_state = 6},
  [2916] = {.lex_state = 71},
  [2917] = {.lex_state = 71},
  [2918] = {.lex_state = 71},
  [2919] = {.lex_state = 1},
  [2920] = {.lex_state = 71},
  [2921] = {.lex_state = 71},
  [2922] = {.lex_state = 3},
  [2923] = {.lex_state = 1},
  [2924] = {.lex_state = 3},
  [2925] = {.lex_state = 1},
  [2926] = {.lex_state = 3},
  [2927] = {.lex_state = 0, .external_lex_state = 4},
  [2928] = {.lex_state = 3},
  [2929] = {.lex_state = 0, .external_lex_state = 4},
  [2930] = {.lex_state = 71},
  [2931] = {.lex_state = 0},
  [2932] = {.lex_state = 1},
  [2933] = {.lex_state = 0},
  [2934] = {.lex_state = 71},
  [2935] = {.lex_state = 71},
  [2936] = {.lex_state = 71},
  [2937] = {.lex_state = 71, .external_lex_state = 4},
  [2938] = {.lex_state = 71},
  [2939] = {.lex_state = 71},
  [2940] = {.lex_state = 0},
  [2941] = {.lex_state = 71},
  [2942] = {.lex_state = 0},
  [2943] = {.lex_state = 71},
  [2944] = {.lex_state = 71},
  [2945] = {.lex_state = 0},
  [2946] = {.lex_state = 0},
  [2947] = {.lex_state = 71},
  [2948] = {.lex_state = 0},
  [2949] = {.lex_state = 0},
  [2950] = {.lex_state = 0},
  [2951] = {.lex_state = 0},
  [2952] = {.lex_state = 0, .external_lex_state = 4},
  [2953] = {.lex_state = 0},
  [2954] = {.lex_state = 0},
  [2955] = {.lex_state = 14},
  [2956] = {.lex_state = 71, .external_lex_state = 4},
  [2957] = {.lex_state = 0, .external_lex_state = 4},
  [2958] = {.lex_state = 30},
  [2959] = {.lex_state = 0},
  [2960] = {.lex_state = 30},
  [2961] = {.lex_state = 0, .external_lex_state = 4},
  [2962] = {.lex_state = 30},
  [2963] = {.lex_state = 0},
  [2964] = {.lex_state = 0},
  [2965] = {.lex_state = 0},
  [2966] = {.lex_state = 71, .external_lex_state = 4},
  [2967] = {.lex_state = 0},
  [2968] = {.lex_state = 0, .external_lex_state = 4},
  [2969] = {.lex_state = 14},
  [2970] = {.lex_state = 0},
  [2971] = {.lex_state = 0},
  [2972] = {.lex_state = 71},
  [2973] = {.lex_state = 30},
  [2974] = {.lex_state = 71},
  [2975] = {.lex_state = 0},
  [2976] = {.lex_state = 0},
  [2977] = {.lex_state = 0},
  [2978] = {.lex_state = 0},
  [2979] = {.lex_state = 0},
  [2980] = {.lex_state = 0},
  [2981] = {.lex_state = 30},
  [2982] = {.lex_state = 0},
  [2983] = {.lex_state = 30},
  [2984] = {.lex_state = 71},
  [2985] = {.lex_state = 71},
  [2986] = {.lex_state = 0},
  [2987] = {.lex_state = 0},
  [2988] = {.lex_state = 0},
  [2989] = {.lex_state = 0},
  [2990] = {.lex_state = 0},
  [2991] = {.lex_state = 71},
  [2992] = {.lex_state = 0, .external_lex_state = 4},
  [2993] = {.lex_state = 0},
  [2994] = {.lex_state = 0, .external_lex_state = 4},
  [2995] = {.lex_state = 0},
  [2996] = {.lex_state = 0},
  [2997] = {.lex_state = 0},
  [2998] = {.lex_state = 0},
  [2999] = {.lex_state = 0},
  [3000] = {.lex_state = 0},
  [3001] = {.lex_state = 0},
  [3002] = {.lex_state = 0},
  [3003] = {.lex_state = 0},
  [3004] = {.lex_state = 0},
  [3005] = {.lex_state = 0},
  [3006] = {.lex_state = 0},
  [3007] = {.lex_state = 71},
  [3008] = {.lex_state = 0, .external_lex_state = 4},
  [3009] = {.lex_state = 0},
  [3010] = {.lex_state = 0},
  [3011] = {.lex_state = 0},
  [3012] = {.lex_state = 0},
  [3013] = {.lex_state = 0},
  [3014] = {.lex_state = 0},
  [3015] = {.lex_state = 0},
  [3016] = {.lex_state = 0},
  [3017] = {.lex_state = 0},
  [3018] = {.lex_state = 71},
  [3019] = {.lex_state = 0},
  [3020] = {.lex_state = 0},
  [3021] = {.lex_state = 0},
  [3022] = {.lex_state = 30},
  [3023] = {.lex_state = 0},
  [3024] = {.lex_state = 0},
  [3025] = {.lex_state = 0},
  [3026] = {.lex_state = 30},
  [3027] = {.lex_state = 0},
  [3028] = {.lex_state = 0, .external_lex_state = 4},
  [3029] = {.lex_state = 71},
  [3030] = {.lex_state = 30},
  [3031] = {.lex_state = 0},
  [3032] = {.lex_state = 30},
  [3033] = {.lex_state = 71},
  [3034] = {.lex_state = 0},
  [3035] = {.lex_state = 0, .external_lex_state = 4},
  [3036] = {.lex_state = 0},
  [3037] = {.lex_state = 0},
  [3038] = {.lex_state = 0, .external_lex_state = 4},
  [3039] = {.lex_state = 0},
  [3040] = {.lex_state = 0},
  [3041] = {.lex_state = 71},
  [3042] = {.lex_state = 71},
  [3043] = {.lex_state = 71},
  [3044] = {.lex_state = 71, .external_lex_state = 4},
  [3045] = {.lex_state = 71},
  [3046] = {.lex_state = 0, .external_lex_state = 4},
  [3047] = {.lex_state = 0},
  [3048] = {.lex_state = 0},
  [3049] = {.lex_state = 0, .external_lex_state = 4},
  [3050] = {.lex_state = 30},
  [3051] = {.lex_state = 0},
  [3052] = {.lex_state = 71},
  [3053] = {.lex_state = 71},
  [3054] = {.lex_state = 71},
  [3055] = {.lex_state = 0, .external_lex_state = 4},
  [3056] = {.lex_state = 0, .external_lex_state = 4},
  [3057] = {.lex_state = 71},
  [3058] = {.lex_state = 71},
  [3059] = {.lex_state = 0, .external_lex_state = 4},
  [3060] = {.lex_state = 71, .external_lex_state = 4},
  [3061] = {.lex_state = 71},
  [3062] = {.lex_state = 0},
  [3063] = {.lex_state = 0, .external_lex_state = 4},
  [3064] = {.lex_state = 0, .external_lex_state = 4},
  [3065] = {.lex_state = 0, .external_lex_state = 4},
  [3066] = {.lex_state = 0, .external_lex_state = 4},
  [3067] = {.lex_state = 0, .external_lex_state = 4},
  [3068] = {.lex_state = 71},
  [3069] = {.lex_state = 0, .external_lex_state = 4},
  [3070] = {.lex_state = 71},
  [3071] = {.lex_state = 0, .external_lex_state = 4},
  [3072] = {.lex_state = 14},
  [3073] = {.lex_state = 0, .external_lex_state = 4},
  [3074] = {.lex_state = 0, .external_lex_state = 4},
  [3075] = {.lex_state = 0},
  [3076] = {.lex_state = 0},
  [3077] = {.lex_state = 0},
  [3078] = {.lex_state = 71},
  [3079] = {.lex_state = 71},
  [3080] = {.lex_state = 71},
  [3081] = {.lex_state = 0},
  [3082] = {.lex_state = 0},
  [3083] = {.lex_state = 0},
  [3084] = {.lex_state = 0, .external_lex_state = 4},
  [3085] = {.lex_state = 0},
  [3086] = {.lex_state = 0, .external_lex_state = 4},
  [3087] = {.lex_state = 71},
  [3088] = {.lex_state = 0},
  [3089] = {.lex_state = 71},
  [3090] = {.lex_state = 71},
  [3091] = {.lex_state = 30},
  [3092] = {.lex_state = 71},
  [3093] = {.lex_state = 0, .external_lex_state = 4},
  [3094] = {.lex_state = 0},
  [3095] = {.lex_state = 0},
  [3096] = {.lex_state = 71},
  [3097] = {.lex_state = 71},
  [3098] = {.lex_state = 0},
  [3099] = {.lex_state = 71},
  [3100] = {.lex_state = 0, .external_lex_state = 4},
  [3101] = {.lex_state = 71},
  [3102] = {.lex_state = 71},
  [3103] = {.lex_state = 0},
  [3104] = {.lex_state = 71},
  [3105] = {.lex_state = 0},
  [3106] = {.lex_state = 0},
  [3107] = {.lex_state = 0},
  [3108] = {.lex_state = 30},
  [3109] = {.lex_state = 71},
  [3110] = {.lex_state = 0, .external_lex_state = 4},
  [3111] = {.lex_state = 71},
  [3112] = {.lex_state = 0, .external_lex_state = 4},
  [3113] = {.lex_state = 71},
  [3114] = {.lex_state = 0},
  [3115] = {.lex_state = 71},
  [3116] = {.lex_state = 71},
  [3117] = {.lex_state = 0},
  [3118] = {.lex_state = 0},
  [3119] = {.lex_state = 0, .external_lex_state = 4},
  [3120] = {.lex_state = 71},
  [3121] = {.lex_state = 0, .external_lex_state = 4},
  [3122] = {.lex_state = 0},
  [3123] = {.lex_state = 0},
  [3124] = {.lex_state = 0},
  [3125] = {.lex_state = 0},
  [3126] = {.lex_state = 0},
  [3127] = {.lex_state = 71},
  [3128] = {.lex_state = 0},
  [3129] = {.lex_state = 30},
  [3130] = {.lex_state = 0},
  [3131] = {.lex_state = 30},
  [3132] = {.lex_state = 0},
  [3133] = {.lex_state = 0},
  [3134] = {.lex_state = 71, .external_lex_state = 4},
  [3135] = {.lex_state = 71, .external_lex_state = 4},
  [3136] = {.lex_state = 71},
  [3137] = {.lex_state = 71},
  [3138] = {.lex_state = 0},
  [3139] = {.lex_state = 71},
  [3140] = {.lex_state = 71},
  [3141] = {.lex_state = 71},
  [3142] = {.lex_state = 71},
  [3143] = {.lex_state = 71},
  [3144] = {.lex_state = 71},
  [3145] = {.lex_state = 71},
  [3146] = {.lex_state = 71},
  [3147] = {.lex_state = 0},
  [3148] = {.lex_state = 71},
  [3149] = {.lex_state = 0},
  [3150] = {.lex_state = 0},
  [3151] = {.lex_state = 0, .external_lex_state = 4},
  [3152] = {.lex_state = 71},
  [3153] = {.lex_state = 0},
  [3154] = {.lex_state = 0},
  [3155] = {.lex_state = 0},
  [3156] = {.lex_state = 71},
  [3157] = {.lex_state = 71},
  [3158] = {.lex_state = 71},
  [3159] = {.lex_state = 71},
  [3160] = {.lex_state = 71},
  [3161] = {.lex_state = 0},
  [3162] = {.lex_state = 0},
  [3163] = {.lex_state = 0},
  [3164] = {.lex_state = 71},
  [3165] = {.lex_state = 71},
  [3166] = {.lex_state = 0},
  [3167] = {.lex_state = 71},
  [3168] = {.lex_state = 0},
  [3169] = {.lex_state = 0},
  [3170] = {.lex_state = 71},
  [3171] = {.lex_state = 0},
  [3172] = {.lex_state = 71},
  [3173] = {.lex_state = 71},
  [3174] = {.lex_state = 0},
  [3175] = {.lex_state = 0},
  [3176] = {.lex_state = 0},
  [3177] = {.lex_state = 0, .external_lex_state = 4},
  [3178] = {.lex_state = 71},
  [3179] = {.lex_state = 0, .external_lex_state = 4},
  [3180] = {.lex_state = 0},
  [3181] = {.lex_state = 71},
  [3182] = {.lex_state = 71},
  [3183] = {.lex_state = 71},
  [3184] = {.lex_state = 71},
  [3185] = {.lex_state = 0},
  [3186] = {.lex_state = 71},
  [3187] = {.lex_state = 0},
  [3188] = {.lex_state = 0},
  [3189] = {.lex_state = 17},
  [3190] = {.lex_state = 0, .external_lex_state = 4},
  [3191] = {.lex_state = 71},
  [3192] = {.lex_state = 71},
  [3193] = {.lex_state = 71},
  [3194] = {.lex_state = 71},
  [3195] = {.lex_state = 0},
  [3196] = {.lex_state = 71},
  [3197] = {.lex_state = 0},
  [3198] = {.lex_state = 71},
  [3199] = {.lex_state = 71},
  [3200] = {.lex_state = 71},
  [3201] = {.lex_state = 71},
  [3202] = {.lex_state = 0},
  [3203] = {.lex_state = 71},
  [3204] = {.lex_state = 0},
  [3205] = {.lex_state = 0},
  [3206] = {.lex_state = 71},
  [3207] = {.lex_state = 0, .external_lex_state = 4},
  [3208] = {.lex_state = 0},
  [3209] = {.lex_state = 71},
  [3210] = {.lex_state = 0},
  [3211] = {.lex_state = 0},
  [3212] = {.lex_state = 71},
  [3213] = {.lex_state = 71},
  [3214] = {.lex_state = 71},
  [3215] = {.lex_state = 0},
  [3216] = {.lex_state = 71},
  [3217] = {.lex_state = 71},
  [3218] = {.lex_state = 71},
  [3219] = {.lex_state = 71},
  [3220] = {.lex_state = 71},
  [3221] = {.lex_state = 0},
  [3222] = {.lex_state = 71},
  [3223] = {.lex_state = 71},
  [3224] = {.lex_state = 71},
  [3225] = {.lex_state = 0},
  [3226] = {.lex_state = 71},
  [3227] = {.lex_state = 71},
  [3228] = {.lex_state = 71},
  [3229] = {.lex_state = 71},
  [3230] = {.lex_state = 71},
  [3231] = {.lex_state = 0},
  [3232] = {.lex_state = 71},
  [3233] = {.lex_state = 0},
  [3234] = {.lex_state = 71},
  [3235] = {.lex_state = 0},
  [3236] = {.lex_state = 71},
  [3237] = {.lex_state = 0},
  [3238] = {.lex_state = 0},
  [3239] = {.lex_state = 71},
  [3240] = {.lex_state = 71},
  [3241] = {.lex_state = 71},
  [3242] = {.lex_state = 0, .external_lex_state = 4},
  [3243] = {.lex_state = 71},
  [3244] = {.lex_state = 71},
  [3245] = {.lex_state = 71},
  [3246] = {.lex_state = 71},
  [3247] = {.lex_state = 71},
  [3248] = {.lex_state = 71},
  [3249] = {.lex_state = 0, .external_lex_state = 4},
  [3250] = {.lex_state = 71},
  [3251] = {.lex_state = 0},
  [3252] = {.lex_state = 71},
  [3253] = {.lex_state = 0, .external_lex_state = 4},
  [3254] = {.lex_state = 71},
  [3255] = {.lex_state = 0},
  [3256] = {.lex_state = 71},
  [3257] = {.lex_state = 71},
  [3258] = {.lex_state = 71},
  [3259] = {.lex_state = 71},
  [3260] = {.lex_state = 0},
  [3261] = {.lex_state = 0},
  [3262] = {.lex_state = 71},
  [3263] = {.lex_state = 0},
  [3264] = {.lex_state = 71},
  [3265] = {.lex_state = 71},
  [3266] = {.lex_state = 71},
  [3267] = {.lex_state = 71},
  [3268] = {.lex_state = 71},
  [3269] = {.lex_state = 0},
  [3270] = {.lex_state = 0, .external_lex_state = 4},
  [3271] = {.lex_state = 0, .external_lex_state = 4},
  [3272] = {.lex_state = 0, .external_lex_state = 4},
  [3273] = {.lex_state = 0, .external_lex_state = 4},
  [3274] = {.lex_state = 0},
  [3275] = {.lex_state = 71},
  [3276] = {.lex_state = 71},
  [3277] = {.lex_state = 71},
  [3278] = {.lex_state = 71},
  [3279] = {.lex_state = 0},
  [3280] = {.lex_state = 71},
  [3281] = {.lex_state = 0},
  [3282] = {.lex_state = 71},
  [3283] = {.lex_state = 71},
  [3284] = {.lex_state = 71},
  [3285] = {.lex_state = 0},
  [3286] = {.lex_state = 71},
  [3287] = {.lex_state = 71},
  [3288] = {.lex_state = 0},
  [3289] = {.lex_state = 71},
  [3290] = {.lex_state = 0, .external_lex_state = 4},
  [3291] = {.lex_state = 71},
  [3292] = {.lex_state = 0},
  [3293] = {.lex_state = 71},
  [3294] = {.lex_state = 71},
  [3295] = {.lex_state = 71},
  [3296] = {.lex_state = 71},
  [3297] = {.lex_state = 71},
  [3298] = {.lex_state = 71},
  [3299] = {.lex_state = 0},
  [3300] = {.lex_state = 0, .external_lex_state = 4},
  [3301] = {.lex_state = 0},
  [3302] = {.lex_state = 0, .external_lex_state = 4},
  [3303] = {.lex_state = 71},
  [3304] = {.lex_state = 71},
  [3305] = {.lex_state = 71},
  [3306] = {.lex_state = 0, .external_lex_state = 4},
  [3307] = {.lex_state = 71},
  [3308] = {.lex_state = 71},
  [3309] = {.lex_state = 0},
  [3310] = {.lex_state = 71},
  [3311] = {.lex_state = 0},
  [3312] = {.lex_state = 71},
  [3313] = {.lex_state = 71},
  [3314] = {.lex_state = 71},
  [3315] = {.lex_state = 71},
  [3316] = {.lex_state = 71},
  [3317] = {.lex_state = 71},
  [3318] = {.lex_state = 71},
  [3319] = {.lex_state = 0},
  [3320] = {.lex_state = 0},
  [3321] = {.lex_state = 0},
  [3322] = {.lex_state = 0},
  [3323] = {.lex_state = 71},
  [3324] = {.lex_state = 71},
  [3325] = {.lex_state = 0, .external_lex_state = 4},
  [3326] = {.lex_state = 0},
  [3327] = {.lex_state = 71},
  [3328] = {.lex_state = 0},
  [3329] = {.lex_state = 71},
  [3330] = {.lex_state = 71},
  [3331] = {.lex_state = 71},
  [3332] = {.lex_state = 71},
  [3333] = {.lex_state = 71},
  [3334] = {.lex_state = 0},
  [3335] = {.lex_state = 0, .external_lex_state = 4},
  [3336] = {.lex_state = 0},
  [3337] = {.lex_state = 71},
  [3338] = {.lex_state = 71},
  [3339] = {.lex_state = 71},
  [3340] = {.lex_state = 71},
  [3341] = {.lex_state = 0},
  [3342] = {.lex_state = 0},
  [3343] = {.lex_state = 0},
  [3344] = {.lex_state = 0},
  [3345] = {.lex_state = 71},
  [3346] = {.lex_state = 71},
  [3347] = {.lex_state = 0},
  [3348] = {.lex_state = 0},
  [3349] = {.lex_state = 71},
  [3350] = {.lex_state = 0},
  [3351] = {.lex_state = 71},
  [3352] = {.lex_state = 71},
  [3353] = {.lex_state = 0},
  [3354] = {.lex_state = 71},
  [3355] = {.lex_state = 0},
  [3356] = {.lex_state = 71},
  [3357] = {.lex_state = 71},
  [3358] = {.lex_state = 71},
  [3359] = {.lex_state = 0},
  [3360] = {.lex_state = 0},
  [3361] = {.lex_state = 71},
  [3362] = {.lex_state = 0, .external_lex_state = 4},
  [3363] = {.lex_state = 71},
  [3364] = {.lex_state = 0},
  [3365] = {.lex_state = 71},
  [3366] = {.lex_state = 71},
  [3367] = {.lex_state = 71},
  [3368] = {.lex_state = 71},
  [3369] = {.lex_state = 71},
  [3370] = {.lex_state = 71},
  [3371] = {.lex_state = 71},
  [3372] = {.lex_state = 71},
  [3373] = {.lex_state = 0},
  [3374] = {.lex_state = 0},
  [3375] = {.lex_state = 71},
  [3376] = {.lex_state = 0, .external_lex_state = 4},
  [3377] = {.lex_state = 0},
  [3378] = {.lex_state = 71},
  [3379] = {.lex_state = 0},
  [3380] = {.lex_state = 71},
  [3381] = {.lex_state = 0},
  [3382] = {.lex_state = 71},
  [3383] = {.lex_state = 71},
  [3384] = {.lex_state = 71},
  [3385] = {.lex_state = 0},
  [3386] = {.lex_state = 71},
  [3387] = {.lex_state = 0},
  [3388] = {.lex_state = 0},
  [3389] = {.lex_state = 0},
  [3390] = {.lex_state = 71},
  [3391] = {.lex_state = 71},
  [3392] = {.lex_state = 71},
  [3393] = {.lex_state = 71},
  [3394] = {.lex_state = 71},
  [3395] = {.lex_state = 71},
  [3396] = {.lex_state = 71},
  [3397] = {.lex_state = 71},
  [3398] = {.lex_state = 5},
  [3399] = {.lex_state = 0},
  [3400] = {.lex_state = 71},
  [3401] = {.lex_state = 71},
  [3402] = {.lex_state = 0},
  [3403] = {.lex_state = 71},
  [3404] = {.lex_state = 0},
  [3405] = {.lex_state = 0},
  [3406] = {.lex_state = 71},
  [3407] = {.lex_state = 0},
  [3408] = {.lex_state = 71},
  [3409] = {.lex_state = 0},
  [3410] = {.lex_state = 0},
  [3411] = {.lex_state = 0},
  [3412] = {.lex_state = 71},
  [3413] = {.lex_state = 0},
  [3414] = {.lex_state = 71},
  [3415] = {.lex_state = 0},
  [3416] = {.lex_state = 71},
  [3417] = {.lex_state = 0},
  [3418] = {.lex_state = 0},
  [3419] = {.lex_state = 71},
  [3420] = {.lex_state = 0},
  [3421] = {.lex_state = 71},
  [3422] = {.lex_state = 71},
  [3423] = {.lex_state = 0},
  [3424] = {.lex_state = 71},
  [3425] = {.lex_state = 71},
  [3426] = {.lex_state = 71},
  [3427] = {.lex_state = 0},
  [3428] = {.lex_state = 0},
  [3429] = {.lex_state = 0},
  [3430] = {.lex_state = 0},
  [3431] = {.lex_state = 71},
  [3432] = {.lex_state = 0},
  [3433] = {.lex_state = 0},
  [3434] = {.lex_state = 71},
  [3435] = {.lex_state = 5},
  [3436] = {.lex_state = 0},
  [3437] = {.lex_state = 71},
  [3438] = {.lex_state = 0},
  [3439] = {.lex_state = 0},
  [3440] = {.lex_state = 0},
  [3441] = {.lex_state = 0},
  [3442] = {.lex_state = 15},
  [3443] = {.lex_state = 0},
  [3444] = {.lex_state = 71},
  [3445] = {.lex_state = 0},
  [3446] = {.lex_state = 0},
  [3447] = {.lex_state = 0},
  [3448] = {.lex_state = 71},
  [3449] = {.lex_state = 0},
  [3450] = {.lex_state = 71},
  [3451] = {.lex_state = 71},
  [3452] = {.lex_state = 71},
  [3453] = {.lex_state = 71},
  [3454] = {.lex_state = 0},
  [3455] = {.lex_state = 0},
  [3456] = {.lex_state = 0},
  [3457] = {.lex_state = 0},
  [3458] = {.lex_state = 0},
  [3459] = {.lex_state = 71},
  [3460] = {.lex_state = 0},
  [3461] = {.lex_state = 15},
  [3462] = {.lex_state = 0},
  [3463] = {.lex_state = 71},
  [3464] = {.lex_state = 71},
  [3465] = {.lex_state = 71},
  [3466] = {.lex_state = 0},
  [3467] = {.lex_state = 0},
  [3468] = {.lex_state = 0},
  [3469] = {.lex_state = 0},
  [3470] = {.lex_state = 0},
  [3471] = {.lex_state = 0},
  [3472] = {.lex_state = 0},
  [3473] = {.lex_state = 71},
  [3474] = {.lex_state = 0},
  [3475] = {.lex_state = 0},
  [3476] = {.lex_state = 71},
  [3477] = {.lex_state = 71},
  [3478] = {.lex_state = 71},
  [3479] = {.lex_state = 71},
  [3480] = {.lex_state = 0},
  [3481] = {.lex_state = 71},
  [3482] = {.lex_state = 71},
  [3483] = {.lex_state = 0},
  [3484] = {.lex_state = 71},
  [3485] = {.lex_state = 0},
  [3486] = {.lex_state = 0},
  [3487] = {.lex_state = 71},
  [3488] = {.lex_state = 0},
  [3489] = {.lex_state = 0},
  [3490] = {.lex_state = 71},
  [3491] = {.lex_state = 0},
  [3492] = {.lex_state = 71},
  [3493] = {.lex_state = 71},
  [3494] = {.lex_state = 0},
  [3495] = {.lex_state = 0},
  [3496] = {.lex_state = 0},
  [3497] = {.lex_state = 71},
  [3498] = {.lex_state = 15},
  [3499] = {.lex_state = 71},
  [3500] = {.lex_state = 0},
  [3501] = {.lex_state = 0},
  [3502] = {.lex_state = 0},
  [3503] = {.lex_state = 71},
  [3504] = {.lex_state = 71},
  [3505] = {.lex_state = 71},
  [3506] = {.lex_state = 71},
  [3507] = {.lex_state = 71},
  [3508] = {.lex_state = 71},
  [3509] = {.lex_state = 71},
  [3510] = {.lex_state = 0},
  [3511] = {.lex_state = 0},
  [3512] = {.lex_state = 71},
  [3513] = {.lex_state = 71},
  [3514] = {.lex_state = 0},
  [3515] = {.lex_state = 0},
  [3516] = {.lex_state = 71},
  [3517] = {.lex_state = 71},
  [3518] = {.lex_state = 0},
  [3519] = {.lex_state = 0},
  [3520] = {.lex_state = 71},
  [3521] = {.lex_state = 0},
  [3522] = {.lex_state = 15},
  [3523] = {.lex_state = 0},
  [3524] = {.lex_state = 0},
  [3525] = {.lex_state = 71},
  [3526] = {.lex_state = 0},
  [3527] = {.lex_state = 0},
  [3528] = {.lex_state = 71},
  [3529] = {.lex_state = 0},
  [3530] = {.lex_state = 0},
  [3531] = {.lex_state = 71},
  [3532] = {.lex_state = 0},
  [3533] = {.lex_state = 71},
  [3534] = {.lex_state = 0},
  [3535] = {.lex_state = 0},
  [3536] = {.lex_state = 71},
  [3537] = {.lex_state = 71},
  [3538] = {.lex_state = 0},
  [3539] = {.lex_state = 0},
  [3540] = {.lex_state = 71},
  [3541] = {.lex_state = 0},
  [3542] = {.lex_state = 71},
  [3543] = {.lex_state = 0},
  [3544] = {.lex_state = 0},
  [3545] = {.lex_state = 71},
  [3546] = {.lex_state = 71},
  [3547] = {.lex_state = 71},
  [3548] = {.lex_state = 71},
  [3549] = {.lex_state = 71},
  [3550] = {.lex_state = 71},
  [3551] = {.lex_state = 71},
  [3552] = {.lex_state = 0},
  [3553] = {.lex_state = 0},
  [3554] = {.lex_state = 0},
  [3555] = {.lex_state = 71},
  [3556] = {.lex_state = 71},
  [3557] = {.lex_state = 0},
  [3558] = {.lex_state = 71},
  [3559] = {.lex_state = 71},
  [3560] = {.lex_state = 0},
  [3561] = {.lex_state = 71},
  [3562] = {.lex_state = 71},
  [3563] = {.lex_state = 71},
  [3564] = {.lex_state = 71},
  [3565] = {.lex_state = 0},
  [3566] = {.lex_state = 71},
  [3567] = {.lex_state = 71},
  [3568] = {.lex_state = 71},
  [3569] = {.lex_state = 71},
  [3570] = {.lex_state = 0},
  [3571] = {.lex_state = 0},
  [3572] = {.lex_state = 71},
  [3573] = {.lex_state = 71},
  [3574] = {.lex_state = 71},
  [3575] = {.lex_state = 0},
  [3576] = {.lex_state = 0},
  [3577] = {.lex_state = 0},
  [3578] = {.lex_state = 0},
  [3579] = {.lex_state = 0},
  [3580] = {.lex_state = 71},
  [3581] = {.lex_state = 71},
  [3582] = {.lex_state = 71},
  [3583] = {.lex_state = 71},
  [3584] = {.lex_state = 71},
  [3585] = {.lex_state = 71},
  [3586] = {.lex_state = 71},
  [3587] = {.lex_state = 71},
  [3588] = {.lex_state = 0},
  [3589] = {.lex_state = 0},
  [3590] = {.lex_state = 71},
  [3591] = {.lex_state = 71},
  [3592] = {.lex_state = 71},
  [3593] = {.lex_state = 0},
  [3594] = {.lex_state = 0},
  [3595] = {.lex_state = 0},
  [3596] = {.lex_state = 0},
  [3597] = {.lex_state = 71},
  [3598] = {.lex_state = 71},
  [3599] = {.lex_state = 0},
  [3600] = {.lex_state = 0},
  [3601] = {.lex_state = 71},
  [3602] = {.lex_state = 0},
  [3603] = {.lex_state = 71},
  [3604] = {.lex_state = 71},
  [3605] = {.lex_state = 0},
  [3606] = {.lex_state = 0},
  [3607] = {.lex_state = 71},
  [3608] = {.lex_state = 0},
  [3609] = {.lex_state = 0},
  [3610] = {.lex_state = 0},
  [3611] = {.lex_state = 0},
  [3612] = {.lex_state = 71},
  [3613] = {.lex_state = 71},
  [3614] = {.lex_state = 0},
  [3615] = {.lex_state = 0},
  [3616] = {.lex_state = 0},
  [3617] = {.lex_state = 0},
  [3618] = {.lex_state = 0},
  [3619] = {.lex_state = 0},
  [3620] = {.lex_state = 71},
  [3621] = {.lex_state = 0},
  [3622] = {.lex_state = 71},
  [3623] = {.lex_state = 71},
  [3624] = {.lex_state = 71},
  [3625] = {.lex_state = 0},
  [3626] = {.lex_state = 71},
  [3627] = {.lex_state = 71},
  [3628] = {.lex_state = 0},
  [3629] = {.lex_state = 71},
  [3630] = {.lex_state = 0},
  [3631] = {.lex_state = 71},
  [3632] = {.lex_state = 0},
  [3633] = {.lex_state = 0},
  [3634] = {.lex_state = 71},
  [3635] = {.lex_state = 71},
  [3636] = {.lex_state = 0},
  [3637] = {.lex_state = 0},
  [3638] = {.lex_state = 71},
  [3639] = {.lex_state = 71},
  [3640] = {.lex_state = 71},
  [3641] = {.lex_state = 71},
  [3642] = {.lex_state = 71},
  [3643] = {.lex_state = 71},
  [3644] = {.lex_state = 0},
  [3645] = {.lex_state = 71},
  [3646] = {.lex_state = 71},
  [3647] = {.lex_state = 71},
  [3648] = {.lex_state = 71},
  [3649] = {.lex_state = 0},
  [3650] = {.lex_state = 71},
  [3651] = {.lex_state = 71},
  [3652] = {.lex_state = 0},
  [3653] = {.lex_state = 71},
  [3654] = {.lex_state = 0},
  [3655] = {.lex_state = 71},
  [3656] = {.lex_state = 5},
  [3657] = {.lex_state = 71},
  [3658] = {.lex_state = 71},
  [3659] = {.lex_state = 71},
  [3660] = {.lex_state = 0},
  [3661] = {.lex_state = 71},
  [3662] = {.lex_state = 71},
  [3663] = {.lex_state = 71},
  [3664] = {.lex_state = 71},
  [3665] = {.lex_state = 71},
  [3666] = {.lex_state = 71},
  [3667] = {.lex_state = 71},
  [3668] = {.lex_state = 5},
  [3669] = {.lex_state = 71},
  [3670] = {.lex_state = 0},
  [3671] = {.lex_state = 71},
  [3672] = {.lex_state = 0},
  [3673] = {.lex_state = 71},
  [3674] = {.lex_state = 71},
  [3675] = {.lex_state = 71},
  [3676] = {.lex_state = 71},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token_PIPE_PIPE = 2,
  ts_external_token__function_signature_automatic_semicolon = 3,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [ts_external_token__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
};

static bool ts_external_scanner_states[7][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [2] = {
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [6] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(3625),
    [sym_export_statement] = STATE(26),
    [sym__declaration] = STATE(26),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(26),
    [sym_expression_statement] = STATE(26),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_switch_statement] = STATE(26),
    [sym_for_statement] = STATE(26),
    [sym_for_in_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_do_statement] = STATE(26),
    [sym_try_statement] = STATE(26),
    [sym_with_statement] = STATE(26),
    [sym_break_statement] = STATE(26),
    [sym_continue_statement] = STATE(26),
    [sym_debugger_statement] = STATE(26),
    [sym_return_statement] = STATE(26),
    [sym_throw_statement] = STATE(26),
    [sym_empty_statement] = STATE(26),
    [sym_labeled_statement] = STATE(26),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(26),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [2] = {
    [sym_export_statement] = STATE(20),
    [sym__declaration] = STATE(20),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1602),
    [sym_assignment_pattern] = STATE(3098),
    [sym_array] = STATE(1606),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_spread_element] = STATE(3098),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1599),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_method_definition] = STATE(3098),
    [sym_pair] = STATE(3098),
    [sym__property_name] = STATE(2353),
    [sym_computed_property_name] = STATE(2353),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_accessibility_modifier] = STATE(1984),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [aux_sym_object_repeat1] = STATE(3095),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(115),
    [anon_sym_type] = ACTIONS(117),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(127),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(129),
    [anon_sym_set] = ACTIONS(129),
    [anon_sym_declare] = ACTIONS(131),
    [anon_sym_public] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(133),
    [anon_sym_protected] = ACTIONS(133),
    [anon_sym_module] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(139),
  },
  [3] = {
    [sym_export_statement] = STATE(14),
    [sym__declaration] = STATE(14),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1602),
    [sym_assignment_pattern] = STATE(3025),
    [sym_array] = STATE(1606),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_spread_element] = STATE(3025),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1599),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_method_definition] = STATE(3025),
    [sym_pair] = STATE(3025),
    [sym__property_name] = STATE(2353),
    [sym_computed_property_name] = STATE(2353),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_accessibility_modifier] = STATE(1984),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [aux_sym_object_repeat1] = STATE(3021),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_export] = ACTIONS(143),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(147),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(151),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(153),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(155),
    [anon_sym_set] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(157),
    [anon_sym_public] = ACTIONS(159),
    [anon_sym_private] = ACTIONS(159),
    [anon_sym_protected] = ACTIONS(159),
    [anon_sym_module] = ACTIONS(161),
    [anon_sym_any] = ACTIONS(163),
    [anon_sym_number] = ACTIONS(163),
    [anon_sym_boolean] = ACTIONS(163),
    [anon_sym_string] = ACTIONS(163),
    [anon_sym_symbol] = ACTIONS(163),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(165),
  },
  [4] = {
    [sym_export_statement] = STATE(20),
    [sym__declaration] = STATE(20),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1602),
    [sym_assignment_pattern] = STATE(3098),
    [sym_array] = STATE(1606),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_spread_element] = STATE(3098),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1599),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_method_definition] = STATE(3098),
    [sym_pair] = STATE(3098),
    [sym__property_name] = STATE(2353),
    [sym_computed_property_name] = STATE(2353),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_accessibility_modifier] = STATE(1984),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [aux_sym_object_repeat1] = STATE(3095),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(167),
    [anon_sym_type] = ACTIONS(117),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(127),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(129),
    [anon_sym_set] = ACTIONS(129),
    [anon_sym_declare] = ACTIONS(131),
    [anon_sym_public] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(133),
    [anon_sym_protected] = ACTIONS(133),
    [anon_sym_module] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(139),
  },
  [5] = {
    [sym_export_statement] = STATE(28),
    [sym__declaration] = STATE(28),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1602),
    [sym_assignment_pattern] = STATE(2996),
    [sym_array] = STATE(1606),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_spread_element] = STATE(2996),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1599),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_method_definition] = STATE(2996),
    [sym_pair] = STATE(2996),
    [sym__property_name] = STATE(2353),
    [sym_computed_property_name] = STATE(2353),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_accessibility_modifier] = STATE(1984),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [aux_sym_object_repeat1] = STATE(2998),
    [sym_identifier] = ACTIONS(169),
    [anon_sym_export] = ACTIONS(171),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(175),
    [anon_sym_type] = ACTIONS(177),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(179),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(181),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(183),
    [anon_sym_set] = ACTIONS(183),
    [anon_sym_declare] = ACTIONS(185),
    [anon_sym_public] = ACTIONS(187),
    [anon_sym_private] = ACTIONS(187),
    [anon_sym_protected] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(189),
    [anon_sym_any] = ACTIONS(191),
    [anon_sym_number] = ACTIONS(191),
    [anon_sym_boolean] = ACTIONS(191),
    [anon_sym_string] = ACTIONS(191),
    [anon_sym_symbol] = ACTIONS(191),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(193),
  },
  [6] = {
    [sym_export_statement] = STATE(13),
    [sym__declaration] = STATE(13),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1602),
    [sym_assignment_pattern] = STATE(3098),
    [sym_array] = STATE(1606),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_spread_element] = STATE(3098),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1599),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_method_definition] = STATE(3098),
    [sym_pair] = STATE(3098),
    [sym__property_name] = STATE(2353),
    [sym_computed_property_name] = STATE(2353),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_accessibility_modifier] = STATE(1984),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [aux_sym_object_repeat1] = STATE(3095),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(195),
    [anon_sym_type] = ACTIONS(117),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(125),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(127),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(129),
    [anon_sym_set] = ACTIONS(129),
    [anon_sym_declare] = ACTIONS(131),
    [anon_sym_public] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(133),
    [anon_sym_protected] = ACTIONS(133),
    [anon_sym_module] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(139),
  },
  [7] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [ts_builtin_sym_end] = ACTIONS(197),
    [sym_identifier] = ACTIONS(199),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_namespace] = ACTIONS(207),
    [anon_sym_LBRACE] = ACTIONS(210),
    [anon_sym_RBRACE] = ACTIONS(197),
    [anon_sym_type] = ACTIONS(213),
    [anon_sym_typeof] = ACTIONS(216),
    [anon_sym_import] = ACTIONS(219),
    [anon_sym_var] = ACTIONS(222),
    [anon_sym_let] = ACTIONS(225),
    [anon_sym_const] = ACTIONS(228),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_switch] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(240),
    [anon_sym_LPAREN] = ACTIONS(243),
    [anon_sym_await] = ACTIONS(246),
    [anon_sym_while] = ACTIONS(249),
    [anon_sym_do] = ACTIONS(252),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_with] = ACTIONS(258),
    [anon_sym_break] = ACTIONS(261),
    [anon_sym_continue] = ACTIONS(264),
    [anon_sym_debugger] = ACTIONS(267),
    [anon_sym_return] = ACTIONS(270),
    [anon_sym_throw] = ACTIONS(273),
    [anon_sym_SEMI] = ACTIONS(276),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(282),
    [anon_sym_LT] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(288),
    [anon_sym_class] = ACTIONS(291),
    [anon_sym_async] = ACTIONS(294),
    [anon_sym_function] = ACTIONS(297),
    [anon_sym_new] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(303),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(231),
    [anon_sym_void] = ACTIONS(216),
    [anon_sym_delete] = ACTIONS(216),
    [anon_sym_PLUS_PLUS] = ACTIONS(306),
    [anon_sym_DASH_DASH] = ACTIONS(306),
    [anon_sym_DQUOTE] = ACTIONS(309),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(315),
    [sym_number] = ACTIONS(318),
    [sym_this] = ACTIONS(321),
    [sym_super] = ACTIONS(321),
    [sym_true] = ACTIONS(321),
    [sym_false] = ACTIONS(321),
    [sym_null] = ACTIONS(321),
    [sym_undefined] = ACTIONS(321),
    [anon_sym_AT] = ACTIONS(324),
    [anon_sym_static] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(330),
    [anon_sym_get] = ACTIONS(327),
    [anon_sym_set] = ACTIONS(327),
    [anon_sym_declare] = ACTIONS(333),
    [anon_sym_public] = ACTIONS(327),
    [anon_sym_private] = ACTIONS(327),
    [anon_sym_protected] = ACTIONS(327),
    [anon_sym_module] = ACTIONS(336),
    [anon_sym_any] = ACTIONS(327),
    [anon_sym_number] = ACTIONS(327),
    [anon_sym_boolean] = ACTIONS(327),
    [anon_sym_string] = ACTIONS(327),
    [anon_sym_symbol] = ACTIONS(327),
    [anon_sym_interface] = ACTIONS(339),
    [anon_sym_enum] = ACTIONS(342),
    [sym_readonly] = ACTIONS(327),
  },
  [8] = {
    [sym_export_statement] = STATE(10),
    [sym__declaration] = STATE(10),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(347),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [9] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(349),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(351),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [10] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(353),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(353),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [11] = {
    [sym_export_statement] = STATE(9),
    [sym__declaration] = STATE(9),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(357),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(359),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(357),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [12] = {
    [sym_export_statement] = STATE(14),
    [sym__declaration] = STATE(14),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [13] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [14] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [15] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [ts_builtin_sym_end] = ACTIONS(367),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [16] = {
    [sym_export_statement] = STATE(21),
    [sym__declaration] = STATE(21),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(369),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [17] = {
    [sym_export_statement] = STATE(19),
    [sym__declaration] = STATE(19),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [18] = {
    [sym_export_statement] = STATE(13),
    [sym__declaration] = STATE(13),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(373),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [19] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [20] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(377),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [21] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [22] = {
    [sym_export_statement] = STATE(15),
    [sym__declaration] = STATE(15),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [ts_builtin_sym_end] = ACTIONS(381),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [23] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [24] = {
    [sym_export_statement] = STATE(23),
    [sym__declaration] = STATE(23),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(385),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [25] = {
    [sym_export_statement] = STATE(28),
    [sym__declaration] = STATE(28),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [26] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [ts_builtin_sym_end] = ACTIONS(381),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [27] = {
    [sym_export_statement] = STATE(20),
    [sym__declaration] = STATE(20),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [28] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [29] = {
    [sym_export_statement] = STATE(593),
    [sym__declaration] = STATE(593),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(593),
    [sym_expression_statement] = STATE(593),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(593),
    [sym_if_statement] = STATE(593),
    [sym_switch_statement] = STATE(593),
    [sym_for_statement] = STATE(593),
    [sym_for_in_statement] = STATE(593),
    [sym_while_statement] = STATE(593),
    [sym_do_statement] = STATE(593),
    [sym_try_statement] = STATE(593),
    [sym_with_statement] = STATE(593),
    [sym_break_statement] = STATE(593),
    [sym_continue_statement] = STATE(593),
    [sym_debugger_statement] = STATE(593),
    [sym_return_statement] = STATE(593),
    [sym_throw_statement] = STATE(593),
    [sym_empty_statement] = STATE(593),
    [sym_labeled_statement] = STATE(593),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [30] = {
    [sym_export_statement] = STATE(623),
    [sym__declaration] = STATE(623),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(623),
    [sym_expression_statement] = STATE(623),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(623),
    [sym_if_statement] = STATE(623),
    [sym_switch_statement] = STATE(623),
    [sym_for_statement] = STATE(623),
    [sym_for_in_statement] = STATE(623),
    [sym_while_statement] = STATE(623),
    [sym_do_statement] = STATE(623),
    [sym_try_statement] = STATE(623),
    [sym_with_statement] = STATE(623),
    [sym_break_statement] = STATE(623),
    [sym_continue_statement] = STATE(623),
    [sym_debugger_statement] = STATE(623),
    [sym_return_statement] = STATE(623),
    [sym_throw_statement] = STATE(623),
    [sym_empty_statement] = STATE(623),
    [sym_labeled_statement] = STATE(623),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2521),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [31] = {
    [sym_export_statement] = STATE(597),
    [sym__declaration] = STATE(597),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(597),
    [sym_expression_statement] = STATE(597),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(597),
    [sym_if_statement] = STATE(597),
    [sym_switch_statement] = STATE(597),
    [sym_for_statement] = STATE(597),
    [sym_for_in_statement] = STATE(597),
    [sym_while_statement] = STATE(597),
    [sym_do_statement] = STATE(597),
    [sym_try_statement] = STATE(597),
    [sym_with_statement] = STATE(597),
    [sym_break_statement] = STATE(597),
    [sym_continue_statement] = STATE(597),
    [sym_debugger_statement] = STATE(597),
    [sym_return_statement] = STATE(597),
    [sym_throw_statement] = STATE(597),
    [sym_empty_statement] = STATE(597),
    [sym_labeled_statement] = STATE(597),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [32] = {
    [sym_export_statement] = STATE(630),
    [sym__declaration] = STATE(630),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(630),
    [sym_expression_statement] = STATE(630),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(630),
    [sym_if_statement] = STATE(630),
    [sym_switch_statement] = STATE(630),
    [sym_for_statement] = STATE(630),
    [sym_for_in_statement] = STATE(630),
    [sym_while_statement] = STATE(630),
    [sym_do_statement] = STATE(630),
    [sym_try_statement] = STATE(630),
    [sym_with_statement] = STATE(630),
    [sym_break_statement] = STATE(630),
    [sym_continue_statement] = STATE(630),
    [sym_debugger_statement] = STATE(630),
    [sym_return_statement] = STATE(630),
    [sym_throw_statement] = STATE(630),
    [sym_empty_statement] = STATE(630),
    [sym_labeled_statement] = STATE(630),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2496),
    [sym_identifier] = ACTIONS(423),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_namespace] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(429),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(441),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(441),
    [anon_sym_set] = ACTIONS(441),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(441),
    [anon_sym_private] = ACTIONS(441),
    [anon_sym_protected] = ACTIONS(441),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_any] = ACTIONS(441),
    [anon_sym_number] = ACTIONS(441),
    [anon_sym_boolean] = ACTIONS(441),
    [anon_sym_string] = ACTIONS(441),
    [anon_sym_symbol] = ACTIONS(441),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(441),
  },
  [33] = {
    [sym_export_statement] = STATE(630),
    [sym__declaration] = STATE(630),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(630),
    [sym_expression_statement] = STATE(630),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(630),
    [sym_if_statement] = STATE(630),
    [sym_switch_statement] = STATE(630),
    [sym_for_statement] = STATE(630),
    [sym_for_in_statement] = STATE(630),
    [sym_while_statement] = STATE(630),
    [sym_do_statement] = STATE(630),
    [sym_try_statement] = STATE(630),
    [sym_with_statement] = STATE(630),
    [sym_break_statement] = STATE(630),
    [sym_continue_statement] = STATE(630),
    [sym_debugger_statement] = STATE(630),
    [sym_return_statement] = STATE(630),
    [sym_throw_statement] = STATE(630),
    [sym_empty_statement] = STATE(630),
    [sym_labeled_statement] = STATE(630),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2521),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [34] = {
    [sym_export_statement] = STATE(607),
    [sym__declaration] = STATE(607),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(607),
    [sym_expression_statement] = STATE(607),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(607),
    [sym_if_statement] = STATE(607),
    [sym_switch_statement] = STATE(607),
    [sym_for_statement] = STATE(607),
    [sym_for_in_statement] = STATE(607),
    [sym_while_statement] = STATE(607),
    [sym_do_statement] = STATE(607),
    [sym_try_statement] = STATE(607),
    [sym_with_statement] = STATE(607),
    [sym_break_statement] = STATE(607),
    [sym_continue_statement] = STATE(607),
    [sym_debugger_statement] = STATE(607),
    [sym_return_statement] = STATE(607),
    [sym_throw_statement] = STATE(607),
    [sym_empty_statement] = STATE(607),
    [sym_labeled_statement] = STATE(607),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2521),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [35] = {
    [sym_export_statement] = STATE(607),
    [sym__declaration] = STATE(607),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(607),
    [sym_expression_statement] = STATE(607),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(607),
    [sym_if_statement] = STATE(607),
    [sym_switch_statement] = STATE(607),
    [sym_for_statement] = STATE(607),
    [sym_for_in_statement] = STATE(607),
    [sym_while_statement] = STATE(607),
    [sym_do_statement] = STATE(607),
    [sym_try_statement] = STATE(607),
    [sym_with_statement] = STATE(607),
    [sym_break_statement] = STATE(607),
    [sym_continue_statement] = STATE(607),
    [sym_debugger_statement] = STATE(607),
    [sym_return_statement] = STATE(607),
    [sym_throw_statement] = STATE(607),
    [sym_empty_statement] = STATE(607),
    [sym_labeled_statement] = STATE(607),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2496),
    [sym_identifier] = ACTIONS(423),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_namespace] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(429),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(441),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(441),
    [anon_sym_set] = ACTIONS(441),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(441),
    [anon_sym_private] = ACTIONS(441),
    [anon_sym_protected] = ACTIONS(441),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_any] = ACTIONS(441),
    [anon_sym_number] = ACTIONS(441),
    [anon_sym_boolean] = ACTIONS(441),
    [anon_sym_string] = ACTIONS(441),
    [anon_sym_symbol] = ACTIONS(441),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(441),
  },
  [36] = {
    [sym_export_statement] = STATE(615),
    [sym__declaration] = STATE(615),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(615),
    [sym_expression_statement] = STATE(615),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(615),
    [sym_if_statement] = STATE(615),
    [sym_switch_statement] = STATE(615),
    [sym_for_statement] = STATE(615),
    [sym_for_in_statement] = STATE(615),
    [sym_while_statement] = STATE(615),
    [sym_do_statement] = STATE(615),
    [sym_try_statement] = STATE(615),
    [sym_with_statement] = STATE(615),
    [sym_break_statement] = STATE(615),
    [sym_continue_statement] = STATE(615),
    [sym_debugger_statement] = STATE(615),
    [sym_return_statement] = STATE(615),
    [sym_throw_statement] = STATE(615),
    [sym_empty_statement] = STATE(615),
    [sym_labeled_statement] = STATE(615),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [37] = {
    [sym_export_statement] = STATE(615),
    [sym__declaration] = STATE(615),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(615),
    [sym_expression_statement] = STATE(615),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(615),
    [sym_if_statement] = STATE(615),
    [sym_switch_statement] = STATE(615),
    [sym_for_statement] = STATE(615),
    [sym_for_in_statement] = STATE(615),
    [sym_while_statement] = STATE(615),
    [sym_do_statement] = STATE(615),
    [sym_try_statement] = STATE(615),
    [sym_with_statement] = STATE(615),
    [sym_break_statement] = STATE(615),
    [sym_continue_statement] = STATE(615),
    [sym_debugger_statement] = STATE(615),
    [sym_return_statement] = STATE(615),
    [sym_throw_statement] = STATE(615),
    [sym_empty_statement] = STATE(615),
    [sym_labeled_statement] = STATE(615),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2496),
    [sym_identifier] = ACTIONS(423),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_namespace] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(429),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(441),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(441),
    [anon_sym_set] = ACTIONS(441),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(441),
    [anon_sym_private] = ACTIONS(441),
    [anon_sym_protected] = ACTIONS(441),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_any] = ACTIONS(441),
    [anon_sym_number] = ACTIONS(441),
    [anon_sym_boolean] = ACTIONS(441),
    [anon_sym_string] = ACTIONS(441),
    [anon_sym_symbol] = ACTIONS(441),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(441),
  },
  [38] = {
    [sym_export_statement] = STATE(593),
    [sym__declaration] = STATE(593),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(593),
    [sym_expression_statement] = STATE(593),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(593),
    [sym_if_statement] = STATE(593),
    [sym_switch_statement] = STATE(593),
    [sym_for_statement] = STATE(593),
    [sym_for_in_statement] = STATE(593),
    [sym_while_statement] = STATE(593),
    [sym_do_statement] = STATE(593),
    [sym_try_statement] = STATE(593),
    [sym_with_statement] = STATE(593),
    [sym_break_statement] = STATE(593),
    [sym_continue_statement] = STATE(593),
    [sym_debugger_statement] = STATE(593),
    [sym_return_statement] = STATE(593),
    [sym_throw_statement] = STATE(593),
    [sym_empty_statement] = STATE(593),
    [sym_labeled_statement] = STATE(593),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2496),
    [sym_identifier] = ACTIONS(423),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_namespace] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(429),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(441),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(441),
    [anon_sym_set] = ACTIONS(441),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(441),
    [anon_sym_private] = ACTIONS(441),
    [anon_sym_protected] = ACTIONS(441),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_any] = ACTIONS(441),
    [anon_sym_number] = ACTIONS(441),
    [anon_sym_boolean] = ACTIONS(441),
    [anon_sym_string] = ACTIONS(441),
    [anon_sym_symbol] = ACTIONS(441),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(441),
  },
  [39] = {
    [sym_export_statement] = STATE(623),
    [sym__declaration] = STATE(623),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(623),
    [sym_expression_statement] = STATE(623),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(623),
    [sym_if_statement] = STATE(623),
    [sym_switch_statement] = STATE(623),
    [sym_for_statement] = STATE(623),
    [sym_for_in_statement] = STATE(623),
    [sym_while_statement] = STATE(623),
    [sym_do_statement] = STATE(623),
    [sym_try_statement] = STATE(623),
    [sym_with_statement] = STATE(623),
    [sym_break_statement] = STATE(623),
    [sym_continue_statement] = STATE(623),
    [sym_debugger_statement] = STATE(623),
    [sym_return_statement] = STATE(623),
    [sym_throw_statement] = STATE(623),
    [sym_empty_statement] = STATE(623),
    [sym_labeled_statement] = STATE(623),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [40] = {
    [sym_export_statement] = STATE(544),
    [sym__declaration] = STATE(544),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(544),
    [sym_expression_statement] = STATE(544),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(544),
    [sym_if_statement] = STATE(544),
    [sym_switch_statement] = STATE(544),
    [sym_for_statement] = STATE(544),
    [sym_for_in_statement] = STATE(544),
    [sym_while_statement] = STATE(544),
    [sym_do_statement] = STATE(544),
    [sym_try_statement] = STATE(544),
    [sym_with_statement] = STATE(544),
    [sym_break_statement] = STATE(544),
    [sym_continue_statement] = STATE(544),
    [sym_debugger_statement] = STATE(544),
    [sym_return_statement] = STATE(544),
    [sym_throw_statement] = STATE(544),
    [sym_empty_statement] = STATE(544),
    [sym_labeled_statement] = STATE(544),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [41] = {
    [sym_export_statement] = STATE(615),
    [sym__declaration] = STATE(615),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(615),
    [sym_expression_statement] = STATE(615),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(615),
    [sym_if_statement] = STATE(615),
    [sym_switch_statement] = STATE(615),
    [sym_for_statement] = STATE(615),
    [sym_for_in_statement] = STATE(615),
    [sym_while_statement] = STATE(615),
    [sym_do_statement] = STATE(615),
    [sym_try_statement] = STATE(615),
    [sym_with_statement] = STATE(615),
    [sym_break_statement] = STATE(615),
    [sym_continue_statement] = STATE(615),
    [sym_debugger_statement] = STATE(615),
    [sym_return_statement] = STATE(615),
    [sym_throw_statement] = STATE(615),
    [sym_empty_statement] = STATE(615),
    [sym_labeled_statement] = STATE(615),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2521),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [42] = {
    [sym_export_statement] = STATE(3068),
    [sym__declaration] = STATE(3068),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(3068),
    [sym_expression_statement] = STATE(3068),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(3068),
    [sym_if_statement] = STATE(3068),
    [sym_switch_statement] = STATE(3068),
    [sym_for_statement] = STATE(3068),
    [sym_for_in_statement] = STATE(3068),
    [sym_while_statement] = STATE(3068),
    [sym_do_statement] = STATE(3068),
    [sym_try_statement] = STATE(3068),
    [sym_with_statement] = STATE(3068),
    [sym_break_statement] = STATE(3068),
    [sym_continue_statement] = STATE(3068),
    [sym_debugger_statement] = STATE(3068),
    [sym_return_statement] = STATE(3068),
    [sym_throw_statement] = STATE(3068),
    [sym_empty_statement] = STATE(3068),
    [sym_labeled_statement] = STATE(3068),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2521),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [43] = {
    [sym_export_statement] = STATE(565),
    [sym__declaration] = STATE(565),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(565),
    [sym_expression_statement] = STATE(565),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(565),
    [sym_if_statement] = STATE(565),
    [sym_switch_statement] = STATE(565),
    [sym_for_statement] = STATE(565),
    [sym_for_in_statement] = STATE(565),
    [sym_while_statement] = STATE(565),
    [sym_do_statement] = STATE(565),
    [sym_try_statement] = STATE(565),
    [sym_with_statement] = STATE(565),
    [sym_break_statement] = STATE(565),
    [sym_continue_statement] = STATE(565),
    [sym_debugger_statement] = STATE(565),
    [sym_return_statement] = STATE(565),
    [sym_throw_statement] = STATE(565),
    [sym_empty_statement] = STATE(565),
    [sym_labeled_statement] = STATE(565),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [44] = {
    [sym_export_statement] = STATE(593),
    [sym__declaration] = STATE(593),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(593),
    [sym_expression_statement] = STATE(593),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(593),
    [sym_if_statement] = STATE(593),
    [sym_switch_statement] = STATE(593),
    [sym_for_statement] = STATE(593),
    [sym_for_in_statement] = STATE(593),
    [sym_while_statement] = STATE(593),
    [sym_do_statement] = STATE(593),
    [sym_try_statement] = STATE(593),
    [sym_with_statement] = STATE(593),
    [sym_break_statement] = STATE(593),
    [sym_continue_statement] = STATE(593),
    [sym_debugger_statement] = STATE(593),
    [sym_return_statement] = STATE(593),
    [sym_throw_statement] = STATE(593),
    [sym_empty_statement] = STATE(593),
    [sym_labeled_statement] = STATE(593),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2521),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [45] = {
    [sym_export_statement] = STATE(630),
    [sym__declaration] = STATE(630),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(630),
    [sym_expression_statement] = STATE(630),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(630),
    [sym_if_statement] = STATE(630),
    [sym_switch_statement] = STATE(630),
    [sym_for_statement] = STATE(630),
    [sym_for_in_statement] = STATE(630),
    [sym_while_statement] = STATE(630),
    [sym_do_statement] = STATE(630),
    [sym_try_statement] = STATE(630),
    [sym_with_statement] = STATE(630),
    [sym_break_statement] = STATE(630),
    [sym_continue_statement] = STATE(630),
    [sym_debugger_statement] = STATE(630),
    [sym_return_statement] = STATE(630),
    [sym_throw_statement] = STATE(630),
    [sym_empty_statement] = STATE(630),
    [sym_labeled_statement] = STATE(630),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [46] = {
    [sym_export_statement] = STATE(565),
    [sym__declaration] = STATE(565),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(565),
    [sym_expression_statement] = STATE(565),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(565),
    [sym_if_statement] = STATE(565),
    [sym_switch_statement] = STATE(565),
    [sym_for_statement] = STATE(565),
    [sym_for_in_statement] = STATE(565),
    [sym_while_statement] = STATE(565),
    [sym_do_statement] = STATE(565),
    [sym_try_statement] = STATE(565),
    [sym_with_statement] = STATE(565),
    [sym_break_statement] = STATE(565),
    [sym_continue_statement] = STATE(565),
    [sym_debugger_statement] = STATE(565),
    [sym_return_statement] = STATE(565),
    [sym_throw_statement] = STATE(565),
    [sym_empty_statement] = STATE(565),
    [sym_labeled_statement] = STATE(565),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2496),
    [sym_identifier] = ACTIONS(423),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_namespace] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(429),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(441),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(441),
    [anon_sym_set] = ACTIONS(441),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(441),
    [anon_sym_private] = ACTIONS(441),
    [anon_sym_protected] = ACTIONS(441),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_any] = ACTIONS(441),
    [anon_sym_number] = ACTIONS(441),
    [anon_sym_boolean] = ACTIONS(441),
    [anon_sym_string] = ACTIONS(441),
    [anon_sym_symbol] = ACTIONS(441),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(441),
  },
  [47] = {
    [sym_export_statement] = STATE(607),
    [sym__declaration] = STATE(607),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(607),
    [sym_expression_statement] = STATE(607),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(607),
    [sym_if_statement] = STATE(607),
    [sym_switch_statement] = STATE(607),
    [sym_for_statement] = STATE(607),
    [sym_for_in_statement] = STATE(607),
    [sym_while_statement] = STATE(607),
    [sym_do_statement] = STATE(607),
    [sym_try_statement] = STATE(607),
    [sym_with_statement] = STATE(607),
    [sym_break_statement] = STATE(607),
    [sym_continue_statement] = STATE(607),
    [sym_debugger_statement] = STATE(607),
    [sym_return_statement] = STATE(607),
    [sym_throw_statement] = STATE(607),
    [sym_empty_statement] = STATE(607),
    [sym_labeled_statement] = STATE(607),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [48] = {
    [sym_export_statement] = STATE(565),
    [sym__declaration] = STATE(565),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(565),
    [sym_expression_statement] = STATE(565),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(565),
    [sym_if_statement] = STATE(565),
    [sym_switch_statement] = STATE(565),
    [sym_for_statement] = STATE(565),
    [sym_for_in_statement] = STATE(565),
    [sym_while_statement] = STATE(565),
    [sym_do_statement] = STATE(565),
    [sym_try_statement] = STATE(565),
    [sym_with_statement] = STATE(565),
    [sym_break_statement] = STATE(565),
    [sym_continue_statement] = STATE(565),
    [sym_debugger_statement] = STATE(565),
    [sym_return_statement] = STATE(565),
    [sym_throw_statement] = STATE(565),
    [sym_empty_statement] = STATE(565),
    [sym_labeled_statement] = STATE(565),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2521),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [49] = {
    [sym_export_statement] = STATE(597),
    [sym__declaration] = STATE(597),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(597),
    [sym_expression_statement] = STATE(597),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(597),
    [sym_if_statement] = STATE(597),
    [sym_switch_statement] = STATE(597),
    [sym_for_statement] = STATE(597),
    [sym_for_in_statement] = STATE(597),
    [sym_while_statement] = STATE(597),
    [sym_do_statement] = STATE(597),
    [sym_try_statement] = STATE(597),
    [sym_with_statement] = STATE(597),
    [sym_break_statement] = STATE(597),
    [sym_continue_statement] = STATE(597),
    [sym_debugger_statement] = STATE(597),
    [sym_return_statement] = STATE(597),
    [sym_throw_statement] = STATE(597),
    [sym_empty_statement] = STATE(597),
    [sym_labeled_statement] = STATE(597),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2521),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [50] = {
    [sym_export_statement] = STATE(623),
    [sym__declaration] = STATE(623),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(623),
    [sym_expression_statement] = STATE(623),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(623),
    [sym_if_statement] = STATE(623),
    [sym_switch_statement] = STATE(623),
    [sym_for_statement] = STATE(623),
    [sym_for_in_statement] = STATE(623),
    [sym_while_statement] = STATE(623),
    [sym_do_statement] = STATE(623),
    [sym_try_statement] = STATE(623),
    [sym_with_statement] = STATE(623),
    [sym_break_statement] = STATE(623),
    [sym_continue_statement] = STATE(623),
    [sym_debugger_statement] = STATE(623),
    [sym_return_statement] = STATE(623),
    [sym_throw_statement] = STATE(623),
    [sym_empty_statement] = STATE(623),
    [sym_labeled_statement] = STATE(623),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2496),
    [sym_identifier] = ACTIONS(423),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_namespace] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(429),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(441),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(441),
    [anon_sym_set] = ACTIONS(441),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(441),
    [anon_sym_private] = ACTIONS(441),
    [anon_sym_protected] = ACTIONS(441),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_any] = ACTIONS(441),
    [anon_sym_number] = ACTIONS(441),
    [anon_sym_boolean] = ACTIONS(441),
    [anon_sym_string] = ACTIONS(441),
    [anon_sym_symbol] = ACTIONS(441),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(441),
  },
  [51] = {
    [sym_export_statement] = STATE(608),
    [sym__declaration] = STATE(608),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(608),
    [sym_expression_statement] = STATE(608),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(608),
    [sym_if_statement] = STATE(608),
    [sym_switch_statement] = STATE(608),
    [sym_for_statement] = STATE(608),
    [sym_for_in_statement] = STATE(608),
    [sym_while_statement] = STATE(608),
    [sym_do_statement] = STATE(608),
    [sym_try_statement] = STATE(608),
    [sym_with_statement] = STATE(608),
    [sym_break_statement] = STATE(608),
    [sym_continue_statement] = STATE(608),
    [sym_debugger_statement] = STATE(608),
    [sym_return_statement] = STATE(608),
    [sym_throw_statement] = STATE(608),
    [sym_empty_statement] = STATE(608),
    [sym_labeled_statement] = STATE(608),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2496),
    [sym_identifier] = ACTIONS(423),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_namespace] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(429),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(441),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(441),
    [anon_sym_set] = ACTIONS(441),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(441),
    [anon_sym_private] = ACTIONS(441),
    [anon_sym_protected] = ACTIONS(441),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_any] = ACTIONS(441),
    [anon_sym_number] = ACTIONS(441),
    [anon_sym_boolean] = ACTIONS(441),
    [anon_sym_string] = ACTIONS(441),
    [anon_sym_symbol] = ACTIONS(441),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(441),
  },
  [52] = {
    [sym_export_statement] = STATE(608),
    [sym__declaration] = STATE(608),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(608),
    [sym_expression_statement] = STATE(608),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(608),
    [sym_if_statement] = STATE(608),
    [sym_switch_statement] = STATE(608),
    [sym_for_statement] = STATE(608),
    [sym_for_in_statement] = STATE(608),
    [sym_while_statement] = STATE(608),
    [sym_do_statement] = STATE(608),
    [sym_try_statement] = STATE(608),
    [sym_with_statement] = STATE(608),
    [sym_break_statement] = STATE(608),
    [sym_continue_statement] = STATE(608),
    [sym_debugger_statement] = STATE(608),
    [sym_return_statement] = STATE(608),
    [sym_throw_statement] = STATE(608),
    [sym_empty_statement] = STATE(608),
    [sym_labeled_statement] = STATE(608),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2521),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [53] = {
    [sym_export_statement] = STATE(597),
    [sym__declaration] = STATE(597),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(597),
    [sym_expression_statement] = STATE(597),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(597),
    [sym_if_statement] = STATE(597),
    [sym_switch_statement] = STATE(597),
    [sym_for_statement] = STATE(597),
    [sym_for_in_statement] = STATE(597),
    [sym_while_statement] = STATE(597),
    [sym_do_statement] = STATE(597),
    [sym_try_statement] = STATE(597),
    [sym_with_statement] = STATE(597),
    [sym_break_statement] = STATE(597),
    [sym_continue_statement] = STATE(597),
    [sym_debugger_statement] = STATE(597),
    [sym_return_statement] = STATE(597),
    [sym_throw_statement] = STATE(597),
    [sym_empty_statement] = STATE(597),
    [sym_labeled_statement] = STATE(597),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2496),
    [sym_identifier] = ACTIONS(423),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_namespace] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(429),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(441),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(441),
    [anon_sym_set] = ACTIONS(441),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(441),
    [anon_sym_private] = ACTIONS(441),
    [anon_sym_protected] = ACTIONS(441),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_any] = ACTIONS(441),
    [anon_sym_number] = ACTIONS(441),
    [anon_sym_boolean] = ACTIONS(441),
    [anon_sym_string] = ACTIONS(441),
    [anon_sym_symbol] = ACTIONS(441),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(441),
  },
  [54] = {
    [sym_export_statement] = STATE(608),
    [sym__declaration] = STATE(608),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(608),
    [sym_expression_statement] = STATE(608),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(608),
    [sym_if_statement] = STATE(608),
    [sym_switch_statement] = STATE(608),
    [sym_for_statement] = STATE(608),
    [sym_for_in_statement] = STATE(608),
    [sym_while_statement] = STATE(608),
    [sym_do_statement] = STATE(608),
    [sym_try_statement] = STATE(608),
    [sym_with_statement] = STATE(608),
    [sym_break_statement] = STATE(608),
    [sym_continue_statement] = STATE(608),
    [sym_debugger_statement] = STATE(608),
    [sym_return_statement] = STATE(608),
    [sym_throw_statement] = STATE(608),
    [sym_empty_statement] = STATE(608),
    [sym_labeled_statement] = STATE(608),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(86),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2518),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(97),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(99),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(93),
  },
  [55] = {
    [sym_export_statement] = STATE(3113),
    [sym__declaration] = STATE(3113),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(3113),
    [sym_expression_statement] = STATE(3113),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(3113),
    [sym_if_statement] = STATE(3113),
    [sym_switch_statement] = STATE(3113),
    [sym_for_statement] = STATE(3113),
    [sym_for_in_statement] = STATE(3113),
    [sym_while_statement] = STATE(3113),
    [sym_do_statement] = STATE(3113),
    [sym_try_statement] = STATE(3113),
    [sym_with_statement] = STATE(3113),
    [sym_break_statement] = STATE(3113),
    [sym_continue_statement] = STATE(3113),
    [sym_debugger_statement] = STATE(3113),
    [sym_return_statement] = STATE(3113),
    [sym_throw_statement] = STATE(3113),
    [sym_empty_statement] = STATE(3113),
    [sym_labeled_statement] = STATE(3113),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2521),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_export] = ACTIONS(395),
    [anon_sym_namespace] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(409),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(417),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(417),
    [anon_sym_set] = ACTIONS(417),
    [anon_sym_declare] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(421),
    [anon_sym_any] = ACTIONS(417),
    [anon_sym_number] = ACTIONS(417),
    [anon_sym_boolean] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_symbol] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(417),
  },
  [56] = {
    [sym_export_statement] = STATE(3537),
    [sym__declaration] = STATE(3537),
    [sym_import] = STATE(1569),
    [sym_import_statement] = STATE(3537),
    [sym_expression_statement] = STATE(3537),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(3537),
    [sym_if_statement] = STATE(3537),
    [sym_switch_statement] = STATE(3537),
    [sym_for_statement] = STATE(3537),
    [sym_for_in_statement] = STATE(3537),
    [sym_while_statement] = STATE(3537),
    [sym_do_statement] = STATE(3537),
    [sym_try_statement] = STATE(3537),
    [sym_with_statement] = STATE(3537),
    [sym_break_statement] = STATE(3537),
    [sym_continue_statement] = STATE(3537),
    [sym_debugger_statement] = STATE(3537),
    [sym_return_statement] = STATE(3537),
    [sym_throw_statement] = STATE(3537),
    [sym_empty_statement] = STATE(3537),
    [sym_labeled_statement] = STATE(3537),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1569),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1569),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_function_signature] = STATE(627),
    [sym_as_expression] = STATE(1581),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(1439),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2496),
    [sym_identifier] = ACTIONS(423),
    [anon_sym_export] = ACTIONS(425),
    [anon_sym_namespace] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(429),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(415),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(441),
    [anon_sym_abstract] = ACTIONS(95),
    [anon_sym_get] = ACTIONS(441),
    [anon_sym_set] = ACTIONS(441),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(441),
    [anon_sym_private] = ACTIONS(441),
    [anon_sym_protected] = ACTIONS(441),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_any] = ACTIONS(441),
    [anon_sym_number] = ACTIONS(441),
    [anon_sym_boolean] = ACTIONS(441),
    [anon_sym_string] = ACTIONS(441),
    [anon_sym_symbol] = ACTIONS(441),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
    [sym_readonly] = ACTIONS(441),
  },
  [57] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1275),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1626),
    [sym_array] = STATE(1651),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(3514),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3543),
    [sym_string] = STATE(1725),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2574),
    [sym_rest_parameter] = STATE(2999),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(2023),
    [sym_accessibility_modifier] = STATE(2015),
    [sym_required_parameter] = STATE(2999),
    [sym_optional_parameter] = STATE(2999),
    [sym__parameter_name] = STATE(2342),
    [sym__rest_identifier] = STATE(2829),
    [sym__type] = STATE(2832),
    [sym_constructor_type] = STATE(2832),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2832),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3251),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2832),
    [sym_intersection_type] = STATE(2832),
    [sym_function_type] = STATE(2832),
    [aux_sym_export_statement_repeat1] = STATE(1872),
    [sym_identifier] = ACTIONS(447),
    [anon_sym_export] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(449),
    [anon_sym_typeof] = ACTIONS(457),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(479),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_QMARK] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(495),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(507),
    [sym_this] = ACTIONS(509),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(513),
    [sym_false] = ACTIONS(513),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_get] = ACTIONS(449),
    [anon_sym_set] = ACTIONS(449),
    [anon_sym_declare] = ACTIONS(449),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(449),
    [anon_sym_any] = ACTIONS(517),
    [anon_sym_number] = ACTIONS(517),
    [anon_sym_boolean] = ACTIONS(517),
    [anon_sym_string] = ACTIONS(517),
    [anon_sym_symbol] = ACTIONS(517),
    [sym_readonly] = ACTIONS(519),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [58] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1278),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1626),
    [sym_array] = STATE(1651),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(3514),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3472),
    [sym_string] = STATE(1725),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2574),
    [sym_rest_parameter] = STATE(2999),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(2023),
    [sym_accessibility_modifier] = STATE(2015),
    [sym_required_parameter] = STATE(2999),
    [sym_optional_parameter] = STATE(2999),
    [sym__parameter_name] = STATE(2342),
    [sym__rest_identifier] = STATE(2829),
    [sym__type] = STATE(2867),
    [sym_constructor_type] = STATE(2867),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2867),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3251),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2867),
    [sym_intersection_type] = STATE(2867),
    [sym_function_type] = STATE(2867),
    [aux_sym_export_statement_repeat1] = STATE(1872),
    [sym_identifier] = ACTIONS(447),
    [anon_sym_export] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(449),
    [anon_sym_typeof] = ACTIONS(457),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(479),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_QMARK] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(495),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(507),
    [sym_this] = ACTIONS(509),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(513),
    [sym_false] = ACTIONS(513),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_get] = ACTIONS(449),
    [anon_sym_set] = ACTIONS(449),
    [anon_sym_declare] = ACTIONS(449),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(449),
    [anon_sym_any] = ACTIONS(517),
    [anon_sym_number] = ACTIONS(517),
    [anon_sym_boolean] = ACTIONS(517),
    [anon_sym_string] = ACTIONS(517),
    [anon_sym_symbol] = ACTIONS(517),
    [sym_readonly] = ACTIONS(519),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [59] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1264),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1626),
    [sym_array] = STATE(1651),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(3514),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3527),
    [sym_string] = STATE(1725),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2574),
    [sym_rest_parameter] = STATE(2999),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(2023),
    [sym_accessibility_modifier] = STATE(2015),
    [sym_required_parameter] = STATE(2999),
    [sym_optional_parameter] = STATE(2999),
    [sym__parameter_name] = STATE(2342),
    [sym__rest_identifier] = STATE(2829),
    [sym__type] = STATE(2832),
    [sym_constructor_type] = STATE(2832),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2832),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3251),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2832),
    [sym_intersection_type] = STATE(2832),
    [sym_function_type] = STATE(2832),
    [aux_sym_export_statement_repeat1] = STATE(1872),
    [sym_identifier] = ACTIONS(447),
    [anon_sym_export] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(449),
    [anon_sym_typeof] = ACTIONS(457),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(479),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_QMARK] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(495),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(507),
    [sym_this] = ACTIONS(509),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(513),
    [sym_false] = ACTIONS(513),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_get] = ACTIONS(449),
    [anon_sym_set] = ACTIONS(449),
    [anon_sym_declare] = ACTIONS(449),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(449),
    [anon_sym_any] = ACTIONS(517),
    [anon_sym_number] = ACTIONS(517),
    [anon_sym_boolean] = ACTIONS(517),
    [anon_sym_string] = ACTIONS(517),
    [anon_sym_symbol] = ACTIONS(517),
    [sym_readonly] = ACTIONS(519),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [60] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1278),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1626),
    [sym_array] = STATE(1651),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(3514),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3472),
    [sym_string] = STATE(1725),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2574),
    [sym_rest_parameter] = STATE(2999),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(2023),
    [sym_accessibility_modifier] = STATE(2015),
    [sym_required_parameter] = STATE(2999),
    [sym_optional_parameter] = STATE(2999),
    [sym__parameter_name] = STATE(2342),
    [sym__rest_identifier] = STATE(2829),
    [sym__type] = STATE(2832),
    [sym_constructor_type] = STATE(2832),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2832),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3251),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2832),
    [sym_intersection_type] = STATE(2832),
    [sym_function_type] = STATE(2832),
    [aux_sym_export_statement_repeat1] = STATE(1872),
    [sym_identifier] = ACTIONS(447),
    [anon_sym_export] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(449),
    [anon_sym_typeof] = ACTIONS(457),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(479),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_QMARK] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(495),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(507),
    [sym_this] = ACTIONS(509),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(513),
    [sym_false] = ACTIONS(513),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_get] = ACTIONS(449),
    [anon_sym_set] = ACTIONS(449),
    [anon_sym_declare] = ACTIONS(449),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(449),
    [anon_sym_any] = ACTIONS(517),
    [anon_sym_number] = ACTIONS(517),
    [anon_sym_boolean] = ACTIONS(517),
    [anon_sym_string] = ACTIONS(517),
    [anon_sym_symbol] = ACTIONS(517),
    [sym_readonly] = ACTIONS(519),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [61] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1390),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_nested_identifier] = STATE(3514),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1629),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2772),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(2471),
    [sym_constructor_type] = STATE(2471),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2471),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(2390),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3326),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2471),
    [sym_intersection_type] = STATE(2471),
    [sym_function_type] = STATE(2471),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(527),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(535),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(541),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(547),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(569),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [sym_this] = ACTIONS(583),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(589),
    [anon_sym_number] = ACTIONS(589),
    [anon_sym_boolean] = ACTIONS(589),
    [anon_sym_string] = ACTIONS(589),
    [anon_sym_symbol] = ACTIONS(589),
    [sym_readonly] = ACTIONS(591),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [62] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1092),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(3514),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1094),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2772),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(2471),
    [sym_constructor_type] = STATE(2471),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2471),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(2390),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3326),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2471),
    [sym_intersection_type] = STATE(2471),
    [sym_function_type] = STATE(2471),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(593),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(599),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(601),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(463),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(607),
    [anon_sym_QMARK] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(609),
    [anon_sym_DASH] = ACTIONS(609),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(495),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(611),
    [sym_this] = ACTIONS(613),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(617),
    [anon_sym_number] = ACTIONS(617),
    [anon_sym_boolean] = ACTIONS(617),
    [anon_sym_string] = ACTIONS(617),
    [anon_sym_symbol] = ACTIONS(617),
    [sym_readonly] = ACTIONS(619),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [63] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1436),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_nested_identifier] = STATE(3514),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1708),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2772),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(2471),
    [sym_constructor_type] = STATE(2471),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2471),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(2390),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3326),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2471),
    [sym_intersection_type] = STATE(2471),
    [sym_function_type] = STATE(2471),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(629),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(635),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(649),
    [anon_sym_QMARK] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(653),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(659),
    [sym_this] = ACTIONS(661),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(663),
    [sym_false] = ACTIONS(663),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(665),
    [anon_sym_number] = ACTIONS(665),
    [anon_sym_boolean] = ACTIONS(665),
    [anon_sym_string] = ACTIONS(665),
    [anon_sym_symbol] = ACTIONS(665),
    [sym_readonly] = ACTIONS(667),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [64] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1468),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(3415),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1298),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2735),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(2053),
    [sym__type] = STATE(2134),
    [sym_constructor_type] = STATE(2134),
    [sym__primary_type] = STATE(2130),
    [sym_infer_type] = STATE(2134),
    [sym_conditional_type] = STATE(2130),
    [sym_generic_type] = STATE(2130),
    [sym_type_query] = STATE(2130),
    [sym_index_type_query] = STATE(2130),
    [sym_lookup_type] = STATE(2130),
    [sym_literal_type] = STATE(2130),
    [sym__number] = STATE(2106),
    [sym_existential_type] = STATE(2130),
    [sym_flow_maybe_type] = STATE(2130),
    [sym_parenthesized_type] = STATE(2130),
    [sym_predefined_type] = STATE(2130),
    [sym_object_type] = STATE(2130),
    [sym_type_parameters] = STATE(3377),
    [sym_array_type] = STATE(2130),
    [sym__tuple_type_body] = STATE(2129),
    [sym_tuple_type] = STATE(2130),
    [sym_union_type] = STATE(2134),
    [sym_intersection_type] = STATE(2134),
    [sym_function_type] = STATE(2134),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(675),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(677),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(681),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(685),
    [anon_sym_PIPE] = ACTIONS(687),
    [anon_sym_PLUS] = ACTIONS(689),
    [anon_sym_DASH] = ACTIONS(689),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(693),
    [sym_this] = ACTIONS(695),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(697),
    [sym_false] = ACTIONS(697),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(699),
    [anon_sym_number] = ACTIONS(699),
    [anon_sym_boolean] = ACTIONS(699),
    [anon_sym_string] = ACTIONS(699),
    [anon_sym_symbol] = ACTIONS(699),
    [sym_readonly] = ACTIONS(701),
    [anon_sym_infer] = ACTIONS(703),
    [anon_sym_keyof] = ACTIONS(705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(707),
  },
  [65] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1365),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(3514),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1531),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2772),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(2471),
    [sym_constructor_type] = STATE(2471),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2471),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(2390),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3326),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2471),
    [sym_intersection_type] = STATE(2471),
    [sym_function_type] = STATE(2471),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(709),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(599),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(715),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(463),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_QMARK] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(729),
    [anon_sym_DASH] = ACTIONS(729),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(731),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(743),
    [anon_sym_number] = ACTIONS(743),
    [anon_sym_boolean] = ACTIONS(743),
    [anon_sym_string] = ACTIONS(743),
    [anon_sym_symbol] = ACTIONS(743),
    [sym_readonly] = ACTIONS(745),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [66] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1316),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(3514),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1094),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2772),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(2471),
    [sym_constructor_type] = STATE(2471),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2471),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(2390),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3326),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2471),
    [sym_intersection_type] = STATE(2471),
    [sym_function_type] = STATE(2471),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(747),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(599),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(753),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(463),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(765),
    [anon_sym_QMARK] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(769),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(611),
    [sym_this] = ACTIONS(613),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(775),
    [anon_sym_number] = ACTIONS(775),
    [anon_sym_boolean] = ACTIONS(775),
    [anon_sym_string] = ACTIONS(775),
    [anon_sym_symbol] = ACTIONS(775),
    [sym_readonly] = ACTIONS(777),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [67] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1276),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_nested_identifier] = STATE(3514),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1479),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2772),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(2471),
    [sym_constructor_type] = STATE(2471),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2471),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(2390),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3326),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2471),
    [sym_intersection_type] = STATE(2471),
    [sym_function_type] = STATE(2471),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(779),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(785),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(635),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(791),
    [anon_sym_QMARK] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(795),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(797),
    [sym_this] = ACTIONS(799),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(801),
    [sym_false] = ACTIONS(801),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(803),
    [anon_sym_number] = ACTIONS(803),
    [anon_sym_boolean] = ACTIONS(803),
    [anon_sym_string] = ACTIONS(803),
    [anon_sym_symbol] = ACTIONS(803),
    [sym_readonly] = ACTIONS(805),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [68] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1142),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_STAR] = ACTIONS(809),
    [anon_sym_as] = ACTIONS(811),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(815),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_in] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(811),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_QMARK_DOT] = ACTIONS(815),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(811),
    [anon_sym_GT_GT_GT] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(811),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_PERCENT] = ACTIONS(815),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_QMARK_QMARK] = ACTIONS(815),
    [anon_sym_instanceof] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [69] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1283),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_as] = ACTIONS(811),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_in] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(811),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_QMARK_DOT] = ACTIONS(815),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(811),
    [anon_sym_GT_GT_GT] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(811),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(815),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_QMARK_QMARK] = ACTIONS(815),
    [anon_sym_instanceof] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
    [sym__automatic_semicolon] = ACTIONS(815),
  },
  [70] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1337),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_STAR] = ACTIONS(843),
    [anon_sym_as] = ACTIONS(811),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_in] = ACTIONS(811),
    [anon_sym_COLON] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(811),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_QMARK_DOT] = ACTIONS(815),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(811),
    [anon_sym_GT_GT_GT] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(811),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_PERCENT] = ACTIONS(815),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_QMARK_QMARK] = ACTIONS(815),
    [anon_sym_instanceof] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [71] = {
    [sym_object] = STATE(2624),
    [sym_array] = STATE(2621),
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_formal_parameters] = STATE(3565),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(3018),
    [sym_constructor_type] = STATE(3018),
    [sym__primary_type] = STATE(2823),
    [sym_infer_type] = STATE(3018),
    [sym_conditional_type] = STATE(2823),
    [sym_generic_type] = STATE(2823),
    [sym_type_query] = STATE(2823),
    [sym_index_type_query] = STATE(2823),
    [sym_lookup_type] = STATE(2823),
    [sym_literal_type] = STATE(2823),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(2823),
    [sym_flow_maybe_type] = STATE(2823),
    [sym_parenthesized_type] = STATE(2823),
    [sym_predefined_type] = STATE(2823),
    [sym_object_type] = STATE(2823),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(2823),
    [sym__tuple_type_body] = STATE(434),
    [sym_tuple_type] = STATE(2823),
    [sym_union_type] = STATE(3018),
    [sym_intersection_type] = STATE(3018),
    [sym_function_type] = STATE(3018),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_export] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_EQ] = ACTIONS(857),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(853),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(864),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(864),
    [anon_sym_LBRACK] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(875),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(885),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(903),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_static] = ACTIONS(853),
    [anon_sym_get] = ACTIONS(853),
    [anon_sym_set] = ACTIONS(853),
    [anon_sym_declare] = ACTIONS(853),
    [anon_sym_public] = ACTIONS(853),
    [anon_sym_private] = ACTIONS(853),
    [anon_sym_protected] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(853),
    [anon_sym_any] = ACTIONS(907),
    [anon_sym_number] = ACTIONS(907),
    [anon_sym_boolean] = ACTIONS(907),
    [anon_sym_string] = ACTIONS(907),
    [anon_sym_symbol] = ACTIONS(907),
    [sym_readonly] = ACTIONS(909),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [72] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1285),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_as] = ACTIONS(811),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_in] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(923),
    [anon_sym_GT] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_DOT] = ACTIONS(811),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_QMARK_DOT] = ACTIONS(815),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(811),
    [anon_sym_GT_GT_GT] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(811),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_PERCENT] = ACTIONS(815),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_QMARK_QMARK] = ACTIONS(815),
    [anon_sym_instanceof] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(815),
  },
  [73] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1391),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(933),
    [anon_sym_as] = ACTIONS(811),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(935),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_in] = ACTIONS(811),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(823),
    [anon_sym_GT] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_DOT] = ACTIONS(811),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_QMARK_DOT] = ACTIONS(815),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(811),
    [anon_sym_GT_GT_GT] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(811),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(815),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_QMARK_QMARK] = ACTIONS(815),
    [anon_sym_instanceof] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [anon_sym_implements] = ACTIONS(811),
    [sym_readonly] = ACTIONS(749),
  },
  [74] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1545),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_STAR] = ACTIONS(943),
    [anon_sym_as] = ACTIONS(811),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_in] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(811),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_QMARK_DOT] = ACTIONS(815),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(811),
    [anon_sym_GT_GT_GT] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(811),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_PERCENT] = ACTIONS(815),
    [anon_sym_STAR_STAR] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_EQ_EQ] = ACTIONS(811),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(811),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_QMARK_QMARK] = ACTIONS(815),
    [anon_sym_instanceof] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
    [sym__automatic_semicolon] = ACTIONS(815),
  },
  [75] = {
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_formal_parameters] = STATE(3565),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(3018),
    [sym_constructor_type] = STATE(3018),
    [sym__primary_type] = STATE(2823),
    [sym_infer_type] = STATE(3018),
    [sym_conditional_type] = STATE(2823),
    [sym_generic_type] = STATE(2823),
    [sym_type_query] = STATE(2823),
    [sym_index_type_query] = STATE(2823),
    [sym_lookup_type] = STATE(2823),
    [sym_literal_type] = STATE(2823),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(2823),
    [sym_flow_maybe_type] = STATE(2823),
    [sym_parenthesized_type] = STATE(2823),
    [sym_predefined_type] = STATE(2823),
    [sym_object_type] = STATE(2823),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(2823),
    [sym__tuple_type_body] = STATE(434),
    [sym_tuple_type] = STATE(2823),
    [sym_union_type] = STATE(3018),
    [sym_intersection_type] = STATE(3018),
    [sym_function_type] = STATE(3018),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_EQ] = ACTIONS(953),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(955),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(957),
    [anon_sym_RBRACK] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(875),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(885),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(959),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_any] = ACTIONS(895),
    [anon_sym_number] = ACTIONS(895),
    [anon_sym_boolean] = ACTIONS(895),
    [anon_sym_string] = ACTIONS(895),
    [anon_sym_symbol] = ACTIONS(895),
    [sym_readonly] = ACTIONS(961),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [76] = {
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_formal_parameters] = STATE(3565),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(3018),
    [sym_constructor_type] = STATE(3018),
    [sym__primary_type] = STATE(2823),
    [sym_infer_type] = STATE(3018),
    [sym_conditional_type] = STATE(2823),
    [sym_generic_type] = STATE(2823),
    [sym_type_query] = STATE(2823),
    [sym_index_type_query] = STATE(2823),
    [sym_lookup_type] = STATE(2823),
    [sym_literal_type] = STATE(2823),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(2823),
    [sym_flow_maybe_type] = STATE(2823),
    [sym_parenthesized_type] = STATE(2823),
    [sym_predefined_type] = STATE(2823),
    [sym_object_type] = STATE(2823),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(2823),
    [sym__tuple_type_body] = STATE(434),
    [sym_tuple_type] = STATE(2823),
    [sym_union_type] = STATE(3018),
    [sym_intersection_type] = STATE(3018),
    [sym_function_type] = STATE(3018),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_EQ] = ACTIONS(963),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(955),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(885),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(959),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_any] = ACTIONS(895),
    [anon_sym_number] = ACTIONS(895),
    [anon_sym_boolean] = ACTIONS(895),
    [anon_sym_string] = ACTIONS(895),
    [anon_sym_symbol] = ACTIONS(895),
    [sym_readonly] = ACTIONS(961),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(973),
    [sym_identifier] = ACTIONS(975),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_STAR] = ACTIONS(977),
    [anon_sym_default] = ACTIONS(975),
    [anon_sym_EQ] = ACTIONS(977),
    [anon_sym_as] = ACTIONS(977),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_COMMA] = ACTIONS(979),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(975),
    [anon_sym_import] = ACTIONS(975),
    [anon_sym_var] = ACTIONS(975),
    [anon_sym_let] = ACTIONS(975),
    [anon_sym_const] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_else] = ACTIONS(975),
    [anon_sym_if] = ACTIONS(975),
    [anon_sym_switch] = ACTIONS(975),
    [anon_sym_for] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(973),
    [anon_sym_await] = ACTIONS(975),
    [anon_sym_in] = ACTIONS(977),
    [anon_sym_while] = ACTIONS(975),
    [anon_sym_do] = ACTIONS(975),
    [anon_sym_try] = ACTIONS(975),
    [anon_sym_with] = ACTIONS(975),
    [anon_sym_break] = ACTIONS(975),
    [anon_sym_continue] = ACTIONS(975),
    [anon_sym_debugger] = ACTIONS(975),
    [anon_sym_return] = ACTIONS(975),
    [anon_sym_throw] = ACTIONS(975),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_case] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(973),
    [anon_sym_LT] = ACTIONS(975),
    [anon_sym_GT] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_DOT] = ACTIONS(977),
    [anon_sym_class] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_QMARK_DOT] = ACTIONS(979),
    [anon_sym_new] = ACTIONS(975),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(979),
    [anon_sym_PIPE_PIPE] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_GT_GT_GT] = ACTIONS(979),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(979),
    [anon_sym_STAR_STAR] = ACTIONS(979),
    [anon_sym_LT_EQ] = ACTIONS(979),
    [anon_sym_EQ_EQ] = ACTIONS(977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(979),
    [anon_sym_BANG_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(979),
    [anon_sym_GT_EQ] = ACTIONS(979),
    [anon_sym_QMARK_QMARK] = ACTIONS(979),
    [anon_sym_instanceof] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(973),
    [anon_sym_void] = ACTIONS(975),
    [anon_sym_delete] = ACTIONS(975),
    [anon_sym_PLUS_PLUS] = ACTIONS(973),
    [anon_sym_DASH_DASH] = ACTIONS(973),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(973),
    [sym_number] = ACTIONS(973),
    [sym_this] = ACTIONS(975),
    [sym_super] = ACTIONS(975),
    [sym_true] = ACTIONS(975),
    [sym_false] = ACTIONS(975),
    [sym_null] = ACTIONS(975),
    [sym_undefined] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(973),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_abstract] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_interface] = ACTIONS(975),
    [anon_sym_enum] = ACTIONS(975),
    [sym_readonly] = ACTIONS(975),
    [sym__automatic_semicolon] = ACTIONS(981),
  },
  [78] = {
    [sym_statement_block] = STATE(95),
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym_identifier] = ACTIONS(985),
    [anon_sym_export] = ACTIONS(985),
    [anon_sym_STAR] = ACTIONS(985),
    [anon_sym_default] = ACTIONS(985),
    [anon_sym_as] = ACTIONS(985),
    [anon_sym_namespace] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_COMMA] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_type] = ACTIONS(985),
    [anon_sym_typeof] = ACTIONS(985),
    [anon_sym_import] = ACTIONS(985),
    [anon_sym_var] = ACTIONS(985),
    [anon_sym_let] = ACTIONS(985),
    [anon_sym_const] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_else] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_switch] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [anon_sym_in] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_do] = ACTIONS(985),
    [anon_sym_try] = ACTIONS(985),
    [anon_sym_with] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_continue] = ACTIONS(985),
    [anon_sym_debugger] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_throw] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_case] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_DOT] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(985),
    [anon_sym_QMARK_DOT] = ACTIONS(983),
    [anon_sym_new] = ACTIONS(985),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(983),
    [anon_sym_PIPE_PIPE] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_GT_GT_GT] = ACTIONS(983),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_PIPE] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_PERCENT] = ACTIONS(983),
    [anon_sym_STAR_STAR] = ACTIONS(983),
    [anon_sym_LT_EQ] = ACTIONS(983),
    [anon_sym_EQ_EQ] = ACTIONS(985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(983),
    [anon_sym_BANG_EQ] = ACTIONS(985),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(983),
    [anon_sym_QMARK_QMARK] = ACTIONS(983),
    [anon_sym_instanceof] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(983),
    [anon_sym_void] = ACTIONS(985),
    [anon_sym_delete] = ACTIONS(985),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [sym_number] = ACTIONS(983),
    [sym_this] = ACTIONS(985),
    [sym_super] = ACTIONS(985),
    [sym_true] = ACTIONS(985),
    [sym_false] = ACTIONS(985),
    [sym_null] = ACTIONS(985),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(983),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_abstract] = ACTIONS(985),
    [anon_sym_get] = ACTIONS(985),
    [anon_sym_set] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(985),
    [anon_sym_public] = ACTIONS(985),
    [anon_sym_private] = ACTIONS(985),
    [anon_sym_protected] = ACTIONS(985),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_any] = ACTIONS(985),
    [anon_sym_number] = ACTIONS(985),
    [anon_sym_boolean] = ACTIONS(985),
    [anon_sym_string] = ACTIONS(985),
    [anon_sym_symbol] = ACTIONS(985),
    [anon_sym_interface] = ACTIONS(985),
    [anon_sym_enum] = ACTIONS(985),
    [sym_readonly] = ACTIONS(985),
    [sym__automatic_semicolon] = ACTIONS(983),
  },
  [79] = {
    [sym_statement_block] = STATE(95),
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym_identifier] = ACTIONS(985),
    [anon_sym_export] = ACTIONS(985),
    [anon_sym_STAR] = ACTIONS(985),
    [anon_sym_default] = ACTIONS(985),
    [anon_sym_as] = ACTIONS(985),
    [anon_sym_namespace] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_COMMA] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_type] = ACTIONS(985),
    [anon_sym_typeof] = ACTIONS(985),
    [anon_sym_import] = ACTIONS(985),
    [anon_sym_var] = ACTIONS(985),
    [anon_sym_let] = ACTIONS(985),
    [anon_sym_const] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_else] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_switch] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [anon_sym_in] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_do] = ACTIONS(985),
    [anon_sym_try] = ACTIONS(985),
    [anon_sym_with] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_continue] = ACTIONS(985),
    [anon_sym_debugger] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_throw] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_case] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_LT] = ACTIONS(985),
    [anon_sym_GT] = ACTIONS(985),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_DOT] = ACTIONS(989),
    [anon_sym_class] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(985),
    [anon_sym_QMARK_DOT] = ACTIONS(983),
    [anon_sym_new] = ACTIONS(985),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_AMP_AMP] = ACTIONS(983),
    [anon_sym_PIPE_PIPE] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_GT_GT_GT] = ACTIONS(983),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_PIPE] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_PERCENT] = ACTIONS(983),
    [anon_sym_STAR_STAR] = ACTIONS(983),
    [anon_sym_LT_EQ] = ACTIONS(983),
    [anon_sym_EQ_EQ] = ACTIONS(985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(983),
    [anon_sym_BANG_EQ] = ACTIONS(985),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(983),
    [anon_sym_GT_EQ] = ACTIONS(983),
    [anon_sym_QMARK_QMARK] = ACTIONS(983),
    [anon_sym_instanceof] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(983),
    [anon_sym_void] = ACTIONS(985),
    [anon_sym_delete] = ACTIONS(985),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [sym_number] = ACTIONS(983),
    [sym_this] = ACTIONS(985),
    [sym_super] = ACTIONS(985),
    [sym_true] = ACTIONS(985),
    [sym_false] = ACTIONS(985),
    [sym_null] = ACTIONS(985),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(983),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_abstract] = ACTIONS(985),
    [anon_sym_get] = ACTIONS(985),
    [anon_sym_set] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(985),
    [anon_sym_public] = ACTIONS(985),
    [anon_sym_private] = ACTIONS(985),
    [anon_sym_protected] = ACTIONS(985),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_any] = ACTIONS(985),
    [anon_sym_number] = ACTIONS(985),
    [anon_sym_boolean] = ACTIONS(985),
    [anon_sym_string] = ACTIONS(985),
    [anon_sym_symbol] = ACTIONS(985),
    [anon_sym_interface] = ACTIONS(985),
    [anon_sym_enum] = ACTIONS(985),
    [sym_readonly] = ACTIONS(985),
    [sym__automatic_semicolon] = ACTIONS(983),
  },
  [80] = {
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_formal_parameters] = STATE(3565),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(3018),
    [sym_constructor_type] = STATE(3018),
    [sym__primary_type] = STATE(2823),
    [sym_infer_type] = STATE(3018),
    [sym_conditional_type] = STATE(2823),
    [sym_generic_type] = STATE(2823),
    [sym_type_query] = STATE(2823),
    [sym_index_type_query] = STATE(2823),
    [sym_lookup_type] = STATE(2823),
    [sym_literal_type] = STATE(2823),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(2823),
    [sym_flow_maybe_type] = STATE(2823),
    [sym_parenthesized_type] = STATE(2823),
    [sym_predefined_type] = STATE(2823),
    [sym_object_type] = STATE(2823),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(2823),
    [sym__tuple_type_body] = STATE(434),
    [sym_tuple_type] = STATE(2823),
    [sym_union_type] = STATE(3018),
    [sym_intersection_type] = STATE(3018),
    [sym_function_type] = STATE(3018),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(955),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(957),
    [anon_sym_RBRACK] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(875),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(885),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(959),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_any] = ACTIONS(895),
    [anon_sym_number] = ACTIONS(895),
    [anon_sym_boolean] = ACTIONS(895),
    [anon_sym_string] = ACTIONS(895),
    [anon_sym_symbol] = ACTIONS(895),
    [sym_readonly] = ACTIONS(961),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(995),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_default] = ACTIONS(997),
    [anon_sym_as] = ACTIONS(997),
    [anon_sym_namespace] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_RBRACE] = ACTIONS(995),
    [anon_sym_type] = ACTIONS(997),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(997),
    [anon_sym_var] = ACTIONS(997),
    [anon_sym_let] = ACTIONS(997),
    [anon_sym_const] = ACTIONS(997),
    [anon_sym_BANG] = ACTIONS(997),
    [anon_sym_else] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_switch] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_await] = ACTIONS(997),
    [anon_sym_in] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_try] = ACTIONS(997),
    [anon_sym_with] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_debugger] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_throw] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_case] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_class] = ACTIONS(997),
    [anon_sym_async] = ACTIONS(997),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_QMARK_DOT] = ACTIONS(995),
    [anon_sym_new] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_GT_GT_GT] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_QMARK_QMARK] = ACTIONS(995),
    [anon_sym_instanceof] = ACTIONS(997),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_void] = ACTIONS(997),
    [anon_sym_delete] = ACTIONS(997),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_SQUOTE] = ACTIONS(995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [sym_number] = ACTIONS(995),
    [sym_this] = ACTIONS(997),
    [sym_super] = ACTIONS(997),
    [sym_true] = ACTIONS(997),
    [sym_false] = ACTIONS(997),
    [sym_null] = ACTIONS(997),
    [sym_undefined] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_static] = ACTIONS(997),
    [anon_sym_abstract] = ACTIONS(997),
    [anon_sym_get] = ACTIONS(997),
    [anon_sym_set] = ACTIONS(997),
    [anon_sym_declare] = ACTIONS(997),
    [anon_sym_public] = ACTIONS(997),
    [anon_sym_private] = ACTIONS(997),
    [anon_sym_protected] = ACTIONS(997),
    [anon_sym_module] = ACTIONS(997),
    [anon_sym_any] = ACTIONS(997),
    [anon_sym_number] = ACTIONS(997),
    [anon_sym_boolean] = ACTIONS(997),
    [anon_sym_string] = ACTIONS(997),
    [anon_sym_symbol] = ACTIONS(997),
    [anon_sym_interface] = ACTIONS(997),
    [anon_sym_enum] = ACTIONS(997),
    [sym_readonly] = ACTIONS(997),
    [sym__automatic_semicolon] = ACTIONS(995),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(999),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_export] = ACTIONS(1001),
    [anon_sym_STAR] = ACTIONS(1003),
    [anon_sym_default] = ACTIONS(1001),
    [anon_sym_as] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(1005),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_type] = ACTIONS(1001),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(1001),
    [anon_sym_var] = ACTIONS(1001),
    [anon_sym_let] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1001),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_else] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_in] = ACTIONS(1003),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1001),
    [anon_sym_try] = ACTIONS(1001),
    [anon_sym_with] = ACTIONS(1001),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_continue] = ACTIONS(1001),
    [anon_sym_debugger] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_throw] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_case] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(1001),
    [anon_sym_GT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(1001),
    [anon_sym_DOT] = ACTIONS(1003),
    [anon_sym_class] = ACTIONS(1001),
    [anon_sym_async] = ACTIONS(1001),
    [anon_sym_function] = ACTIONS(1001),
    [anon_sym_QMARK_DOT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(1003),
    [anon_sym_AMP_AMP] = ACTIONS(1005),
    [anon_sym_PIPE_PIPE] = ACTIONS(1005),
    [anon_sym_GT_GT] = ACTIONS(1003),
    [anon_sym_GT_GT_GT] = ACTIONS(1005),
    [anon_sym_LT_LT] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(1003),
    [anon_sym_CARET] = ACTIONS(1005),
    [anon_sym_PIPE] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PERCENT] = ACTIONS(1005),
    [anon_sym_STAR_STAR] = ACTIONS(1005),
    [anon_sym_LT_EQ] = ACTIONS(1005),
    [anon_sym_EQ_EQ] = ACTIONS(1003),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1005),
    [anon_sym_BANG_EQ] = ACTIONS(1003),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1005),
    [anon_sym_GT_EQ] = ACTIONS(1005),
    [anon_sym_QMARK_QMARK] = ACTIONS(1005),
    [anon_sym_instanceof] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(999),
    [anon_sym_DASH_DASH] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(999),
    [sym_number] = ACTIONS(999),
    [sym_this] = ACTIONS(1001),
    [sym_super] = ACTIONS(1001),
    [sym_true] = ACTIONS(1001),
    [sym_false] = ACTIONS(1001),
    [sym_null] = ACTIONS(1001),
    [sym_undefined] = ACTIONS(1001),
    [anon_sym_AT] = ACTIONS(999),
    [anon_sym_static] = ACTIONS(1001),
    [anon_sym_abstract] = ACTIONS(1001),
    [anon_sym_get] = ACTIONS(1001),
    [anon_sym_set] = ACTIONS(1001),
    [anon_sym_declare] = ACTIONS(1001),
    [anon_sym_public] = ACTIONS(1001),
    [anon_sym_private] = ACTIONS(1001),
    [anon_sym_protected] = ACTIONS(1001),
    [anon_sym_module] = ACTIONS(1001),
    [anon_sym_any] = ACTIONS(1001),
    [anon_sym_number] = ACTIONS(1001),
    [anon_sym_boolean] = ACTIONS(1001),
    [anon_sym_string] = ACTIONS(1001),
    [anon_sym_symbol] = ACTIONS(1001),
    [anon_sym_interface] = ACTIONS(1001),
    [anon_sym_enum] = ACTIONS(1001),
    [sym_readonly] = ACTIONS(1001),
    [sym__automatic_semicolon] = ACTIONS(1007),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(1009),
    [sym_identifier] = ACTIONS(1011),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1013),
    [anon_sym_default] = ACTIONS(1011),
    [anon_sym_as] = ACTIONS(1013),
    [anon_sym_namespace] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_COMMA] = ACTIONS(1015),
    [anon_sym_RBRACE] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1011),
    [anon_sym_import] = ACTIONS(1011),
    [anon_sym_var] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1011),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_else] = ACTIONS(1011),
    [anon_sym_if] = ACTIONS(1011),
    [anon_sym_switch] = ACTIONS(1011),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(1009),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_in] = ACTIONS(1013),
    [anon_sym_while] = ACTIONS(1011),
    [anon_sym_do] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1011),
    [anon_sym_with] = ACTIONS(1011),
    [anon_sym_break] = ACTIONS(1011),
    [anon_sym_continue] = ACTIONS(1011),
    [anon_sym_debugger] = ACTIONS(1011),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_case] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1011),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_SLASH] = ACTIONS(1011),
    [anon_sym_DOT] = ACTIONS(1013),
    [anon_sym_class] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(1011),
    [anon_sym_QMARK_DOT] = ACTIONS(1015),
    [anon_sym_new] = ACTIONS(1011),
    [anon_sym_QMARK] = ACTIONS(1013),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_PIPE_PIPE] = ACTIONS(1015),
    [anon_sym_GT_GT] = ACTIONS(1013),
    [anon_sym_GT_GT_GT] = ACTIONS(1015),
    [anon_sym_LT_LT] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1013),
    [anon_sym_CARET] = ACTIONS(1015),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_PERCENT] = ACTIONS(1015),
    [anon_sym_STAR_STAR] = ACTIONS(1015),
    [anon_sym_LT_EQ] = ACTIONS(1015),
    [anon_sym_EQ_EQ] = ACTIONS(1013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1015),
    [anon_sym_BANG_EQ] = ACTIONS(1013),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1015),
    [anon_sym_GT_EQ] = ACTIONS(1015),
    [anon_sym_QMARK_QMARK] = ACTIONS(1015),
    [anon_sym_instanceof] = ACTIONS(1013),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1011),
    [anon_sym_delete] = ACTIONS(1011),
    [anon_sym_PLUS_PLUS] = ACTIONS(1009),
    [anon_sym_DASH_DASH] = ACTIONS(1009),
    [anon_sym_DQUOTE] = ACTIONS(1009),
    [anon_sym_SQUOTE] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1009),
    [sym_number] = ACTIONS(1009),
    [sym_this] = ACTIONS(1011),
    [sym_super] = ACTIONS(1011),
    [sym_true] = ACTIONS(1011),
    [sym_false] = ACTIONS(1011),
    [sym_null] = ACTIONS(1011),
    [sym_undefined] = ACTIONS(1011),
    [anon_sym_AT] = ACTIONS(1009),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_abstract] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
    [anon_sym_interface] = ACTIONS(1011),
    [anon_sym_enum] = ACTIONS(1011),
    [sym_readonly] = ACTIONS(1011),
    [sym__automatic_semicolon] = ACTIONS(1017),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(1019),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_export] = ACTIONS(1021),
    [anon_sym_STAR] = ACTIONS(1023),
    [anon_sym_default] = ACTIONS(1021),
    [anon_sym_as] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1019),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1019),
    [anon_sym_type] = ACTIONS(1021),
    [anon_sym_typeof] = ACTIONS(1021),
    [anon_sym_import] = ACTIONS(1021),
    [anon_sym_var] = ACTIONS(1021),
    [anon_sym_let] = ACTIONS(1021),
    [anon_sym_const] = ACTIONS(1021),
    [anon_sym_BANG] = ACTIONS(1021),
    [anon_sym_else] = ACTIONS(1021),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_switch] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1021),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1021),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_try] = ACTIONS(1021),
    [anon_sym_with] = ACTIONS(1021),
    [anon_sym_break] = ACTIONS(1021),
    [anon_sym_continue] = ACTIONS(1021),
    [anon_sym_debugger] = ACTIONS(1021),
    [anon_sym_return] = ACTIONS(1021),
    [anon_sym_throw] = ACTIONS(1021),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_case] = ACTIONS(1021),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(1021),
    [anon_sym_async] = ACTIONS(1021),
    [anon_sym_function] = ACTIONS(1021),
    [anon_sym_QMARK_DOT] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(1021),
    [anon_sym_QMARK] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_DASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_QMARK_QMARK] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1019),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(1021),
    [anon_sym_PLUS_PLUS] = ACTIONS(1019),
    [anon_sym_DASH_DASH] = ACTIONS(1019),
    [anon_sym_DQUOTE] = ACTIONS(1019),
    [anon_sym_SQUOTE] = ACTIONS(1019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_number] = ACTIONS(1019),
    [sym_this] = ACTIONS(1021),
    [sym_super] = ACTIONS(1021),
    [sym_true] = ACTIONS(1021),
    [sym_false] = ACTIONS(1021),
    [sym_null] = ACTIONS(1021),
    [sym_undefined] = ACTIONS(1021),
    [anon_sym_AT] = ACTIONS(1019),
    [anon_sym_static] = ACTIONS(1021),
    [anon_sym_abstract] = ACTIONS(1021),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
    [anon_sym_declare] = ACTIONS(1021),
    [anon_sym_public] = ACTIONS(1021),
    [anon_sym_private] = ACTIONS(1021),
    [anon_sym_protected] = ACTIONS(1021),
    [anon_sym_module] = ACTIONS(1021),
    [anon_sym_any] = ACTIONS(1021),
    [anon_sym_number] = ACTIONS(1021),
    [anon_sym_boolean] = ACTIONS(1021),
    [anon_sym_string] = ACTIONS(1021),
    [anon_sym_symbol] = ACTIONS(1021),
    [anon_sym_interface] = ACTIONS(1021),
    [anon_sym_enum] = ACTIONS(1021),
    [sym_readonly] = ACTIONS(1021),
    [sym__automatic_semicolon] = ACTIONS(1027),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1031),
    [anon_sym_export] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1033),
    [anon_sym_default] = ACTIONS(1031),
    [anon_sym_as] = ACTIONS(1033),
    [anon_sym_namespace] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(1035),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_type] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1031),
    [anon_sym_import] = ACTIONS(1031),
    [anon_sym_var] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1031),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_else] = ACTIONS(1031),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1031),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_await] = ACTIONS(1031),
    [anon_sym_in] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_do] = ACTIONS(1031),
    [anon_sym_try] = ACTIONS(1031),
    [anon_sym_with] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1031),
    [anon_sym_continue] = ACTIONS(1031),
    [anon_sym_debugger] = ACTIONS(1031),
    [anon_sym_return] = ACTIONS(1031),
    [anon_sym_throw] = ACTIONS(1031),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_case] = ACTIONS(1031),
    [anon_sym_yield] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_LT] = ACTIONS(1031),
    [anon_sym_GT] = ACTIONS(1033),
    [anon_sym_SLASH] = ACTIONS(1031),
    [anon_sym_DOT] = ACTIONS(1033),
    [anon_sym_class] = ACTIONS(1031),
    [anon_sym_async] = ACTIONS(1031),
    [anon_sym_function] = ACTIONS(1031),
    [anon_sym_QMARK_DOT] = ACTIONS(1035),
    [anon_sym_new] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1035),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_GT_GT] = ACTIONS(1033),
    [anon_sym_GT_GT_GT] = ACTIONS(1035),
    [anon_sym_LT_LT] = ACTIONS(1035),
    [anon_sym_AMP] = ACTIONS(1033),
    [anon_sym_CARET] = ACTIONS(1035),
    [anon_sym_PIPE] = ACTIONS(1033),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_LT_EQ] = ACTIONS(1035),
    [anon_sym_EQ_EQ] = ACTIONS(1033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1035),
    [anon_sym_BANG_EQ] = ACTIONS(1033),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1035),
    [anon_sym_GT_EQ] = ACTIONS(1035),
    [anon_sym_QMARK_QMARK] = ACTIONS(1035),
    [anon_sym_instanceof] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1029),
    [anon_sym_void] = ACTIONS(1031),
    [anon_sym_delete] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1029),
    [sym_number] = ACTIONS(1029),
    [sym_this] = ACTIONS(1031),
    [sym_super] = ACTIONS(1031),
    [sym_true] = ACTIONS(1031),
    [sym_false] = ACTIONS(1031),
    [sym_null] = ACTIONS(1031),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(1029),
    [anon_sym_static] = ACTIONS(1031),
    [anon_sym_abstract] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(1031),
    [anon_sym_set] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1031),
    [anon_sym_public] = ACTIONS(1031),
    [anon_sym_private] = ACTIONS(1031),
    [anon_sym_protected] = ACTIONS(1031),
    [anon_sym_module] = ACTIONS(1031),
    [anon_sym_any] = ACTIONS(1031),
    [anon_sym_number] = ACTIONS(1031),
    [anon_sym_boolean] = ACTIONS(1031),
    [anon_sym_string] = ACTIONS(1031),
    [anon_sym_symbol] = ACTIONS(1031),
    [anon_sym_interface] = ACTIONS(1031),
    [anon_sym_enum] = ACTIONS(1031),
    [sym_readonly] = ACTIONS(1031),
    [sym__automatic_semicolon] = ACTIONS(1037),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(1039),
    [sym_identifier] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_default] = ACTIONS(1041),
    [anon_sym_as] = ACTIONS(1043),
    [anon_sym_namespace] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_type] = ACTIONS(1041),
    [anon_sym_typeof] = ACTIONS(1041),
    [anon_sym_import] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_let] = ACTIONS(1041),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_await] = ACTIONS(1041),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_do] = ACTIONS(1041),
    [anon_sym_try] = ACTIONS(1041),
    [anon_sym_with] = ACTIONS(1041),
    [anon_sym_break] = ACTIONS(1041),
    [anon_sym_continue] = ACTIONS(1041),
    [anon_sym_debugger] = ACTIONS(1041),
    [anon_sym_return] = ACTIONS(1041),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_case] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1043),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_DOT] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1041),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_function] = ACTIONS(1041),
    [anon_sym_QMARK_DOT] = ACTIONS(1045),
    [anon_sym_new] = ACTIONS(1041),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_AMP_AMP] = ACTIONS(1045),
    [anon_sym_PIPE_PIPE] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_GT_GT_GT] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1045),
    [anon_sym_AMP] = ACTIONS(1043),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_PIPE] = ACTIONS(1043),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1045),
    [anon_sym_STAR_STAR] = ACTIONS(1045),
    [anon_sym_LT_EQ] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1045),
    [anon_sym_BANG_EQ] = ACTIONS(1043),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1045),
    [anon_sym_GT_EQ] = ACTIONS(1045),
    [anon_sym_QMARK_QMARK] = ACTIONS(1045),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_void] = ACTIONS(1041),
    [anon_sym_delete] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_DASH_DASH] = ACTIONS(1039),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1039),
    [sym_number] = ACTIONS(1039),
    [sym_this] = ACTIONS(1041),
    [sym_super] = ACTIONS(1041),
    [sym_true] = ACTIONS(1041),
    [sym_false] = ACTIONS(1041),
    [sym_null] = ACTIONS(1041),
    [sym_undefined] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(1041),
    [anon_sym_abstract] = ACTIONS(1041),
    [anon_sym_get] = ACTIONS(1041),
    [anon_sym_set] = ACTIONS(1041),
    [anon_sym_declare] = ACTIONS(1041),
    [anon_sym_public] = ACTIONS(1041),
    [anon_sym_private] = ACTIONS(1041),
    [anon_sym_protected] = ACTIONS(1041),
    [anon_sym_module] = ACTIONS(1041),
    [anon_sym_any] = ACTIONS(1041),
    [anon_sym_number] = ACTIONS(1041),
    [anon_sym_boolean] = ACTIONS(1041),
    [anon_sym_string] = ACTIONS(1041),
    [anon_sym_symbol] = ACTIONS(1041),
    [anon_sym_interface] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [sym_readonly] = ACTIONS(1041),
    [sym__automatic_semicolon] = ACTIONS(1045),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1049),
    [anon_sym_export] = ACTIONS(1049),
    [anon_sym_STAR] = ACTIONS(1049),
    [anon_sym_default] = ACTIONS(1049),
    [anon_sym_as] = ACTIONS(1049),
    [anon_sym_namespace] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1049),
    [anon_sym_typeof] = ACTIONS(1049),
    [anon_sym_import] = ACTIONS(1049),
    [anon_sym_var] = ACTIONS(1049),
    [anon_sym_let] = ACTIONS(1049),
    [anon_sym_const] = ACTIONS(1049),
    [anon_sym_BANG] = ACTIONS(1049),
    [anon_sym_else] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(1049),
    [anon_sym_switch] = ACTIONS(1049),
    [anon_sym_for] = ACTIONS(1049),
    [anon_sym_LPAREN] = ACTIONS(1047),
    [anon_sym_await] = ACTIONS(1049),
    [anon_sym_in] = ACTIONS(1049),
    [anon_sym_while] = ACTIONS(1049),
    [anon_sym_do] = ACTIONS(1049),
    [anon_sym_try] = ACTIONS(1049),
    [anon_sym_with] = ACTIONS(1049),
    [anon_sym_break] = ACTIONS(1049),
    [anon_sym_continue] = ACTIONS(1049),
    [anon_sym_debugger] = ACTIONS(1049),
    [anon_sym_return] = ACTIONS(1049),
    [anon_sym_throw] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1047),
    [anon_sym_case] = ACTIONS(1049),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1049),
    [anon_sym_GT] = ACTIONS(1049),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_DOT] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1049),
    [anon_sym_function] = ACTIONS(1049),
    [anon_sym_QMARK_DOT] = ACTIONS(1047),
    [anon_sym_new] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1049),
    [anon_sym_AMP_AMP] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(1047),
    [anon_sym_GT_GT] = ACTIONS(1049),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_AMP] = ACTIONS(1049),
    [anon_sym_CARET] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(1049),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_STAR_STAR] = ACTIONS(1047),
    [anon_sym_LT_EQ] = ACTIONS(1047),
    [anon_sym_EQ_EQ] = ACTIONS(1049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1047),
    [anon_sym_BANG_EQ] = ACTIONS(1049),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1047),
    [anon_sym_GT_EQ] = ACTIONS(1047),
    [anon_sym_QMARK_QMARK] = ACTIONS(1047),
    [anon_sym_instanceof] = ACTIONS(1049),
    [anon_sym_TILDE] = ACTIONS(1047),
    [anon_sym_void] = ACTIONS(1049),
    [anon_sym_delete] = ACTIONS(1049),
    [anon_sym_PLUS_PLUS] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(1047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1047),
    [sym_number] = ACTIONS(1047),
    [sym_this] = ACTIONS(1049),
    [sym_super] = ACTIONS(1049),
    [sym_true] = ACTIONS(1049),
    [sym_false] = ACTIONS(1049),
    [sym_null] = ACTIONS(1049),
    [sym_undefined] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1049),
    [anon_sym_abstract] = ACTIONS(1049),
    [anon_sym_get] = ACTIONS(1049),
    [anon_sym_set] = ACTIONS(1049),
    [anon_sym_declare] = ACTIONS(1049),
    [anon_sym_public] = ACTIONS(1049),
    [anon_sym_private] = ACTIONS(1049),
    [anon_sym_protected] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1049),
    [anon_sym_any] = ACTIONS(1049),
    [anon_sym_number] = ACTIONS(1049),
    [anon_sym_boolean] = ACTIONS(1049),
    [anon_sym_string] = ACTIONS(1049),
    [anon_sym_symbol] = ACTIONS(1049),
    [anon_sym_interface] = ACTIONS(1049),
    [anon_sym_enum] = ACTIONS(1049),
    [sym_readonly] = ACTIONS(1049),
    [sym__automatic_semicolon] = ACTIONS(1047),
  },
  [88] = {
    [ts_builtin_sym_end] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_default] = ACTIONS(1053),
    [anon_sym_as] = ACTIONS(1053),
    [anon_sym_namespace] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1051),
    [anon_sym_COMMA] = ACTIONS(1051),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typeof] = ACTIONS(1053),
    [anon_sym_import] = ACTIONS(1053),
    [anon_sym_var] = ACTIONS(1053),
    [anon_sym_let] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1053),
    [anon_sym_else] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [anon_sym_switch] = ACTIONS(1053),
    [anon_sym_for] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_await] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [anon_sym_do] = ACTIONS(1053),
    [anon_sym_try] = ACTIONS(1053),
    [anon_sym_with] = ACTIONS(1053),
    [anon_sym_break] = ACTIONS(1053),
    [anon_sym_continue] = ACTIONS(1053),
    [anon_sym_debugger] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_throw] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1053),
    [anon_sym_yield] = ACTIONS(1053),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_SLASH] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(1053),
    [anon_sym_class] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1053),
    [anon_sym_QMARK_DOT] = ACTIONS(1051),
    [anon_sym_new] = ACTIONS(1053),
    [anon_sym_QMARK] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
    [anon_sym_CARET] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_DASH] = ACTIONS(1053),
    [anon_sym_PERCENT] = ACTIONS(1051),
    [anon_sym_STAR_STAR] = ACTIONS(1051),
    [anon_sym_LT_EQ] = ACTIONS(1051),
    [anon_sym_EQ_EQ] = ACTIONS(1053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1051),
    [anon_sym_BANG_EQ] = ACTIONS(1053),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1051),
    [anon_sym_GT_EQ] = ACTIONS(1051),
    [anon_sym_QMARK_QMARK] = ACTIONS(1051),
    [anon_sym_instanceof] = ACTIONS(1053),
    [anon_sym_TILDE] = ACTIONS(1051),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_delete] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1051),
    [anon_sym_DASH_DASH] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1051),
    [anon_sym_SQUOTE] = ACTIONS(1051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [sym_number] = ACTIONS(1051),
    [sym_this] = ACTIONS(1053),
    [sym_super] = ACTIONS(1053),
    [sym_true] = ACTIONS(1053),
    [sym_false] = ACTIONS(1053),
    [sym_null] = ACTIONS(1053),
    [sym_undefined] = ACTIONS(1053),
    [anon_sym_AT] = ACTIONS(1051),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_abstract] = ACTIONS(1053),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_interface] = ACTIONS(1053),
    [anon_sym_enum] = ACTIONS(1053),
    [sym_readonly] = ACTIONS(1053),
    [sym__automatic_semicolon] = ACTIONS(1051),
  },
  [89] = {
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_formal_parameters] = STATE(3565),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(3018),
    [sym_constructor_type] = STATE(3018),
    [sym__primary_type] = STATE(2823),
    [sym_infer_type] = STATE(3018),
    [sym_conditional_type] = STATE(2823),
    [sym_generic_type] = STATE(2823),
    [sym_type_query] = STATE(2823),
    [sym_index_type_query] = STATE(2823),
    [sym_lookup_type] = STATE(2823),
    [sym_literal_type] = STATE(2823),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(2823),
    [sym_flow_maybe_type] = STATE(2823),
    [sym_parenthesized_type] = STATE(2823),
    [sym_predefined_type] = STATE(2823),
    [sym_object_type] = STATE(2823),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(2823),
    [sym__tuple_type_body] = STATE(434),
    [sym_tuple_type] = STATE(2823),
    [sym_union_type] = STATE(3018),
    [sym_intersection_type] = STATE(3018),
    [sym_function_type] = STATE(3018),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_EQ] = ACTIONS(1055),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(955),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_LBRACK] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(875),
    [anon_sym_EQ_GT] = ACTIONS(1057),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(885),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(959),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_any] = ACTIONS(895),
    [anon_sym_number] = ACTIONS(895),
    [anon_sym_boolean] = ACTIONS(895),
    [anon_sym_string] = ACTIONS(895),
    [anon_sym_symbol] = ACTIONS(895),
    [anon_sym_implements] = ACTIONS(860),
    [sym_readonly] = ACTIONS(961),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [90] = {
    [ts_builtin_sym_end] = ACTIONS(1059),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_default] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(1061),
    [anon_sym_var] = ACTIONS(1061),
    [anon_sym_let] = ACTIONS(1061),
    [anon_sym_const] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_switch] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_await] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_do] = ACTIONS(1061),
    [anon_sym_try] = ACTIONS(1061),
    [anon_sym_with] = ACTIONS(1061),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_continue] = ACTIONS(1061),
    [anon_sym_debugger] = ACTIONS(1061),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_throw] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_case] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_function] = ACTIONS(1061),
    [anon_sym_QMARK_DOT] = ACTIONS(1059),
    [anon_sym_new] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_GT_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(1059),
    [anon_sym_STAR_STAR] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1059),
    [anon_sym_BANG_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_QMARK_QMARK] = ACTIONS(1059),
    [anon_sym_instanceof] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [sym_number] = ACTIONS(1059),
    [sym_this] = ACTIONS(1061),
    [sym_super] = ACTIONS(1061),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_null] = ACTIONS(1061),
    [sym_undefined] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1059),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_abstract] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_interface] = ACTIONS(1061),
    [anon_sym_enum] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
    [sym__automatic_semicolon] = ACTIONS(1059),
  },
  [91] = {
    [ts_builtin_sym_end] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1065),
    [anon_sym_export] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_default] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1065),
    [anon_sym_typeof] = ACTIONS(1065),
    [anon_sym_import] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1065),
    [anon_sym_let] = ACTIONS(1065),
    [anon_sym_const] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1065),
    [anon_sym_else] = ACTIONS(1065),
    [anon_sym_if] = ACTIONS(1065),
    [anon_sym_switch] = ACTIONS(1065),
    [anon_sym_for] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_await] = ACTIONS(1065),
    [anon_sym_in] = ACTIONS(1067),
    [anon_sym_while] = ACTIONS(1065),
    [anon_sym_do] = ACTIONS(1065),
    [anon_sym_try] = ACTIONS(1065),
    [anon_sym_with] = ACTIONS(1065),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_continue] = ACTIONS(1065),
    [anon_sym_debugger] = ACTIONS(1065),
    [anon_sym_return] = ACTIONS(1065),
    [anon_sym_throw] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_case] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_class] = ACTIONS(1065),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(1065),
    [anon_sym_QMARK_DOT] = ACTIONS(1069),
    [anon_sym_new] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_GT_GT] = ACTIONS(1067),
    [anon_sym_GT_GT_GT] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_CARET] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1069),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_EQ_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1069),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK] = ACTIONS(1069),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_void] = ACTIONS(1065),
    [anon_sym_delete] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [sym_number] = ACTIONS(1063),
    [sym_this] = ACTIONS(1065),
    [sym_super] = ACTIONS(1065),
    [sym_true] = ACTIONS(1065),
    [sym_false] = ACTIONS(1065),
    [sym_null] = ACTIONS(1065),
    [sym_undefined] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1063),
    [anon_sym_static] = ACTIONS(1065),
    [anon_sym_abstract] = ACTIONS(1065),
    [anon_sym_get] = ACTIONS(1065),
    [anon_sym_set] = ACTIONS(1065),
    [anon_sym_declare] = ACTIONS(1065),
    [anon_sym_public] = ACTIONS(1065),
    [anon_sym_private] = ACTIONS(1065),
    [anon_sym_protected] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(1065),
    [anon_sym_any] = ACTIONS(1065),
    [anon_sym_number] = ACTIONS(1065),
    [anon_sym_boolean] = ACTIONS(1065),
    [anon_sym_string] = ACTIONS(1065),
    [anon_sym_symbol] = ACTIONS(1065),
    [anon_sym_interface] = ACTIONS(1065),
    [anon_sym_enum] = ACTIONS(1065),
    [sym_readonly] = ACTIONS(1065),
    [sym__automatic_semicolon] = ACTIONS(1071),
  },
  [92] = {
    [ts_builtin_sym_end] = ACTIONS(1073),
    [sym_identifier] = ACTIONS(1075),
    [anon_sym_export] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_default] = ACTIONS(1075),
    [anon_sym_as] = ACTIONS(1077),
    [anon_sym_namespace] = ACTIONS(1075),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1079),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_type] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(1075),
    [anon_sym_import] = ACTIONS(1075),
    [anon_sym_var] = ACTIONS(1075),
    [anon_sym_let] = ACTIONS(1075),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_else] = ACTIONS(1075),
    [anon_sym_if] = ACTIONS(1075),
    [anon_sym_switch] = ACTIONS(1075),
    [anon_sym_for] = ACTIONS(1075),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_await] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_while] = ACTIONS(1075),
    [anon_sym_do] = ACTIONS(1075),
    [anon_sym_try] = ACTIONS(1075),
    [anon_sym_with] = ACTIONS(1075),
    [anon_sym_break] = ACTIONS(1075),
    [anon_sym_continue] = ACTIONS(1075),
    [anon_sym_debugger] = ACTIONS(1075),
    [anon_sym_return] = ACTIONS(1075),
    [anon_sym_throw] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_case] = ACTIONS(1075),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1077),
    [anon_sym_SLASH] = ACTIONS(1075),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_class] = ACTIONS(1075),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_function] = ACTIONS(1075),
    [anon_sym_QMARK_DOT] = ACTIONS(1079),
    [anon_sym_new] = ACTIONS(1075),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1079),
    [anon_sym_PIPE_PIPE] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1077),
    [anon_sym_GT_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_LT] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_PIPE] = ACTIONS(1077),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_PERCENT] = ACTIONS(1079),
    [anon_sym_STAR_STAR] = ACTIONS(1079),
    [anon_sym_LT_EQ] = ACTIONS(1079),
    [anon_sym_EQ_EQ] = ACTIONS(1077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1079),
    [anon_sym_BANG_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1079),
    [anon_sym_GT_EQ] = ACTIONS(1079),
    [anon_sym_QMARK_QMARK] = ACTIONS(1079),
    [anon_sym_instanceof] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1073),
    [anon_sym_void] = ACTIONS(1075),
    [anon_sym_delete] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [anon_sym_DQUOTE] = ACTIONS(1073),
    [anon_sym_SQUOTE] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [sym_number] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [sym_super] = ACTIONS(1075),
    [sym_true] = ACTIONS(1075),
    [sym_false] = ACTIONS(1075),
    [sym_null] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(1073),
    [anon_sym_static] = ACTIONS(1075),
    [anon_sym_abstract] = ACTIONS(1075),
    [anon_sym_get] = ACTIONS(1075),
    [anon_sym_set] = ACTIONS(1075),
    [anon_sym_declare] = ACTIONS(1075),
    [anon_sym_public] = ACTIONS(1075),
    [anon_sym_private] = ACTIONS(1075),
    [anon_sym_protected] = ACTIONS(1075),
    [anon_sym_module] = ACTIONS(1075),
    [anon_sym_any] = ACTIONS(1075),
    [anon_sym_number] = ACTIONS(1075),
    [anon_sym_boolean] = ACTIONS(1075),
    [anon_sym_string] = ACTIONS(1075),
    [anon_sym_symbol] = ACTIONS(1075),
    [anon_sym_interface] = ACTIONS(1075),
    [anon_sym_enum] = ACTIONS(1075),
    [sym_readonly] = ACTIONS(1075),
    [sym__automatic_semicolon] = ACTIONS(1081),
  },
  [93] = {
    [ts_builtin_sym_end] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1085),
    [anon_sym_export] = ACTIONS(1085),
    [anon_sym_STAR] = ACTIONS(1087),
    [anon_sym_default] = ACTIONS(1085),
    [anon_sym_as] = ACTIONS(1087),
    [anon_sym_namespace] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1083),
    [anon_sym_type] = ACTIONS(1085),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_var] = ACTIONS(1085),
    [anon_sym_let] = ACTIONS(1085),
    [anon_sym_const] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1085),
    [anon_sym_else] = ACTIONS(1085),
    [anon_sym_if] = ACTIONS(1085),
    [anon_sym_switch] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1085),
    [anon_sym_LPAREN] = ACTIONS(1083),
    [anon_sym_await] = ACTIONS(1085),
    [anon_sym_in] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1085),
    [anon_sym_try] = ACTIONS(1085),
    [anon_sym_with] = ACTIONS(1085),
    [anon_sym_break] = ACTIONS(1085),
    [anon_sym_continue] = ACTIONS(1085),
    [anon_sym_debugger] = ACTIONS(1085),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1085),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_SLASH] = ACTIONS(1085),
    [anon_sym_DOT] = ACTIONS(1087),
    [anon_sym_class] = ACTIONS(1085),
    [anon_sym_async] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(1085),
    [anon_sym_QMARK_DOT] = ACTIONS(1089),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_QMARK] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1087),
    [anon_sym_GT_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1087),
    [anon_sym_CARET] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_PERCENT] = ACTIONS(1089),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1087),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1087),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_QMARK_QMARK] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1087),
    [anon_sym_TILDE] = ACTIONS(1083),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1083),
    [anon_sym_DQUOTE] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1083),
    [sym_number] = ACTIONS(1083),
    [sym_this] = ACTIONS(1085),
    [sym_super] = ACTIONS(1085),
    [sym_true] = ACTIONS(1085),
    [sym_false] = ACTIONS(1085),
    [sym_null] = ACTIONS(1085),
    [sym_undefined] = ACTIONS(1085),
    [anon_sym_AT] = ACTIONS(1083),
    [anon_sym_static] = ACTIONS(1085),
    [anon_sym_abstract] = ACTIONS(1085),
    [anon_sym_get] = ACTIONS(1085),
    [anon_sym_set] = ACTIONS(1085),
    [anon_sym_declare] = ACTIONS(1085),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_private] = ACTIONS(1085),
    [anon_sym_protected] = ACTIONS(1085),
    [anon_sym_module] = ACTIONS(1085),
    [anon_sym_any] = ACTIONS(1085),
    [anon_sym_number] = ACTIONS(1085),
    [anon_sym_boolean] = ACTIONS(1085),
    [anon_sym_string] = ACTIONS(1085),
    [anon_sym_symbol] = ACTIONS(1085),
    [anon_sym_interface] = ACTIONS(1085),
    [anon_sym_enum] = ACTIONS(1085),
    [sym_readonly] = ACTIONS(1085),
    [sym__automatic_semicolon] = ACTIONS(1091),
  },
  [94] = {
    [ts_builtin_sym_end] = ACTIONS(1093),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_default] = ACTIONS(1095),
    [anon_sym_as] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_typeof] = ACTIONS(1095),
    [anon_sym_import] = ACTIONS(1095),
    [anon_sym_var] = ACTIONS(1095),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_const] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_switch] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_await] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_try] = ACTIONS(1095),
    [anon_sym_with] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_continue] = ACTIONS(1095),
    [anon_sym_debugger] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_throw] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_function] = ACTIONS(1095),
    [anon_sym_QMARK_DOT] = ACTIONS(1093),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_GT_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_CARET] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1093),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_QMARK_QMARK] = ACTIONS(1093),
    [anon_sym_instanceof] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(1095),
    [anon_sym_delete] = ACTIONS(1095),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_SQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_number] = ACTIONS(1093),
    [sym_this] = ACTIONS(1095),
    [sym_super] = ACTIONS(1095),
    [sym_true] = ACTIONS(1095),
    [sym_false] = ACTIONS(1095),
    [sym_null] = ACTIONS(1095),
    [sym_undefined] = ACTIONS(1095),
    [anon_sym_AT] = ACTIONS(1093),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_abstract] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_interface] = ACTIONS(1095),
    [anon_sym_enum] = ACTIONS(1095),
    [sym_readonly] = ACTIONS(1095),
    [sym__automatic_semicolon] = ACTIONS(1093),
  },
  [95] = {
    [ts_builtin_sym_end] = ACTIONS(1097),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(1099),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_default] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(1099),
    [anon_sym_namespace] = ACTIONS(1099),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [anon_sym_COMMA] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1099),
    [anon_sym_var] = ACTIONS(1099),
    [anon_sym_let] = ACTIONS(1099),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_else] = ACTIONS(1099),
    [anon_sym_if] = ACTIONS(1099),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_await] = ACTIONS(1099),
    [anon_sym_in] = ACTIONS(1099),
    [anon_sym_while] = ACTIONS(1099),
    [anon_sym_do] = ACTIONS(1099),
    [anon_sym_try] = ACTIONS(1099),
    [anon_sym_with] = ACTIONS(1099),
    [anon_sym_break] = ACTIONS(1099),
    [anon_sym_continue] = ACTIONS(1099),
    [anon_sym_debugger] = ACTIONS(1099),
    [anon_sym_return] = ACTIONS(1099),
    [anon_sym_throw] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_case] = ACTIONS(1099),
    [anon_sym_yield] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(1099),
    [anon_sym_DOT] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1099),
    [anon_sym_function] = ACTIONS(1099),
    [anon_sym_QMARK_DOT] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_GT_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_PERCENT] = ACTIONS(1097),
    [anon_sym_STAR_STAR] = ACTIONS(1097),
    [anon_sym_LT_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ] = ACTIONS(1099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1097),
    [anon_sym_QMARK_QMARK] = ACTIONS(1097),
    [anon_sym_instanceof] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_void] = ACTIONS(1099),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [sym_number] = ACTIONS(1097),
    [sym_this] = ACTIONS(1099),
    [sym_super] = ACTIONS(1099),
    [sym_true] = ACTIONS(1099),
    [sym_false] = ACTIONS(1099),
    [sym_null] = ACTIONS(1099),
    [sym_undefined] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1097),
    [anon_sym_static] = ACTIONS(1099),
    [anon_sym_abstract] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(1099),
    [anon_sym_set] = ACTIONS(1099),
    [anon_sym_declare] = ACTIONS(1099),
    [anon_sym_public] = ACTIONS(1099),
    [anon_sym_private] = ACTIONS(1099),
    [anon_sym_protected] = ACTIONS(1099),
    [anon_sym_module] = ACTIONS(1099),
    [anon_sym_any] = ACTIONS(1099),
    [anon_sym_number] = ACTIONS(1099),
    [anon_sym_boolean] = ACTIONS(1099),
    [anon_sym_string] = ACTIONS(1099),
    [anon_sym_symbol] = ACTIONS(1099),
    [anon_sym_interface] = ACTIONS(1099),
    [anon_sym_enum] = ACTIONS(1099),
    [sym_readonly] = ACTIONS(1099),
    [sym__automatic_semicolon] = ACTIONS(1097),
  },
  [96] = {
    [ts_builtin_sym_end] = ACTIONS(1101),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1103),
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_as] = ACTIONS(1105),
    [anon_sym_namespace] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(1101),
    [anon_sym_type] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1103),
    [anon_sym_import] = ACTIONS(1103),
    [anon_sym_var] = ACTIONS(1103),
    [anon_sym_let] = ACTIONS(1103),
    [anon_sym_const] = ACTIONS(1103),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_else] = ACTIONS(1103),
    [anon_sym_if] = ACTIONS(1103),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_for] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(1103),
    [anon_sym_do] = ACTIONS(1103),
    [anon_sym_try] = ACTIONS(1103),
    [anon_sym_with] = ACTIONS(1103),
    [anon_sym_break] = ACTIONS(1103),
    [anon_sym_continue] = ACTIONS(1103),
    [anon_sym_debugger] = ACTIONS(1103),
    [anon_sym_return] = ACTIONS(1103),
    [anon_sym_throw] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_case] = ACTIONS(1103),
    [anon_sym_yield] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_SLASH] = ACTIONS(1103),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_class] = ACTIONS(1103),
    [anon_sym_async] = ACTIONS(1103),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_QMARK_DOT] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1103),
    [anon_sym_QMARK] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_GT_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_PERCENT] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1107),
    [anon_sym_LT_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1107),
    [anon_sym_GT_EQ] = ACTIONS(1107),
    [anon_sym_QMARK_QMARK] = ACTIONS(1107),
    [anon_sym_instanceof] = ACTIONS(1105),
    [anon_sym_TILDE] = ACTIONS(1101),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_PLUS_PLUS] = ACTIONS(1101),
    [anon_sym_DASH_DASH] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_SQUOTE] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [sym_number] = ACTIONS(1101),
    [sym_this] = ACTIONS(1103),
    [sym_super] = ACTIONS(1103),
    [sym_true] = ACTIONS(1103),
    [sym_false] = ACTIONS(1103),
    [sym_null] = ACTIONS(1103),
    [sym_undefined] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(1101),
    [anon_sym_static] = ACTIONS(1103),
    [anon_sym_abstract] = ACTIONS(1103),
    [anon_sym_get] = ACTIONS(1103),
    [anon_sym_set] = ACTIONS(1103),
    [anon_sym_declare] = ACTIONS(1103),
    [anon_sym_public] = ACTIONS(1103),
    [anon_sym_private] = ACTIONS(1103),
    [anon_sym_protected] = ACTIONS(1103),
    [anon_sym_module] = ACTIONS(1103),
    [anon_sym_any] = ACTIONS(1103),
    [anon_sym_number] = ACTIONS(1103),
    [anon_sym_boolean] = ACTIONS(1103),
    [anon_sym_string] = ACTIONS(1103),
    [anon_sym_symbol] = ACTIONS(1103),
    [anon_sym_interface] = ACTIONS(1103),
    [anon_sym_enum] = ACTIONS(1103),
    [sym_readonly] = ACTIONS(1103),
    [sym__automatic_semicolon] = ACTIONS(1109),
  },
  [97] = {
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_formal_parameters] = STATE(3565),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(3018),
    [sym_constructor_type] = STATE(3018),
    [sym__primary_type] = STATE(2869),
    [sym_infer_type] = STATE(3018),
    [sym_conditional_type] = STATE(2869),
    [sym_generic_type] = STATE(2869),
    [sym_type_query] = STATE(2869),
    [sym_index_type_query] = STATE(2869),
    [sym_lookup_type] = STATE(2869),
    [sym_literal_type] = STATE(2869),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(2869),
    [sym_flow_maybe_type] = STATE(2869),
    [sym_parenthesized_type] = STATE(2869),
    [sym_predefined_type] = STATE(2869),
    [sym_object_type] = STATE(2869),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(2869),
    [sym__tuple_type_body] = STATE(2090),
    [sym_tuple_type] = STATE(2869),
    [sym_union_type] = STATE(3018),
    [sym_intersection_type] = STATE(3018),
    [sym_function_type] = STATE(3018),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_EQ] = ACTIONS(953),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(955),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(875),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(885),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(1113),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_any] = ACTIONS(895),
    [anon_sym_number] = ACTIONS(895),
    [anon_sym_boolean] = ACTIONS(895),
    [anon_sym_string] = ACTIONS(895),
    [anon_sym_symbol] = ACTIONS(895),
    [sym_readonly] = ACTIONS(961),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [98] = {
    [ts_builtin_sym_end] = ACTIONS(1115),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_export] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_default] = ACTIONS(1117),
    [anon_sym_as] = ACTIONS(1119),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(1121),
    [anon_sym_RBRACE] = ACTIONS(1115),
    [anon_sym_type] = ACTIONS(1117),
    [anon_sym_typeof] = ACTIONS(1117),
    [anon_sym_import] = ACTIONS(1117),
    [anon_sym_var] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_const] = ACTIONS(1117),
    [anon_sym_BANG] = ACTIONS(1117),
    [anon_sym_else] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_switch] = ACTIONS(1117),
    [anon_sym_for] = ACTIONS(1117),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_await] = ACTIONS(1117),
    [anon_sym_in] = ACTIONS(1119),
    [anon_sym_while] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1117),
    [anon_sym_with] = ACTIONS(1117),
    [anon_sym_break] = ACTIONS(1117),
    [anon_sym_continue] = ACTIONS(1117),
    [anon_sym_debugger] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1117),
    [anon_sym_throw] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1115),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_yield] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1119),
    [anon_sym_SLASH] = ACTIONS(1117),
    [anon_sym_DOT] = ACTIONS(1119),
    [anon_sym_class] = ACTIONS(1117),
    [anon_sym_async] = ACTIONS(1117),
    [anon_sym_function] = ACTIONS(1117),
    [anon_sym_QMARK_DOT] = ACTIONS(1121),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1119),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ] = ACTIONS(1119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1121),
    [anon_sym_GT_EQ] = ACTIONS(1121),
    [anon_sym_QMARK_QMARK] = ACTIONS(1121),
    [anon_sym_instanceof] = ACTIONS(1119),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_void] = ACTIONS(1117),
    [anon_sym_delete] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [sym_number] = ACTIONS(1115),
    [sym_this] = ACTIONS(1117),
    [sym_super] = ACTIONS(1117),
    [sym_true] = ACTIONS(1117),
    [sym_false] = ACTIONS(1117),
    [sym_null] = ACTIONS(1117),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(1115),
    [anon_sym_static] = ACTIONS(1117),
    [anon_sym_abstract] = ACTIONS(1117),
    [anon_sym_get] = ACTIONS(1117),
    [anon_sym_set] = ACTIONS(1117),
    [anon_sym_declare] = ACTIONS(1117),
    [anon_sym_public] = ACTIONS(1117),
    [anon_sym_private] = ACTIONS(1117),
    [anon_sym_protected] = ACTIONS(1117),
    [anon_sym_module] = ACTIONS(1117),
    [anon_sym_any] = ACTIONS(1117),
    [anon_sym_number] = ACTIONS(1117),
    [anon_sym_boolean] = ACTIONS(1117),
    [anon_sym_string] = ACTIONS(1117),
    [anon_sym_symbol] = ACTIONS(1117),
    [anon_sym_interface] = ACTIONS(1117),
    [anon_sym_enum] = ACTIONS(1117),
    [sym_readonly] = ACTIONS(1117),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [99] = {
    [ts_builtin_sym_end] = ACTIONS(1125),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_as] = ACTIONS(1129),
    [anon_sym_namespace] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1125),
    [anon_sym_type] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1127),
    [anon_sym_import] = ACTIONS(1127),
    [anon_sym_var] = ACTIONS(1127),
    [anon_sym_let] = ACTIONS(1127),
    [anon_sym_const] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(1127),
    [anon_sym_else] = ACTIONS(1127),
    [anon_sym_if] = ACTIONS(1127),
    [anon_sym_switch] = ACTIONS(1127),
    [anon_sym_for] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(1125),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_in] = ACTIONS(1129),
    [anon_sym_while] = ACTIONS(1127),
    [anon_sym_do] = ACTIONS(1127),
    [anon_sym_try] = ACTIONS(1127),
    [anon_sym_with] = ACTIONS(1127),
    [anon_sym_break] = ACTIONS(1127),
    [anon_sym_continue] = ACTIONS(1127),
    [anon_sym_debugger] = ACTIONS(1127),
    [anon_sym_return] = ACTIONS(1127),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1127),
    [anon_sym_yield] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1129),
    [anon_sym_class] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1127),
    [anon_sym_function] = ACTIONS(1127),
    [anon_sym_QMARK_DOT] = ACTIONS(1131),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1131),
    [anon_sym_PIPE_PIPE] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_GT_GT_GT] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1131),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_PERCENT] = ACTIONS(1131),
    [anon_sym_STAR_STAR] = ACTIONS(1131),
    [anon_sym_LT_EQ] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1131),
    [anon_sym_BANG_EQ] = ACTIONS(1129),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1131),
    [anon_sym_GT_EQ] = ACTIONS(1131),
    [anon_sym_QMARK_QMARK] = ACTIONS(1131),
    [anon_sym_instanceof] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1125),
    [anon_sym_void] = ACTIONS(1127),
    [anon_sym_delete] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1125),
    [anon_sym_DASH_DASH] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [sym_number] = ACTIONS(1125),
    [sym_this] = ACTIONS(1127),
    [sym_super] = ACTIONS(1127),
    [sym_true] = ACTIONS(1127),
    [sym_false] = ACTIONS(1127),
    [sym_null] = ACTIONS(1127),
    [sym_undefined] = ACTIONS(1127),
    [anon_sym_AT] = ACTIONS(1125),
    [anon_sym_static] = ACTIONS(1127),
    [anon_sym_abstract] = ACTIONS(1127),
    [anon_sym_get] = ACTIONS(1127),
    [anon_sym_set] = ACTIONS(1127),
    [anon_sym_declare] = ACTIONS(1127),
    [anon_sym_public] = ACTIONS(1127),
    [anon_sym_private] = ACTIONS(1127),
    [anon_sym_protected] = ACTIONS(1127),
    [anon_sym_module] = ACTIONS(1127),
    [anon_sym_any] = ACTIONS(1127),
    [anon_sym_number] = ACTIONS(1127),
    [anon_sym_boolean] = ACTIONS(1127),
    [anon_sym_string] = ACTIONS(1127),
    [anon_sym_symbol] = ACTIONS(1127),
    [anon_sym_interface] = ACTIONS(1127),
    [anon_sym_enum] = ACTIONS(1127),
    [sym_readonly] = ACTIONS(1127),
    [sym__automatic_semicolon] = ACTIONS(1133),
  },
  [100] = {
    [ts_builtin_sym_end] = ACTIONS(1135),
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_export] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_as] = ACTIONS(1139),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1137),
    [anon_sym_typeof] = ACTIONS(1137),
    [anon_sym_import] = ACTIONS(1137),
    [anon_sym_var] = ACTIONS(1137),
    [anon_sym_let] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_await] = ACTIONS(1137),
    [anon_sym_in] = ACTIONS(1139),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_try] = ACTIONS(1137),
    [anon_sym_with] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_debugger] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_throw] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_yield] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_GT] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_class] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1137),
    [anon_sym_function] = ACTIONS(1137),
    [anon_sym_QMARK_DOT] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1137),
    [anon_sym_QMARK] = ACTIONS(1139),
    [anon_sym_AMP_AMP] = ACTIONS(1141),
    [anon_sym_PIPE_PIPE] = ACTIONS(1141),
    [anon_sym_GT_GT] = ACTIONS(1139),
    [anon_sym_GT_GT_GT] = ACTIONS(1141),
    [anon_sym_LT_LT] = ACTIONS(1141),
    [anon_sym_AMP] = ACTIONS(1139),
    [anon_sym_CARET] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1139),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1141),
    [anon_sym_STAR_STAR] = ACTIONS(1141),
    [anon_sym_LT_EQ] = ACTIONS(1141),
    [anon_sym_EQ_EQ] = ACTIONS(1139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1141),
    [anon_sym_BANG_EQ] = ACTIONS(1139),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1141),
    [anon_sym_GT_EQ] = ACTIONS(1141),
    [anon_sym_QMARK_QMARK] = ACTIONS(1141),
    [anon_sym_instanceof] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_void] = ACTIONS(1137),
    [anon_sym_delete] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1135),
    [sym_this] = ACTIONS(1137),
    [sym_super] = ACTIONS(1137),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [sym_null] = ACTIONS(1137),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_abstract] = ACTIONS(1137),
    [anon_sym_get] = ACTIONS(1137),
    [anon_sym_set] = ACTIONS(1137),
    [anon_sym_declare] = ACTIONS(1137),
    [anon_sym_public] = ACTIONS(1137),
    [anon_sym_private] = ACTIONS(1137),
    [anon_sym_protected] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1137),
    [anon_sym_any] = ACTIONS(1137),
    [anon_sym_number] = ACTIONS(1137),
    [anon_sym_boolean] = ACTIONS(1137),
    [anon_sym_string] = ACTIONS(1137),
    [anon_sym_symbol] = ACTIONS(1137),
    [anon_sym_interface] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [sym_readonly] = ACTIONS(1137),
    [sym__automatic_semicolon] = ACTIONS(1143),
  },
  [101] = {
    [ts_builtin_sym_end] = ACTIONS(1145),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(1147),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1147),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(1147),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_type] = ACTIONS(1147),
    [anon_sym_typeof] = ACTIONS(1147),
    [anon_sym_import] = ACTIONS(1147),
    [anon_sym_var] = ACTIONS(1147),
    [anon_sym_let] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_else] = ACTIONS(1147),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1147),
    [anon_sym_do] = ACTIONS(1147),
    [anon_sym_try] = ACTIONS(1147),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_break] = ACTIONS(1147),
    [anon_sym_continue] = ACTIONS(1147),
    [anon_sym_debugger] = ACTIONS(1147),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_throw] = ACTIONS(1147),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_case] = ACTIONS(1147),
    [anon_sym_yield] = ACTIONS(1147),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_class] = ACTIONS(1147),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(1147),
    [anon_sym_QMARK_DOT] = ACTIONS(1145),
    [anon_sym_new] = ACTIONS(1147),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1145),
    [anon_sym_PIPE_PIPE] = ACTIONS(1145),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_GT_GT_GT] = ACTIONS(1145),
    [anon_sym_LT_LT] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_STAR_STAR] = ACTIONS(1145),
    [anon_sym_LT_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ] = ACTIONS(1147),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ] = ACTIONS(1147),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1145),
    [anon_sym_GT_EQ] = ACTIONS(1145),
    [anon_sym_QMARK_QMARK] = ACTIONS(1145),
    [anon_sym_instanceof] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1145),
    [anon_sym_void] = ACTIONS(1147),
    [anon_sym_delete] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1145),
    [anon_sym_SQUOTE] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [sym_number] = ACTIONS(1145),
    [sym_this] = ACTIONS(1147),
    [sym_super] = ACTIONS(1147),
    [sym_true] = ACTIONS(1147),
    [sym_false] = ACTIONS(1147),
    [sym_null] = ACTIONS(1147),
    [sym_undefined] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(1145),
    [anon_sym_static] = ACTIONS(1147),
    [anon_sym_abstract] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(1147),
    [anon_sym_set] = ACTIONS(1147),
    [anon_sym_declare] = ACTIONS(1147),
    [anon_sym_public] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(1147),
    [anon_sym_protected] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(1147),
    [anon_sym_any] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(1147),
    [anon_sym_interface] = ACTIONS(1147),
    [anon_sym_enum] = ACTIONS(1147),
    [sym_readonly] = ACTIONS(1147),
    [sym__automatic_semicolon] = ACTIONS(1145),
  },
  [102] = {
    [ts_builtin_sym_end] = ACTIONS(1149),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_export] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1153),
    [anon_sym_default] = ACTIONS(1151),
    [anon_sym_as] = ACTIONS(1153),
    [anon_sym_namespace] = ACTIONS(1151),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_type] = ACTIONS(1151),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_import] = ACTIONS(1151),
    [anon_sym_var] = ACTIONS(1151),
    [anon_sym_let] = ACTIONS(1151),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_else] = ACTIONS(1151),
    [anon_sym_if] = ACTIONS(1151),
    [anon_sym_switch] = ACTIONS(1151),
    [anon_sym_for] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1149),
    [anon_sym_await] = ACTIONS(1151),
    [anon_sym_in] = ACTIONS(1153),
    [anon_sym_while] = ACTIONS(1151),
    [anon_sym_do] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1151),
    [anon_sym_with] = ACTIONS(1151),
    [anon_sym_break] = ACTIONS(1151),
    [anon_sym_continue] = ACTIONS(1151),
    [anon_sym_debugger] = ACTIONS(1151),
    [anon_sym_return] = ACTIONS(1151),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_SEMI] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1151),
    [anon_sym_yield] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1151),
    [anon_sym_GT] = ACTIONS(1153),
    [anon_sym_SLASH] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(1153),
    [anon_sym_class] = ACTIONS(1151),
    [anon_sym_async] = ACTIONS(1151),
    [anon_sym_function] = ACTIONS(1151),
    [anon_sym_QMARK_DOT] = ACTIONS(1155),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_QMARK] = ACTIONS(1153),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1153),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1153),
    [anon_sym_CARET] = ACTIONS(1155),
    [anon_sym_PIPE] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_STAR_STAR] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1153),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1153),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_instanceof] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1149),
    [anon_sym_void] = ACTIONS(1151),
    [anon_sym_delete] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [anon_sym_SQUOTE] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1149),
    [sym_number] = ACTIONS(1149),
    [sym_this] = ACTIONS(1151),
    [sym_super] = ACTIONS(1151),
    [sym_true] = ACTIONS(1151),
    [sym_false] = ACTIONS(1151),
    [sym_null] = ACTIONS(1151),
    [sym_undefined] = ACTIONS(1151),
    [anon_sym_AT] = ACTIONS(1149),
    [anon_sym_static] = ACTIONS(1151),
    [anon_sym_abstract] = ACTIONS(1151),
    [anon_sym_get] = ACTIONS(1151),
    [anon_sym_set] = ACTIONS(1151),
    [anon_sym_declare] = ACTIONS(1151),
    [anon_sym_public] = ACTIONS(1151),
    [anon_sym_private] = ACTIONS(1151),
    [anon_sym_protected] = ACTIONS(1151),
    [anon_sym_module] = ACTIONS(1151),
    [anon_sym_any] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1151),
    [anon_sym_boolean] = ACTIONS(1151),
    [anon_sym_string] = ACTIONS(1151),
    [anon_sym_symbol] = ACTIONS(1151),
    [anon_sym_interface] = ACTIONS(1151),
    [anon_sym_enum] = ACTIONS(1151),
    [sym_readonly] = ACTIONS(1151),
    [sym__automatic_semicolon] = ACTIONS(1157),
  },
  [103] = {
    [ts_builtin_sym_end] = ACTIONS(1159),
    [sym_identifier] = ACTIONS(1161),
    [anon_sym_export] = ACTIONS(1161),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_default] = ACTIONS(1161),
    [anon_sym_as] = ACTIONS(1161),
    [anon_sym_namespace] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_type] = ACTIONS(1161),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_import] = ACTIONS(1161),
    [anon_sym_var] = ACTIONS(1161),
    [anon_sym_let] = ACTIONS(1161),
    [anon_sym_const] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_else] = ACTIONS(1161),
    [anon_sym_if] = ACTIONS(1161),
    [anon_sym_switch] = ACTIONS(1161),
    [anon_sym_for] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_await] = ACTIONS(1161),
    [anon_sym_in] = ACTIONS(1161),
    [anon_sym_while] = ACTIONS(1161),
    [anon_sym_do] = ACTIONS(1161),
    [anon_sym_try] = ACTIONS(1161),
    [anon_sym_with] = ACTIONS(1161),
    [anon_sym_break] = ACTIONS(1161),
    [anon_sym_continue] = ACTIONS(1161),
    [anon_sym_debugger] = ACTIONS(1161),
    [anon_sym_return] = ACTIONS(1161),
    [anon_sym_throw] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(1161),
    [anon_sym_LBRACK] = ACTIONS(1159),
    [anon_sym_LT] = ACTIONS(1161),
    [anon_sym_GT] = ACTIONS(1161),
    [anon_sym_SLASH] = ACTIONS(1161),
    [anon_sym_DOT] = ACTIONS(1161),
    [anon_sym_class] = ACTIONS(1161),
    [anon_sym_async] = ACTIONS(1161),
    [anon_sym_function] = ACTIONS(1161),
    [anon_sym_QMARK_DOT] = ACTIONS(1159),
    [anon_sym_new] = ACTIONS(1161),
    [anon_sym_QMARK] = ACTIONS(1161),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1161),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1159),
    [anon_sym_PIPE] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1161),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1161),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_QMARK_QMARK] = ACTIONS(1159),
    [anon_sym_instanceof] = ACTIONS(1161),
    [anon_sym_TILDE] = ACTIONS(1159),
    [anon_sym_void] = ACTIONS(1161),
    [anon_sym_delete] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1159),
    [anon_sym_DASH_DASH] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_SQUOTE] = ACTIONS(1159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1159),
    [sym_number] = ACTIONS(1159),
    [sym_this] = ACTIONS(1161),
    [sym_super] = ACTIONS(1161),
    [sym_true] = ACTIONS(1161),
    [sym_false] = ACTIONS(1161),
    [sym_null] = ACTIONS(1161),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_AT] = ACTIONS(1159),
    [anon_sym_static] = ACTIONS(1161),
    [anon_sym_abstract] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(1161),
    [anon_sym_set] = ACTIONS(1161),
    [anon_sym_declare] = ACTIONS(1161),
    [anon_sym_public] = ACTIONS(1161),
    [anon_sym_private] = ACTIONS(1161),
    [anon_sym_protected] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(1161),
    [anon_sym_any] = ACTIONS(1161),
    [anon_sym_number] = ACTIONS(1161),
    [anon_sym_boolean] = ACTIONS(1161),
    [anon_sym_string] = ACTIONS(1161),
    [anon_sym_symbol] = ACTIONS(1161),
    [anon_sym_interface] = ACTIONS(1161),
    [anon_sym_enum] = ACTIONS(1161),
    [sym_readonly] = ACTIONS(1161),
    [sym__automatic_semicolon] = ACTIONS(1159),
  },
  [104] = {
    [ts_builtin_sym_end] = ACTIONS(1163),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_export] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(1165),
    [anon_sym_namespace] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_type] = ACTIONS(1165),
    [anon_sym_typeof] = ACTIONS(1165),
    [anon_sym_import] = ACTIONS(1165),
    [anon_sym_var] = ACTIONS(1165),
    [anon_sym_let] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_else] = ACTIONS(1165),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_switch] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_in] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_do] = ACTIONS(1165),
    [anon_sym_try] = ACTIONS(1165),
    [anon_sym_with] = ACTIONS(1165),
    [anon_sym_break] = ACTIONS(1165),
    [anon_sym_continue] = ACTIONS(1165),
    [anon_sym_debugger] = ACTIONS(1165),
    [anon_sym_return] = ACTIONS(1165),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_case] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_class] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1165),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_QMARK_DOT] = ACTIONS(1163),
    [anon_sym_new] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1165),
    [anon_sym_AMP_AMP] = ACTIONS(1163),
    [anon_sym_PIPE_PIPE] = ACTIONS(1163),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_GT_GT_GT] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(1163),
    [anon_sym_LT_EQ] = ACTIONS(1163),
    [anon_sym_EQ_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1163),
    [anon_sym_BANG_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1163),
    [anon_sym_GT_EQ] = ACTIONS(1163),
    [anon_sym_QMARK_QMARK] = ACTIONS(1163),
    [anon_sym_instanceof] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_void] = ACTIONS(1165),
    [anon_sym_delete] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1163),
    [sym_number] = ACTIONS(1163),
    [sym_this] = ACTIONS(1165),
    [sym_super] = ACTIONS(1165),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [sym_null] = ACTIONS(1165),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(1163),
    [anon_sym_static] = ACTIONS(1165),
    [anon_sym_abstract] = ACTIONS(1165),
    [anon_sym_get] = ACTIONS(1165),
    [anon_sym_set] = ACTIONS(1165),
    [anon_sym_declare] = ACTIONS(1165),
    [anon_sym_public] = ACTIONS(1165),
    [anon_sym_private] = ACTIONS(1165),
    [anon_sym_protected] = ACTIONS(1165),
    [anon_sym_module] = ACTIONS(1165),
    [anon_sym_any] = ACTIONS(1165),
    [anon_sym_number] = ACTIONS(1165),
    [anon_sym_boolean] = ACTIONS(1165),
    [anon_sym_string] = ACTIONS(1165),
    [anon_sym_symbol] = ACTIONS(1165),
    [anon_sym_interface] = ACTIONS(1165),
    [anon_sym_enum] = ACTIONS(1165),
    [sym_readonly] = ACTIONS(1165),
    [sym__automatic_semicolon] = ACTIONS(1163),
  },
  [105] = {
    [ts_builtin_sym_end] = ACTIONS(973),
    [sym_identifier] = ACTIONS(975),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_default] = ACTIONS(975),
    [anon_sym_as] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(975),
    [anon_sym_import] = ACTIONS(975),
    [anon_sym_var] = ACTIONS(975),
    [anon_sym_let] = ACTIONS(975),
    [anon_sym_const] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_else] = ACTIONS(975),
    [anon_sym_if] = ACTIONS(975),
    [anon_sym_switch] = ACTIONS(975),
    [anon_sym_for] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(973),
    [anon_sym_await] = ACTIONS(975),
    [anon_sym_in] = ACTIONS(975),
    [anon_sym_while] = ACTIONS(975),
    [anon_sym_do] = ACTIONS(975),
    [anon_sym_try] = ACTIONS(975),
    [anon_sym_with] = ACTIONS(975),
    [anon_sym_break] = ACTIONS(975),
    [anon_sym_continue] = ACTIONS(975),
    [anon_sym_debugger] = ACTIONS(975),
    [anon_sym_return] = ACTIONS(975),
    [anon_sym_throw] = ACTIONS(975),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_case] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(973),
    [anon_sym_LT] = ACTIONS(975),
    [anon_sym_GT] = ACTIONS(975),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_DOT] = ACTIONS(975),
    [anon_sym_class] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_QMARK_DOT] = ACTIONS(973),
    [anon_sym_new] = ACTIONS(975),
    [anon_sym_QMARK] = ACTIONS(975),
    [anon_sym_AMP_AMP] = ACTIONS(973),
    [anon_sym_PIPE_PIPE] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(975),
    [anon_sym_GT_GT_GT] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_CARET] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_STAR_STAR] = ACTIONS(973),
    [anon_sym_LT_EQ] = ACTIONS(973),
    [anon_sym_EQ_EQ] = ACTIONS(975),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(973),
    [anon_sym_BANG_EQ] = ACTIONS(975),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(973),
    [anon_sym_GT_EQ] = ACTIONS(973),
    [anon_sym_QMARK_QMARK] = ACTIONS(973),
    [anon_sym_instanceof] = ACTIONS(975),
    [anon_sym_TILDE] = ACTIONS(973),
    [anon_sym_void] = ACTIONS(975),
    [anon_sym_delete] = ACTIONS(975),
    [anon_sym_PLUS_PLUS] = ACTIONS(973),
    [anon_sym_DASH_DASH] = ACTIONS(973),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(973),
    [sym_number] = ACTIONS(973),
    [sym_this] = ACTIONS(975),
    [sym_super] = ACTIONS(975),
    [sym_true] = ACTIONS(975),
    [sym_false] = ACTIONS(975),
    [sym_null] = ACTIONS(975),
    [sym_undefined] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(973),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_abstract] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_interface] = ACTIONS(975),
    [anon_sym_enum] = ACTIONS(975),
    [sym_readonly] = ACTIONS(975),
    [sym__automatic_semicolon] = ACTIONS(1167),
  },
  [106] = {
    [ts_builtin_sym_end] = ACTIONS(1093),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_default] = ACTIONS(1095),
    [anon_sym_as] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_typeof] = ACTIONS(1095),
    [anon_sym_import] = ACTIONS(1095),
    [anon_sym_var] = ACTIONS(1095),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_const] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_switch] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_await] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_try] = ACTIONS(1095),
    [anon_sym_with] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_continue] = ACTIONS(1095),
    [anon_sym_debugger] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_throw] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_function] = ACTIONS(1095),
    [anon_sym_QMARK_DOT] = ACTIONS(1093),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_GT_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_CARET] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1093),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_QMARK_QMARK] = ACTIONS(1093),
    [anon_sym_instanceof] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(1095),
    [anon_sym_delete] = ACTIONS(1095),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_SQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_number] = ACTIONS(1093),
    [sym_this] = ACTIONS(1095),
    [sym_super] = ACTIONS(1095),
    [sym_true] = ACTIONS(1095),
    [sym_false] = ACTIONS(1095),
    [sym_null] = ACTIONS(1095),
    [sym_undefined] = ACTIONS(1095),
    [anon_sym_AT] = ACTIONS(1093),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_abstract] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_interface] = ACTIONS(1095),
    [anon_sym_enum] = ACTIONS(1095),
    [sym_readonly] = ACTIONS(1095),
    [sym__automatic_semicolon] = ACTIONS(1169),
  },
  [107] = {
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_formal_parameters] = STATE(3565),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(3018),
    [sym_constructor_type] = STATE(3018),
    [sym__primary_type] = STATE(2823),
    [sym_infer_type] = STATE(3018),
    [sym_conditional_type] = STATE(2823),
    [sym_generic_type] = STATE(2823),
    [sym_type_query] = STATE(2823),
    [sym_index_type_query] = STATE(2823),
    [sym_lookup_type] = STATE(2823),
    [sym_literal_type] = STATE(2823),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(2823),
    [sym_flow_maybe_type] = STATE(2823),
    [sym_parenthesized_type] = STATE(2823),
    [sym_predefined_type] = STATE(2823),
    [sym_object_type] = STATE(2823),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(2823),
    [sym__tuple_type_body] = STATE(434),
    [sym_tuple_type] = STATE(2823),
    [sym_union_type] = STATE(3018),
    [sym_intersection_type] = STATE(3018),
    [sym_function_type] = STATE(3018),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_EQ] = ACTIONS(1171),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(955),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_EQ_GT] = ACTIONS(1173),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(885),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(959),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_any] = ACTIONS(895),
    [anon_sym_number] = ACTIONS(895),
    [anon_sym_boolean] = ACTIONS(895),
    [anon_sym_string] = ACTIONS(895),
    [anon_sym_symbol] = ACTIONS(895),
    [sym_readonly] = ACTIONS(961),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [108] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1386),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(2975),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3628),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym__rest_identifier] = STATE(3001),
    [sym_rest_identifier] = STATE(2872),
    [sym_optional_identifier] = STATE(2872),
    [sym__tuple_type_identifier] = STATE(2872),
    [sym_labeled_tuple_type_member] = STATE(3013),
    [sym__tuple_type_member] = STATE(3013),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(2945),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [109] = {
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_formal_parameters] = STATE(3565),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(3018),
    [sym_constructor_type] = STATE(3018),
    [sym__primary_type] = STATE(2823),
    [sym_infer_type] = STATE(3018),
    [sym_conditional_type] = STATE(2823),
    [sym_generic_type] = STATE(2823),
    [sym_type_query] = STATE(2823),
    [sym_index_type_query] = STATE(2823),
    [sym_lookup_type] = STATE(2823),
    [sym_literal_type] = STATE(2823),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(2823),
    [sym_flow_maybe_type] = STATE(2823),
    [sym_parenthesized_type] = STATE(2823),
    [sym_predefined_type] = STATE(2823),
    [sym_object_type] = STATE(2823),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(2823),
    [sym__tuple_type_body] = STATE(434),
    [sym_tuple_type] = STATE(2823),
    [sym_union_type] = STATE(3018),
    [sym_intersection_type] = STATE(3018),
    [sym_function_type] = STATE(3018),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(955),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1187),
    [anon_sym_EQ_GT] = ACTIONS(1189),
    [anon_sym_QMARK_DOT] = ACTIONS(1191),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(885),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(959),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_any] = ACTIONS(895),
    [anon_sym_number] = ACTIONS(895),
    [anon_sym_boolean] = ACTIONS(895),
    [anon_sym_string] = ACTIONS(895),
    [anon_sym_symbol] = ACTIONS(895),
    [sym_readonly] = ACTIONS(961),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [110] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1349),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3076),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym__rest_identifier] = STATE(3001),
    [sym_rest_identifier] = STATE(2872),
    [sym_optional_identifier] = STATE(2872),
    [sym__tuple_type_identifier] = STATE(2872),
    [sym_labeled_tuple_type_member] = STATE(3013),
    [sym__tuple_type_member] = STATE(3013),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(3075),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [111] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1296),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3017),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym__rest_identifier] = STATE(3001),
    [sym_rest_identifier] = STATE(2872),
    [sym_optional_identifier] = STATE(2872),
    [sym__tuple_type_identifier] = STATE(2872),
    [sym_labeled_tuple_type_member] = STATE(3013),
    [sym__tuple_type_member] = STATE(3013),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(3016),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [112] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1296),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3017),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym__rest_identifier] = STATE(3001),
    [sym_rest_identifier] = STATE(2872),
    [sym_optional_identifier] = STATE(2872),
    [sym__tuple_type_identifier] = STATE(2872),
    [sym_labeled_tuple_type_member] = STATE(2987),
    [sym__tuple_type_member] = STATE(2987),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(3016),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1197),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [113] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1289),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(2975),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym__rest_identifier] = STATE(3001),
    [sym_rest_identifier] = STATE(2872),
    [sym_optional_identifier] = STATE(2872),
    [sym__tuple_type_identifier] = STATE(2872),
    [sym_labeled_tuple_type_member] = STATE(3013),
    [sym__tuple_type_member] = STATE(3013),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(2945),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [114] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1301),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3004),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym__rest_identifier] = STATE(3001),
    [sym_rest_identifier] = STATE(2872),
    [sym_optional_identifier] = STATE(2872),
    [sym__tuple_type_identifier] = STATE(2872),
    [sym_labeled_tuple_type_member] = STATE(3013),
    [sym__tuple_type_member] = STATE(3013),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(3005),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [115] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1296),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3017),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym__rest_identifier] = STATE(3001),
    [sym_rest_identifier] = STATE(2872),
    [sym_optional_identifier] = STATE(2872),
    [sym__tuple_type_identifier] = STATE(2872),
    [sym_labeled_tuple_type_member] = STATE(3013),
    [sym__tuple_type_member] = STATE(3013),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(3016),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1201),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [116] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1349),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3076),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym__rest_identifier] = STATE(3001),
    [sym_rest_identifier] = STATE(2872),
    [sym_optional_identifier] = STATE(2872),
    [sym__tuple_type_identifier] = STATE(2872),
    [sym_labeled_tuple_type_member] = STATE(3013),
    [sym__tuple_type_member] = STATE(3013),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(3075),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1203),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [117] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1296),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3017),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym__rest_identifier] = STATE(3001),
    [sym_rest_identifier] = STATE(2872),
    [sym_optional_identifier] = STATE(2872),
    [sym__tuple_type_identifier] = STATE(2872),
    [sym_labeled_tuple_type_member] = STATE(3013),
    [sym__tuple_type_member] = STATE(3013),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(3016),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [118] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1264),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1626),
    [sym_array] = STATE(1651),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3527),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_rest_parameter] = STATE(2999),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_accessibility_modifier] = STATE(2015),
    [sym_required_parameter] = STATE(2999),
    [sym_optional_parameter] = STATE(2999),
    [sym__parameter_name] = STATE(2342),
    [sym__rest_identifier] = STATE(2829),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(1872),
    [sym_identifier] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(449),
    [anon_sym_namespace] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(449),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(479),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(1209),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_get] = ACTIONS(449),
    [anon_sym_set] = ACTIONS(449),
    [anon_sym_declare] = ACTIONS(449),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(449),
    [anon_sym_any] = ACTIONS(449),
    [anon_sym_number] = ACTIONS(449),
    [anon_sym_boolean] = ACTIONS(449),
    [anon_sym_string] = ACTIONS(449),
    [anon_sym_symbol] = ACTIONS(449),
    [sym_readonly] = ACTIONS(1211),
  },
  [119] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1534),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3475),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym__rest_identifier] = STATE(3001),
    [sym_rest_identifier] = STATE(2872),
    [sym_optional_identifier] = STATE(2872),
    [sym__tuple_type_identifier] = STATE(2872),
    [sym_labeled_tuple_type_member] = STATE(3013),
    [sym__tuple_type_member] = STATE(3013),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [120] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1275),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1626),
    [sym_array] = STATE(1651),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3543),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_rest_parameter] = STATE(2999),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_accessibility_modifier] = STATE(2015),
    [sym_required_parameter] = STATE(2999),
    [sym_optional_parameter] = STATE(2999),
    [sym__parameter_name] = STATE(2342),
    [sym__rest_identifier] = STATE(2829),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(1872),
    [sym_identifier] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(449),
    [anon_sym_namespace] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(449),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(479),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(1209),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_get] = ACTIONS(449),
    [anon_sym_set] = ACTIONS(449),
    [anon_sym_declare] = ACTIONS(449),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(449),
    [anon_sym_any] = ACTIONS(449),
    [anon_sym_number] = ACTIONS(449),
    [anon_sym_boolean] = ACTIONS(449),
    [anon_sym_string] = ACTIONS(449),
    [anon_sym_symbol] = ACTIONS(449),
    [sym_readonly] = ACTIONS(1211),
  },
  [121] = {
    [sym_import] = STATE(1569),
    [sym_expression_statement] = STATE(155),
    [sym_variable_declaration] = STATE(155),
    [sym_lexical_declaration] = STATE(155),
    [sym_empty_statement] = STATE(155),
    [sym_parenthesized_expression] = STATE(971),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1550),
    [sym_array] = STATE(1547),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(971),
    [sym_subscript_expression] = STATE(971),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(962),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(1215),
    [anon_sym_export] = ACTIONS(1217),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(1217),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_const] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(1225),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1217),
    [anon_sym_get] = ACTIONS(1217),
    [anon_sym_set] = ACTIONS(1217),
    [anon_sym_declare] = ACTIONS(1217),
    [anon_sym_public] = ACTIONS(1217),
    [anon_sym_private] = ACTIONS(1217),
    [anon_sym_protected] = ACTIONS(1217),
    [anon_sym_module] = ACTIONS(1217),
    [anon_sym_any] = ACTIONS(1217),
    [anon_sym_number] = ACTIONS(1217),
    [anon_sym_boolean] = ACTIONS(1217),
    [anon_sym_string] = ACTIONS(1217),
    [anon_sym_symbol] = ACTIONS(1217),
    [sym_readonly] = ACTIONS(1217),
  },
  [122] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1419),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3628),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym__rest_identifier] = STATE(3001),
    [sym_rest_identifier] = STATE(2872),
    [sym_optional_identifier] = STATE(2872),
    [sym__tuple_type_identifier] = STATE(2872),
    [sym_labeled_tuple_type_member] = STATE(3013),
    [sym__tuple_type_member] = STATE(3013),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [123] = {
    [sym_import] = STATE(1569),
    [sym_expression_statement] = STATE(157),
    [sym_variable_declaration] = STATE(157),
    [sym_lexical_declaration] = STATE(157),
    [sym_empty_statement] = STATE(157),
    [sym_parenthesized_expression] = STATE(971),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1550),
    [sym_array] = STATE(1547),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(971),
    [sym_subscript_expression] = STATE(971),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(962),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(1215),
    [anon_sym_export] = ACTIONS(1217),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(1217),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_const] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(1225),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1217),
    [anon_sym_get] = ACTIONS(1217),
    [anon_sym_set] = ACTIONS(1217),
    [anon_sym_declare] = ACTIONS(1217),
    [anon_sym_public] = ACTIONS(1217),
    [anon_sym_private] = ACTIONS(1217),
    [anon_sym_protected] = ACTIONS(1217),
    [anon_sym_module] = ACTIONS(1217),
    [anon_sym_any] = ACTIONS(1217),
    [anon_sym_number] = ACTIONS(1217),
    [anon_sym_boolean] = ACTIONS(1217),
    [anon_sym_string] = ACTIONS(1217),
    [anon_sym_symbol] = ACTIONS(1217),
    [sym_readonly] = ACTIONS(1217),
  },
  [124] = {
    [sym_import] = STATE(1569),
    [sym_expression_statement] = STATE(156),
    [sym_variable_declaration] = STATE(156),
    [sym_lexical_declaration] = STATE(156),
    [sym_empty_statement] = STATE(156),
    [sym_parenthesized_expression] = STATE(971),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1550),
    [sym_array] = STATE(1547),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(971),
    [sym_subscript_expression] = STATE(971),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(962),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(1215),
    [anon_sym_export] = ACTIONS(1217),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(1217),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_const] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(1225),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1217),
    [anon_sym_get] = ACTIONS(1217),
    [anon_sym_set] = ACTIONS(1217),
    [anon_sym_declare] = ACTIONS(1217),
    [anon_sym_public] = ACTIONS(1217),
    [anon_sym_private] = ACTIONS(1217),
    [anon_sym_protected] = ACTIONS(1217),
    [anon_sym_module] = ACTIONS(1217),
    [anon_sym_any] = ACTIONS(1217),
    [anon_sym_number] = ACTIONS(1217),
    [anon_sym_boolean] = ACTIONS(1217),
    [anon_sym_string] = ACTIONS(1217),
    [anon_sym_symbol] = ACTIONS(1217),
    [sym_readonly] = ACTIONS(1217),
  },
  [125] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1419),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3628),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym__rest_identifier] = STATE(3001),
    [sym_rest_identifier] = STATE(2872),
    [sym_optional_identifier] = STATE(2872),
    [sym__tuple_type_identifier] = STATE(2872),
    [sym_labeled_tuple_type_member] = STATE(2987),
    [sym__tuple_type_member] = STATE(2987),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [126] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1278),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1626),
    [sym_array] = STATE(1651),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3472),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_rest_parameter] = STATE(2999),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_accessibility_modifier] = STATE(2015),
    [sym_required_parameter] = STATE(2999),
    [sym_optional_parameter] = STATE(2999),
    [sym__parameter_name] = STATE(2342),
    [sym__rest_identifier] = STATE(2829),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(1872),
    [sym_identifier] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(449),
    [anon_sym_namespace] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(449),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(479),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(1209),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_get] = ACTIONS(449),
    [anon_sym_set] = ACTIONS(449),
    [anon_sym_declare] = ACTIONS(449),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(449),
    [anon_sym_any] = ACTIONS(449),
    [anon_sym_number] = ACTIONS(449),
    [anon_sym_boolean] = ACTIONS(449),
    [anon_sym_string] = ACTIONS(449),
    [anon_sym_symbol] = ACTIONS(449),
    [sym_readonly] = ACTIONS(1211),
  },
  [127] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1506),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3438),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym__rest_identifier] = STATE(3001),
    [sym_rest_identifier] = STATE(2872),
    [sym_optional_identifier] = STATE(2872),
    [sym__tuple_type_identifier] = STATE(2872),
    [sym_labeled_tuple_type_member] = STATE(3013),
    [sym__tuple_type_member] = STATE(3013),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [128] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1161),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [anon_sym_extends] = ACTIONS(1231),
    [sym_readonly] = ACTIONS(595),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1229),
    [sym__automatic_semicolon] = ACTIONS(1229),
  },
  [129] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1293),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(2975),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3628),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(2945),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [130] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1161),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [anon_sym_extends] = ACTIONS(1231),
    [sym_readonly] = ACTIONS(595),
  },
  [131] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1386),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(2975),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3628),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(2945),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [132] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1297),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(2975),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_mapped_type_clause] = STATE(3606),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(2945),
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_export] = ACTIONS(1237),
    [anon_sym_namespace] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(1237),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1241),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_get] = ACTIONS(1237),
    [anon_sym_set] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1237),
    [anon_sym_public] = ACTIONS(1237),
    [anon_sym_private] = ACTIONS(1237),
    [anon_sym_protected] = ACTIONS(1237),
    [anon_sym_module] = ACTIONS(1237),
    [anon_sym_any] = ACTIONS(1237),
    [anon_sym_number] = ACTIONS(1237),
    [anon_sym_boolean] = ACTIONS(1237),
    [anon_sym_string] = ACTIONS(1237),
    [anon_sym_symbol] = ACTIONS(1237),
    [sym_readonly] = ACTIONS(1237),
  },
  [133] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3076),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(3075),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [134] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1385),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [anon_sym_extends] = ACTIONS(1231),
    [sym_readonly] = ACTIONS(749),
  },
  [135] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1507),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3149),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(2933),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1245),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1245),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [136] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1397),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3020),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(3024),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(1247),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [137] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1301),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3004),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(3005),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1249),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [138] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1253),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [anon_sym_extends] = ACTIONS(1231),
    [sym_readonly] = ACTIONS(781),
  },
  [139] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1339),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3149),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1245),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(1245),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1245),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [140] = {
    [sym_export_clause] = STATE(2893),
    [sym__declaration] = STATE(582),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_class_declaration] = STATE(627),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function_declaration] = STATE(627),
    [sym_decorator] = STATE(1994),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(575),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [aux_sym_export_statement_repeat1] = STATE(2655),
    [aux_sym_object_repeat1] = STATE(3011),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_EQ] = ACTIONS(1255),
    [anon_sym_as] = ACTIONS(1257),
    [anon_sym_namespace] = ACTIONS(1259),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1288),
    [anon_sym_async] = ACTIONS(1290),
    [anon_sym_function] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1296),
    [anon_sym_module] = ACTIONS(1298),
    [anon_sym_interface] = ACTIONS(1300),
    [anon_sym_enum] = ACTIONS(1302),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [141] = {
    [sym_export_clause] = STATE(2893),
    [sym__declaration] = STATE(582),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_class_declaration] = STATE(627),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function_declaration] = STATE(627),
    [sym_decorator] = STATE(1994),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(575),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [aux_sym_export_statement_repeat1] = STATE(2655),
    [aux_sym_object_repeat1] = STATE(3010),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_EQ] = ACTIONS(1255),
    [anon_sym_as] = ACTIONS(1257),
    [anon_sym_namespace] = ACTIONS(1259),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1288),
    [anon_sym_async] = ACTIONS(1290),
    [anon_sym_function] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1296),
    [anon_sym_module] = ACTIONS(1298),
    [anon_sym_interface] = ACTIONS(1300),
    [anon_sym_enum] = ACTIONS(1302),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [142] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1402),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(2975),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(2945),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [143] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1540),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [anon_sym_extends] = ACTIONS(1231),
    [sym_readonly] = ACTIONS(623),
  },
  [144] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1317),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(2997),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(2995),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(1306),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [145] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1349),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3076),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(3075),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1243),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [146] = {
    [sym_export_clause] = STATE(2893),
    [sym__declaration] = STATE(582),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_class_declaration] = STATE(627),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function_declaration] = STATE(627),
    [sym_decorator] = STATE(1994),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(575),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [aux_sym_export_statement_repeat1] = STATE(2655),
    [aux_sym_object_repeat1] = STATE(2959),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_EQ] = ACTIONS(1255),
    [anon_sym_as] = ACTIONS(1257),
    [anon_sym_namespace] = ACTIONS(1259),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1288),
    [anon_sym_async] = ACTIONS(1290),
    [anon_sym_function] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1296),
    [anon_sym_module] = ACTIONS(1298),
    [anon_sym_interface] = ACTIONS(1300),
    [anon_sym_enum] = ACTIONS(1302),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [147] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1411),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3047),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(3048),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1310),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [148] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1289),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(2975),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(2945),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [149] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1296),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3017),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(3016),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_RBRACK] = ACTIONS(1312),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [150] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1395),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(2953),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(2954),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [151] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1350),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [anon_sym_extends] = ACTIONS(1231),
    [sym_readonly] = ACTIONS(529),
  },
  [152] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1322),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [anon_sym_extends] = ACTIONS(1231),
    [sym_readonly] = ACTIONS(711),
  },
  [153] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1404),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3132),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [aux_sym_array_repeat1] = STATE(3128),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(1318),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [154] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1455),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3652),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3652),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1320),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1322),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [155] = {
    [sym_import] = STATE(1569),
    [sym_expression_statement] = STATE(180),
    [sym_empty_statement] = STATE(180),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [156] = {
    [sym_import] = STATE(1569),
    [sym_expression_statement] = STATE(179),
    [sym_empty_statement] = STATE(179),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [157] = {
    [sym_import] = STATE(1569),
    [sym_expression_statement] = STATE(181),
    [sym_empty_statement] = STATE(181),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3207),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [158] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1491),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_spread_element] = STATE(3480),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3480),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(1324),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1322),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [159] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1161),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(2081),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(3391),
    [sym_generic_type] = STATE(2099),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1326),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [160] = {
    [sym_export_clause] = STATE(2893),
    [sym__declaration] = STATE(582),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_class_declaration] = STATE(627),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function_declaration] = STATE(627),
    [sym_decorator] = STATE(1994),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(575),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [aux_sym_export_statement_repeat1] = STATE(2655),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_EQ] = ACTIONS(1328),
    [anon_sym_as] = ACTIONS(1257),
    [anon_sym_namespace] = ACTIONS(1330),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(860),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1288),
    [anon_sym_async] = ACTIONS(1290),
    [anon_sym_function] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1334),
    [anon_sym_module] = ACTIONS(1336),
    [anon_sym_interface] = ACTIONS(1300),
    [anon_sym_enum] = ACTIONS(1302),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [161] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1262),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_nested_identifier] = STATE(3427),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_nested_type_identifier] = STATE(2448),
    [sym_generic_type] = STATE(2865),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(1338),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [162] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1216),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(3514),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(2441),
    [sym_generic_type] = STATE(2941),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1340),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [163] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1335),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(3514),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(2535),
    [sym_generic_type] = STATE(3029),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [164] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1403),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_nested_identifier] = STATE(3427),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_nested_type_identifier] = STATE(2656),
    [sym_generic_type] = STATE(3103),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(1344),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [165] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(1022),
    [sym__expression] = STATE(1790),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1816),
    [sym_array] = STATE(1815),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(1022),
    [sym_subscript_expression] = STATE(1022),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1019),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_export] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1348),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_var] = ACTIONS(1352),
    [anon_sym_let] = ACTIONS(1352),
    [anon_sym_const] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1348),
    [anon_sym_set] = ACTIONS(1348),
    [anon_sym_declare] = ACTIONS(1348),
    [anon_sym_public] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1348),
    [anon_sym_protected] = ACTIONS(1348),
    [anon_sym_module] = ACTIONS(1348),
    [anon_sym_any] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1348),
    [sym_readonly] = ACTIONS(1348),
  },
  [166] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1322),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(2027),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(3156),
    [sym_generic_type] = STATE(445),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [167] = {
    [sym_export_clause] = STATE(2893),
    [sym__declaration] = STATE(582),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_class_declaration] = STATE(627),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function_declaration] = STATE(627),
    [sym_decorator] = STATE(1994),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(575),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [aux_sym_export_statement_repeat1] = STATE(2655),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_EQ] = ACTIONS(1328),
    [anon_sym_as] = ACTIONS(1257),
    [anon_sym_namespace] = ACTIONS(1259),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(860),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1288),
    [anon_sym_async] = ACTIONS(1290),
    [anon_sym_function] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_module] = ACTIONS(1298),
    [anon_sym_interface] = ACTIONS(1300),
    [anon_sym_enum] = ACTIONS(1302),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [168] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1350),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_nested_identifier] = STATE(2027),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_nested_type_identifier] = STATE(3156),
    [sym_generic_type] = STATE(445),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [169] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1161),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(2027),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(3156),
    [sym_generic_type] = STATE(445),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1364),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [170] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1161),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(2027),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(3156),
    [sym_generic_type] = STATE(445),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [171] = {
    [sym__declaration] = STATE(625),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_class_declaration] = STATE(627),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function_declaration] = STATE(627),
    [sym_decorator] = STATE(1994),
    [sym_function_signature] = STATE(627),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(575),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [aux_sym_export_statement_repeat1] = STATE(2655),
    [aux_sym_object_repeat1] = STATE(2959),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1259),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1288),
    [anon_sym_async] = ACTIONS(1290),
    [anon_sym_function] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1296),
    [anon_sym_module] = ACTIONS(1370),
    [anon_sym_global] = ACTIONS(1372),
    [anon_sym_interface] = ACTIONS(1300),
    [anon_sym_enum] = ACTIONS(1302),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [172] = {
    [sym__declaration] = STATE(625),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_class_declaration] = STATE(627),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function_declaration] = STATE(627),
    [sym_decorator] = STATE(1994),
    [sym_function_signature] = STATE(627),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(575),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [aux_sym_export_statement_repeat1] = STATE(2655),
    [aux_sym_object_repeat1] = STATE(3010),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1259),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1288),
    [anon_sym_async] = ACTIONS(1290),
    [anon_sym_function] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1296),
    [anon_sym_module] = ACTIONS(1370),
    [anon_sym_global] = ACTIONS(1372),
    [anon_sym_interface] = ACTIONS(1300),
    [anon_sym_enum] = ACTIONS(1302),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [173] = {
    [sym__declaration] = STATE(625),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_class_declaration] = STATE(627),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function_declaration] = STATE(627),
    [sym_decorator] = STATE(1994),
    [sym_function_signature] = STATE(627),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(575),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [aux_sym_export_statement_repeat1] = STATE(2655),
    [aux_sym_object_repeat1] = STATE(3011),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1259),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1288),
    [anon_sym_async] = ACTIONS(1290),
    [anon_sym_function] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1296),
    [anon_sym_module] = ACTIONS(1370),
    [anon_sym_global] = ACTIONS(1372),
    [anon_sym_interface] = ACTIONS(1300),
    [anon_sym_enum] = ACTIONS(1302),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [174] = {
    [sym_export_clause] = STATE(2893),
    [sym__declaration] = STATE(582),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_class_declaration] = STATE(627),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function_declaration] = STATE(627),
    [sym_decorator] = STATE(1994),
    [sym_function_signature] = STATE(577),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(575),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [aux_sym_export_statement_repeat1] = STATE(2655),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_EQ] = ACTIONS(1328),
    [anon_sym_as] = ACTIONS(1257),
    [anon_sym_namespace] = ACTIONS(1259),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(860),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1288),
    [anon_sym_async] = ACTIONS(1290),
    [anon_sym_function] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1296),
    [anon_sym_module] = ACTIONS(1298),
    [anon_sym_interface] = ACTIONS(1300),
    [anon_sym_enum] = ACTIONS(1302),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [175] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1253),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_nested_identifier] = STATE(2027),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_nested_type_identifier] = STATE(3156),
    [sym_generic_type] = STATE(445),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [176] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1540),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_nested_identifier] = STATE(2027),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_nested_type_identifier] = STATE(3156),
    [sym_generic_type] = STATE(445),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(1378),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [177] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3272),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
    [sym__automatic_semicolon] = ACTIONS(1380),
  },
  [178] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1385),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_nested_identifier] = STATE(2027),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_nested_type_identifier] = STATE(3156),
    [sym_generic_type] = STATE(445),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1382),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [179] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1552),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3530),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(1384),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [180] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1423),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3616),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(1386),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [181] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1539),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3539),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RPAREN] = ACTIONS(1388),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [182] = {
    [sym_import] = STATE(1810),
    [sym_statement_block] = STATE(1801),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1302),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [183] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1291),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3273),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [184] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1208),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1138),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [185] = {
    [sym_import] = STATE(1810),
    [sym_statement_block] = STATE(1787),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1320),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [186] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1213),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1131),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [187] = {
    [sym_import] = STATE(1810),
    [sym_statement_block] = STATE(1804),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1287),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [188] = {
    [sym_import] = STATE(1810),
    [sym_statement_block] = STATE(1808),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [189] = {
    [sym__declaration] = STATE(625),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_class_declaration] = STATE(627),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function_declaration] = STATE(627),
    [sym_decorator] = STATE(1994),
    [sym_function_signature] = STATE(627),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(575),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [aux_sym_export_statement_repeat1] = STATE(2655),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(963),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1330),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(860),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1288),
    [anon_sym_async] = ACTIONS(1290),
    [anon_sym_function] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1334),
    [anon_sym_module] = ACTIONS(1394),
    [anon_sym_global] = ACTIONS(1372),
    [anon_sym_interface] = ACTIONS(1300),
    [anon_sym_enum] = ACTIONS(1302),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [190] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1419),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3628),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [191] = {
    [sym_import] = STATE(1569),
    [sym_statement_block] = STATE(1594),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1420),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [192] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1210),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1133),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [193] = {
    [sym_import] = STATE(1063),
    [sym_parenthesized_expression] = STATE(678),
    [sym__expression] = STATE(1790),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1055),
    [sym_array] = STATE(1056),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1063),
    [sym_function] = STATE(1063),
    [sym_generator_function] = STATE(1063),
    [sym_arrow_function] = STATE(1063),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1063),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(678),
    [sym_subscript_expression] = STATE(678),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1063),
    [sym_template_string] = STATE(1063),
    [sym_regex] = STATE(1063),
    [sym_meta_property] = STATE(1063),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2647),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3274),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1398),
    [anon_sym_export] = ACTIONS(1400),
    [anon_sym_namespace] = ACTIONS(1402),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1400),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(1404),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1410),
    [sym_super] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_null] = ACTIONS(1410),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1400),
    [anon_sym_get] = ACTIONS(1400),
    [anon_sym_set] = ACTIONS(1400),
    [anon_sym_declare] = ACTIONS(1400),
    [anon_sym_public] = ACTIONS(1400),
    [anon_sym_private] = ACTIONS(1400),
    [anon_sym_protected] = ACTIONS(1400),
    [anon_sym_module] = ACTIONS(1400),
    [anon_sym_any] = ACTIONS(1400),
    [anon_sym_number] = ACTIONS(1400),
    [anon_sym_boolean] = ACTIONS(1400),
    [anon_sym_string] = ACTIONS(1400),
    [anon_sym_symbol] = ACTIONS(1400),
    [sym_readonly] = ACTIONS(1400),
  },
  [194] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1183),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3440),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [195] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1234),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1311),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [196] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1266),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1314),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [197] = {
    [sym_import] = STATE(1487),
    [sym_parenthesized_expression] = STATE(926),
    [sym__expression] = STATE(1756),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1300),
    [sym_array] = STATE(1409),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1487),
    [sym_function] = STATE(1487),
    [sym_generator_function] = STATE(1487),
    [sym_arrow_function] = STATE(1487),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1487),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(926),
    [sym_subscript_expression] = STATE(926),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1487),
    [sym_template_string] = STATE(1487),
    [sym_regex] = STATE(1487),
    [sym_meta_property] = STATE(1487),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2616),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3202),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(1412),
    [anon_sym_export] = ACTIONS(1414),
    [anon_sym_namespace] = ACTIONS(1416),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(1414),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_DOT] = ACTIONS(1418),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(1420),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(1422),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_super] = ACTIONS(1426),
    [sym_true] = ACTIONS(1426),
    [sym_false] = ACTIONS(1426),
    [sym_null] = ACTIONS(1426),
    [sym_undefined] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_get] = ACTIONS(1414),
    [anon_sym_set] = ACTIONS(1414),
    [anon_sym_declare] = ACTIONS(1414),
    [anon_sym_public] = ACTIONS(1414),
    [anon_sym_private] = ACTIONS(1414),
    [anon_sym_protected] = ACTIONS(1414),
    [anon_sym_module] = ACTIONS(1414),
    [anon_sym_any] = ACTIONS(1414),
    [anon_sym_number] = ACTIONS(1414),
    [anon_sym_boolean] = ACTIONS(1414),
    [anon_sym_string] = ACTIONS(1414),
    [anon_sym_symbol] = ACTIONS(1414),
    [sym_readonly] = ACTIONS(1414),
  },
  [198] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1430),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3660),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [199] = {
    [sym_import] = STATE(1569),
    [sym_statement_block] = STATE(1665),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1434),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [200] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1506),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3438),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [201] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1684),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_mapped_type_clause] = STATE(3606),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_export] = ACTIONS(1430),
    [anon_sym_namespace] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1430),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1434),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1430),
    [anon_sym_get] = ACTIONS(1430),
    [anon_sym_set] = ACTIONS(1430),
    [anon_sym_declare] = ACTIONS(1430),
    [anon_sym_public] = ACTIONS(1430),
    [anon_sym_private] = ACTIONS(1430),
    [anon_sym_protected] = ACTIONS(1430),
    [anon_sym_module] = ACTIONS(1430),
    [anon_sym_any] = ACTIONS(1430),
    [anon_sym_number] = ACTIONS(1430),
    [anon_sym_boolean] = ACTIONS(1430),
    [anon_sym_string] = ACTIONS(1430),
    [anon_sym_symbol] = ACTIONS(1430),
    [sym_readonly] = ACTIONS(1430),
  },
  [202] = {
    [sym_import] = STATE(1348),
    [sym_parenthesized_expression] = STATE(763),
    [sym__expression] = STATE(1729),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1247),
    [sym_array] = STATE(1227),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1348),
    [sym_function] = STATE(1348),
    [sym_generator_function] = STATE(1348),
    [sym_arrow_function] = STATE(1348),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1348),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(763),
    [sym_subscript_expression] = STATE(763),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1348),
    [sym_template_string] = STATE(1348),
    [sym_regex] = STATE(1348),
    [sym_meta_property] = STATE(1348),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(1436),
    [anon_sym_export] = ACTIONS(1438),
    [anon_sym_namespace] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(1438),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1442),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1448),
    [sym_this] = ACTIONS(1450),
    [sym_super] = ACTIONS(1450),
    [sym_true] = ACTIONS(1450),
    [sym_false] = ACTIONS(1450),
    [sym_null] = ACTIONS(1450),
    [sym_undefined] = ACTIONS(1450),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1438),
    [anon_sym_get] = ACTIONS(1438),
    [anon_sym_set] = ACTIONS(1438),
    [anon_sym_declare] = ACTIONS(1438),
    [anon_sym_public] = ACTIONS(1438),
    [anon_sym_private] = ACTIONS(1438),
    [anon_sym_protected] = ACTIONS(1438),
    [anon_sym_module] = ACTIONS(1438),
    [anon_sym_any] = ACTIONS(1438),
    [anon_sym_number] = ACTIONS(1438),
    [anon_sym_boolean] = ACTIONS(1438),
    [anon_sym_string] = ACTIONS(1438),
    [anon_sym_symbol] = ACTIONS(1438),
    [sym_readonly] = ACTIONS(1438),
  },
  [203] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1536),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3544),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [204] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1503),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3430),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [205] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1501),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3441),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [206] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1499),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3443),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [207] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1498),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3467),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [208] = {
    [sym_import] = STATE(1168),
    [sym_variable_declarator] = STATE(2877),
    [sym_parenthesized_expression] = STATE(1021),
    [sym__expression] = STATE(1790),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1101),
    [sym_array] = STATE(1163),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(1021),
    [sym_subscript_expression] = STATE(1021),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1020),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_export] = ACTIONS(1454),
    [anon_sym_namespace] = ACTIONS(1456),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(1454),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1458),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_get] = ACTIONS(1454),
    [anon_sym_set] = ACTIONS(1454),
    [anon_sym_declare] = ACTIONS(1454),
    [anon_sym_public] = ACTIONS(1454),
    [anon_sym_private] = ACTIONS(1454),
    [anon_sym_protected] = ACTIONS(1454),
    [anon_sym_module] = ACTIONS(1454),
    [anon_sym_any] = ACTIONS(1454),
    [anon_sym_number] = ACTIONS(1454),
    [anon_sym_boolean] = ACTIONS(1454),
    [anon_sym_string] = ACTIONS(1454),
    [anon_sym_symbol] = ACTIONS(1454),
    [sym_readonly] = ACTIONS(1454),
  },
  [209] = {
    [sym_import] = STATE(1168),
    [sym_variable_declarator] = STATE(2881),
    [sym_parenthesized_expression] = STATE(1021),
    [sym__expression] = STATE(1790),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1101),
    [sym_array] = STATE(1163),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(1021),
    [sym_subscript_expression] = STATE(1021),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1020),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_export] = ACTIONS(1454),
    [anon_sym_namespace] = ACTIONS(1456),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(1454),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1458),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_get] = ACTIONS(1454),
    [anon_sym_set] = ACTIONS(1454),
    [anon_sym_declare] = ACTIONS(1454),
    [anon_sym_public] = ACTIONS(1454),
    [anon_sym_private] = ACTIONS(1454),
    [anon_sym_protected] = ACTIONS(1454),
    [anon_sym_module] = ACTIONS(1454),
    [anon_sym_any] = ACTIONS(1454),
    [anon_sym_number] = ACTIONS(1454),
    [anon_sym_boolean] = ACTIONS(1454),
    [anon_sym_string] = ACTIONS(1454),
    [anon_sym_symbol] = ACTIONS(1454),
    [sym_readonly] = ACTIONS(1454),
  },
  [210] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1174),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3446),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [211] = {
    [sym_import] = STATE(1569),
    [sym_statement_block] = STATE(1706),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1458),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [212] = {
    [sym_import] = STATE(1063),
    [sym_parenthesized_expression] = STATE(678),
    [sym__expression] = STATE(1790),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1055),
    [sym_array] = STATE(1056),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1063),
    [sym_function] = STATE(1063),
    [sym_generator_function] = STATE(1063),
    [sym_arrow_function] = STATE(1063),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1063),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(678),
    [sym_subscript_expression] = STATE(678),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1063),
    [sym_template_string] = STATE(1063),
    [sym_regex] = STATE(1063),
    [sym_meta_property] = STATE(1063),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2616),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3202),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1398),
    [anon_sym_export] = ACTIONS(1400),
    [anon_sym_namespace] = ACTIONS(1402),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1400),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(1404),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1410),
    [sym_super] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_null] = ACTIONS(1410),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1400),
    [anon_sym_get] = ACTIONS(1400),
    [anon_sym_set] = ACTIONS(1400),
    [anon_sym_declare] = ACTIONS(1400),
    [anon_sym_public] = ACTIONS(1400),
    [anon_sym_private] = ACTIONS(1400),
    [anon_sym_protected] = ACTIONS(1400),
    [anon_sym_module] = ACTIONS(1400),
    [anon_sym_any] = ACTIONS(1400),
    [anon_sym_number] = ACTIONS(1400),
    [anon_sym_boolean] = ACTIONS(1400),
    [anon_sym_string] = ACTIONS(1400),
    [anon_sym_symbol] = ACTIONS(1400),
    [sym_readonly] = ACTIONS(1400),
  },
  [213] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1461),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3636),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [214] = {
    [sym_import] = STATE(1810),
    [sym_statement_block] = STATE(1754),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1393),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [215] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1235),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1353),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [216] = {
    [sym_import] = STATE(1348),
    [sym_parenthesized_expression] = STATE(763),
    [sym__expression] = STATE(1729),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1247),
    [sym_array] = STATE(1227),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1348),
    [sym_function] = STATE(1348),
    [sym_generator_function] = STATE(1348),
    [sym_arrow_function] = STATE(1348),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1348),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(763),
    [sym_subscript_expression] = STATE(763),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1348),
    [sym_template_string] = STATE(1348),
    [sym_regex] = STATE(1348),
    [sym_meta_property] = STATE(1348),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(1460),
    [anon_sym_export] = ACTIONS(1462),
    [anon_sym_namespace] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(1462),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1442),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(1466),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1448),
    [sym_this] = ACTIONS(1450),
    [sym_super] = ACTIONS(1450),
    [sym_true] = ACTIONS(1450),
    [sym_false] = ACTIONS(1450),
    [sym_null] = ACTIONS(1450),
    [sym_undefined] = ACTIONS(1450),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_get] = ACTIONS(1462),
    [anon_sym_set] = ACTIONS(1462),
    [anon_sym_declare] = ACTIONS(1462),
    [anon_sym_public] = ACTIONS(1462),
    [anon_sym_private] = ACTIONS(1462),
    [anon_sym_protected] = ACTIONS(1462),
    [anon_sym_module] = ACTIONS(1462),
    [anon_sym_any] = ACTIONS(1462),
    [anon_sym_number] = ACTIONS(1462),
    [anon_sym_boolean] = ACTIONS(1462),
    [anon_sym_string] = ACTIONS(1462),
    [anon_sym_symbol] = ACTIONS(1462),
    [sym_readonly] = ACTIONS(1462),
  },
  [217] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1213),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1355),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [218] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1210),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1356),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [219] = {
    [sym_import] = STATE(1569),
    [sym_statement_block] = STATE(1703),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1463),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [220] = {
    [sym_import] = STATE(1569),
    [sym_statement_block] = STATE(1697),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1465),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [221] = {
    [sym_import] = STATE(1569),
    [sym_statement_block] = STATE(1677),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1466),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [222] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1467),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3600),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [223] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1208),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1359),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [224] = {
    [sym__declaration] = STATE(625),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_class_declaration] = STATE(627),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function_declaration] = STATE(627),
    [sym_decorator] = STATE(1994),
    [sym_function_signature] = STATE(627),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(575),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [aux_sym_export_statement_repeat1] = STATE(2655),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(963),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1259),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(860),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1288),
    [anon_sym_async] = ACTIONS(1290),
    [anon_sym_function] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1296),
    [anon_sym_module] = ACTIONS(1370),
    [anon_sym_global] = ACTIONS(1372),
    [anon_sym_interface] = ACTIONS(1300),
    [anon_sym_enum] = ACTIONS(1302),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [225] = {
    [sym_import] = STATE(1348),
    [sym_parenthesized_expression] = STATE(763),
    [sym__expression] = STATE(1729),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1247),
    [sym_array] = STATE(1227),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1348),
    [sym_function] = STATE(1348),
    [sym_generator_function] = STATE(1348),
    [sym_arrow_function] = STATE(1348),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1348),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(763),
    [sym_subscript_expression] = STATE(763),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1348),
    [sym_template_string] = STATE(1348),
    [sym_regex] = STATE(1348),
    [sym_meta_property] = STATE(1348),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2616),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3202),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(1460),
    [anon_sym_export] = ACTIONS(1462),
    [anon_sym_namespace] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(1462),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1442),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(1466),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1448),
    [sym_this] = ACTIONS(1450),
    [sym_super] = ACTIONS(1450),
    [sym_true] = ACTIONS(1450),
    [sym_false] = ACTIONS(1450),
    [sym_null] = ACTIONS(1450),
    [sym_undefined] = ACTIONS(1450),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_get] = ACTIONS(1462),
    [anon_sym_set] = ACTIONS(1462),
    [anon_sym_declare] = ACTIONS(1462),
    [anon_sym_public] = ACTIONS(1462),
    [anon_sym_private] = ACTIONS(1462),
    [anon_sym_protected] = ACTIONS(1462),
    [anon_sym_module] = ACTIONS(1462),
    [anon_sym_any] = ACTIONS(1462),
    [anon_sym_number] = ACTIONS(1462),
    [anon_sym_boolean] = ACTIONS(1462),
    [anon_sym_string] = ACTIONS(1462),
    [anon_sym_symbol] = ACTIONS(1462),
    [sym_readonly] = ACTIONS(1462),
  },
  [226] = {
    [sym_import] = STATE(1063),
    [sym_parenthesized_expression] = STATE(678),
    [sym__expression] = STATE(1790),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1055),
    [sym_array] = STATE(1056),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1063),
    [sym_function] = STATE(1063),
    [sym_generator_function] = STATE(1063),
    [sym_arrow_function] = STATE(1063),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1063),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(678),
    [sym_subscript_expression] = STATE(678),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1063),
    [sym_template_string] = STATE(1063),
    [sym_regex] = STATE(1063),
    [sym_meta_property] = STATE(1063),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2616),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3202),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_export] = ACTIONS(1470),
    [anon_sym_namespace] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1470),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_DOT] = ACTIONS(1404),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1410),
    [sym_super] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_null] = ACTIONS(1410),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1470),
    [anon_sym_get] = ACTIONS(1470),
    [anon_sym_set] = ACTIONS(1470),
    [anon_sym_declare] = ACTIONS(1470),
    [anon_sym_public] = ACTIONS(1470),
    [anon_sym_private] = ACTIONS(1470),
    [anon_sym_protected] = ACTIONS(1470),
    [anon_sym_module] = ACTIONS(1470),
    [anon_sym_any] = ACTIONS(1470),
    [anon_sym_number] = ACTIONS(1470),
    [anon_sym_boolean] = ACTIONS(1470),
    [anon_sym_string] = ACTIONS(1470),
    [anon_sym_symbol] = ACTIONS(1470),
    [sym_readonly] = ACTIONS(1470),
  },
  [227] = {
    [sym_import] = STATE(1569),
    [sym_statement_block] = STATE(1703),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [228] = {
    [sym_import] = STATE(1569),
    [sym_statement_block] = STATE(1697),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1251),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [229] = {
    [sym_import] = STATE(1569),
    [sym_statement_block] = STATE(1677),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1249),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [230] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1234),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1378),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [231] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1537),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3541),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [232] = {
    [sym_import] = STATE(1810),
    [sym_statement_block] = STATE(1739),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1377),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [233] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1474),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3475),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [234] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1497),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3428),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [235] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1235),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1112),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [236] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1513),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3402),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [237] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1551),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3526),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [238] = {
    [sym_import] = STATE(1487),
    [sym_parenthesized_expression] = STATE(926),
    [sym__expression] = STATE(1756),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1300),
    [sym_array] = STATE(1409),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1487),
    [sym_function] = STATE(1487),
    [sym_generator_function] = STATE(1487),
    [sym_arrow_function] = STATE(1487),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1487),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(926),
    [sym_subscript_expression] = STATE(926),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1487),
    [sym_template_string] = STATE(1487),
    [sym_regex] = STATE(1487),
    [sym_meta_property] = STATE(1487),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(1412),
    [anon_sym_export] = ACTIONS(1414),
    [anon_sym_namespace] = ACTIONS(1416),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(1414),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_DOT] = ACTIONS(1418),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(1420),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(1422),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_super] = ACTIONS(1426),
    [sym_true] = ACTIONS(1426),
    [sym_false] = ACTIONS(1426),
    [sym_null] = ACTIONS(1426),
    [sym_undefined] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_get] = ACTIONS(1414),
    [anon_sym_set] = ACTIONS(1414),
    [anon_sym_declare] = ACTIONS(1414),
    [anon_sym_public] = ACTIONS(1414),
    [anon_sym_private] = ACTIONS(1414),
    [anon_sym_protected] = ACTIONS(1414),
    [anon_sym_module] = ACTIONS(1414),
    [anon_sym_any] = ACTIONS(1414),
    [anon_sym_number] = ACTIONS(1414),
    [anon_sym_boolean] = ACTIONS(1414),
    [anon_sym_string] = ACTIONS(1414),
    [anon_sym_symbol] = ACTIONS(1414),
    [sym_readonly] = ACTIONS(1414),
  },
  [239] = {
    [sym_import] = STATE(1063),
    [sym_parenthesized_expression] = STATE(678),
    [sym__expression] = STATE(1790),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1055),
    [sym_array] = STATE(1056),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1063),
    [sym_function] = STATE(1063),
    [sym_generator_function] = STATE(1063),
    [sym_arrow_function] = STATE(1063),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1063),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(678),
    [sym_subscript_expression] = STATE(678),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1063),
    [sym_template_string] = STATE(1063),
    [sym_regex] = STATE(1063),
    [sym_meta_property] = STATE(1063),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2682),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3387),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1398),
    [anon_sym_export] = ACTIONS(1400),
    [anon_sym_namespace] = ACTIONS(1402),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1400),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(1404),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1410),
    [sym_super] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_null] = ACTIONS(1410),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1400),
    [anon_sym_get] = ACTIONS(1400),
    [anon_sym_set] = ACTIONS(1400),
    [anon_sym_declare] = ACTIONS(1400),
    [anon_sym_public] = ACTIONS(1400),
    [anon_sym_private] = ACTIONS(1400),
    [anon_sym_protected] = ACTIONS(1400),
    [anon_sym_module] = ACTIONS(1400),
    [anon_sym_any] = ACTIONS(1400),
    [anon_sym_number] = ACTIONS(1400),
    [anon_sym_boolean] = ACTIONS(1400),
    [anon_sym_string] = ACTIONS(1400),
    [anon_sym_symbol] = ACTIONS(1400),
    [sym_readonly] = ACTIONS(1400),
  },
  [240] = {
    [sym_import] = STATE(1569),
    [sym_statement_block] = STATE(1665),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1272),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [241] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1415),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3649),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [242] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1266),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1369),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [243] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1235),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1340),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [244] = {
    [sym_import] = STATE(1348),
    [sym_parenthesized_expression] = STATE(763),
    [sym__expression] = STATE(1729),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1247),
    [sym_array] = STATE(1227),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1348),
    [sym_function] = STATE(1348),
    [sym_generator_function] = STATE(1348),
    [sym_arrow_function] = STATE(1348),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1348),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(763),
    [sym_subscript_expression] = STATE(763),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1348),
    [sym_template_string] = STATE(1348),
    [sym_regex] = STATE(1348),
    [sym_meta_property] = STATE(1348),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2616),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3202),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(1436),
    [anon_sym_export] = ACTIONS(1438),
    [anon_sym_namespace] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(1438),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1442),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1448),
    [sym_this] = ACTIONS(1450),
    [sym_super] = ACTIONS(1450),
    [sym_true] = ACTIONS(1450),
    [sym_false] = ACTIONS(1450),
    [sym_null] = ACTIONS(1450),
    [sym_undefined] = ACTIONS(1450),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1438),
    [anon_sym_get] = ACTIONS(1438),
    [anon_sym_set] = ACTIONS(1438),
    [anon_sym_declare] = ACTIONS(1438),
    [anon_sym_public] = ACTIONS(1438),
    [anon_sym_private] = ACTIONS(1438),
    [anon_sym_protected] = ACTIONS(1438),
    [anon_sym_module] = ACTIONS(1438),
    [anon_sym_any] = ACTIONS(1438),
    [anon_sym_number] = ACTIONS(1438),
    [anon_sym_boolean] = ACTIONS(1438),
    [anon_sym_string] = ACTIONS(1438),
    [anon_sym_symbol] = ACTIONS(1438),
    [sym_readonly] = ACTIONS(1438),
  },
  [245] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1213),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1330),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [246] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1210),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1329),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [247] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1208),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1328),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [248] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1488),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3515),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [249] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1088),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(2933),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [250] = {
    [sym_import] = STATE(1063),
    [sym_parenthesized_expression] = STATE(678),
    [sym__expression] = STATE(1790),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1055),
    [sym_array] = STATE(1056),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1063),
    [sym_function] = STATE(1063),
    [sym_generator_function] = STATE(1063),
    [sym_arrow_function] = STATE(1063),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1063),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(678),
    [sym_subscript_expression] = STATE(678),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1063),
    [sym_template_string] = STATE(1063),
    [sym_regex] = STATE(1063),
    [sym_meta_property] = STATE(1063),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2616),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3202),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_export] = ACTIONS(1478),
    [anon_sym_namespace] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1478),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(1404),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1410),
    [sym_super] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_null] = ACTIONS(1410),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1478),
    [anon_sym_get] = ACTIONS(1478),
    [anon_sym_set] = ACTIONS(1478),
    [anon_sym_declare] = ACTIONS(1478),
    [anon_sym_public] = ACTIONS(1478),
    [anon_sym_private] = ACTIONS(1478),
    [anon_sym_protected] = ACTIONS(1478),
    [anon_sym_module] = ACTIONS(1478),
    [anon_sym_any] = ACTIONS(1478),
    [anon_sym_number] = ACTIONS(1478),
    [anon_sym_boolean] = ACTIONS(1478),
    [anon_sym_string] = ACTIONS(1478),
    [anon_sym_symbol] = ACTIONS(1478),
    [sym_readonly] = ACTIONS(1478),
  },
  [251] = {
    [sym_import] = STATE(1569),
    [sym_statement_block] = STATE(1594),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1219),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [252] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1684),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_mapped_type_clause] = STATE(3611),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_export] = ACTIONS(1486),
    [anon_sym_namespace] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1486),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1490),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_get] = ACTIONS(1486),
    [anon_sym_set] = ACTIONS(1486),
    [anon_sym_declare] = ACTIONS(1486),
    [anon_sym_public] = ACTIONS(1486),
    [anon_sym_private] = ACTIONS(1486),
    [anon_sym_protected] = ACTIONS(1486),
    [anon_sym_module] = ACTIONS(1486),
    [anon_sym_any] = ACTIONS(1486),
    [anon_sym_number] = ACTIONS(1486),
    [anon_sym_boolean] = ACTIONS(1486),
    [anon_sym_string] = ACTIONS(1486),
    [anon_sym_symbol] = ACTIONS(1486),
    [sym_readonly] = ACTIONS(1486),
  },
  [253] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1295),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_sequence_expression] = STATE(3335),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [254] = {
    [sym_import] = STATE(1063),
    [sym_parenthesized_expression] = STATE(678),
    [sym__expression] = STATE(1790),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1055),
    [sym_array] = STATE(1056),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1063),
    [sym_function] = STATE(1063),
    [sym_generator_function] = STATE(1063),
    [sym_arrow_function] = STATE(1063),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1063),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(678),
    [sym_subscript_expression] = STATE(678),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1063),
    [sym_template_string] = STATE(1063),
    [sym_regex] = STATE(1063),
    [sym_meta_property] = STATE(1063),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_export] = ACTIONS(1478),
    [anon_sym_namespace] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1478),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(1404),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1410),
    [sym_super] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_null] = ACTIONS(1410),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1478),
    [anon_sym_get] = ACTIONS(1478),
    [anon_sym_set] = ACTIONS(1478),
    [anon_sym_declare] = ACTIONS(1478),
    [anon_sym_public] = ACTIONS(1478),
    [anon_sym_private] = ACTIONS(1478),
    [anon_sym_protected] = ACTIONS(1478),
    [anon_sym_module] = ACTIONS(1478),
    [anon_sym_any] = ACTIONS(1478),
    [anon_sym_number] = ACTIONS(1478),
    [anon_sym_boolean] = ACTIONS(1478),
    [anon_sym_string] = ACTIONS(1478),
    [anon_sym_symbol] = ACTIONS(1478),
    [sym_readonly] = ACTIONS(1478),
  },
  [255] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1534),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3475),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [256] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1234),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1136),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [257] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1543),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3529),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [258] = {
    [sym_import] = STATE(1063),
    [sym_parenthesized_expression] = STATE(678),
    [sym__expression] = STATE(1790),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1055),
    [sym_array] = STATE(1056),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1063),
    [sym_function] = STATE(1063),
    [sym_generator_function] = STATE(1063),
    [sym_arrow_function] = STATE(1063),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1063),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(678),
    [sym_subscript_expression] = STATE(678),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1063),
    [sym_template_string] = STATE(1063),
    [sym_regex] = STATE(1063),
    [sym_meta_property] = STATE(1063),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_export] = ACTIONS(1470),
    [anon_sym_namespace] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1470),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_DOT] = ACTIONS(1404),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1410),
    [sym_super] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_null] = ACTIONS(1410),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1470),
    [anon_sym_get] = ACTIONS(1470),
    [anon_sym_set] = ACTIONS(1470),
    [anon_sym_declare] = ACTIONS(1470),
    [anon_sym_public] = ACTIONS(1470),
    [anon_sym_private] = ACTIONS(1470),
    [anon_sym_protected] = ACTIONS(1470),
    [anon_sym_module] = ACTIONS(1470),
    [anon_sym_any] = ACTIONS(1470),
    [anon_sym_number] = ACTIONS(1470),
    [anon_sym_boolean] = ACTIONS(1470),
    [anon_sym_string] = ACTIONS(1470),
    [anon_sym_symbol] = ACTIONS(1470),
    [sym_readonly] = ACTIONS(1470),
  },
  [259] = {
    [sym_import] = STATE(1063),
    [sym_parenthesized_expression] = STATE(678),
    [sym__expression] = STATE(1790),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1055),
    [sym_array] = STATE(1056),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1063),
    [sym_function] = STATE(1063),
    [sym_generator_function] = STATE(1063),
    [sym_arrow_function] = STATE(1063),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1063),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(678),
    [sym_subscript_expression] = STATE(678),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1063),
    [sym_template_string] = STATE(1063),
    [sym_regex] = STATE(1063),
    [sym_meta_property] = STATE(1063),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_export] = ACTIONS(1478),
    [anon_sym_namespace] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1478),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(1442),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1410),
    [sym_super] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_null] = ACTIONS(1410),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1478),
    [anon_sym_get] = ACTIONS(1478),
    [anon_sym_set] = ACTIONS(1478),
    [anon_sym_declare] = ACTIONS(1478),
    [anon_sym_public] = ACTIONS(1478),
    [anon_sym_private] = ACTIONS(1478),
    [anon_sym_protected] = ACTIONS(1478),
    [anon_sym_module] = ACTIONS(1478),
    [anon_sym_any] = ACTIONS(1478),
    [anon_sym_number] = ACTIONS(1478),
    [anon_sym_boolean] = ACTIONS(1478),
    [anon_sym_string] = ACTIONS(1478),
    [anon_sym_symbol] = ACTIONS(1478),
    [sym_readonly] = ACTIONS(1478),
  },
  [260] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1520),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_function_signature] = STATE(589),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(1492),
    [anon_sym_function] = ACTIONS(1494),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [261] = {
    [sym_import] = STATE(1168),
    [sym_statement_block] = STATE(1266),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1085),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [262] = {
    [sym__declaration] = STATE(625),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_class_declaration] = STATE(627),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function_declaration] = STATE(627),
    [sym_decorator] = STATE(1994),
    [sym_function_signature] = STATE(627),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(575),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [aux_sym_export_statement_repeat1] = STATE(2655),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(963),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1259),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(860),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1288),
    [anon_sym_async] = ACTIONS(1290),
    [anon_sym_function] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_declare] = ACTIONS(1360),
    [anon_sym_module] = ACTIONS(1496),
    [anon_sym_global] = ACTIONS(1372),
    [anon_sym_interface] = ACTIONS(1300),
    [anon_sym_enum] = ACTIONS(1302),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [263] = {
    [sym_import] = STATE(1063),
    [sym_parenthesized_expression] = STATE(678),
    [sym__expression] = STATE(1790),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1055),
    [sym_array] = STATE(1056),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1063),
    [sym_function] = STATE(1063),
    [sym_generator_function] = STATE(1063),
    [sym_arrow_function] = STATE(1063),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1063),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(678),
    [sym_subscript_expression] = STATE(678),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1063),
    [sym_template_string] = STATE(1063),
    [sym_regex] = STATE(1063),
    [sym_meta_property] = STATE(1063),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_export] = ACTIONS(1478),
    [anon_sym_namespace] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1478),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(1418),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1410),
    [sym_super] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_null] = ACTIONS(1410),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1478),
    [anon_sym_get] = ACTIONS(1478),
    [anon_sym_set] = ACTIONS(1478),
    [anon_sym_declare] = ACTIONS(1478),
    [anon_sym_public] = ACTIONS(1478),
    [anon_sym_private] = ACTIONS(1478),
    [anon_sym_protected] = ACTIONS(1478),
    [anon_sym_module] = ACTIONS(1478),
    [anon_sym_any] = ACTIONS(1478),
    [anon_sym_number] = ACTIONS(1478),
    [anon_sym_boolean] = ACTIONS(1478),
    [anon_sym_string] = ACTIONS(1478),
    [anon_sym_symbol] = ACTIONS(1478),
    [sym_readonly] = ACTIONS(1478),
  },
  [264] = {
    [sym_import] = STATE(1569),
    [sym_statement_block] = STATE(1706),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1194),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [265] = {
    [sym_import] = STATE(1063),
    [sym_parenthesized_expression] = STATE(678),
    [sym__expression] = STATE(1790),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1055),
    [sym_array] = STATE(1056),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1063),
    [sym_function] = STATE(1063),
    [sym_generator_function] = STATE(1063),
    [sym_arrow_function] = STATE(1063),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1063),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(678),
    [sym_subscript_expression] = STATE(678),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1063),
    [sym_template_string] = STATE(1063),
    [sym_regex] = STATE(1063),
    [sym_meta_property] = STATE(1063),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1398),
    [anon_sym_export] = ACTIONS(1400),
    [anon_sym_namespace] = ACTIONS(1402),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1400),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_DOT] = ACTIONS(1404),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1410),
    [sym_super] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_null] = ACTIONS(1410),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1400),
    [anon_sym_get] = ACTIONS(1400),
    [anon_sym_set] = ACTIONS(1400),
    [anon_sym_declare] = ACTIONS(1400),
    [anon_sym_public] = ACTIONS(1400),
    [anon_sym_private] = ACTIONS(1400),
    [anon_sym_protected] = ACTIONS(1400),
    [anon_sym_module] = ACTIONS(1400),
    [anon_sym_any] = ACTIONS(1400),
    [anon_sym_number] = ACTIONS(1400),
    [anon_sym_boolean] = ACTIONS(1400),
    [anon_sym_string] = ACTIONS(1400),
    [anon_sym_symbol] = ACTIONS(1400),
    [sym_readonly] = ACTIONS(1400),
  },
  [266] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1541),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3534),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [267] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1417),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_function_signature] = STATE(2712),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(1498),
    [anon_sym_function] = ACTIONS(1500),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [268] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1514),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3410),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [269] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1510),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3399),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [270] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1509),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_sequence_expression] = STATE(3405),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [271] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1169),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [272] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1092),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [273] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1254),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [274] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1252),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [275] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1241),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [276] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1140),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [277] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1269),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [278] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1253),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [279] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1058),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [280] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1246),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [281] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1137),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [282] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1492),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1502),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [283] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [284] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1635),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [285] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1261),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [286] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1267),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [287] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1663),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [288] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1277),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [289] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1134),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [290] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1207),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [291] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1286),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [292] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1695),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [293] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1206),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [294] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1495),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [295] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1276),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [296] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1336),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [297] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1323),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [298] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1322),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [299] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1493),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [300] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1326),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [301] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1309),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [302] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1492),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [303] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1310),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [304] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(1021),
    [sym__expression] = STATE(1790),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1817),
    [sym_array] = STATE(1819),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(1021),
    [sym_subscript_expression] = STATE(1021),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1020),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_export] = ACTIONS(1454),
    [anon_sym_namespace] = ACTIONS(1456),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(1454),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(1458),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_get] = ACTIONS(1454),
    [anon_sym_set] = ACTIONS(1454),
    [anon_sym_declare] = ACTIONS(1454),
    [anon_sym_public] = ACTIONS(1454),
    [anon_sym_private] = ACTIONS(1454),
    [anon_sym_protected] = ACTIONS(1454),
    [anon_sym_module] = ACTIONS(1454),
    [anon_sym_any] = ACTIONS(1454),
    [anon_sym_number] = ACTIONS(1454),
    [anon_sym_boolean] = ACTIONS(1454),
    [anon_sym_string] = ACTIONS(1454),
    [anon_sym_symbol] = ACTIONS(1454),
    [sym_readonly] = ACTIONS(1454),
  },
  [305] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1343),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1506),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [306] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1274),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [307] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1715),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [308] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1058),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [309] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1396),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [310] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1140),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1508),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [311] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1124),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [312] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1598),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [313] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1338),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [314] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1150),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [315] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1200),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(1510),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [316] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1156),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [317] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1161),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [318] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1347),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [319] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1557),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [320] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1318),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [321] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1200),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [322] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1352),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [323] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1360),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [324] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1362),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [325] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1363),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [326] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1364),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [327] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1365),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [328] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1368),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [329] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1413),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [330] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1374),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [331] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1350),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [332] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1315),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [333] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1155),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [334] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1308),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [335] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1258),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [336] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1217),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(1510),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [337] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1388),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [338] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1387),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [339] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1373),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [340] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1375),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [341] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1385),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [342] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1178),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [343] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1185),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [344] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1468),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [345] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1237),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [346] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1327),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [347] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1086),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [348] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1358),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [349] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1370),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [350] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1371),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [351] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1361),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [352] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1306),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [353] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1207),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1512),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [354] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1372),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [355] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1379),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [356] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1540),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [357] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1099),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [358] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1401),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [359] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1486),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [360] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1217),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [361] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1083),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [362] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1102),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [363] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1418),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [364] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1312),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [365] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1313),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [366] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1472),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [367] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1233),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [368] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1104),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [369] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1546),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(1512),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [370] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1233),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [371] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1542),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [372] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1140),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1516),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [373] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1257),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [374] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1106),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [375] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1544),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [376] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1108),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [377] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1113),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [378] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1412),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [379] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1284),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [380] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1396),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1506),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [381] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1294),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [382] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1684),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [383] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1190),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [384] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1546),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [385] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1206),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [386] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1460),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [387] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1140),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(1506),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [388] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1454),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [389] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1453),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [390] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(817),
    [sym__expression] = STATE(1103),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1407),
    [sym_array] = STATE(1406),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3518),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(817),
    [sym_subscript_expression] = STATE(817),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(824),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(595),
    [anon_sym_namespace] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(595),
    [anon_sym_typeof] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_void] = ACTIONS(497),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_get] = ACTIONS(595),
    [anon_sym_set] = ACTIONS(595),
    [anon_sym_declare] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_any] = ACTIONS(595),
    [anon_sym_number] = ACTIONS(595),
    [anon_sym_boolean] = ACTIONS(595),
    [anon_sym_string] = ACTIONS(595),
    [anon_sym_symbol] = ACTIONS(595),
    [sym_readonly] = ACTIONS(595),
  },
  [391] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1452),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [392] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1451),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [393] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1307),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [394] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1449),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [395] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1354),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [396] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1392),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [397] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1351),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [398] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1571),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [399] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [400] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1394),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [401] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1390),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [402] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1389),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [403] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1344),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [404] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1447),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [405] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1446),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [406] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1383),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [407] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(977),
    [sym__expression] = STATE(1384),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1424),
    [sym_array] = STATE(1425),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3609),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(977),
    [sym_subscript_expression] = STATE(977),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2034),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(979),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(831),
    [anon_sym_export] = ACTIONS(781),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
    [anon_sym_declare] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(781),
    [anon_sym_number] = ACTIONS(781),
    [anon_sym_boolean] = ACTIONS(781),
    [anon_sym_string] = ACTIONS(781),
    [anon_sym_symbol] = ACTIONS(781),
    [sym_readonly] = ACTIONS(781),
  },
  [408] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1342),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [409] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [410] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1650),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [411] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1436),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [412] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1334),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [413] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1435),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [414] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1331),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [415] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1432),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [416] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1382),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [417] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1343),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [418] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1316),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [419] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(1290),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1567),
    [sym_array] = STATE(1558),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3588),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(988),
    [sym_subscript_expression] = STATE(988),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(999),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(931),
    [anon_sym_export] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(751),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_typeof] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_void] = ACTIONS(771),
    [anon_sym_delete] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(749),
    [anon_sym_set] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_any] = ACTIONS(749),
    [anon_sym_number] = ACTIONS(749),
    [anon_sym_boolean] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_symbol] = ACTIONS(749),
    [sym_readonly] = ACTIONS(749),
  },
  [420] = {
    [sym_import] = STATE(1810),
    [sym_parenthesized_expression] = STATE(992),
    [sym__expression] = STATE(1286),
    [sym_yield_expression] = STATE(1805),
    [sym_object] = STATE(1575),
    [sym_array] = STATE(1573),
    [sym_jsx_element] = STATE(1805),
    [sym_jsx_fragment] = STATE(1805),
    [sym_jsx_opening_element] = STATE(2150),
    [sym_jsx_self_closing_element] = STATE(1805),
    [sym_class] = STATE(1810),
    [sym_function] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_arrow_function] = STATE(1810),
    [sym__call_signature] = STATE(3489),
    [sym_call_expression] = STATE(1810),
    [sym_new_expression] = STATE(1805),
    [sym_await_expression] = STATE(1805),
    [sym_member_expression] = STATE(992),
    [sym_subscript_expression] = STATE(992),
    [sym_assignment_expression] = STATE(1805),
    [sym__augmented_assignment_lhs] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(1805),
    [sym_ternary_expression] = STATE(1805),
    [sym_binary_expression] = STATE(1805),
    [sym_unary_expression] = STATE(1805),
    [sym_update_expression] = STATE(1805),
    [sym_string] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(993),
    [sym_as_expression] = STATE(1805),
    [sym_internal_module] = STATE(1805),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2905),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(529),
    [anon_sym_namespace] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(537),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(545),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(553),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_void] = ACTIONS(571),
    [anon_sym_delete] = ACTIONS(571),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_SQUOTE] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(579),
    [sym_number] = ACTIONS(1518),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(585),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_get] = ACTIONS(529),
    [anon_sym_set] = ACTIONS(529),
    [anon_sym_declare] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(529),
    [anon_sym_number] = ACTIONS(529),
    [anon_sym_boolean] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [anon_sym_symbol] = ACTIONS(529),
    [sym_readonly] = ACTIONS(529),
  },
  [421] = {
    [sym_import] = STATE(1569),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1428),
    [sym_yield_expression] = STATE(1581),
    [sym_object] = STATE(1737),
    [sym_array] = STATE(1776),
    [sym_jsx_element] = STATE(1581),
    [sym_jsx_fragment] = STATE(1581),
    [sym_jsx_opening_element] = STATE(2162),
    [sym_jsx_self_closing_element] = STATE(1581),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_arrow_function] = STATE(1569),
    [sym__call_signature] = STATE(3469),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1581),
    [sym_await_expression] = STATE(1581),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1581),
    [sym__augmented_assignment_lhs] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(1581),
    [sym_ternary_expression] = STATE(1581),
    [sym_binary_expression] = STATE(1581),
    [sym_unary_expression] = STATE(1581),
    [sym_update_expression] = STATE(1581),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(1016),
    [sym_as_expression] = STATE(1581),
    [sym_internal_module] = STATE(1581),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2883),
    [sym_identifier] = ACTIONS(941),
    [anon_sym_export] = ACTIONS(623),
    [anon_sym_namespace] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_type] = ACTIONS(623),
    [anon_sym_typeof] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(637),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_async] = ACTIONS(645),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_void] = ACTIONS(655),
    [anon_sym_delete] = ACTIONS(655),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_DQUOTE] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(85),
    [sym_number] = ACTIONS(87),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_get] = ACTIONS(623),
    [anon_sym_set] = ACTIONS(623),
    [anon_sym_declare] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_any] = ACTIONS(623),
    [anon_sym_number] = ACTIONS(623),
    [anon_sym_boolean] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [anon_sym_symbol] = ACTIONS(623),
    [sym_readonly] = ACTIONS(623),
  },
  [422] = {
    [sym_import] = STATE(1168),
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(1058),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1673),
    [sym_array] = STATE(1667),
    [sym_jsx_element] = STATE(1170),
    [sym_jsx_fragment] = STATE(1170),
    [sym_jsx_opening_element] = STATE(2163),
    [sym_jsx_self_closing_element] = STATE(1170),
    [sym_class] = STATE(1168),
    [sym_function] = STATE(1168),
    [sym_generator_function] = STATE(1168),
    [sym_arrow_function] = STATE(1168),
    [sym__call_signature] = STATE(3462),
    [sym_call_expression] = STATE(1168),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(991),
    [sym_subscript_expression] = STATE(991),
    [sym_assignment_expression] = STATE(1170),
    [sym__augmented_assignment_lhs] = STATE(2035),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1168),
    [sym_template_string] = STATE(1168),
    [sym_regex] = STATE(1168),
    [sym_meta_property] = STATE(1168),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(2519),
    [sym_non_null_expression] = STATE(998),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_export_statement_repeat1] = STATE(2934),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(711),
    [anon_sym_typeof] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(821),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(477),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(717),
    [anon_sym_void] = ACTIONS(733),
    [anon_sym_delete] = ACTIONS(733),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(829),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(511),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_get] = ACTIONS(711),
    [anon_sym_set] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_module] = ACTIONS(711),
    [anon_sym_any] = ACTIONS(711),
    [anon_sym_number] = ACTIONS(711),
    [anon_sym_boolean] = ACTIONS(711),
    [anon_sym_string] = ACTIONS(711),
    [anon_sym_symbol] = ACTIONS(711),
    [sym_readonly] = ACTIONS(711),
  },
  [423] = {
    [sym__call_signature] = STATE(3466),
    [sym_string] = STATE(2459),
    [sym_formal_parameters] = STATE(2519),
    [sym__property_name] = STATE(2459),
    [sym_computed_property_name] = STATE(2459),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_object_repeat1] = STATE(2959),
    [sym_identifier] = ACTIONS(1520),
    [anon_sym_export] = ACTIONS(1522),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1522),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1527),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1522),
    [anon_sym_function] = ACTIONS(1537),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1539),
    [anon_sym_static] = ACTIONS(1522),
    [anon_sym_get] = ACTIONS(1541),
    [anon_sym_set] = ACTIONS(1541),
    [anon_sym_declare] = ACTIONS(1522),
    [anon_sym_public] = ACTIONS(1522),
    [anon_sym_private] = ACTIONS(1522),
    [anon_sym_protected] = ACTIONS(1522),
    [anon_sym_module] = ACTIONS(1522),
    [anon_sym_any] = ACTIONS(1522),
    [anon_sym_number] = ACTIONS(1522),
    [anon_sym_boolean] = ACTIONS(1522),
    [anon_sym_string] = ACTIONS(1522),
    [anon_sym_symbol] = ACTIONS(1522),
    [sym_readonly] = ACTIONS(1522),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [424] = {
    [ts_builtin_sym_end] = ACTIONS(1543),
    [sym_identifier] = ACTIONS(1545),
    [anon_sym_export] = ACTIONS(1545),
    [anon_sym_default] = ACTIONS(1545),
    [anon_sym_EQ] = ACTIONS(1545),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1543),
    [anon_sym_COMMA] = ACTIONS(1543),
    [anon_sym_RBRACE] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1545),
    [anon_sym_typeof] = ACTIONS(1545),
    [anon_sym_import] = ACTIONS(1545),
    [anon_sym_var] = ACTIONS(1545),
    [anon_sym_let] = ACTIONS(1545),
    [anon_sym_const] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_else] = ACTIONS(1545),
    [anon_sym_if] = ACTIONS(1545),
    [anon_sym_switch] = ACTIONS(1545),
    [anon_sym_for] = ACTIONS(1545),
    [anon_sym_LPAREN] = ACTIONS(1543),
    [anon_sym_RPAREN] = ACTIONS(1543),
    [anon_sym_await] = ACTIONS(1545),
    [anon_sym_while] = ACTIONS(1545),
    [anon_sym_do] = ACTIONS(1545),
    [anon_sym_try] = ACTIONS(1545),
    [anon_sym_with] = ACTIONS(1545),
    [anon_sym_break] = ACTIONS(1545),
    [anon_sym_continue] = ACTIONS(1545),
    [anon_sym_debugger] = ACTIONS(1545),
    [anon_sym_return] = ACTIONS(1545),
    [anon_sym_throw] = ACTIONS(1545),
    [anon_sym_SEMI] = ACTIONS(1543),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_case] = ACTIONS(1545),
    [anon_sym_yield] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(1543),
    [anon_sym_RBRACK] = ACTIONS(1543),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_GT] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1545),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1545),
    [anon_sym_async] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(1545),
    [anon_sym_EQ_GT] = ACTIONS(1543),
    [anon_sym_new] = ACTIONS(1545),
    [anon_sym_QMARK] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_PIPE] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1543),
    [anon_sym_void] = ACTIONS(1545),
    [anon_sym_delete] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1543),
    [anon_sym_DASH_DASH] = ACTIONS(1543),
    [anon_sym_DQUOTE] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1543),
    [sym_number] = ACTIONS(1543),
    [sym_this] = ACTIONS(1545),
    [sym_super] = ACTIONS(1545),
    [sym_true] = ACTIONS(1545),
    [sym_false] = ACTIONS(1545),
    [sym_null] = ACTIONS(1545),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(1543),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_abstract] = ACTIONS(1545),
    [anon_sym_get] = ACTIONS(1545),
    [anon_sym_set] = ACTIONS(1545),
    [anon_sym_declare] = ACTIONS(1545),
    [anon_sym_public] = ACTIONS(1545),
    [anon_sym_private] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1545),
    [anon_sym_any] = ACTIONS(1545),
    [anon_sym_number] = ACTIONS(1545),
    [anon_sym_boolean] = ACTIONS(1545),
    [anon_sym_string] = ACTIONS(1545),
    [anon_sym_symbol] = ACTIONS(1545),
    [anon_sym_implements] = ACTIONS(1545),
    [anon_sym_interface] = ACTIONS(1545),
    [anon_sym_extends] = ACTIONS(1545),
    [anon_sym_enum] = ACTIONS(1545),
    [sym_readonly] = ACTIONS(1545),
  },
  [425] = {
    [sym__call_signature] = STATE(3466),
    [sym_string] = STATE(2459),
    [sym_formal_parameters] = STATE(2519),
    [sym__property_name] = STATE(2459),
    [sym_computed_property_name] = STATE(2459),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_object_repeat1] = STATE(3011),
    [sym_identifier] = ACTIONS(1520),
    [anon_sym_export] = ACTIONS(1522),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1522),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_type] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1527),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1522),
    [anon_sym_function] = ACTIONS(1537),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1539),
    [anon_sym_static] = ACTIONS(1522),
    [anon_sym_get] = ACTIONS(1541),
    [anon_sym_set] = ACTIONS(1541),
    [anon_sym_declare] = ACTIONS(1522),
    [anon_sym_public] = ACTIONS(1522),
    [anon_sym_private] = ACTIONS(1522),
    [anon_sym_protected] = ACTIONS(1522),
    [anon_sym_module] = ACTIONS(1522),
    [anon_sym_any] = ACTIONS(1522),
    [anon_sym_number] = ACTIONS(1522),
    [anon_sym_boolean] = ACTIONS(1522),
    [anon_sym_string] = ACTIONS(1522),
    [anon_sym_symbol] = ACTIONS(1522),
    [sym_readonly] = ACTIONS(1522),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [426] = {
    [sym__call_signature] = STATE(3466),
    [sym_string] = STATE(2459),
    [sym_formal_parameters] = STATE(2519),
    [sym__property_name] = STATE(2459),
    [sym_computed_property_name] = STATE(2459),
    [sym_type_parameters] = STATE(3215),
    [aux_sym_object_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(1520),
    [anon_sym_export] = ACTIONS(1522),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1522),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_type] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1527),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1522),
    [anon_sym_function] = ACTIONS(1537),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1539),
    [anon_sym_static] = ACTIONS(1522),
    [anon_sym_get] = ACTIONS(1541),
    [anon_sym_set] = ACTIONS(1541),
    [anon_sym_declare] = ACTIONS(1522),
    [anon_sym_public] = ACTIONS(1522),
    [anon_sym_private] = ACTIONS(1522),
    [anon_sym_protected] = ACTIONS(1522),
    [anon_sym_module] = ACTIONS(1522),
    [anon_sym_any] = ACTIONS(1522),
    [anon_sym_number] = ACTIONS(1522),
    [anon_sym_boolean] = ACTIONS(1522),
    [anon_sym_string] = ACTIONS(1522),
    [anon_sym_symbol] = ACTIONS(1522),
    [sym_readonly] = ACTIONS(1522),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [427] = {
    [ts_builtin_sym_end] = ACTIONS(1547),
    [sym_identifier] = ACTIONS(1549),
    [anon_sym_export] = ACTIONS(1549),
    [anon_sym_default] = ACTIONS(1549),
    [anon_sym_EQ] = ACTIONS(1549),
    [anon_sym_namespace] = ACTIONS(1549),
    [anon_sym_LBRACE] = ACTIONS(1547),
    [anon_sym_COMMA] = ACTIONS(1547),
    [anon_sym_RBRACE] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1549),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(1549),
    [anon_sym_var] = ACTIONS(1549),
    [anon_sym_let] = ACTIONS(1549),
    [anon_sym_const] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_else] = ACTIONS(1549),
    [anon_sym_if] = ACTIONS(1549),
    [anon_sym_switch] = ACTIONS(1549),
    [anon_sym_for] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_RPAREN] = ACTIONS(1547),
    [anon_sym_await] = ACTIONS(1549),
    [anon_sym_while] = ACTIONS(1549),
    [anon_sym_do] = ACTIONS(1549),
    [anon_sym_try] = ACTIONS(1549),
    [anon_sym_with] = ACTIONS(1549),
    [anon_sym_break] = ACTIONS(1549),
    [anon_sym_continue] = ACTIONS(1549),
    [anon_sym_debugger] = ACTIONS(1549),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_SEMI] = ACTIONS(1547),
    [anon_sym_COLON] = ACTIONS(1547),
    [anon_sym_case] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1549),
    [anon_sym_LBRACK] = ACTIONS(1547),
    [anon_sym_RBRACK] = ACTIONS(1547),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_GT] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1549),
    [anon_sym_class] = ACTIONS(1549),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_function] = ACTIONS(1549),
    [anon_sym_EQ_GT] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1549),
    [anon_sym_QMARK] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1547),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1547),
    [anon_sym_DASH_DASH] = ACTIONS(1547),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1547),
    [sym_number] = ACTIONS(1547),
    [sym_this] = ACTIONS(1549),
    [sym_super] = ACTIONS(1549),
    [sym_true] = ACTIONS(1549),
    [sym_false] = ACTIONS(1549),
    [sym_null] = ACTIONS(1549),
    [sym_undefined] = ACTIONS(1549),
    [anon_sym_AT] = ACTIONS(1547),
    [anon_sym_static] = ACTIONS(1549),
    [anon_sym_abstract] = ACTIONS(1549),
    [anon_sym_get] = ACTIONS(1549),
    [anon_sym_set] = ACTIONS(1549),
    [anon_sym_declare] = ACTIONS(1549),
    [anon_sym_public] = ACTIONS(1549),
    [anon_sym_private] = ACTIONS(1549),
    [anon_sym_protected] = ACTIONS(1549),
    [anon_sym_module] = ACTIONS(1549),
    [anon_sym_any] = ACTIONS(1549),
    [anon_sym_number] = ACTIONS(1549),
    [anon_sym_boolean] = ACTIONS(1549),
    [anon_sym_string] = ACTIONS(1549),
    [anon_sym_symbol] = ACTIONS(1549),
    [anon_sym_implements] = ACTIONS(1549),
    [anon_sym_interface] = ACTIONS(1549),
    [anon_sym_extends] = ACTIONS(1549),
    [anon_sym_enum] = ACTIONS(1549),
    [sym_readonly] = ACTIONS(1549),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1553),
    [anon_sym_export] = ACTIONS(1553),
    [anon_sym_default] = ACTIONS(1553),
    [anon_sym_EQ] = ACTIONS(1553),
    [anon_sym_namespace] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1551),
    [anon_sym_COMMA] = ACTIONS(1551),
    [anon_sym_RBRACE] = ACTIONS(1551),
    [anon_sym_type] = ACTIONS(1553),
    [anon_sym_typeof] = ACTIONS(1553),
    [anon_sym_import] = ACTIONS(1553),
    [anon_sym_var] = ACTIONS(1553),
    [anon_sym_let] = ACTIONS(1553),
    [anon_sym_const] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_else] = ACTIONS(1553),
    [anon_sym_if] = ACTIONS(1553),
    [anon_sym_switch] = ACTIONS(1553),
    [anon_sym_for] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_RPAREN] = ACTIONS(1551),
    [anon_sym_await] = ACTIONS(1553),
    [anon_sym_while] = ACTIONS(1553),
    [anon_sym_do] = ACTIONS(1553),
    [anon_sym_try] = ACTIONS(1553),
    [anon_sym_with] = ACTIONS(1553),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_continue] = ACTIONS(1553),
    [anon_sym_debugger] = ACTIONS(1553),
    [anon_sym_return] = ACTIONS(1553),
    [anon_sym_throw] = ACTIONS(1553),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym_COLON] = ACTIONS(1551),
    [anon_sym_case] = ACTIONS(1553),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(1551),
    [anon_sym_RBRACK] = ACTIONS(1551),
    [anon_sym_LT] = ACTIONS(1551),
    [anon_sym_GT] = ACTIONS(1551),
    [anon_sym_SLASH] = ACTIONS(1553),
    [anon_sym_class] = ACTIONS(1553),
    [anon_sym_async] = ACTIONS(1553),
    [anon_sym_function] = ACTIONS(1553),
    [anon_sym_EQ_GT] = ACTIONS(1551),
    [anon_sym_new] = ACTIONS(1553),
    [anon_sym_QMARK] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_PIPE] = ACTIONS(1551),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1553),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_void] = ACTIONS(1553),
    [anon_sym_delete] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1551),
    [sym_number] = ACTIONS(1551),
    [sym_this] = ACTIONS(1553),
    [sym_super] = ACTIONS(1553),
    [sym_true] = ACTIONS(1553),
    [sym_false] = ACTIONS(1553),
    [sym_null] = ACTIONS(1553),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1551),
    [anon_sym_static] = ACTIONS(1553),
    [anon_sym_abstract] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(1553),
    [anon_sym_set] = ACTIONS(1553),
    [anon_sym_declare] = ACTIONS(1553),
    [anon_sym_public] = ACTIONS(1553),
    [anon_sym_private] = ACTIONS(1553),
    [anon_sym_protected] = ACTIONS(1553),
    [anon_sym_module] = ACTIONS(1553),
    [anon_sym_any] = ACTIONS(1553),
    [anon_sym_number] = ACTIONS(1553),
    [anon_sym_boolean] = ACTIONS(1553),
    [anon_sym_string] = ACTIONS(1553),
    [anon_sym_symbol] = ACTIONS(1553),
    [anon_sym_implements] = ACTIONS(1553),
    [anon_sym_interface] = ACTIONS(1553),
    [anon_sym_extends] = ACTIONS(1553),
    [anon_sym_enum] = ACTIONS(1553),
    [sym_readonly] = ACTIONS(1553),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(1555),
    [sym_identifier] = ACTIONS(1557),
    [anon_sym_export] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(1557),
    [anon_sym_EQ] = ACTIONS(1557),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1555),
    [anon_sym_COMMA] = ACTIONS(1555),
    [anon_sym_RBRACE] = ACTIONS(1555),
    [anon_sym_type] = ACTIONS(1557),
    [anon_sym_typeof] = ACTIONS(1557),
    [anon_sym_import] = ACTIONS(1557),
    [anon_sym_var] = ACTIONS(1557),
    [anon_sym_let] = ACTIONS(1557),
    [anon_sym_const] = ACTIONS(1557),
    [anon_sym_BANG] = ACTIONS(1555),
    [anon_sym_else] = ACTIONS(1557),
    [anon_sym_if] = ACTIONS(1557),
    [anon_sym_switch] = ACTIONS(1557),
    [anon_sym_for] = ACTIONS(1557),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_RPAREN] = ACTIONS(1555),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_while] = ACTIONS(1557),
    [anon_sym_do] = ACTIONS(1557),
    [anon_sym_try] = ACTIONS(1557),
    [anon_sym_with] = ACTIONS(1557),
    [anon_sym_break] = ACTIONS(1557),
    [anon_sym_continue] = ACTIONS(1557),
    [anon_sym_debugger] = ACTIONS(1557),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_throw] = ACTIONS(1557),
    [anon_sym_SEMI] = ACTIONS(1555),
    [anon_sym_COLON] = ACTIONS(1555),
    [anon_sym_case] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1557),
    [anon_sym_LBRACK] = ACTIONS(1555),
    [anon_sym_RBRACK] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1555),
    [anon_sym_GT] = ACTIONS(1555),
    [anon_sym_SLASH] = ACTIONS(1557),
    [anon_sym_class] = ACTIONS(1557),
    [anon_sym_async] = ACTIONS(1557),
    [anon_sym_function] = ACTIONS(1557),
    [anon_sym_EQ_GT] = ACTIONS(1555),
    [anon_sym_new] = ACTIONS(1557),
    [anon_sym_QMARK] = ACTIONS(1555),
    [anon_sym_AMP] = ACTIONS(1555),
    [anon_sym_PIPE] = ACTIONS(1555),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_TILDE] = ACTIONS(1555),
    [anon_sym_void] = ACTIONS(1557),
    [anon_sym_delete] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1555),
    [anon_sym_DASH_DASH] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [anon_sym_SQUOTE] = ACTIONS(1555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1555),
    [sym_number] = ACTIONS(1555),
    [sym_this] = ACTIONS(1557),
    [sym_super] = ACTIONS(1557),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [sym_null] = ACTIONS(1557),
    [sym_undefined] = ACTIONS(1557),
    [anon_sym_AT] = ACTIONS(1555),
    [anon_sym_static] = ACTIONS(1557),
    [anon_sym_abstract] = ACTIONS(1557),
    [anon_sym_get] = ACTIONS(1557),
    [anon_sym_set] = ACTIONS(1557),
    [anon_sym_declare] = ACTIONS(1557),
    [anon_sym_public] = ACTIONS(1557),
    [anon_sym_private] = ACTIONS(1557),
    [anon_sym_protected] = ACTIONS(1557),
    [anon_sym_module] = ACTIONS(1557),
    [anon_sym_any] = ACTIONS(1557),
    [anon_sym_number] = ACTIONS(1557),
    [anon_sym_boolean] = ACTIONS(1557),
    [anon_sym_string] = ACTIONS(1557),
    [anon_sym_symbol] = ACTIONS(1557),
    [anon_sym_implements] = ACTIONS(1557),
    [anon_sym_interface] = ACTIONS(1557),
    [anon_sym_extends] = ACTIONS(1557),
    [anon_sym_enum] = ACTIONS(1557),
    [sym_readonly] = ACTIONS(1557),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(1559),
    [sym_identifier] = ACTIONS(1561),
    [anon_sym_export] = ACTIONS(1561),
    [anon_sym_default] = ACTIONS(1561),
    [anon_sym_EQ] = ACTIONS(1561),
    [anon_sym_namespace] = ACTIONS(1561),
    [anon_sym_LBRACE] = ACTIONS(1559),
    [anon_sym_COMMA] = ACTIONS(1559),
    [anon_sym_RBRACE] = ACTIONS(1559),
    [anon_sym_type] = ACTIONS(1561),
    [anon_sym_typeof] = ACTIONS(1561),
    [anon_sym_import] = ACTIONS(1561),
    [anon_sym_var] = ACTIONS(1561),
    [anon_sym_let] = ACTIONS(1561),
    [anon_sym_const] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_else] = ACTIONS(1561),
    [anon_sym_if] = ACTIONS(1561),
    [anon_sym_switch] = ACTIONS(1561),
    [anon_sym_for] = ACTIONS(1561),
    [anon_sym_LPAREN] = ACTIONS(1559),
    [anon_sym_RPAREN] = ACTIONS(1559),
    [anon_sym_await] = ACTIONS(1561),
    [anon_sym_while] = ACTIONS(1561),
    [anon_sym_do] = ACTIONS(1561),
    [anon_sym_try] = ACTIONS(1561),
    [anon_sym_with] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1561),
    [anon_sym_continue] = ACTIONS(1561),
    [anon_sym_debugger] = ACTIONS(1561),
    [anon_sym_return] = ACTIONS(1561),
    [anon_sym_throw] = ACTIONS(1561),
    [anon_sym_SEMI] = ACTIONS(1559),
    [anon_sym_COLON] = ACTIONS(1559),
    [anon_sym_case] = ACTIONS(1561),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_LBRACK] = ACTIONS(1559),
    [anon_sym_RBRACK] = ACTIONS(1559),
    [anon_sym_LT] = ACTIONS(1559),
    [anon_sym_GT] = ACTIONS(1559),
    [anon_sym_SLASH] = ACTIONS(1561),
    [anon_sym_class] = ACTIONS(1561),
    [anon_sym_async] = ACTIONS(1561),
    [anon_sym_function] = ACTIONS(1561),
    [anon_sym_EQ_GT] = ACTIONS(1559),
    [anon_sym_new] = ACTIONS(1561),
    [anon_sym_QMARK] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_PIPE] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_TILDE] = ACTIONS(1559),
    [anon_sym_void] = ACTIONS(1561),
    [anon_sym_delete] = ACTIONS(1561),
    [anon_sym_PLUS_PLUS] = ACTIONS(1559),
    [anon_sym_DASH_DASH] = ACTIONS(1559),
    [anon_sym_DQUOTE] = ACTIONS(1559),
    [anon_sym_SQUOTE] = ACTIONS(1559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1559),
    [sym_number] = ACTIONS(1559),
    [sym_this] = ACTIONS(1561),
    [sym_super] = ACTIONS(1561),
    [sym_true] = ACTIONS(1561),
    [sym_false] = ACTIONS(1561),
    [sym_null] = ACTIONS(1561),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(1559),
    [anon_sym_static] = ACTIONS(1561),
    [anon_sym_abstract] = ACTIONS(1561),
    [anon_sym_get] = ACTIONS(1561),
    [anon_sym_set] = ACTIONS(1561),
    [anon_sym_declare] = ACTIONS(1561),
    [anon_sym_public] = ACTIONS(1561),
    [anon_sym_private] = ACTIONS(1561),
    [anon_sym_protected] = ACTIONS(1561),
    [anon_sym_module] = ACTIONS(1561),
    [anon_sym_any] = ACTIONS(1561),
    [anon_sym_number] = ACTIONS(1561),
    [anon_sym_boolean] = ACTIONS(1561),
    [anon_sym_string] = ACTIONS(1561),
    [anon_sym_symbol] = ACTIONS(1561),
    [anon_sym_implements] = ACTIONS(1561),
    [anon_sym_interface] = ACTIONS(1561),
    [anon_sym_extends] = ACTIONS(1561),
    [anon_sym_enum] = ACTIONS(1561),
    [sym_readonly] = ACTIONS(1561),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(1563),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1565),
    [anon_sym_default] = ACTIONS(1565),
    [anon_sym_EQ] = ACTIONS(1565),
    [anon_sym_namespace] = ACTIONS(1565),
    [anon_sym_LBRACE] = ACTIONS(1563),
    [anon_sym_COMMA] = ACTIONS(1563),
    [anon_sym_RBRACE] = ACTIONS(1563),
    [anon_sym_type] = ACTIONS(1565),
    [anon_sym_typeof] = ACTIONS(1565),
    [anon_sym_import] = ACTIONS(1565),
    [anon_sym_var] = ACTIONS(1565),
    [anon_sym_let] = ACTIONS(1565),
    [anon_sym_const] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_else] = ACTIONS(1565),
    [anon_sym_if] = ACTIONS(1565),
    [anon_sym_switch] = ACTIONS(1565),
    [anon_sym_for] = ACTIONS(1565),
    [anon_sym_LPAREN] = ACTIONS(1563),
    [anon_sym_RPAREN] = ACTIONS(1563),
    [anon_sym_await] = ACTIONS(1565),
    [anon_sym_while] = ACTIONS(1565),
    [anon_sym_do] = ACTIONS(1565),
    [anon_sym_try] = ACTIONS(1565),
    [anon_sym_with] = ACTIONS(1565),
    [anon_sym_break] = ACTIONS(1565),
    [anon_sym_continue] = ACTIONS(1565),
    [anon_sym_debugger] = ACTIONS(1565),
    [anon_sym_return] = ACTIONS(1565),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_SEMI] = ACTIONS(1563),
    [anon_sym_COLON] = ACTIONS(1563),
    [anon_sym_case] = ACTIONS(1565),
    [anon_sym_yield] = ACTIONS(1565),
    [anon_sym_LBRACK] = ACTIONS(1563),
    [anon_sym_RBRACK] = ACTIONS(1563),
    [anon_sym_LT] = ACTIONS(1563),
    [anon_sym_GT] = ACTIONS(1563),
    [anon_sym_SLASH] = ACTIONS(1565),
    [anon_sym_class] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1565),
    [anon_sym_function] = ACTIONS(1565),
    [anon_sym_EQ_GT] = ACTIONS(1563),
    [anon_sym_new] = ACTIONS(1565),
    [anon_sym_QMARK] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_PIPE] = ACTIONS(1563),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_void] = ACTIONS(1565),
    [anon_sym_delete] = ACTIONS(1565),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_DQUOTE] = ACTIONS(1563),
    [anon_sym_SQUOTE] = ACTIONS(1563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1563),
    [sym_number] = ACTIONS(1563),
    [sym_this] = ACTIONS(1565),
    [sym_super] = ACTIONS(1565),
    [sym_true] = ACTIONS(1565),
    [sym_false] = ACTIONS(1565),
    [sym_null] = ACTIONS(1565),
    [sym_undefined] = ACTIONS(1565),
    [anon_sym_AT] = ACTIONS(1563),
    [anon_sym_static] = ACTIONS(1565),
    [anon_sym_abstract] = ACTIONS(1565),
    [anon_sym_get] = ACTIONS(1565),
    [anon_sym_set] = ACTIONS(1565),
    [anon_sym_declare] = ACTIONS(1565),
    [anon_sym_public] = ACTIONS(1565),
    [anon_sym_private] = ACTIONS(1565),
    [anon_sym_protected] = ACTIONS(1565),
    [anon_sym_module] = ACTIONS(1565),
    [anon_sym_any] = ACTIONS(1565),
    [anon_sym_number] = ACTIONS(1565),
    [anon_sym_boolean] = ACTIONS(1565),
    [anon_sym_string] = ACTIONS(1565),
    [anon_sym_symbol] = ACTIONS(1565),
    [anon_sym_implements] = ACTIONS(1565),
    [anon_sym_interface] = ACTIONS(1565),
    [anon_sym_extends] = ACTIONS(1565),
    [anon_sym_enum] = ACTIONS(1565),
    [sym_readonly] = ACTIONS(1565),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(1567),
    [sym_identifier] = ACTIONS(1569),
    [anon_sym_export] = ACTIONS(1569),
    [anon_sym_default] = ACTIONS(1569),
    [anon_sym_EQ] = ACTIONS(1569),
    [anon_sym_namespace] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [anon_sym_COMMA] = ACTIONS(1567),
    [anon_sym_RBRACE] = ACTIONS(1567),
    [anon_sym_type] = ACTIONS(1569),
    [anon_sym_typeof] = ACTIONS(1569),
    [anon_sym_import] = ACTIONS(1569),
    [anon_sym_var] = ACTIONS(1569),
    [anon_sym_let] = ACTIONS(1569),
    [anon_sym_const] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_else] = ACTIONS(1569),
    [anon_sym_if] = ACTIONS(1569),
    [anon_sym_switch] = ACTIONS(1569),
    [anon_sym_for] = ACTIONS(1569),
    [anon_sym_LPAREN] = ACTIONS(1567),
    [anon_sym_RPAREN] = ACTIONS(1567),
    [anon_sym_await] = ACTIONS(1569),
    [anon_sym_while] = ACTIONS(1569),
    [anon_sym_do] = ACTIONS(1569),
    [anon_sym_try] = ACTIONS(1569),
    [anon_sym_with] = ACTIONS(1569),
    [anon_sym_break] = ACTIONS(1569),
    [anon_sym_continue] = ACTIONS(1569),
    [anon_sym_debugger] = ACTIONS(1569),
    [anon_sym_return] = ACTIONS(1569),
    [anon_sym_throw] = ACTIONS(1569),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym_COLON] = ACTIONS(1567),
    [anon_sym_case] = ACTIONS(1569),
    [anon_sym_yield] = ACTIONS(1569),
    [anon_sym_LBRACK] = ACTIONS(1567),
    [anon_sym_RBRACK] = ACTIONS(1567),
    [anon_sym_LT] = ACTIONS(1567),
    [anon_sym_GT] = ACTIONS(1567),
    [anon_sym_SLASH] = ACTIONS(1569),
    [anon_sym_class] = ACTIONS(1569),
    [anon_sym_async] = ACTIONS(1569),
    [anon_sym_function] = ACTIONS(1569),
    [anon_sym_EQ_GT] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_QMARK] = ACTIONS(1567),
    [anon_sym_AMP] = ACTIONS(1567),
    [anon_sym_PIPE] = ACTIONS(1567),
    [anon_sym_PLUS] = ACTIONS(1569),
    [anon_sym_DASH] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_void] = ACTIONS(1569),
    [anon_sym_delete] = ACTIONS(1569),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1567),
    [anon_sym_SQUOTE] = ACTIONS(1567),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [sym_number] = ACTIONS(1567),
    [sym_this] = ACTIONS(1569),
    [sym_super] = ACTIONS(1569),
    [sym_true] = ACTIONS(1569),
    [sym_false] = ACTIONS(1569),
    [sym_null] = ACTIONS(1569),
    [sym_undefined] = ACTIONS(1569),
    [anon_sym_AT] = ACTIONS(1567),
    [anon_sym_static] = ACTIONS(1569),
    [anon_sym_abstract] = ACTIONS(1569),
    [anon_sym_get] = ACTIONS(1569),
    [anon_sym_set] = ACTIONS(1569),
    [anon_sym_declare] = ACTIONS(1569),
    [anon_sym_public] = ACTIONS(1569),
    [anon_sym_private] = ACTIONS(1569),
    [anon_sym_protected] = ACTIONS(1569),
    [anon_sym_module] = ACTIONS(1569),
    [anon_sym_any] = ACTIONS(1569),
    [anon_sym_number] = ACTIONS(1569),
    [anon_sym_boolean] = ACTIONS(1569),
    [anon_sym_string] = ACTIONS(1569),
    [anon_sym_symbol] = ACTIONS(1569),
    [anon_sym_interface] = ACTIONS(1569),
    [anon_sym_extends] = ACTIONS(1569),
    [anon_sym_enum] = ACTIONS(1569),
    [sym_readonly] = ACTIONS(1569),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(1571),
    [sym_identifier] = ACTIONS(1573),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_default] = ACTIONS(1573),
    [anon_sym_EQ] = ACTIONS(1573),
    [anon_sym_namespace] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_COMMA] = ACTIONS(1571),
    [anon_sym_RBRACE] = ACTIONS(1571),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_typeof] = ACTIONS(1573),
    [anon_sym_import] = ACTIONS(1573),
    [anon_sym_var] = ACTIONS(1573),
    [anon_sym_let] = ACTIONS(1573),
    [anon_sym_const] = ACTIONS(1573),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_else] = ACTIONS(1573),
    [anon_sym_if] = ACTIONS(1573),
    [anon_sym_switch] = ACTIONS(1573),
    [anon_sym_for] = ACTIONS(1573),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_RPAREN] = ACTIONS(1571),
    [anon_sym_await] = ACTIONS(1573),
    [anon_sym_while] = ACTIONS(1573),
    [anon_sym_do] = ACTIONS(1573),
    [anon_sym_try] = ACTIONS(1573),
    [anon_sym_with] = ACTIONS(1573),
    [anon_sym_break] = ACTIONS(1573),
    [anon_sym_continue] = ACTIONS(1573),
    [anon_sym_debugger] = ACTIONS(1573),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_throw] = ACTIONS(1573),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_COLON] = ACTIONS(1571),
    [anon_sym_case] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1573),
    [anon_sym_LBRACK] = ACTIONS(1575),
    [anon_sym_RBRACK] = ACTIONS(1571),
    [anon_sym_LT] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(1571),
    [anon_sym_SLASH] = ACTIONS(1573),
    [anon_sym_class] = ACTIONS(1573),
    [anon_sym_async] = ACTIONS(1573),
    [anon_sym_function] = ACTIONS(1573),
    [anon_sym_EQ_GT] = ACTIONS(1571),
    [anon_sym_new] = ACTIONS(1573),
    [anon_sym_QMARK] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_PIPE] = ACTIONS(1571),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_void] = ACTIONS(1573),
    [anon_sym_delete] = ACTIONS(1573),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_DQUOTE] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1571),
    [sym_number] = ACTIONS(1571),
    [sym_this] = ACTIONS(1573),
    [sym_super] = ACTIONS(1573),
    [sym_true] = ACTIONS(1573),
    [sym_false] = ACTIONS(1573),
    [sym_null] = ACTIONS(1573),
    [sym_undefined] = ACTIONS(1573),
    [anon_sym_AT] = ACTIONS(1571),
    [anon_sym_static] = ACTIONS(1573),
    [anon_sym_abstract] = ACTIONS(1573),
    [anon_sym_get] = ACTIONS(1573),
    [anon_sym_set] = ACTIONS(1573),
    [anon_sym_declare] = ACTIONS(1573),
    [anon_sym_public] = ACTIONS(1573),
    [anon_sym_private] = ACTIONS(1573),
    [anon_sym_protected] = ACTIONS(1573),
    [anon_sym_module] = ACTIONS(1573),
    [anon_sym_any] = ACTIONS(1573),
    [anon_sym_number] = ACTIONS(1573),
    [anon_sym_boolean] = ACTIONS(1573),
    [anon_sym_string] = ACTIONS(1573),
    [anon_sym_symbol] = ACTIONS(1573),
    [anon_sym_interface] = ACTIONS(1573),
    [anon_sym_extends] = ACTIONS(1573),
    [anon_sym_enum] = ACTIONS(1573),
    [sym_readonly] = ACTIONS(1573),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(1577),
    [sym_identifier] = ACTIONS(1579),
    [anon_sym_export] = ACTIONS(1579),
    [anon_sym_default] = ACTIONS(1579),
    [anon_sym_EQ] = ACTIONS(1579),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1577),
    [anon_sym_COMMA] = ACTIONS(1577),
    [anon_sym_RBRACE] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1579),
    [anon_sym_typeof] = ACTIONS(1579),
    [anon_sym_import] = ACTIONS(1579),
    [anon_sym_var] = ACTIONS(1579),
    [anon_sym_let] = ACTIONS(1579),
    [anon_sym_const] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1577),
    [anon_sym_else] = ACTIONS(1579),
    [anon_sym_if] = ACTIONS(1579),
    [anon_sym_switch] = ACTIONS(1579),
    [anon_sym_for] = ACTIONS(1579),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_RPAREN] = ACTIONS(1577),
    [anon_sym_await] = ACTIONS(1579),
    [anon_sym_while] = ACTIONS(1579),
    [anon_sym_do] = ACTIONS(1579),
    [anon_sym_try] = ACTIONS(1579),
    [anon_sym_with] = ACTIONS(1579),
    [anon_sym_break] = ACTIONS(1579),
    [anon_sym_continue] = ACTIONS(1579),
    [anon_sym_debugger] = ACTIONS(1579),
    [anon_sym_return] = ACTIONS(1579),
    [anon_sym_throw] = ACTIONS(1579),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_COLON] = ACTIONS(1577),
    [anon_sym_case] = ACTIONS(1579),
    [anon_sym_yield] = ACTIONS(1579),
    [anon_sym_LBRACK] = ACTIONS(1577),
    [anon_sym_RBRACK] = ACTIONS(1577),
    [anon_sym_LT] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(1577),
    [anon_sym_SLASH] = ACTIONS(1579),
    [anon_sym_class] = ACTIONS(1579),
    [anon_sym_async] = ACTIONS(1579),
    [anon_sym_function] = ACTIONS(1579),
    [anon_sym_EQ_GT] = ACTIONS(1577),
    [anon_sym_new] = ACTIONS(1579),
    [anon_sym_QMARK] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(1579),
    [anon_sym_DASH] = ACTIONS(1579),
    [anon_sym_TILDE] = ACTIONS(1577),
    [anon_sym_void] = ACTIONS(1579),
    [anon_sym_delete] = ACTIONS(1579),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_DQUOTE] = ACTIONS(1577),
    [anon_sym_SQUOTE] = ACTIONS(1577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1577),
    [sym_number] = ACTIONS(1577),
    [sym_this] = ACTIONS(1579),
    [sym_super] = ACTIONS(1579),
    [sym_true] = ACTIONS(1579),
    [sym_false] = ACTIONS(1579),
    [sym_null] = ACTIONS(1579),
    [sym_undefined] = ACTIONS(1579),
    [anon_sym_AT] = ACTIONS(1577),
    [anon_sym_static] = ACTIONS(1579),
    [anon_sym_abstract] = ACTIONS(1579),
    [anon_sym_get] = ACTIONS(1579),
    [anon_sym_set] = ACTIONS(1579),
    [anon_sym_declare] = ACTIONS(1579),
    [anon_sym_public] = ACTIONS(1579),
    [anon_sym_private] = ACTIONS(1579),
    [anon_sym_protected] = ACTIONS(1579),
    [anon_sym_module] = ACTIONS(1579),
    [anon_sym_any] = ACTIONS(1579),
    [anon_sym_number] = ACTIONS(1579),
    [anon_sym_boolean] = ACTIONS(1579),
    [anon_sym_string] = ACTIONS(1579),
    [anon_sym_symbol] = ACTIONS(1579),
    [anon_sym_interface] = ACTIONS(1579),
    [anon_sym_extends] = ACTIONS(1579),
    [anon_sym_enum] = ACTIONS(1579),
    [sym_readonly] = ACTIONS(1579),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(1581),
    [sym_identifier] = ACTIONS(1583),
    [anon_sym_export] = ACTIONS(1583),
    [anon_sym_default] = ACTIONS(1583),
    [anon_sym_EQ] = ACTIONS(1583),
    [anon_sym_namespace] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1581),
    [anon_sym_COMMA] = ACTIONS(1581),
    [anon_sym_RBRACE] = ACTIONS(1581),
    [anon_sym_type] = ACTIONS(1583),
    [anon_sym_typeof] = ACTIONS(1583),
    [anon_sym_import] = ACTIONS(1583),
    [anon_sym_var] = ACTIONS(1583),
    [anon_sym_let] = ACTIONS(1583),
    [anon_sym_const] = ACTIONS(1583),
    [anon_sym_BANG] = ACTIONS(1581),
    [anon_sym_else] = ACTIONS(1583),
    [anon_sym_if] = ACTIONS(1583),
    [anon_sym_switch] = ACTIONS(1583),
    [anon_sym_for] = ACTIONS(1583),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_RPAREN] = ACTIONS(1581),
    [anon_sym_await] = ACTIONS(1583),
    [anon_sym_while] = ACTIONS(1583),
    [anon_sym_do] = ACTIONS(1583),
    [anon_sym_try] = ACTIONS(1583),
    [anon_sym_with] = ACTIONS(1583),
    [anon_sym_break] = ACTIONS(1583),
    [anon_sym_continue] = ACTIONS(1583),
    [anon_sym_debugger] = ACTIONS(1583),
    [anon_sym_return] = ACTIONS(1583),
    [anon_sym_throw] = ACTIONS(1583),
    [anon_sym_SEMI] = ACTIONS(1581),
    [anon_sym_COLON] = ACTIONS(1581),
    [anon_sym_case] = ACTIONS(1583),
    [anon_sym_yield] = ACTIONS(1583),
    [anon_sym_LBRACK] = ACTIONS(1585),
    [anon_sym_RBRACK] = ACTIONS(1581),
    [anon_sym_LT] = ACTIONS(1581),
    [anon_sym_GT] = ACTIONS(1581),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_class] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(1583),
    [anon_sym_EQ_GT] = ACTIONS(1581),
    [anon_sym_new] = ACTIONS(1583),
    [anon_sym_QMARK] = ACTIONS(1581),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_PIPE] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1583),
    [anon_sym_DASH] = ACTIONS(1583),
    [anon_sym_TILDE] = ACTIONS(1581),
    [anon_sym_void] = ACTIONS(1583),
    [anon_sym_delete] = ACTIONS(1583),
    [anon_sym_PLUS_PLUS] = ACTIONS(1581),
    [anon_sym_DASH_DASH] = ACTIONS(1581),
    [anon_sym_DQUOTE] = ACTIONS(1581),
    [anon_sym_SQUOTE] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1581),
    [sym_number] = ACTIONS(1581),
    [sym_this] = ACTIONS(1583),
    [sym_super] = ACTIONS(1583),
    [sym_true] = ACTIONS(1583),
    [sym_false] = ACTIONS(1583),
    [sym_null] = ACTIONS(1583),
    [sym_undefined] = ACTIONS(1583),
    [anon_sym_AT] = ACTIONS(1581),
    [anon_sym_static] = ACTIONS(1583),
    [anon_sym_abstract] = ACTIONS(1583),
    [anon_sym_get] = ACTIONS(1583),
    [anon_sym_set] = ACTIONS(1583),
    [anon_sym_declare] = ACTIONS(1583),
    [anon_sym_public] = ACTIONS(1583),
    [anon_sym_private] = ACTIONS(1583),
    [anon_sym_protected] = ACTIONS(1583),
    [anon_sym_module] = ACTIONS(1583),
    [anon_sym_any] = ACTIONS(1583),
    [anon_sym_number] = ACTIONS(1583),
    [anon_sym_boolean] = ACTIONS(1583),
    [anon_sym_string] = ACTIONS(1583),
    [anon_sym_symbol] = ACTIONS(1583),
    [anon_sym_interface] = ACTIONS(1583),
    [anon_sym_extends] = ACTIONS(1587),
    [anon_sym_enum] = ACTIONS(1583),
    [sym_readonly] = ACTIONS(1583),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(1589),
    [sym_identifier] = ACTIONS(1591),
    [anon_sym_export] = ACTIONS(1591),
    [anon_sym_default] = ACTIONS(1591),
    [anon_sym_EQ] = ACTIONS(1591),
    [anon_sym_namespace] = ACTIONS(1591),
    [anon_sym_LBRACE] = ACTIONS(1589),
    [anon_sym_COMMA] = ACTIONS(1589),
    [anon_sym_RBRACE] = ACTIONS(1589),
    [anon_sym_type] = ACTIONS(1591),
    [anon_sym_typeof] = ACTIONS(1591),
    [anon_sym_import] = ACTIONS(1591),
    [anon_sym_var] = ACTIONS(1591),
    [anon_sym_let] = ACTIONS(1591),
    [anon_sym_const] = ACTIONS(1591),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_else] = ACTIONS(1591),
    [anon_sym_if] = ACTIONS(1591),
    [anon_sym_switch] = ACTIONS(1591),
    [anon_sym_for] = ACTIONS(1591),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_RPAREN] = ACTIONS(1589),
    [anon_sym_await] = ACTIONS(1591),
    [anon_sym_while] = ACTIONS(1591),
    [anon_sym_do] = ACTIONS(1591),
    [anon_sym_try] = ACTIONS(1591),
    [anon_sym_with] = ACTIONS(1591),
    [anon_sym_break] = ACTIONS(1591),
    [anon_sym_continue] = ACTIONS(1591),
    [anon_sym_debugger] = ACTIONS(1591),
    [anon_sym_return] = ACTIONS(1591),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_SEMI] = ACTIONS(1589),
    [anon_sym_COLON] = ACTIONS(1589),
    [anon_sym_case] = ACTIONS(1591),
    [anon_sym_yield] = ACTIONS(1591),
    [anon_sym_LBRACK] = ACTIONS(1589),
    [anon_sym_RBRACK] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_SLASH] = ACTIONS(1591),
    [anon_sym_class] = ACTIONS(1591),
    [anon_sym_async] = ACTIONS(1591),
    [anon_sym_function] = ACTIONS(1591),
    [anon_sym_EQ_GT] = ACTIONS(1589),
    [anon_sym_new] = ACTIONS(1591),
    [anon_sym_QMARK] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_void] = ACTIONS(1591),
    [anon_sym_delete] = ACTIONS(1591),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_SQUOTE] = ACTIONS(1589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [sym_number] = ACTIONS(1589),
    [sym_this] = ACTIONS(1591),
    [sym_super] = ACTIONS(1591),
    [sym_true] = ACTIONS(1591),
    [sym_false] = ACTIONS(1591),
    [sym_null] = ACTIONS(1591),
    [sym_undefined] = ACTIONS(1591),
    [anon_sym_AT] = ACTIONS(1589),
    [anon_sym_static] = ACTIONS(1591),
    [anon_sym_abstract] = ACTIONS(1591),
    [anon_sym_get] = ACTIONS(1591),
    [anon_sym_set] = ACTIONS(1591),
    [anon_sym_declare] = ACTIONS(1591),
    [anon_sym_public] = ACTIONS(1591),
    [anon_sym_private] = ACTIONS(1591),
    [anon_sym_protected] = ACTIONS(1591),
    [anon_sym_module] = ACTIONS(1591),
    [anon_sym_any] = ACTIONS(1591),
    [anon_sym_number] = ACTIONS(1591),
    [anon_sym_boolean] = ACTIONS(1591),
    [anon_sym_string] = ACTIONS(1591),
    [anon_sym_symbol] = ACTIONS(1591),
    [anon_sym_interface] = ACTIONS(1591),
    [anon_sym_extends] = ACTIONS(1591),
    [anon_sym_enum] = ACTIONS(1591),
    [sym_readonly] = ACTIONS(1591),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(1593),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_export] = ACTIONS(1595),
    [anon_sym_default] = ACTIONS(1595),
    [anon_sym_EQ] = ACTIONS(1595),
    [anon_sym_namespace] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(1593),
    [anon_sym_COMMA] = ACTIONS(1593),
    [anon_sym_RBRACE] = ACTIONS(1593),
    [anon_sym_type] = ACTIONS(1595),
    [anon_sym_typeof] = ACTIONS(1595),
    [anon_sym_import] = ACTIONS(1595),
    [anon_sym_var] = ACTIONS(1595),
    [anon_sym_let] = ACTIONS(1595),
    [anon_sym_const] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1593),
    [anon_sym_else] = ACTIONS(1595),
    [anon_sym_if] = ACTIONS(1595),
    [anon_sym_switch] = ACTIONS(1595),
    [anon_sym_for] = ACTIONS(1595),
    [anon_sym_LPAREN] = ACTIONS(1593),
    [anon_sym_RPAREN] = ACTIONS(1593),
    [anon_sym_await] = ACTIONS(1595),
    [anon_sym_while] = ACTIONS(1595),
    [anon_sym_do] = ACTIONS(1595),
    [anon_sym_try] = ACTIONS(1595),
    [anon_sym_with] = ACTIONS(1595),
    [anon_sym_break] = ACTIONS(1595),
    [anon_sym_continue] = ACTIONS(1595),
    [anon_sym_debugger] = ACTIONS(1595),
    [anon_sym_return] = ACTIONS(1595),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_SEMI] = ACTIONS(1593),
    [anon_sym_COLON] = ACTIONS(1593),
    [anon_sym_case] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(1595),
    [anon_sym_LBRACK] = ACTIONS(1593),
    [anon_sym_RBRACK] = ACTIONS(1593),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1593),
    [anon_sym_SLASH] = ACTIONS(1595),
    [anon_sym_class] = ACTIONS(1595),
    [anon_sym_async] = ACTIONS(1595),
    [anon_sym_function] = ACTIONS(1595),
    [anon_sym_EQ_GT] = ACTIONS(1593),
    [anon_sym_new] = ACTIONS(1595),
    [anon_sym_QMARK] = ACTIONS(1593),
    [anon_sym_AMP] = ACTIONS(1593),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_TILDE] = ACTIONS(1593),
    [anon_sym_void] = ACTIONS(1595),
    [anon_sym_delete] = ACTIONS(1595),
    [anon_sym_PLUS_PLUS] = ACTIONS(1593),
    [anon_sym_DASH_DASH] = ACTIONS(1593),
    [anon_sym_DQUOTE] = ACTIONS(1593),
    [anon_sym_SQUOTE] = ACTIONS(1593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1593),
    [sym_number] = ACTIONS(1593),
    [sym_this] = ACTIONS(1595),
    [sym_super] = ACTIONS(1595),
    [sym_true] = ACTIONS(1595),
    [sym_false] = ACTIONS(1595),
    [sym_null] = ACTIONS(1595),
    [sym_undefined] = ACTIONS(1595),
    [anon_sym_AT] = ACTIONS(1593),
    [anon_sym_static] = ACTIONS(1595),
    [anon_sym_abstract] = ACTIONS(1595),
    [anon_sym_get] = ACTIONS(1595),
    [anon_sym_set] = ACTIONS(1595),
    [anon_sym_declare] = ACTIONS(1595),
    [anon_sym_public] = ACTIONS(1595),
    [anon_sym_private] = ACTIONS(1595),
    [anon_sym_protected] = ACTIONS(1595),
    [anon_sym_module] = ACTIONS(1595),
    [anon_sym_any] = ACTIONS(1595),
    [anon_sym_number] = ACTIONS(1595),
    [anon_sym_boolean] = ACTIONS(1595),
    [anon_sym_string] = ACTIONS(1595),
    [anon_sym_symbol] = ACTIONS(1595),
    [anon_sym_interface] = ACTIONS(1595),
    [anon_sym_extends] = ACTIONS(1595),
    [anon_sym_enum] = ACTIONS(1595),
    [sym_readonly] = ACTIONS(1595),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(1597),
    [sym_identifier] = ACTIONS(1599),
    [anon_sym_export] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(1599),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1599),
    [anon_sym_typeof] = ACTIONS(1599),
    [anon_sym_import] = ACTIONS(1599),
    [anon_sym_var] = ACTIONS(1599),
    [anon_sym_let] = ACTIONS(1599),
    [anon_sym_const] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_else] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(1599),
    [anon_sym_switch] = ACTIONS(1599),
    [anon_sym_for] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_RPAREN] = ACTIONS(1597),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_while] = ACTIONS(1599),
    [anon_sym_do] = ACTIONS(1599),
    [anon_sym_try] = ACTIONS(1599),
    [anon_sym_with] = ACTIONS(1599),
    [anon_sym_break] = ACTIONS(1599),
    [anon_sym_continue] = ACTIONS(1599),
    [anon_sym_debugger] = ACTIONS(1599),
    [anon_sym_return] = ACTIONS(1599),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_COLON] = ACTIONS(1597),
    [anon_sym_case] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(1597),
    [anon_sym_GT] = ACTIONS(1597),
    [anon_sym_SLASH] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(1599),
    [anon_sym_async] = ACTIONS(1599),
    [anon_sym_function] = ACTIONS(1599),
    [anon_sym_EQ_GT] = ACTIONS(1597),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_QMARK] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_PIPE] = ACTIONS(1597),
    [anon_sym_PLUS] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1597),
    [anon_sym_void] = ACTIONS(1599),
    [anon_sym_delete] = ACTIONS(1599),
    [anon_sym_PLUS_PLUS] = ACTIONS(1597),
    [anon_sym_DASH_DASH] = ACTIONS(1597),
    [anon_sym_DQUOTE] = ACTIONS(1597),
    [anon_sym_SQUOTE] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1597),
    [sym_number] = ACTIONS(1597),
    [sym_this] = ACTIONS(1599),
    [sym_super] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_null] = ACTIONS(1599),
    [sym_undefined] = ACTIONS(1599),
    [anon_sym_AT] = ACTIONS(1597),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_abstract] = ACTIONS(1599),
    [anon_sym_get] = ACTIONS(1599),
    [anon_sym_set] = ACTIONS(1599),
    [anon_sym_declare] = ACTIONS(1599),
    [anon_sym_public] = ACTIONS(1599),
    [anon_sym_private] = ACTIONS(1599),
    [anon_sym_protected] = ACTIONS(1599),
    [anon_sym_module] = ACTIONS(1599),
    [anon_sym_any] = ACTIONS(1599),
    [anon_sym_number] = ACTIONS(1599),
    [anon_sym_boolean] = ACTIONS(1599),
    [anon_sym_string] = ACTIONS(1599),
    [anon_sym_symbol] = ACTIONS(1599),
    [anon_sym_interface] = ACTIONS(1599),
    [anon_sym_extends] = ACTIONS(1599),
    [anon_sym_enum] = ACTIONS(1599),
    [sym_readonly] = ACTIONS(1599),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(1601),
    [sym_identifier] = ACTIONS(1603),
    [anon_sym_export] = ACTIONS(1603),
    [anon_sym_default] = ACTIONS(1603),
    [anon_sym_EQ] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1603),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_COMMA] = ACTIONS(1601),
    [anon_sym_RBRACE] = ACTIONS(1601),
    [anon_sym_type] = ACTIONS(1603),
    [anon_sym_typeof] = ACTIONS(1603),
    [anon_sym_import] = ACTIONS(1603),
    [anon_sym_var] = ACTIONS(1603),
    [anon_sym_let] = ACTIONS(1603),
    [anon_sym_const] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_else] = ACTIONS(1603),
    [anon_sym_if] = ACTIONS(1603),
    [anon_sym_switch] = ACTIONS(1603),
    [anon_sym_for] = ACTIONS(1603),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1601),
    [anon_sym_await] = ACTIONS(1603),
    [anon_sym_while] = ACTIONS(1603),
    [anon_sym_do] = ACTIONS(1603),
    [anon_sym_try] = ACTIONS(1603),
    [anon_sym_with] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1603),
    [anon_sym_continue] = ACTIONS(1603),
    [anon_sym_debugger] = ACTIONS(1603),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_throw] = ACTIONS(1603),
    [anon_sym_SEMI] = ACTIONS(1601),
    [anon_sym_COLON] = ACTIONS(1601),
    [anon_sym_case] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_LBRACK] = ACTIONS(1601),
    [anon_sym_RBRACK] = ACTIONS(1601),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1603),
    [anon_sym_class] = ACTIONS(1603),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(1603),
    [anon_sym_EQ_GT] = ACTIONS(1601),
    [anon_sym_new] = ACTIONS(1603),
    [anon_sym_QMARK] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1603),
    [anon_sym_DASH] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1601),
    [anon_sym_void] = ACTIONS(1603),
    [anon_sym_delete] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1601),
    [anon_sym_DASH_DASH] = ACTIONS(1601),
    [anon_sym_DQUOTE] = ACTIONS(1601),
    [anon_sym_SQUOTE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1601),
    [sym_number] = ACTIONS(1601),
    [sym_this] = ACTIONS(1603),
    [sym_super] = ACTIONS(1603),
    [sym_true] = ACTIONS(1603),
    [sym_false] = ACTIONS(1603),
    [sym_null] = ACTIONS(1603),
    [sym_undefined] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(1601),
    [anon_sym_static] = ACTIONS(1603),
    [anon_sym_abstract] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1603),
    [anon_sym_set] = ACTIONS(1603),
    [anon_sym_declare] = ACTIONS(1603),
    [anon_sym_public] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1603),
    [anon_sym_protected] = ACTIONS(1603),
    [anon_sym_module] = ACTIONS(1603),
    [anon_sym_any] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1603),
    [anon_sym_interface] = ACTIONS(1603),
    [anon_sym_extends] = ACTIONS(1603),
    [anon_sym_enum] = ACTIONS(1603),
    [sym_readonly] = ACTIONS(1603),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(1605),
    [sym_identifier] = ACTIONS(1607),
    [anon_sym_export] = ACTIONS(1607),
    [anon_sym_default] = ACTIONS(1607),
    [anon_sym_EQ] = ACTIONS(1607),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_LBRACE] = ACTIONS(1605),
    [anon_sym_COMMA] = ACTIONS(1605),
    [anon_sym_RBRACE] = ACTIONS(1605),
    [anon_sym_type] = ACTIONS(1607),
    [anon_sym_typeof] = ACTIONS(1607),
    [anon_sym_import] = ACTIONS(1607),
    [anon_sym_var] = ACTIONS(1607),
    [anon_sym_let] = ACTIONS(1607),
    [anon_sym_const] = ACTIONS(1607),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_else] = ACTIONS(1607),
    [anon_sym_if] = ACTIONS(1607),
    [anon_sym_switch] = ACTIONS(1607),
    [anon_sym_for] = ACTIONS(1607),
    [anon_sym_LPAREN] = ACTIONS(1605),
    [anon_sym_RPAREN] = ACTIONS(1605),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_while] = ACTIONS(1607),
    [anon_sym_do] = ACTIONS(1607),
    [anon_sym_try] = ACTIONS(1607),
    [anon_sym_with] = ACTIONS(1607),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_continue] = ACTIONS(1607),
    [anon_sym_debugger] = ACTIONS(1607),
    [anon_sym_return] = ACTIONS(1607),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_SEMI] = ACTIONS(1605),
    [anon_sym_COLON] = ACTIONS(1605),
    [anon_sym_case] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_RBRACK] = ACTIONS(1605),
    [anon_sym_LT] = ACTIONS(1605),
    [anon_sym_GT] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(1607),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_async] = ACTIONS(1607),
    [anon_sym_function] = ACTIONS(1607),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_QMARK] = ACTIONS(1605),
    [anon_sym_AMP] = ACTIONS(1605),
    [anon_sym_PIPE] = ACTIONS(1605),
    [anon_sym_PLUS] = ACTIONS(1607),
    [anon_sym_DASH] = ACTIONS(1607),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1607),
    [anon_sym_delete] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1605),
    [anon_sym_DASH_DASH] = ACTIONS(1605),
    [anon_sym_DQUOTE] = ACTIONS(1605),
    [anon_sym_SQUOTE] = ACTIONS(1605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1605),
    [sym_number] = ACTIONS(1605),
    [sym_this] = ACTIONS(1607),
    [sym_super] = ACTIONS(1607),
    [sym_true] = ACTIONS(1607),
    [sym_false] = ACTIONS(1607),
    [sym_null] = ACTIONS(1607),
    [sym_undefined] = ACTIONS(1607),
    [anon_sym_AT] = ACTIONS(1605),
    [anon_sym_static] = ACTIONS(1607),
    [anon_sym_abstract] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(1607),
    [anon_sym_set] = ACTIONS(1607),
    [anon_sym_declare] = ACTIONS(1607),
    [anon_sym_public] = ACTIONS(1607),
    [anon_sym_private] = ACTIONS(1607),
    [anon_sym_protected] = ACTIONS(1607),
    [anon_sym_module] = ACTIONS(1607),
    [anon_sym_any] = ACTIONS(1607),
    [anon_sym_number] = ACTIONS(1607),
    [anon_sym_boolean] = ACTIONS(1607),
    [anon_sym_string] = ACTIONS(1607),
    [anon_sym_symbol] = ACTIONS(1607),
    [anon_sym_interface] = ACTIONS(1607),
    [anon_sym_extends] = ACTIONS(1607),
    [anon_sym_enum] = ACTIONS(1607),
    [sym_readonly] = ACTIONS(1607),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1049),
    [anon_sym_export] = ACTIONS(1049),
    [anon_sym_default] = ACTIONS(1049),
    [anon_sym_EQ] = ACTIONS(1049),
    [anon_sym_namespace] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1049),
    [anon_sym_typeof] = ACTIONS(1049),
    [anon_sym_import] = ACTIONS(1049),
    [anon_sym_var] = ACTIONS(1049),
    [anon_sym_let] = ACTIONS(1049),
    [anon_sym_const] = ACTIONS(1049),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_else] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(1049),
    [anon_sym_switch] = ACTIONS(1049),
    [anon_sym_for] = ACTIONS(1049),
    [anon_sym_LPAREN] = ACTIONS(1047),
    [anon_sym_RPAREN] = ACTIONS(1047),
    [anon_sym_await] = ACTIONS(1049),
    [anon_sym_while] = ACTIONS(1049),
    [anon_sym_do] = ACTIONS(1049),
    [anon_sym_try] = ACTIONS(1049),
    [anon_sym_with] = ACTIONS(1049),
    [anon_sym_break] = ACTIONS(1049),
    [anon_sym_continue] = ACTIONS(1049),
    [anon_sym_debugger] = ACTIONS(1049),
    [anon_sym_return] = ACTIONS(1049),
    [anon_sym_throw] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1047),
    [anon_sym_COLON] = ACTIONS(1047),
    [anon_sym_case] = ACTIONS(1049),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1047),
    [anon_sym_GT] = ACTIONS(1047),
    [anon_sym_SLASH] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1049),
    [anon_sym_function] = ACTIONS(1049),
    [anon_sym_EQ_GT] = ACTIONS(1047),
    [anon_sym_new] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1047),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(1047),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_TILDE] = ACTIONS(1047),
    [anon_sym_void] = ACTIONS(1049),
    [anon_sym_delete] = ACTIONS(1049),
    [anon_sym_PLUS_PLUS] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(1047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1047),
    [sym_number] = ACTIONS(1047),
    [sym_this] = ACTIONS(1049),
    [sym_super] = ACTIONS(1049),
    [sym_true] = ACTIONS(1049),
    [sym_false] = ACTIONS(1049),
    [sym_null] = ACTIONS(1049),
    [sym_undefined] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1049),
    [anon_sym_abstract] = ACTIONS(1049),
    [anon_sym_get] = ACTIONS(1049),
    [anon_sym_set] = ACTIONS(1049),
    [anon_sym_declare] = ACTIONS(1049),
    [anon_sym_public] = ACTIONS(1049),
    [anon_sym_private] = ACTIONS(1049),
    [anon_sym_protected] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1049),
    [anon_sym_any] = ACTIONS(1049),
    [anon_sym_number] = ACTIONS(1049),
    [anon_sym_boolean] = ACTIONS(1049),
    [anon_sym_string] = ACTIONS(1049),
    [anon_sym_symbol] = ACTIONS(1049),
    [anon_sym_interface] = ACTIONS(1049),
    [anon_sym_extends] = ACTIONS(1049),
    [anon_sym_enum] = ACTIONS(1049),
    [sym_readonly] = ACTIONS(1049),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(1611),
    [anon_sym_EQ] = ACTIONS(1611),
    [anon_sym_namespace] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1611),
    [anon_sym_var] = ACTIONS(1611),
    [anon_sym_let] = ACTIONS(1611),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_BANG] = ACTIONS(1609),
    [anon_sym_else] = ACTIONS(1611),
    [anon_sym_if] = ACTIONS(1611),
    [anon_sym_switch] = ACTIONS(1611),
    [anon_sym_for] = ACTIONS(1611),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_while] = ACTIONS(1611),
    [anon_sym_do] = ACTIONS(1611),
    [anon_sym_try] = ACTIONS(1611),
    [anon_sym_with] = ACTIONS(1611),
    [anon_sym_break] = ACTIONS(1611),
    [anon_sym_continue] = ACTIONS(1611),
    [anon_sym_debugger] = ACTIONS(1611),
    [anon_sym_return] = ACTIONS(1611),
    [anon_sym_throw] = ACTIONS(1611),
    [anon_sym_SEMI] = ACTIONS(1609),
    [anon_sym_COLON] = ACTIONS(1609),
    [anon_sym_case] = ACTIONS(1611),
    [anon_sym_yield] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1575),
    [anon_sym_RBRACK] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1611),
    [anon_sym_class] = ACTIONS(1611),
    [anon_sym_async] = ACTIONS(1611),
    [anon_sym_function] = ACTIONS(1611),
    [anon_sym_EQ_GT] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1611),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_AMP] = ACTIONS(1609),
    [anon_sym_PIPE] = ACTIONS(1609),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1611),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(1609),
    [anon_sym_SQUOTE] = ACTIONS(1609),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1609),
    [sym_number] = ACTIONS(1609),
    [sym_this] = ACTIONS(1611),
    [sym_super] = ACTIONS(1611),
    [sym_true] = ACTIONS(1611),
    [sym_false] = ACTIONS(1611),
    [sym_null] = ACTIONS(1611),
    [sym_undefined] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(1609),
    [anon_sym_static] = ACTIONS(1611),
    [anon_sym_abstract] = ACTIONS(1611),
    [anon_sym_get] = ACTIONS(1611),
    [anon_sym_set] = ACTIONS(1611),
    [anon_sym_declare] = ACTIONS(1611),
    [anon_sym_public] = ACTIONS(1611),
    [anon_sym_private] = ACTIONS(1611),
    [anon_sym_protected] = ACTIONS(1611),
    [anon_sym_module] = ACTIONS(1611),
    [anon_sym_any] = ACTIONS(1611),
    [anon_sym_number] = ACTIONS(1611),
    [anon_sym_boolean] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_symbol] = ACTIONS(1611),
    [anon_sym_interface] = ACTIONS(1611),
    [anon_sym_extends] = ACTIONS(1611),
    [anon_sym_enum] = ACTIONS(1611),
    [sym_readonly] = ACTIONS(1611),
  },
  [443] = {
    [ts_builtin_sym_end] = ACTIONS(1613),
    [sym_identifier] = ACTIONS(1615),
    [anon_sym_export] = ACTIONS(1615),
    [anon_sym_default] = ACTIONS(1615),
    [anon_sym_EQ] = ACTIONS(1615),
    [anon_sym_namespace] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1613),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_RBRACE] = ACTIONS(1613),
    [anon_sym_type] = ACTIONS(1615),
    [anon_sym_typeof] = ACTIONS(1615),
    [anon_sym_import] = ACTIONS(1615),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1615),
    [anon_sym_const] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1613),
    [anon_sym_else] = ACTIONS(1615),
    [anon_sym_if] = ACTIONS(1615),
    [anon_sym_switch] = ACTIONS(1615),
    [anon_sym_for] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_RPAREN] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1615),
    [anon_sym_while] = ACTIONS(1615),
    [anon_sym_do] = ACTIONS(1615),
    [anon_sym_try] = ACTIONS(1615),
    [anon_sym_with] = ACTIONS(1615),
    [anon_sym_break] = ACTIONS(1615),
    [anon_sym_continue] = ACTIONS(1615),
    [anon_sym_debugger] = ACTIONS(1615),
    [anon_sym_return] = ACTIONS(1615),
    [anon_sym_throw] = ACTIONS(1615),
    [anon_sym_SEMI] = ACTIONS(1613),
    [anon_sym_COLON] = ACTIONS(1613),
    [anon_sym_case] = ACTIONS(1615),
    [anon_sym_yield] = ACTIONS(1615),
    [anon_sym_LBRACK] = ACTIONS(1613),
    [anon_sym_RBRACK] = ACTIONS(1613),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_GT] = ACTIONS(1613),
    [anon_sym_SLASH] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(1615),
    [anon_sym_async] = ACTIONS(1615),
    [anon_sym_function] = ACTIONS(1615),
    [anon_sym_EQ_GT] = ACTIONS(1613),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_QMARK] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_PIPE] = ACTIONS(1613),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_DASH] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1613),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_delete] = ACTIONS(1615),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_SQUOTE] = ACTIONS(1613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1613),
    [sym_number] = ACTIONS(1613),
    [sym_this] = ACTIONS(1615),
    [sym_super] = ACTIONS(1615),
    [sym_true] = ACTIONS(1615),
    [sym_false] = ACTIONS(1615),
    [sym_null] = ACTIONS(1615),
    [sym_undefined] = ACTIONS(1615),
    [anon_sym_AT] = ACTIONS(1613),
    [anon_sym_static] = ACTIONS(1615),
    [anon_sym_abstract] = ACTIONS(1615),
    [anon_sym_get] = ACTIONS(1615),
    [anon_sym_set] = ACTIONS(1615),
    [anon_sym_declare] = ACTIONS(1615),
    [anon_sym_public] = ACTIONS(1615),
    [anon_sym_private] = ACTIONS(1615),
    [anon_sym_protected] = ACTIONS(1615),
    [anon_sym_module] = ACTIONS(1615),
    [anon_sym_any] = ACTIONS(1615),
    [anon_sym_number] = ACTIONS(1615),
    [anon_sym_boolean] = ACTIONS(1615),
    [anon_sym_string] = ACTIONS(1615),
    [anon_sym_symbol] = ACTIONS(1615),
    [anon_sym_interface] = ACTIONS(1615),
    [anon_sym_extends] = ACTIONS(1615),
    [anon_sym_enum] = ACTIONS(1615),
    [sym_readonly] = ACTIONS(1615),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1619),
    [anon_sym_export] = ACTIONS(1619),
    [anon_sym_default] = ACTIONS(1619),
    [anon_sym_EQ] = ACTIONS(1619),
    [anon_sym_namespace] = ACTIONS(1619),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_COMMA] = ACTIONS(1617),
    [anon_sym_RBRACE] = ACTIONS(1617),
    [anon_sym_type] = ACTIONS(1619),
    [anon_sym_typeof] = ACTIONS(1619),
    [anon_sym_import] = ACTIONS(1619),
    [anon_sym_var] = ACTIONS(1619),
    [anon_sym_let] = ACTIONS(1619),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_else] = ACTIONS(1619),
    [anon_sym_if] = ACTIONS(1619),
    [anon_sym_switch] = ACTIONS(1619),
    [anon_sym_for] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(1617),
    [anon_sym_RPAREN] = ACTIONS(1617),
    [anon_sym_await] = ACTIONS(1619),
    [anon_sym_while] = ACTIONS(1619),
    [anon_sym_do] = ACTIONS(1619),
    [anon_sym_try] = ACTIONS(1619),
    [anon_sym_with] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1619),
    [anon_sym_continue] = ACTIONS(1619),
    [anon_sym_debugger] = ACTIONS(1619),
    [anon_sym_return] = ACTIONS(1619),
    [anon_sym_throw] = ACTIONS(1619),
    [anon_sym_SEMI] = ACTIONS(1617),
    [anon_sym_COLON] = ACTIONS(1617),
    [anon_sym_case] = ACTIONS(1619),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(1617),
    [anon_sym_RBRACK] = ACTIONS(1617),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1617),
    [anon_sym_SLASH] = ACTIONS(1619),
    [anon_sym_class] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1619),
    [anon_sym_function] = ACTIONS(1619),
    [anon_sym_EQ_GT] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1619),
    [anon_sym_QMARK] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1617),
    [anon_sym_void] = ACTIONS(1619),
    [anon_sym_delete] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1617),
    [anon_sym_DASH_DASH] = ACTIONS(1617),
    [anon_sym_DQUOTE] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1617),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1619),
    [sym_super] = ACTIONS(1619),
    [sym_true] = ACTIONS(1619),
    [sym_false] = ACTIONS(1619),
    [sym_null] = ACTIONS(1619),
    [sym_undefined] = ACTIONS(1619),
    [anon_sym_AT] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1619),
    [anon_sym_abstract] = ACTIONS(1619),
    [anon_sym_get] = ACTIONS(1619),
    [anon_sym_set] = ACTIONS(1619),
    [anon_sym_declare] = ACTIONS(1619),
    [anon_sym_public] = ACTIONS(1619),
    [anon_sym_private] = ACTIONS(1619),
    [anon_sym_protected] = ACTIONS(1619),
    [anon_sym_module] = ACTIONS(1619),
    [anon_sym_any] = ACTIONS(1619),
    [anon_sym_number] = ACTIONS(1619),
    [anon_sym_boolean] = ACTIONS(1619),
    [anon_sym_string] = ACTIONS(1619),
    [anon_sym_symbol] = ACTIONS(1619),
    [anon_sym_interface] = ACTIONS(1619),
    [anon_sym_extends] = ACTIONS(1619),
    [anon_sym_enum] = ACTIONS(1619),
    [sym_readonly] = ACTIONS(1619),
  },
  [445] = {
    [ts_builtin_sym_end] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_default] = ACTIONS(1623),
    [anon_sym_EQ] = ACTIONS(1623),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1621),
    [anon_sym_COMMA] = ACTIONS(1621),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_typeof] = ACTIONS(1623),
    [anon_sym_import] = ACTIONS(1623),
    [anon_sym_var] = ACTIONS(1623),
    [anon_sym_let] = ACTIONS(1623),
    [anon_sym_const] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_else] = ACTIONS(1623),
    [anon_sym_if] = ACTIONS(1623),
    [anon_sym_switch] = ACTIONS(1623),
    [anon_sym_for] = ACTIONS(1623),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_RPAREN] = ACTIONS(1621),
    [anon_sym_await] = ACTIONS(1623),
    [anon_sym_while] = ACTIONS(1623),
    [anon_sym_do] = ACTIONS(1623),
    [anon_sym_try] = ACTIONS(1623),
    [anon_sym_with] = ACTIONS(1623),
    [anon_sym_break] = ACTIONS(1623),
    [anon_sym_continue] = ACTIONS(1623),
    [anon_sym_debugger] = ACTIONS(1623),
    [anon_sym_return] = ACTIONS(1623),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_COLON] = ACTIONS(1621),
    [anon_sym_case] = ACTIONS(1623),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_RBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(1621),
    [anon_sym_SLASH] = ACTIONS(1623),
    [anon_sym_class] = ACTIONS(1623),
    [anon_sym_async] = ACTIONS(1623),
    [anon_sym_function] = ACTIONS(1623),
    [anon_sym_EQ_GT] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1623),
    [anon_sym_QMARK] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_PLUS] = ACTIONS(1623),
    [anon_sym_DASH] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_void] = ACTIONS(1623),
    [anon_sym_delete] = ACTIONS(1623),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1621),
    [sym_number] = ACTIONS(1621),
    [sym_this] = ACTIONS(1623),
    [sym_super] = ACTIONS(1623),
    [sym_true] = ACTIONS(1623),
    [sym_false] = ACTIONS(1623),
    [sym_null] = ACTIONS(1623),
    [sym_undefined] = ACTIONS(1623),
    [anon_sym_AT] = ACTIONS(1621),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_abstract] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1623),
    [anon_sym_set] = ACTIONS(1623),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [anon_sym_interface] = ACTIONS(1623),
    [anon_sym_extends] = ACTIONS(1623),
    [anon_sym_enum] = ACTIONS(1623),
    [sym_readonly] = ACTIONS(1623),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(1625),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1627),
    [anon_sym_default] = ACTIONS(1627),
    [anon_sym_EQ] = ACTIONS(1627),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_type] = ACTIONS(1627),
    [anon_sym_typeof] = ACTIONS(1627),
    [anon_sym_import] = ACTIONS(1627),
    [anon_sym_var] = ACTIONS(1627),
    [anon_sym_let] = ACTIONS(1627),
    [anon_sym_const] = ACTIONS(1627),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_switch] = ACTIONS(1627),
    [anon_sym_for] = ACTIONS(1627),
    [anon_sym_LPAREN] = ACTIONS(1625),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_await] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_try] = ACTIONS(1627),
    [anon_sym_with] = ACTIONS(1627),
    [anon_sym_break] = ACTIONS(1627),
    [anon_sym_continue] = ACTIONS(1627),
    [anon_sym_debugger] = ACTIONS(1627),
    [anon_sym_return] = ACTIONS(1627),
    [anon_sym_throw] = ACTIONS(1627),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_COLON] = ACTIONS(1625),
    [anon_sym_case] = ACTIONS(1627),
    [anon_sym_yield] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_RBRACK] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1625),
    [anon_sym_GT] = ACTIONS(1625),
    [anon_sym_SLASH] = ACTIONS(1627),
    [anon_sym_class] = ACTIONS(1627),
    [anon_sym_async] = ACTIONS(1627),
    [anon_sym_function] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1625),
    [anon_sym_new] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(1625),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_void] = ACTIONS(1627),
    [anon_sym_delete] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [anon_sym_SQUOTE] = ACTIONS(1625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [sym_number] = ACTIONS(1625),
    [sym_this] = ACTIONS(1627),
    [sym_super] = ACTIONS(1627),
    [sym_true] = ACTIONS(1627),
    [sym_false] = ACTIONS(1627),
    [sym_null] = ACTIONS(1627),
    [sym_undefined] = ACTIONS(1627),
    [anon_sym_AT] = ACTIONS(1625),
    [anon_sym_static] = ACTIONS(1627),
    [anon_sym_abstract] = ACTIONS(1627),
    [anon_sym_get] = ACTIONS(1627),
    [anon_sym_set] = ACTIONS(1627),
    [anon_sym_declare] = ACTIONS(1627),
    [anon_sym_public] = ACTIONS(1627),
    [anon_sym_private] = ACTIONS(1627),
    [anon_sym_protected] = ACTIONS(1627),
    [anon_sym_module] = ACTIONS(1627),
    [anon_sym_any] = ACTIONS(1627),
    [anon_sym_number] = ACTIONS(1627),
    [anon_sym_boolean] = ACTIONS(1627),
    [anon_sym_string] = ACTIONS(1627),
    [anon_sym_symbol] = ACTIONS(1627),
    [anon_sym_interface] = ACTIONS(1627),
    [anon_sym_extends] = ACTIONS(1627),
    [anon_sym_enum] = ACTIONS(1627),
    [sym_readonly] = ACTIONS(1627),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(1629),
    [sym_identifier] = ACTIONS(1631),
    [anon_sym_export] = ACTIONS(1631),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_EQ] = ACTIONS(1631),
    [anon_sym_namespace] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1629),
    [anon_sym_COMMA] = ACTIONS(1629),
    [anon_sym_RBRACE] = ACTIONS(1629),
    [anon_sym_type] = ACTIONS(1631),
    [anon_sym_typeof] = ACTIONS(1631),
    [anon_sym_import] = ACTIONS(1631),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1631),
    [anon_sym_const] = ACTIONS(1631),
    [anon_sym_BANG] = ACTIONS(1629),
    [anon_sym_else] = ACTIONS(1631),
    [anon_sym_if] = ACTIONS(1631),
    [anon_sym_switch] = ACTIONS(1631),
    [anon_sym_for] = ACTIONS(1631),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_RPAREN] = ACTIONS(1629),
    [anon_sym_await] = ACTIONS(1631),
    [anon_sym_while] = ACTIONS(1631),
    [anon_sym_do] = ACTIONS(1631),
    [anon_sym_try] = ACTIONS(1631),
    [anon_sym_with] = ACTIONS(1631),
    [anon_sym_break] = ACTIONS(1631),
    [anon_sym_continue] = ACTIONS(1631),
    [anon_sym_debugger] = ACTIONS(1631),
    [anon_sym_return] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_SEMI] = ACTIONS(1629),
    [anon_sym_COLON] = ACTIONS(1629),
    [anon_sym_case] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(1631),
    [anon_sym_LBRACK] = ACTIONS(1629),
    [anon_sym_RBRACK] = ACTIONS(1629),
    [anon_sym_LT] = ACTIONS(1629),
    [anon_sym_GT] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_class] = ACTIONS(1631),
    [anon_sym_async] = ACTIONS(1631),
    [anon_sym_function] = ACTIONS(1631),
    [anon_sym_EQ_GT] = ACTIONS(1629),
    [anon_sym_new] = ACTIONS(1631),
    [anon_sym_QMARK] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1629),
    [anon_sym_PIPE] = ACTIONS(1629),
    [anon_sym_PLUS] = ACTIONS(1631),
    [anon_sym_DASH] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1629),
    [anon_sym_void] = ACTIONS(1631),
    [anon_sym_delete] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1629),
    [anon_sym_DASH_DASH] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(1629),
    [anon_sym_SQUOTE] = ACTIONS(1629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1629),
    [sym_number] = ACTIONS(1629),
    [sym_this] = ACTIONS(1631),
    [sym_super] = ACTIONS(1631),
    [sym_true] = ACTIONS(1631),
    [sym_false] = ACTIONS(1631),
    [sym_null] = ACTIONS(1631),
    [sym_undefined] = ACTIONS(1631),
    [anon_sym_AT] = ACTIONS(1629),
    [anon_sym_static] = ACTIONS(1631),
    [anon_sym_abstract] = ACTIONS(1631),
    [anon_sym_get] = ACTIONS(1631),
    [anon_sym_set] = ACTIONS(1631),
    [anon_sym_declare] = ACTIONS(1631),
    [anon_sym_public] = ACTIONS(1631),
    [anon_sym_private] = ACTIONS(1631),
    [anon_sym_protected] = ACTIONS(1631),
    [anon_sym_module] = ACTIONS(1631),
    [anon_sym_any] = ACTIONS(1631),
    [anon_sym_number] = ACTIONS(1631),
    [anon_sym_boolean] = ACTIONS(1631),
    [anon_sym_string] = ACTIONS(1631),
    [anon_sym_symbol] = ACTIONS(1631),
    [anon_sym_interface] = ACTIONS(1631),
    [anon_sym_extends] = ACTIONS(1631),
    [anon_sym_enum] = ACTIONS(1631),
    [sym_readonly] = ACTIONS(1631),
  },
  [448] = {
    [ts_builtin_sym_end] = ACTIONS(1163),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_export] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_namespace] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_type] = ACTIONS(1165),
    [anon_sym_typeof] = ACTIONS(1165),
    [anon_sym_import] = ACTIONS(1165),
    [anon_sym_var] = ACTIONS(1165),
    [anon_sym_let] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_else] = ACTIONS(1165),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_switch] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_RPAREN] = ACTIONS(1163),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_do] = ACTIONS(1165),
    [anon_sym_try] = ACTIONS(1165),
    [anon_sym_with] = ACTIONS(1165),
    [anon_sym_break] = ACTIONS(1165),
    [anon_sym_continue] = ACTIONS(1165),
    [anon_sym_debugger] = ACTIONS(1165),
    [anon_sym_return] = ACTIONS(1165),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_COLON] = ACTIONS(1163),
    [anon_sym_case] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_RBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1163),
    [anon_sym_GT] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_class] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1165),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_EQ_GT] = ACTIONS(1163),
    [anon_sym_new] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_void] = ACTIONS(1165),
    [anon_sym_delete] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1163),
    [sym_number] = ACTIONS(1163),
    [sym_this] = ACTIONS(1165),
    [sym_super] = ACTIONS(1165),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [sym_null] = ACTIONS(1165),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(1163),
    [anon_sym_static] = ACTIONS(1165),
    [anon_sym_abstract] = ACTIONS(1165),
    [anon_sym_get] = ACTIONS(1165),
    [anon_sym_set] = ACTIONS(1165),
    [anon_sym_declare] = ACTIONS(1165),
    [anon_sym_public] = ACTIONS(1165),
    [anon_sym_private] = ACTIONS(1165),
    [anon_sym_protected] = ACTIONS(1165),
    [anon_sym_module] = ACTIONS(1165),
    [anon_sym_any] = ACTIONS(1165),
    [anon_sym_number] = ACTIONS(1165),
    [anon_sym_boolean] = ACTIONS(1165),
    [anon_sym_string] = ACTIONS(1165),
    [anon_sym_symbol] = ACTIONS(1165),
    [anon_sym_interface] = ACTIONS(1165),
    [anon_sym_extends] = ACTIONS(1165),
    [anon_sym_enum] = ACTIONS(1165),
    [sym_readonly] = ACTIONS(1165),
  },
  [449] = {
    [ts_builtin_sym_end] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1635),
    [anon_sym_export] = ACTIONS(1635),
    [anon_sym_default] = ACTIONS(1635),
    [anon_sym_EQ] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1635),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1633),
    [anon_sym_RBRACE] = ACTIONS(1633),
    [anon_sym_type] = ACTIONS(1635),
    [anon_sym_typeof] = ACTIONS(1635),
    [anon_sym_import] = ACTIONS(1635),
    [anon_sym_var] = ACTIONS(1635),
    [anon_sym_let] = ACTIONS(1635),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(1633),
    [anon_sym_else] = ACTIONS(1635),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_switch] = ACTIONS(1635),
    [anon_sym_for] = ACTIONS(1635),
    [anon_sym_LPAREN] = ACTIONS(1633),
    [anon_sym_RPAREN] = ACTIONS(1633),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_while] = ACTIONS(1635),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_try] = ACTIONS(1635),
    [anon_sym_with] = ACTIONS(1635),
    [anon_sym_break] = ACTIONS(1635),
    [anon_sym_continue] = ACTIONS(1635),
    [anon_sym_debugger] = ACTIONS(1635),
    [anon_sym_return] = ACTIONS(1635),
    [anon_sym_throw] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_COLON] = ACTIONS(1633),
    [anon_sym_case] = ACTIONS(1635),
    [anon_sym_yield] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1633),
    [anon_sym_RBRACK] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_class] = ACTIONS(1635),
    [anon_sym_async] = ACTIONS(1635),
    [anon_sym_function] = ACTIONS(1635),
    [anon_sym_EQ_GT] = ACTIONS(1633),
    [anon_sym_new] = ACTIONS(1635),
    [anon_sym_QMARK] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1633),
    [anon_sym_void] = ACTIONS(1635),
    [anon_sym_delete] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1633),
    [anon_sym_DASH_DASH] = ACTIONS(1633),
    [anon_sym_DQUOTE] = ACTIONS(1633),
    [anon_sym_SQUOTE] = ACTIONS(1633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1633),
    [sym_number] = ACTIONS(1633),
    [sym_this] = ACTIONS(1635),
    [sym_super] = ACTIONS(1635),
    [sym_true] = ACTIONS(1635),
    [sym_false] = ACTIONS(1635),
    [sym_null] = ACTIONS(1635),
    [sym_undefined] = ACTIONS(1635),
    [anon_sym_AT] = ACTIONS(1633),
    [anon_sym_static] = ACTIONS(1635),
    [anon_sym_abstract] = ACTIONS(1635),
    [anon_sym_get] = ACTIONS(1635),
    [anon_sym_set] = ACTIONS(1635),
    [anon_sym_declare] = ACTIONS(1635),
    [anon_sym_public] = ACTIONS(1635),
    [anon_sym_private] = ACTIONS(1635),
    [anon_sym_protected] = ACTIONS(1635),
    [anon_sym_module] = ACTIONS(1635),
    [anon_sym_any] = ACTIONS(1635),
    [anon_sym_number] = ACTIONS(1635),
    [anon_sym_boolean] = ACTIONS(1635),
    [anon_sym_string] = ACTIONS(1635),
    [anon_sym_symbol] = ACTIONS(1635),
    [anon_sym_interface] = ACTIONS(1635),
    [anon_sym_extends] = ACTIONS(1635),
    [anon_sym_enum] = ACTIONS(1635),
    [sym_readonly] = ACTIONS(1635),
  },
  [450] = {
    [ts_builtin_sym_end] = ACTIONS(1229),
    [sym_identifier] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1231),
    [anon_sym_EQ] = ACTIONS(1231),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1231),
    [anon_sym_typeof] = ACTIONS(1231),
    [anon_sym_import] = ACTIONS(1231),
    [anon_sym_var] = ACTIONS(1231),
    [anon_sym_let] = ACTIONS(1231),
    [anon_sym_const] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1229),
    [anon_sym_else] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_await] = ACTIONS(1231),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1231),
    [anon_sym_try] = ACTIONS(1231),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_break] = ACTIONS(1231),
    [anon_sym_continue] = ACTIONS(1231),
    [anon_sym_debugger] = ACTIONS(1231),
    [anon_sym_return] = ACTIONS(1231),
    [anon_sym_throw] = ACTIONS(1231),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [anon_sym_RBRACK] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_class] = ACTIONS(1231),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_EQ_GT] = ACTIONS(1229),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_QMARK] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_TILDE] = ACTIONS(1229),
    [anon_sym_void] = ACTIONS(1231),
    [anon_sym_delete] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_DASH_DASH] = ACTIONS(1229),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [sym_number] = ACTIONS(1229),
    [sym_this] = ACTIONS(1231),
    [sym_super] = ACTIONS(1231),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_AT] = ACTIONS(1229),
    [anon_sym_static] = ACTIONS(1231),
    [anon_sym_abstract] = ACTIONS(1231),
    [anon_sym_get] = ACTIONS(1231),
    [anon_sym_set] = ACTIONS(1231),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_public] = ACTIONS(1231),
    [anon_sym_private] = ACTIONS(1231),
    [anon_sym_protected] = ACTIONS(1231),
    [anon_sym_module] = ACTIONS(1231),
    [anon_sym_any] = ACTIONS(1231),
    [anon_sym_number] = ACTIONS(1231),
    [anon_sym_boolean] = ACTIONS(1231),
    [anon_sym_string] = ACTIONS(1231),
    [anon_sym_symbol] = ACTIONS(1231),
    [anon_sym_interface] = ACTIONS(1231),
    [anon_sym_extends] = ACTIONS(1231),
    [anon_sym_enum] = ACTIONS(1231),
    [sym_readonly] = ACTIONS(1231),
  },
  [451] = {
    [ts_builtin_sym_end] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1639),
    [anon_sym_default] = ACTIONS(1639),
    [anon_sym_EQ] = ACTIONS(1639),
    [anon_sym_namespace] = ACTIONS(1639),
    [anon_sym_LBRACE] = ACTIONS(1637),
    [anon_sym_COMMA] = ACTIONS(1637),
    [anon_sym_RBRACE] = ACTIONS(1637),
    [anon_sym_type] = ACTIONS(1639),
    [anon_sym_typeof] = ACTIONS(1639),
    [anon_sym_import] = ACTIONS(1639),
    [anon_sym_var] = ACTIONS(1639),
    [anon_sym_let] = ACTIONS(1639),
    [anon_sym_const] = ACTIONS(1639),
    [anon_sym_BANG] = ACTIONS(1637),
    [anon_sym_else] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(1639),
    [anon_sym_switch] = ACTIONS(1639),
    [anon_sym_for] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_RPAREN] = ACTIONS(1637),
    [anon_sym_await] = ACTIONS(1639),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_do] = ACTIONS(1639),
    [anon_sym_try] = ACTIONS(1639),
    [anon_sym_with] = ACTIONS(1639),
    [anon_sym_break] = ACTIONS(1639),
    [anon_sym_continue] = ACTIONS(1639),
    [anon_sym_debugger] = ACTIONS(1639),
    [anon_sym_return] = ACTIONS(1639),
    [anon_sym_throw] = ACTIONS(1639),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_COLON] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1639),
    [anon_sym_yield] = ACTIONS(1639),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_RBRACK] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_SLASH] = ACTIONS(1639),
    [anon_sym_class] = ACTIONS(1639),
    [anon_sym_async] = ACTIONS(1639),
    [anon_sym_function] = ACTIONS(1639),
    [anon_sym_EQ_GT] = ACTIONS(1637),
    [anon_sym_new] = ACTIONS(1639),
    [anon_sym_QMARK] = ACTIONS(1637),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_PIPE] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1639),
    [anon_sym_DASH] = ACTIONS(1639),
    [anon_sym_TILDE] = ACTIONS(1637),
    [anon_sym_void] = ACTIONS(1639),
    [anon_sym_delete] = ACTIONS(1639),
    [anon_sym_PLUS_PLUS] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1637),
    [anon_sym_DQUOTE] = ACTIONS(1637),
    [anon_sym_SQUOTE] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1637),
    [sym_number] = ACTIONS(1637),
    [sym_this] = ACTIONS(1639),
    [sym_super] = ACTIONS(1639),
    [sym_true] = ACTIONS(1639),
    [sym_false] = ACTIONS(1639),
    [sym_null] = ACTIONS(1639),
    [sym_undefined] = ACTIONS(1639),
    [anon_sym_AT] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1639),
    [anon_sym_abstract] = ACTIONS(1639),
    [anon_sym_get] = ACTIONS(1639),
    [anon_sym_set] = ACTIONS(1639),
    [anon_sym_declare] = ACTIONS(1639),
    [anon_sym_public] = ACTIONS(1639),
    [anon_sym_private] = ACTIONS(1639),
    [anon_sym_protected] = ACTIONS(1639),
    [anon_sym_module] = ACTIONS(1639),
    [anon_sym_any] = ACTIONS(1639),
    [anon_sym_number] = ACTIONS(1639),
    [anon_sym_boolean] = ACTIONS(1639),
    [anon_sym_string] = ACTIONS(1639),
    [anon_sym_symbol] = ACTIONS(1639),
    [anon_sym_interface] = ACTIONS(1639),
    [anon_sym_extends] = ACTIONS(1639),
    [anon_sym_enum] = ACTIONS(1639),
    [sym_readonly] = ACTIONS(1639),
  },
  [452] = {
    [ts_builtin_sym_end] = ACTIONS(1641),
    [sym_identifier] = ACTIONS(1643),
    [anon_sym_export] = ACTIONS(1643),
    [anon_sym_default] = ACTIONS(1643),
    [anon_sym_EQ] = ACTIONS(1643),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1643),
    [anon_sym_typeof] = ACTIONS(1643),
    [anon_sym_import] = ACTIONS(1643),
    [anon_sym_var] = ACTIONS(1643),
    [anon_sym_let] = ACTIONS(1643),
    [anon_sym_const] = ACTIONS(1643),
    [anon_sym_BANG] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1643),
    [anon_sym_if] = ACTIONS(1643),
    [anon_sym_switch] = ACTIONS(1643),
    [anon_sym_for] = ACTIONS(1643),
    [anon_sym_LPAREN] = ACTIONS(1641),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_await] = ACTIONS(1643),
    [anon_sym_while] = ACTIONS(1643),
    [anon_sym_do] = ACTIONS(1643),
    [anon_sym_try] = ACTIONS(1643),
    [anon_sym_with] = ACTIONS(1643),
    [anon_sym_break] = ACTIONS(1643),
    [anon_sym_continue] = ACTIONS(1643),
    [anon_sym_debugger] = ACTIONS(1643),
    [anon_sym_return] = ACTIONS(1643),
    [anon_sym_throw] = ACTIONS(1643),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_COLON] = ACTIONS(1641),
    [anon_sym_case] = ACTIONS(1643),
    [anon_sym_yield] = ACTIONS(1643),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_RBRACK] = ACTIONS(1641),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_GT] = ACTIONS(1641),
    [anon_sym_SLASH] = ACTIONS(1643),
    [anon_sym_class] = ACTIONS(1643),
    [anon_sym_async] = ACTIONS(1643),
    [anon_sym_function] = ACTIONS(1643),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_new] = ACTIONS(1643),
    [anon_sym_QMARK] = ACTIONS(1641),
    [anon_sym_AMP] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(1641),
    [anon_sym_PLUS] = ACTIONS(1643),
    [anon_sym_DASH] = ACTIONS(1643),
    [anon_sym_TILDE] = ACTIONS(1641),
    [anon_sym_void] = ACTIONS(1643),
    [anon_sym_delete] = ACTIONS(1643),
    [anon_sym_PLUS_PLUS] = ACTIONS(1641),
    [anon_sym_DASH_DASH] = ACTIONS(1641),
    [anon_sym_DQUOTE] = ACTIONS(1641),
    [anon_sym_SQUOTE] = ACTIONS(1641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1641),
    [sym_number] = ACTIONS(1641),
    [sym_this] = ACTIONS(1643),
    [sym_super] = ACTIONS(1643),
    [sym_true] = ACTIONS(1643),
    [sym_false] = ACTIONS(1643),
    [sym_null] = ACTIONS(1643),
    [sym_undefined] = ACTIONS(1643),
    [anon_sym_AT] = ACTIONS(1641),
    [anon_sym_static] = ACTIONS(1643),
    [anon_sym_abstract] = ACTIONS(1643),
    [anon_sym_get] = ACTIONS(1643),
    [anon_sym_set] = ACTIONS(1643),
    [anon_sym_declare] = ACTIONS(1643),
    [anon_sym_public] = ACTIONS(1643),
    [anon_sym_private] = ACTIONS(1643),
    [anon_sym_protected] = ACTIONS(1643),
    [anon_sym_module] = ACTIONS(1643),
    [anon_sym_any] = ACTIONS(1643),
    [anon_sym_number] = ACTIONS(1643),
    [anon_sym_boolean] = ACTIONS(1643),
    [anon_sym_string] = ACTIONS(1643),
    [anon_sym_symbol] = ACTIONS(1643),
    [anon_sym_interface] = ACTIONS(1643),
    [anon_sym_extends] = ACTIONS(1643),
    [anon_sym_enum] = ACTIONS(1643),
    [sym_readonly] = ACTIONS(1643),
  },
  [453] = {
    [ts_builtin_sym_end] = ACTIONS(1645),
    [sym_identifier] = ACTIONS(1647),
    [anon_sym_export] = ACTIONS(1647),
    [anon_sym_default] = ACTIONS(1647),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_namespace] = ACTIONS(1647),
    [anon_sym_LBRACE] = ACTIONS(1645),
    [anon_sym_COMMA] = ACTIONS(1645),
    [anon_sym_RBRACE] = ACTIONS(1645),
    [anon_sym_type] = ACTIONS(1647),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(1647),
    [anon_sym_var] = ACTIONS(1647),
    [anon_sym_let] = ACTIONS(1647),
    [anon_sym_const] = ACTIONS(1647),
    [anon_sym_BANG] = ACTIONS(1645),
    [anon_sym_else] = ACTIONS(1647),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_switch] = ACTIONS(1647),
    [anon_sym_for] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1645),
    [anon_sym_RPAREN] = ACTIONS(1645),
    [anon_sym_await] = ACTIONS(1647),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_do] = ACTIONS(1647),
    [anon_sym_try] = ACTIONS(1647),
    [anon_sym_with] = ACTIONS(1647),
    [anon_sym_break] = ACTIONS(1647),
    [anon_sym_continue] = ACTIONS(1647),
    [anon_sym_debugger] = ACTIONS(1647),
    [anon_sym_return] = ACTIONS(1647),
    [anon_sym_throw] = ACTIONS(1647),
    [anon_sym_SEMI] = ACTIONS(1645),
    [anon_sym_COLON] = ACTIONS(1645),
    [anon_sym_case] = ACTIONS(1647),
    [anon_sym_yield] = ACTIONS(1647),
    [anon_sym_LBRACK] = ACTIONS(1645),
    [anon_sym_RBRACK] = ACTIONS(1645),
    [anon_sym_LT] = ACTIONS(1645),
    [anon_sym_GT] = ACTIONS(1645),
    [anon_sym_SLASH] = ACTIONS(1647),
    [anon_sym_class] = ACTIONS(1647),
    [anon_sym_async] = ACTIONS(1647),
    [anon_sym_function] = ACTIONS(1647),
    [anon_sym_EQ_GT] = ACTIONS(1645),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_QMARK] = ACTIONS(1645),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_PIPE] = ACTIONS(1645),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(1645),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1645),
    [anon_sym_DASH_DASH] = ACTIONS(1645),
    [anon_sym_DQUOTE] = ACTIONS(1645),
    [anon_sym_SQUOTE] = ACTIONS(1645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1645),
    [sym_number] = ACTIONS(1645),
    [sym_this] = ACTIONS(1647),
    [sym_super] = ACTIONS(1647),
    [sym_true] = ACTIONS(1647),
    [sym_false] = ACTIONS(1647),
    [sym_null] = ACTIONS(1647),
    [sym_undefined] = ACTIONS(1647),
    [anon_sym_AT] = ACTIONS(1645),
    [anon_sym_static] = ACTIONS(1647),
    [anon_sym_abstract] = ACTIONS(1647),
    [anon_sym_get] = ACTIONS(1647),
    [anon_sym_set] = ACTIONS(1647),
    [anon_sym_declare] = ACTIONS(1647),
    [anon_sym_public] = ACTIONS(1647),
    [anon_sym_private] = ACTIONS(1647),
    [anon_sym_protected] = ACTIONS(1647),
    [anon_sym_module] = ACTIONS(1647),
    [anon_sym_any] = ACTIONS(1647),
    [anon_sym_number] = ACTIONS(1647),
    [anon_sym_boolean] = ACTIONS(1647),
    [anon_sym_string] = ACTIONS(1647),
    [anon_sym_symbol] = ACTIONS(1647),
    [anon_sym_interface] = ACTIONS(1647),
    [anon_sym_extends] = ACTIONS(1647),
    [anon_sym_enum] = ACTIONS(1647),
    [sym_readonly] = ACTIONS(1647),
  },
  [454] = {
    [ts_builtin_sym_end] = ACTIONS(1585),
    [sym_identifier] = ACTIONS(1587),
    [anon_sym_export] = ACTIONS(1587),
    [anon_sym_default] = ACTIONS(1587),
    [anon_sym_EQ] = ACTIONS(1587),
    [anon_sym_namespace] = ACTIONS(1587),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_COMMA] = ACTIONS(1585),
    [anon_sym_RBRACE] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(1587),
    [anon_sym_typeof] = ACTIONS(1587),
    [anon_sym_import] = ACTIONS(1587),
    [anon_sym_var] = ACTIONS(1587),
    [anon_sym_let] = ACTIONS(1587),
    [anon_sym_const] = ACTIONS(1587),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_else] = ACTIONS(1587),
    [anon_sym_if] = ACTIONS(1587),
    [anon_sym_switch] = ACTIONS(1587),
    [anon_sym_for] = ACTIONS(1587),
    [anon_sym_LPAREN] = ACTIONS(1585),
    [anon_sym_RPAREN] = ACTIONS(1585),
    [anon_sym_await] = ACTIONS(1587),
    [anon_sym_while] = ACTIONS(1587),
    [anon_sym_do] = ACTIONS(1587),
    [anon_sym_try] = ACTIONS(1587),
    [anon_sym_with] = ACTIONS(1587),
    [anon_sym_break] = ACTIONS(1587),
    [anon_sym_continue] = ACTIONS(1587),
    [anon_sym_debugger] = ACTIONS(1587),
    [anon_sym_return] = ACTIONS(1587),
    [anon_sym_throw] = ACTIONS(1587),
    [anon_sym_SEMI] = ACTIONS(1585),
    [anon_sym_COLON] = ACTIONS(1585),
    [anon_sym_case] = ACTIONS(1587),
    [anon_sym_yield] = ACTIONS(1587),
    [anon_sym_LBRACK] = ACTIONS(1585),
    [anon_sym_RBRACK] = ACTIONS(1585),
    [anon_sym_LT] = ACTIONS(1585),
    [anon_sym_GT] = ACTIONS(1585),
    [anon_sym_SLASH] = ACTIONS(1587),
    [anon_sym_class] = ACTIONS(1587),
    [anon_sym_async] = ACTIONS(1587),
    [anon_sym_function] = ACTIONS(1587),
    [anon_sym_EQ_GT] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(1587),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_PIPE] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1587),
    [anon_sym_DASH] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1585),
    [anon_sym_void] = ACTIONS(1587),
    [anon_sym_delete] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1585),
    [anon_sym_DASH_DASH] = ACTIONS(1585),
    [anon_sym_DQUOTE] = ACTIONS(1585),
    [anon_sym_SQUOTE] = ACTIONS(1585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1585),
    [sym_number] = ACTIONS(1585),
    [sym_this] = ACTIONS(1587),
    [sym_super] = ACTIONS(1587),
    [sym_true] = ACTIONS(1587),
    [sym_false] = ACTIONS(1587),
    [sym_null] = ACTIONS(1587),
    [sym_undefined] = ACTIONS(1587),
    [anon_sym_AT] = ACTIONS(1585),
    [anon_sym_static] = ACTIONS(1587),
    [anon_sym_abstract] = ACTIONS(1587),
    [anon_sym_get] = ACTIONS(1587),
    [anon_sym_set] = ACTIONS(1587),
    [anon_sym_declare] = ACTIONS(1587),
    [anon_sym_public] = ACTIONS(1587),
    [anon_sym_private] = ACTIONS(1587),
    [anon_sym_protected] = ACTIONS(1587),
    [anon_sym_module] = ACTIONS(1587),
    [anon_sym_any] = ACTIONS(1587),
    [anon_sym_number] = ACTIONS(1587),
    [anon_sym_boolean] = ACTIONS(1587),
    [anon_sym_string] = ACTIONS(1587),
    [anon_sym_symbol] = ACTIONS(1587),
    [anon_sym_interface] = ACTIONS(1587),
    [anon_sym_extends] = ACTIONS(1587),
    [anon_sym_enum] = ACTIONS(1587),
    [sym_readonly] = ACTIONS(1587),
  },
  [455] = {
    [ts_builtin_sym_end] = ACTIONS(1649),
    [sym_identifier] = ACTIONS(1651),
    [anon_sym_export] = ACTIONS(1651),
    [anon_sym_default] = ACTIONS(1651),
    [anon_sym_EQ] = ACTIONS(1651),
    [anon_sym_namespace] = ACTIONS(1651),
    [anon_sym_LBRACE] = ACTIONS(1649),
    [anon_sym_COMMA] = ACTIONS(1649),
    [anon_sym_RBRACE] = ACTIONS(1649),
    [anon_sym_type] = ACTIONS(1651),
    [anon_sym_typeof] = ACTIONS(1651),
    [anon_sym_import] = ACTIONS(1651),
    [anon_sym_var] = ACTIONS(1651),
    [anon_sym_let] = ACTIONS(1651),
    [anon_sym_const] = ACTIONS(1651),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_else] = ACTIONS(1651),
    [anon_sym_if] = ACTIONS(1651),
    [anon_sym_switch] = ACTIONS(1651),
    [anon_sym_for] = ACTIONS(1651),
    [anon_sym_LPAREN] = ACTIONS(1649),
    [anon_sym_RPAREN] = ACTIONS(1649),
    [anon_sym_await] = ACTIONS(1651),
    [anon_sym_while] = ACTIONS(1651),
    [anon_sym_do] = ACTIONS(1651),
    [anon_sym_try] = ACTIONS(1651),
    [anon_sym_with] = ACTIONS(1651),
    [anon_sym_break] = ACTIONS(1651),
    [anon_sym_continue] = ACTIONS(1651),
    [anon_sym_debugger] = ACTIONS(1651),
    [anon_sym_return] = ACTIONS(1651),
    [anon_sym_throw] = ACTIONS(1651),
    [anon_sym_SEMI] = ACTIONS(1649),
    [anon_sym_COLON] = ACTIONS(1649),
    [anon_sym_case] = ACTIONS(1651),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_RBRACK] = ACTIONS(1649),
    [anon_sym_LT] = ACTIONS(1649),
    [anon_sym_GT] = ACTIONS(1649),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_class] = ACTIONS(1651),
    [anon_sym_async] = ACTIONS(1651),
    [anon_sym_function] = ACTIONS(1651),
    [anon_sym_EQ_GT] = ACTIONS(1649),
    [anon_sym_new] = ACTIONS(1651),
    [anon_sym_QMARK] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_TILDE] = ACTIONS(1649),
    [anon_sym_void] = ACTIONS(1651),
    [anon_sym_delete] = ACTIONS(1651),
    [anon_sym_PLUS_PLUS] = ACTIONS(1649),
    [anon_sym_DASH_DASH] = ACTIONS(1649),
    [anon_sym_DQUOTE] = ACTIONS(1649),
    [anon_sym_SQUOTE] = ACTIONS(1649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1649),
    [sym_number] = ACTIONS(1649),
    [sym_this] = ACTIONS(1651),
    [sym_super] = ACTIONS(1651),
    [sym_true] = ACTIONS(1651),
    [sym_false] = ACTIONS(1651),
    [sym_null] = ACTIONS(1651),
    [sym_undefined] = ACTIONS(1651),
    [anon_sym_AT] = ACTIONS(1649),
    [anon_sym_static] = ACTIONS(1651),
    [anon_sym_abstract] = ACTIONS(1651),
    [anon_sym_get] = ACTIONS(1651),
    [anon_sym_set] = ACTIONS(1651),
    [anon_sym_declare] = ACTIONS(1651),
    [anon_sym_public] = ACTIONS(1651),
    [anon_sym_private] = ACTIONS(1651),
    [anon_sym_protected] = ACTIONS(1651),
    [anon_sym_module] = ACTIONS(1651),
    [anon_sym_any] = ACTIONS(1651),
    [anon_sym_number] = ACTIONS(1651),
    [anon_sym_boolean] = ACTIONS(1651),
    [anon_sym_string] = ACTIONS(1651),
    [anon_sym_symbol] = ACTIONS(1651),
    [anon_sym_interface] = ACTIONS(1651),
    [anon_sym_extends] = ACTIONS(1651),
    [anon_sym_enum] = ACTIONS(1651),
    [sym_readonly] = ACTIONS(1651),
  },
  [456] = {
    [ts_builtin_sym_end] = ACTIONS(1653),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_export] = ACTIONS(1655),
    [anon_sym_default] = ACTIONS(1655),
    [anon_sym_EQ] = ACTIONS(1655),
    [anon_sym_namespace] = ACTIONS(1655),
    [anon_sym_LBRACE] = ACTIONS(1653),
    [anon_sym_COMMA] = ACTIONS(1653),
    [anon_sym_RBRACE] = ACTIONS(1653),
    [anon_sym_type] = ACTIONS(1655),
    [anon_sym_typeof] = ACTIONS(1655),
    [anon_sym_import] = ACTIONS(1655),
    [anon_sym_var] = ACTIONS(1655),
    [anon_sym_let] = ACTIONS(1655),
    [anon_sym_const] = ACTIONS(1655),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_else] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(1655),
    [anon_sym_switch] = ACTIONS(1655),
    [anon_sym_for] = ACTIONS(1655),
    [anon_sym_LPAREN] = ACTIONS(1653),
    [anon_sym_RPAREN] = ACTIONS(1653),
    [anon_sym_await] = ACTIONS(1655),
    [anon_sym_while] = ACTIONS(1655),
    [anon_sym_do] = ACTIONS(1655),
    [anon_sym_try] = ACTIONS(1655),
    [anon_sym_with] = ACTIONS(1655),
    [anon_sym_break] = ACTIONS(1655),
    [anon_sym_continue] = ACTIONS(1655),
    [anon_sym_debugger] = ACTIONS(1655),
    [anon_sym_return] = ACTIONS(1655),
    [anon_sym_throw] = ACTIONS(1655),
    [anon_sym_SEMI] = ACTIONS(1653),
    [anon_sym_COLON] = ACTIONS(1653),
    [anon_sym_case] = ACTIONS(1655),
    [anon_sym_yield] = ACTIONS(1655),
    [anon_sym_LBRACK] = ACTIONS(1653),
    [anon_sym_RBRACK] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1653),
    [anon_sym_GT] = ACTIONS(1653),
    [anon_sym_SLASH] = ACTIONS(1655),
    [anon_sym_class] = ACTIONS(1655),
    [anon_sym_async] = ACTIONS(1655),
    [anon_sym_function] = ACTIONS(1655),
    [anon_sym_EQ_GT] = ACTIONS(1653),
    [anon_sym_new] = ACTIONS(1655),
    [anon_sym_QMARK] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_PIPE] = ACTIONS(1653),
    [anon_sym_PLUS] = ACTIONS(1655),
    [anon_sym_DASH] = ACTIONS(1655),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_void] = ACTIONS(1655),
    [anon_sym_delete] = ACTIONS(1655),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_DQUOTE] = ACTIONS(1653),
    [anon_sym_SQUOTE] = ACTIONS(1653),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1653),
    [sym_number] = ACTIONS(1653),
    [sym_this] = ACTIONS(1655),
    [sym_super] = ACTIONS(1655),
    [sym_true] = ACTIONS(1655),
    [sym_false] = ACTIONS(1655),
    [sym_null] = ACTIONS(1655),
    [sym_undefined] = ACTIONS(1655),
    [anon_sym_AT] = ACTIONS(1653),
    [anon_sym_static] = ACTIONS(1655),
    [anon_sym_abstract] = ACTIONS(1655),
    [anon_sym_get] = ACTIONS(1655),
    [anon_sym_set] = ACTIONS(1655),
    [anon_sym_declare] = ACTIONS(1655),
    [anon_sym_public] = ACTIONS(1655),
    [anon_sym_private] = ACTIONS(1655),
    [anon_sym_protected] = ACTIONS(1655),
    [anon_sym_module] = ACTIONS(1655),
    [anon_sym_any] = ACTIONS(1655),
    [anon_sym_number] = ACTIONS(1655),
    [anon_sym_boolean] = ACTIONS(1655),
    [anon_sym_string] = ACTIONS(1655),
    [anon_sym_symbol] = ACTIONS(1655),
    [anon_sym_interface] = ACTIONS(1655),
    [anon_sym_extends] = ACTIONS(1655),
    [anon_sym_enum] = ACTIONS(1655),
    [sym_readonly] = ACTIONS(1655),
  },
  [457] = {
    [ts_builtin_sym_end] = ACTIONS(1657),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_export] = ACTIONS(1659),
    [anon_sym_default] = ACTIONS(1659),
    [anon_sym_EQ] = ACTIONS(1659),
    [anon_sym_namespace] = ACTIONS(1659),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_COMMA] = ACTIONS(1657),
    [anon_sym_RBRACE] = ACTIONS(1657),
    [anon_sym_type] = ACTIONS(1659),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_import] = ACTIONS(1659),
    [anon_sym_var] = ACTIONS(1659),
    [anon_sym_let] = ACTIONS(1659),
    [anon_sym_const] = ACTIONS(1659),
    [anon_sym_BANG] = ACTIONS(1657),
    [anon_sym_else] = ACTIONS(1659),
    [anon_sym_if] = ACTIONS(1659),
    [anon_sym_switch] = ACTIONS(1659),
    [anon_sym_for] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1657),
    [anon_sym_RPAREN] = ACTIONS(1657),
    [anon_sym_await] = ACTIONS(1659),
    [anon_sym_while] = ACTIONS(1659),
    [anon_sym_do] = ACTIONS(1659),
    [anon_sym_try] = ACTIONS(1659),
    [anon_sym_with] = ACTIONS(1659),
    [anon_sym_break] = ACTIONS(1659),
    [anon_sym_continue] = ACTIONS(1659),
    [anon_sym_debugger] = ACTIONS(1659),
    [anon_sym_return] = ACTIONS(1659),
    [anon_sym_throw] = ACTIONS(1659),
    [anon_sym_SEMI] = ACTIONS(1657),
    [anon_sym_COLON] = ACTIONS(1657),
    [anon_sym_case] = ACTIONS(1659),
    [anon_sym_yield] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(1657),
    [anon_sym_RBRACK] = ACTIONS(1657),
    [anon_sym_LT] = ACTIONS(1657),
    [anon_sym_GT] = ACTIONS(1657),
    [anon_sym_SLASH] = ACTIONS(1659),
    [anon_sym_class] = ACTIONS(1659),
    [anon_sym_async] = ACTIONS(1659),
    [anon_sym_function] = ACTIONS(1659),
    [anon_sym_EQ_GT] = ACTIONS(1657),
    [anon_sym_new] = ACTIONS(1659),
    [anon_sym_QMARK] = ACTIONS(1657),
    [anon_sym_AMP] = ACTIONS(1657),
    [anon_sym_PIPE] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_TILDE] = ACTIONS(1657),
    [anon_sym_void] = ACTIONS(1659),
    [anon_sym_delete] = ACTIONS(1659),
    [anon_sym_PLUS_PLUS] = ACTIONS(1657),
    [anon_sym_DASH_DASH] = ACTIONS(1657),
    [anon_sym_DQUOTE] = ACTIONS(1657),
    [anon_sym_SQUOTE] = ACTIONS(1657),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1657),
    [sym_number] = ACTIONS(1657),
    [sym_this] = ACTIONS(1659),
    [sym_super] = ACTIONS(1659),
    [sym_true] = ACTIONS(1659),
    [sym_false] = ACTIONS(1659),
    [sym_null] = ACTIONS(1659),
    [sym_undefined] = ACTIONS(1659),
    [anon_sym_AT] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(1659),
    [anon_sym_abstract] = ACTIONS(1659),
    [anon_sym_get] = ACTIONS(1659),
    [anon_sym_set] = ACTIONS(1659),
    [anon_sym_declare] = ACTIONS(1659),
    [anon_sym_public] = ACTIONS(1659),
    [anon_sym_private] = ACTIONS(1659),
    [anon_sym_protected] = ACTIONS(1659),
    [anon_sym_module] = ACTIONS(1659),
    [anon_sym_any] = ACTIONS(1659),
    [anon_sym_number] = ACTIONS(1659),
    [anon_sym_boolean] = ACTIONS(1659),
    [anon_sym_string] = ACTIONS(1659),
    [anon_sym_symbol] = ACTIONS(1659),
    [anon_sym_interface] = ACTIONS(1659),
    [anon_sym_extends] = ACTIONS(1659),
    [anon_sym_enum] = ACTIONS(1659),
    [sym_readonly] = ACTIONS(1659),
  },
  [458] = {
    [ts_builtin_sym_end] = ACTIONS(1661),
    [sym_identifier] = ACTIONS(1663),
    [anon_sym_export] = ACTIONS(1663),
    [anon_sym_default] = ACTIONS(1663),
    [anon_sym_EQ] = ACTIONS(1663),
    [anon_sym_namespace] = ACTIONS(1663),
    [anon_sym_LBRACE] = ACTIONS(1661),
    [anon_sym_COMMA] = ACTIONS(1661),
    [anon_sym_RBRACE] = ACTIONS(1661),
    [anon_sym_type] = ACTIONS(1663),
    [anon_sym_typeof] = ACTIONS(1663),
    [anon_sym_import] = ACTIONS(1663),
    [anon_sym_var] = ACTIONS(1663),
    [anon_sym_let] = ACTIONS(1663),
    [anon_sym_const] = ACTIONS(1663),
    [anon_sym_BANG] = ACTIONS(1661),
    [anon_sym_else] = ACTIONS(1663),
    [anon_sym_if] = ACTIONS(1663),
    [anon_sym_switch] = ACTIONS(1663),
    [anon_sym_for] = ACTIONS(1663),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_RPAREN] = ACTIONS(1661),
    [anon_sym_await] = ACTIONS(1663),
    [anon_sym_while] = ACTIONS(1663),
    [anon_sym_do] = ACTIONS(1663),
    [anon_sym_try] = ACTIONS(1663),
    [anon_sym_with] = ACTIONS(1663),
    [anon_sym_break] = ACTIONS(1663),
    [anon_sym_continue] = ACTIONS(1663),
    [anon_sym_debugger] = ACTIONS(1663),
    [anon_sym_return] = ACTIONS(1663),
    [anon_sym_throw] = ACTIONS(1663),
    [anon_sym_SEMI] = ACTIONS(1661),
    [anon_sym_COLON] = ACTIONS(1661),
    [anon_sym_case] = ACTIONS(1663),
    [anon_sym_yield] = ACTIONS(1663),
    [anon_sym_LBRACK] = ACTIONS(1661),
    [anon_sym_RBRACK] = ACTIONS(1661),
    [anon_sym_LT] = ACTIONS(1661),
    [anon_sym_GT] = ACTIONS(1661),
    [anon_sym_SLASH] = ACTIONS(1663),
    [anon_sym_class] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(1663),
    [anon_sym_function] = ACTIONS(1663),
    [anon_sym_EQ_GT] = ACTIONS(1661),
    [anon_sym_new] = ACTIONS(1663),
    [anon_sym_QMARK] = ACTIONS(1661),
    [anon_sym_AMP] = ACTIONS(1661),
    [anon_sym_PIPE] = ACTIONS(1661),
    [anon_sym_PLUS] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_TILDE] = ACTIONS(1661),
    [anon_sym_void] = ACTIONS(1663),
    [anon_sym_delete] = ACTIONS(1663),
    [anon_sym_PLUS_PLUS] = ACTIONS(1661),
    [anon_sym_DASH_DASH] = ACTIONS(1661),
    [anon_sym_DQUOTE] = ACTIONS(1661),
    [anon_sym_SQUOTE] = ACTIONS(1661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1661),
    [sym_number] = ACTIONS(1661),
    [sym_this] = ACTIONS(1663),
    [sym_super] = ACTIONS(1663),
    [sym_true] = ACTIONS(1663),
    [sym_false] = ACTIONS(1663),
    [sym_null] = ACTIONS(1663),
    [sym_undefined] = ACTIONS(1663),
    [anon_sym_AT] = ACTIONS(1661),
    [anon_sym_static] = ACTIONS(1663),
    [anon_sym_abstract] = ACTIONS(1663),
    [anon_sym_get] = ACTIONS(1663),
    [anon_sym_set] = ACTIONS(1663),
    [anon_sym_declare] = ACTIONS(1663),
    [anon_sym_public] = ACTIONS(1663),
    [anon_sym_private] = ACTIONS(1663),
    [anon_sym_protected] = ACTIONS(1663),
    [anon_sym_module] = ACTIONS(1663),
    [anon_sym_any] = ACTIONS(1663),
    [anon_sym_number] = ACTIONS(1663),
    [anon_sym_boolean] = ACTIONS(1663),
    [anon_sym_string] = ACTIONS(1663),
    [anon_sym_symbol] = ACTIONS(1663),
    [anon_sym_interface] = ACTIONS(1663),
    [anon_sym_extends] = ACTIONS(1663),
    [anon_sym_enum] = ACTIONS(1663),
    [sym_readonly] = ACTIONS(1663),
  },
  [459] = {
    [ts_builtin_sym_end] = ACTIONS(1665),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_export] = ACTIONS(1667),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1667),
    [anon_sym_namespace] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(1665),
    [anon_sym_COMMA] = ACTIONS(1665),
    [anon_sym_RBRACE] = ACTIONS(1665),
    [anon_sym_type] = ACTIONS(1667),
    [anon_sym_typeof] = ACTIONS(1667),
    [anon_sym_import] = ACTIONS(1667),
    [anon_sym_var] = ACTIONS(1667),
    [anon_sym_let] = ACTIONS(1667),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_else] = ACTIONS(1667),
    [anon_sym_if] = ACTIONS(1667),
    [anon_sym_switch] = ACTIONS(1667),
    [anon_sym_for] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(1665),
    [anon_sym_RPAREN] = ACTIONS(1665),
    [anon_sym_await] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1667),
    [anon_sym_do] = ACTIONS(1667),
    [anon_sym_try] = ACTIONS(1667),
    [anon_sym_with] = ACTIONS(1667),
    [anon_sym_break] = ACTIONS(1667),
    [anon_sym_continue] = ACTIONS(1667),
    [anon_sym_debugger] = ACTIONS(1667),
    [anon_sym_return] = ACTIONS(1667),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [anon_sym_COLON] = ACTIONS(1665),
    [anon_sym_case] = ACTIONS(1667),
    [anon_sym_yield] = ACTIONS(1667),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_RBRACK] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_SLASH] = ACTIONS(1667),
    [anon_sym_class] = ACTIONS(1667),
    [anon_sym_async] = ACTIONS(1667),
    [anon_sym_function] = ACTIONS(1667),
    [anon_sym_EQ_GT] = ACTIONS(1665),
    [anon_sym_new] = ACTIONS(1667),
    [anon_sym_QMARK] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_void] = ACTIONS(1667),
    [anon_sym_delete] = ACTIONS(1667),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [anon_sym_SQUOTE] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [sym_number] = ACTIONS(1665),
    [sym_this] = ACTIONS(1667),
    [sym_super] = ACTIONS(1667),
    [sym_true] = ACTIONS(1667),
    [sym_false] = ACTIONS(1667),
    [sym_null] = ACTIONS(1667),
    [sym_undefined] = ACTIONS(1667),
    [anon_sym_AT] = ACTIONS(1665),
    [anon_sym_static] = ACTIONS(1667),
    [anon_sym_abstract] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(1667),
    [anon_sym_set] = ACTIONS(1667),
    [anon_sym_declare] = ACTIONS(1667),
    [anon_sym_public] = ACTIONS(1667),
    [anon_sym_private] = ACTIONS(1667),
    [anon_sym_protected] = ACTIONS(1667),
    [anon_sym_module] = ACTIONS(1667),
    [anon_sym_any] = ACTIONS(1667),
    [anon_sym_number] = ACTIONS(1667),
    [anon_sym_boolean] = ACTIONS(1667),
    [anon_sym_string] = ACTIONS(1667),
    [anon_sym_symbol] = ACTIONS(1667),
    [anon_sym_interface] = ACTIONS(1667),
    [anon_sym_extends] = ACTIONS(1667),
    [anon_sym_enum] = ACTIONS(1667),
    [sym_readonly] = ACTIONS(1667),
  },
  [460] = {
    [ts_builtin_sym_end] = ACTIONS(1669),
    [sym_identifier] = ACTIONS(1671),
    [anon_sym_export] = ACTIONS(1671),
    [anon_sym_default] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1671),
    [anon_sym_namespace] = ACTIONS(1671),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_COMMA] = ACTIONS(1669),
    [anon_sym_RBRACE] = ACTIONS(1669),
    [anon_sym_type] = ACTIONS(1671),
    [anon_sym_typeof] = ACTIONS(1671),
    [anon_sym_import] = ACTIONS(1671),
    [anon_sym_var] = ACTIONS(1671),
    [anon_sym_let] = ACTIONS(1671),
    [anon_sym_const] = ACTIONS(1671),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_else] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(1671),
    [anon_sym_switch] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(1669),
    [anon_sym_RPAREN] = ACTIONS(1669),
    [anon_sym_await] = ACTIONS(1671),
    [anon_sym_while] = ACTIONS(1671),
    [anon_sym_do] = ACTIONS(1671),
    [anon_sym_try] = ACTIONS(1671),
    [anon_sym_with] = ACTIONS(1671),
    [anon_sym_break] = ACTIONS(1671),
    [anon_sym_continue] = ACTIONS(1671),
    [anon_sym_debugger] = ACTIONS(1671),
    [anon_sym_return] = ACTIONS(1671),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_SEMI] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(1669),
    [anon_sym_case] = ACTIONS(1671),
    [anon_sym_yield] = ACTIONS(1671),
    [anon_sym_LBRACK] = ACTIONS(1669),
    [anon_sym_RBRACK] = ACTIONS(1669),
    [anon_sym_LT] = ACTIONS(1669),
    [anon_sym_GT] = ACTIONS(1669),
    [anon_sym_SLASH] = ACTIONS(1671),
    [anon_sym_class] = ACTIONS(1671),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_function] = ACTIONS(1671),
    [anon_sym_EQ_GT] = ACTIONS(1669),
    [anon_sym_new] = ACTIONS(1671),
    [anon_sym_QMARK] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_PIPE] = ACTIONS(1669),
    [anon_sym_PLUS] = ACTIONS(1671),
    [anon_sym_DASH] = ACTIONS(1671),
    [anon_sym_TILDE] = ACTIONS(1669),
    [anon_sym_void] = ACTIONS(1671),
    [anon_sym_delete] = ACTIONS(1671),
    [anon_sym_PLUS_PLUS] = ACTIONS(1669),
    [anon_sym_DASH_DASH] = ACTIONS(1669),
    [anon_sym_DQUOTE] = ACTIONS(1669),
    [anon_sym_SQUOTE] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1669),
    [sym_number] = ACTIONS(1669),
    [sym_this] = ACTIONS(1671),
    [sym_super] = ACTIONS(1671),
    [sym_true] = ACTIONS(1671),
    [sym_false] = ACTIONS(1671),
    [sym_null] = ACTIONS(1671),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(1669),
    [anon_sym_static] = ACTIONS(1671),
    [anon_sym_abstract] = ACTIONS(1671),
    [anon_sym_get] = ACTIONS(1671),
    [anon_sym_set] = ACTIONS(1671),
    [anon_sym_declare] = ACTIONS(1671),
    [anon_sym_public] = ACTIONS(1671),
    [anon_sym_private] = ACTIONS(1671),
    [anon_sym_protected] = ACTIONS(1671),
    [anon_sym_module] = ACTIONS(1671),
    [anon_sym_any] = ACTIONS(1671),
    [anon_sym_number] = ACTIONS(1671),
    [anon_sym_boolean] = ACTIONS(1671),
    [anon_sym_string] = ACTIONS(1671),
    [anon_sym_symbol] = ACTIONS(1671),
    [anon_sym_interface] = ACTIONS(1671),
    [anon_sym_extends] = ACTIONS(1671),
    [anon_sym_enum] = ACTIONS(1671),
    [sym_readonly] = ACTIONS(1671),
  },
  [461] = {
    [ts_builtin_sym_end] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(1675),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_EQ] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1675),
    [anon_sym_LBRACE] = ACTIONS(1673),
    [anon_sym_COMMA] = ACTIONS(1673),
    [anon_sym_RBRACE] = ACTIONS(1673),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_typeof] = ACTIONS(1675),
    [anon_sym_import] = ACTIONS(1675),
    [anon_sym_var] = ACTIONS(1675),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_const] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1673),
    [anon_sym_else] = ACTIONS(1675),
    [anon_sym_if] = ACTIONS(1675),
    [anon_sym_switch] = ACTIONS(1675),
    [anon_sym_for] = ACTIONS(1675),
    [anon_sym_LPAREN] = ACTIONS(1673),
    [anon_sym_RPAREN] = ACTIONS(1673),
    [anon_sym_await] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1675),
    [anon_sym_do] = ACTIONS(1675),
    [anon_sym_try] = ACTIONS(1675),
    [anon_sym_with] = ACTIONS(1675),
    [anon_sym_break] = ACTIONS(1675),
    [anon_sym_continue] = ACTIONS(1675),
    [anon_sym_debugger] = ACTIONS(1675),
    [anon_sym_return] = ACTIONS(1675),
    [anon_sym_throw] = ACTIONS(1675),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_COLON] = ACTIONS(1673),
    [anon_sym_case] = ACTIONS(1675),
    [anon_sym_yield] = ACTIONS(1675),
    [anon_sym_LBRACK] = ACTIONS(1673),
    [anon_sym_RBRACK] = ACTIONS(1673),
    [anon_sym_LT] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1673),
    [anon_sym_SLASH] = ACTIONS(1675),
    [anon_sym_class] = ACTIONS(1675),
    [anon_sym_async] = ACTIONS(1675),
    [anon_sym_function] = ACTIONS(1675),
    [anon_sym_EQ_GT] = ACTIONS(1673),
    [anon_sym_new] = ACTIONS(1675),
    [anon_sym_QMARK] = ACTIONS(1673),
    [anon_sym_AMP] = ACTIONS(1673),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_DASH] = ACTIONS(1675),
    [anon_sym_TILDE] = ACTIONS(1673),
    [anon_sym_void] = ACTIONS(1675),
    [anon_sym_delete] = ACTIONS(1675),
    [anon_sym_PLUS_PLUS] = ACTIONS(1673),
    [anon_sym_DASH_DASH] = ACTIONS(1673),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1673),
    [sym_number] = ACTIONS(1673),
    [sym_this] = ACTIONS(1675),
    [sym_super] = ACTIONS(1675),
    [sym_true] = ACTIONS(1675),
    [sym_false] = ACTIONS(1675),
    [sym_null] = ACTIONS(1675),
    [sym_undefined] = ACTIONS(1675),
    [anon_sym_AT] = ACTIONS(1673),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_abstract] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_interface] = ACTIONS(1675),
    [anon_sym_extends] = ACTIONS(1675),
    [anon_sym_enum] = ACTIONS(1675),
    [sym_readonly] = ACTIONS(1675),
  },
  [462] = {
    [ts_builtin_sym_end] = ACTIONS(1677),
    [sym_identifier] = ACTIONS(1679),
    [anon_sym_export] = ACTIONS(1679),
    [anon_sym_default] = ACTIONS(1679),
    [anon_sym_EQ] = ACTIONS(1679),
    [anon_sym_namespace] = ACTIONS(1679),
    [anon_sym_LBRACE] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(1677),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [anon_sym_type] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym_import] = ACTIONS(1679),
    [anon_sym_var] = ACTIONS(1679),
    [anon_sym_let] = ACTIONS(1679),
    [anon_sym_const] = ACTIONS(1679),
    [anon_sym_BANG] = ACTIONS(1677),
    [anon_sym_else] = ACTIONS(1679),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_switch] = ACTIONS(1679),
    [anon_sym_for] = ACTIONS(1679),
    [anon_sym_LPAREN] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1677),
    [anon_sym_await] = ACTIONS(1679),
    [anon_sym_while] = ACTIONS(1679),
    [anon_sym_do] = ACTIONS(1679),
    [anon_sym_try] = ACTIONS(1679),
    [anon_sym_with] = ACTIONS(1679),
    [anon_sym_break] = ACTIONS(1679),
    [anon_sym_continue] = ACTIONS(1679),
    [anon_sym_debugger] = ACTIONS(1679),
    [anon_sym_return] = ACTIONS(1679),
    [anon_sym_throw] = ACTIONS(1679),
    [anon_sym_SEMI] = ACTIONS(1677),
    [anon_sym_COLON] = ACTIONS(1677),
    [anon_sym_case] = ACTIONS(1679),
    [anon_sym_yield] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1677),
    [anon_sym_RBRACK] = ACTIONS(1677),
    [anon_sym_LT] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1677),
    [anon_sym_SLASH] = ACTIONS(1679),
    [anon_sym_class] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(1679),
    [anon_sym_function] = ACTIONS(1679),
    [anon_sym_EQ_GT] = ACTIONS(1677),
    [anon_sym_new] = ACTIONS(1679),
    [anon_sym_QMARK] = ACTIONS(1677),
    [anon_sym_AMP] = ACTIONS(1677),
    [anon_sym_PIPE] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_TILDE] = ACTIONS(1677),
    [anon_sym_void] = ACTIONS(1679),
    [anon_sym_delete] = ACTIONS(1679),
    [anon_sym_PLUS_PLUS] = ACTIONS(1677),
    [anon_sym_DASH_DASH] = ACTIONS(1677),
    [anon_sym_DQUOTE] = ACTIONS(1677),
    [anon_sym_SQUOTE] = ACTIONS(1677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1677),
    [sym_this] = ACTIONS(1679),
    [sym_super] = ACTIONS(1679),
    [sym_true] = ACTIONS(1679),
    [sym_false] = ACTIONS(1679),
    [sym_null] = ACTIONS(1679),
    [sym_undefined] = ACTIONS(1679),
    [anon_sym_AT] = ACTIONS(1677),
    [anon_sym_static] = ACTIONS(1679),
    [anon_sym_abstract] = ACTIONS(1679),
    [anon_sym_get] = ACTIONS(1679),
    [anon_sym_set] = ACTIONS(1679),
    [anon_sym_declare] = ACTIONS(1679),
    [anon_sym_public] = ACTIONS(1679),
    [anon_sym_private] = ACTIONS(1679),
    [anon_sym_protected] = ACTIONS(1679),
    [anon_sym_module] = ACTIONS(1679),
    [anon_sym_any] = ACTIONS(1679),
    [anon_sym_number] = ACTIONS(1679),
    [anon_sym_boolean] = ACTIONS(1679),
    [anon_sym_string] = ACTIONS(1679),
    [anon_sym_symbol] = ACTIONS(1679),
    [anon_sym_interface] = ACTIONS(1679),
    [anon_sym_extends] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1679),
    [sym_readonly] = ACTIONS(1679),
  },
  [463] = {
    [sym_string] = STATE(2459),
    [sym__property_name] = STATE(2459),
    [sym_computed_property_name] = STATE(2459),
    [aux_sym_object_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(1681),
    [anon_sym_export] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_type] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1539),
    [anon_sym_static] = ACTIONS(1681),
    [anon_sym_get] = ACTIONS(1681),
    [anon_sym_set] = ACTIONS(1681),
    [anon_sym_declare] = ACTIONS(1681),
    [anon_sym_public] = ACTIONS(1681),
    [anon_sym_private] = ACTIONS(1681),
    [anon_sym_protected] = ACTIONS(1681),
    [anon_sym_module] = ACTIONS(1681),
    [anon_sym_any] = ACTIONS(1681),
    [anon_sym_number] = ACTIONS(1681),
    [anon_sym_boolean] = ACTIONS(1681),
    [anon_sym_string] = ACTIONS(1681),
    [anon_sym_symbol] = ACTIONS(1681),
    [sym_readonly] = ACTIONS(1681),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [464] = {
    [sym_string] = STATE(2459),
    [sym__property_name] = STATE(2459),
    [sym_computed_property_name] = STATE(2459),
    [aux_sym_object_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(1681),
    [anon_sym_export] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_type] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1539),
    [anon_sym_static] = ACTIONS(1681),
    [anon_sym_get] = ACTIONS(1685),
    [anon_sym_set] = ACTIONS(1685),
    [anon_sym_declare] = ACTIONS(1681),
    [anon_sym_public] = ACTIONS(1681),
    [anon_sym_private] = ACTIONS(1681),
    [anon_sym_protected] = ACTIONS(1681),
    [anon_sym_module] = ACTIONS(1681),
    [anon_sym_any] = ACTIONS(1681),
    [anon_sym_number] = ACTIONS(1681),
    [anon_sym_boolean] = ACTIONS(1681),
    [anon_sym_string] = ACTIONS(1681),
    [anon_sym_symbol] = ACTIONS(1681),
    [sym_readonly] = ACTIONS(1687),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [465] = {
    [sym_string] = STATE(2459),
    [sym__property_name] = STATE(2459),
    [sym_computed_property_name] = STATE(2459),
    [aux_sym_object_repeat1] = STATE(3011),
    [sym_identifier] = ACTIONS(1681),
    [anon_sym_export] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_type] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1539),
    [anon_sym_static] = ACTIONS(1681),
    [anon_sym_get] = ACTIONS(1685),
    [anon_sym_set] = ACTIONS(1685),
    [anon_sym_declare] = ACTIONS(1681),
    [anon_sym_public] = ACTIONS(1681),
    [anon_sym_private] = ACTIONS(1681),
    [anon_sym_protected] = ACTIONS(1681),
    [anon_sym_module] = ACTIONS(1681),
    [anon_sym_any] = ACTIONS(1681),
    [anon_sym_number] = ACTIONS(1681),
    [anon_sym_boolean] = ACTIONS(1681),
    [anon_sym_string] = ACTIONS(1681),
    [anon_sym_symbol] = ACTIONS(1681),
    [sym_readonly] = ACTIONS(1687),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [466] = {
    [sym_string] = STATE(2459),
    [sym__property_name] = STATE(2459),
    [sym_computed_property_name] = STATE(2459),
    [aux_sym_object_repeat1] = STATE(3011),
    [sym_identifier] = ACTIONS(1681),
    [anon_sym_export] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_type] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1539),
    [anon_sym_static] = ACTIONS(1681),
    [anon_sym_get] = ACTIONS(1681),
    [anon_sym_set] = ACTIONS(1681),
    [anon_sym_declare] = ACTIONS(1681),
    [anon_sym_public] = ACTIONS(1681),
    [anon_sym_private] = ACTIONS(1681),
    [anon_sym_protected] = ACTIONS(1681),
    [anon_sym_module] = ACTIONS(1681),
    [anon_sym_any] = ACTIONS(1681),
    [anon_sym_number] = ACTIONS(1681),
    [anon_sym_boolean] = ACTIONS(1681),
    [anon_sym_string] = ACTIONS(1681),
    [anon_sym_symbol] = ACTIONS(1681),
    [sym_readonly] = ACTIONS(1681),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [467] = {
    [sym_string] = STATE(2459),
    [sym__property_name] = STATE(2459),
    [sym_computed_property_name] = STATE(2459),
    [aux_sym_object_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(1681),
    [anon_sym_export] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_type] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1539),
    [anon_sym_static] = ACTIONS(1681),
    [anon_sym_get] = ACTIONS(1685),
    [anon_sym_set] = ACTIONS(1685),
    [anon_sym_declare] = ACTIONS(1681),
    [anon_sym_public] = ACTIONS(1681),
    [anon_sym_private] = ACTIONS(1681),
    [anon_sym_protected] = ACTIONS(1681),
    [anon_sym_module] = ACTIONS(1681),
    [anon_sym_any] = ACTIONS(1681),
    [anon_sym_number] = ACTIONS(1681),
    [anon_sym_boolean] = ACTIONS(1681),
    [anon_sym_string] = ACTIONS(1681),
    [anon_sym_symbol] = ACTIONS(1681),
    [sym_readonly] = ACTIONS(1681),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [468] = {
    [sym_string] = STATE(2459),
    [sym__property_name] = STATE(2459),
    [sym_computed_property_name] = STATE(2459),
    [aux_sym_object_repeat1] = STATE(2959),
    [sym_identifier] = ACTIONS(1681),
    [anon_sym_export] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1539),
    [anon_sym_static] = ACTIONS(1681),
    [anon_sym_get] = ACTIONS(1685),
    [anon_sym_set] = ACTIONS(1685),
    [anon_sym_declare] = ACTIONS(1681),
    [anon_sym_public] = ACTIONS(1681),
    [anon_sym_private] = ACTIONS(1681),
    [anon_sym_protected] = ACTIONS(1681),
    [anon_sym_module] = ACTIONS(1681),
    [anon_sym_any] = ACTIONS(1681),
    [anon_sym_number] = ACTIONS(1681),
    [anon_sym_boolean] = ACTIONS(1681),
    [anon_sym_string] = ACTIONS(1681),
    [anon_sym_symbol] = ACTIONS(1681),
    [sym_readonly] = ACTIONS(1681),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [469] = {
    [sym_string] = STATE(2459),
    [sym__property_name] = STATE(2459),
    [sym_computed_property_name] = STATE(2459),
    [aux_sym_object_repeat1] = STATE(2959),
    [sym_identifier] = ACTIONS(1681),
    [anon_sym_export] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1681),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1539),
    [anon_sym_static] = ACTIONS(1681),
    [anon_sym_get] = ACTIONS(1681),
    [anon_sym_set] = ACTIONS(1681),
    [anon_sym_declare] = ACTIONS(1681),
    [anon_sym_public] = ACTIONS(1681),
    [anon_sym_private] = ACTIONS(1681),
    [anon_sym_protected] = ACTIONS(1681),
    [anon_sym_module] = ACTIONS(1681),
    [anon_sym_any] = ACTIONS(1681),
    [anon_sym_number] = ACTIONS(1681),
    [anon_sym_boolean] = ACTIONS(1681),
    [anon_sym_string] = ACTIONS(1681),
    [anon_sym_symbol] = ACTIONS(1681),
    [sym_readonly] = ACTIONS(1681),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [470] = {
    [sym_string] = STATE(2459),
    [sym__property_name] = STATE(2459),
    [sym_computed_property_name] = STATE(2459),
    [aux_sym_object_repeat1] = STATE(3011),
    [sym_identifier] = ACTIONS(1681),
    [anon_sym_export] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_type] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1539),
    [anon_sym_static] = ACTIONS(1681),
    [anon_sym_get] = ACTIONS(1685),
    [anon_sym_set] = ACTIONS(1685),
    [anon_sym_declare] = ACTIONS(1681),
    [anon_sym_public] = ACTIONS(1681),
    [anon_sym_private] = ACTIONS(1681),
    [anon_sym_protected] = ACTIONS(1681),
    [anon_sym_module] = ACTIONS(1681),
    [anon_sym_any] = ACTIONS(1681),
    [anon_sym_number] = ACTIONS(1681),
    [anon_sym_boolean] = ACTIONS(1681),
    [anon_sym_string] = ACTIONS(1681),
    [anon_sym_symbol] = ACTIONS(1681),
    [sym_readonly] = ACTIONS(1681),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [471] = {
    [sym_string] = STATE(2459),
    [sym__property_name] = STATE(2459),
    [sym_computed_property_name] = STATE(2459),
    [aux_sym_object_repeat1] = STATE(2959),
    [sym_identifier] = ACTIONS(1681),
    [anon_sym_export] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1539),
    [anon_sym_static] = ACTIONS(1681),
    [anon_sym_get] = ACTIONS(1685),
    [anon_sym_set] = ACTIONS(1685),
    [anon_sym_declare] = ACTIONS(1681),
    [anon_sym_public] = ACTIONS(1681),
    [anon_sym_private] = ACTIONS(1681),
    [anon_sym_protected] = ACTIONS(1681),
    [anon_sym_module] = ACTIONS(1681),
    [anon_sym_any] = ACTIONS(1681),
    [anon_sym_number] = ACTIONS(1681),
    [anon_sym_boolean] = ACTIONS(1681),
    [anon_sym_string] = ACTIONS(1681),
    [anon_sym_symbol] = ACTIONS(1681),
    [sym_readonly] = ACTIONS(1687),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [472] = {
    [sym__call_signature] = STATE(3523),
    [sym_arguments] = STATE(1279),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_arguments] = STATE(1126),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1689),
    [anon_sym_export] = ACTIONS(1691),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(1693),
    [anon_sym_namespace] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(1695),
    [anon_sym_type] = ACTIONS(1691),
    [anon_sym_BANG] = ACTIONS(1693),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_RPAREN] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1693),
    [anon_sym_COLON] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_RBRACK] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(1693),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1691),
    [anon_sym_function] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1693),
    [anon_sym_GT_GT_GT] = ACTIONS(1693),
    [anon_sym_LT_LT] = ACTIONS(1693),
    [anon_sym_AMP] = ACTIONS(1693),
    [anon_sym_CARET] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(1693),
    [anon_sym_PERCENT] = ACTIONS(1693),
    [anon_sym_STAR_STAR] = ACTIONS(1693),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BANG_EQ] = ACTIONS(1693),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_QMARK_QMARK] = ACTIONS(1693),
    [anon_sym_instanceof] = ACTIONS(1693),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_static] = ACTIONS(1691),
    [anon_sym_get] = ACTIONS(1691),
    [anon_sym_set] = ACTIONS(1691),
    [anon_sym_declare] = ACTIONS(1691),
    [anon_sym_public] = ACTIONS(1691),
    [anon_sym_private] = ACTIONS(1691),
    [anon_sym_protected] = ACTIONS(1691),
    [anon_sym_module] = ACTIONS(1691),
    [anon_sym_any] = ACTIONS(1691),
    [anon_sym_number] = ACTIONS(1691),
    [anon_sym_boolean] = ACTIONS(1691),
    [anon_sym_string] = ACTIONS(1691),
    [anon_sym_symbol] = ACTIONS(1691),
    [sym_readonly] = ACTIONS(1691),
  },
  [473] = {
    [sym_object] = STATE(2538),
    [sym_array] = STATE(2537),
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(3565),
    [sym_rest_parameter] = STATE(2999),
    [sym_nested_type_identifier] = STATE(2023),
    [sym_accessibility_modifier] = STATE(2015),
    [sym_required_parameter] = STATE(2999),
    [sym_optional_parameter] = STATE(2999),
    [sym__parameter_name] = STATE(2342),
    [sym__rest_identifier] = STATE(2829),
    [sym__type] = STATE(2831),
    [sym_constructor_type] = STATE(2831),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2831),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2831),
    [sym_intersection_type] = STATE(2831),
    [sym_function_type] = STATE(2831),
    [aux_sym_export_statement_repeat1] = STATE(1906),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_type] = ACTIONS(1705),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_async] = ACTIONS(1705),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_QMARK] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(1715),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_get] = ACTIONS(1705),
    [anon_sym_set] = ACTIONS(1705),
    [anon_sym_declare] = ACTIONS(1705),
    [anon_sym_public] = ACTIONS(1717),
    [anon_sym_private] = ACTIONS(1717),
    [anon_sym_protected] = ACTIONS(1717),
    [anon_sym_module] = ACTIONS(1705),
    [anon_sym_any] = ACTIONS(1719),
    [anon_sym_number] = ACTIONS(1719),
    [anon_sym_boolean] = ACTIONS(1719),
    [anon_sym_string] = ACTIONS(1719),
    [anon_sym_symbol] = ACTIONS(1719),
    [sym_readonly] = ACTIONS(1721),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [474] = {
    [sym_object] = STATE(2538),
    [sym_array] = STATE(2537),
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(3565),
    [sym_rest_parameter] = STATE(2999),
    [sym_nested_type_identifier] = STATE(2023),
    [sym_accessibility_modifier] = STATE(2015),
    [sym_required_parameter] = STATE(2999),
    [sym_optional_parameter] = STATE(2999),
    [sym__parameter_name] = STATE(2342),
    [sym__rest_identifier] = STATE(2829),
    [sym__type] = STATE(2910),
    [sym_constructor_type] = STATE(2910),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2910),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2910),
    [sym_intersection_type] = STATE(2910),
    [sym_function_type] = STATE(2910),
    [aux_sym_export_statement_repeat1] = STATE(1906),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_type] = ACTIONS(1705),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_async] = ACTIONS(1705),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_QMARK] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(1715),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_get] = ACTIONS(1705),
    [anon_sym_set] = ACTIONS(1705),
    [anon_sym_declare] = ACTIONS(1705),
    [anon_sym_public] = ACTIONS(1717),
    [anon_sym_private] = ACTIONS(1717),
    [anon_sym_protected] = ACTIONS(1717),
    [anon_sym_module] = ACTIONS(1705),
    [anon_sym_any] = ACTIONS(1719),
    [anon_sym_number] = ACTIONS(1719),
    [anon_sym_boolean] = ACTIONS(1719),
    [anon_sym_string] = ACTIONS(1719),
    [anon_sym_symbol] = ACTIONS(1719),
    [sym_readonly] = ACTIONS(1721),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [475] = {
    [sym__call_signature] = STATE(3466),
    [sym_arguments] = STATE(1636),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_arguments] = STATE(1530),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1723),
    [anon_sym_export] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(1693),
    [anon_sym_namespace] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(1695),
    [anon_sym_type] = ACTIONS(1725),
    [anon_sym_BANG] = ACTIONS(1693),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(1693),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1725),
    [anon_sym_function] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1693),
    [anon_sym_GT_GT_GT] = ACTIONS(1693),
    [anon_sym_LT_LT] = ACTIONS(1693),
    [anon_sym_AMP] = ACTIONS(1693),
    [anon_sym_CARET] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(1693),
    [anon_sym_PERCENT] = ACTIONS(1693),
    [anon_sym_STAR_STAR] = ACTIONS(1693),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BANG_EQ] = ACTIONS(1693),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_QMARK_QMARK] = ACTIONS(1693),
    [anon_sym_instanceof] = ACTIONS(1693),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_get] = ACTIONS(1725),
    [anon_sym_set] = ACTIONS(1725),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_public] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym_protected] = ACTIONS(1725),
    [anon_sym_module] = ACTIONS(1725),
    [anon_sym_any] = ACTIONS(1725),
    [anon_sym_number] = ACTIONS(1725),
    [anon_sym_boolean] = ACTIONS(1725),
    [anon_sym_string] = ACTIONS(1725),
    [anon_sym_symbol] = ACTIONS(1725),
    [sym_readonly] = ACTIONS(1725),
    [sym__automatic_semicolon] = ACTIONS(1695),
  },
  [476] = {
    [sym_object] = STATE(2538),
    [sym_array] = STATE(2537),
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(3565),
    [sym_rest_parameter] = STATE(2999),
    [sym_nested_type_identifier] = STATE(2023),
    [sym_accessibility_modifier] = STATE(2015),
    [sym_required_parameter] = STATE(2999),
    [sym_optional_parameter] = STATE(2999),
    [sym__parameter_name] = STATE(2342),
    [sym__rest_identifier] = STATE(2829),
    [sym__type] = STATE(2832),
    [sym_constructor_type] = STATE(2832),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2832),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2832),
    [sym_intersection_type] = STATE(2832),
    [sym_function_type] = STATE(2832),
    [aux_sym_export_statement_repeat1] = STATE(1906),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_type] = ACTIONS(1705),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_async] = ACTIONS(1705),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_QMARK] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(1715),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_get] = ACTIONS(1705),
    [anon_sym_set] = ACTIONS(1705),
    [anon_sym_declare] = ACTIONS(1705),
    [anon_sym_public] = ACTIONS(1717),
    [anon_sym_private] = ACTIONS(1717),
    [anon_sym_protected] = ACTIONS(1717),
    [anon_sym_module] = ACTIONS(1705),
    [anon_sym_any] = ACTIONS(1719),
    [anon_sym_number] = ACTIONS(1719),
    [anon_sym_boolean] = ACTIONS(1719),
    [anon_sym_string] = ACTIONS(1719),
    [anon_sym_symbol] = ACTIONS(1719),
    [sym_readonly] = ACTIONS(1721),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [477] = {
    [sym_object] = STATE(2538),
    [sym_array] = STATE(2537),
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(3565),
    [sym_rest_parameter] = STATE(2999),
    [sym_nested_type_identifier] = STATE(2023),
    [sym_accessibility_modifier] = STATE(2015),
    [sym_required_parameter] = STATE(2999),
    [sym_optional_parameter] = STATE(2999),
    [sym__parameter_name] = STATE(2342),
    [sym__rest_identifier] = STATE(2829),
    [sym__type] = STATE(2879),
    [sym_constructor_type] = STATE(2879),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2879),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2879),
    [sym_intersection_type] = STATE(2879),
    [sym_function_type] = STATE(2879),
    [aux_sym_export_statement_repeat1] = STATE(1906),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_type] = ACTIONS(1705),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_async] = ACTIONS(1705),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_QMARK] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(1715),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_get] = ACTIONS(1705),
    [anon_sym_set] = ACTIONS(1705),
    [anon_sym_declare] = ACTIONS(1705),
    [anon_sym_public] = ACTIONS(1717),
    [anon_sym_private] = ACTIONS(1717),
    [anon_sym_protected] = ACTIONS(1717),
    [anon_sym_module] = ACTIONS(1705),
    [anon_sym_any] = ACTIONS(1719),
    [anon_sym_number] = ACTIONS(1719),
    [anon_sym_boolean] = ACTIONS(1719),
    [anon_sym_string] = ACTIONS(1719),
    [anon_sym_symbol] = ACTIONS(1719),
    [sym_readonly] = ACTIONS(1721),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [478] = {
    [sym_object] = STATE(2538),
    [sym_array] = STATE(2537),
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(3565),
    [sym_rest_parameter] = STATE(2999),
    [sym_nested_type_identifier] = STATE(2023),
    [sym_accessibility_modifier] = STATE(2015),
    [sym_required_parameter] = STATE(2999),
    [sym_optional_parameter] = STATE(2999),
    [sym__parameter_name] = STATE(2342),
    [sym__rest_identifier] = STATE(2829),
    [sym__type] = STATE(2867),
    [sym_constructor_type] = STATE(2867),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2867),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2867),
    [sym_intersection_type] = STATE(2867),
    [sym_function_type] = STATE(2867),
    [aux_sym_export_statement_repeat1] = STATE(1906),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_type] = ACTIONS(1705),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_async] = ACTIONS(1705),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_QMARK] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(1715),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_get] = ACTIONS(1705),
    [anon_sym_set] = ACTIONS(1705),
    [anon_sym_declare] = ACTIONS(1705),
    [anon_sym_public] = ACTIONS(1717),
    [anon_sym_private] = ACTIONS(1717),
    [anon_sym_protected] = ACTIONS(1717),
    [anon_sym_module] = ACTIONS(1705),
    [anon_sym_any] = ACTIONS(1719),
    [anon_sym_number] = ACTIONS(1719),
    [anon_sym_boolean] = ACTIONS(1719),
    [anon_sym_string] = ACTIONS(1719),
    [anon_sym_symbol] = ACTIONS(1719),
    [sym_readonly] = ACTIONS(1721),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [479] = {
    [sym_object] = STATE(2538),
    [sym_array] = STATE(2537),
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_decorator] = STATE(1994),
    [sym_formal_parameters] = STATE(3565),
    [sym_rest_parameter] = STATE(2999),
    [sym_nested_type_identifier] = STATE(2023),
    [sym_accessibility_modifier] = STATE(2015),
    [sym_required_parameter] = STATE(2999),
    [sym_optional_parameter] = STATE(2999),
    [sym__parameter_name] = STATE(2342),
    [sym__rest_identifier] = STATE(2829),
    [sym__type] = STATE(2938),
    [sym_constructor_type] = STATE(2938),
    [sym__primary_type] = STATE(433),
    [sym_infer_type] = STATE(2938),
    [sym_conditional_type] = STATE(433),
    [sym_generic_type] = STATE(433),
    [sym_type_query] = STATE(433),
    [sym_index_type_query] = STATE(433),
    [sym_lookup_type] = STATE(433),
    [sym_literal_type] = STATE(433),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(433),
    [sym_flow_maybe_type] = STATE(433),
    [sym_parenthesized_type] = STATE(433),
    [sym_predefined_type] = STATE(433),
    [sym_object_type] = STATE(433),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(433),
    [sym__tuple_type_body] = STATE(461),
    [sym_tuple_type] = STATE(433),
    [sym_union_type] = STATE(2938),
    [sym_intersection_type] = STATE(2938),
    [sym_function_type] = STATE(2938),
    [aux_sym_export_statement_repeat1] = STATE(1906),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_export] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_namespace] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_type] = ACTIONS(1705),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_async] = ACTIONS(1705),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_QMARK] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(1715),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_get] = ACTIONS(1705),
    [anon_sym_set] = ACTIONS(1705),
    [anon_sym_declare] = ACTIONS(1705),
    [anon_sym_public] = ACTIONS(1717),
    [anon_sym_private] = ACTIONS(1717),
    [anon_sym_protected] = ACTIONS(1717),
    [anon_sym_module] = ACTIONS(1705),
    [anon_sym_any] = ACTIONS(1719),
    [anon_sym_number] = ACTIONS(1719),
    [anon_sym_boolean] = ACTIONS(1719),
    [anon_sym_string] = ACTIONS(1719),
    [anon_sym_symbol] = ACTIONS(1719),
    [sym_readonly] = ACTIONS(1721),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [480] = {
    [aux_sym_object_repeat1] = STATE(3011),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_export] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1729),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1729),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_type] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1729),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_SQUOTE] = ACTIONS(1731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1731),
    [anon_sym_static] = ACTIONS(1729),
    [anon_sym_get] = ACTIONS(1729),
    [anon_sym_set] = ACTIONS(1729),
    [anon_sym_declare] = ACTIONS(1729),
    [anon_sym_public] = ACTIONS(1729),
    [anon_sym_private] = ACTIONS(1729),
    [anon_sym_protected] = ACTIONS(1729),
    [anon_sym_module] = ACTIONS(1729),
    [anon_sym_any] = ACTIONS(1729),
    [anon_sym_number] = ACTIONS(1729),
    [anon_sym_boolean] = ACTIONS(1729),
    [anon_sym_string] = ACTIONS(1729),
    [anon_sym_symbol] = ACTIONS(1729),
    [sym_readonly] = ACTIONS(1729),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [481] = {
    [sym__call_signature] = STATE(3596),
    [sym_arguments] = STATE(1279),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_arguments] = STATE(1126),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1733),
    [anon_sym_export] = ACTIONS(1735),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(1693),
    [anon_sym_namespace] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(1695),
    [anon_sym_COMMA] = ACTIONS(1695),
    [anon_sym_type] = ACTIONS(1735),
    [anon_sym_BANG] = ACTIONS(1693),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1693),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(1693),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1735),
    [anon_sym_function] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(1057),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1693),
    [anon_sym_GT_GT_GT] = ACTIONS(1693),
    [anon_sym_LT_LT] = ACTIONS(1693),
    [anon_sym_AMP] = ACTIONS(1693),
    [anon_sym_CARET] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(1693),
    [anon_sym_PERCENT] = ACTIONS(1693),
    [anon_sym_STAR_STAR] = ACTIONS(1693),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BANG_EQ] = ACTIONS(1693),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_QMARK_QMARK] = ACTIONS(1693),
    [anon_sym_instanceof] = ACTIONS(1693),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_static] = ACTIONS(1735),
    [anon_sym_get] = ACTIONS(1735),
    [anon_sym_set] = ACTIONS(1735),
    [anon_sym_declare] = ACTIONS(1735),
    [anon_sym_public] = ACTIONS(1735),
    [anon_sym_private] = ACTIONS(1735),
    [anon_sym_protected] = ACTIONS(1735),
    [anon_sym_module] = ACTIONS(1735),
    [anon_sym_any] = ACTIONS(1735),
    [anon_sym_number] = ACTIONS(1735),
    [anon_sym_boolean] = ACTIONS(1735),
    [anon_sym_string] = ACTIONS(1735),
    [anon_sym_symbol] = ACTIONS(1735),
    [anon_sym_implements] = ACTIONS(1693),
    [sym_readonly] = ACTIONS(1735),
  },
  [482] = {
    [sym__call_signature] = STATE(3456),
    [sym_arguments] = STATE(1738),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_arguments] = STATE(1710),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_export] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(1693),
    [anon_sym_namespace] = ACTIONS(1739),
    [anon_sym_LBRACE] = ACTIONS(1693),
    [anon_sym_COMMA] = ACTIONS(1695),
    [anon_sym_type] = ACTIONS(1739),
    [anon_sym_BANG] = ACTIONS(1693),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1693),
    [anon_sym_LBRACK] = ACTIONS(1741),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(1693),
    [anon_sym_DOT] = ACTIONS(1743),
    [anon_sym_async] = ACTIONS(1739),
    [anon_sym_function] = ACTIONS(1745),
    [anon_sym_EQ_GT] = ACTIONS(1189),
    [anon_sym_QMARK_DOT] = ACTIONS(1191),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1693),
    [anon_sym_GT_GT_GT] = ACTIONS(1693),
    [anon_sym_LT_LT] = ACTIONS(1693),
    [anon_sym_AMP] = ACTIONS(1693),
    [anon_sym_CARET] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(1693),
    [anon_sym_PERCENT] = ACTIONS(1693),
    [anon_sym_STAR_STAR] = ACTIONS(1693),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BANG_EQ] = ACTIONS(1693),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_QMARK_QMARK] = ACTIONS(1693),
    [anon_sym_instanceof] = ACTIONS(1693),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_static] = ACTIONS(1739),
    [anon_sym_get] = ACTIONS(1739),
    [anon_sym_set] = ACTIONS(1739),
    [anon_sym_declare] = ACTIONS(1739),
    [anon_sym_public] = ACTIONS(1739),
    [anon_sym_private] = ACTIONS(1739),
    [anon_sym_protected] = ACTIONS(1739),
    [anon_sym_module] = ACTIONS(1739),
    [anon_sym_any] = ACTIONS(1739),
    [anon_sym_number] = ACTIONS(1739),
    [anon_sym_boolean] = ACTIONS(1739),
    [anon_sym_string] = ACTIONS(1739),
    [anon_sym_symbol] = ACTIONS(1739),
    [sym_readonly] = ACTIONS(1739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1695),
  },
  [483] = {
    [sym__call_signature] = STATE(3523),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1689),
    [anon_sym_export] = ACTIONS(1691),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(953),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1691),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_RBRACK] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1691),
    [anon_sym_function] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1691),
    [anon_sym_get] = ACTIONS(1691),
    [anon_sym_set] = ACTIONS(1691),
    [anon_sym_declare] = ACTIONS(1691),
    [anon_sym_public] = ACTIONS(1691),
    [anon_sym_private] = ACTIONS(1691),
    [anon_sym_protected] = ACTIONS(1691),
    [anon_sym_module] = ACTIONS(1691),
    [anon_sym_any] = ACTIONS(1691),
    [anon_sym_number] = ACTIONS(1691),
    [anon_sym_boolean] = ACTIONS(1691),
    [anon_sym_string] = ACTIONS(1691),
    [anon_sym_symbol] = ACTIONS(1691),
    [sym_readonly] = ACTIONS(1691),
  },
  [484] = {
    [aux_sym_object_repeat1] = STATE(2959),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_export] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1729),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1729),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_type] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1729),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_SQUOTE] = ACTIONS(1731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1731),
    [anon_sym_static] = ACTIONS(1729),
    [anon_sym_get] = ACTIONS(1729),
    [anon_sym_set] = ACTIONS(1729),
    [anon_sym_declare] = ACTIONS(1729),
    [anon_sym_public] = ACTIONS(1729),
    [anon_sym_private] = ACTIONS(1729),
    [anon_sym_protected] = ACTIONS(1729),
    [anon_sym_module] = ACTIONS(1729),
    [anon_sym_any] = ACTIONS(1729),
    [anon_sym_number] = ACTIONS(1729),
    [anon_sym_boolean] = ACTIONS(1729),
    [anon_sym_string] = ACTIONS(1729),
    [anon_sym_symbol] = ACTIONS(1729),
    [sym_readonly] = ACTIONS(1729),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [485] = {
    [aux_sym_object_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_export] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1729),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1729),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_type] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(967),
    [anon_sym_async] = ACTIONS(1729),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(1731),
    [anon_sym_SQUOTE] = ACTIONS(1731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_number] = ACTIONS(1731),
    [anon_sym_static] = ACTIONS(1729),
    [anon_sym_get] = ACTIONS(1729),
    [anon_sym_set] = ACTIONS(1729),
    [anon_sym_declare] = ACTIONS(1729),
    [anon_sym_public] = ACTIONS(1729),
    [anon_sym_private] = ACTIONS(1729),
    [anon_sym_protected] = ACTIONS(1729),
    [anon_sym_module] = ACTIONS(1729),
    [anon_sym_any] = ACTIONS(1729),
    [anon_sym_number] = ACTIONS(1729),
    [anon_sym_boolean] = ACTIONS(1729),
    [anon_sym_string] = ACTIONS(1729),
    [anon_sym_symbol] = ACTIONS(1729),
    [sym_readonly] = ACTIONS(1729),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [486] = {
    [sym__call_signature] = STATE(3454),
    [sym_arguments] = STATE(1279),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_arguments] = STATE(1126),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_export] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(1693),
    [anon_sym_namespace] = ACTIONS(1755),
    [anon_sym_RBRACE] = ACTIONS(1695),
    [anon_sym_type] = ACTIONS(1755),
    [anon_sym_BANG] = ACTIONS(1693),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1693),
    [anon_sym_COLON] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_RBRACK] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(1693),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1755),
    [anon_sym_function] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1693),
    [anon_sym_GT_GT_GT] = ACTIONS(1693),
    [anon_sym_LT_LT] = ACTIONS(1693),
    [anon_sym_AMP] = ACTIONS(1693),
    [anon_sym_CARET] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(1693),
    [anon_sym_PERCENT] = ACTIONS(1693),
    [anon_sym_STAR_STAR] = ACTIONS(1693),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BANG_EQ] = ACTIONS(1693),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_QMARK_QMARK] = ACTIONS(1693),
    [anon_sym_instanceof] = ACTIONS(1693),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_static] = ACTIONS(1755),
    [anon_sym_get] = ACTIONS(1755),
    [anon_sym_set] = ACTIONS(1755),
    [anon_sym_declare] = ACTIONS(1755),
    [anon_sym_public] = ACTIONS(1755),
    [anon_sym_private] = ACTIONS(1755),
    [anon_sym_protected] = ACTIONS(1755),
    [anon_sym_module] = ACTIONS(1755),
    [anon_sym_any] = ACTIONS(1755),
    [anon_sym_number] = ACTIONS(1755),
    [anon_sym_boolean] = ACTIONS(1755),
    [anon_sym_string] = ACTIONS(1755),
    [anon_sym_symbol] = ACTIONS(1755),
    [sym_readonly] = ACTIONS(1755),
  },
  [487] = {
    [sym__call_signature] = STATE(3466),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1723),
    [anon_sym_export] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(963),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1725),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1725),
    [anon_sym_function] = ACTIONS(1757),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_get] = ACTIONS(1725),
    [anon_sym_set] = ACTIONS(1725),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_public] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym_protected] = ACTIONS(1725),
    [anon_sym_module] = ACTIONS(1725),
    [anon_sym_any] = ACTIONS(1725),
    [anon_sym_number] = ACTIONS(1725),
    [anon_sym_boolean] = ACTIONS(1725),
    [anon_sym_string] = ACTIONS(1725),
    [anon_sym_symbol] = ACTIONS(1725),
    [sym_readonly] = ACTIONS(1725),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [488] = {
    [sym_type_arguments] = STATE(428),
    [ts_builtin_sym_end] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_export] = ACTIONS(1761),
    [anon_sym_default] = ACTIONS(1761),
    [anon_sym_namespace] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(1759),
    [anon_sym_RBRACE] = ACTIONS(1759),
    [anon_sym_type] = ACTIONS(1761),
    [anon_sym_typeof] = ACTIONS(1761),
    [anon_sym_import] = ACTIONS(1761),
    [anon_sym_var] = ACTIONS(1761),
    [anon_sym_let] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1761),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_else] = ACTIONS(1761),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_switch] = ACTIONS(1761),
    [anon_sym_for] = ACTIONS(1761),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_await] = ACTIONS(1761),
    [anon_sym_while] = ACTIONS(1761),
    [anon_sym_do] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1761),
    [anon_sym_with] = ACTIONS(1761),
    [anon_sym_break] = ACTIONS(1761),
    [anon_sym_continue] = ACTIONS(1761),
    [anon_sym_debugger] = ACTIONS(1761),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_SEMI] = ACTIONS(1759),
    [anon_sym_case] = ACTIONS(1761),
    [anon_sym_yield] = ACTIONS(1761),
    [anon_sym_LBRACK] = ACTIONS(1759),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_DOT] = ACTIONS(1766),
    [anon_sym_class] = ACTIONS(1761),
    [anon_sym_async] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(1761),
    [anon_sym_new] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1759),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_void] = ACTIONS(1761),
    [anon_sym_delete] = ACTIONS(1761),
    [anon_sym_PLUS_PLUS] = ACTIONS(1759),
    [anon_sym_DASH_DASH] = ACTIONS(1759),
    [anon_sym_DQUOTE] = ACTIONS(1759),
    [anon_sym_SQUOTE] = ACTIONS(1759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1759),
    [sym_number] = ACTIONS(1759),
    [sym_this] = ACTIONS(1761),
    [sym_super] = ACTIONS(1761),
    [sym_true] = ACTIONS(1761),
    [sym_false] = ACTIONS(1761),
    [sym_null] = ACTIONS(1761),
    [sym_undefined] = ACTIONS(1761),
    [anon_sym_AT] = ACTIONS(1759),
    [anon_sym_static] = ACTIONS(1761),
    [anon_sym_abstract] = ACTIONS(1761),
    [anon_sym_get] = ACTIONS(1761),
    [anon_sym_set] = ACTIONS(1761),
    [anon_sym_declare] = ACTIONS(1761),
    [anon_sym_public] = ACTIONS(1761),
    [anon_sym_private] = ACTIONS(1761),
    [anon_sym_protected] = ACTIONS(1761),
    [anon_sym_module] = ACTIONS(1761),
    [anon_sym_any] = ACTIONS(1761),
    [anon_sym_number] = ACTIONS(1761),
    [anon_sym_boolean] = ACTIONS(1761),
    [anon_sym_string] = ACTIONS(1761),
    [anon_sym_symbol] = ACTIONS(1761),
    [anon_sym_interface] = ACTIONS(1761),
    [anon_sym_extends] = ACTIONS(1761),
    [anon_sym_enum] = ACTIONS(1761),
    [sym_readonly] = ACTIONS(1761),
  },
  [489] = {
    [sym__call_signature] = STATE(3466),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1723),
    [anon_sym_export] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(963),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1725),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1725),
    [anon_sym_function] = ACTIONS(1757),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_get] = ACTIONS(1725),
    [anon_sym_set] = ACTIONS(1725),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_public] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym_protected] = ACTIONS(1725),
    [anon_sym_module] = ACTIONS(1725),
    [anon_sym_any] = ACTIONS(1725),
    [anon_sym_number] = ACTIONS(1725),
    [anon_sym_boolean] = ACTIONS(1725),
    [anon_sym_string] = ACTIONS(1725),
    [anon_sym_symbol] = ACTIONS(1725),
    [sym_readonly] = ACTIONS(1725),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [490] = {
    [sym__call_signature] = STATE(3466),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1723),
    [anon_sym_export] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(963),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1725),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1725),
    [anon_sym_function] = ACTIONS(1537),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_get] = ACTIONS(1725),
    [anon_sym_set] = ACTIONS(1725),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_public] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym_protected] = ACTIONS(1725),
    [anon_sym_module] = ACTIONS(1725),
    [anon_sym_any] = ACTIONS(1725),
    [anon_sym_number] = ACTIONS(1725),
    [anon_sym_boolean] = ACTIONS(1725),
    [anon_sym_string] = ACTIONS(1725),
    [anon_sym_symbol] = ACTIONS(1725),
    [sym_readonly] = ACTIONS(1725),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [491] = {
    [sym_type_arguments] = STATE(428),
    [ts_builtin_sym_end] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_default] = ACTIONS(1623),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1621),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_typeof] = ACTIONS(1623),
    [anon_sym_import] = ACTIONS(1623),
    [anon_sym_var] = ACTIONS(1623),
    [anon_sym_let] = ACTIONS(1623),
    [anon_sym_const] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_else] = ACTIONS(1623),
    [anon_sym_if] = ACTIONS(1623),
    [anon_sym_switch] = ACTIONS(1623),
    [anon_sym_for] = ACTIONS(1623),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_await] = ACTIONS(1623),
    [anon_sym_while] = ACTIONS(1623),
    [anon_sym_do] = ACTIONS(1623),
    [anon_sym_try] = ACTIONS(1623),
    [anon_sym_with] = ACTIONS(1623),
    [anon_sym_break] = ACTIONS(1623),
    [anon_sym_continue] = ACTIONS(1623),
    [anon_sym_debugger] = ACTIONS(1623),
    [anon_sym_return] = ACTIONS(1623),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_case] = ACTIONS(1623),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_SLASH] = ACTIONS(1623),
    [anon_sym_DOT] = ACTIONS(1768),
    [anon_sym_class] = ACTIONS(1623),
    [anon_sym_async] = ACTIONS(1623),
    [anon_sym_function] = ACTIONS(1623),
    [anon_sym_new] = ACTIONS(1623),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_PLUS] = ACTIONS(1623),
    [anon_sym_DASH] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_void] = ACTIONS(1623),
    [anon_sym_delete] = ACTIONS(1623),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1621),
    [sym_number] = ACTIONS(1621),
    [sym_this] = ACTIONS(1623),
    [sym_super] = ACTIONS(1623),
    [sym_true] = ACTIONS(1623),
    [sym_false] = ACTIONS(1623),
    [sym_null] = ACTIONS(1623),
    [sym_undefined] = ACTIONS(1623),
    [anon_sym_AT] = ACTIONS(1621),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_abstract] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1623),
    [anon_sym_set] = ACTIONS(1623),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [anon_sym_interface] = ACTIONS(1623),
    [anon_sym_extends] = ACTIONS(1623),
    [anon_sym_enum] = ACTIONS(1623),
    [sym_readonly] = ACTIONS(1623),
  },
  [492] = {
    [sym__call_signature] = STATE(3466),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1723),
    [anon_sym_export] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(963),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1725),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(1770),
    [anon_sym_of] = ACTIONS(1773),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1725),
    [anon_sym_function] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_get] = ACTIONS(1725),
    [anon_sym_set] = ACTIONS(1725),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_public] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym_protected] = ACTIONS(1725),
    [anon_sym_module] = ACTIONS(1725),
    [anon_sym_any] = ACTIONS(1725),
    [anon_sym_number] = ACTIONS(1725),
    [anon_sym_boolean] = ACTIONS(1725),
    [anon_sym_string] = ACTIONS(1725),
    [anon_sym_symbol] = ACTIONS(1725),
    [sym_readonly] = ACTIONS(1725),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [493] = {
    [sym_type_arguments] = STATE(428),
    [ts_builtin_sym_end] = ACTIONS(1775),
    [sym_identifier] = ACTIONS(1777),
    [anon_sym_export] = ACTIONS(1777),
    [anon_sym_default] = ACTIONS(1777),
    [anon_sym_namespace] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(1775),
    [anon_sym_RBRACE] = ACTIONS(1775),
    [anon_sym_type] = ACTIONS(1777),
    [anon_sym_typeof] = ACTIONS(1777),
    [anon_sym_import] = ACTIONS(1777),
    [anon_sym_var] = ACTIONS(1777),
    [anon_sym_let] = ACTIONS(1777),
    [anon_sym_const] = ACTIONS(1777),
    [anon_sym_BANG] = ACTIONS(1775),
    [anon_sym_else] = ACTIONS(1777),
    [anon_sym_if] = ACTIONS(1777),
    [anon_sym_switch] = ACTIONS(1777),
    [anon_sym_for] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_while] = ACTIONS(1777),
    [anon_sym_do] = ACTIONS(1777),
    [anon_sym_try] = ACTIONS(1777),
    [anon_sym_with] = ACTIONS(1777),
    [anon_sym_break] = ACTIONS(1777),
    [anon_sym_continue] = ACTIONS(1777),
    [anon_sym_debugger] = ACTIONS(1777),
    [anon_sym_return] = ACTIONS(1777),
    [anon_sym_throw] = ACTIONS(1777),
    [anon_sym_SEMI] = ACTIONS(1775),
    [anon_sym_case] = ACTIONS(1777),
    [anon_sym_yield] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(1775),
    [anon_sym_LT] = ACTIONS(1775),
    [anon_sym_SLASH] = ACTIONS(1777),
    [anon_sym_DOT] = ACTIONS(1766),
    [anon_sym_class] = ACTIONS(1777),
    [anon_sym_async] = ACTIONS(1777),
    [anon_sym_function] = ACTIONS(1777),
    [anon_sym_new] = ACTIONS(1777),
    [anon_sym_AMP] = ACTIONS(1775),
    [anon_sym_PIPE] = ACTIONS(1775),
    [anon_sym_PLUS] = ACTIONS(1777),
    [anon_sym_DASH] = ACTIONS(1777),
    [anon_sym_TILDE] = ACTIONS(1775),
    [anon_sym_void] = ACTIONS(1777),
    [anon_sym_delete] = ACTIONS(1777),
    [anon_sym_PLUS_PLUS] = ACTIONS(1775),
    [anon_sym_DASH_DASH] = ACTIONS(1775),
    [anon_sym_DQUOTE] = ACTIONS(1775),
    [anon_sym_SQUOTE] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1775),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_super] = ACTIONS(1777),
    [sym_true] = ACTIONS(1777),
    [sym_false] = ACTIONS(1777),
    [sym_null] = ACTIONS(1777),
    [sym_undefined] = ACTIONS(1777),
    [anon_sym_AT] = ACTIONS(1775),
    [anon_sym_static] = ACTIONS(1777),
    [anon_sym_abstract] = ACTIONS(1777),
    [anon_sym_get] = ACTIONS(1777),
    [anon_sym_set] = ACTIONS(1777),
    [anon_sym_declare] = ACTIONS(1777),
    [anon_sym_public] = ACTIONS(1777),
    [anon_sym_private] = ACTIONS(1777),
    [anon_sym_protected] = ACTIONS(1777),
    [anon_sym_module] = ACTIONS(1777),
    [anon_sym_any] = ACTIONS(1777),
    [anon_sym_number] = ACTIONS(1777),
    [anon_sym_boolean] = ACTIONS(1777),
    [anon_sym_string] = ACTIONS(1777),
    [anon_sym_symbol] = ACTIONS(1777),
    [anon_sym_interface] = ACTIONS(1777),
    [anon_sym_extends] = ACTIONS(1777),
    [anon_sym_enum] = ACTIONS(1777),
    [sym_readonly] = ACTIONS(1777),
  },
  [494] = {
    [sym__call_signature] = STATE(3466),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1723),
    [anon_sym_export] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(963),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1725),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1725),
    [anon_sym_function] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_get] = ACTIONS(1725),
    [anon_sym_set] = ACTIONS(1725),
    [anon_sym_declare] = ACTIONS(1725),
    [anon_sym_public] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym_protected] = ACTIONS(1725),
    [anon_sym_module] = ACTIONS(1725),
    [anon_sym_any] = ACTIONS(1725),
    [anon_sym_number] = ACTIONS(1725),
    [anon_sym_boolean] = ACTIONS(1725),
    [anon_sym_string] = ACTIONS(1725),
    [anon_sym_symbol] = ACTIONS(1725),
    [sym_readonly] = ACTIONS(1725),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [495] = {
    [sym__call_signature] = STATE(3486),
    [sym_arguments] = STATE(1636),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_arguments] = STATE(1530),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(1693),
    [anon_sym_namespace] = ACTIONS(1781),
    [anon_sym_type] = ACTIONS(1781),
    [anon_sym_BANG] = ACTIONS(1693),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(1693),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1781),
    [anon_sym_function] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(1173),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1693),
    [anon_sym_GT_GT_GT] = ACTIONS(1693),
    [anon_sym_LT_LT] = ACTIONS(1693),
    [anon_sym_AMP] = ACTIONS(1693),
    [anon_sym_CARET] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(1693),
    [anon_sym_PERCENT] = ACTIONS(1693),
    [anon_sym_STAR_STAR] = ACTIONS(1693),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BANG_EQ] = ACTIONS(1693),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_QMARK_QMARK] = ACTIONS(1693),
    [anon_sym_instanceof] = ACTIONS(1693),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_static] = ACTIONS(1781),
    [anon_sym_get] = ACTIONS(1781),
    [anon_sym_set] = ACTIONS(1781),
    [anon_sym_declare] = ACTIONS(1781),
    [anon_sym_public] = ACTIONS(1781),
    [anon_sym_private] = ACTIONS(1781),
    [anon_sym_protected] = ACTIONS(1781),
    [anon_sym_module] = ACTIONS(1781),
    [anon_sym_any] = ACTIONS(1781),
    [anon_sym_number] = ACTIONS(1781),
    [anon_sym_boolean] = ACTIONS(1781),
    [anon_sym_string] = ACTIONS(1781),
    [anon_sym_symbol] = ACTIONS(1781),
    [sym_readonly] = ACTIONS(1781),
    [sym__automatic_semicolon] = ACTIONS(1695),
  },
  [496] = {
    [sym_object] = STATE(2624),
    [sym_array] = STATE(2621),
    [sym_identifier] = ACTIONS(1783),
    [anon_sym_export] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(857),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1785),
    [anon_sym_COMMA] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(864),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(864),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(860),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1789),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_this] = ACTIONS(1783),
    [anon_sym_static] = ACTIONS(853),
    [anon_sym_get] = ACTIONS(853),
    [anon_sym_set] = ACTIONS(853),
    [anon_sym_declare] = ACTIONS(853),
    [anon_sym_public] = ACTIONS(853),
    [anon_sym_private] = ACTIONS(853),
    [anon_sym_protected] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(853),
    [anon_sym_any] = ACTIONS(853),
    [anon_sym_number] = ACTIONS(853),
    [anon_sym_boolean] = ACTIONS(853),
    [anon_sym_string] = ACTIONS(853),
    [anon_sym_symbol] = ACTIONS(853),
    [sym_readonly] = ACTIONS(853),
  },
  [497] = {
    [sym__call_signature] = STATE(3523),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1689),
    [anon_sym_export] = ACTIONS(1691),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(953),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1691),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(1792),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_RBRACK] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1691),
    [anon_sym_function] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1691),
    [anon_sym_get] = ACTIONS(1691),
    [anon_sym_set] = ACTIONS(1691),
    [anon_sym_declare] = ACTIONS(1691),
    [anon_sym_public] = ACTIONS(1691),
    [anon_sym_private] = ACTIONS(1691),
    [anon_sym_protected] = ACTIONS(1691),
    [anon_sym_module] = ACTIONS(1691),
    [anon_sym_any] = ACTIONS(1691),
    [anon_sym_number] = ACTIONS(1691),
    [anon_sym_boolean] = ACTIONS(1691),
    [anon_sym_string] = ACTIONS(1691),
    [anon_sym_symbol] = ACTIONS(1691),
    [sym_readonly] = ACTIONS(1691),
  },
  [498] = {
    [sym__call_signature] = STATE(3523),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1689),
    [anon_sym_export] = ACTIONS(1691),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(857),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(1691),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_RPAREN] = ACTIONS(864),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(864),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1691),
    [anon_sym_function] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1789),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1691),
    [anon_sym_get] = ACTIONS(1691),
    [anon_sym_set] = ACTIONS(1691),
    [anon_sym_declare] = ACTIONS(1691),
    [anon_sym_public] = ACTIONS(1691),
    [anon_sym_private] = ACTIONS(1691),
    [anon_sym_protected] = ACTIONS(1691),
    [anon_sym_module] = ACTIONS(1691),
    [anon_sym_any] = ACTIONS(1691),
    [anon_sym_number] = ACTIONS(1691),
    [anon_sym_boolean] = ACTIONS(1691),
    [anon_sym_string] = ACTIONS(1691),
    [anon_sym_symbol] = ACTIONS(1691),
    [sym_readonly] = ACTIONS(1691),
  },
  [499] = {
    [sym__call_signature] = STATE(3523),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1689),
    [anon_sym_export] = ACTIONS(1691),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(857),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1691),
    [anon_sym_COMMA] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(1691),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_RPAREN] = ACTIONS(864),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1691),
    [anon_sym_function] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1789),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1691),
    [anon_sym_get] = ACTIONS(1691),
    [anon_sym_set] = ACTIONS(1691),
    [anon_sym_declare] = ACTIONS(1691),
    [anon_sym_public] = ACTIONS(1691),
    [anon_sym_private] = ACTIONS(1691),
    [anon_sym_protected] = ACTIONS(1691),
    [anon_sym_module] = ACTIONS(1691),
    [anon_sym_any] = ACTIONS(1691),
    [anon_sym_number] = ACTIONS(1691),
    [anon_sym_boolean] = ACTIONS(1691),
    [anon_sym_string] = ACTIONS(1691),
    [anon_sym_symbol] = ACTIONS(1691),
    [sym_readonly] = ACTIONS(1691),
  },
  [500] = {
    [ts_builtin_sym_end] = ACTIONS(973),
    [sym_identifier] = ACTIONS(975),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_default] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(975),
    [anon_sym_import] = ACTIONS(975),
    [anon_sym_var] = ACTIONS(975),
    [anon_sym_let] = ACTIONS(975),
    [anon_sym_const] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_else] = ACTIONS(975),
    [anon_sym_if] = ACTIONS(975),
    [anon_sym_switch] = ACTIONS(975),
    [anon_sym_for] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(973),
    [anon_sym_await] = ACTIONS(975),
    [anon_sym_while] = ACTIONS(975),
    [anon_sym_do] = ACTIONS(975),
    [anon_sym_try] = ACTIONS(975),
    [anon_sym_with] = ACTIONS(975),
    [anon_sym_break] = ACTIONS(975),
    [anon_sym_continue] = ACTIONS(975),
    [anon_sym_debugger] = ACTIONS(975),
    [anon_sym_return] = ACTIONS(975),
    [anon_sym_throw] = ACTIONS(975),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_case] = ACTIONS(975),
    [anon_sym_catch] = ACTIONS(975),
    [anon_sym_finally] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(973),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_class] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_TILDE] = ACTIONS(973),
    [anon_sym_void] = ACTIONS(975),
    [anon_sym_delete] = ACTIONS(975),
    [anon_sym_PLUS_PLUS] = ACTIONS(973),
    [anon_sym_DASH_DASH] = ACTIONS(973),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(973),
    [sym_number] = ACTIONS(973),
    [sym_this] = ACTIONS(975),
    [sym_super] = ACTIONS(975),
    [sym_true] = ACTIONS(975),
    [sym_false] = ACTIONS(975),
    [sym_null] = ACTIONS(975),
    [sym_undefined] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(973),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_abstract] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_interface] = ACTIONS(975),
    [anon_sym_enum] = ACTIONS(975),
    [sym_readonly] = ACTIONS(975),
    [sym__automatic_semicolon] = ACTIONS(981),
  },
  [501] = {
    [sym__call_signature] = STATE(3596),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1733),
    [anon_sym_export] = ACTIONS(1735),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1055),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1735),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1735),
    [anon_sym_function] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(1057),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1735),
    [anon_sym_get] = ACTIONS(1735),
    [anon_sym_set] = ACTIONS(1735),
    [anon_sym_declare] = ACTIONS(1735),
    [anon_sym_public] = ACTIONS(1735),
    [anon_sym_private] = ACTIONS(1735),
    [anon_sym_protected] = ACTIONS(1735),
    [anon_sym_module] = ACTIONS(1735),
    [anon_sym_any] = ACTIONS(1735),
    [anon_sym_number] = ACTIONS(1735),
    [anon_sym_boolean] = ACTIONS(1735),
    [anon_sym_string] = ACTIONS(1735),
    [anon_sym_symbol] = ACTIONS(1735),
    [anon_sym_implements] = ACTIONS(860),
    [sym_readonly] = ACTIONS(1735),
  },
  [502] = {
    [sym_object] = STATE(2624),
    [sym_array] = STATE(2621),
    [sym_identifier] = ACTIONS(1783),
    [anon_sym_export] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(857),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(1785),
    [anon_sym_COMMA] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(864),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1796),
    [anon_sym_LT] = ACTIONS(860),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1789),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_this] = ACTIONS(1783),
    [anon_sym_static] = ACTIONS(853),
    [anon_sym_get] = ACTIONS(853),
    [anon_sym_set] = ACTIONS(853),
    [anon_sym_declare] = ACTIONS(853),
    [anon_sym_public] = ACTIONS(853),
    [anon_sym_private] = ACTIONS(853),
    [anon_sym_protected] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(853),
    [anon_sym_any] = ACTIONS(853),
    [anon_sym_number] = ACTIONS(853),
    [anon_sym_boolean] = ACTIONS(853),
    [anon_sym_string] = ACTIONS(853),
    [anon_sym_symbol] = ACTIONS(853),
    [sym_readonly] = ACTIONS(853),
  },
  [503] = {
    [sym_type_arguments] = STATE(427),
    [ts_builtin_sym_end] = ACTIONS(1798),
    [sym_identifier] = ACTIONS(1800),
    [anon_sym_export] = ACTIONS(1800),
    [anon_sym_default] = ACTIONS(1800),
    [anon_sym_namespace] = ACTIONS(1800),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(1800),
    [anon_sym_typeof] = ACTIONS(1800),
    [anon_sym_import] = ACTIONS(1800),
    [anon_sym_var] = ACTIONS(1800),
    [anon_sym_let] = ACTIONS(1800),
    [anon_sym_const] = ACTIONS(1800),
    [anon_sym_BANG] = ACTIONS(1798),
    [anon_sym_else] = ACTIONS(1800),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_switch] = ACTIONS(1800),
    [anon_sym_for] = ACTIONS(1800),
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_await] = ACTIONS(1800),
    [anon_sym_while] = ACTIONS(1800),
    [anon_sym_do] = ACTIONS(1800),
    [anon_sym_try] = ACTIONS(1800),
    [anon_sym_with] = ACTIONS(1800),
    [anon_sym_break] = ACTIONS(1800),
    [anon_sym_continue] = ACTIONS(1800),
    [anon_sym_debugger] = ACTIONS(1800),
    [anon_sym_return] = ACTIONS(1800),
    [anon_sym_throw] = ACTIONS(1800),
    [anon_sym_SEMI] = ACTIONS(1798),
    [anon_sym_case] = ACTIONS(1800),
    [anon_sym_yield] = ACTIONS(1800),
    [anon_sym_LBRACK] = ACTIONS(1798),
    [anon_sym_LT] = ACTIONS(1802),
    [anon_sym_SLASH] = ACTIONS(1800),
    [anon_sym_class] = ACTIONS(1800),
    [anon_sym_async] = ACTIONS(1800),
    [anon_sym_function] = ACTIONS(1800),
    [anon_sym_new] = ACTIONS(1800),
    [anon_sym_AMP] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1798),
    [anon_sym_PLUS] = ACTIONS(1800),
    [anon_sym_DASH] = ACTIONS(1800),
    [anon_sym_TILDE] = ACTIONS(1798),
    [anon_sym_void] = ACTIONS(1800),
    [anon_sym_delete] = ACTIONS(1800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1798),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_SQUOTE] = ACTIONS(1798),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1798),
    [sym_number] = ACTIONS(1798),
    [sym_this] = ACTIONS(1800),
    [sym_super] = ACTIONS(1800),
    [sym_true] = ACTIONS(1800),
    [sym_false] = ACTIONS(1800),
    [sym_null] = ACTIONS(1800),
    [sym_undefined] = ACTIONS(1800),
    [anon_sym_AT] = ACTIONS(1798),
    [anon_sym_static] = ACTIONS(1800),
    [anon_sym_abstract] = ACTIONS(1800),
    [anon_sym_get] = ACTIONS(1800),
    [anon_sym_set] = ACTIONS(1800),
    [anon_sym_declare] = ACTIONS(1800),
    [anon_sym_public] = ACTIONS(1800),
    [anon_sym_private] = ACTIONS(1800),
    [anon_sym_protected] = ACTIONS(1800),
    [anon_sym_module] = ACTIONS(1800),
    [anon_sym_any] = ACTIONS(1800),
    [anon_sym_number] = ACTIONS(1800),
    [anon_sym_boolean] = ACTIONS(1800),
    [anon_sym_string] = ACTIONS(1800),
    [anon_sym_symbol] = ACTIONS(1800),
    [anon_sym_interface] = ACTIONS(1800),
    [anon_sym_extends] = ACTIONS(1800),
    [anon_sym_enum] = ACTIONS(1800),
    [sym_readonly] = ACTIONS(1800),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_default] = ACTIONS(1623),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1621),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_typeof] = ACTIONS(1623),
    [anon_sym_import] = ACTIONS(1623),
    [anon_sym_var] = ACTIONS(1623),
    [anon_sym_let] = ACTIONS(1623),
    [anon_sym_const] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_else] = ACTIONS(1623),
    [anon_sym_if] = ACTIONS(1623),
    [anon_sym_switch] = ACTIONS(1623),
    [anon_sym_for] = ACTIONS(1623),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_await] = ACTIONS(1623),
    [anon_sym_while] = ACTIONS(1623),
    [anon_sym_do] = ACTIONS(1623),
    [anon_sym_try] = ACTIONS(1623),
    [anon_sym_with] = ACTIONS(1623),
    [anon_sym_break] = ACTIONS(1623),
    [anon_sym_continue] = ACTIONS(1623),
    [anon_sym_debugger] = ACTIONS(1623),
    [anon_sym_return] = ACTIONS(1623),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_case] = ACTIONS(1623),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_SLASH] = ACTIONS(1623),
    [anon_sym_DOT] = ACTIONS(1768),
    [anon_sym_class] = ACTIONS(1623),
    [anon_sym_async] = ACTIONS(1623),
    [anon_sym_function] = ACTIONS(1623),
    [anon_sym_new] = ACTIONS(1623),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_PLUS] = ACTIONS(1623),
    [anon_sym_DASH] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_void] = ACTIONS(1623),
    [anon_sym_delete] = ACTIONS(1623),
    [anon_sym_PLUS_PLUS] = ACTIONS(1621),
    [anon_sym_DASH_DASH] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(1621),
    [anon_sym_SQUOTE] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1621),
    [sym_number] = ACTIONS(1621),
    [sym_this] = ACTIONS(1623),
    [sym_super] = ACTIONS(1623),
    [sym_true] = ACTIONS(1623),
    [sym_false] = ACTIONS(1623),
    [sym_null] = ACTIONS(1623),
    [sym_undefined] = ACTIONS(1623),
    [anon_sym_AT] = ACTIONS(1621),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_abstract] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1623),
    [anon_sym_set] = ACTIONS(1623),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [anon_sym_interface] = ACTIONS(1623),
    [anon_sym_extends] = ACTIONS(1623),
    [anon_sym_enum] = ACTIONS(1623),
    [sym_readonly] = ACTIONS(1623),
  },
  [505] = {
    [ts_builtin_sym_end] = ACTIONS(1059),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_default] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(1061),
    [anon_sym_var] = ACTIONS(1061),
    [anon_sym_let] = ACTIONS(1061),
    [anon_sym_const] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_switch] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_await] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_do] = ACTIONS(1061),
    [anon_sym_try] = ACTIONS(1061),
    [anon_sym_with] = ACTIONS(1061),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_continue] = ACTIONS(1061),
    [anon_sym_debugger] = ACTIONS(1061),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_throw] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_case] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1805),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_function] = ACTIONS(1061),
    [anon_sym_new] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [sym_number] = ACTIONS(1059),
    [sym_this] = ACTIONS(1061),
    [sym_super] = ACTIONS(1061),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_null] = ACTIONS(1061),
    [sym_undefined] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1059),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_abstract] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_interface] = ACTIONS(1061),
    [anon_sym_extends] = ACTIONS(1061),
    [anon_sym_enum] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
  },
  [506] = {
    [sym_type_arguments] = STATE(427),
    [ts_builtin_sym_end] = ACTIONS(1601),
    [sym_identifier] = ACTIONS(1603),
    [anon_sym_export] = ACTIONS(1603),
    [anon_sym_default] = ACTIONS(1603),
    [anon_sym_namespace] = ACTIONS(1603),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_RBRACE] = ACTIONS(1601),
    [anon_sym_type] = ACTIONS(1603),
    [anon_sym_typeof] = ACTIONS(1603),
    [anon_sym_import] = ACTIONS(1603),
    [anon_sym_var] = ACTIONS(1603),
    [anon_sym_let] = ACTIONS(1603),
    [anon_sym_const] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_else] = ACTIONS(1603),
    [anon_sym_if] = ACTIONS(1603),
    [anon_sym_switch] = ACTIONS(1603),
    [anon_sym_for] = ACTIONS(1603),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_await] = ACTIONS(1603),
    [anon_sym_while] = ACTIONS(1603),
    [anon_sym_do] = ACTIONS(1603),
    [anon_sym_try] = ACTIONS(1603),
    [anon_sym_with] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1603),
    [anon_sym_continue] = ACTIONS(1603),
    [anon_sym_debugger] = ACTIONS(1603),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_throw] = ACTIONS(1603),
    [anon_sym_SEMI] = ACTIONS(1601),
    [anon_sym_case] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_LBRACK] = ACTIONS(1601),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1603),
    [anon_sym_class] = ACTIONS(1603),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1603),
    [anon_sym_DASH] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1601),
    [anon_sym_void] = ACTIONS(1603),
    [anon_sym_delete] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1601),
    [anon_sym_DASH_DASH] = ACTIONS(1601),
    [anon_sym_DQUOTE] = ACTIONS(1601),
    [anon_sym_SQUOTE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1601),
    [sym_number] = ACTIONS(1601),
    [sym_this] = ACTIONS(1603),
    [sym_super] = ACTIONS(1603),
    [sym_true] = ACTIONS(1603),
    [sym_false] = ACTIONS(1603),
    [sym_null] = ACTIONS(1603),
    [sym_undefined] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(1601),
    [anon_sym_static] = ACTIONS(1603),
    [anon_sym_abstract] = ACTIONS(1603),
    [anon_sym_get] = ACTIONS(1603),
    [anon_sym_set] = ACTIONS(1603),
    [anon_sym_declare] = ACTIONS(1603),
    [anon_sym_public] = ACTIONS(1603),
    [anon_sym_private] = ACTIONS(1603),
    [anon_sym_protected] = ACTIONS(1603),
    [anon_sym_module] = ACTIONS(1603),
    [anon_sym_any] = ACTIONS(1603),
    [anon_sym_number] = ACTIONS(1603),
    [anon_sym_boolean] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1603),
    [anon_sym_symbol] = ACTIONS(1603),
    [anon_sym_interface] = ACTIONS(1603),
    [anon_sym_extends] = ACTIONS(1603),
    [anon_sym_enum] = ACTIONS(1603),
    [sym_readonly] = ACTIONS(1603),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(1093),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_default] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_typeof] = ACTIONS(1095),
    [anon_sym_import] = ACTIONS(1095),
    [anon_sym_var] = ACTIONS(1095),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_const] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_switch] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_await] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_try] = ACTIONS(1095),
    [anon_sym_with] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_continue] = ACTIONS(1095),
    [anon_sym_debugger] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_throw] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_catch] = ACTIONS(1095),
    [anon_sym_finally] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_function] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(1095),
    [anon_sym_delete] = ACTIONS(1095),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_SQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_number] = ACTIONS(1093),
    [sym_this] = ACTIONS(1095),
    [sym_super] = ACTIONS(1095),
    [sym_true] = ACTIONS(1095),
    [sym_false] = ACTIONS(1095),
    [sym_null] = ACTIONS(1095),
    [sym_undefined] = ACTIONS(1095),
    [anon_sym_AT] = ACTIONS(1093),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_abstract] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_interface] = ACTIONS(1095),
    [anon_sym_enum] = ACTIONS(1095),
    [sym_readonly] = ACTIONS(1095),
    [sym__automatic_semicolon] = ACTIONS(1808),
  },
  [508] = {
    [sym__call_signature] = STATE(3456),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_export] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1739),
    [anon_sym_LBRACE] = ACTIONS(860),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1739),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_LBRACK] = ACTIONS(1741),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1743),
    [anon_sym_async] = ACTIONS(1739),
    [anon_sym_function] = ACTIONS(1745),
    [anon_sym_EQ_GT] = ACTIONS(1189),
    [anon_sym_QMARK_DOT] = ACTIONS(1191),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1739),
    [anon_sym_get] = ACTIONS(1739),
    [anon_sym_set] = ACTIONS(1739),
    [anon_sym_declare] = ACTIONS(1739),
    [anon_sym_public] = ACTIONS(1739),
    [anon_sym_private] = ACTIONS(1739),
    [anon_sym_protected] = ACTIONS(1739),
    [anon_sym_module] = ACTIONS(1739),
    [anon_sym_any] = ACTIONS(1739),
    [anon_sym_number] = ACTIONS(1739),
    [anon_sym_boolean] = ACTIONS(1739),
    [anon_sym_string] = ACTIONS(1739),
    [anon_sym_symbol] = ACTIONS(1739),
    [sym_readonly] = ACTIONS(1739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(893),
  },
  [509] = {
    [sym_catch_clause] = STATE(530),
    [sym_finally_clause] = STATE(559),
    [ts_builtin_sym_end] = ACTIONS(1810),
    [sym_identifier] = ACTIONS(1812),
    [anon_sym_export] = ACTIONS(1812),
    [anon_sym_default] = ACTIONS(1812),
    [anon_sym_namespace] = ACTIONS(1812),
    [anon_sym_LBRACE] = ACTIONS(1810),
    [anon_sym_RBRACE] = ACTIONS(1810),
    [anon_sym_type] = ACTIONS(1812),
    [anon_sym_typeof] = ACTIONS(1812),
    [anon_sym_import] = ACTIONS(1812),
    [anon_sym_var] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1812),
    [anon_sym_const] = ACTIONS(1812),
    [anon_sym_BANG] = ACTIONS(1810),
    [anon_sym_else] = ACTIONS(1812),
    [anon_sym_if] = ACTIONS(1812),
    [anon_sym_switch] = ACTIONS(1812),
    [anon_sym_for] = ACTIONS(1812),
    [anon_sym_LPAREN] = ACTIONS(1810),
    [anon_sym_await] = ACTIONS(1812),
    [anon_sym_while] = ACTIONS(1812),
    [anon_sym_do] = ACTIONS(1812),
    [anon_sym_try] = ACTIONS(1812),
    [anon_sym_with] = ACTIONS(1812),
    [anon_sym_break] = ACTIONS(1812),
    [anon_sym_continue] = ACTIONS(1812),
    [anon_sym_debugger] = ACTIONS(1812),
    [anon_sym_return] = ACTIONS(1812),
    [anon_sym_throw] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(1810),
    [anon_sym_case] = ACTIONS(1812),
    [anon_sym_catch] = ACTIONS(1814),
    [anon_sym_finally] = ACTIONS(1816),
    [anon_sym_yield] = ACTIONS(1812),
    [anon_sym_LBRACK] = ACTIONS(1810),
    [anon_sym_LT] = ACTIONS(1810),
    [anon_sym_SLASH] = ACTIONS(1812),
    [anon_sym_class] = ACTIONS(1812),
    [anon_sym_async] = ACTIONS(1812),
    [anon_sym_function] = ACTIONS(1812),
    [anon_sym_new] = ACTIONS(1812),
    [anon_sym_PLUS] = ACTIONS(1812),
    [anon_sym_DASH] = ACTIONS(1812),
    [anon_sym_TILDE] = ACTIONS(1810),
    [anon_sym_void] = ACTIONS(1812),
    [anon_sym_delete] = ACTIONS(1812),
    [anon_sym_PLUS_PLUS] = ACTIONS(1810),
    [anon_sym_DASH_DASH] = ACTIONS(1810),
    [anon_sym_DQUOTE] = ACTIONS(1810),
    [anon_sym_SQUOTE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1810),
    [sym_number] = ACTIONS(1810),
    [sym_this] = ACTIONS(1812),
    [sym_super] = ACTIONS(1812),
    [sym_true] = ACTIONS(1812),
    [sym_false] = ACTIONS(1812),
    [sym_null] = ACTIONS(1812),
    [sym_undefined] = ACTIONS(1812),
    [anon_sym_AT] = ACTIONS(1810),
    [anon_sym_static] = ACTIONS(1812),
    [anon_sym_abstract] = ACTIONS(1812),
    [anon_sym_get] = ACTIONS(1812),
    [anon_sym_set] = ACTIONS(1812),
    [anon_sym_declare] = ACTIONS(1812),
    [anon_sym_public] = ACTIONS(1812),
    [anon_sym_private] = ACTIONS(1812),
    [anon_sym_protected] = ACTIONS(1812),
    [anon_sym_module] = ACTIONS(1812),
    [anon_sym_any] = ACTIONS(1812),
    [anon_sym_number] = ACTIONS(1812),
    [anon_sym_boolean] = ACTIONS(1812),
    [anon_sym_string] = ACTIONS(1812),
    [anon_sym_symbol] = ACTIONS(1812),
    [anon_sym_interface] = ACTIONS(1812),
    [anon_sym_enum] = ACTIONS(1812),
    [sym_readonly] = ACTIONS(1812),
  },
  [510] = {
    [sym__call_signature] = STATE(3454),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_export] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1755),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_type] = ACTIONS(1755),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_RBRACK] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1755),
    [anon_sym_function] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1755),
    [anon_sym_get] = ACTIONS(1755),
    [anon_sym_set] = ACTIONS(1755),
    [anon_sym_declare] = ACTIONS(1755),
    [anon_sym_public] = ACTIONS(1755),
    [anon_sym_private] = ACTIONS(1755),
    [anon_sym_protected] = ACTIONS(1755),
    [anon_sym_module] = ACTIONS(1755),
    [anon_sym_any] = ACTIONS(1755),
    [anon_sym_number] = ACTIONS(1755),
    [anon_sym_boolean] = ACTIONS(1755),
    [anon_sym_string] = ACTIONS(1755),
    [anon_sym_symbol] = ACTIONS(1755),
    [sym_readonly] = ACTIONS(1755),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(1093),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_default] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_typeof] = ACTIONS(1095),
    [anon_sym_import] = ACTIONS(1095),
    [anon_sym_var] = ACTIONS(1095),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_const] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_switch] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_await] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_try] = ACTIONS(1095),
    [anon_sym_with] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_continue] = ACTIONS(1095),
    [anon_sym_debugger] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_throw] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_function] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(1095),
    [anon_sym_delete] = ACTIONS(1095),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_SQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_number] = ACTIONS(1093),
    [sym_this] = ACTIONS(1095),
    [sym_super] = ACTIONS(1095),
    [sym_true] = ACTIONS(1095),
    [sym_false] = ACTIONS(1095),
    [sym_null] = ACTIONS(1095),
    [sym_undefined] = ACTIONS(1095),
    [anon_sym_AT] = ACTIONS(1093),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_abstract] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_interface] = ACTIONS(1095),
    [anon_sym_enum] = ACTIONS(1095),
    [sym_readonly] = ACTIONS(1095),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1093),
    [sym__automatic_semicolon] = ACTIONS(1818),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_default] = ACTIONS(1053),
    [anon_sym_namespace] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1051),
    [anon_sym_COMMA] = ACTIONS(1051),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typeof] = ACTIONS(1053),
    [anon_sym_import] = ACTIONS(1053),
    [anon_sym_var] = ACTIONS(1053),
    [anon_sym_let] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_else] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [anon_sym_switch] = ACTIONS(1053),
    [anon_sym_for] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_await] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [anon_sym_do] = ACTIONS(1053),
    [anon_sym_try] = ACTIONS(1053),
    [anon_sym_with] = ACTIONS(1053),
    [anon_sym_break] = ACTIONS(1053),
    [anon_sym_continue] = ACTIONS(1053),
    [anon_sym_debugger] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_throw] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1053),
    [anon_sym_catch] = ACTIONS(1053),
    [anon_sym_finally] = ACTIONS(1053),
    [anon_sym_yield] = ACTIONS(1053),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1053),
    [anon_sym_class] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1053),
    [anon_sym_new] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_DASH] = ACTIONS(1053),
    [anon_sym_TILDE] = ACTIONS(1051),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_delete] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1051),
    [anon_sym_DASH_DASH] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1051),
    [anon_sym_SQUOTE] = ACTIONS(1051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [sym_number] = ACTIONS(1051),
    [sym_this] = ACTIONS(1053),
    [sym_super] = ACTIONS(1053),
    [sym_true] = ACTIONS(1053),
    [sym_false] = ACTIONS(1053),
    [sym_null] = ACTIONS(1053),
    [sym_undefined] = ACTIONS(1053),
    [anon_sym_AT] = ACTIONS(1051),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_abstract] = ACTIONS(1053),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_interface] = ACTIONS(1053),
    [anon_sym_enum] = ACTIONS(1053),
    [sym_readonly] = ACTIONS(1053),
  },
  [513] = {
    [sym__call_signature] = STATE(3486),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1171),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1781),
    [anon_sym_type] = ACTIONS(1781),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1781),
    [anon_sym_function] = ACTIONS(1820),
    [anon_sym_EQ_GT] = ACTIONS(1173),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1781),
    [anon_sym_get] = ACTIONS(1781),
    [anon_sym_set] = ACTIONS(1781),
    [anon_sym_declare] = ACTIONS(1781),
    [anon_sym_public] = ACTIONS(1781),
    [anon_sym_private] = ACTIONS(1781),
    [anon_sym_protected] = ACTIONS(1781),
    [anon_sym_module] = ACTIONS(1781),
    [anon_sym_any] = ACTIONS(1781),
    [anon_sym_number] = ACTIONS(1781),
    [anon_sym_boolean] = ACTIONS(1781),
    [anon_sym_string] = ACTIONS(1781),
    [anon_sym_symbol] = ACTIONS(1781),
    [sym_readonly] = ACTIONS(1781),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_default] = ACTIONS(1053),
    [anon_sym_namespace] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1051),
    [anon_sym_COMMA] = ACTIONS(1051),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_typeof] = ACTIONS(1053),
    [anon_sym_import] = ACTIONS(1053),
    [anon_sym_var] = ACTIONS(1053),
    [anon_sym_let] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_else] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [anon_sym_switch] = ACTIONS(1053),
    [anon_sym_for] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_await] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [anon_sym_do] = ACTIONS(1053),
    [anon_sym_try] = ACTIONS(1053),
    [anon_sym_with] = ACTIONS(1053),
    [anon_sym_break] = ACTIONS(1053),
    [anon_sym_continue] = ACTIONS(1053),
    [anon_sym_debugger] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_throw] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1053),
    [anon_sym_yield] = ACTIONS(1053),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_SLASH] = ACTIONS(1053),
    [anon_sym_class] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1053),
    [anon_sym_new] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_DASH] = ACTIONS(1053),
    [anon_sym_TILDE] = ACTIONS(1051),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_delete] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1051),
    [anon_sym_DASH_DASH] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1051),
    [anon_sym_SQUOTE] = ACTIONS(1051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [sym_number] = ACTIONS(1051),
    [sym_this] = ACTIONS(1053),
    [sym_super] = ACTIONS(1053),
    [sym_true] = ACTIONS(1053),
    [sym_false] = ACTIONS(1053),
    [sym_null] = ACTIONS(1053),
    [sym_undefined] = ACTIONS(1053),
    [anon_sym_AT] = ACTIONS(1051),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_abstract] = ACTIONS(1053),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_interface] = ACTIONS(1053),
    [anon_sym_enum] = ACTIONS(1053),
    [sym_readonly] = ACTIONS(1053),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1051),
    [sym__automatic_semicolon] = ACTIONS(1051),
  },
  [515] = {
    [ts_builtin_sym_end] = ACTIONS(973),
    [sym_identifier] = ACTIONS(975),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_default] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_type] = ACTIONS(975),
    [anon_sym_typeof] = ACTIONS(975),
    [anon_sym_import] = ACTIONS(975),
    [anon_sym_var] = ACTIONS(975),
    [anon_sym_let] = ACTIONS(975),
    [anon_sym_const] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_else] = ACTIONS(975),
    [anon_sym_if] = ACTIONS(975),
    [anon_sym_switch] = ACTIONS(975),
    [anon_sym_for] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(973),
    [anon_sym_await] = ACTIONS(975),
    [anon_sym_while] = ACTIONS(975),
    [anon_sym_do] = ACTIONS(975),
    [anon_sym_try] = ACTIONS(975),
    [anon_sym_with] = ACTIONS(975),
    [anon_sym_break] = ACTIONS(975),
    [anon_sym_continue] = ACTIONS(975),
    [anon_sym_debugger] = ACTIONS(975),
    [anon_sym_return] = ACTIONS(975),
    [anon_sym_throw] = ACTIONS(975),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_case] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(973),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_class] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_TILDE] = ACTIONS(973),
    [anon_sym_void] = ACTIONS(975),
    [anon_sym_delete] = ACTIONS(975),
    [anon_sym_PLUS_PLUS] = ACTIONS(973),
    [anon_sym_DASH_DASH] = ACTIONS(973),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(973),
    [sym_number] = ACTIONS(973),
    [sym_this] = ACTIONS(975),
    [sym_super] = ACTIONS(975),
    [sym_true] = ACTIONS(975),
    [sym_false] = ACTIONS(975),
    [sym_null] = ACTIONS(975),
    [sym_undefined] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(973),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_abstract] = ACTIONS(975),
    [anon_sym_get] = ACTIONS(975),
    [anon_sym_set] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_any] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_boolean] = ACTIONS(975),
    [anon_sym_string] = ACTIONS(975),
    [anon_sym_symbol] = ACTIONS(975),
    [anon_sym_interface] = ACTIONS(975),
    [anon_sym_enum] = ACTIONS(975),
    [sym_readonly] = ACTIONS(975),
    [anon_sym_PIPE_RBRACE] = ACTIONS(973),
    [sym__automatic_semicolon] = ACTIONS(1822),
  },
  [516] = {
    [ts_builtin_sym_end] = ACTIONS(995),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(997),
    [anon_sym_default] = ACTIONS(997),
    [anon_sym_namespace] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_RBRACE] = ACTIONS(995),
    [anon_sym_type] = ACTIONS(997),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(997),
    [anon_sym_var] = ACTIONS(997),
    [anon_sym_let] = ACTIONS(997),
    [anon_sym_const] = ACTIONS(997),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_else] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_switch] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_await] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_try] = ACTIONS(997),
    [anon_sym_with] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_debugger] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_throw] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_case] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_class] = ACTIONS(997),
    [anon_sym_async] = ACTIONS(997),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_new] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_void] = ACTIONS(997),
    [anon_sym_delete] = ACTIONS(997),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_SQUOTE] = ACTIONS(995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [sym_number] = ACTIONS(995),
    [sym_this] = ACTIONS(997),
    [sym_super] = ACTIONS(997),
    [sym_true] = ACTIONS(997),
    [sym_false] = ACTIONS(997),
    [sym_null] = ACTIONS(997),
    [sym_undefined] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_static] = ACTIONS(997),
    [anon_sym_abstract] = ACTIONS(997),
    [anon_sym_get] = ACTIONS(997),
    [anon_sym_set] = ACTIONS(997),
    [anon_sym_declare] = ACTIONS(997),
    [anon_sym_public] = ACTIONS(997),
    [anon_sym_private] = ACTIONS(997),
    [anon_sym_protected] = ACTIONS(997),
    [anon_sym_module] = ACTIONS(997),
    [anon_sym_any] = ACTIONS(997),
    [anon_sym_number] = ACTIONS(997),
    [anon_sym_boolean] = ACTIONS(997),
    [anon_sym_string] = ACTIONS(997),
    [anon_sym_symbol] = ACTIONS(997),
    [anon_sym_interface] = ACTIONS(997),
    [anon_sym_enum] = ACTIONS(997),
    [sym_readonly] = ACTIONS(997),
    [anon_sym_PIPE_RBRACE] = ACTIONS(995),
    [sym__automatic_semicolon] = ACTIONS(995),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(1093),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_default] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_typeof] = ACTIONS(1095),
    [anon_sym_import] = ACTIONS(1095),
    [anon_sym_var] = ACTIONS(1095),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_const] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_switch] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_await] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_try] = ACTIONS(1095),
    [anon_sym_with] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_continue] = ACTIONS(1095),
    [anon_sym_debugger] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_throw] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_function] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(1095),
    [anon_sym_delete] = ACTIONS(1095),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_SQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_number] = ACTIONS(1093),
    [sym_this] = ACTIONS(1095),
    [sym_super] = ACTIONS(1095),
    [sym_true] = ACTIONS(1095),
    [sym_false] = ACTIONS(1095),
    [sym_null] = ACTIONS(1095),
    [sym_undefined] = ACTIONS(1095),
    [anon_sym_AT] = ACTIONS(1093),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_abstract] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_interface] = ACTIONS(1095),
    [anon_sym_enum] = ACTIONS(1095),
    [sym_readonly] = ACTIONS(1095),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1093),
    [sym__automatic_semicolon] = ACTIONS(1093),
  },
  [518] = {
    [ts_builtin_sym_end] = ACTIONS(1824),
    [sym_identifier] = ACTIONS(1826),
    [anon_sym_export] = ACTIONS(1826),
    [anon_sym_default] = ACTIONS(1826),
    [anon_sym_namespace] = ACTIONS(1826),
    [anon_sym_LBRACE] = ACTIONS(1824),
    [anon_sym_RBRACE] = ACTIONS(1824),
    [anon_sym_type] = ACTIONS(1826),
    [anon_sym_typeof] = ACTIONS(1826),
    [anon_sym_import] = ACTIONS(1826),
    [anon_sym_var] = ACTIONS(1826),
    [anon_sym_let] = ACTIONS(1826),
    [anon_sym_const] = ACTIONS(1826),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_else] = ACTIONS(1826),
    [anon_sym_if] = ACTIONS(1826),
    [anon_sym_switch] = ACTIONS(1826),
    [anon_sym_for] = ACTIONS(1826),
    [anon_sym_LPAREN] = ACTIONS(1824),
    [anon_sym_await] = ACTIONS(1826),
    [anon_sym_while] = ACTIONS(1826),
    [anon_sym_do] = ACTIONS(1826),
    [anon_sym_try] = ACTIONS(1826),
    [anon_sym_with] = ACTIONS(1826),
    [anon_sym_break] = ACTIONS(1826),
    [anon_sym_continue] = ACTIONS(1826),
    [anon_sym_debugger] = ACTIONS(1826),
    [anon_sym_return] = ACTIONS(1826),
    [anon_sym_throw] = ACTIONS(1826),
    [anon_sym_SEMI] = ACTIONS(1824),
    [anon_sym_case] = ACTIONS(1826),
    [anon_sym_yield] = ACTIONS(1826),
    [anon_sym_LBRACK] = ACTIONS(1824),
    [anon_sym_LT] = ACTIONS(1824),
    [anon_sym_SLASH] = ACTIONS(1826),
    [anon_sym_class] = ACTIONS(1826),
    [anon_sym_async] = ACTIONS(1826),
    [anon_sym_function] = ACTIONS(1826),
    [anon_sym_new] = ACTIONS(1826),
    [anon_sym_AMP] = ACTIONS(1828),
    [anon_sym_PIPE] = ACTIONS(1830),
    [anon_sym_PLUS] = ACTIONS(1826),
    [anon_sym_DASH] = ACTIONS(1826),
    [anon_sym_TILDE] = ACTIONS(1824),
    [anon_sym_void] = ACTIONS(1826),
    [anon_sym_delete] = ACTIONS(1826),
    [anon_sym_PLUS_PLUS] = ACTIONS(1824),
    [anon_sym_DASH_DASH] = ACTIONS(1824),
    [anon_sym_DQUOTE] = ACTIONS(1824),
    [anon_sym_SQUOTE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [sym_number] = ACTIONS(1824),
    [sym_this] = ACTIONS(1826),
    [sym_super] = ACTIONS(1826),
    [sym_true] = ACTIONS(1826),
    [sym_false] = ACTIONS(1826),
    [sym_null] = ACTIONS(1826),
    [sym_undefined] = ACTIONS(1826),
    [anon_sym_AT] = ACTIONS(1824),
    [anon_sym_static] = ACTIONS(1826),
    [anon_sym_abstract] = ACTIONS(1826),
    [anon_sym_get] = ACTIONS(1826),
    [anon_sym_set] = ACTIONS(1826),
    [anon_sym_declare] = ACTIONS(1826),
    [anon_sym_public] = ACTIONS(1826),
    [anon_sym_private] = ACTIONS(1826),
    [anon_sym_protected] = ACTIONS(1826),
    [anon_sym_module] = ACTIONS(1826),
    [anon_sym_any] = ACTIONS(1826),
    [anon_sym_number] = ACTIONS(1826),
    [anon_sym_boolean] = ACTIONS(1826),
    [anon_sym_string] = ACTIONS(1826),
    [anon_sym_symbol] = ACTIONS(1826),
    [anon_sym_interface] = ACTIONS(1826),
    [anon_sym_extends] = ACTIONS(1832),
    [anon_sym_enum] = ACTIONS(1826),
    [sym_readonly] = ACTIONS(1826),
  },
  [519] = {
    [ts_builtin_sym_end] = ACTIONS(1834),
    [sym_identifier] = ACTIONS(1836),
    [anon_sym_export] = ACTIONS(1836),
    [anon_sym_default] = ACTIONS(1836),
    [anon_sym_namespace] = ACTIONS(1836),
    [anon_sym_LBRACE] = ACTIONS(1834),
    [anon_sym_RBRACE] = ACTIONS(1834),
    [anon_sym_type] = ACTIONS(1836),
    [anon_sym_typeof] = ACTIONS(1836),
    [anon_sym_import] = ACTIONS(1836),
    [anon_sym_var] = ACTIONS(1836),
    [anon_sym_let] = ACTIONS(1836),
    [anon_sym_const] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1834),
    [anon_sym_else] = ACTIONS(1836),
    [anon_sym_if] = ACTIONS(1836),
    [anon_sym_switch] = ACTIONS(1836),
    [anon_sym_for] = ACTIONS(1836),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_await] = ACTIONS(1836),
    [anon_sym_while] = ACTIONS(1836),
    [anon_sym_do] = ACTIONS(1836),
    [anon_sym_try] = ACTIONS(1836),
    [anon_sym_with] = ACTIONS(1836),
    [anon_sym_break] = ACTIONS(1836),
    [anon_sym_continue] = ACTIONS(1836),
    [anon_sym_debugger] = ACTIONS(1836),
    [anon_sym_return] = ACTIONS(1836),
    [anon_sym_throw] = ACTIONS(1836),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_case] = ACTIONS(1836),
    [anon_sym_yield] = ACTIONS(1836),
    [anon_sym_LBRACK] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1834),
    [anon_sym_SLASH] = ACTIONS(1836),
    [anon_sym_class] = ACTIONS(1836),
    [anon_sym_async] = ACTIONS(1836),
    [anon_sym_function] = ACTIONS(1836),
    [anon_sym_new] = ACTIONS(1836),
    [anon_sym_AMP] = ACTIONS(1828),
    [anon_sym_PIPE] = ACTIONS(1830),
    [anon_sym_PLUS] = ACTIONS(1836),
    [anon_sym_DASH] = ACTIONS(1836),
    [anon_sym_TILDE] = ACTIONS(1834),
    [anon_sym_void] = ACTIONS(1836),
    [anon_sym_delete] = ACTIONS(1836),
    [anon_sym_PLUS_PLUS] = ACTIONS(1834),
    [anon_sym_DASH_DASH] = ACTIONS(1834),
    [anon_sym_DQUOTE] = ACTIONS(1834),
    [anon_sym_SQUOTE] = ACTIONS(1834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [sym_number] = ACTIONS(1834),
    [sym_this] = ACTIONS(1836),
    [sym_super] = ACTIONS(1836),
    [sym_true] = ACTIONS(1836),
    [sym_false] = ACTIONS(1836),
    [sym_null] = ACTIONS(1836),
    [sym_undefined] = ACTIONS(1836),
    [anon_sym_AT] = ACTIONS(1834),
    [anon_sym_static] = ACTIONS(1836),
    [anon_sym_abstract] = ACTIONS(1836),
    [anon_sym_get] = ACTIONS(1836),
    [anon_sym_set] = ACTIONS(1836),
    [anon_sym_declare] = ACTIONS(1836),
    [anon_sym_public] = ACTIONS(1836),
    [anon_sym_private] = ACTIONS(1836),
    [anon_sym_protected] = ACTIONS(1836),
    [anon_sym_module] = ACTIONS(1836),
    [anon_sym_any] = ACTIONS(1836),
    [anon_sym_number] = ACTIONS(1836),
    [anon_sym_boolean] = ACTIONS(1836),
    [anon_sym_string] = ACTIONS(1836),
    [anon_sym_symbol] = ACTIONS(1836),
    [anon_sym_interface] = ACTIONS(1836),
    [anon_sym_extends] = ACTIONS(1832),
    [anon_sym_enum] = ACTIONS(1836),
    [sym_readonly] = ACTIONS(1836),
  },
  [520] = {
    [sym__call_signature] = STATE(3486),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1171),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1781),
    [anon_sym_type] = ACTIONS(1781),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1781),
    [anon_sym_function] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(1173),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1781),
    [anon_sym_get] = ACTIONS(1781),
    [anon_sym_set] = ACTIONS(1781),
    [anon_sym_declare] = ACTIONS(1781),
    [anon_sym_public] = ACTIONS(1781),
    [anon_sym_private] = ACTIONS(1781),
    [anon_sym_protected] = ACTIONS(1781),
    [anon_sym_module] = ACTIONS(1781),
    [anon_sym_any] = ACTIONS(1781),
    [anon_sym_number] = ACTIONS(1781),
    [anon_sym_boolean] = ACTIONS(1781),
    [anon_sym_string] = ACTIONS(1781),
    [anon_sym_symbol] = ACTIONS(1781),
    [sym_readonly] = ACTIONS(1781),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(1145),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(1147),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_type] = ACTIONS(1147),
    [anon_sym_typeof] = ACTIONS(1147),
    [anon_sym_import] = ACTIONS(1147),
    [anon_sym_var] = ACTIONS(1147),
    [anon_sym_let] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1145),
    [anon_sym_else] = ACTIONS(1147),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1147),
    [anon_sym_do] = ACTIONS(1147),
    [anon_sym_try] = ACTIONS(1147),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_break] = ACTIONS(1147),
    [anon_sym_continue] = ACTIONS(1147),
    [anon_sym_debugger] = ACTIONS(1147),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_throw] = ACTIONS(1147),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_case] = ACTIONS(1147),
    [anon_sym_yield] = ACTIONS(1147),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_class] = ACTIONS(1147),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(1147),
    [anon_sym_new] = ACTIONS(1147),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1145),
    [anon_sym_void] = ACTIONS(1147),
    [anon_sym_delete] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1145),
    [anon_sym_SQUOTE] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [sym_number] = ACTIONS(1145),
    [sym_this] = ACTIONS(1147),
    [sym_super] = ACTIONS(1147),
    [sym_true] = ACTIONS(1147),
    [sym_false] = ACTIONS(1147),
    [sym_null] = ACTIONS(1147),
    [sym_undefined] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(1145),
    [anon_sym_static] = ACTIONS(1147),
    [anon_sym_abstract] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(1147),
    [anon_sym_set] = ACTIONS(1147),
    [anon_sym_declare] = ACTIONS(1147),
    [anon_sym_public] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(1147),
    [anon_sym_protected] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(1147),
    [anon_sym_any] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(1147),
    [anon_sym_interface] = ACTIONS(1147),
    [anon_sym_enum] = ACTIONS(1147),
    [sym_readonly] = ACTIONS(1147),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1145),
    [sym__automatic_semicolon] = ACTIONS(1145),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(1093),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_default] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_typeof] = ACTIONS(1095),
    [anon_sym_import] = ACTIONS(1095),
    [anon_sym_var] = ACTIONS(1095),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_const] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_switch] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_await] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_try] = ACTIONS(1095),
    [anon_sym_with] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_continue] = ACTIONS(1095),
    [anon_sym_debugger] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_throw] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_catch] = ACTIONS(1095),
    [anon_sym_finally] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_function] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(1095),
    [anon_sym_delete] = ACTIONS(1095),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_SQUOTE] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [sym_number] = ACTIONS(1093),
    [sym_this] = ACTIONS(1095),
    [sym_super] = ACTIONS(1095),
    [sym_true] = ACTIONS(1095),
    [sym_false] = ACTIONS(1095),
    [sym_null] = ACTIONS(1095),
    [sym_undefined] = ACTIONS(1095),
    [anon_sym_AT] = ACTIONS(1093),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_abstract] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_interface] = ACTIONS(1095),
    [anon_sym_enum] = ACTIONS(1095),
    [sym_readonly] = ACTIONS(1095),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(1838),
    [sym_identifier] = ACTIONS(1840),
    [anon_sym_export] = ACTIONS(1840),
    [anon_sym_default] = ACTIONS(1840),
    [anon_sym_namespace] = ACTIONS(1840),
    [anon_sym_LBRACE] = ACTIONS(1838),
    [anon_sym_RBRACE] = ACTIONS(1838),
    [anon_sym_type] = ACTIONS(1840),
    [anon_sym_typeof] = ACTIONS(1840),
    [anon_sym_import] = ACTIONS(1840),
    [anon_sym_var] = ACTIONS(1840),
    [anon_sym_let] = ACTIONS(1840),
    [anon_sym_const] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_else] = ACTIONS(1840),
    [anon_sym_if] = ACTIONS(1840),
    [anon_sym_switch] = ACTIONS(1840),
    [anon_sym_for] = ACTIONS(1840),
    [anon_sym_LPAREN] = ACTIONS(1838),
    [anon_sym_await] = ACTIONS(1840),
    [anon_sym_while] = ACTIONS(1840),
    [anon_sym_do] = ACTIONS(1840),
    [anon_sym_try] = ACTIONS(1840),
    [anon_sym_with] = ACTIONS(1840),
    [anon_sym_break] = ACTIONS(1840),
    [anon_sym_continue] = ACTIONS(1840),
    [anon_sym_debugger] = ACTIONS(1840),
    [anon_sym_return] = ACTIONS(1840),
    [anon_sym_throw] = ACTIONS(1840),
    [anon_sym_SEMI] = ACTIONS(1838),
    [anon_sym_case] = ACTIONS(1840),
    [anon_sym_yield] = ACTIONS(1840),
    [anon_sym_LBRACK] = ACTIONS(1838),
    [anon_sym_LT] = ACTIONS(1838),
    [anon_sym_SLASH] = ACTIONS(1840),
    [anon_sym_class] = ACTIONS(1840),
    [anon_sym_async] = ACTIONS(1840),
    [anon_sym_function] = ACTIONS(1840),
    [anon_sym_new] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1828),
    [anon_sym_PIPE] = ACTIONS(1830),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_DASH] = ACTIONS(1840),
    [anon_sym_TILDE] = ACTIONS(1838),
    [anon_sym_void] = ACTIONS(1840),
    [anon_sym_delete] = ACTIONS(1840),
    [anon_sym_PLUS_PLUS] = ACTIONS(1838),
    [anon_sym_DASH_DASH] = ACTIONS(1838),
    [anon_sym_DQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1838),
    [sym_number] = ACTIONS(1838),
    [sym_this] = ACTIONS(1840),
    [sym_super] = ACTIONS(1840),
    [sym_true] = ACTIONS(1840),
    [sym_false] = ACTIONS(1840),
    [sym_null] = ACTIONS(1840),
    [sym_undefined] = ACTIONS(1840),
    [anon_sym_AT] = ACTIONS(1838),
    [anon_sym_static] = ACTIONS(1840),
    [anon_sym_abstract] = ACTIONS(1840),
    [anon_sym_get] = ACTIONS(1840),
    [anon_sym_set] = ACTIONS(1840),
    [anon_sym_declare] = ACTIONS(1840),
    [anon_sym_public] = ACTIONS(1840),
    [anon_sym_private] = ACTIONS(1840),
    [anon_sym_protected] = ACTIONS(1840),
    [anon_sym_module] = ACTIONS(1840),
    [anon_sym_any] = ACTIONS(1840),
    [anon_sym_number] = ACTIONS(1840),
    [anon_sym_boolean] = ACTIONS(1840),
    [anon_sym_string] = ACTIONS(1840),
    [anon_sym_symbol] = ACTIONS(1840),
    [anon_sym_interface] = ACTIONS(1840),
    [anon_sym_extends] = ACTIONS(1840),
    [anon_sym_enum] = ACTIONS(1840),
    [sym_readonly] = ACTIONS(1840),
  },
  [524] = {
    [sym__call_signature] = STATE(3486),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1781),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1171),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1781),
    [anon_sym_type] = ACTIONS(1781),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1781),
    [anon_sym_function] = ACTIONS(1842),
    [anon_sym_EQ_GT] = ACTIONS(1173),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1781),
    [anon_sym_get] = ACTIONS(1781),
    [anon_sym_set] = ACTIONS(1781),
    [anon_sym_declare] = ACTIONS(1781),
    [anon_sym_public] = ACTIONS(1781),
    [anon_sym_private] = ACTIONS(1781),
    [anon_sym_protected] = ACTIONS(1781),
    [anon_sym_module] = ACTIONS(1781),
    [anon_sym_any] = ACTIONS(1781),
    [anon_sym_number] = ACTIONS(1781),
    [anon_sym_boolean] = ACTIONS(1781),
    [anon_sym_string] = ACTIONS(1781),
    [anon_sym_symbol] = ACTIONS(1781),
    [sym_readonly] = ACTIONS(1781),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(1844),
    [sym_identifier] = ACTIONS(1846),
    [anon_sym_export] = ACTIONS(1846),
    [anon_sym_default] = ACTIONS(1846),
    [anon_sym_namespace] = ACTIONS(1846),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_RBRACE] = ACTIONS(1844),
    [anon_sym_type] = ACTIONS(1846),
    [anon_sym_typeof] = ACTIONS(1846),
    [anon_sym_import] = ACTIONS(1846),
    [anon_sym_var] = ACTIONS(1846),
    [anon_sym_let] = ACTIONS(1846),
    [anon_sym_const] = ACTIONS(1846),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_else] = ACTIONS(1846),
    [anon_sym_if] = ACTIONS(1846),
    [anon_sym_switch] = ACTIONS(1846),
    [anon_sym_for] = ACTIONS(1846),
    [anon_sym_LPAREN] = ACTIONS(1844),
    [anon_sym_await] = ACTIONS(1846),
    [anon_sym_while] = ACTIONS(1846),
    [anon_sym_do] = ACTIONS(1846),
    [anon_sym_try] = ACTIONS(1846),
    [anon_sym_with] = ACTIONS(1846),
    [anon_sym_break] = ACTIONS(1846),
    [anon_sym_continue] = ACTIONS(1846),
    [anon_sym_debugger] = ACTIONS(1846),
    [anon_sym_return] = ACTIONS(1846),
    [anon_sym_throw] = ACTIONS(1846),
    [anon_sym_SEMI] = ACTIONS(1844),
    [anon_sym_case] = ACTIONS(1846),
    [anon_sym_yield] = ACTIONS(1846),
    [anon_sym_LBRACK] = ACTIONS(1844),
    [anon_sym_LT] = ACTIONS(1844),
    [anon_sym_SLASH] = ACTIONS(1846),
    [anon_sym_class] = ACTIONS(1846),
    [anon_sym_async] = ACTIONS(1846),
    [anon_sym_function] = ACTIONS(1846),
    [anon_sym_new] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1828),
    [anon_sym_PIPE] = ACTIONS(1830),
    [anon_sym_PLUS] = ACTIONS(1846),
    [anon_sym_DASH] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1844),
    [anon_sym_void] = ACTIONS(1846),
    [anon_sym_delete] = ACTIONS(1846),
    [anon_sym_PLUS_PLUS] = ACTIONS(1844),
    [anon_sym_DASH_DASH] = ACTIONS(1844),
    [anon_sym_DQUOTE] = ACTIONS(1844),
    [anon_sym_SQUOTE] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1844),
    [sym_number] = ACTIONS(1844),
    [sym_this] = ACTIONS(1846),
    [sym_super] = ACTIONS(1846),
    [sym_true] = ACTIONS(1846),
    [sym_false] = ACTIONS(1846),
    [sym_null] = ACTIONS(1846),
    [sym_undefined] = ACTIONS(1846),
    [anon_sym_AT] = ACTIONS(1844),
    [anon_sym_static] = ACTIONS(1846),
    [anon_sym_abstract] = ACTIONS(1846),
    [anon_sym_get] = ACTIONS(1846),
    [anon_sym_set] = ACTIONS(1846),
    [anon_sym_declare] = ACTIONS(1846),
    [anon_sym_public] = ACTIONS(1846),
    [anon_sym_private] = ACTIONS(1846),
    [anon_sym_protected] = ACTIONS(1846),
    [anon_sym_module] = ACTIONS(1846),
    [anon_sym_any] = ACTIONS(1846),
    [anon_sym_number] = ACTIONS(1846),
    [anon_sym_boolean] = ACTIONS(1846),
    [anon_sym_string] = ACTIONS(1846),
    [anon_sym_symbol] = ACTIONS(1846),
    [anon_sym_interface] = ACTIONS(1846),
    [anon_sym_extends] = ACTIONS(1832),
    [anon_sym_enum] = ACTIONS(1846),
    [sym_readonly] = ACTIONS(1846),
  },
  [526] = {
    [sym__call_signature] = STATE(3454),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_export] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1755),
    [anon_sym_type] = ACTIONS(1755),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(1848),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_RBRACK] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1755),
    [anon_sym_function] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1755),
    [anon_sym_get] = ACTIONS(1755),
    [anon_sym_set] = ACTIONS(1755),
    [anon_sym_declare] = ACTIONS(1755),
    [anon_sym_public] = ACTIONS(1755),
    [anon_sym_private] = ACTIONS(1755),
    [anon_sym_protected] = ACTIONS(1755),
    [anon_sym_module] = ACTIONS(1755),
    [anon_sym_any] = ACTIONS(1755),
    [anon_sym_number] = ACTIONS(1755),
    [anon_sym_boolean] = ACTIONS(1755),
    [anon_sym_string] = ACTIONS(1755),
    [anon_sym_symbol] = ACTIONS(1755),
    [sym_readonly] = ACTIONS(1755),
  },
  [527] = {
    [sym__call_signature] = STATE(3454),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_export] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1755),
    [anon_sym_type] = ACTIONS(1755),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(1792),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_RBRACK] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1755),
    [anon_sym_function] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1755),
    [anon_sym_get] = ACTIONS(1755),
    [anon_sym_set] = ACTIONS(1755),
    [anon_sym_declare] = ACTIONS(1755),
    [anon_sym_public] = ACTIONS(1755),
    [anon_sym_private] = ACTIONS(1755),
    [anon_sym_protected] = ACTIONS(1755),
    [anon_sym_module] = ACTIONS(1755),
    [anon_sym_any] = ACTIONS(1755),
    [anon_sym_number] = ACTIONS(1755),
    [anon_sym_boolean] = ACTIONS(1755),
    [anon_sym_string] = ACTIONS(1755),
    [anon_sym_symbol] = ACTIONS(1755),
    [sym_readonly] = ACTIONS(1755),
  },
  [528] = {
    [sym__call_signature] = STATE(3454),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_export] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1755),
    [anon_sym_type] = ACTIONS(1755),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(1770),
    [anon_sym_of] = ACTIONS(1773),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1755),
    [anon_sym_function] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1755),
    [anon_sym_get] = ACTIONS(1755),
    [anon_sym_set] = ACTIONS(1755),
    [anon_sym_declare] = ACTIONS(1755),
    [anon_sym_public] = ACTIONS(1755),
    [anon_sym_private] = ACTIONS(1755),
    [anon_sym_protected] = ACTIONS(1755),
    [anon_sym_module] = ACTIONS(1755),
    [anon_sym_any] = ACTIONS(1755),
    [anon_sym_number] = ACTIONS(1755),
    [anon_sym_boolean] = ACTIONS(1755),
    [anon_sym_string] = ACTIONS(1755),
    [anon_sym_symbol] = ACTIONS(1755),
    [sym_readonly] = ACTIONS(1755),
  },
  [529] = {
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_export] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(857),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1731),
    [anon_sym_COMMA] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(864),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(860),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1729),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1789),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_this] = ACTIONS(1729),
    [anon_sym_static] = ACTIONS(1729),
    [anon_sym_get] = ACTIONS(1729),
    [anon_sym_set] = ACTIONS(1729),
    [anon_sym_declare] = ACTIONS(1729),
    [anon_sym_public] = ACTIONS(1729),
    [anon_sym_private] = ACTIONS(1729),
    [anon_sym_protected] = ACTIONS(1729),
    [anon_sym_module] = ACTIONS(1729),
    [anon_sym_any] = ACTIONS(1729),
    [anon_sym_number] = ACTIONS(1729),
    [anon_sym_boolean] = ACTIONS(1729),
    [anon_sym_string] = ACTIONS(1729),
    [anon_sym_symbol] = ACTIONS(1729),
    [sym_readonly] = ACTIONS(1729),
  },
  [530] = {
    [sym_finally_clause] = STATE(620),
    [ts_builtin_sym_end] = ACTIONS(1850),
    [sym_identifier] = ACTIONS(1852),
    [anon_sym_export] = ACTIONS(1852),
    [anon_sym_default] = ACTIONS(1852),
    [anon_sym_namespace] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(1850),
    [anon_sym_RBRACE] = ACTIONS(1850),
    [anon_sym_type] = ACTIONS(1852),
    [anon_sym_typeof] = ACTIONS(1852),
    [anon_sym_import] = ACTIONS(1852),
    [anon_sym_var] = ACTIONS(1852),
    [anon_sym_let] = ACTIONS(1852),
    [anon_sym_const] = ACTIONS(1852),
    [anon_sym_BANG] = ACTIONS(1850),
    [anon_sym_else] = ACTIONS(1852),
    [anon_sym_if] = ACTIONS(1852),
    [anon_sym_switch] = ACTIONS(1852),
    [anon_sym_for] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1850),
    [anon_sym_await] = ACTIONS(1852),
    [anon_sym_while] = ACTIONS(1852),
    [anon_sym_do] = ACTIONS(1852),
    [anon_sym_try] = ACTIONS(1852),
    [anon_sym_with] = ACTIONS(1852),
    [anon_sym_break] = ACTIONS(1852),
    [anon_sym_continue] = ACTIONS(1852),
    [anon_sym_debugger] = ACTIONS(1852),
    [anon_sym_return] = ACTIONS(1852),
    [anon_sym_throw] = ACTIONS(1852),
    [anon_sym_SEMI] = ACTIONS(1850),
    [anon_sym_case] = ACTIONS(1852),
    [anon_sym_finally] = ACTIONS(1816),
    [anon_sym_yield] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1850),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_SLASH] = ACTIONS(1852),
    [anon_sym_class] = ACTIONS(1852),
    [anon_sym_async] = ACTIONS(1852),
    [anon_sym_function] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1852),
    [anon_sym_PLUS] = ACTIONS(1852),
    [anon_sym_DASH] = ACTIONS(1852),
    [anon_sym_TILDE] = ACTIONS(1850),
    [anon_sym_void] = ACTIONS(1852),
    [anon_sym_delete] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1850),
    [anon_sym_DASH_DASH] = ACTIONS(1850),
    [anon_sym_DQUOTE] = ACTIONS(1850),
    [anon_sym_SQUOTE] = ACTIONS(1850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1850),
    [sym_number] = ACTIONS(1850),
    [sym_this] = ACTIONS(1852),
    [sym_super] = ACTIONS(1852),
    [sym_true] = ACTIONS(1852),
    [sym_false] = ACTIONS(1852),
    [sym_null] = ACTIONS(1852),
    [sym_undefined] = ACTIONS(1852),
    [anon_sym_AT] = ACTIONS(1850),
    [anon_sym_static] = ACTIONS(1852),
    [anon_sym_abstract] = ACTIONS(1852),
    [anon_sym_get] = ACTIONS(1852),
    [anon_sym_set] = ACTIONS(1852),
    [anon_sym_declare] = ACTIONS(1852),
    [anon_sym_public] = ACTIONS(1852),
    [anon_sym_private] = ACTIONS(1852),
    [anon_sym_protected] = ACTIONS(1852),
    [anon_sym_module] = ACTIONS(1852),
    [anon_sym_any] = ACTIONS(1852),
    [anon_sym_number] = ACTIONS(1852),
    [anon_sym_boolean] = ACTIONS(1852),
    [anon_sym_string] = ACTIONS(1852),
    [anon_sym_symbol] = ACTIONS(1852),
    [anon_sym_interface] = ACTIONS(1852),
    [anon_sym_enum] = ACTIONS(1852),
    [sym_readonly] = ACTIONS(1852),
  },
  [531] = {
    [sym__call_signature] = STATE(3454),
    [sym_formal_parameters] = STATE(2519),
    [sym_type_parameters] = STATE(3215),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_export] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1755),
    [anon_sym_type] = ACTIONS(1755),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(1854),
    [anon_sym_of] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(1750),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1755),
    [anon_sym_function] = ACTIONS(1701),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(1755),
    [anon_sym_get] = ACTIONS(1755),
    [anon_sym_set] = ACTIONS(1755),
    [anon_sym_declare] = ACTIONS(1755),
    [anon_sym_public] = ACTIONS(1755),
    [anon_sym_private] = ACTIONS(1755),
    [anon_sym_protected] = ACTIONS(1755),
    [anon_sym_module] = ACTIONS(1755),
    [anon_sym_any] = ACTIONS(1755),
    [anon_sym_number] = ACTIONS(1755),
    [anon_sym_boolean] = ACTIONS(1755),
    [anon_sym_string] = ACTIONS(1755),
    [anon_sym_symbol] = ACTIONS(1755),
    [sym_readonly] = ACTIONS(1755),
  },
  [532] = {
    [sym_statement_block] = STATE(583),
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym_identifier] = ACTIONS(985),
    [anon_sym_export] = ACTIONS(985),
    [anon_sym_default] = ACTIONS(985),
    [anon_sym_namespace] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_type] = ACTIONS(985),
    [anon_sym_typeof] = ACTIONS(985),
    [anon_sym_import] = ACTIONS(985),
    [anon_sym_var] = ACTIONS(985),
    [anon_sym_let] = ACTIONS(985),
    [anon_sym_const] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(983),
    [anon_sym_else] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_switch] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_do] = ACTIONS(985),
    [anon_sym_try] = ACTIONS(985),
    [anon_sym_with] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_continue] = ACTIONS(985),
    [anon_sym_debugger] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_throw] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_case] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_DOT] = ACTIONS(1861),
    [anon_sym_class] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(985),
    [anon_sym_new] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(983),
    [anon_sym_void] = ACTIONS(985),
    [anon_sym_delete] = ACTIONS(985),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [sym_number] = ACTIONS(983),
    [sym_this] = ACTIONS(985),
    [sym_super] = ACTIONS(985),
    [sym_true] = ACTIONS(985),
    [sym_false] = ACTIONS(985),
    [sym_null] = ACTIONS(985),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(983),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_abstract] = ACTIONS(985),
    [anon_sym_get] = ACTIONS(985),
    [anon_sym_set] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(985),
    [anon_sym_public] = ACTIONS(985),
    [anon_sym_private] = ACTIONS(985),
    [anon_sym_protected] = ACTIONS(985),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_any] = ACTIONS(985),
    [anon_sym_number] = ACTIONS(985),
    [anon_sym_boolean] = ACTIONS(985),
    [anon_sym_string] = ACTIONS(985),
    [anon_sym_symbol] = ACTIONS(985),
    [anon_sym_interface] = ACTIONS(985),
    [anon_sym_enum] = ACTIONS(985),
    [sym_readonly] = ACTIONS(985),
  },
  [533] = {
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_export] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(857),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_namespace] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1731),
    [anon_sym_COMMA] = ACTIONS(864),
    [anon_sym_type] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(864),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_COLON] = ACTIONS(864),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(860),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1729),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1789),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym_this] = ACTIONS(1729),
    [anon_sym_static] = ACTIONS(1729),
    [anon_sym_get] = ACTIONS(1729),
    [anon_sym_set] = ACTIONS(1729),
    [anon_sym_declare] = ACTIONS(1729),
    [anon_sym_public] = ACTIONS(1729),
    [anon_sym_private] = ACTIONS(1729),
    [anon_sym_protected] = ACTIONS(1729),
    [anon_sym_module] = ACTIONS(1729),
    [anon_sym_any] = ACTIONS(1729),
    [anon_sym_number] = ACTIONS(1729),
    [anon_sym_boolean] = ACTIONS(1729),
    [anon_sym_string] = ACTIONS(1729),
    [anon_sym_symbol] = ACTIONS(1729),
    [sym_readonly] = ACTIONS(1729),
  },
  [534] = {
    [ts_builtin_sym_end] = ACTIONS(1863),
    [sym_identifier] = ACTIONS(1865),
    [anon_sym_export] = ACTIONS(1865),
    [anon_sym_default] = ACTIONS(1865),
    [anon_sym_namespace] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1863),
    [anon_sym_RBRACE] = ACTIONS(1863),
    [anon_sym_type] = ACTIONS(1865),
    [anon_sym_typeof] = ACTIONS(1865),
    [anon_sym_import] = ACTIONS(1865),
    [anon_sym_var] = ACTIONS(1865),
    [anon_sym_let] = ACTIONS(1865),
    [anon_sym_const] = ACTIONS(1865),
    [anon_sym_BANG] = ACTIONS(1863),
    [anon_sym_else] = ACTIONS(1865),
    [anon_sym_if] = ACTIONS(1865),
    [anon_sym_switch] = ACTIONS(1865),
    [anon_sym_for] = ACTIONS(1865),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_await] = ACTIONS(1865),
    [anon_sym_while] = ACTIONS(1865),
    [anon_sym_do] = ACTIONS(1865),
    [anon_sym_try] = ACTIONS(1865),
    [anon_sym_with] = ACTIONS(1865),
    [anon_sym_break] = ACTIONS(1865),
    [anon_sym_continue] = ACTIONS(1865),
    [anon_sym_debugger] = ACTIONS(1865),
    [anon_sym_return] = ACTIONS(1865),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1863),
    [anon_sym_case] = ACTIONS(1865),
    [anon_sym_finally] = ACTIONS(1865),
    [anon_sym_yield] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_SLASH] = ACTIONS(1865),
    [anon_sym_class] = ACTIONS(1865),
    [anon_sym_async] = ACTIONS(1865),
    [anon_sym_function] = ACTIONS(1865),
    [anon_sym_new] = ACTIONS(1865),
    [anon_sym_PLUS] = ACTIONS(1865),
    [anon_sym_DASH] = ACTIONS(1865),
    [anon_sym_TILDE] = ACTIONS(1863),
    [anon_sym_void] = ACTIONS(1865),
    [anon_sym_delete] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1863),
    [anon_sym_DASH_DASH] = ACTIONS(1863),
    [anon_sym_DQUOTE] = ACTIONS(1863),
    [anon_sym_SQUOTE] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1863),
    [sym_number] = ACTIONS(1863),
    [sym_this] = ACTIONS(1865),
    [sym_super] = ACTIONS(1865),
    [sym_true] = ACTIONS(1865),
    [sym_false] = ACTIONS(1865),
    [sym_null] = ACTIONS(1865),
    [sym_undefined] = ACTIONS(1865),
    [anon_sym_AT] = ACTIONS(1863),
    [anon_sym_static] = ACTIONS(1865),
    [anon_sym_abstract] = ACTIONS(1865),
    [anon_sym_get] = ACTIONS(1865),
    [anon_sym_set] = ACTIONS(1865),
    [anon_sym_declare] = ACTIONS(1865),
    [anon_sym_public] = ACTIONS(1865),
    [anon_sym_private] = ACTIONS(1865),
    [anon_sym_protected] = ACTIONS(1865),
    [anon_sym_module] = ACTIONS(1865),
    [anon_sym_any] = ACTIONS(1865),
    [anon_sym_number] = ACTIONS(1865),
    [anon_sym_boolean] = ACTIONS(1865),
    [anon_sym_string] = ACTIONS(1865),
    [anon_sym_symbol] = ACTIONS(1865),
    [anon_sym_interface] = ACTIONS(1865),
    [anon_sym_enum] = ACTIONS(1865),
    [sym_readonly] = ACTIONS(1865),
  },
  [535] = {
    [ts_builtin_sym_end] = ACTIONS(1135),
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_export] = ACTIONS(1137),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1137),
    [anon_sym_typeof] = ACTIONS(1137),
    [anon_sym_import] = ACTIONS(1137),
    [anon_sym_var] = ACTIONS(1137),
    [anon_sym_let] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_await] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_try] = ACTIONS(1137),
    [anon_sym_with] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_debugger] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_throw] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_yield] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_class] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1137),
    [anon_sym_function] = ACTIONS(1137),
    [anon_sym_new] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_void] = ACTIONS(1137),
    [anon_sym_delete] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1135),
    [sym_this] = ACTIONS(1137),
    [sym_super] = ACTIONS(1137),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [sym_null] = ACTIONS(1137),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_abstract] = ACTIONS(1137),
    [anon_sym_get] = ACTIONS(1137),
    [anon_sym_set] = ACTIONS(1137),
    [anon_sym_declare] = ACTIONS(1137),
    [anon_sym_public] = ACTIONS(1137),
    [anon_sym_private] = ACTIONS(1137),
    [anon_sym_protected] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1137),
    [anon_sym_any] = ACTIONS(1137),
    [anon_sym_number] = ACTIONS(1137),
    [anon_sym_boolean] = ACTIONS(1137),
    [anon_sym_string] = ACTIONS(1137),
    [anon_sym_symbol] = ACTIONS(1137),
    [anon_sym_interface] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [sym_readonly] = ACTIONS(1137),
    [sym__automatic_semicolon] = ACTIONS(1143),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(1125),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_namespace] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_RBRACE] = ACTIONS(1125),
    [anon_sym_type] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1127),
    [anon_sym_import] = ACTIONS(1127),
    [anon_sym_var] = ACTIONS(1127),
    [anon_sym_let] = ACTIONS(1127),
    [anon_sym_const] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(1125),
    [anon_sym_else] = ACTIONS(1127),
    [anon_sym_if] = ACTIONS(1127),
    [anon_sym_switch] = ACTIONS(1127),
    [anon_sym_for] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(1125),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1127),
    [anon_sym_do] = ACTIONS(1127),
    [anon_sym_try] = ACTIONS(1127),
    [anon_sym_with] = ACTIONS(1127),
    [anon_sym_break] = ACTIONS(1127),
    [anon_sym_continue] = ACTIONS(1127),
    [anon_sym_debugger] = ACTIONS(1127),
    [anon_sym_return] = ACTIONS(1127),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1127),
    [anon_sym_yield] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1127),
    [anon_sym_class] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1127),
    [anon_sym_function] = ACTIONS(1127),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_TILDE] = ACTIONS(1125),
    [anon_sym_void] = ACTIONS(1127),
    [anon_sym_delete] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1125),
    [anon_sym_DASH_DASH] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [sym_number] = ACTIONS(1125),
    [sym_this] = ACTIONS(1127),
    [sym_super] = ACTIONS(1127),
    [sym_true] = ACTIONS(1127),
    [sym_false] = ACTIONS(1127),
    [sym_null] = ACTIONS(1127),
    [sym_undefined] = ACTIONS(1127),
    [anon_sym_AT] = ACTIONS(1125),
    [anon_sym_static] = ACTIONS(1127),
    [anon_sym_abstract] = ACTIONS(1127),
    [anon_sym_get] = ACTIONS(1127),
    [anon_sym_set] = ACTIONS(1127),
    [anon_sym_declare] = ACTIONS(1127),
    [anon_sym_public] = ACTIONS(1127),
    [anon_sym_private] = ACTIONS(1127),
    [anon_sym_protected] = ACTIONS(1127),
    [anon_sym_module] = ACTIONS(1127),
    [anon_sym_any] = ACTIONS(1127),
    [anon_sym_number] = ACTIONS(1127),
    [anon_sym_boolean] = ACTIONS(1127),
    [anon_sym_string] = ACTIONS(1127),
    [anon_sym_symbol] = ACTIONS(1127),
    [anon_sym_interface] = ACTIONS(1127),
    [anon_sym_enum] = ACTIONS(1127),
    [sym_readonly] = ACTIONS(1127),
    [sym__automatic_semicolon] = ACTIONS(1133),
  },
  [537] = {
    [ts_builtin_sym_end] = ACTIONS(1867),
    [sym_identifier] = ACTIONS(1869),
    [anon_sym_export] = ACTIONS(1869),
    [anon_sym_default] = ACTIONS(1869),
    [anon_sym_namespace] = ACTIONS(1869),
    [anon_sym_LBRACE] = ACTIONS(1867),
    [anon_sym_RBRACE] = ACTIONS(1867),
    [anon_sym_type] = ACTIONS(1869),
    [anon_sym_typeof] = ACTIONS(1869),
    [anon_sym_import] = ACTIONS(1869),
    [anon_sym_var] = ACTIONS(1869),
    [anon_sym_let] = ACTIONS(1869),
    [anon_sym_const] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1867),
    [anon_sym_else] = ACTIONS(1869),
    [anon_sym_if] = ACTIONS(1869),
    [anon_sym_switch] = ACTIONS(1869),
    [anon_sym_for] = ACTIONS(1869),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_RPAREN] = ACTIONS(1867),
    [anon_sym_await] = ACTIONS(1869),
    [anon_sym_while] = ACTIONS(1869),
    [anon_sym_do] = ACTIONS(1869),
    [anon_sym_try] = ACTIONS(1869),
    [anon_sym_with] = ACTIONS(1869),
    [anon_sym_break] = ACTIONS(1869),
    [anon_sym_continue] = ACTIONS(1869),
    [anon_sym_debugger] = ACTIONS(1869),
    [anon_sym_return] = ACTIONS(1869),
    [anon_sym_throw] = ACTIONS(1869),
    [anon_sym_SEMI] = ACTIONS(1867),
    [anon_sym_case] = ACTIONS(1869),
    [anon_sym_yield] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_SLASH] = ACTIONS(1869),
    [anon_sym_class] = ACTIONS(1869),
    [anon_sym_async] = ACTIONS(1869),
    [anon_sym_function] = ACTIONS(1869),
    [anon_sym_new] = ACTIONS(1869),
    [anon_sym_PLUS] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_TILDE] = ACTIONS(1867),
    [anon_sym_void] = ACTIONS(1869),
    [anon_sym_delete] = ACTIONS(1869),
    [anon_sym_PLUS_PLUS] = ACTIONS(1867),
    [anon_sym_DASH_DASH] = ACTIONS(1867),
    [anon_sym_DQUOTE] = ACTIONS(1867),
    [anon_sym_SQUOTE] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1867),
    [sym_number] = ACTIONS(1867),
    [sym_this] = ACTIONS(1869),
    [sym_super] = ACTIONS(1869),
    [sym_true] = ACTIONS(1869),
    [sym_false] = ACTIONS(1869),
    [sym_null] = ACTIONS(1869),
    [sym_undefined] = ACTIONS(1869),
    [anon_sym_AT] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(1869),
    [anon_sym_abstract] = ACTIONS(1869),
    [anon_sym_get] = ACTIONS(1869),
    [anon_sym_set] = ACTIONS(1869),
    [anon_sym_declare] = ACTIONS(1869),
    [anon_sym_public] = ACTIONS(1869),
    [anon_sym_private] = ACTIONS(1869),
    [anon_sym_protected] = ACTIONS(1869),
    [anon_sym_module] = ACTIONS(1869),
    [anon_sym_any] = ACTIONS(1869),
    [anon_sym_number] = ACTIONS(1869),
    [anon_sym_boolean] = ACTIONS(1869),
    [anon_sym_string] = ACTIONS(1869),
    [anon_sym_symbol] = ACTIONS(1869),
    [anon_sym_interface] = ACTIONS(1869),
    [anon_sym_enum] = ACTIONS(1869),
    [sym_readonly] = ACTIONS(1869),
  },
  [538] = {
    [ts_builtin_sym_end] = ACTIONS(1073),
    [sym_identifier] = ACTIONS(1075),
    [anon_sym_export] = ACTIONS(1075),
    [anon_sym_default] = ACTIONS(1075),
    [anon_sym_namespace] = ACTIONS(1075),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_type] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(1075),
    [anon_sym_import] = ACTIONS(1075),
    [anon_sym_var] = ACTIONS(1075),
    [anon_sym_let] = ACTIONS(1075),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_else] = ACTIONS(1075),
    [anon_sym_if] = ACTIONS(1075),
    [anon_sym_switch] = ACTIONS(1075),
    [anon_sym_for] = ACTIONS(1075),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_await] = ACTIONS(1075),
    [anon_sym_while] = ACTIONS(1075),
    [anon_sym_do] = ACTIONS(1075),
    [anon_sym_try] = ACTIONS(1075),
    [anon_sym_with] = ACTIONS(1075),
    [anon_sym_break] = ACTIONS(1075),
    [anon_sym_continue] = ACTIONS(1075),
    [anon_sym_debugger] = ACTIONS(1075),
    [anon_sym_return] = ACTIONS(1075),
    [anon_sym_throw] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_case] = ACTIONS(1075),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1075),
    [anon_sym_class] = ACTIONS(1075),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_function] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(1075),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1073),
    [anon_sym_void] = ACTIONS(1075),
    [anon_sym_delete] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [anon_sym_DQUOTE] = ACTIONS(1073),
    [anon_sym_SQUOTE] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [sym_number] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [sym_super] = ACTIONS(1075),
    [sym_true] = ACTIONS(1075),
    [sym_false] = ACTIONS(1075),
    [sym_null] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(1073),
    [anon_sym_static] = ACTIONS(1075),
    [anon_sym_abstract] = ACTIONS(1075),
    [anon_sym_get] = ACTIONS(1075),
    [anon_sym_set] = ACTIONS(1075),
    [anon_sym_declare] = ACTIONS(1075),
    [anon_sym_public] = ACTIONS(1075),
    [anon_sym_private] = ACTIONS(1075),
    [anon_sym_protected] = ACTIONS(1075),
    [anon_sym_module] = ACTIONS(1075),
    [anon_sym_any] = ACTIONS(1075),
    [anon_sym_number] = ACTIONS(1075),
    [anon_sym_boolean] = ACTIONS(1075),
    [anon_sym_string] = ACTIONS(1075),
    [anon_sym_symbol] = ACTIONS(1075),
    [anon_sym_interface] = ACTIONS(1075),
    [anon_sym_enum] = ACTIONS(1075),
    [sym_readonly] = ACTIONS(1075),
    [sym__automatic_semicolon] = ACTIONS(1081),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(1871),
    [sym_identifier] = ACTIONS(1873),
    [anon_sym_export] = ACTIONS(1873),
    [anon_sym_default] = ACTIONS(1873),
    [anon_sym_namespace] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1871),
    [anon_sym_RBRACE] = ACTIONS(1871),
    [anon_sym_type] = ACTIONS(1873),
    [anon_sym_typeof] = ACTIONS(1873),
    [anon_sym_import] = ACTIONS(1873),
    [anon_sym_var] = ACTIONS(1873),
    [anon_sym_let] = ACTIONS(1873),
    [anon_sym_const] = ACTIONS(1873),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_else] = ACTIONS(1873),
    [anon_sym_if] = ACTIONS(1873),
    [anon_sym_switch] = ACTIONS(1873),
    [anon_sym_for] = ACTIONS(1873),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_await] = ACTIONS(1873),
    [anon_sym_while] = ACTIONS(1873),
    [anon_sym_do] = ACTIONS(1873),
    [anon_sym_try] = ACTIONS(1873),
    [anon_sym_with] = ACTIONS(1873),
    [anon_sym_break] = ACTIONS(1873),
    [anon_sym_continue] = ACTIONS(1873),
    [anon_sym_debugger] = ACTIONS(1873),
    [anon_sym_return] = ACTIONS(1873),
    [anon_sym_throw] = ACTIONS(1873),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_case] = ACTIONS(1873),
    [anon_sym_finally] = ACTIONS(1873),
    [anon_sym_yield] = ACTIONS(1873),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [anon_sym_LT] = ACTIONS(1871),
    [anon_sym_SLASH] = ACTIONS(1873),
    [anon_sym_class] = ACTIONS(1873),
    [anon_sym_async] = ACTIONS(1873),
    [anon_sym_function] = ACTIONS(1873),
    [anon_sym_new] = ACTIONS(1873),
    [anon_sym_PLUS] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_void] = ACTIONS(1873),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_PLUS_PLUS] = ACTIONS(1871),
    [anon_sym_DASH_DASH] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [anon_sym_SQUOTE] = ACTIONS(1871),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1871),
    [sym_number] = ACTIONS(1871),
    [sym_this] = ACTIONS(1873),
    [sym_super] = ACTIONS(1873),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [sym_null] = ACTIONS(1873),
    [sym_undefined] = ACTIONS(1873),
    [anon_sym_AT] = ACTIONS(1871),
    [anon_sym_static] = ACTIONS(1873),
    [anon_sym_abstract] = ACTIONS(1873),
    [anon_sym_get] = ACTIONS(1873),
    [anon_sym_set] = ACTIONS(1873),
    [anon_sym_declare] = ACTIONS(1873),
    [anon_sym_public] = ACTIONS(1873),
    [anon_sym_private] = ACTIONS(1873),
    [anon_sym_protected] = ACTIONS(1873),
    [anon_sym_module] = ACTIONS(1873),
    [anon_sym_any] = ACTIONS(1873),
    [anon_sym_number] = ACTIONS(1873),
    [anon_sym_boolean] = ACTIONS(1873),
    [anon_sym_string] = ACTIONS(1873),
    [anon_sym_symbol] = ACTIONS(1873),
    [anon_sym_interface] = ACTIONS(1873),
    [anon_sym_enum] = ACTIONS(1873),
    [sym_readonly] = ACTIONS(1873),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1877),
    [anon_sym_export] = ACTIONS(1877),
    [anon_sym_default] = ACTIONS(1877),
    [anon_sym_namespace] = ACTIONS(1877),
    [anon_sym_LBRACE] = ACTIONS(1875),
    [anon_sym_RBRACE] = ACTIONS(1875),
    [anon_sym_type] = ACTIONS(1877),
    [anon_sym_typeof] = ACTIONS(1877),
    [anon_sym_import] = ACTIONS(1877),
    [anon_sym_var] = ACTIONS(1877),
    [anon_sym_let] = ACTIONS(1877),
    [anon_sym_const] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1875),
    [anon_sym_else] = ACTIONS(1877),
    [anon_sym_if] = ACTIONS(1877),
    [anon_sym_switch] = ACTIONS(1877),
    [anon_sym_for] = ACTIONS(1877),
    [anon_sym_LPAREN] = ACTIONS(1875),
    [anon_sym_await] = ACTIONS(1877),
    [anon_sym_while] = ACTIONS(1877),
    [anon_sym_do] = ACTIONS(1877),
    [anon_sym_try] = ACTIONS(1877),
    [anon_sym_with] = ACTIONS(1877),
    [anon_sym_break] = ACTIONS(1877),
    [anon_sym_continue] = ACTIONS(1877),
    [anon_sym_debugger] = ACTIONS(1877),
    [anon_sym_return] = ACTIONS(1877),
    [anon_sym_throw] = ACTIONS(1877),
    [anon_sym_SEMI] = ACTIONS(1875),
    [anon_sym_case] = ACTIONS(1877),
    [anon_sym_finally] = ACTIONS(1877),
    [anon_sym_yield] = ACTIONS(1877),
    [anon_sym_LBRACK] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(1875),
    [anon_sym_SLASH] = ACTIONS(1877),
    [anon_sym_class] = ACTIONS(1877),
    [anon_sym_async] = ACTIONS(1877),
    [anon_sym_function] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1877),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_void] = ACTIONS(1877),
    [anon_sym_delete] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1875),
    [anon_sym_DASH_DASH] = ACTIONS(1875),
    [anon_sym_DQUOTE] = ACTIONS(1875),
    [anon_sym_SQUOTE] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1875),
    [sym_number] = ACTIONS(1875),
    [sym_this] = ACTIONS(1877),
    [sym_super] = ACTIONS(1877),
    [sym_true] = ACTIONS(1877),
    [sym_false] = ACTIONS(1877),
    [sym_null] = ACTIONS(1877),
    [sym_undefined] = ACTIONS(1877),
    [anon_sym_AT] = ACTIONS(1875),
    [anon_sym_static] = ACTIONS(1877),
    [anon_sym_abstract] = ACTIONS(1877),
    [anon_sym_get] = ACTIONS(1877),
    [anon_sym_set] = ACTIONS(1877),
    [anon_sym_declare] = ACTIONS(1877),
    [anon_sym_public] = ACTIONS(1877),
    [anon_sym_private] = ACTIONS(1877),
    [anon_sym_protected] = ACTIONS(1877),
    [anon_sym_module] = ACTIONS(1877),
    [anon_sym_any] = ACTIONS(1877),
    [anon_sym_number] = ACTIONS(1877),
    [anon_sym_boolean] = ACTIONS(1877),
    [anon_sym_string] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1877),
    [anon_sym_interface] = ACTIONS(1877),
    [anon_sym_enum] = ACTIONS(1877),
    [sym_readonly] = ACTIONS(1877),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(1019),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_export] = ACTIONS(1021),
    [anon_sym_default] = ACTIONS(1021),
    [anon_sym_namespace] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1019),
    [anon_sym_RBRACE] = ACTIONS(1019),
    [anon_sym_type] = ACTIONS(1021),
    [anon_sym_typeof] = ACTIONS(1021),
    [anon_sym_import] = ACTIONS(1021),
    [anon_sym_var] = ACTIONS(1021),
    [anon_sym_let] = ACTIONS(1021),
    [anon_sym_const] = ACTIONS(1021),
    [anon_sym_BANG] = ACTIONS(1019),
    [anon_sym_else] = ACTIONS(1021),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_switch] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1021),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_await] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1021),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_try] = ACTIONS(1021),
    [anon_sym_with] = ACTIONS(1021),
    [anon_sym_break] = ACTIONS(1021),
    [anon_sym_continue] = ACTIONS(1021),
    [anon_sym_debugger] = ACTIONS(1021),
    [anon_sym_return] = ACTIONS(1021),
    [anon_sym_throw] = ACTIONS(1021),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_case] = ACTIONS(1021),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_class] = ACTIONS(1021),
    [anon_sym_async] = ACTIONS(1021),
    [anon_sym_function] = ACTIONS(1021),
    [anon_sym_new] = ACTIONS(1021),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_DASH] = ACTIONS(1021),
    [anon_sym_TILDE] = ACTIONS(1019),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(1021),
    [anon_sym_PLUS_PLUS] = ACTIONS(1019),
    [anon_sym_DASH_DASH] = ACTIONS(1019),
    [anon_sym_DQUOTE] = ACTIONS(1019),
    [anon_sym_SQUOTE] = ACTIONS(1019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [sym_number] = ACTIONS(1019),
    [sym_this] = ACTIONS(1021),
    [sym_super] = ACTIONS(1021),
    [sym_true] = ACTIONS(1021),
    [sym_false] = ACTIONS(1021),
    [sym_null] = ACTIONS(1021),
    [sym_undefined] = ACTIONS(1021),
    [anon_sym_AT] = ACTIONS(1019),
    [anon_sym_static] = ACTIONS(1021),
    [anon_sym_abstract] = ACTIONS(1021),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
    [anon_sym_declare] = ACTIONS(1021),
    [anon_sym_public] = ACTIONS(1021),
    [anon_sym_private] = ACTIONS(1021),
    [anon_sym_protected] = ACTIONS(1021),
    [anon_sym_module] = ACTIONS(1021),
    [anon_sym_any] = ACTIONS(1021),
    [anon_sym_number] = ACTIONS(1021),
    [anon_sym_boolean] = ACTIONS(1021),
    [anon_sym_string] = ACTIONS(1021),
    [anon_sym_symbol] = ACTIONS(1021),
    [anon_sym_interface] = ACTIONS(1021),
    [anon_sym_enum] = ACTIONS(1021),
    [sym_readonly] = ACTIONS(1021),
    [sym__automatic_semicolon] = ACTIONS(1027),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(1059),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_default] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(1061),
    [anon_sym_var] = ACTIONS(1061),
    [anon_sym_let] = ACTIONS(1061),
    [anon_sym_const] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_switch] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_await] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_do] = ACTIONS(1061),
    [anon_sym_try] = ACTIONS(1061),
    [anon_sym_with] = ACTIONS(1061),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_continue] = ACTIONS(1061),
    [anon_sym_debugger] = ACTIONS(1061),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_throw] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_case] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_function] = ACTIONS(1061),
    [anon_sym_new] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [sym_number] = ACTIONS(1059),
    [sym_this] = ACTIONS(1061),
    [sym_super] = ACTIONS(1061),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_null] = ACTIONS(1061),
    [sym_undefined] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1059),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_abstract] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_interface] = ACTIONS(1061),
    [anon_sym_enum] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1031),
    [anon_sym_export] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(1031),
    [anon_sym_namespace] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_type] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1031),
    [anon_sym_import] = ACTIONS(1031),
    [anon_sym_var] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1031),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_BANG] = ACTIONS(1029),
    [anon_sym_else] = ACTIONS(1031),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1031),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_await] = ACTIONS(1031),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_do] = ACTIONS(1031),
    [anon_sym_try] = ACTIONS(1031),
    [anon_sym_with] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1031),
    [anon_sym_continue] = ACTIONS(1031),
    [anon_sym_debugger] = ACTIONS(1031),
    [anon_sym_return] = ACTIONS(1031),
    [anon_sym_throw] = ACTIONS(1031),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_case] = ACTIONS(1031),
    [anon_sym_yield] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_LT] = ACTIONS(1029),
    [anon_sym_SLASH] = ACTIONS(1031),
    [anon_sym_class] = ACTIONS(1031),
    [anon_sym_async] = ACTIONS(1031),
    [anon_sym_function] = ACTIONS(1031),
    [anon_sym_new] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1029),
    [anon_sym_void] = ACTIONS(1031),
    [anon_sym_delete] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1029),
    [sym_number] = ACTIONS(1029),
    [sym_this] = ACTIONS(1031),
    [sym_super] = ACTIONS(1031),
    [sym_true] = ACTIONS(1031),
    [sym_false] = ACTIONS(1031),
    [sym_null] = ACTIONS(1031),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(1029),
    [anon_sym_static] = ACTIONS(1031),
    [anon_sym_abstract] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(1031),
    [anon_sym_set] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1031),
    [anon_sym_public] = ACTIONS(1031),
    [anon_sym_private] = ACTIONS(1031),
    [anon_sym_protected] = ACTIONS(1031),
    [anon_sym_module] = ACTIONS(1031),
    [anon_sym_any] = ACTIONS(1031),
    [anon_sym_number] = ACTIONS(1031),
    [anon_sym_boolean] = ACTIONS(1031),
    [anon_sym_string] = ACTIONS(1031),
    [anon_sym_symbol] = ACTIONS(1031),
    [anon_sym_interface] = ACTIONS(1031),
    [anon_sym_enum] = ACTIONS(1031),
    [sym_readonly] = ACTIONS(1031),
    [sym__automatic_semicolon] = ACTIONS(1037),
  },
  [544] = {
    [sym_else_clause] = STATE(580),
    [ts_builtin_sym_end] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1881),
    [anon_sym_export] = ACTIONS(1881),
    [anon_sym_default] = ACTIONS(1881),
    [anon_sym_namespace] = ACTIONS(1881),
    [anon_sym_LBRACE] = ACTIONS(1879),
    [anon_sym_RBRACE] = ACTIONS(1879),
    [anon_sym_type] = ACTIONS(1881),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_import] = ACTIONS(1881),
    [anon_sym_var] = ACTIONS(1881),
    [anon_sym_let] = ACTIONS(1881),
    [anon_sym_const] = ACTIONS(1881),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_else] = ACTIONS(1883),
    [anon_sym_if] = ACTIONS(1881),
    [anon_sym_switch] = ACTIONS(1881),
    [anon_sym_for] = ACTIONS(1881),
    [anon_sym_LPAREN] = ACTIONS(1879),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_while] = ACTIONS(1881),
    [anon_sym_do] = ACTIONS(1881),
    [anon_sym_try] = ACTIONS(1881),
    [anon_sym_with] = ACTIONS(1881),
    [anon_sym_break] = ACTIONS(1881),
    [anon_sym_continue] = ACTIONS(1881),
    [anon_sym_debugger] = ACTIONS(1881),
    [anon_sym_return] = ACTIONS(1881),
    [anon_sym_throw] = ACTIONS(1881),
    [anon_sym_SEMI] = ACTIONS(1879),
    [anon_sym_case] = ACTIONS(1881),
    [anon_sym_yield] = ACTIONS(1881),
    [anon_sym_LBRACK] = ACTIONS(1879),
    [anon_sym_LT] = ACTIONS(1879),
    [anon_sym_SLASH] = ACTIONS(1881),
    [anon_sym_class] = ACTIONS(1881),
    [anon_sym_async] = ACTIONS(1881),
    [anon_sym_function] = ACTIONS(1881),
    [anon_sym_new] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_void] = ACTIONS(1881),
    [anon_sym_delete] = ACTIONS(1881),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_DQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1879),
    [sym_number] = ACTIONS(1879),
    [sym_this] = ACTIONS(1881),
    [sym_super] = ACTIONS(1881),
    [sym_true] = ACTIONS(1881),
    [sym_false] = ACTIONS(1881),
    [sym_null] = ACTIONS(1881),
    [sym_undefined] = ACTIONS(1881),
    [anon_sym_AT] = ACTIONS(1879),
    [anon_sym_static] = ACTIONS(1881),
    [anon_sym_abstract] = ACTIONS(1881),
    [anon_sym_get] = ACTIONS(1881),
    [anon_sym_set] = ACTIONS(1881),
    [anon_sym_declare] = ACTIONS(1881),
    [anon_sym_public] = ACTIONS(1881),
    [anon_sym_private] = ACTIONS(1881),
    [anon_sym_protected] = ACTIONS(1881),
    [anon_sym_module] = ACTIONS(1881),
    [anon_sym_any] = ACTIONS(1881),
    [anon_sym_number] = ACTIONS(1881),
    [anon_sym_boolean] = ACTIONS(1881),
    [anon_sym_string] = ACTIONS(1881),
    [anon_sym_symbol] = ACTIONS(1881),
    [anon_sym_interface] = ACTIONS(1881),
    [anon_sym_enum] = ACTIONS(1881),
    [sym_readonly] = ACTIONS(1881),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(1885),
    [sym_identifier] = ACTIONS(1887),
    [anon_sym_export] = ACTIONS(1887),
    [anon_sym_default] = ACTIONS(1887),
    [anon_sym_namespace] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1885),
    [anon_sym_RBRACE] = ACTIONS(1885),
    [anon_sym_type] = ACTIONS(1887),
    [anon_sym_typeof] = ACTIONS(1887),
    [anon_sym_import] = ACTIONS(1887),
    [anon_sym_var] = ACTIONS(1887),
    [anon_sym_let] = ACTIONS(1887),
    [anon_sym_const] = ACTIONS(1887),
    [anon_sym_BANG] = ACTIONS(1885),
    [anon_sym_else] = ACTIONS(1887),
    [anon_sym_if] = ACTIONS(1887),
    [anon_sym_switch] = ACTIONS(1887),
    [anon_sym_for] = ACTIONS(1887),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1885),
    [anon_sym_await] = ACTIONS(1887),
    [anon_sym_while] = ACTIONS(1887),
    [anon_sym_do] = ACTIONS(1887),
    [anon_sym_try] = ACTIONS(1887),
    [anon_sym_with] = ACTIONS(1887),
    [anon_sym_break] = ACTIONS(1887),
    [anon_sym_continue] = ACTIONS(1887),
    [anon_sym_debugger] = ACTIONS(1887),
    [anon_sym_return] = ACTIONS(1887),
    [anon_sym_throw] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_case] = ACTIONS(1887),
    [anon_sym_yield] = ACTIONS(1887),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_SLASH] = ACTIONS(1887),
    [anon_sym_class] = ACTIONS(1887),
    [anon_sym_async] = ACTIONS(1887),
    [anon_sym_function] = ACTIONS(1887),
    [anon_sym_new] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_TILDE] = ACTIONS(1885),
    [anon_sym_void] = ACTIONS(1887),
    [anon_sym_delete] = ACTIONS(1887),
    [anon_sym_PLUS_PLUS] = ACTIONS(1885),
    [anon_sym_DASH_DASH] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1885),
    [sym_number] = ACTIONS(1885),
    [sym_this] = ACTIONS(1887),
    [sym_super] = ACTIONS(1887),
    [sym_true] = ACTIONS(1887),
    [sym_false] = ACTIONS(1887),
    [sym_null] = ACTIONS(1887),
    [sym_undefined] = ACTIONS(1887),
    [anon_sym_AT] = ACTIONS(1885),
    [anon_sym_static] = ACTIONS(1887),
    [anon_sym_abstract] = ACTIONS(1887),
    [anon_sym_get] = ACTIONS(1887),
    [anon_sym_set] = ACTIONS(1887),
    [anon_sym_declare] = ACTIONS(1887),
    [anon_sym_public] = ACTIONS(1887),
    [anon_sym_private] = ACTIONS(1887),
    [anon_sym_protected] = ACTIONS(1887),
    [anon_sym_module] = ACTIONS(1887),
    [anon_sym_any] = ACTIONS(1887),
    [anon_sym_number] = ACTIONS(1887),
    [anon_sym_boolean] = ACTIONS(1887),
    [anon_sym_string] = ACTIONS(1887),
    [anon_sym_symbol] = ACTIONS(1887),
    [anon_sym_interface] = ACTIONS(1887),
    [anon_sym_enum] = ACTIONS(1887),
    [sym_readonly] = ACTIONS(1887),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(999),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_export] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(1001),
    [anon_sym_namespace] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(999),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_type] = ACTIONS(1001),
    [anon_sym_typeof] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(1001),
    [anon_sym_var] = ACTIONS(1001),
    [anon_sym_let] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1001),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_else] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1001),
    [anon_sym_switch] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_do] = ACTIONS(1001),
    [anon_sym_try] = ACTIONS(1001),
    [anon_sym_with] = ACTIONS(1001),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_continue] = ACTIONS(1001),
    [anon_sym_debugger] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_throw] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_case] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1001),
    [anon_sym_class] = ACTIONS(1001),
    [anon_sym_async] = ACTIONS(1001),
    [anon_sym_function] = ACTIONS(1001),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1001),
    [anon_sym_delete] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(999),
    [anon_sym_DASH_DASH] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(999),
    [anon_sym_SQUOTE] = ACTIONS(999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(999),
    [sym_number] = ACTIONS(999),
    [sym_this] = ACTIONS(1001),
    [sym_super] = ACTIONS(1001),
    [sym_true] = ACTIONS(1001),
    [sym_false] = ACTIONS(1001),
    [sym_null] = ACTIONS(1001),
    [sym_undefined] = ACTIONS(1001),
    [anon_sym_AT] = ACTIONS(999),
    [anon_sym_static] = ACTIONS(1001),
    [anon_sym_abstract] = ACTIONS(1001),
    [anon_sym_get] = ACTIONS(1001),
    [anon_sym_set] = ACTIONS(1001),
    [anon_sym_declare] = ACTIONS(1001),
    [anon_sym_public] = ACTIONS(1001),
    [anon_sym_private] = ACTIONS(1001),
    [anon_sym_protected] = ACTIONS(1001),
    [anon_sym_module] = ACTIONS(1001),
    [anon_sym_any] = ACTIONS(1001),
    [anon_sym_number] = ACTIONS(1001),
    [anon_sym_boolean] = ACTIONS(1001),
    [anon_sym_string] = ACTIONS(1001),
    [anon_sym_symbol] = ACTIONS(1001),
    [anon_sym_interface] = ACTIONS(1001),
    [anon_sym_enum] = ACTIONS(1001),
    [sym_readonly] = ACTIONS(1001),
    [sym__automatic_semicolon] = ACTIONS(1007),
  },
  [547] = {
    [sym_statement_block] = STATE(583),
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym_identifier] = ACTIONS(985),
    [anon_sym_export] = ACTIONS(985),
    [anon_sym_default] = ACTIONS(985),
    [anon_sym_namespace] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_type] = ACTIONS(985),
    [anon_sym_typeof] = ACTIONS(985),
    [anon_sym_import] = ACTIONS(985),
    [anon_sym_var] = ACTIONS(985),
    [anon_sym_let] = ACTIONS(985),
    [anon_sym_const] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(983),
    [anon_sym_else] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_switch] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_do] = ACTIONS(985),
    [anon_sym_try] = ACTIONS(985),
    [anon_sym_with] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_continue] = ACTIONS(985),
    [anon_sym_debugger] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_throw] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(983),
    [anon_sym_case] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_SLASH] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(985),
    [anon_sym_new] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(983),
    [anon_sym_void] = ACTIONS(985),
    [anon_sym_delete] = ACTIONS(985),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [sym_number] = ACTIONS(983),
    [sym_this] = ACTIONS(985),
    [sym_super] = ACTIONS(985),
    [sym_true] = ACTIONS(985),
    [sym_false] = ACTIONS(985),
    [sym_null] = ACTIONS(985),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(983),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_abstract] = ACTIONS(985),
    [anon_sym_get] = ACTIONS(985),
    [anon_sym_set] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(985),
    [anon_sym_public] = ACTIONS(985),
    [anon_sym_private] = ACTIONS(985),
    [anon_sym_protected] = ACTIONS(985),
    [anon_sym_module] = ACTIONS(985),
    [anon_sym_any] = ACTIONS(985),
    [anon_sym_number] = ACTIONS(985),
    [anon_sym_boolean] = ACTIONS(985),
    [anon_sym_string] = ACTIONS(985),
    [anon_sym_symbol] = ACTIONS(985),
    [anon_sym_interface] = ACTIONS(985),
    [anon_sym_enum] = ACTIONS(985),
    [sym_readonly] = ACTIONS(985),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(1149),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_export] = ACTIONS(1151),
    [anon_sym_default] = ACTIONS(1151),
    [anon_sym_namespace] = ACTIONS(1151),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_type] = ACTIONS(1151),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_import] = ACTIONS(1151),
    [anon_sym_var] = ACTIONS(1151),
    [anon_sym_let] = ACTIONS(1151),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1149),
    [anon_sym_else] = ACTIONS(1151),
    [anon_sym_if] = ACTIONS(1151),
    [anon_sym_switch] = ACTIONS(1151),
    [anon_sym_for] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1149),
    [anon_sym_await] = ACTIONS(1151),
    [anon_sym_while] = ACTIONS(1151),
    [anon_sym_do] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1151),
    [anon_sym_with] = ACTIONS(1151),
    [anon_sym_break] = ACTIONS(1151),
    [anon_sym_continue] = ACTIONS(1151),
    [anon_sym_debugger] = ACTIONS(1151),
    [anon_sym_return] = ACTIONS(1151),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_SEMI] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1151),
    [anon_sym_yield] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1149),
    [anon_sym_SLASH] = ACTIONS(1151),
    [anon_sym_class] = ACTIONS(1151),
    [anon_sym_async] = ACTIONS(1151),
    [anon_sym_function] = ACTIONS(1151),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1149),
    [anon_sym_void] = ACTIONS(1151),
    [anon_sym_delete] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [anon_sym_SQUOTE] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1149),
    [sym_number] = ACTIONS(1149),
    [sym_this] = ACTIONS(1151),
    [sym_super] = ACTIONS(1151),
    [sym_true] = ACTIONS(1151),
    [sym_false] = ACTIONS(1151),
    [sym_null] = ACTIONS(1151),
    [sym_undefined] = ACTIONS(1151),
    [anon_sym_AT] = ACTIONS(1149),
    [anon_sym_static] = ACTIONS(1151),
    [anon_sym_abstract] = ACTIONS(1151),
    [anon_sym_get] = ACTIONS(1151),
    [anon_sym_set] = ACTIONS(1151),
    [anon_sym_declare] = ACTIONS(1151),
    [anon_sym_public] = ACTIONS(1151),
    [anon_sym_private] = ACTIONS(1151),
    [anon_sym_protected] = ACTIONS(1151),
    [anon_sym_module] = ACTIONS(1151),
    [anon_sym_any] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1151),
    [anon_sym_boolean] = ACTIONS(1151),
    [anon_sym_string] = ACTIONS(1151),
    [anon_sym_symbol] = ACTIONS(1151),
    [anon_sym_interface] = ACTIONS(1151),
    [anon_sym_enum] = ACTIONS(1151),
    [sym_readonly] = ACTIONS(1151),
    [sym__automatic_semicolon] = ACTIONS(1157),
  },
  [549] = {
    [ts_builtin_sym_end] = ACTIONS(1115),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_export] = ACTIONS(1117),
    [anon_sym_default] = ACTIONS(1117),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1115),
    [anon_sym_type] = ACTIONS(1117),
    [anon_sym_typeof] = ACTIONS(1117),
    [anon_sym_import] = ACTIONS(1117),
    [anon_sym_var] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_const] = ACTIONS(1117),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_else] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_switch] = ACTIONS(1117),
    [anon_sym_for] = ACTIONS(1117),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [anon_sym_await] = ACTIONS(1117),
    [anon_sym_while] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1117),
    [anon_sym_with] = ACTIONS(1117),
    [anon_sym_break] = ACTIONS(1117),
    [anon_sym_continue] = ACTIONS(1117),
    [anon_sym_debugger] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1117),
    [anon_sym_throw] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1115),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_yield] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1115),
    [anon_sym_SLASH] = ACTIONS(1117),
    [anon_sym_class] = ACTIONS(1117),
    [anon_sym_async] = ACTIONS(1117),
    [anon_sym_function] = ACTIONS(1117),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_void] = ACTIONS(1117),
    [anon_sym_delete] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1115),
    [sym_number] = ACTIONS(1115),
    [sym_this] = ACTIONS(1117),
    [sym_super] = ACTIONS(1117),
    [sym_true] = ACTIONS(1117),
    [sym_false] = ACTIONS(1117),
    [sym_null] = ACTIONS(1117),
    [sym_undefined] = ACTIONS(1117),
    [anon_sym_AT] = ACTIONS(1115),
    [anon_sym_static] = ACTIONS(1117),
    [anon_sym_abstract] = ACTIONS(1117),
    [anon_sym_get] = ACTIONS(1117),
    [anon_sym_set] = ACTIONS(1117),
    [anon_sym_declare] = ACTIONS(1117),
    [anon_sym_public] = ACTIONS(1117),
    [anon_sym_private] = ACTIONS(1117),
    [anon_sym_protected] = ACTIONS(1117),
    [anon_sym_module] = ACTIONS(1117),
    [anon_sym_any] = ACTIONS(1117),
    [anon_sym_number] = ACTIONS(1117),
    [anon_sym_boolean] = ACTIONS(1117),
    [anon_sym_string] = ACTIONS(1117),
    [anon_sym_symbol] = ACTIONS(1117),
    [anon_sym_interface] = ACTIONS(1117),
    [anon_sym_enum] = ACTIONS(1117),
    [sym_readonly] = ACTIONS(1117),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [550] = {
    [ts_builtin_sym_end] = ACTIONS(1009),
    [sym_identifier] = ACTIONS(1011),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_default] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_RBRACE] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1011),
    [anon_sym_import] = ACTIONS(1011),
    [anon_sym_var] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1011),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_else] = ACTIONS(1011),
    [anon_sym_if] = ACTIONS(1011),
    [anon_sym_switch] = ACTIONS(1011),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(1009),
    [anon_sym_await] = ACTIONS(1011),
    [anon_sym_while] = ACTIONS(1011),
    [anon_sym_do] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1011),
    [anon_sym_with] = ACTIONS(1011),
    [anon_sym_break] = ACTIONS(1011),
    [anon_sym_continue] = ACTIONS(1011),
    [anon_sym_debugger] = ACTIONS(1011),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_case] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1011),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LT] = ACTIONS(1009),
    [anon_sym_SLASH] = ACTIONS(1011),
    [anon_sym_class] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1011),
    [anon_sym_function] = ACTIONS(1011),
    [anon_sym_new] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1011),
    [anon_sym_delete] = ACTIONS(1011),
    [anon_sym_PLUS_PLUS] = ACTIONS(1009),
    [anon_sym_DASH_DASH] = ACTIONS(1009),
    [anon_sym_DQUOTE] = ACTIONS(1009),
    [anon_sym_SQUOTE] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1009),
    [sym_number] = ACTIONS(1009),
    [sym_this] = ACTIONS(1011),
    [sym_super] = ACTIONS(1011),
    [sym_true] = ACTIONS(1011),
    [sym_false] = ACTIONS(1011),
    [sym_null] = ACTIONS(1011),
    [sym_undefined] = ACTIONS(1011),
    [anon_sym_AT] = ACTIONS(1009),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_abstract] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
    [anon_sym_interface] = ACTIONS(1011),
    [anon_sym_enum] = ACTIONS(1011),
    [sym_readonly] = ACTIONS(1011),
    [sym__automatic_semicolon] = ACTIONS(1017),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1085),
    [anon_sym_export] = ACTIONS(1085),
    [anon_sym_default] = ACTIONS(1085),
    [anon_sym_namespace] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1083),
    [anon_sym_RBRACE] = ACTIONS(1083),
    [anon_sym_type] = ACTIONS(1085),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1085),
    [anon_sym_var] = ACTIONS(1085),
    [anon_sym_let] = ACTIONS(1085),
    [anon_sym_const] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_else] = ACTIONS(1085),
    [anon_sym_if] = ACTIONS(1085),
    [anon_sym_switch] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1085),
    [anon_sym_LPAREN] = ACTIONS(1083),
    [anon_sym_await] = ACTIONS(1085),
    [anon_sym_while] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1085),
    [anon_sym_try] = ACTIONS(1085),
    [anon_sym_with] = ACTIONS(1085),
    [anon_sym_break] = ACTIONS(1085),
    [anon_sym_continue] = ACTIONS(1085),
    [anon_sym_debugger] = ACTIONS(1085),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1085),
    [anon_sym_class] = ACTIONS(1085),
    [anon_sym_async] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(1085),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1083),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1083),
    [anon_sym_DQUOTE] = ACTIONS(1083),
    [anon_sym_SQUOTE] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1083),
    [sym_number] = ACTIONS(1083),
    [sym_this] = ACTIONS(1085),
    [sym_super] = ACTIONS(1085),
    [sym_true] = ACTIONS(1085),
    [sym_false] = ACTIONS(1085),
    [sym_null] = ACTIONS(1085),
    [sym_undefined] = ACTIONS(1085),
    [anon_sym_AT] = ACTIONS(1083),
    [anon_sym_static] = ACTIONS(1085),
    [anon_sym_abstract] = ACTIONS(1085),
    [anon_sym_get] = ACTIONS(1085),
    [anon_sym_set] = ACTIONS(1085),
    [anon_sym_declare] = ACTIONS(1085),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_private] = ACTIONS(1085),
    [anon_sym_protected] = ACTIONS(1085),
    [anon_sym_module] = ACTIONS(1085),
    [anon_sym_any] = ACTIONS(1085),
    [anon_sym_number] = ACTIONS(1085),
    [anon_sym_boolean] = ACTIONS(1085),
    [anon_sym_string] = ACTIONS(1085),
    [anon_sym_symbol] = ACTIONS(1085),
    [anon_sym_interface] = ACTIONS(1085),
    [anon_sym_enum] = ACTIONS(1085),
    [sym_readonly] = ACTIONS(1085),
    [sym__automatic_semicolon] = ACTIONS(1091),
  },
  [552] = {
    [ts_builtin_sym_end] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1065),
    [anon_sym_export] = ACTIONS(1065),
    [anon_sym_default] = ACTIONS(1065),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1065),
    [anon_sym_typeof] = ACTIONS(1065),
    [anon_sym_import] = ACTIONS(1065),
    [anon_sym_var] = ACTIONS(1065),
    [anon_sym_let] = ACTIONS(1065),
    [anon_sym_const] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1063),
    [anon_sym_else] = ACTIONS(1065),
    [anon_sym_if] = ACTIONS(1065),
    [anon_sym_switch] = ACTIONS(1065),
    [anon_sym_for] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_await] = ACTIONS(1065),
    [anon_sym_while] = ACTIONS(1065),
    [anon_sym_do] = ACTIONS(1065),
    [anon_sym_try] = ACTIONS(1065),
    [anon_sym_with] = ACTIONS(1065),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_continue] = ACTIONS(1065),
    [anon_sym_debugger] = ACTIONS(1065),
    [anon_sym_return] = ACTIONS(1065),
    [anon_sym_throw] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_case] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_class] = ACTIONS(1065),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(1065),
    [anon_sym_new] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_void] = ACTIONS(1065),
    [anon_sym_delete] = ACTIONS(1065),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [sym_number] = ACTIONS(1063),
    [sym_this] = ACTIONS(1065),
    [sym_super] = ACTIONS(1065),
    [sym_true] = ACTIONS(1065),
    [sym_false] = ACTIONS(1065),
    [sym_null] = ACTIONS(1065),
    [sym_undefined] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1063),
    [anon_sym_static] = ACTIONS(1065),
    [anon_sym_abstract] = ACTIONS(1065),
    [anon_sym_get] = ACTIONS(1065),
    [anon_sym_set] = ACTIONS(1065),
    [anon_sym_declare] = ACTIONS(1065),
    [anon_sym_public] = ACTIONS(1065),
    [anon_sym_private] = ACTIONS(1065),
    [anon_sym_protected] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(1065),
    [anon_sym_any] = ACTIONS(1065),
    [anon_sym_number] = ACTIONS(1065),
    [anon_sym_boolean] = ACTIONS(1065),
    [anon_sym_string] = ACTIONS(1065),
    [anon_sym_symbol] = ACTIONS(1065),
    [anon_sym_interface] = ACTIONS(1065),
    [anon_sym_enum] = ACTIONS(1065),
    [sym_readonly] = ACTIONS(1065),
    [sym__automatic_semicolon] = ACTIONS(1071),
  },
  [553] = {
    [ts_builtin_sym_end] = ACTIONS(1101),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(1103),
    [anon_sym_namespace] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_RBRACE] = ACTIONS(1101),
    [anon_sym_type] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1103),
    [anon_sym_import] = ACTIONS(1103),
    [anon_sym_var] = ACTIONS(1103),
    [anon_sym_let] = ACTIONS(1103),
    [anon_sym_const] = ACTIONS(1103),
    [anon_sym_BANG] = ACTIONS(1101),
    [anon_sym_else] = ACTIONS(1103),
    [anon_sym_if] = ACTIONS(1103),
    [anon_sym_switch] = ACTIONS(1103),
    [anon_sym_for] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1103),
    [anon_sym_do] = ACTIONS(1103),
    [anon_sym_try] = ACTIONS(1103),
    [anon_sym_with] = ACTIONS(1103),
    [anon_sym_break] = ACTIONS(1103),
    [anon_sym_continue] = ACTIONS(1103),
    [anon_sym_debugger] = ACTIONS(1103),
    [anon_sym_return] = ACTIONS(1103),
    [anon_sym_throw] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_case] = ACTIONS(1103),
    [anon_sym_yield] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1101),
    [anon_sym_SLASH] = ACTIONS(1103),
    [anon_sym_class] = ACTIONS(1103),
    [anon_sym_async] = ACTIONS(1103),
    [anon_sym_function] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1103),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_TILDE] = ACTIONS(1101),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_delete] = ACTIONS(1103),
    [anon_sym_PLUS_PLUS] = ACTIONS(1101),
    [anon_sym_DASH_DASH] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_SQUOTE] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [sym_number] = ACTIONS(1101),
    [sym_this] = ACTIONS(1103),
    [sym_super] = ACTIONS(1103),
    [sym_true] = ACTIONS(1103),
    [sym_false] = ACTIONS(1103),
    [sym_null] = ACTIONS(1103),
    [sym_undefined] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(1101),
    [anon_sym_static] = ACTIONS(1103),
    [anon_sym_abstract] = ACTIONS(1103),
    [anon_sym_get] = ACTIONS(1103),
    [anon_sym_set] = ACTIONS(1103),
    [anon_sym_declare] = ACTIONS(1103),
    [anon_sym_public] = ACTIONS(1103),
    [anon_sym_private] = ACTIONS(1103),
    [anon_sym_protected] = ACTIONS(1103),
    [anon_sym_module] = ACTIONS(1103),
    [anon_sym_any] = ACTIONS(1103),
    [anon_sym_number] = ACTIONS(1103),
    [anon_sym_boolean] = ACTIONS(1103),
    [anon_sym_string] = ACTIONS(1103),
    [anon_sym_symbol] = ACTIONS(1103),
    [anon_sym_interface] = ACTIONS(1103),
    [anon_sym_enum] = ACTIONS(1103),
    [sym_readonly] = ACTIONS(1103),
    [sym__automatic_semicolon] = ACTIONS(1109),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(1889),
    [sym_identifier] = ACTIONS(1891),
    [anon_sym_export] = ACTIONS(1891),
    [anon_sym_default] = ACTIONS(1891),
    [anon_sym_namespace] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_type] = ACTIONS(1891),
    [anon_sym_typeof] = ACTIONS(1891),
    [anon_sym_import] = ACTIONS(1891),
    [anon_sym_var] = ACTIONS(1891),
    [anon_sym_let] = ACTIONS(1891),
    [anon_sym_const] = ACTIONS(1891),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_else] = ACTIONS(1891),
    [anon_sym_if] = ACTIONS(1891),
    [anon_sym_switch] = ACTIONS(1891),
    [anon_sym_for] = ACTIONS(1891),
    [anon_sym_LPAREN] = ACTIONS(1889),
    [anon_sym_await] = ACTIONS(1891),
    [anon_sym_while] = ACTIONS(1891),
    [anon_sym_do] = ACTIONS(1891),
    [anon_sym_try] = ACTIONS(1891),
    [anon_sym_with] = ACTIONS(1891),
    [anon_sym_break] = ACTIONS(1891),
    [anon_sym_continue] = ACTIONS(1891),
    [anon_sym_debugger] = ACTIONS(1891),
    [anon_sym_return] = ACTIONS(1891),
    [anon_sym_throw] = ACTIONS(1891),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_case] = ACTIONS(1891),
    [anon_sym_finally] = ACTIONS(1891),
    [anon_sym_yield] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1889),
    [anon_sym_SLASH] = ACTIONS(1891),
    [anon_sym_class] = ACTIONS(1891),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_function] = ACTIONS(1891),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_PLUS] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_void] = ACTIONS(1891),
    [anon_sym_delete] = ACTIONS(1891),
    [anon_sym_PLUS_PLUS] = ACTIONS(1889),
    [anon_sym_DASH_DASH] = ACTIONS(1889),
    [anon_sym_DQUOTE] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1889),
    [sym_number] = ACTIONS(1889),
    [sym_this] = ACTIONS(1891),
    [sym_super] = ACTIONS(1891),
    [sym_true] = ACTIONS(1891),
    [sym_false] = ACTIONS(1891),
    [sym_null] = ACTIONS(1891),
    [sym_undefined] = ACTIONS(1891),
    [anon_sym_AT] = ACTIONS(1889),
    [anon_sym_static] = ACTIONS(1891),
    [anon_sym_abstract] = ACTIONS(1891),
    [anon_sym_get] = ACTIONS(1891),
    [anon_sym_set] = ACTIONS(1891),
    [anon_sym_declare] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1891),
    [anon_sym_private] = ACTIONS(1891),
    [anon_sym_protected] = ACTIONS(1891),
    [anon_sym_module] = ACTIONS(1891),
    [anon_sym_any] = ACTIONS(1891),
    [anon_sym_number] = ACTIONS(1891),
    [anon_sym_boolean] = ACTIONS(1891),
    [anon_sym_string] = ACTIONS(1891),
    [anon_sym_symbol] = ACTIONS(1891),
    [anon_sym_interface] = ACTIONS(1891),
    [anon_sym_enum] = ACTIONS(1891),
    [sym_readonly] = ACTIONS(1891),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(1893),
    [sym_identifier] = ACTIONS(1895),
    [anon_sym_export] = ACTIONS(1895),
    [anon_sym_default] = ACTIONS(1895),
    [anon_sym_namespace] = ACTIONS(1895),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_RBRACE] = ACTIONS(1893),
    [anon_sym_type] = ACTIONS(1895),
    [anon_sym_typeof] = ACTIONS(1895),
    [anon_sym_import] = ACTIONS(1895),
    [anon_sym_var] = ACTIONS(1895),
    [anon_sym_let] = ACTIONS(1895),
    [anon_sym_const] = ACTIONS(1895),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_else] = ACTIONS(1895),
    [anon_sym_if] = ACTIONS(1895),
    [anon_sym_switch] = ACTIONS(1895),
    [anon_sym_for] = ACTIONS(1895),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_await] = ACTIONS(1895),
    [anon_sym_while] = ACTIONS(1895),
    [anon_sym_do] = ACTIONS(1895),
    [anon_sym_try] = ACTIONS(1895),
    [anon_sym_with] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1895),
    [anon_sym_continue] = ACTIONS(1895),
    [anon_sym_debugger] = ACTIONS(1895),
    [anon_sym_return] = ACTIONS(1895),
    [anon_sym_throw] = ACTIONS(1895),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_case] = ACTIONS(1895),
    [anon_sym_yield] = ACTIONS(1895),
    [anon_sym_LBRACK] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1895),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_async] = ACTIONS(1895),
    [anon_sym_function] = ACTIONS(1895),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_PLUS] = ACTIONS(1895),
    [anon_sym_DASH] = ACTIONS(1895),
    [anon_sym_TILDE] = ACTIONS(1893),
    [anon_sym_void] = ACTIONS(1895),
    [anon_sym_delete] = ACTIONS(1895),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_DQUOTE] = ACTIONS(1893),
    [anon_sym_SQUOTE] = ACTIONS(1893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1893),
    [sym_number] = ACTIONS(1893),
    [sym_this] = ACTIONS(1895),
    [sym_super] = ACTIONS(1895),
    [sym_true] = ACTIONS(1895),
    [sym_false] = ACTIONS(1895),
    [sym_null] = ACTIONS(1895),
    [sym_undefined] = ACTIONS(1895),
    [anon_sym_AT] = ACTIONS(1893),
    [anon_sym_static] = ACTIONS(1895),
    [anon_sym_abstract] = ACTIONS(1895),
    [anon_sym_get] = ACTIONS(1895),
    [anon_sym_set] = ACTIONS(1895),
    [anon_sym_declare] = ACTIONS(1895),
    [anon_sym_public] = ACTIONS(1895),
    [anon_sym_private] = ACTIONS(1895),
    [anon_sym_protected] = ACTIONS(1895),
    [anon_sym_module] = ACTIONS(1895),
    [anon_sym_any] = ACTIONS(1895),
    [anon_sym_number] = ACTIONS(1895),
    [anon_sym_boolean] = ACTIONS(1895),
    [anon_sym_string] = ACTIONS(1895),
    [anon_sym_symbol] = ACTIONS(1895),
    [anon_sym_interface] = ACTIONS(1895),
    [anon_sym_enum] = ACTIONS(1895),
    [sym_readonly] = ACTIONS(1895),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(1897),
    [sym_identifier] = ACTIONS(1899),
    [anon_sym_export] = ACTIONS(1899),
    [anon_sym_default] = ACTIONS(1899),
    [anon_sym_namespace] = ACTIONS(1899),
    [anon_sym_LBRACE] = ACTIONS(1897),
    [anon_sym_RBRACE] = ACTIONS(1897),
    [anon_sym_type] = ACTIONS(1899),
    [anon_sym_typeof] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1899),
    [anon_sym_var] = ACTIONS(1899),
    [anon_sym_let] = ACTIONS(1899),
    [anon_sym_const] = ACTIONS(1899),
    [anon_sym_BANG] = ACTIONS(1897),
    [anon_sym_else] = ACTIONS(1899),
    [anon_sym_if] = ACTIONS(1899),
    [anon_sym_switch] = ACTIONS(1899),
    [anon_sym_for] = ACTIONS(1899),
    [anon_sym_LPAREN] = ACTIONS(1897),
    [anon_sym_await] = ACTIONS(1899),
    [anon_sym_while] = ACTIONS(1899),
    [anon_sym_do] = ACTIONS(1899),
    [anon_sym_try] = ACTIONS(1899),
    [anon_sym_with] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1899),
    [anon_sym_continue] = ACTIONS(1899),
    [anon_sym_debugger] = ACTIONS(1899),
    [anon_sym_return] = ACTIONS(1899),
    [anon_sym_throw] = ACTIONS(1899),
    [anon_sym_SEMI] = ACTIONS(1897),
    [anon_sym_case] = ACTIONS(1899),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(1897),
    [anon_sym_LT] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(1899),
    [anon_sym_class] = ACTIONS(1899),
    [anon_sym_async] = ACTIONS(1899),
    [anon_sym_function] = ACTIONS(1899),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_PLUS] = ACTIONS(1899),
    [anon_sym_DASH] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1897),
    [anon_sym_void] = ACTIONS(1899),
    [anon_sym_delete] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1897),
    [anon_sym_DASH_DASH] = ACTIONS(1897),
    [anon_sym_DQUOTE] = ACTIONS(1897),
    [anon_sym_SQUOTE] = ACTIONS(1897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1897),
    [sym_number] = ACTIONS(1897),
    [sym_this] = ACTIONS(1899),
    [sym_super] = ACTIONS(1899),
    [sym_true] = ACTIONS(1899),
    [sym_false] = ACTIONS(1899),
    [sym_null] = ACTIONS(1899),
    [sym_undefined] = ACTIONS(1899),
    [anon_sym_AT] = ACTIONS(1897),
    [anon_sym_static] = ACTIONS(1899),
    [anon_sym_abstract] = ACTIONS(1899),
    [anon_sym_get] = ACTIONS(1899),
    [anon_sym_set] = ACTIONS(1899),
    [anon_sym_declare] = ACTIONS(1899),
    [anon_sym_public] = ACTIONS(1899),
    [anon_sym_private] = ACTIONS(1899),
    [anon_sym_protected] = ACTIONS(1899),
    [anon_sym_module] = ACTIONS(1899),
    [anon_sym_any] = ACTIONS(1899),
    [anon_sym_number] = ACTIONS(1899),
    [anon_sym_boolean] = ACTIONS(1899),
    [anon_sym_string] = ACTIONS(1899),
    [anon_sym_symbol] = ACTIONS(1899),
    [anon_sym_interface] = ACTIONS(1899),
    [anon_sym_enum] = ACTIONS(1899),
    [sym_readonly] = ACTIONS(1899),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(1901),
    [sym_identifier] = ACTIONS(1903),
    [anon_sym_export] = ACTIONS(1903),
    [anon_sym_default] = ACTIONS(1903),
    [anon_sym_namespace] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1901),
    [anon_sym_RBRACE] = ACTIONS(1901),
    [anon_sym_type] = ACTIONS(1903),
    [anon_sym_typeof] = ACTIONS(1903),
    [anon_sym_import] = ACTIONS(1903),
    [anon_sym_var] = ACTIONS(1903),
    [anon_sym_let] = ACTIONS(1903),
    [anon_sym_const] = ACTIONS(1903),
    [anon_sym_BANG] = ACTIONS(1901),
    [anon_sym_else] = ACTIONS(1903),
    [anon_sym_if] = ACTIONS(1903),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_for] = ACTIONS(1903),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1903),
    [anon_sym_do] = ACTIONS(1903),
    [anon_sym_try] = ACTIONS(1903),
    [anon_sym_with] = ACTIONS(1903),
    [anon_sym_break] = ACTIONS(1903),
    [anon_sym_continue] = ACTIONS(1903),
    [anon_sym_debugger] = ACTIONS(1903),
    [anon_sym_return] = ACTIONS(1903),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_SEMI] = ACTIONS(1901),
    [anon_sym_case] = ACTIONS(1903),
    [anon_sym_yield] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_LT] = ACTIONS(1901),
    [anon_sym_SLASH] = ACTIONS(1903),
    [anon_sym_class] = ACTIONS(1903),
    [anon_sym_async] = ACTIONS(1903),
    [anon_sym_function] = ACTIONS(1903),
    [anon_sym_new] = ACTIONS(1903),
    [anon_sym_PLUS] = ACTIONS(1903),
    [anon_sym_DASH] = ACTIONS(1903),
    [anon_sym_TILDE] = ACTIONS(1901),
    [anon_sym_void] = ACTIONS(1903),
    [anon_sym_delete] = ACTIONS(1903),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_DQUOTE] = ACTIONS(1901),
    [anon_sym_SQUOTE] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1901),
    [sym_number] = ACTIONS(1901),
    [sym_this] = ACTIONS(1903),
    [sym_super] = ACTIONS(1903),
    [sym_true] = ACTIONS(1903),
    [sym_false] = ACTIONS(1903),
    [sym_null] = ACTIONS(1903),
    [sym_undefined] = ACTIONS(1903),
    [anon_sym_AT] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1903),
    [anon_sym_abstract] = ACTIONS(1903),
    [anon_sym_get] = ACTIONS(1903),
    [anon_sym_set] = ACTIONS(1903),
    [anon_sym_declare] = ACTIONS(1903),
    [anon_sym_public] = ACTIONS(1903),
    [anon_sym_private] = ACTIONS(1903),
    [anon_sym_protected] = ACTIONS(1903),
    [anon_sym_module] = ACTIONS(1903),
    [anon_sym_any] = ACTIONS(1903),
    [anon_sym_number] = ACTIONS(1903),
    [anon_sym_boolean] = ACTIONS(1903),
    [anon_sym_string] = ACTIONS(1903),
    [anon_sym_symbol] = ACTIONS(1903),
    [anon_sym_interface] = ACTIONS(1903),
    [anon_sym_enum] = ACTIONS(1903),
    [sym_readonly] = ACTIONS(1903),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(1905),
    [sym_identifier] = ACTIONS(1907),
    [anon_sym_export] = ACTIONS(1907),
    [anon_sym_default] = ACTIONS(1907),
    [anon_sym_namespace] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_RBRACE] = ACTIONS(1905),
    [anon_sym_type] = ACTIONS(1907),
    [anon_sym_typeof] = ACTIONS(1907),
    [anon_sym_import] = ACTIONS(1907),
    [anon_sym_var] = ACTIONS(1907),
    [anon_sym_let] = ACTIONS(1907),
    [anon_sym_const] = ACTIONS(1907),
    [anon_sym_BANG] = ACTIONS(1905),
    [anon_sym_else] = ACTIONS(1907),
    [anon_sym_if] = ACTIONS(1907),
    [anon_sym_switch] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1907),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_await] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1907),
    [anon_sym_do] = ACTIONS(1907),
    [anon_sym_try] = ACTIONS(1907),
    [anon_sym_with] = ACTIONS(1907),
    [anon_sym_break] = ACTIONS(1907),
    [anon_sym_continue] = ACTIONS(1907),
    [anon_sym_debugger] = ACTIONS(1907),
    [anon_sym_return] = ACTIONS(1907),
    [anon_sym_throw] = ACTIONS(1907),
    [anon_sym_SEMI] = ACTIONS(1905),
    [anon_sym_case] = ACTIONS(1907),
    [anon_sym_yield] = ACTIONS(1907),
    [anon_sym_LBRACK] = ACTIONS(1905),
    [anon_sym_LT] = ACTIONS(1905),
    [anon_sym_SLASH] = ACTIONS(1907),
    [anon_sym_class] = ACTIONS(1907),
    [anon_sym_async] = ACTIONS(1907),
    [anon_sym_function] = ACTIONS(1907),
    [anon_sym_new] = ACTIONS(1907),
    [anon_sym_PLUS] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_TILDE] = ACTIONS(1905),
    [anon_sym_void] = ACTIONS(1907),
    [anon_sym_delete] = ACTIONS(1907),
    [anon_sym_PLUS_PLUS] = ACTIONS(1905),
    [anon_sym_DASH_DASH] = ACTIONS(1905),
    [anon_sym_DQUOTE] = ACTIONS(1905),
    [anon_sym_SQUOTE] = ACTIONS(1905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1905),
    [sym_number] = ACTIONS(1905),
    [sym_this] = ACTIONS(1907),
    [sym_super] = ACTIONS(1907),
    [sym_true] = ACTIONS(1907),
    [sym_false] = ACTIONS(1907),
    [sym_null] = ACTIONS(1907),
    [sym_undefined] = ACTIONS(1907),
    [anon_sym_AT] = ACTIONS(1905),
    [anon_sym_static] = ACTIONS(1907),
    [anon_sym_abstract] = ACTIONS(1907),
    [anon_sym_get] = ACTIONS(1907),
    [anon_sym_set] = ACTIONS(1907),
    [anon_sym_declare] = ACTIONS(1907),
    [anon_sym_public] = ACTIONS(1907),
    [anon_sym_private] = ACTIONS(1907),
    [anon_sym_protected] = ACTIONS(1907),
    [anon_sym_module] = ACTIONS(1907),
    [anon_sym_any] = ACTIONS(1907),
    [anon_sym_number] = ACTIONS(1907),
    [anon_sym_boolean] = ACTIONS(1907),
    [anon_sym_string] = ACTIONS(1907),
    [anon_sym_symbol] = ACTIONS(1907),
    [anon_sym_interface] = ACTIONS(1907),
    [anon_sym_enum] = ACTIONS(1907),
    [sym_readonly] = ACTIONS(1907),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(1909),
    [sym_identifier] = ACTIONS(1911),
    [anon_sym_export] = ACTIONS(1911),
    [anon_sym_default] = ACTIONS(1911),
    [anon_sym_namespace] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_RBRACE] = ACTIONS(1909),
    [anon_sym_type] = ACTIONS(1911),
    [anon_sym_typeof] = ACTIONS(1911),
    [anon_sym_import] = ACTIONS(1911),
    [anon_sym_var] = ACTIONS(1911),
    [anon_sym_let] = ACTIONS(1911),
    [anon_sym_const] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_else] = ACTIONS(1911),
    [anon_sym_if] = ACTIONS(1911),
    [anon_sym_switch] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(1911),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_await] = ACTIONS(1911),
    [anon_sym_while] = ACTIONS(1911),
    [anon_sym_do] = ACTIONS(1911),
    [anon_sym_try] = ACTIONS(1911),
    [anon_sym_with] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1911),
    [anon_sym_continue] = ACTIONS(1911),
    [anon_sym_debugger] = ACTIONS(1911),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_throw] = ACTIONS(1911),
    [anon_sym_SEMI] = ACTIONS(1909),
    [anon_sym_case] = ACTIONS(1911),
    [anon_sym_yield] = ACTIONS(1911),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_LT] = ACTIONS(1909),
    [anon_sym_SLASH] = ACTIONS(1911),
    [anon_sym_class] = ACTIONS(1911),
    [anon_sym_async] = ACTIONS(1911),
    [anon_sym_function] = ACTIONS(1911),
    [anon_sym_new] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1909),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_delete] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1909),
    [anon_sym_DQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1909),
    [sym_number] = ACTIONS(1909),
    [sym_this] = ACTIONS(1911),
    [sym_super] = ACTIONS(1911),
    [sym_true] = ACTIONS(1911),
    [sym_false] = ACTIONS(1911),
    [sym_null] = ACTIONS(1911),
    [sym_undefined] = ACTIONS(1911),
    [anon_sym_AT] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1911),
    [anon_sym_abstract] = ACTIONS(1911),
    [anon_sym_get] = ACTIONS(1911),
    [anon_sym_set] = ACTIONS(1911),
    [anon_sym_declare] = ACTIONS(1911),
    [anon_sym_public] = ACTIONS(1911),
    [anon_sym_private] = ACTIONS(1911),
    [anon_sym_protected] = ACTIONS(1911),
    [anon_sym_module] = ACTIONS(1911),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_boolean] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_interface] = ACTIONS(1911),
    [anon_sym_enum] = ACTIONS(1911),
    [sym_readonly] = ACTIONS(1911),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(1913),
    [sym_identifier] = ACTIONS(1915),
    [anon_sym_export] = ACTIONS(1915),
    [anon_sym_default] = ACTIONS(1915),
    [anon_sym_namespace] = ACTIONS(1915),
    [anon_sym_LBRACE] = ACTIONS(1913),
    [anon_sym_RBRACE] = ACTIONS(1913),
    [anon_sym_type] = ACTIONS(1915),
    [anon_sym_typeof] = ACTIONS(1915),
    [anon_sym_import] = ACTIONS(1915),
    [anon_sym_var] = ACTIONS(1915),
    [anon_sym_let] = ACTIONS(1915),
    [anon_sym_const] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_else] = ACTIONS(1915),
    [anon_sym_if] = ACTIONS(1915),
    [anon_sym_switch] = ACTIONS(1915),
    [anon_sym_for] = ACTIONS(1915),
    [anon_sym_LPAREN] = ACTIONS(1913),
    [anon_sym_await] = ACTIONS(1915),
    [anon_sym_while] = ACTIONS(1915),
    [anon_sym_do] = ACTIONS(1915),
    [anon_sym_try] = ACTIONS(1915),
    [anon_sym_with] = ACTIONS(1915),
    [anon_sym_break] = ACTIONS(1915),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_debugger] = ACTIONS(1915),
    [anon_sym_return] = ACTIONS(1915),
    [anon_sym_throw] = ACTIONS(1915),
    [anon_sym_SEMI] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1915),
    [anon_sym_yield] = ACTIONS(1915),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_LT] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1915),
    [anon_sym_class] = ACTIONS(1915),
    [anon_sym_async] = ACTIONS(1915),
    [anon_sym_function] = ACTIONS(1915),
    [anon_sym_new] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1913),
    [anon_sym_void] = ACTIONS(1915),
    [anon_sym_delete] = ACTIONS(1915),
    [anon_sym_PLUS_PLUS] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1913),
    [anon_sym_DQUOTE] = ACTIONS(1913),
    [anon_sym_SQUOTE] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1913),
    [sym_number] = ACTIONS(1913),
    [sym_this] = ACTIONS(1915),
    [sym_super] = ACTIONS(1915),
    [sym_true] = ACTIONS(1915),
    [sym_false] = ACTIONS(1915),
    [sym_null] = ACTIONS(1915),
    [sym_undefined] = ACTIONS(1915),
    [anon_sym_AT] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1915),
    [anon_sym_abstract] = ACTIONS(1915),
    [anon_sym_get] = ACTIONS(1915),
    [anon_sym_set] = ACTIONS(1915),
    [anon_sym_declare] = ACTIONS(1915),
    [anon_sym_public] = ACTIONS(1915),
    [anon_sym_private] = ACTIONS(1915),
    [anon_sym_protected] = ACTIONS(1915),
    [anon_sym_module] = ACTIONS(1915),
    [anon_sym_any] = ACTIONS(1915),
    [anon_sym_number] = ACTIONS(1915),
    [anon_sym_boolean] = ACTIONS(1915),
    [anon_sym_string] = ACTIONS(1915),
    [anon_sym_symbol] = ACTIONS(1915),
    [anon_sym_interface] = ACTIONS(1915),
    [anon_sym_enum] = ACTIONS(1915),
    [sym_readonly] = ACTIONS(1915),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(1917),
    [sym_identifier] = ACTIONS(1919),
    [anon_sym_export] = ACTIONS(1919),
    [anon_sym_default] = ACTIONS(1919),
    [anon_sym_namespace] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1917),
    [anon_sym_RBRACE] = ACTIONS(1917),
    [anon_sym_type] = ACTIONS(1919),
    [anon_sym_typeof] = ACTIONS(1919),
    [anon_sym_import] = ACTIONS(1919),
    [anon_sym_var] = ACTIONS(1919),
    [anon_sym_let] = ACTIONS(1919),
    [anon_sym_const] = ACTIONS(1919),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_else] = ACTIONS(1919),
    [anon_sym_if] = ACTIONS(1919),
    [anon_sym_switch] = ACTIONS(1919),
    [anon_sym_for] = ACTIONS(1919),
    [anon_sym_LPAREN] = ACTIONS(1917),
    [anon_sym_await] = ACTIONS(1919),
    [anon_sym_while] = ACTIONS(1919),
    [anon_sym_do] = ACTIONS(1919),
    [anon_sym_try] = ACTIONS(1919),
    [anon_sym_with] = ACTIONS(1919),
    [anon_sym_break] = ACTIONS(1919),
    [anon_sym_continue] = ACTIONS(1919),
    [anon_sym_debugger] = ACTIONS(1919),
    [anon_sym_return] = ACTIONS(1919),
    [anon_sym_throw] = ACTIONS(1919),
    [anon_sym_SEMI] = ACTIONS(1917),
    [anon_sym_case] = ACTIONS(1919),
    [anon_sym_yield] = ACTIONS(1919),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(1919),
    [anon_sym_class] = ACTIONS(1919),
    [anon_sym_async] = ACTIONS(1919),
    [anon_sym_function] = ACTIONS(1919),
    [anon_sym_new] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_void] = ACTIONS(1919),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [anon_sym_SQUOTE] = ACTIONS(1917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1917),
    [sym_number] = ACTIONS(1917),
    [sym_this] = ACTIONS(1919),
    [sym_super] = ACTIONS(1919),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [sym_null] = ACTIONS(1919),
    [sym_undefined] = ACTIONS(1919),
    [anon_sym_AT] = ACTIONS(1917),
    [anon_sym_static] = ACTIONS(1919),
    [anon_sym_abstract] = ACTIONS(1919),
    [anon_sym_get] = ACTIONS(1919),
    [anon_sym_set] = ACTIONS(1919),
    [anon_sym_declare] = ACTIONS(1919),
    [anon_sym_public] = ACTIONS(1919),
    [anon_sym_private] = ACTIONS(1919),
    [anon_sym_protected] = ACTIONS(1919),
    [anon_sym_module] = ACTIONS(1919),
    [anon_sym_any] = ACTIONS(1919),
    [anon_sym_number] = ACTIONS(1919),
    [anon_sym_boolean] = ACTIONS(1919),
    [anon_sym_string] = ACTIONS(1919),
    [anon_sym_symbol] = ACTIONS(1919),
    [anon_sym_interface] = ACTIONS(1919),
    [anon_sym_enum] = ACTIONS(1919),
    [sym_readonly] = ACTIONS(1919),
  },
  [562] = {
    [ts_builtin_sym_end] = ACTIONS(995),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(997),
    [anon_sym_default] = ACTIONS(997),
    [anon_sym_namespace] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_RBRACE] = ACTIONS(995),
    [anon_sym_type] = ACTIONS(997),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(997),
    [anon_sym_var] = ACTIONS(997),
    [anon_sym_let] = ACTIONS(997),
    [anon_sym_const] = ACTIONS(997),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_else] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_switch] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_await] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_try] = ACTIONS(997),
    [anon_sym_with] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_debugger] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_throw] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_case] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_class] = ACTIONS(997),
    [anon_sym_async] = ACTIONS(997),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_new] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_void] = ACTIONS(997),
    [anon_sym_delete] = ACTIONS(997),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_SQUOTE] = ACTIONS(995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [sym_number] = ACTIONS(995),
    [sym_this] = ACTIONS(997),
    [sym_super] = ACTIONS(997),
    [sym_true] = ACTIONS(997),
    [sym_false] = ACTIONS(997),
    [sym_null] = ACTIONS(997),
    [sym_undefined] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_static] = ACTIONS(997),
    [anon_sym_abstract] = ACTIONS(997),
    [anon_sym_get] = ACTIONS(997),
    [anon_sym_set] = ACTIONS(997),
    [anon_sym_declare] = ACTIONS(997),
    [anon_sym_public] = ACTIONS(997),
    [anon_sym_private] = ACTIONS(997),
    [anon_sym_protected] = ACTIONS(997),
    [anon_sym_module] = ACTIONS(997),
    [anon_sym_any] = ACTIONS(997),
    [anon_sym_number] = ACTIONS(997),
    [anon_sym_boolean] = ACTIONS(997),
    [anon_sym_string] = ACTIONS(997),
    [anon_sym_symbol] = ACTIONS(997),
    [anon_sym_interface] = ACTIONS(997),
    [anon_sym_enum] = ACTIONS(997),
    [sym_readonly] = ACTIONS(997),
  },
  [563] = {
    [ts_builtin_sym_end] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1923),
    [anon_sym_export] = ACTIONS(1923),
    [anon_sym_default] = ACTIONS(1923),
    [anon_sym_namespace] = ACTIONS(1923),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(1921),
    [anon_sym_type] = ACTIONS(1923),
    [anon_sym_typeof] = ACTIONS(1923),
    [anon_sym_import] = ACTIONS(1923),
    [anon_sym_var] = ACTIONS(1923),
    [anon_sym_let] = ACTIONS(1923),
    [anon_sym_const] = ACTIONS(1923),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_else] = ACTIONS(1923),
    [anon_sym_if] = ACTIONS(1923),
    [anon_sym_switch] = ACTIONS(1923),
    [anon_sym_for] = ACTIONS(1923),
    [anon_sym_LPAREN] = ACTIONS(1921),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_while] = ACTIONS(1923),
    [anon_sym_do] = ACTIONS(1923),
    [anon_sym_try] = ACTIONS(1923),
    [anon_sym_with] = ACTIONS(1923),
    [anon_sym_break] = ACTIONS(1923),
    [anon_sym_continue] = ACTIONS(1923),
    [anon_sym_debugger] = ACTIONS(1923),
    [anon_sym_return] = ACTIONS(1923),
    [anon_sym_throw] = ACTIONS(1923),
    [anon_sym_SEMI] = ACTIONS(1921),
    [anon_sym_case] = ACTIONS(1923),
    [anon_sym_yield] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1921),
    [anon_sym_LT] = ACTIONS(1921),
    [anon_sym_SLASH] = ACTIONS(1923),
    [anon_sym_class] = ACTIONS(1923),
    [anon_sym_async] = ACTIONS(1923),
    [anon_sym_function] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1923),
    [anon_sym_PLUS] = ACTIONS(1923),
    [anon_sym_DASH] = ACTIONS(1923),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_void] = ACTIONS(1923),
    [anon_sym_delete] = ACTIONS(1923),
    [anon_sym_PLUS_PLUS] = ACTIONS(1921),
    [anon_sym_DASH_DASH] = ACTIONS(1921),
    [anon_sym_DQUOTE] = ACTIONS(1921),
    [anon_sym_SQUOTE] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1921),
    [sym_number] = ACTIONS(1921),
    [sym_this] = ACTIONS(1923),
    [sym_super] = ACTIONS(1923),
    [sym_true] = ACTIONS(1923),
    [sym_false] = ACTIONS(1923),
    [sym_null] = ACTIONS(1923),
    [sym_undefined] = ACTIONS(1923),
    [anon_sym_AT] = ACTIONS(1921),
    [anon_sym_static] = ACTIONS(1923),
    [anon_sym_abstract] = ACTIONS(1923),
    [anon_sym_get] = ACTIONS(1923),
    [anon_sym_set] = ACTIONS(1923),
    [anon_sym_declare] = ACTIONS(1923),
    [anon_sym_public] = ACTIONS(1923),
    [anon_sym_private] = ACTIONS(1923),
    [anon_sym_protected] = ACTIONS(1923),
    [anon_sym_module] = ACTIONS(1923),
    [anon_sym_any] = ACTIONS(1923),
    [anon_sym_number] = ACTIONS(1923),
    [anon_sym_boolean] = ACTIONS(1923),
    [anon_sym_string] = ACTIONS(1923),
    [anon_sym_symbol] = ACTIONS(1923),
    [anon_sym_interface] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1923),
    [sym_readonly] = ACTIONS(1923),
  },
  [564] = {
    [ts_builtin_sym_end] = ACTIONS(1145),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(1147),
    [anon_sym_namespace] = ACTIONS(1147),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_type] = ACTIONS(1147),
    [anon_sym_typeof] = ACTIONS(1147),
    [anon_sym_import] = ACTIONS(1147),
    [anon_sym_var] = ACTIONS(1147),
    [anon_sym_let] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1145),
    [anon_sym_else] = ACTIONS(1147),
    [anon_sym_if] = ACTIONS(1147),
    [anon_sym_switch] = ACTIONS(1147),
    [anon_sym_for] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_while] = ACTIONS(1147),
    [anon_sym_do] = ACTIONS(1147),
    [anon_sym_try] = ACTIONS(1147),
    [anon_sym_with] = ACTIONS(1147),
    [anon_sym_break] = ACTIONS(1147),
    [anon_sym_continue] = ACTIONS(1147),
    [anon_sym_debugger] = ACTIONS(1147),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_throw] = ACTIONS(1147),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_case] = ACTIONS(1147),
    [anon_sym_yield] = ACTIONS(1147),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_class] = ACTIONS(1147),
    [anon_sym_async] = ACTIONS(1147),
    [anon_sym_function] = ACTIONS(1147),
    [anon_sym_new] = ACTIONS(1147),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1147),
    [anon_sym_TILDE] = ACTIONS(1145),
    [anon_sym_void] = ACTIONS(1147),
    [anon_sym_delete] = ACTIONS(1147),
    [anon_sym_PLUS_PLUS] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1145),
    [anon_sym_SQUOTE] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [sym_number] = ACTIONS(1145),
    [sym_this] = ACTIONS(1147),
    [sym_super] = ACTIONS(1147),
    [sym_true] = ACTIONS(1147),
    [sym_false] = ACTIONS(1147),
    [sym_null] = ACTIONS(1147),
    [sym_undefined] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(1145),
    [anon_sym_static] = ACTIONS(1147),
    [anon_sym_abstract] = ACTIONS(1147),
    [anon_sym_get] = ACTIONS(1147),
    [anon_sym_set] = ACTIONS(1147),
    [anon_sym_declare] = ACTIONS(1147),
    [anon_sym_public] = ACTIONS(1147),
    [anon_sym_private] = ACTIONS(1147),
    [anon_sym_protected] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(1147),
    [anon_sym_any] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(1147),
    [anon_sym_interface] = ACTIONS(1147),
    [anon_sym_enum] = ACTIONS(1147),
    [sym_readonly] = ACTIONS(1147),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1927),
    [anon_sym_export] = ACTIONS(1927),
    [anon_sym_default] = ACTIONS(1927),
    [anon_sym_namespace] = ACTIONS(1927),
    [anon_sym_LBRACE] = ACTIONS(1925),
    [anon_sym_RBRACE] = ACTIONS(1925),
    [anon_sym_type] = ACTIONS(1927),
    [anon_sym_typeof] = ACTIONS(1927),
    [anon_sym_import] = ACTIONS(1927),
    [anon_sym_var] = ACTIONS(1927),
    [anon_sym_let] = ACTIONS(1927),
    [anon_sym_const] = ACTIONS(1927),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(1927),
    [anon_sym_if] = ACTIONS(1927),
    [anon_sym_switch] = ACTIONS(1927),
    [anon_sym_for] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_await] = ACTIONS(1927),
    [anon_sym_while] = ACTIONS(1927),
    [anon_sym_do] = ACTIONS(1927),
    [anon_sym_try] = ACTIONS(1927),
    [anon_sym_with] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1927),
    [anon_sym_continue] = ACTIONS(1927),
    [anon_sym_debugger] = ACTIONS(1927),
    [anon_sym_return] = ACTIONS(1927),
    [anon_sym_throw] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(1925),
    [anon_sym_case] = ACTIONS(1927),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(1925),
    [anon_sym_SLASH] = ACTIONS(1927),
    [anon_sym_class] = ACTIONS(1927),
    [anon_sym_async] = ACTIONS(1927),
    [anon_sym_function] = ACTIONS(1927),
    [anon_sym_new] = ACTIONS(1927),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_TILDE] = ACTIONS(1925),
    [anon_sym_void] = ACTIONS(1927),
    [anon_sym_delete] = ACTIONS(1927),
    [anon_sym_PLUS_PLUS] = ACTIONS(1925),
    [anon_sym_DASH_DASH] = ACTIONS(1925),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1925),
    [sym_number] = ACTIONS(1925),
    [sym_this] = ACTIONS(1927),
    [sym_super] = ACTIONS(1927),
    [sym_true] = ACTIONS(1927),
    [sym_false] = ACTIONS(1927),
    [sym_null] = ACTIONS(1927),
    [sym_undefined] = ACTIONS(1927),
    [anon_sym_AT] = ACTIONS(1925),
    [anon_sym_static] = ACTIONS(1927),
    [anon_sym_abstract] = ACTIONS(1927),
    [anon_sym_get] = ACTIONS(1927),
    [anon_sym_set] = ACTIONS(1927),
    [anon_sym_declare] = ACTIONS(1927),
    [anon_sym_public] = ACTIONS(1927),
    [anon_sym_private] = ACTIONS(1927),
    [anon_sym_protected] = ACTIONS(1927),
    [anon_sym_module] = ACTIONS(1927),
    [anon_sym_any] = ACTIONS(1927),
    [anon_sym_number] = ACTIONS(1927),
    [anon_sym_boolean] = ACTIONS(1927),
    [anon_sym_string] = ACTIONS(1927),
    [anon_sym_symbol] = ACTIONS(1927),
    [anon_sym_interface] = ACTIONS(1927),
    [anon_sym_enum] = ACTIONS(1927),
    [sym_readonly] = ACTIONS(1927),
  },
  [566] = {
    [sym_object] = STATE(2624),
    [sym_array] = STATE(2621),
    [sym_nested_identifier] = STATE(3514),
    [sym_string] = STATE(453),
    [sym_formal_parameters] = STATE(3565),
    [sym_nested_type_identifier] = STATE(2023),
    [sym__type] = STATE(3018),
    [sym_constructor_type] = STATE(3018),
    [sym__primary_type] = STATE(2823),
    [sym_infer_type] = STATE(3018),
    [sym_conditional_type] = STATE(2823),
    [sym_generic_type] = STATE(2823),
    [sym_type_query] = STATE(2823),
    [sym_index_type_query] = STATE(2823),
    [sym_lookup_type] = STATE(2823),
    [sym_literal_type] = STATE(2823),
    [sym__number] = STATE(453),
    [sym_existential_type] = STATE(2823),
    [sym_flow_maybe_type] = STATE(2823),
    [sym_parenthesized_type] = STATE(2823),
    [sym_predefined_type] = STATE(2823),
    [sym_object_type] = STATE(2823),
    [sym_type_parameters] = STATE(3299),
    [sym_array_type] = STATE(2823),
    [sym__tuple_type_body] = STATE(434),
    [sym_tuple_type] = STATE(2823),
    [sym_union_type] = STATE(3018),
    [sym_intersection_type] = STATE(3018),
    [sym_function_type] = STATE(3018),
    [sym_identifier] = ACTIONS(851),
    [anon_sym_export] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_EQ] = ACTIONS(1794),
    [anon_sym_namespace] = ACTIONS(853),
    [anon_sym_LBRACE] = ACTIONS(862),
    [anon_sym_COMMA] = ACTIONS(1794),
    [anon_sym_type] = ACTIONS(853),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_RPAREN] = ACTIONS(1794),
    [anon_sym_COLON] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1713),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(903),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [anon_sym_static] = ACTIONS(853),
    [anon_sym_get] = ACTIONS(853),
    [anon_sym_set] = ACTIONS(853),
    [anon_sym_declare] = ACTIONS(853),
    [anon_sym_public] = ACTIONS(853),
    [anon_sym_private] = ACTIONS(853),
    [anon_sym_protected] = ACTIONS(853),
    [anon_sym_module] = ACTIONS(853),
    [anon_sym_any] = ACTIONS(907),
    [anon_sym_number] = ACTIONS(907),
    [anon_sym_boolean] = ACTIONS(907),
    [anon_sym_string] = ACTIONS(907),
    [anon_sym_symbol] = ACTIONS(907),
    [sym_readonly] = ACTIONS(909),
    [anon_sym_infer] = ACTIONS(521),
    [anon_sym_keyof] = ACTIONS(523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(525),
  },
  [567] = {
    [ts_builtin_sym_end] = ACTIONS(1929),
    [sym_identifier] = ACTIONS(1931),
    [anon_sym_export] = ACTIONS(1931),
    [anon_sym_default] = ACTIONS(1931),
    [anon_sym_namespace] = ACTIONS(1931),
    [anon_sym_LBRACE] = ACTIONS(1929),
    [anon_sym_RBRACE] = ACTIONS(1929),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_typeof] = ACTIONS(1931),
    [anon_sym_import] = ACTIONS(1931),
    [anon_sym_var] = ACTIONS(1931),
    [anon_sym_let] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(1931),
    [anon_sym_BANG] = ACTIONS(1929),
    [anon_sym_else] = ACTIONS(1931),
    [anon_sym_if] = ACTIONS(1931),
    [anon_sym_switch] = ACTIONS(1931),
    [anon_sym_for] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(1929),
    [anon_sym_await] = ACTIONS(1931),
    [anon_sym_while] = ACTIONS(1931),
    [anon_sym_do] = ACTIONS(1931),
    [anon_sym_try] = ACTIONS(1931),
    [anon_sym_with] = ACTIONS(1931),
    [anon_sym_break] = ACTIONS(1931),
    [anon_sym_continue] = ACTIONS(1931),
    [anon_sym_debugger] = ACTIONS(1931),
    [anon_sym_return] = ACTIONS(1931),
    [anon_sym_throw] = ACTIONS(1931),
    [anon_sym_SEMI] = ACTIONS(1929),
    [anon_sym_case] = ACTIONS(1931),
    [anon_sym_yield] = ACTIONS(1931),
    [anon_sym_LBRACK] = ACTIONS(1929),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_SLASH] = ACTIONS(1931),
    [anon_sym_class] = ACTIONS(1931),
    [anon_sym_async] = ACTIONS(1931),
    [anon_sym_function] = ACTIONS(1931),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_TILDE] = ACTIONS(1929),
    [anon_sym_void] = ACTIONS(1931),
    [anon_sym_delete] = ACTIONS(1931),
    [anon_sym_PLUS_PLUS] = ACTIONS(1929),
    [anon_sym_DASH_DASH] = ACTIONS(1929),
    [anon_sym_DQUOTE] = ACTIONS(1929),
    [anon_sym_SQUOTE] = ACTIONS(1929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1929),
    [sym_number] = ACTIONS(1929),
    [sym_this] = ACTIONS(1931),
    [sym_super] = ACTIONS(1931),
    [sym_true] = ACTIONS(1931),
    [sym_false] = ACTIONS(1931),
    [sym_null] = ACTIONS(1931),
    [sym_undefined] = ACTIONS(1931),
    [anon_sym_AT] = ACTIONS(1929),
    [anon_sym_static] = ACTIONS(1931),
    [anon_sym_abstract] = ACTIONS(1931),
    [anon_sym_get] = ACTIONS(1931),
    [anon_sym_set] = ACTIONS(1931),
    [anon_sym_declare] = ACTIONS(1931),
    [anon_sym_public] = ACTIONS(1931),
    [anon_sym_private] = ACTIONS(1931),
    [anon_sym_protected] = ACTIONS(1931),
    [anon_sym_module] = ACTIONS(1931),
    [anon_sym_any] = ACTIONS(1931),
    [anon_sym_number] = ACTIONS(1931),
    [anon_sym_boolean] = ACTIONS(1931),
    [anon_sym_string] = ACTIONS(1931),
    [anon_sym_symbol] = ACTIONS(1931),
    [anon_sym_interface] = ACTIONS(1931),
    [anon_sym_enum] = ACTIONS(1931),
    [sym_readonly] = ACTIONS(1931),
  },
  [568] = {
    [ts_builtin_sym_end] = ACTIONS(1933),
    [sym_identifier] = ACTIONS(1935),
    [anon_sym_export] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1935),
    [anon_sym_namespace] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1933),
    [anon_sym_RBRACE] = ACTIONS(1933),
    [anon_sym_type] = ACTIONS(1935),
    [anon_sym_typeof] = ACTIONS(1935),
    [anon_sym_import] = ACTIONS(1935),
    [anon_sym_var] = ACTIONS(1935),
    [anon_sym_let] = ACTIONS(1935),
    [anon_sym_const] = ACTIONS(1935),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_else] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(1935),
    [anon_sym_switch] = ACTIONS(1935),
    [anon_sym_for] = ACTIONS(1935),
    [anon_sym_LPAREN] = ACTIONS(1933),
    [anon_sym_await] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1935),
    [anon_sym_do] = ACTIONS(1935),
    [anon_sym_try] = ACTIONS(1935),
    [anon_sym_with] = ACTIONS(1935),
    [anon_sym_break] = ACTIONS(1935),
    [anon_sym_continue] = ACTIONS(1935),
    [anon_sym_debugger] = ACTIONS(1935),
    [anon_sym_return] = ACTIONS(1935),
    [anon_sym_throw] = ACTIONS(1935),
    [anon_sym_SEMI] = ACTIONS(1933),
    [anon_sym_case] = ACTIONS(1935),
    [anon_sym_yield] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(1933),
    [anon_sym_LT] = ACTIONS(1933),
    [anon_sym_SLASH] = ACTIONS(1935),
    [anon_sym_class] = ACTIONS(1935),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_function] = ACTIONS(1935),
    [anon_sym_new] = ACTIONS(1935),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_DASH] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_void] = ACTIONS(1935),
    [anon_sym_delete] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1933),
    [anon_sym_DASH_DASH] = ACTIONS(1933),
    [anon_sym_DQUOTE] = ACTIONS(1933),
    [anon_sym_SQUOTE] = ACTIONS(1933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1933),
    [sym_number] = ACTIONS(1933),
    [sym_this] = ACTIONS(1935),
    [sym_super] = ACTIONS(1935),
    [sym_true] = ACTIONS(1935),
    [sym_false] = ACTIONS(1935),
    [sym_null] = ACTIONS(1935),
    [sym_undefined] = ACTIONS(1935),
    [anon_sym_AT] = ACTIONS(1933),
    [anon_sym_static] = ACTIONS(1935),
    [anon_sym_abstract] = ACTIONS(1935),
    [anon_sym_get] = ACTIONS(1935),
    [anon_sym_set] = ACTIONS(1935),
    [anon_sym_declare] = ACTIONS(1935),
    [anon_sym_public] = ACTIONS(1935),
    [anon_sym_private] = ACTIONS(1935),
    [anon_sym_protected] = ACTIONS(1935),
    [anon_sym_module] = ACTIONS(1935),
    [anon_sym_any] = ACTIONS(1935),
    [anon_sym_number] = ACTIONS(1935),
    [anon_sym_boolean] = ACTIONS(1935),
    [anon_sym_string] = ACTIONS(1935),
    [anon_sym_symbol] = ACTIONS(1935),
    [anon_sym_interface] = ACTIONS(1935),
    [anon_sym_enum] = ACTIONS(1935),
    [sym_readonly] = ACTIONS(1935),
  },
  [569] = {
    [ts_builtin_sym_end] = ACTIONS(1937),
    [sym_identifier] = ACTIONS(1939),
    [anon_sym_export] = ACTIONS(1939),
    [anon_sym_default] = ACTIONS(1939),
    [anon_sym_namespace] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_RBRACE] = ACTIONS(1937),
    [anon_sym_type] = ACTIONS(1939),
    [anon_sym_typeof] = ACTIONS(1939),
    [anon_sym_import] = ACTIONS(1939),
    [anon_sym_var] = ACTIONS(1939),
    [anon_sym_let] = ACTIONS(1939),
    [anon_sym_const] = ACTIONS(1939),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_else] = ACTIONS(1939),
    [anon_sym_if] = ACTIONS(1939),
    [anon_sym_switch] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(1939),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_await] = ACTIONS(1939),
    [anon_sym_while] = ACTIONS(1939),
    [anon_sym_do] = ACTIONS(1939),
    [anon_sym_try] = ACTIONS(1939),
    [anon_sym_with] = ACTIONS(1939),
    [anon_sym_break] = ACTIONS(1939),
    [anon_sym_continue] = ACTIONS(1939),
    [anon_sym_debugger] = ACTIONS(1939),
    [anon_sym_return] = ACTIONS(1939),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_SEMI] = ACTIONS(1937),
    [anon_sym_case] = ACTIONS(1939),
    [anon_sym_yield] = ACTIONS(1939),
    [anon_sym_LBRACK] = ACTIONS(1937),
    [anon_sym_LT] = ACTIONS(1937),
    [anon_sym_SLASH] = ACTIONS(1939),
    [anon_sym_class] = ACTIONS(1939),
    [anon_sym_async] = ACTIONS(1939),
    [anon_sym_function] = ACTIONS(1939),
    [anon_sym_new] = ACTIONS(1939),
    [anon_sym_PLUS] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1939),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_void] = ACTIONS(1939),
    [anon_sym_delete] = ACTIONS(1939),
    [anon_sym_PLUS_PLUS] = ACTIONS(1937),
    [anon_sym_DASH_DASH] = ACTIONS(1937),
    [anon_sym_DQUOTE] = ACTIONS(1937),
    [anon_sym_SQUOTE] = ACTIONS(1937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1937),
    [sym_number] = ACTIONS(1937),
    [sym_this] = ACTIONS(1939),
    [sym_super] = ACTIONS(1939),
    [sym_true] = ACTIONS(1939),
    [sym_false] = ACTIONS(1939),
    [sym_null] = ACTIONS(1939),
    [sym_undefined] = ACTIONS(1939),
    [anon_sym_AT] = ACTIONS(1937),
    [anon_sym_static] = ACTIONS(1939),
    [anon_sym_abstract] = ACTIONS(1939),
    [anon_sym_get] = ACTIONS(1939),
    [anon_sym_set] = ACTIONS(1939),
    [anon_sym_declare] = ACTIONS(1939),
    [anon_sym_public] = ACTIONS(1939),
    [anon_sym_private] = ACTIONS(1939),
    [anon_sym_protected] = ACTIONS(1939),
    [anon_sym_module] = ACTIONS(1939),
    [anon_sym_any] = ACTIONS(1939),
    [anon_sym_number] = ACTIONS(1939),
    [anon_sym_boolean] = ACTIONS(1939),
    [anon_sym_string] = ACTIONS(1939),
    [anon_sym_symbol] = ACTIONS(1939),
    [anon_sym_interface] = ACTIONS(1939),
    [anon_sym_enum] = ACTIONS(1939),
    [sym_readonly] = ACTIONS(1939),
  },
  [570] = {
    [ts_builtin_sym_end] = ACTIONS(1941),
    [sym_identifier] = ACTIONS(1943),
    [anon_sym_export] = ACTIONS(1943),
    [anon_sym_default] = ACTIONS(1943),
    [anon_sym_namespace] = ACTIONS(1943),
    [anon_sym_LBRACE] = ACTIONS(1941),
    [anon_sym_RBRACE] = ACTIONS(1941),
    [anon_sym_type] = ACTIONS(1943),
    [anon_sym_typeof] = ACTIONS(1943),
    [anon_sym_import] = ACTIONS(1943),
    [anon_sym_var] = ACTIONS(1943),
    [anon_sym_let] = ACTIONS(1943),
    [anon_sym_const] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1941),
    [anon_sym_else] = ACTIONS(1943),
    [anon_sym_if] = ACTIONS(1943),
    [anon_sym_switch] = ACTIONS(1943),
    [anon_sym_for] = ACTIONS(1943),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_await] = ACTIONS(1943),
    [anon_sym_while] = ACTIONS(1943),
    [anon_sym_do] = ACTIONS(1943),
    [anon_sym_try] = ACTIONS(1943),
    [anon_sym_with] = ACTIONS(1943),
    [anon_sym_break] = ACTIONS(1943),
    [anon_sym_continue] = ACTIONS(1943),
    [anon_sym_debugger] = ACTIONS(1943),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_throw] = ACTIONS(1943),
    [anon_sym_SEMI] = ACTIONS(1941),
    [anon_sym_case] = ACTIONS(1943),
    [anon_sym_yield] = ACTIONS(1943),
    [anon_sym_LBRACK] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(1941),
    [anon_sym_SLASH] = ACTIONS(1943),
    [anon_sym_class] = ACTIONS(1943),
    [anon_sym_async] = ACTIONS(1943),
    [anon_sym_function] = ACTIONS(1943),
    [anon_sym_new] = ACTIONS(1943),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_TILDE] = ACTIONS(1941),
    [anon_sym_void] = ACTIONS(1943),
    [anon_sym_delete] = ACTIONS(1943),
    [anon_sym_PLUS_PLUS] = ACTIONS(1941),
    [anon_sym_DASH_DASH] = ACTIONS(1941),
    [anon_sym_DQUOTE] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1941),
    [sym_number] = ACTIONS(1941),
    [sym_this] = ACTIONS(1943),
    [sym_super] = ACTIONS(1943),
    [sym_true] = ACTIONS(1943),
    [sym_false] = ACTIONS(1943),
    [sym_null] = ACTIONS(1943),
    [sym_undefined] = ACTIONS(1943),
    [anon_sym_AT] = ACTIONS(1941),
    [anon_sym_static] = ACTIONS(1943),
    [anon_sym_abstract] = ACTIONS(1943),
    [anon_sym_get] = ACTIONS(1943),
    [anon_sym_set] = ACTIONS(1943),
    [anon_sym_declare] = ACTIONS(1943),
    [anon_sym_public] = ACTIONS(1943),
    [anon_sym_private] = ACTIONS(1943),
    [anon_sym_protected] = ACTIONS(1943),
    [anon_sym_module] = ACTIONS(1943),
    [anon_sym_any] = ACTIONS(1943),
    [anon_sym_number] = ACTIONS(1943),
    [anon_sym_boolean] = ACTIONS(1943),
    [anon_sym_string] = ACTIONS(1943),
    [anon_sym_symbol] = ACTIONS(1943),
    [anon_sym_interface] = ACTIONS(1943),
    [anon_sym_enum] = ACTIONS(1943),
    [sym_readonly] = ACTIONS(1943),
  },
  [571] = {
    [ts_builtin_sym_end] = ACTIONS(1945),
    [sym_identifier] = ACTIONS(1947),
    [anon_sym_export] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_namespace] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_type] = ACTIONS(1947),
    [anon_sym_typeof] = ACTIONS(1947),
    [anon_sym_import] = ACTIONS(1947),
    [anon_sym_var] = ACTIONS(1947),
    [anon_sym_let] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_else] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_switch] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_await] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_do] = ACTIONS(1947),
    [anon_sym_try] = ACTIONS(1947),
    [anon_sym_with] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_debugger] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_throw] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym_case] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1945),
    [anon_sym_LT] = ACTIONS(1945),
    [anon_sym_SLASH] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_async] = ACTIONS(1947),
    [anon_sym_function] = ACTIONS(1947),
    [anon_sym_new] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_void] = ACTIONS(1947),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1945),
    [sym_number] = ACTIONS(1945),
    [sym_this] = ACTIONS(1947),
    [sym_super] = ACTIONS(1947),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [sym_null] = ACTIONS(1947),
    [sym_undefined] = ACTIONS(1947),
    [anon_sym_AT] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_abstract] = ACTIONS(1947),
    [anon_sym_get] = ACTIONS(1947),
    [anon_sym_set] = ACTIONS(1947),
    [anon_sym_declare] = ACTIONS(1947),
    [anon_sym_public] = ACTIONS(1947),
    [anon_sym_private] = ACTIONS(1947),
    [anon_sym_protected] = ACTIONS(1947),
    [anon_sym_module] = ACTIONS(1947),
    [anon_sym_any] = ACTIONS(1947),
    [anon_sym_number] = ACTIONS(1947),
    [anon_sym_boolean] = ACTIONS(1947),
    [anon_sym_string] = ACTIONS(1947),
    [anon_sym_symbol] = ACTIONS(1947),
    [anon_sym_interface] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [sym_readonly] = ACTIONS(1947),
  },
  [572] = {
    [ts_builtin_sym_end] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_export] = ACTIONS(1951),
    [anon_sym_default] = ACTIONS(1951),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_RBRACE] = ACTIONS(1949),
    [anon_sym_type] = ACTIONS(1951),
    [anon_sym_typeof] = ACTIONS(1951),
    [anon_sym_import] = ACTIONS(1951),
    [anon_sym_var] = ACTIONS(1951),
    [anon_sym_let] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_else] = ACTIONS(1951),
    [anon_sym_if] = ACTIONS(1951),
    [anon_sym_switch] = ACTIONS(1951),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_LPAREN] = ACTIONS(1949),
    [anon_sym_await] = ACTIONS(1951),
    [anon_sym_while] = ACTIONS(1951),
    [anon_sym_do] = ACTIONS(1951),
    [anon_sym_try] = ACTIONS(1951),
    [anon_sym_with] = ACTIONS(1951),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_continue] = ACTIONS(1951),
    [anon_sym_debugger] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1951),
    [anon_sym_throw] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(1949),
    [anon_sym_case] = ACTIONS(1951),
    [anon_sym_yield] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1949),
    [anon_sym_LT] = ACTIONS(1949),
    [anon_sym_SLASH] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_async] = ACTIONS(1951),
    [anon_sym_function] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1951),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_DASH] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_void] = ACTIONS(1951),
    [anon_sym_delete] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1949),
    [anon_sym_DASH_DASH] = ACTIONS(1949),
    [anon_sym_DQUOTE] = ACTIONS(1949),
    [anon_sym_SQUOTE] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1949),
    [sym_number] = ACTIONS(1949),
    [sym_this] = ACTIONS(1951),
    [sym_super] = ACTIONS(1951),
    [sym_true] = ACTIONS(1951),
    [sym_false] = ACTIONS(1951),
    [sym_null] = ACTIONS(1951),
    [sym_undefined] = ACTIONS(1951),
    [anon_sym_AT] = ACTIONS(1949),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_abstract] = ACTIONS(1951),
    [anon_sym_get] = ACTIONS(1951),
    [anon_sym_set] = ACTIONS(1951),
    [anon_sym_declare] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_module] = ACTIONS(1951),
    [anon_sym_any] = ACTIONS(1951),
    [anon_sym_number] = ACTIONS(1951),
    [anon_sym_boolean] = ACTIONS(1951),
    [anon_sym_string] = ACTIONS(1951),
    [anon_sym_symbol] = ACTIONS(1951),
    [anon_sym_interface] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [sym_readonly] = ACTIONS(1951),
  },
  [573] = {
    [ts_builtin_sym_end] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1955),
    [anon_sym_export] = ACTIONS(1955),
    [anon_sym_default] = ACTIONS(1955),
    [anon_sym_namespace] = ACTIONS(1955),
    [anon_sym_LBRACE] = ACTIONS(1953),
    [anon_sym_RBRACE] = ACTIONS(1953),
    [anon_sym_type] = ACTIONS(1955),
    [anon_sym_typeof] = ACTIONS(1955),
    [anon_sym_import] = ACTIONS(1955),
    [anon_sym_var] = ACTIONS(1955),
    [anon_sym_let] = ACTIONS(1955),
    [anon_sym_const] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1955),
    [anon_sym_if] = ACTIONS(1955),
    [anon_sym_switch] = ACTIONS(1955),
    [anon_sym_for] = ACTIONS(1955),
    [anon_sym_LPAREN] = ACTIONS(1953),
    [anon_sym_await] = ACTIONS(1955),
    [anon_sym_while] = ACTIONS(1955),
    [anon_sym_do] = ACTIONS(1955),
    [anon_sym_try] = ACTIONS(1955),
    [anon_sym_with] = ACTIONS(1955),
    [anon_sym_break] = ACTIONS(1955),
    [anon_sym_continue] = ACTIONS(1955),
    [anon_sym_debugger] = ACTIONS(1955),
    [anon_sym_return] = ACTIONS(1955),
    [anon_sym_throw] = ACTIONS(1955),
    [anon_sym_SEMI] = ACTIONS(1953),
    [anon_sym_case] = ACTIONS(1955),
    [anon_sym_yield] = ACTIONS(1955),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_SLASH] = ACTIONS(1955),
    [anon_sym_class] = ACTIONS(1955),
    [anon_sym_async] = ACTIONS(1955),
    [anon_sym_function] = ACTIONS(1955),
    [anon_sym_new] = ACTIONS(1955),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1953),
    [anon_sym_void] = ACTIONS(1955),
    [anon_sym_delete] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1953),
    [anon_sym_DASH_DASH] = ACTIONS(1953),
    [anon_sym_DQUOTE] = ACTIONS(1953),
    [anon_sym_SQUOTE] = ACTIONS(1953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1953),
    [sym_number] = ACTIONS(1953),
    [sym_this] = ACTIONS(1955),
    [sym_super] = ACTIONS(1955),
    [sym_true] = ACTIONS(1955),
    [sym_false] = ACTIONS(1955),
    [sym_null] = ACTIONS(1955),
    [sym_undefined] = ACTIONS(1955),
    [anon_sym_AT] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1955),
    [anon_sym_abstract] = ACTIONS(1955),
    [anon_sym_get] = ACTIONS(1955),
    [anon_sym_set] = ACTIONS(1955),
    [anon_sym_declare] = ACTIONS(1955),
    [anon_sym_public] = ACTIONS(1955),
    [anon_sym_private] = ACTIONS(1955),
    [anon_sym_protected] = ACTIONS(1955),
    [anon_sym_module] = ACTIONS(1955),
    [anon_sym_any] = ACTIONS(1955),
    [anon_sym_number] = ACTIONS(1955),
    [anon_sym_boolean] = ACTIONS(1955),
    [anon_sym_string] = ACTIONS(1955),
    [anon_sym_symbol] = ACTIONS(1955),
    [anon_sym_interface] = ACTIONS(1955),
    [anon_sym_enum] = ACTIONS(1955),
    [sym_readonly] = ACTIONS(1955),
  },
  [574] = {
    [ts_builtin_sym_end] = ACTIONS(1957),
    [sym_identifier] = ACTIONS(1959),
    [anon_sym_export] = ACTIONS(1959),
    [anon_sym_default] = ACTIONS(1959),
    [anon_sym_namespace] = ACTIONS(1959),
    [anon_sym_LBRACE] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1957),
    [anon_sym_type] = ACTIONS(1959),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(1959),
    [anon_sym_var] = ACTIONS(1959),
    [anon_sym_let] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_else] = ACTIONS(1959),
    [anon_sym_if] = ACTIONS(1959),
    [anon_sym_switch] = ACTIONS(1959),
    [anon_sym_for] = ACTIONS(1959),
    [anon_sym_LPAREN] = ACTIONS(1957),
    [anon_sym_await] = ACTIONS(1959),
    [anon_sym_while] = ACTIONS(1959),
    [anon_sym_do] = ACTIONS(1959),
    [anon_sym_try] = ACTIONS(1959),
    [anon_sym_with] = ACTIONS(1959),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_continue] = ACTIONS(1959),
    [anon_sym_debugger] = ACTIONS(1959),
    [anon_sym_return] = ACTIONS(1959),
    [anon_sym_throw] = ACTIONS(1959),
    [anon_sym_SEMI] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1959),
    [anon_sym_yield] = ACTIONS(1959),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_SLASH] = ACTIONS(1959),
    [anon_sym_class] = ACTIONS(1959),
    [anon_sym_async] = ACTIONS(1959),
    [anon_sym_function] = ACTIONS(1959),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_PLUS] = ACTIONS(1959),
    [anon_sym_DASH] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1957),
    [anon_sym_void] = ACTIONS(1959),
    [anon_sym_delete] = ACTIONS(1959),
    [anon_sym_PLUS_PLUS] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1957),
    [anon_sym_DQUOTE] = ACTIONS(1957),
    [anon_sym_SQUOTE] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1957),
    [sym_number] = ACTIONS(1957),
    [sym_this] = ACTIONS(1959),
    [sym_super] = ACTIONS(1959),
    [sym_true] = ACTIONS(1959),
    [sym_false] = ACTIONS(1959),
    [sym_null] = ACTIONS(1959),
    [sym_undefined] = ACTIONS(1959),
    [anon_sym_AT] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1959),
    [anon_sym_abstract] = ACTIONS(1959),
    [anon_sym_get] = ACTIONS(1959),
    [anon_sym_set] = ACTIONS(1959),
    [anon_sym_declare] = ACTIONS(1959),
    [anon_sym_public] = ACTIONS(1959),
    [anon_sym_private] = ACTIONS(1959),
    [anon_sym_protected] = ACTIONS(1959),
    [anon_sym_module] = ACTIONS(1959),
    [anon_sym_any] = ACTIONS(1959),
    [anon_sym_number] = ACTIONS(1959),
    [anon_sym_boolean] = ACTIONS(1959),
    [anon_sym_string] = ACTIONS(1959),
    [anon_sym_symbol] = ACTIONS(1959),
    [anon_sym_interface] = ACTIONS(1959),
    [anon_sym_enum] = ACTIONS(1959),
    [sym_readonly] = ACTIONS(1959),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(1039),
    [sym_identifier] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_default] = ACTIONS(1041),
    [anon_sym_namespace] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_type] = ACTIONS(1041),
    [anon_sym_typeof] = ACTIONS(1041),
    [anon_sym_import] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_let] = ACTIONS(1041),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_await] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_do] = ACTIONS(1041),
    [anon_sym_try] = ACTIONS(1041),
    [anon_sym_with] = ACTIONS(1041),
    [anon_sym_break] = ACTIONS(1041),
    [anon_sym_continue] = ACTIONS(1041),
    [anon_sym_debugger] = ACTIONS(1041),
    [anon_sym_return] = ACTIONS(1041),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_case] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_class] = ACTIONS(1041),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_function] = ACTIONS(1041),
    [anon_sym_new] = ACTIONS(1041),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_void] = ACTIONS(1041),
    [anon_sym_delete] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_DASH_DASH] = ACTIONS(1039),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1039),
    [sym_number] = ACTIONS(1039),
    [sym_this] = ACTIONS(1041),
    [sym_super] = ACTIONS(1041),
    [sym_true] = ACTIONS(1041),
    [sym_false] = ACTIONS(1041),
    [sym_null] = ACTIONS(1041),
    [sym_undefined] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(1041),
    [anon_sym_abstract] = ACTIONS(1041),
    [anon_sym_get] = ACTIONS(1041),
    [anon_sym_set] = ACTIONS(1041),
    [anon_sym_declare] = ACTIONS(1041),
    [anon_sym_public] = ACTIONS(1041),
    [anon_sym_private] = ACTIONS(1041),
    [anon_sym_protected] = ACTIONS(1041),
    [anon_sym_module] = ACTIONS(1041),
    [anon_sym_any] = ACTIONS(1041),
    [anon_sym_number] = ACTIONS(1041),
    [anon_sym_boolean] = ACTIONS(1041),
    [anon_sym_string] = ACTIONS(1041),
    [anon_sym_symbol] = ACTIONS(1041),
    [anon_sym_interface] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [sym_readonly] = ACTIONS(1041),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(1961),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_export] = ACTIONS(1963),
    [anon_sym_default] = ACTIONS(1963),
    [anon_sym_namespace] = ACTIONS(1963),
    [anon_sym_LBRACE] = ACTIONS(1961),
    [anon_sym_RBRACE] = ACTIONS(1961),
    [anon_sym_type] = ACTIONS(1963),
    [anon_sym_typeof] = ACTIONS(1963),
    [anon_sym_import] = ACTIONS(1963),
    [anon_sym_var] = ACTIONS(1963),
    [anon_sym_let] = ACTIONS(1963),
    [anon_sym_const] = ACTIONS(1963),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_else] = ACTIONS(1963),
    [anon_sym_if] = ACTIONS(1963),
    [anon_sym_switch] = ACTIONS(1963),
    [anon_sym_for] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_await] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(1963),
    [anon_sym_do] = ACTIONS(1963),
    [anon_sym_try] = ACTIONS(1963),
    [anon_sym_with] = ACTIONS(1963),
    [anon_sym_break] = ACTIONS(1963),
    [anon_sym_continue] = ACTIONS(1963),
    [anon_sym_debugger] = ACTIONS(1963),
    [anon_sym_return] = ACTIONS(1963),
    [anon_sym_throw] = ACTIONS(1963),
    [anon_sym_SEMI] = ACTIONS(1961),
    [anon_sym_case] = ACTIONS(1963),
    [anon_sym_yield] = ACTIONS(1963),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_LT] = ACTIONS(1961),
    [anon_sym_SLASH] = ACTIONS(1963),
    [anon_sym_class] = ACTIONS(1963),
    [anon_sym_async] = ACTIONS(1963),
    [anon_sym_function] = ACTIONS(1963),
    [anon_sym_new] = ACTIONS(1963),
    [anon_sym_PLUS] = ACTIONS(1963),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_void] = ACTIONS(1963),
    [anon_sym_delete] = ACTIONS(1963),
    [anon_sym_PLUS_PLUS] = ACTIONS(1961),
    [anon_sym_DASH_DASH] = ACTIONS(1961),
    [anon_sym_DQUOTE] = ACTIONS(1961),
    [anon_sym_SQUOTE] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1961),
    [sym_number] = ACTIONS(1961),
    [sym_this] = ACTIONS(1963),
    [sym_super] = ACTIONS(1963),
    [sym_true] = ACTIONS(1963),
    [sym_false] = ACTIONS(1963),
    [sym_null] = ACTIONS(1963),
    [sym_undefined] = ACTIONS(1963),
    [anon_sym_AT] = ACTIONS(1961),
    [anon_sym_static] = ACTIONS(1963),
    [anon_sym_abstract] = ACTIONS(1963),
    [anon_sym_get] = ACTIONS(1963),
    [anon_sym_set] = ACTIONS(1963),
    [anon_sym_declare] = ACTIONS(1963),
    [anon_sym_public] = ACTIONS(1963),
    [anon_sym_private] = ACTIONS(1963),
    [anon_sym_protected] = ACTIONS(1963),
    [anon_sym_module] = ACTIONS(1963),
    [anon_sym_any] = ACTIONS(1963),
    [anon_sym_number] = ACTIONS(1963),
    [anon_sym_boolean] = ACTIONS(1963),
    [anon_sym_string] = ACTIONS(1963),
    [anon_sym_symbol] = ACTIONS(1963),
    [anon_sym_interface] = ACTIONS(1963),
    [anon_sym_enum] = ACTIONS(1963),
    [sym_readonly] = ACTIONS(1963),
  },
  [577] = {
    [ts_builtin_sym_end] = ACTIONS(1965),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_export] = ACTIONS(1967),
    [anon_sym_default] = ACTIONS(1967),
    [anon_sym_namespace] = ACTIONS(1967),
    [anon_sym_LBRACE] = ACTIONS(1965),
    [anon_sym_RBRACE] = ACTIONS(1965),
    [anon_sym_type] = ACTIONS(1967),
    [anon_sym_typeof] = ACTIONS(1967),
    [anon_sym_import] = ACTIONS(1967),
    [anon_sym_var] = ACTIONS(1967),
    [anon_sym_let] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_BANG] = ACTIONS(1965),
    [anon_sym_else] = ACTIONS(1967),
    [anon_sym_if] = ACTIONS(1967),
    [anon_sym_switch] = ACTIONS(1967),
    [anon_sym_for] = ACTIONS(1967),
    [anon_sym_LPAREN] = ACTIONS(1965),
    [anon_sym_await] = ACTIONS(1967),
    [anon_sym_while] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_try] = ACTIONS(1967),
    [anon_sym_with] = ACTIONS(1967),
    [anon_sym_break] = ACTIONS(1967),
    [anon_sym_continue] = ACTIONS(1967),
    [anon_sym_debugger] = ACTIONS(1967),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_throw] = ACTIONS(1967),
    [anon_sym_SEMI] = ACTIONS(1965),
    [anon_sym_case] = ACTIONS(1967),
    [anon_sym_yield] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(1965),
    [anon_sym_SLASH] = ACTIONS(1967),
    [anon_sym_class] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(1967),
    [anon_sym_function] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1965),
    [anon_sym_void] = ACTIONS(1967),
    [anon_sym_delete] = ACTIONS(1967),
    [anon_sym_PLUS_PLUS] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1965),
    [sym_number] = ACTIONS(1965),
    [sym_this] = ACTIONS(1967),
    [sym_super] = ACTIONS(1967),
    [sym_true] = ACTIONS(1967),
    [sym_false] = ACTIONS(1967),
    [sym_null] = ACTIONS(1967),
    [sym_undefined] = ACTIONS(1967),
    [anon_sym_AT] = ACTIONS(1965),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_abstract] = ACTIONS(1967),
    [anon_sym_get] = ACTIONS(1967),
    [anon_sym_set] = ACTIONS(1967),
    [anon_sym_declare] = ACTIONS(1967),
    [anon_sym_public] = ACTIONS(1967),
    [anon_sym_private] = ACTIONS(1967),
    [anon_sym_protected] = ACTIONS(1967),
    [anon_sym_module] = ACTIONS(1967),
    [anon_sym_any] = ACTIONS(1967),
    [anon_sym_number] = ACTIONS(1967),
    [anon_sym_boolean] = ACTIONS(1967),
    [anon_sym_string] = ACTIONS(1967),
    [anon_sym_symbol] = ACTIONS(1967),
    [anon_sym_interface] = ACTIONS(1967),
    [anon_sym_enum] = ACTIONS(1967),
    [sym_readonly] = ACTIONS(1967),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(1969),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_export] = ACTIONS(1971),
    [anon_sym_default] = ACTIONS(1971),
    [anon_sym_namespace] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1969),
    [anon_sym_RBRACE] = ACTIONS(1969),
    [anon_sym_type] = ACTIONS(1971),
    [anon_sym_typeof] = ACTIONS(1971),
    [anon_sym_import] = ACTIONS(1971),
    [anon_sym_var] = ACTIONS(1971),
    [anon_sym_let] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_else] = ACTIONS(1971),
    [anon_sym_if] = ACTIONS(1971),
    [anon_sym_switch] = ACTIONS(1971),
    [anon_sym_for] = ACTIONS(1971),
    [anon_sym_LPAREN] = ACTIONS(1969),
    [anon_sym_await] = ACTIONS(1971),
    [anon_sym_while] = ACTIONS(1971),
    [anon_sym_do] = ACTIONS(1971),
    [anon_sym_try] = ACTIONS(1971),
    [anon_sym_with] = ACTIONS(1971),
    [anon_sym_break] = ACTIONS(1971),
    [anon_sym_continue] = ACTIONS(1971),
    [anon_sym_debugger] = ACTIONS(1971),
    [anon_sym_return] = ACTIONS(1971),
    [anon_sym_throw] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym_case] = ACTIONS(1971),
    [anon_sym_yield] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1969),
    [anon_sym_SLASH] = ACTIONS(1971),
    [anon_sym_class] = ACTIONS(1971),
    [anon_sym_async] = ACTIONS(1971),
    [anon_sym_function] = ACTIONS(1971),
    [anon_sym_new] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_TILDE] = ACTIONS(1969),
    [anon_sym_void] = ACTIONS(1971),
    [anon_sym_delete] = ACTIONS(1971),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_DQUOTE] = ACTIONS(1969),
    [anon_sym_SQUOTE] = ACTIONS(1969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1969),
    [sym_number] = ACTIONS(1969),
    [sym_this] = ACTIONS(1971),
    [sym_super] = ACTIONS(1971),
    [sym_true] = ACTIONS(1971),
    [sym_false] = ACTIONS(1971),
    [sym_null] = ACTIONS(1971),
    [sym_undefined] = ACTIONS(1971),
    [anon_sym_AT] = ACTIONS(1969),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_abstract] = ACTIONS(1971),
    [anon_sym_get] = ACTIONS(1971),
    [anon_sym_set] = ACTIONS(1971),
    [anon_sym_declare] = ACTIONS(1971),
    [anon_sym_public] = ACTIONS(1971),
    [anon_sym_private] = ACTIONS(1971),
    [anon_sym_protected] = ACTIONS(1971),
    [anon_sym_module] = ACTIONS(1971),
    [anon_sym_any] = ACTIONS(1971),
    [anon_sym_number] = ACTIONS(1971),
    [anon_sym_boolean] = ACTIONS(1971),
    [anon_sym_string] = ACTIONS(1971),
    [anon_sym_symbol] = ACTIONS(1971),
    [anon_sym_interface] = ACTIONS(1971),
    [anon_sym_enum] = ACTIONS(1971),
    [sym_readonly] = ACTIONS(1971),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(1973),
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_export] = ACTIONS(1975),
    [anon_sym_default] = ACTIONS(1975),
    [anon_sym_namespace] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_RBRACE] = ACTIONS(1973),
    [anon_sym_type] = ACTIONS(1975),
    [anon_sym_typeof] = ACTIONS(1975),
    [anon_sym_import] = ACTIONS(1975),
    [anon_sym_var] = ACTIONS(1975),
    [anon_sym_let] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_else] = ACTIONS(1975),
    [anon_sym_if] = ACTIONS(1975),
    [anon_sym_switch] = ACTIONS(1975),
    [anon_sym_for] = ACTIONS(1975),
    [anon_sym_LPAREN] = ACTIONS(1973),
    [anon_sym_await] = ACTIONS(1975),
    [anon_sym_while] = ACTIONS(1975),
    [anon_sym_do] = ACTIONS(1975),
    [anon_sym_try] = ACTIONS(1975),
    [anon_sym_with] = ACTIONS(1975),
    [anon_sym_break] = ACTIONS(1975),
    [anon_sym_continue] = ACTIONS(1975),
    [anon_sym_debugger] = ACTIONS(1975),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_throw] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1973),
    [anon_sym_case] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(1973),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_class] = ACTIONS(1975),
    [anon_sym_async] = ACTIONS(1975),
    [anon_sym_function] = ACTIONS(1975),
    [anon_sym_new] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1975),
    [anon_sym_delete] = ACTIONS(1975),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_DQUOTE] = ACTIONS(1973),
    [anon_sym_SQUOTE] = ACTIONS(1973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1973),
    [sym_number] = ACTIONS(1973),
    [sym_this] = ACTIONS(1975),
    [sym_super] = ACTIONS(1975),
    [sym_true] = ACTIONS(1975),
    [sym_false] = ACTIONS(1975),
    [sym_null] = ACTIONS(1975),
    [sym_undefined] = ACTIONS(1975),
    [anon_sym_AT] = ACTIONS(1973),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_abstract] = ACTIONS(1975),
    [anon_sym_get] = ACTIONS(1975),
    [anon_sym_set] = ACTIONS(1975),
    [anon_sym_declare] = ACTIONS(1975),
    [anon_sym_public] = ACTIONS(1975),
    [anon_sym_private] = ACTIONS(1975),
    [anon_sym_protected] = ACTIONS(1975),
    [anon_sym_module] = ACTIONS(1975),
    [anon_sym_any] = ACTIONS(1975),
    [anon_sym_number] = ACTIONS(1975),
    [anon_sym_boolean] = ACTIONS(1975),
    [anon_sym_string] = ACTIONS(1975),
    [anon_sym_symbol] = ACTIONS(1975),
    [anon_sym_interface] = ACTIONS(1975),
    [anon_sym_enum] = ACTIONS(1975),
    [sym_readonly] = ACTIONS(1975),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(1977),
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_export] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_type] = ACTIONS(1979),
    [anon_sym_typeof] = ACTIONS(1979),
    [anon_sym_import] = ACTIONS(1979),
    [anon_sym_var] = ACTIONS(1979),
    [anon_sym_let] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_await] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_with] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_debugger] = ACTIONS(1979),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_case] = ACTIONS(1979),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_LT] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1979),
    [anon_sym_function] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_void] = ACTIONS(1979),
    [anon_sym_delete] = ACTIONS(1979),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1977),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_super] = ACTIONS(1979),
    [sym_true] = ACTIONS(1979),
    [sym_false] = ACTIONS(1979),
    [sym_null] = ACTIONS(1979),
    [sym_undefined] = ACTIONS(1979),
    [anon_sym_AT] = ACTIONS(1977),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_abstract] = ACTIONS(1979),
    [anon_sym_get] = ACTIONS(1979),
    [anon_sym_set] = ACTIONS(1979),
    [anon_sym_declare] = ACTIONS(1979),
    [anon_sym_public] = ACTIONS(1979),
    [anon_sym_private] = ACTIONS(1979),
    [anon_sym_protected] = ACTIONS(1979),
    [anon_sym_module] = ACTIONS(1979),
    [anon_sym_any] = ACTIONS(1979),
    [anon_sym_number] = ACTIONS(1979),
    [anon_sym_boolean] = ACTIONS(1979),
    [anon_sym_string] = ACTIONS(1979),
    [anon_sym_symbol] = ACTIONS(1979),
    [anon_sym_interface] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [sym_readonly] = ACTIONS(1979),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(1159),
    [sym_identifier] = ACTIONS(1161),
    [anon_sym_export] = ACTIONS(1161),
    [anon_sym_default] = ACTIONS(1161),
    [anon_sym_namespace] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_type] = ACTIONS(1161),
    [anon_sym_typeof] = ACTIONS(1161),
    [anon_sym_import] = ACTIONS(1161),
    [anon_sym_var] = ACTIONS(1161),
    [anon_sym_let] = ACTIONS(1161),
    [anon_sym_const] = ACTIONS(1161),
    [anon_sym_BANG] = ACTIONS(1159),
    [anon_sym_else] = ACTIONS(1161),
    [anon_sym_if] = ACTIONS(1161),
    [anon_sym_switch] = ACTIONS(1161),
    [anon_sym_for] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_await] = ACTIONS(1161),
    [anon_sym_while] = ACTIONS(1161),
    [anon_sym_do] = ACTIONS(1161),
    [anon_sym_try] = ACTIONS(1161),
    [anon_sym_with] = ACTIONS(1161),
    [anon_sym_break] = ACTIONS(1161),
    [anon_sym_continue] = ACTIONS(1161),
    [anon_sym_debugger] = ACTIONS(1161),
    [anon_sym_return] = ACTIONS(1161),
    [anon_sym_throw] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1161),
    [anon_sym_yield] = ACTIONS(1161),
    [anon_sym_LBRACK] = ACTIONS(1159),
    [anon_sym_LT] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(1161),
    [anon_sym_class] = ACTIONS(1161),
    [anon_sym_async] = ACTIONS(1161),
    [anon_sym_function] = ACTIONS(1161),
    [anon_sym_new] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1161),
    [anon_sym_TILDE] = ACTIONS(1159),
    [anon_sym_void] = ACTIONS(1161),
    [anon_sym_delete] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1159),
    [anon_sym_DASH_DASH] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_SQUOTE] = ACTIONS(1159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1159),
    [sym_number] = ACTIONS(1159),
    [sym_this] = ACTIONS(1161),
    [sym_super] = ACTIONS(1161),
    [sym_true] = ACTIONS(1161),
    [sym_false] = ACTIONS(1161),
    [sym_null] = ACTIONS(1161),
    [sym_undefined] = ACTIONS(1161),
    [anon_sym_AT] = ACTIONS(1159),
    [anon_sym_static] = ACTIONS(1161),
    [anon_sym_abstract] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(1161),
    [anon_sym_set] = ACTIONS(1161),
    [anon_sym_declare] = ACTIONS(1161),
    [anon_sym_public] = ACTIONS(1161),
    [anon_sym_private] = ACTIONS(1161),
    [anon_sym_protected] = ACTIONS(1161),
    [anon_sym_module] = ACTIONS(1161),
    [anon_sym_any] = ACTIONS(1161),
    [anon_sym_number] = ACTIONS(1161),
    [anon_sym_boolean] = ACTIONS(1161),
    [anon_sym_string] = ACTIONS(1161),
    [anon_sym_symbol] = ACTIONS(1161),
    [anon_sym_interface] = ACTIONS(1161),
    [anon_sym_enum] = ACTIONS(1161),
    [sym_readonly] = ACTIONS(1161),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(1981),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_export] = ACTIONS(1983),
    [anon_sym_default] = ACTIONS(1983),
    [anon_sym_namespace] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_type] = ACTIONS(1983),
    [anon_sym_typeof] = ACTIONS(1983),
    [anon_sym_import] = ACTIONS(1983),
    [anon_sym_var] = ACTIONS(1983),
    [anon_sym_let] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_BANG] = ACTIONS(1981),
    [anon_sym_else] = ACTIONS(1983),
    [anon_sym_if] = ACTIONS(1983),
    [anon_sym_switch] = ACTIONS(1983),
    [anon_sym_for] = ACTIONS(1983),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_await] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(1983),
    [anon_sym_do] = ACTIONS(1983),
    [anon_sym_try] = ACTIONS(1983),
    [anon_sym_with] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1983),
    [anon_sym_continue] = ACTIONS(1983),
    [anon_sym_debugger] = ACTIONS(1983),
    [anon_sym_return] = ACTIONS(1983),
    [anon_sym_throw] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_case] = ACTIONS(1983),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_LT] = ACTIONS(1981),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_class] = ACTIONS(1983),
    [anon_sym_async] = ACTIONS(1983),
    [anon_sym_function] = ACTIONS(1983),
    [anon_sym_new] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_void] = ACTIONS(1983),
    [anon_sym_delete] = ACTIONS(1983),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_SQUOTE] = ACTIONS(1981),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1981),
    [sym_number] = ACTIONS(1981),
    [sym_this] = ACTIONS(1983),
    [sym_super] = ACTIONS(1983),
    [sym_true] = ACTIONS(1983),
    [sym_false] = ACTIONS(1983),
    [sym_null] = ACTIONS(1983),
    [sym_undefined] = ACTIONS(1983),
    [anon_sym_AT] = ACTIONS(1981),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_abstract] = ACTIONS(1983),
    [anon_sym_get] = ACTIONS(1983),
    [anon_sym_set] = ACTIONS(1983),
    [anon_sym_declare] = ACTIONS(1983),
    [anon_sym_public] = ACTIONS(1983),
    [anon_sym_private] = ACTIONS(1983),
    [anon_sym_protected] = ACTIONS(1983),
    [anon_sym_module] = ACTIONS(1983),
    [anon_sym_any] = ACTIONS(1983),
    [anon_sym_number] = ACTIONS(1983),
    [anon_sym_boolean] = ACTIONS(1983),
    [anon_sym_string] = ACTIONS(1983),
    [anon_sym_symbol] = ACTIONS(1983),
    [anon_sym_interface] = ACTIONS(1983),
    [anon_sym_enum] = ACTIONS(1983),
    [sym_readonly] = ACTIONS(1983),
  },
  [583] = {
    [ts_builtin_sym_end] = ACTIONS(1097),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(1099),
    [anon_sym_default] = ACTIONS(1099),
    [anon_sym_namespace] = ACTIONS(1099),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1099),
    [anon_sym_var] = ACTIONS(1099),
    [anon_sym_let] = ACTIONS(1099),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1099),
    [anon_sym_if] = ACTIONS(1099),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_await] = ACTIONS(1099),
    [anon_sym_while] = ACTIONS(1099),
    [anon_sym_do] = ACTIONS(1099),
    [anon_sym_try] = ACTIONS(1099),
    [anon_sym_with] = ACTIONS(1099),
    [anon_sym_break] = ACTIONS(1099),
    [anon_sym_continue] = ACTIONS(1099),
    [anon_sym_debugger] = ACTIONS(1099),
    [anon_sym_return] = ACTIONS(1099),
    [anon_sym_throw] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1097),
    [anon_sym_case] = ACTIONS(1099),
    [anon_sym_yield] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_SLASH] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1099),
    [anon_sym_function] = ACTIONS(1099),
    [anon_sym_new] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_void] = ACTIONS(1099),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [sym_number] = ACTIONS(1097),
    [sym_this] = ACTIONS(1099),
    [sym_super] = ACTIONS(1099),
    [sym_true] = ACTIONS(1099),
    [sym_false] = ACTIONS(1099),
    [sym_null] = ACTIONS(1099),
    [sym_undefined] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1097),
    [anon_sym_static] = ACTIONS(1099),
    [anon_sym_abstract] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(1099),
    [anon_sym_set] = ACTIONS(1099),
    [anon_sym_declare] = ACTIONS(1099),
    [anon_sym_public] = ACTIONS(1099),
    [anon_sym_private] = ACTIONS(1099),
    [anon_sym_protected] = ACTIONS(1099),
    [anon_sym_module] = ACTIONS(1099),
    [anon_sym_any] = ACTIONS(1099),
    [anon_sym_number] = ACTIONS(1099),
    [anon_sym_boolean] = ACTIONS(1099),
    [anon_sym_string] = ACTIONS(1099),
    [anon_sym_symbol] = ACTIONS(1099),
    [anon_sym_interface] = ACTIONS(1099),
    [anon_sym_enum] = ACTIONS(1099),
    [sym_readonly] = ACTIONS(1099),
  },
  [584] = {
    [ts_builtin_sym_end] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_export] = ACTIONS(1987),
    [anon_sym_default] = ACTIONS(1987),
    [anon_sym_namespace] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_RBRACE] = ACTIONS(1985),
    [anon_sym_type] = ACTIONS(1987),
    [anon_sym_typeof] = ACTIONS(1987),
    [anon_sym_import] = ACTIONS(1987),
    [anon_sym_var] = ACTIONS(1987),
    [anon_sym_let] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_else] = ACTIONS(1987),
    [anon_sym_if] = ACTIONS(1987),
    [anon_sym_switch] = ACTIONS(1987),
    [anon_sym_for] = ACTIONS(1987),
    [anon_sym_LPAREN] = ACTIONS(1985),
    [anon_sym_await] = ACTIONS(1987),
    [anon_sym_while] = ACTIONS(1987),
    [anon_sym_do] = ACTIONS(1987),
    [anon_sym_try] = ACTIONS(1987),
    [anon_sym_with] = ACTIONS(1987),
    [anon_sym_break] = ACTIONS(1987),
    [anon_sym_continue] = ACTIONS(1987),
    [anon_sym_debugger] = ACTIONS(1987),
    [anon_sym_return] = ACTIONS(1987),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_case] = ACTIONS(1987),
    [anon_sym_yield] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(1985),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_class] = ACTIONS(1987),
    [anon_sym_async] = ACTIONS(1987),
    [anon_sym_function] = ACTIONS(1987),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_void] = ACTIONS(1987),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1985),
    [sym_number] = ACTIONS(1985),
    [sym_this] = ACTIONS(1987),
    [sym_super] = ACTIONS(1987),
    [sym_true] = ACTIONS(1987),
    [sym_false] = ACTIONS(1987),
    [sym_null] = ACTIONS(1987),
    [sym_undefined] = ACTIONS(1987),
    [anon_sym_AT] = ACTIONS(1985),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_abstract] = ACTIONS(1987),
    [anon_sym_get] = ACTIONS(1987),
    [anon_sym_set] = ACTIONS(1987),
    [anon_sym_declare] = ACTIONS(1987),
    [anon_sym_public] = ACTIONS(1987),
    [anon_sym_private] = ACTIONS(1987),
    [anon_sym_protected] = ACTIONS(1987),
    [anon_sym_module] = ACTIONS(1987),
    [anon_sym_any] = ACTIONS(1987),
    [anon_sym_number] = ACTIONS(1987),
    [anon_sym_boolean] = ACTIONS(1987),
    [anon_sym_string] = ACTIONS(1987),
    [anon_sym_symbol] = ACTIONS(1987),
    [anon_sym_interface] = ACTIONS(1987),
    [anon_sym_enum] = ACTIONS(1987),
    [sym_readonly] = ACTIONS(1987),
  },
  [585] = {
    [ts_builtin_sym_end] = ACTIONS(1989),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_export] = ACTIONS(1991),
    [anon_sym_default] = ACTIONS(1991),
    [anon_sym_namespace] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1989),
    [anon_sym_type] = ACTIONS(1991),
    [anon_sym_typeof] = ACTIONS(1991),
    [anon_sym_import] = ACTIONS(1991),
    [anon_sym_var] = ACTIONS(1991),
    [anon_sym_let] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_else] = ACTIONS(1991),
    [anon_sym_if] = ACTIONS(1991),
    [anon_sym_switch] = ACTIONS(1991),
    [anon_sym_for] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1989),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1991),
    [anon_sym_do] = ACTIONS(1991),
    [anon_sym_try] = ACTIONS(1991),
    [anon_sym_with] = ACTIONS(1991),
    [anon_sym_break] = ACTIONS(1991),
    [anon_sym_continue] = ACTIONS(1991),
    [anon_sym_debugger] = ACTIONS(1991),
    [anon_sym_return] = ACTIONS(1991),
    [anon_sym_throw] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_case] = ACTIONS(1991),
    [anon_sym_yield] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_SLASH] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(1991),
    [anon_sym_async] = ACTIONS(1991),
    [anon_sym_function] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_void] = ACTIONS(1991),
    [anon_sym_delete] = ACTIONS(1991),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1989),
    [anon_sym_SQUOTE] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1989),
    [sym_number] = ACTIONS(1989),
    [sym_this] = ACTIONS(1991),
    [sym_super] = ACTIONS(1991),
    [sym_true] = ACTIONS(1991),
    [sym_false] = ACTIONS(1991),
    [sym_null] = ACTIONS(1991),
    [sym_undefined] = ACTIONS(1991),
    [anon_sym_AT] = ACTIONS(1989),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_abstract] = ACTIONS(1991),
    [anon_sym_get] = ACTIONS(1991),
    [anon_sym_set] = ACTIONS(1991),
    [anon_sym_declare] = ACTIONS(1991),
    [anon_sym_public] = ACTIONS(1991),
    [anon_sym_private] = ACTIONS(1991),
    [anon_sym_protected] = ACTIONS(1991),
    [anon_sym_module] = ACTIONS(1991),
    [anon_sym_any] = ACTIONS(1991),
    [anon_sym_number] = ACTIONS(1991),
    [anon_sym_boolean] = ACTIONS(1991),
    [anon_sym_string] = ACTIONS(1991),
    [anon_sym_symbol] = ACTIONS(1991),
    [anon_sym_interface] = ACTIONS(1991),
    [anon_sym_enum] = ACTIONS(1991),
    [sym_readonly] = ACTIONS(1991),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_export] = ACTIONS(1995),
    [anon_sym_default] = ACTIONS(1995),
    [anon_sym_namespace] = ACTIONS(1995),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_RBRACE] = ACTIONS(1993),
    [anon_sym_type] = ACTIONS(1995),
    [anon_sym_typeof] = ACTIONS(1995),
    [anon_sym_import] = ACTIONS(1995),
    [anon_sym_var] = ACTIONS(1995),
    [anon_sym_let] = ACTIONS(1995),
    [anon_sym_const] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_else] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_switch] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_await] = ACTIONS(1995),
    [anon_sym_while] = ACTIONS(1995),
    [anon_sym_do] = ACTIONS(1995),
    [anon_sym_try] = ACTIONS(1995),
    [anon_sym_with] = ACTIONS(1995),
    [anon_sym_break] = ACTIONS(1995),
    [anon_sym_continue] = ACTIONS(1995),
    [anon_sym_debugger] = ACTIONS(1995),
    [anon_sym_return] = ACTIONS(1995),
    [anon_sym_throw] = ACTIONS(1995),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym_case] = ACTIONS(1995),
    [anon_sym_yield] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1993),
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_SLASH] = ACTIONS(1995),
    [anon_sym_class] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_function] = ACTIONS(1995),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_void] = ACTIONS(1995),
    [anon_sym_delete] = ACTIONS(1995),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_DQUOTE] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1993),
    [sym_number] = ACTIONS(1993),
    [sym_this] = ACTIONS(1995),
    [sym_super] = ACTIONS(1995),
    [sym_true] = ACTIONS(1995),
    [sym_false] = ACTIONS(1995),
    [sym_null] = ACTIONS(1995),
    [sym_undefined] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(1993),
    [anon_sym_static] = ACTIONS(1995),
    [anon_sym_abstract] = ACTIONS(1995),
    [anon_sym_get] = ACTIONS(1995),
    [anon_sym_set] = ACTIONS(1995),
    [anon_sym_declare] = ACTIONS(1995),
    [anon_sym_public] = ACTIONS(1995),
    [anon_sym_private] = ACTIONS(1995),
    [anon_sym_protected] = ACTIONS(1995),
    [anon_sym_module] = ACTIONS(1995),
    [anon_sym_any] = ACTIONS(1995),
    [anon_sym_number] = ACTIONS(1995),
    [anon_sym_boolean] = ACTIONS(1995),
    [anon_sym_string] = ACTIONS(1995),
    [anon_sym_symbol] = ACTIONS(1995),
    [anon_sym_interface] = ACTIONS(1995),
    [anon_sym_enum] = ACTIONS(1995),
    [sym_readonly] = ACTIONS(1995),
  },
  [587] = {
    [ts_builtin_sym_end] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1999),
    [anon_sym_export] = ACTIONS(1999),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_namespace] = ACTIONS(1999),
    [anon_sym_LBRACE] = ACTIONS(1997),
    [anon_sym_RBRACE] = ACTIONS(1997),
    [anon_sym_type] = ACTIONS(1999),
    [anon_sym_typeof] = ACTIONS(1999),
    [anon_sym_import] = ACTIONS(1999),
    [anon_sym_var] = ACTIONS(1999),
    [anon_sym_let] = ACTIONS(1999),
    [anon_sym_const] = ACTIONS(1999),
    [anon_sym_BANG] = ACTIONS(1997),
    [anon_sym_else] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_switch] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_await] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(1999),
    [anon_sym_do] = ACTIONS(1999),
    [anon_sym_try] = ACTIONS(1999),
    [anon_sym_with] = ACTIONS(1999),
    [anon_sym_break] = ACTIONS(1999),
    [anon_sym_continue] = ACTIONS(1999),
    [anon_sym_debugger] = ACTIONS(1999),
    [anon_sym_return] = ACTIONS(1999),
    [anon_sym_throw] = ACTIONS(1999),
    [anon_sym_SEMI] = ACTIONS(1997),
    [anon_sym_case] = ACTIONS(1999),
    [anon_sym_yield] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_SLASH] = ACTIONS(1999),
    [anon_sym_class] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_function] = ACTIONS(1999),
    [anon_sym_new] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1997),
    [anon_sym_void] = ACTIONS(1999),
    [anon_sym_delete] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1997),
    [anon_sym_DQUOTE] = ACTIONS(1997),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1997),
    [sym_number] = ACTIONS(1997),
    [sym_this] = ACTIONS(1999),
    [sym_super] = ACTIONS(1999),
    [sym_true] = ACTIONS(1999),
    [sym_false] = ACTIONS(1999),
    [sym_null] = ACTIONS(1999),
    [sym_undefined] = ACTIONS(1999),
    [anon_sym_AT] = ACTIONS(1997),
    [anon_sym_static] = ACTIONS(1999),
    [anon_sym_abstract] = ACTIONS(1999),
    [anon_sym_get] = ACTIONS(1999),
    [anon_sym_set] = ACTIONS(1999),
    [anon_sym_declare] = ACTIONS(1999),
    [anon_sym_public] = ACTIONS(1999),
    [anon_sym_private] = ACTIONS(1999),
    [anon_sym_protected] = ACTIONS(1999),
    [anon_sym_module] = ACTIONS(1999),
    [anon_sym_any] = ACTIONS(1999),
    [anon_sym_number] = ACTIONS(1999),
    [anon_sym_boolean] = ACTIONS(1999),
    [anon_sym_string] = ACTIONS(1999),
    [anon_sym_symbol] = ACTIONS(1999),
    [anon_sym_interface] = ACTIONS(1999),
    [anon_sym_enum] = ACTIONS(1999),
    [sym_readonly] = ACTIONS(1999),
  },
  [588] = {
    [ts_builtin_sym_end] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2003),
    [anon_sym_export] = ACTIONS(2003),
    [anon_sym_default] = ACTIONS(2003),
    [anon_sym_namespace] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(2001),
    [anon_sym_type] = ACTIONS(2003),
    [anon_sym_typeof] = ACTIONS(2003),
    [anon_sym_import] = ACTIONS(2003),
    [anon_sym_var] = ACTIONS(2003),
    [anon_sym_let] = ACTIONS(2003),
    [anon_sym_const] = ACTIONS(2003),
    [anon_sym_BANG] = ACTIONS(2001),
    [anon_sym_else] = ACTIONS(2003),
    [anon_sym_if] = ACTIONS(2003),
    [anon_sym_switch] = ACTIONS(2003),
    [anon_sym_for] = ACTIONS(2003),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_await] = ACTIONS(2003),
    [anon_sym_while] = ACTIONS(2003),
    [anon_sym_do] = ACTIONS(2003),
    [anon_sym_try] = ACTIONS(2003),
    [anon_sym_with] = ACTIONS(2003),
    [anon_sym_break] = ACTIONS(2003),
    [anon_sym_continue] = ACTIONS(2003),
    [anon_sym_debugger] = ACTIONS(2003),
    [anon_sym_return] = ACTIONS(2003),
    [anon_sym_throw] = ACTIONS(2003),
    [anon_sym_SEMI] = ACTIONS(2001),
    [anon_sym_case] = ACTIONS(2003),
    [anon_sym_yield] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2001),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2003),
    [anon_sym_class] = ACTIONS(2003),
    [anon_sym_async] = ACTIONS(2003),
    [anon_sym_function] = ACTIONS(2003),
    [anon_sym_new] = ACTIONS(2003),
    [anon_sym_PLUS] = ACTIONS(2003),
    [anon_sym_DASH] = ACTIONS(2003),
    [anon_sym_TILDE] = ACTIONS(2001),
    [anon_sym_void] = ACTIONS(2003),
    [anon_sym_delete] = ACTIONS(2003),
    [anon_sym_PLUS_PLUS] = ACTIONS(2001),
    [anon_sym_DASH_DASH] = ACTIONS(2001),
    [anon_sym_DQUOTE] = ACTIONS(2001),
    [anon_sym_SQUOTE] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2001),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_super] = ACTIONS(2003),
    [sym_true] = ACTIONS(2003),
    [sym_false] = ACTIONS(2003),
    [sym_null] = ACTIONS(2003),
    [sym_undefined] = ACTIONS(2003),
    [anon_sym_AT] = ACTIONS(2001),
    [anon_sym_static] = ACTIONS(2003),
    [anon_sym_abstract] = ACTIONS(2003),
    [anon_sym_get] = ACTIONS(2003),
    [anon_sym_set] = ACTIONS(2003),
    [anon_sym_declare] = ACTIONS(2003),
    [anon_sym_public] = ACTIONS(2003),
    [anon_sym_private] = ACTIONS(2003),
    [anon_sym_protected] = ACTIONS(2003),
    [anon_sym_module] = ACTIONS(2003),
    [anon_sym_any] = ACTIONS(2003),
    [anon_sym_number] = ACTIONS(2003),
    [anon_sym_boolean] = ACTIONS(2003),
    [anon_sym_string] = ACTIONS(2003),
    [anon_sym_symbol] = ACTIONS(2003),
    [anon_sym_interface] = ACTIONS(2003),
    [anon_sym_enum] = ACTIONS(2003),
    [sym_readonly] = ACTIONS(2003),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(2005),
    [sym_identifier] = ACTIONS(2007),
    [anon_sym_export] = ACTIONS(2007),
    [anon_sym_default] = ACTIONS(2007),
    [anon_sym_namespace] = ACTIONS(2007),
    [anon_sym_LBRACE] = ACTIONS(2005),
    [anon_sym_RBRACE] = ACTIONS(2005),
    [anon_sym_type] = ACTIONS(2007),
    [anon_sym_typeof] = ACTIONS(2007),
    [anon_sym_import] = ACTIONS(2007),
    [anon_sym_var] = ACTIONS(2007),
    [anon_sym_let] = ACTIONS(2007),
    [anon_sym_const] = ACTIONS(2007),
    [anon_sym_BANG] = ACTIONS(2005),
    [anon_sym_else] = ACTIONS(2007),
    [anon_sym_if] = ACTIONS(2007),
    [anon_sym_switch] = ACTIONS(2007),
    [anon_sym_for] = ACTIONS(2007),
    [anon_sym_LPAREN] = ACTIONS(2005),
    [anon_sym_await] = ACTIONS(2007),
    [anon_sym_while] = ACTIONS(2007),
    [anon_sym_do] = ACTIONS(2007),
    [anon_sym_try] = ACTIONS(2007),
    [anon_sym_with] = ACTIONS(2007),
    [anon_sym_break] = ACTIONS(2007),
    [anon_sym_continue] = ACTIONS(2007),
    [anon_sym_debugger] = ACTIONS(2007),
    [anon_sym_return] = ACTIONS(2007),
    [anon_sym_throw] = ACTIONS(2007),
    [anon_sym_SEMI] = ACTIONS(2005),
    [anon_sym_case] = ACTIONS(2007),
    [anon_sym_yield] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_class] = ACTIONS(2007),
    [anon_sym_async] = ACTIONS(2007),
    [anon_sym_function] = ACTIONS(2007),
    [anon_sym_new] = ACTIONS(2007),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2005),
    [anon_sym_void] = ACTIONS(2007),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_PLUS_PLUS] = ACTIONS(2005),
    [anon_sym_DASH_DASH] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [anon_sym_SQUOTE] = ACTIONS(2005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2005),
    [sym_number] = ACTIONS(2005),
    [sym_this] = ACTIONS(2007),
    [sym_super] = ACTIONS(2007),
    [sym_true] = ACTIONS(2007),
    [sym_false] = ACTIONS(2007),
    [sym_null] = ACTIONS(2007),
    [sym_undefined] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2005),
    [anon_sym_static] = ACTIONS(2007),
    [anon_sym_abstract] = ACTIONS(2007),
    [anon_sym_get] = ACTIONS(2007),
    [anon_sym_set] = ACTIONS(2007),
    [anon_sym_declare] = ACTIONS(2007),
    [anon_sym_public] = ACTIONS(2007),
    [anon_sym_private] = ACTIONS(2007),
    [anon_sym_protected] = ACTIONS(2007),
    [anon_sym_module] = ACTIONS(2007),
    [anon_sym_any] = ACTIONS(2007),
    [anon_sym_number] = ACTIONS(2007),
    [anon_sym_boolean] = ACTIONS(2007),
    [anon_sym_string] = ACTIONS(2007),
    [anon_sym_symbol] = ACTIONS(2007),
    [anon_sym_interface] = ACTIONS(2007),
    [anon_sym_enum] = ACTIONS(2007),
    [sym_readonly] = ACTIONS(2007),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(2009),
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_export] = ACTIONS(2011),
    [anon_sym_default] = ACTIONS(2011),
    [anon_sym_namespace] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(2009),
    [anon_sym_RBRACE] = ACTIONS(2009),
    [anon_sym_type] = ACTIONS(2011),
    [anon_sym_typeof] = ACTIONS(2011),
    [anon_sym_import] = ACTIONS(2011),
    [anon_sym_var] = ACTIONS(2011),
    [anon_sym_let] = ACTIONS(2011),
    [anon_sym_const] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_else] = ACTIONS(2011),
    [anon_sym_if] = ACTIONS(2011),
    [anon_sym_switch] = ACTIONS(2011),
    [anon_sym_for] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_await] = ACTIONS(2011),
    [anon_sym_while] = ACTIONS(2011),
    [anon_sym_do] = ACTIONS(2011),
    [anon_sym_try] = ACTIONS(2011),
    [anon_sym_with] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2011),
    [anon_sym_continue] = ACTIONS(2011),
    [anon_sym_debugger] = ACTIONS(2011),
    [anon_sym_return] = ACTIONS(2011),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2009),
    [anon_sym_case] = ACTIONS(2011),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2009),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_SLASH] = ACTIONS(2011),
    [anon_sym_class] = ACTIONS(2011),
    [anon_sym_async] = ACTIONS(2011),
    [anon_sym_function] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(2011),
    [anon_sym_PLUS] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2011),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_void] = ACTIONS(2011),
    [anon_sym_delete] = ACTIONS(2011),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_DQUOTE] = ACTIONS(2009),
    [anon_sym_SQUOTE] = ACTIONS(2009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2009),
    [sym_number] = ACTIONS(2009),
    [sym_this] = ACTIONS(2011),
    [sym_super] = ACTIONS(2011),
    [sym_true] = ACTIONS(2011),
    [sym_false] = ACTIONS(2011),
    [sym_null] = ACTIONS(2011),
    [sym_undefined] = ACTIONS(2011),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_static] = ACTIONS(2011),
    [anon_sym_abstract] = ACTIONS(2011),
    [anon_sym_get] = ACTIONS(2011),
    [anon_sym_set] = ACTIONS(2011),
    [anon_sym_declare] = ACTIONS(2011),
    [anon_sym_public] = ACTIONS(2011),
    [anon_sym_private] = ACTIONS(2011),
    [anon_sym_protected] = ACTIONS(2011),
    [anon_sym_module] = ACTIONS(2011),
    [anon_sym_any] = ACTIONS(2011),
    [anon_sym_number] = ACTIONS(2011),
    [anon_sym_boolean] = ACTIONS(2011),
    [anon_sym_string] = ACTIONS(2011),
    [anon_sym_symbol] = ACTIONS(2011),
    [anon_sym_interface] = ACTIONS(2011),
    [anon_sym_enum] = ACTIONS(2011),
    [sym_readonly] = ACTIONS(2011),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(2013),
    [sym_identifier] = ACTIONS(2015),
    [anon_sym_export] = ACTIONS(2015),
    [anon_sym_default] = ACTIONS(2015),
    [anon_sym_namespace] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_RBRACE] = ACTIONS(2013),
    [anon_sym_type] = ACTIONS(2015),
    [anon_sym_typeof] = ACTIONS(2015),
    [anon_sym_import] = ACTIONS(2015),
    [anon_sym_var] = ACTIONS(2015),
    [anon_sym_let] = ACTIONS(2015),
    [anon_sym_const] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_else] = ACTIONS(2015),
    [anon_sym_if] = ACTIONS(2015),
    [anon_sym_switch] = ACTIONS(2015),
    [anon_sym_for] = ACTIONS(2015),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_await] = ACTIONS(2015),
    [anon_sym_while] = ACTIONS(2015),
    [anon_sym_do] = ACTIONS(2015),
    [anon_sym_try] = ACTIONS(2015),
    [anon_sym_with] = ACTIONS(2015),
    [anon_sym_break] = ACTIONS(2015),
    [anon_sym_continue] = ACTIONS(2015),
    [anon_sym_debugger] = ACTIONS(2015),
    [anon_sym_return] = ACTIONS(2015),
    [anon_sym_throw] = ACTIONS(2015),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym_case] = ACTIONS(2015),
    [anon_sym_yield] = ACTIONS(2015),
    [anon_sym_LBRACK] = ACTIONS(2013),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_SLASH] = ACTIONS(2015),
    [anon_sym_class] = ACTIONS(2015),
    [anon_sym_async] = ACTIONS(2015),
    [anon_sym_function] = ACTIONS(2015),
    [anon_sym_new] = ACTIONS(2015),
    [anon_sym_PLUS] = ACTIONS(2015),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_void] = ACTIONS(2015),
    [anon_sym_delete] = ACTIONS(2015),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_DASH_DASH] = ACTIONS(2013),
    [anon_sym_DQUOTE] = ACTIONS(2013),
    [anon_sym_SQUOTE] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2013),
    [sym_number] = ACTIONS(2013),
    [sym_this] = ACTIONS(2015),
    [sym_super] = ACTIONS(2015),
    [sym_true] = ACTIONS(2015),
    [sym_false] = ACTIONS(2015),
    [sym_null] = ACTIONS(2015),
    [sym_undefined] = ACTIONS(2015),
    [anon_sym_AT] = ACTIONS(2013),
    [anon_sym_static] = ACTIONS(2015),
    [anon_sym_abstract] = ACTIONS(2015),
    [anon_sym_get] = ACTIONS(2015),
    [anon_sym_set] = ACTIONS(2015),
    [anon_sym_declare] = ACTIONS(2015),
    [anon_sym_public] = ACTIONS(2015),
    [anon_sym_private] = ACTIONS(2015),
    [anon_sym_protected] = ACTIONS(2015),
    [anon_sym_module] = ACTIONS(2015),
    [anon_sym_any] = ACTIONS(2015),
    [anon_sym_number] = ACTIONS(2015),
    [anon_sym_boolean] = ACTIONS(2015),
    [anon_sym_string] = ACTIONS(2015),
    [anon_sym_symbol] = ACTIONS(2015),
    [anon_sym_interface] = ACTIONS(2015),
    [anon_sym_enum] = ACTIONS(2015),
    [sym_readonly] = ACTIONS(2015),
  },
  [592] = {
    [ts_builtin_sym_end] = ACTIONS(2017),
    [sym_identifier] = ACTIONS(2019),
    [anon_sym_export] = ACTIONS(2019),
    [anon_sym_default] = ACTIONS(2019),
    [anon_sym_namespace] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2017),
    [anon_sym_RBRACE] = ACTIONS(2017),
    [anon_sym_type] = ACTIONS(2019),
    [anon_sym_typeof] = ACTIONS(2019),
    [anon_sym_import] = ACTIONS(2019),
    [anon_sym_var] = ACTIONS(2019),
    [anon_sym_let] = ACTIONS(2019),
    [anon_sym_const] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2019),
    [anon_sym_if] = ACTIONS(2019),
    [anon_sym_switch] = ACTIONS(2019),
    [anon_sym_for] = ACTIONS(2019),
    [anon_sym_LPAREN] = ACTIONS(2017),
    [anon_sym_await] = ACTIONS(2019),
    [anon_sym_while] = ACTIONS(2019),
    [anon_sym_do] = ACTIONS(2019),
    [anon_sym_try] = ACTIONS(2019),
    [anon_sym_with] = ACTIONS(2019),
    [anon_sym_break] = ACTIONS(2019),
    [anon_sym_continue] = ACTIONS(2019),
    [anon_sym_debugger] = ACTIONS(2019),
    [anon_sym_return] = ACTIONS(2019),
    [anon_sym_throw] = ACTIONS(2019),
    [anon_sym_SEMI] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2019),
    [anon_sym_yield] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_LT] = ACTIONS(2017),
    [anon_sym_SLASH] = ACTIONS(2019),
    [anon_sym_class] = ACTIONS(2019),
    [anon_sym_async] = ACTIONS(2019),
    [anon_sym_function] = ACTIONS(2019),
    [anon_sym_new] = ACTIONS(2019),
    [anon_sym_PLUS] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2017),
    [anon_sym_void] = ACTIONS(2019),
    [anon_sym_delete] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2017),
    [anon_sym_DQUOTE] = ACTIONS(2017),
    [anon_sym_SQUOTE] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2017),
    [sym_number] = ACTIONS(2017),
    [sym_this] = ACTIONS(2019),
    [sym_super] = ACTIONS(2019),
    [sym_true] = ACTIONS(2019),
    [sym_false] = ACTIONS(2019),
    [sym_null] = ACTIONS(2019),
    [sym_undefined] = ACTIONS(2019),
    [anon_sym_AT] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2019),
    [anon_sym_abstract] = ACTIONS(2019),
    [anon_sym_get] = ACTIONS(2019),
    [anon_sym_set] = ACTIONS(2019),
    [anon_sym_declare] = ACTIONS(2019),
    [anon_sym_public] = ACTIONS(2019),
    [anon_sym_private] = ACTIONS(2019),
    [anon_sym_protected] = ACTIONS(2019),
    [anon_sym_module] = ACTIONS(2019),
    [anon_sym_any] = ACTIONS(2019),
    [anon_sym_number] = ACTIONS(2019),
    [anon_sym_boolean] = ACTIONS(2019),
    [anon_sym_string] = ACTIONS(2019),
    [anon_sym_symbol] = ACTIONS(2019),
    [anon_sym_interface] = ACTIONS(2019),
    [anon_sym_enum] = ACTIONS(2019),
    [sym_readonly] = ACTIONS(2019),
  },
  [593] = {
    [ts_builtin_sym_end] = ACTIONS(2021),
    [sym_identifier] = ACTIONS(2023),
    [anon_sym_export] = ACTIONS(2023),
    [anon_sym_default] = ACTIONS(2023),
    [anon_sym_namespace] = ACTIONS(2023),
    [anon_sym_LBRACE] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(2021),
    [anon_sym_type] = ACTIONS(2023),
    [anon_sym_typeof] = ACTIONS(2023),
    [anon_sym_import] = ACTIONS(2023),
    [anon_sym_var] = ACTIONS(2023),
    [anon_sym_let] = ACTIONS(2023),
    [anon_sym_const] = ACTIONS(2023),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_else] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(2023),
    [anon_sym_switch] = ACTIONS(2023),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_LPAREN] = ACTIONS(2021),
    [anon_sym_await] = ACTIONS(2023),
    [anon_sym_while] = ACTIONS(2023),
    [anon_sym_do] = ACTIONS(2023),
    [anon_sym_try] = ACTIONS(2023),
    [anon_sym_with] = ACTIONS(2023),
    [anon_sym_break] = ACTIONS(2023),
    [anon_sym_continue] = ACTIONS(2023),
    [anon_sym_debugger] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2023),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_SEMI] = ACTIONS(2021),
    [anon_sym_case] = ACTIONS(2023),
    [anon_sym_yield] = ACTIONS(2023),
    [anon_sym_LBRACK] = ACTIONS(2021),
    [anon_sym_LT] = ACTIONS(2021),
    [anon_sym_SLASH] = ACTIONS(2023),
    [anon_sym_class] = ACTIONS(2023),
    [anon_sym_async] = ACTIONS(2023),
    [anon_sym_function] = ACTIONS(2023),
    [anon_sym_new] = ACTIONS(2023),
    [anon_sym_PLUS] = ACTIONS(2023),
    [anon_sym_DASH] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2021),
    [anon_sym_void] = ACTIONS(2023),
    [anon_sym_delete] = ACTIONS(2023),
    [anon_sym_PLUS_PLUS] = ACTIONS(2021),
    [anon_sym_DASH_DASH] = ACTIONS(2021),
    [anon_sym_DQUOTE] = ACTIONS(2021),
    [anon_sym_SQUOTE] = ACTIONS(2021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2021),
    [sym_number] = ACTIONS(2021),
    [sym_this] = ACTIONS(2023),
    [sym_super] = ACTIONS(2023),
    [sym_true] = ACTIONS(2023),
    [sym_false] = ACTIONS(2023),
    [sym_null] = ACTIONS(2023),
    [sym_undefined] = ACTIONS(2023),
    [anon_sym_AT] = ACTIONS(2021),
    [anon_sym_static] = ACTIONS(2023),
    [anon_sym_abstract] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(2023),
    [anon_sym_set] = ACTIONS(2023),
    [anon_sym_declare] = ACTIONS(2023),
    [anon_sym_public] = ACTIONS(2023),
    [anon_sym_private] = ACTIONS(2023),
    [anon_sym_protected] = ACTIONS(2023),
    [anon_sym_module] = ACTIONS(2023),
    [anon_sym_any] = ACTIONS(2023),
    [anon_sym_number] = ACTIONS(2023),
    [anon_sym_boolean] = ACTIONS(2023),
    [anon_sym_string] = ACTIONS(2023),
    [anon_sym_symbol] = ACTIONS(2023),
    [anon_sym_interface] = ACTIONS(2023),
    [anon_sym_enum] = ACTIONS(2023),
    [sym_readonly] = ACTIONS(2023),
  },
  [594] = {
    [ts_builtin_sym_end] = ACTIONS(2025),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_export] = ACTIONS(2027),
    [anon_sym_default] = ACTIONS(2027),
    [anon_sym_namespace] = ACTIONS(2027),
    [anon_sym_LBRACE] = ACTIONS(2025),
    [anon_sym_RBRACE] = ACTIONS(2025),
    [anon_sym_type] = ACTIONS(2027),
    [anon_sym_typeof] = ACTIONS(2027),
    [anon_sym_import] = ACTIONS(2027),
    [anon_sym_var] = ACTIONS(2027),
    [anon_sym_let] = ACTIONS(2027),
    [anon_sym_const] = ACTIONS(2027),
    [anon_sym_BANG] = ACTIONS(2025),
    [anon_sym_else] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(2027),
    [anon_sym_switch] = ACTIONS(2027),
    [anon_sym_for] = ACTIONS(2027),
    [anon_sym_LPAREN] = ACTIONS(2025),
    [anon_sym_await] = ACTIONS(2027),
    [anon_sym_while] = ACTIONS(2027),
    [anon_sym_do] = ACTIONS(2027),
    [anon_sym_try] = ACTIONS(2027),
    [anon_sym_with] = ACTIONS(2027),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2027),
    [anon_sym_debugger] = ACTIONS(2027),
    [anon_sym_return] = ACTIONS(2027),
    [anon_sym_throw] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(2025),
    [anon_sym_case] = ACTIONS(2027),
    [anon_sym_yield] = ACTIONS(2027),
    [anon_sym_LBRACK] = ACTIONS(2025),
    [anon_sym_LT] = ACTIONS(2025),
    [anon_sym_SLASH] = ACTIONS(2027),
    [anon_sym_class] = ACTIONS(2027),
    [anon_sym_async] = ACTIONS(2027),
    [anon_sym_function] = ACTIONS(2027),
    [anon_sym_new] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2027),
    [anon_sym_DASH] = ACTIONS(2027),
    [anon_sym_TILDE] = ACTIONS(2025),
    [anon_sym_void] = ACTIONS(2027),
    [anon_sym_delete] = ACTIONS(2027),
    [anon_sym_PLUS_PLUS] = ACTIONS(2025),
    [anon_sym_DASH_DASH] = ACTIONS(2025),
    [anon_sym_DQUOTE] = ACTIONS(2025),
    [anon_sym_SQUOTE] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2025),
    [sym_number] = ACTIONS(2025),
    [sym_this] = ACTIONS(2027),
    [sym_super] = ACTIONS(2027),
    [sym_true] = ACTIONS(2027),
    [sym_false] = ACTIONS(2027),
    [sym_null] = ACTIONS(2027),
    [sym_undefined] = ACTIONS(2027),
    [anon_sym_AT] = ACTIONS(2025),
    [anon_sym_static] = ACTIONS(2027),
    [anon_sym_abstract] = ACTIONS(2027),
    [anon_sym_get] = ACTIONS(2027),
    [anon_sym_set] = ACTIONS(2027),
    [anon_sym_declare] = ACTIONS(2027),
    [anon_sym_public] = ACTIONS(2027),
    [anon_sym_private] = ACTIONS(2027),
    [anon_sym_protected] = ACTIONS(2027),
    [anon_sym_module] = ACTIONS(2027),
    [anon_sym_any] = ACTIONS(2027),
    [anon_sym_number] = ACTIONS(2027),
    [anon_sym_boolean] = ACTIONS(2027),
    [anon_sym_string] = ACTIONS(2027),
    [anon_sym_symbol] = ACTIONS(2027),
    [anon_sym_interface] = ACTIONS(2027),
    [anon_sym_enum] = ACTIONS(2027),
    [sym_readonly] = ACTIONS(2027),
  },
  [595] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_number] = ACTIONS(2029),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [sym_undefined] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_any] = ACTIONS(2031),
    [anon_sym_number] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [anon_sym_interface] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [sym_readonly] = ACTIONS(2031),
  },
  [596] = {
    [ts_builtin_sym_end] = ACTIONS(2033),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_export] = ACTIONS(2035),
    [anon_sym_default] = ACTIONS(2035),
    [anon_sym_namespace] = ACTIONS(2035),
    [anon_sym_LBRACE] = ACTIONS(2033),
    [anon_sym_RBRACE] = ACTIONS(2033),
    [anon_sym_type] = ACTIONS(2035),
    [anon_sym_typeof] = ACTIONS(2035),
    [anon_sym_import] = ACTIONS(2035),
    [anon_sym_var] = ACTIONS(2035),
    [anon_sym_let] = ACTIONS(2035),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_BANG] = ACTIONS(2033),
    [anon_sym_else] = ACTIONS(2035),
    [anon_sym_if] = ACTIONS(2035),
    [anon_sym_switch] = ACTIONS(2035),
    [anon_sym_for] = ACTIONS(2035),
    [anon_sym_LPAREN] = ACTIONS(2033),
    [anon_sym_await] = ACTIONS(2035),
    [anon_sym_while] = ACTIONS(2035),
    [anon_sym_do] = ACTIONS(2035),
    [anon_sym_try] = ACTIONS(2035),
    [anon_sym_with] = ACTIONS(2035),
    [anon_sym_break] = ACTIONS(2035),
    [anon_sym_continue] = ACTIONS(2035),
    [anon_sym_debugger] = ACTIONS(2035),
    [anon_sym_return] = ACTIONS(2035),
    [anon_sym_throw] = ACTIONS(2035),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym_case] = ACTIONS(2035),
    [anon_sym_yield] = ACTIONS(2035),
    [anon_sym_LBRACK] = ACTIONS(2033),
    [anon_sym_LT] = ACTIONS(2033),
    [anon_sym_SLASH] = ACTIONS(2035),
    [anon_sym_class] = ACTIONS(2035),
    [anon_sym_async] = ACTIONS(2035),
    [anon_sym_function] = ACTIONS(2035),
    [anon_sym_new] = ACTIONS(2035),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_TILDE] = ACTIONS(2033),
    [anon_sym_void] = ACTIONS(2035),
    [anon_sym_delete] = ACTIONS(2035),
    [anon_sym_PLUS_PLUS] = ACTIONS(2033),
    [anon_sym_DASH_DASH] = ACTIONS(2033),
    [anon_sym_DQUOTE] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2033),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2033),
    [sym_number] = ACTIONS(2033),
    [sym_this] = ACTIONS(2035),
    [sym_super] = ACTIONS(2035),
    [sym_true] = ACTIONS(2035),
    [sym_false] = ACTIONS(2035),
    [sym_null] = ACTIONS(2035),
    [sym_undefined] = ACTIONS(2035),
    [anon_sym_AT] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2035),
    [anon_sym_abstract] = ACTIONS(2035),
    [anon_sym_get] = ACTIONS(2035),
    [anon_sym_set] = ACTIONS(2035),
    [anon_sym_declare] = ACTIONS(2035),
    [anon_sym_public] = ACTIONS(2035),
    [anon_sym_private] = ACTIONS(2035),
    [anon_sym_protected] = ACTIONS(2035),
    [anon_sym_module] = ACTIONS(2035),
    [anon_sym_any] = ACTIONS(2035),
    [anon_sym_number] = ACTIONS(2035),
    [anon_sym_boolean] = ACTIONS(2035),
    [anon_sym_string] = ACTIONS(2035),
    [anon_sym_symbol] = ACTIONS(2035),
    [anon_sym_interface] = ACTIONS(2035),
    [anon_sym_enum] = ACTIONS(2035),
    [sym_readonly] = ACTIONS(2035),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(2037),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(2039),
    [anon_sym_default] = ACTIONS(2039),
    [anon_sym_namespace] = ACTIONS(2039),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_type] = ACTIONS(2039),
    [anon_sym_typeof] = ACTIONS(2039),
    [anon_sym_import] = ACTIONS(2039),
    [anon_sym_var] = ACTIONS(2039),
    [anon_sym_let] = ACTIONS(2039),
    [anon_sym_const] = ACTIONS(2039),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_else] = ACTIONS(2039),
    [anon_sym_if] = ACTIONS(2039),
    [anon_sym_switch] = ACTIONS(2039),
    [anon_sym_for] = ACTIONS(2039),
    [anon_sym_LPAREN] = ACTIONS(2037),
    [anon_sym_await] = ACTIONS(2039),
    [anon_sym_while] = ACTIONS(2039),
    [anon_sym_do] = ACTIONS(2039),
    [anon_sym_try] = ACTIONS(2039),
    [anon_sym_with] = ACTIONS(2039),
    [anon_sym_break] = ACTIONS(2039),
    [anon_sym_continue] = ACTIONS(2039),
    [anon_sym_debugger] = ACTIONS(2039),
    [anon_sym_return] = ACTIONS(2039),
    [anon_sym_throw] = ACTIONS(2039),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_case] = ACTIONS(2039),
    [anon_sym_yield] = ACTIONS(2039),
    [anon_sym_LBRACK] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2037),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_class] = ACTIONS(2039),
    [anon_sym_async] = ACTIONS(2039),
    [anon_sym_function] = ACTIONS(2039),
    [anon_sym_new] = ACTIONS(2039),
    [anon_sym_PLUS] = ACTIONS(2039),
    [anon_sym_DASH] = ACTIONS(2039),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_void] = ACTIONS(2039),
    [anon_sym_delete] = ACTIONS(2039),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [anon_sym_SQUOTE] = ACTIONS(2037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2037),
    [sym_number] = ACTIONS(2037),
    [sym_this] = ACTIONS(2039),
    [sym_super] = ACTIONS(2039),
    [sym_true] = ACTIONS(2039),
    [sym_false] = ACTIONS(2039),
    [sym_null] = ACTIONS(2039),
    [sym_undefined] = ACTIONS(2039),
    [anon_sym_AT] = ACTIONS(2037),
    [anon_sym_static] = ACTIONS(2039),
    [anon_sym_abstract] = ACTIONS(2039),
    [anon_sym_get] = ACTIONS(2039),
    [anon_sym_set] = ACTIONS(2039),
    [anon_sym_declare] = ACTIONS(2039),
    [anon_sym_public] = ACTIONS(2039),
    [anon_sym_private] = ACTIONS(2039),
    [anon_sym_protected] = ACTIONS(2039),
    [anon_sym_module] = ACTIONS(2039),
    [anon_sym_any] = ACTIONS(2039),
    [anon_sym_number] = ACTIONS(2039),
    [anon_sym_boolean] = ACTIONS(2039),
    [anon_sym_string] = ACTIONS(2039),
    [anon_sym_symbol] = ACTIONS(2039),
    [anon_sym_interface] = ACTIONS(2039),
    [anon_sym_enum] = ACTIONS(2039),
    [sym_readonly] = ACTIONS(2039),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(2041),
    [sym_identifier] = ACTIONS(2043),
    [anon_sym_export] = ACTIONS(2043),
    [anon_sym_default] = ACTIONS(2043),
    [anon_sym_namespace] = ACTIONS(2043),
    [anon_sym_LBRACE] = ACTIONS(2041),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_type] = ACTIONS(2043),
    [anon_sym_typeof] = ACTIONS(2043),
    [anon_sym_import] = ACTIONS(2043),
    [anon_sym_var] = ACTIONS(2043),
    [anon_sym_let] = ACTIONS(2043),
    [anon_sym_const] = ACTIONS(2043),
    [anon_sym_BANG] = ACTIONS(2041),
    [anon_sym_else] = ACTIONS(2043),
    [anon_sym_if] = ACTIONS(2043),
    [anon_sym_switch] = ACTIONS(2043),
    [anon_sym_for] = ACTIONS(2043),
    [anon_sym_LPAREN] = ACTIONS(2041),
    [anon_sym_await] = ACTIONS(2043),
    [anon_sym_while] = ACTIONS(2043),
    [anon_sym_do] = ACTIONS(2043),
    [anon_sym_try] = ACTIONS(2043),
    [anon_sym_with] = ACTIONS(2043),
    [anon_sym_break] = ACTIONS(2043),
    [anon_sym_continue] = ACTIONS(2043),
    [anon_sym_debugger] = ACTIONS(2043),
    [anon_sym_return] = ACTIONS(2043),
    [anon_sym_throw] = ACTIONS(2043),
    [anon_sym_SEMI] = ACTIONS(2041),
    [anon_sym_case] = ACTIONS(2043),
    [anon_sym_yield] = ACTIONS(2043),
    [anon_sym_LBRACK] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2041),
    [anon_sym_SLASH] = ACTIONS(2043),
    [anon_sym_class] = ACTIONS(2043),
    [anon_sym_async] = ACTIONS(2043),
    [anon_sym_function] = ACTIONS(2043),
    [anon_sym_new] = ACTIONS(2043),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_TILDE] = ACTIONS(2041),
    [anon_sym_void] = ACTIONS(2043),
    [anon_sym_delete] = ACTIONS(2043),
    [anon_sym_PLUS_PLUS] = ACTIONS(2041),
    [anon_sym_DASH_DASH] = ACTIONS(2041),
    [anon_sym_DQUOTE] = ACTIONS(2041),
    [anon_sym_SQUOTE] = ACTIONS(2041),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2041),
    [sym_number] = ACTIONS(2041),
    [sym_this] = ACTIONS(2043),
    [sym_super] = ACTIONS(2043),
    [sym_true] = ACTIONS(2043),
    [sym_false] = ACTIONS(2043),
    [sym_null] = ACTIONS(2043),
    [sym_undefined] = ACTIONS(2043),
    [anon_sym_AT] = ACTIONS(2041),
    [anon_sym_static] = ACTIONS(2043),
    [anon_sym_abstract] = ACTIONS(2043),
    [anon_sym_get] = ACTIONS(2043),
    [anon_sym_set] = ACTIONS(2043),
    [anon_sym_declare] = ACTIONS(2043),
    [anon_sym_public] = ACTIONS(2043),
    [anon_sym_private] = ACTIONS(2043),
    [anon_sym_protected] = ACTIONS(2043),
    [anon_sym_module] = ACTIONS(2043),
    [anon_sym_any] = ACTIONS(2043),
    [anon_sym_number] = ACTIONS(2043),
    [anon_sym_boolean] = ACTIONS(2043),
    [anon_sym_string] = ACTIONS(2043),
    [anon_sym_symbol] = ACTIONS(2043),
    [anon_sym_interface] = ACTIONS(2043),
    [anon_sym_enum] = ACTIONS(2043),
    [sym_readonly] = ACTIONS(2043),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(2045),
    [sym_identifier] = ACTIONS(2047),
    [anon_sym_export] = ACTIONS(2047),
    [anon_sym_default] = ACTIONS(2047),
    [anon_sym_namespace] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_type] = ACTIONS(2047),
    [anon_sym_typeof] = ACTIONS(2047),
    [anon_sym_import] = ACTIONS(2047),
    [anon_sym_var] = ACTIONS(2047),
    [anon_sym_let] = ACTIONS(2047),
    [anon_sym_const] = ACTIONS(2047),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_else] = ACTIONS(2047),
    [anon_sym_if] = ACTIONS(2047),
    [anon_sym_switch] = ACTIONS(2047),
    [anon_sym_for] = ACTIONS(2047),
    [anon_sym_LPAREN] = ACTIONS(2045),
    [anon_sym_await] = ACTIONS(2047),
    [anon_sym_while] = ACTIONS(2047),
    [anon_sym_do] = ACTIONS(2047),
    [anon_sym_try] = ACTIONS(2047),
    [anon_sym_with] = ACTIONS(2047),
    [anon_sym_break] = ACTIONS(2047),
    [anon_sym_continue] = ACTIONS(2047),
    [anon_sym_debugger] = ACTIONS(2047),
    [anon_sym_return] = ACTIONS(2047),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_case] = ACTIONS(2047),
    [anon_sym_yield] = ACTIONS(2047),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [anon_sym_LT] = ACTIONS(2045),
    [anon_sym_SLASH] = ACTIONS(2047),
    [anon_sym_class] = ACTIONS(2047),
    [anon_sym_async] = ACTIONS(2047),
    [anon_sym_function] = ACTIONS(2047),
    [anon_sym_new] = ACTIONS(2047),
    [anon_sym_PLUS] = ACTIONS(2047),
    [anon_sym_DASH] = ACTIONS(2047),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_void] = ACTIONS(2047),
    [anon_sym_delete] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_DQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2045),
    [sym_number] = ACTIONS(2045),
    [sym_this] = ACTIONS(2047),
    [sym_super] = ACTIONS(2047),
    [sym_true] = ACTIONS(2047),
    [sym_false] = ACTIONS(2047),
    [sym_null] = ACTIONS(2047),
    [sym_undefined] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(2045),
    [anon_sym_static] = ACTIONS(2047),
    [anon_sym_abstract] = ACTIONS(2047),
    [anon_sym_get] = ACTIONS(2047),
    [anon_sym_set] = ACTIONS(2047),
    [anon_sym_declare] = ACTIONS(2047),
    [anon_sym_public] = ACTIONS(2047),
    [anon_sym_private] = ACTIONS(2047),
    [anon_sym_protected] = ACTIONS(2047),
    [anon_sym_module] = ACTIONS(2047),
    [anon_sym_any] = ACTIONS(2047),
    [anon_sym_number] = ACTIONS(2047),
    [anon_sym_boolean] = ACTIONS(2047),
    [anon_sym_string] = ACTIONS(2047),
    [anon_sym_symbol] = ACTIONS(2047),
    [anon_sym_interface] = ACTIONS(2047),
    [anon_sym_enum] = ACTIONS(2047),
    [sym_readonly] = ACTIONS(2047),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(2049),
    [sym_identifier] = ACTIONS(2051),
    [anon_sym_export] = ACTIONS(2051),
    [anon_sym_default] = ACTIONS(2051),
    [anon_sym_namespace] = ACTIONS(2051),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_type] = ACTIONS(2051),
    [anon_sym_typeof] = ACTIONS(2051),
    [anon_sym_import] = ACTIONS(2051),
    [anon_sym_var] = ACTIONS(2051),
    [anon_sym_let] = ACTIONS(2051),
    [anon_sym_const] = ACTIONS(2051),
    [anon_sym_BANG] = ACTIONS(2049),
    [anon_sym_else] = ACTIONS(2051),
    [anon_sym_if] = ACTIONS(2051),
    [anon_sym_switch] = ACTIONS(2051),
    [anon_sym_for] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(2049),
    [anon_sym_await] = ACTIONS(2051),
    [anon_sym_while] = ACTIONS(2051),
    [anon_sym_do] = ACTIONS(2051),
    [anon_sym_try] = ACTIONS(2051),
    [anon_sym_with] = ACTIONS(2051),
    [anon_sym_break] = ACTIONS(2051),
    [anon_sym_continue] = ACTIONS(2051),
    [anon_sym_debugger] = ACTIONS(2051),
    [anon_sym_return] = ACTIONS(2051),
    [anon_sym_throw] = ACTIONS(2051),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_case] = ACTIONS(2051),
    [anon_sym_yield] = ACTIONS(2051),
    [anon_sym_LBRACK] = ACTIONS(2049),
    [anon_sym_LT] = ACTIONS(2049),
    [anon_sym_SLASH] = ACTIONS(2051),
    [anon_sym_class] = ACTIONS(2051),
    [anon_sym_async] = ACTIONS(2051),
    [anon_sym_function] = ACTIONS(2051),
    [anon_sym_new] = ACTIONS(2051),
    [anon_sym_PLUS] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [anon_sym_TILDE] = ACTIONS(2049),
    [anon_sym_void] = ACTIONS(2051),
    [anon_sym_delete] = ACTIONS(2051),
    [anon_sym_PLUS_PLUS] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(2049),
    [anon_sym_DQUOTE] = ACTIONS(2049),
    [anon_sym_SQUOTE] = ACTIONS(2049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2049),
    [sym_number] = ACTIONS(2049),
    [sym_this] = ACTIONS(2051),
    [sym_super] = ACTIONS(2051),
    [sym_true] = ACTIONS(2051),
    [sym_false] = ACTIONS(2051),
    [sym_null] = ACTIONS(2051),
    [sym_undefined] = ACTIONS(2051),
    [anon_sym_AT] = ACTIONS(2049),
    [anon_sym_static] = ACTIONS(2051),
    [anon_sym_abstract] = ACTIONS(2051),
    [anon_sym_get] = ACTIONS(2051),
    [anon_sym_set] = ACTIONS(2051),
    [anon_sym_declare] = ACTIONS(2051),
    [anon_sym_public] = ACTIONS(2051),
    [anon_sym_private] = ACTIONS(2051),
    [anon_sym_protected] = ACTIONS(2051),
    [anon_sym_module] = ACTIONS(2051),
    [anon_sym_any] = ACTIONS(2051),
    [anon_sym_number] = ACTIONS(2051),
    [anon_sym_boolean] = ACTIONS(2051),
    [anon_sym_string] = ACTIONS(2051),
    [anon_sym_symbol] = ACTIONS(2051),
    [anon_sym_interface] = ACTIONS(2051),
    [anon_sym_enum] = ACTIONS(2051),
    [sym_readonly] = ACTIONS(2051),
  },
  [601] = {
    [ts_builtin_sym_end] = ACTIONS(2053),
    [sym_identifier] = ACTIONS(2055),
    [anon_sym_export] = ACTIONS(2055),
    [anon_sym_default] = ACTIONS(2055),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2053),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_type] = ACTIONS(2055),
    [anon_sym_typeof] = ACTIONS(2055),
    [anon_sym_import] = ACTIONS(2055),
    [anon_sym_var] = ACTIONS(2055),
    [anon_sym_let] = ACTIONS(2055),
    [anon_sym_const] = ACTIONS(2055),
    [anon_sym_BANG] = ACTIONS(2053),
    [anon_sym_else] = ACTIONS(2055),
    [anon_sym_if] = ACTIONS(2055),
    [anon_sym_switch] = ACTIONS(2055),
    [anon_sym_for] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_await] = ACTIONS(2055),
    [anon_sym_while] = ACTIONS(2055),
    [anon_sym_do] = ACTIONS(2055),
    [anon_sym_try] = ACTIONS(2055),
    [anon_sym_with] = ACTIONS(2055),
    [anon_sym_break] = ACTIONS(2055),
    [anon_sym_continue] = ACTIONS(2055),
    [anon_sym_debugger] = ACTIONS(2055),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_throw] = ACTIONS(2055),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_case] = ACTIONS(2055),
    [anon_sym_yield] = ACTIONS(2055),
    [anon_sym_LBRACK] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(2053),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_class] = ACTIONS(2055),
    [anon_sym_async] = ACTIONS(2055),
    [anon_sym_function] = ACTIONS(2055),
    [anon_sym_new] = ACTIONS(2055),
    [anon_sym_PLUS] = ACTIONS(2055),
    [anon_sym_DASH] = ACTIONS(2055),
    [anon_sym_TILDE] = ACTIONS(2053),
    [anon_sym_void] = ACTIONS(2055),
    [anon_sym_delete] = ACTIONS(2055),
    [anon_sym_PLUS_PLUS] = ACTIONS(2053),
    [anon_sym_DASH_DASH] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2053),
    [anon_sym_SQUOTE] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2053),
    [sym_number] = ACTIONS(2053),
    [sym_this] = ACTIONS(2055),
    [sym_super] = ACTIONS(2055),
    [sym_true] = ACTIONS(2055),
    [sym_false] = ACTIONS(2055),
    [sym_null] = ACTIONS(2055),
    [sym_undefined] = ACTIONS(2055),
    [anon_sym_AT] = ACTIONS(2053),
    [anon_sym_static] = ACTIONS(2055),
    [anon_sym_abstract] = ACTIONS(2055),
    [anon_sym_get] = ACTIONS(2055),
    [anon_sym_set] = ACTIONS(2055),
    [anon_sym_declare] = ACTIONS(2055),
    [anon_sym_public] = ACTIONS(2055),
    [anon_sym_private] = ACTIONS(2055),
    [anon_sym_protected] = ACTIONS(2055),
    [anon_sym_module] = ACTIONS(2055),
    [anon_sym_any] = ACTIONS(2055),
    [anon_sym_number] = ACTIONS(2055),
    [anon_sym_boolean] = ACTIONS(2055),
    [anon_sym_string] = ACTIONS(2055),
    [anon_sym_symbol] = ACTIONS(2055),
    [anon_sym_interface] = ACTIONS(2055),
    [anon_sym_enum] = ACTIONS(2055),
    [sym_readonly] = ACTIONS(2055),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(2057),
    [sym_identifier] = ACTIONS(2059),
    [anon_sym_export] = ACTIONS(2059),
    [anon_sym_default] = ACTIONS(2059),
    [anon_sym_namespace] = ACTIONS(2059),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_type] = ACTIONS(2059),
    [anon_sym_typeof] = ACTIONS(2059),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2059),
    [anon_sym_let] = ACTIONS(2059),
    [anon_sym_const] = ACTIONS(2059),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_else] = ACTIONS(2059),
    [anon_sym_if] = ACTIONS(2059),
    [anon_sym_switch] = ACTIONS(2059),
    [anon_sym_for] = ACTIONS(2059),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_await] = ACTIONS(2059),
    [anon_sym_while] = ACTIONS(2059),
    [anon_sym_do] = ACTIONS(2059),
    [anon_sym_try] = ACTIONS(2059),
    [anon_sym_with] = ACTIONS(2059),
    [anon_sym_break] = ACTIONS(2059),
    [anon_sym_continue] = ACTIONS(2059),
    [anon_sym_debugger] = ACTIONS(2059),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_throw] = ACTIONS(2059),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_case] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2059),
    [anon_sym_LBRACK] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2059),
    [anon_sym_class] = ACTIONS(2059),
    [anon_sym_async] = ACTIONS(2059),
    [anon_sym_function] = ACTIONS(2059),
    [anon_sym_new] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2059),
    [anon_sym_DASH] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_void] = ACTIONS(2059),
    [anon_sym_delete] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2057),
    [anon_sym_DASH_DASH] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_number] = ACTIONS(2057),
    [sym_this] = ACTIONS(2059),
    [sym_super] = ACTIONS(2059),
    [sym_true] = ACTIONS(2059),
    [sym_false] = ACTIONS(2059),
    [sym_null] = ACTIONS(2059),
    [sym_undefined] = ACTIONS(2059),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_static] = ACTIONS(2059),
    [anon_sym_abstract] = ACTIONS(2059),
    [anon_sym_get] = ACTIONS(2059),
    [anon_sym_set] = ACTIONS(2059),
    [anon_sym_declare] = ACTIONS(2059),
    [anon_sym_public] = ACTIONS(2059),
    [anon_sym_private] = ACTIONS(2059),
    [anon_sym_protected] = ACTIONS(2059),
    [anon_sym_module] = ACTIONS(2059),
    [anon_sym_any] = ACTIONS(2059),
    [anon_sym_number] = ACTIONS(2059),
    [anon_sym_boolean] = ACTIONS(2059),
    [anon_sym_string] = ACTIONS(2059),
    [anon_sym_symbol] = ACTIONS(2059),
    [anon_sym_interface] = ACTIONS(2059),
    [anon_sym_enum] = ACTIONS(2059),
    [sym_readonly] = ACTIONS(2059),
  },
  [603] = {
    [ts_builtin_sym_end] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(2063),
    [anon_sym_export] = ACTIONS(2063),
    [anon_sym_default] = ACTIONS(2063),
    [anon_sym_namespace] = ACTIONS(2063),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_type] = ACTIONS(2063),
    [anon_sym_typeof] = ACTIONS(2063),
    [anon_sym_import] = ACTIONS(2063),
    [anon_sym_var] = ACTIONS(2063),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2063),
    [anon_sym_BANG] = ACTIONS(2061),
    [anon_sym_else] = ACTIONS(2063),
    [anon_sym_if] = ACTIONS(2063),
    [anon_sym_switch] = ACTIONS(2063),
    [anon_sym_for] = ACTIONS(2063),
    [anon_sym_LPAREN] = ACTIONS(2061),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_while] = ACTIONS(2063),
    [anon_sym_do] = ACTIONS(2063),
    [anon_sym_try] = ACTIONS(2063),
    [anon_sym_with] = ACTIONS(2063),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_continue] = ACTIONS(2063),
    [anon_sym_debugger] = ACTIONS(2063),
    [anon_sym_return] = ACTIONS(2063),
    [anon_sym_throw] = ACTIONS(2063),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_case] = ACTIONS(2063),
    [anon_sym_yield] = ACTIONS(2063),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2061),
    [anon_sym_SLASH] = ACTIONS(2063),
    [anon_sym_class] = ACTIONS(2063),
    [anon_sym_async] = ACTIONS(2063),
    [anon_sym_function] = ACTIONS(2063),
    [anon_sym_new] = ACTIONS(2063),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(2063),
    [anon_sym_TILDE] = ACTIONS(2061),
    [anon_sym_void] = ACTIONS(2063),
    [anon_sym_delete] = ACTIONS(2063),
    [anon_sym_PLUS_PLUS] = ACTIONS(2061),
    [anon_sym_DASH_DASH] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(2061),
    [anon_sym_SQUOTE] = ACTIONS(2061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2061),
    [sym_number] = ACTIONS(2061),
    [sym_this] = ACTIONS(2063),
    [sym_super] = ACTIONS(2063),
    [sym_true] = ACTIONS(2063),
    [sym_false] = ACTIONS(2063),
    [sym_null] = ACTIONS(2063),
    [sym_undefined] = ACTIONS(2063),
    [anon_sym_AT] = ACTIONS(2061),
    [anon_sym_static] = ACTIONS(2063),
    [anon_sym_abstract] = ACTIONS(2063),
    [anon_sym_get] = ACTIONS(2063),
    [anon_sym_set] = ACTIONS(2063),
    [anon_sym_declare] = ACTIONS(2063),
    [anon_sym_public] = ACTIONS(2063),
    [anon_sym_private] = ACTIONS(2063),
    [anon_sym_protected] = ACTIONS(2063),
    [anon_sym_module] = ACTIONS(2063),
    [anon_sym_any] = ACTIONS(2063),
    [anon_sym_number] = ACTIONS(2063),
    [anon_sym_boolean] = ACTIONS(2063),
    [anon_sym_string] = ACTIONS(2063),
    [anon_sym_symbol] = ACTIONS(2063),
    [anon_sym_interface] = ACTIONS(2063),
    [anon_sym_enum] = ACTIONS(2063),
    [sym_readonly] = ACTIONS(2063),
  },
  [604] = {
    [ts_builtin_sym_end] = ACTIONS(2065),
    [sym_identifier] = ACTIONS(2067),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2067),
    [anon_sym_LBRACE] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(2065),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_import] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
    [anon_sym_let] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2065),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_for] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2065),
    [anon_sym_await] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_with] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_debugger] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_SLASH] = ACTIONS(2067),
    [anon_sym_class] = ACTIONS(2067),
    [anon_sym_async] = ACTIONS(2067),
    [anon_sym_function] = ACTIONS(2067),
    [anon_sym_new] = ACTIONS(2067),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_TILDE] = ACTIONS(2065),
    [anon_sym_void] = ACTIONS(2067),
    [anon_sym_delete] = ACTIONS(2067),
    [anon_sym_PLUS_PLUS] = ACTIONS(2065),
    [anon_sym_DASH_DASH] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2065),
    [anon_sym_SQUOTE] = ACTIONS(2065),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [sym_number] = ACTIONS(2065),
    [sym_this] = ACTIONS(2067),
    [sym_super] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_null] = ACTIONS(2067),
    [sym_undefined] = ACTIONS(2067),
    [anon_sym_AT] = ACTIONS(2065),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_abstract] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_interface] = ACTIONS(2067),
    [anon_sym_enum] = ACTIONS(2067),
    [sym_readonly] = ACTIONS(2067),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(2069),
    [sym_identifier] = ACTIONS(2071),
    [anon_sym_export] = ACTIONS(2071),
    [anon_sym_default] = ACTIONS(2071),
    [anon_sym_namespace] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(2069),
    [anon_sym_type] = ACTIONS(2071),
    [anon_sym_typeof] = ACTIONS(2071),
    [anon_sym_import] = ACTIONS(2071),
    [anon_sym_var] = ACTIONS(2071),
    [anon_sym_let] = ACTIONS(2071),
    [anon_sym_const] = ACTIONS(2071),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_else] = ACTIONS(2071),
    [anon_sym_if] = ACTIONS(2071),
    [anon_sym_switch] = ACTIONS(2071),
    [anon_sym_for] = ACTIONS(2071),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_await] = ACTIONS(2071),
    [anon_sym_while] = ACTIONS(2071),
    [anon_sym_do] = ACTIONS(2071),
    [anon_sym_try] = ACTIONS(2071),
    [anon_sym_with] = ACTIONS(2071),
    [anon_sym_break] = ACTIONS(2071),
    [anon_sym_continue] = ACTIONS(2071),
    [anon_sym_debugger] = ACTIONS(2071),
    [anon_sym_return] = ACTIONS(2071),
    [anon_sym_throw] = ACTIONS(2071),
    [anon_sym_SEMI] = ACTIONS(2069),
    [anon_sym_case] = ACTIONS(2071),
    [anon_sym_yield] = ACTIONS(2071),
    [anon_sym_LBRACK] = ACTIONS(2069),
    [anon_sym_LT] = ACTIONS(2069),
    [anon_sym_SLASH] = ACTIONS(2071),
    [anon_sym_class] = ACTIONS(2071),
    [anon_sym_async] = ACTIONS(2071),
    [anon_sym_function] = ACTIONS(2071),
    [anon_sym_new] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2069),
    [anon_sym_void] = ACTIONS(2071),
    [anon_sym_delete] = ACTIONS(2071),
    [anon_sym_PLUS_PLUS] = ACTIONS(2069),
    [anon_sym_DASH_DASH] = ACTIONS(2069),
    [anon_sym_DQUOTE] = ACTIONS(2069),
    [anon_sym_SQUOTE] = ACTIONS(2069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2069),
    [sym_number] = ACTIONS(2069),
    [sym_this] = ACTIONS(2071),
    [sym_super] = ACTIONS(2071),
    [sym_true] = ACTIONS(2071),
    [sym_false] = ACTIONS(2071),
    [sym_null] = ACTIONS(2071),
    [sym_undefined] = ACTIONS(2071),
    [anon_sym_AT] = ACTIONS(2069),
    [anon_sym_static] = ACTIONS(2071),
    [anon_sym_abstract] = ACTIONS(2071),
    [anon_sym_get] = ACTIONS(2071),
    [anon_sym_set] = ACTIONS(2071),
    [anon_sym_declare] = ACTIONS(2071),
    [anon_sym_public] = ACTIONS(2071),
    [anon_sym_private] = ACTIONS(2071),
    [anon_sym_protected] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(2071),
    [anon_sym_any] = ACTIONS(2071),
    [anon_sym_number] = ACTIONS(2071),
    [anon_sym_boolean] = ACTIONS(2071),
    [anon_sym_string] = ACTIONS(2071),
    [anon_sym_symbol] = ACTIONS(2071),
    [anon_sym_interface] = ACTIONS(2071),
    [anon_sym_enum] = ACTIONS(2071),
    [sym_readonly] = ACTIONS(2071),
  },
  [606] = {
    [ts_builtin_sym_end] = ACTIONS(2073),
    [sym_identifier] = ACTIONS(2075),
    [anon_sym_export] = ACTIONS(2075),
    [anon_sym_default] = ACTIONS(2075),
    [anon_sym_namespace] = ACTIONS(2075),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_RBRACE] = ACTIONS(2073),
    [anon_sym_type] = ACTIONS(2075),
    [anon_sym_typeof] = ACTIONS(2075),
    [anon_sym_import] = ACTIONS(2075),
    [anon_sym_var] = ACTIONS(2075),
    [anon_sym_let] = ACTIONS(2075),
    [anon_sym_const] = ACTIONS(2075),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_else] = ACTIONS(2075),
    [anon_sym_if] = ACTIONS(2075),
    [anon_sym_switch] = ACTIONS(2075),
    [anon_sym_for] = ACTIONS(2075),
    [anon_sym_LPAREN] = ACTIONS(2073),
    [anon_sym_await] = ACTIONS(2075),
    [anon_sym_while] = ACTIONS(2075),
    [anon_sym_do] = ACTIONS(2075),
    [anon_sym_try] = ACTIONS(2075),
    [anon_sym_with] = ACTIONS(2075),
    [anon_sym_break] = ACTIONS(2075),
    [anon_sym_continue] = ACTIONS(2075),
    [anon_sym_debugger] = ACTIONS(2075),
    [anon_sym_return] = ACTIONS(2075),
    [anon_sym_throw] = ACTIONS(2075),
    [anon_sym_SEMI] = ACTIONS(2073),
    [anon_sym_case] = ACTIONS(2075),
    [anon_sym_yield] = ACTIONS(2075),
    [anon_sym_LBRACK] = ACTIONS(2073),
    [anon_sym_LT] = ACTIONS(2073),
    [anon_sym_SLASH] = ACTIONS(2075),
    [anon_sym_class] = ACTIONS(2075),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_function] = ACTIONS(2075),
    [anon_sym_new] = ACTIONS(2075),
    [anon_sym_PLUS] = ACTIONS(2075),
    [anon_sym_DASH] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_void] = ACTIONS(2075),
    [anon_sym_delete] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_DQUOTE] = ACTIONS(2073),
    [anon_sym_SQUOTE] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2073),
    [sym_number] = ACTIONS(2073),
    [sym_this] = ACTIONS(2075),
    [sym_super] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_null] = ACTIONS(2075),
    [sym_undefined] = ACTIONS(2075),
    [anon_sym_AT] = ACTIONS(2073),
    [anon_sym_static] = ACTIONS(2075),
    [anon_sym_abstract] = ACTIONS(2075),
    [anon_sym_get] = ACTIONS(2075),
    [anon_sym_set] = ACTIONS(2075),
    [anon_sym_declare] = ACTIONS(2075),
    [anon_sym_public] = ACTIONS(2075),
    [anon_sym_private] = ACTIONS(2075),
    [anon_sym_protected] = ACTIONS(2075),
    [anon_sym_module] = ACTIONS(2075),
    [anon_sym_any] = ACTIONS(2075),
    [anon_sym_number] = ACTIONS(2075),
    [anon_sym_boolean] = ACTIONS(2075),
    [anon_sym_string] = ACTIONS(2075),
    [anon_sym_symbol] = ACTIONS(2075),
    [anon_sym_interface] = ACTIONS(2075),
    [anon_sym_enum] = ACTIONS(2075),
    [sym_readonly] = ACTIONS(2075),
  },
  [607] = {
    [ts_builtin_sym_end] = ACTIONS(2077),
    [sym_identifier] = ACTIONS(2079),
    [anon_sym_export] = ACTIONS(2079),
    [anon_sym_default] = ACTIONS(2079),
    [anon_sym_namespace] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(2077),
    [anon_sym_RBRACE] = ACTIONS(2077),
    [anon_sym_type] = ACTIONS(2079),
    [anon_sym_typeof] = ACTIONS(2079),
    [anon_sym_import] = ACTIONS(2079),
    [anon_sym_var] = ACTIONS(2079),
    [anon_sym_let] = ACTIONS(2079),
    [anon_sym_const] = ACTIONS(2079),
    [anon_sym_BANG] = ACTIONS(2077),
    [anon_sym_else] = ACTIONS(2079),
    [anon_sym_if] = ACTIONS(2079),
    [anon_sym_switch] = ACTIONS(2079),
    [anon_sym_for] = ACTIONS(2079),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_await] = ACTIONS(2079),
    [anon_sym_while] = ACTIONS(2079),
    [anon_sym_do] = ACTIONS(2079),
    [anon_sym_try] = ACTIONS(2079),
    [anon_sym_with] = ACTIONS(2079),
    [anon_sym_break] = ACTIONS(2079),
    [anon_sym_continue] = ACTIONS(2079),
    [anon_sym_debugger] = ACTIONS(2079),
    [anon_sym_return] = ACTIONS(2079),
    [anon_sym_throw] = ACTIONS(2079),
    [anon_sym_SEMI] = ACTIONS(2077),
    [anon_sym_case] = ACTIONS(2079),
    [anon_sym_yield] = ACTIONS(2079),
    [anon_sym_LBRACK] = ACTIONS(2077),
    [anon_sym_LT] = ACTIONS(2077),
    [anon_sym_SLASH] = ACTIONS(2079),
    [anon_sym_class] = ACTIONS(2079),
    [anon_sym_async] = ACTIONS(2079),
    [anon_sym_function] = ACTIONS(2079),
    [anon_sym_new] = ACTIONS(2079),
    [anon_sym_PLUS] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2077),
    [anon_sym_void] = ACTIONS(2079),
    [anon_sym_delete] = ACTIONS(2079),
    [anon_sym_PLUS_PLUS] = ACTIONS(2077),
    [anon_sym_DASH_DASH] = ACTIONS(2077),
    [anon_sym_DQUOTE] = ACTIONS(2077),
    [anon_sym_SQUOTE] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2077),
    [sym_number] = ACTIONS(2077),
    [sym_this] = ACTIONS(2079),
    [sym_super] = ACTIONS(2079),
    [sym_true] = ACTIONS(2079),
    [sym_false] = ACTIONS(2079),
    [sym_null] = ACTIONS(2079),
    [sym_undefined] = ACTIONS(2079),
    [anon_sym_AT] = ACTIONS(2077),
    [anon_sym_static] = ACTIONS(2079),
    [anon_sym_abstract] = ACTIONS(2079),
    [anon_sym_get] = ACTIONS(2079),
    [anon_sym_set] = ACTIONS(2079),
    [anon_sym_declare] = ACTIONS(2079),
    [anon_sym_public] = ACTIONS(2079),
    [anon_sym_private] = ACTIONS(2079),
    [anon_sym_protected] = ACTIONS(2079),
    [anon_sym_module] = ACTIONS(2079),
    [anon_sym_any] = ACTIONS(2079),
    [anon_sym_number] = ACTIONS(2079),
    [anon_sym_boolean] = ACTIONS(2079),
    [anon_sym_string] = ACTIONS(2079),
    [anon_sym_symbol] = ACTIONS(2079),
    [anon_sym_interface] = ACTIONS(2079),
    [anon_sym_enum] = ACTIONS(2079),
    [sym_readonly] = ACTIONS(2079),
  },
  [608] = {
    [ts_builtin_sym_end] = ACTIONS(2081),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_default] = ACTIONS(2083),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2081),
    [anon_sym_RBRACE] = ACTIONS(2081),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_typeof] = ACTIONS(2083),
    [anon_sym_import] = ACTIONS(2083),
    [anon_sym_var] = ACTIONS(2083),
    [anon_sym_let] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2081),
    [anon_sym_else] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_switch] = ACTIONS(2083),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2081),
    [anon_sym_await] = ACTIONS(2083),
    [anon_sym_while] = ACTIONS(2083),
    [anon_sym_do] = ACTIONS(2083),
    [anon_sym_try] = ACTIONS(2083),
    [anon_sym_with] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_debugger] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_throw] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2081),
    [anon_sym_case] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2083),
    [anon_sym_class] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(2083),
    [anon_sym_new] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2081),
    [anon_sym_void] = ACTIONS(2083),
    [anon_sym_delete] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(2081),
    [anon_sym_SQUOTE] = ACTIONS(2081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2081),
    [sym_number] = ACTIONS(2081),
    [sym_this] = ACTIONS(2083),
    [sym_super] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [sym_false] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [sym_undefined] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(2081),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [sym_readonly] = ACTIONS(2083),
  },
  [609] = {
    [ts_builtin_sym_end] = ACTIONS(2085),
    [sym_identifier] = ACTIONS(2087),
    [anon_sym_export] = ACTIONS(2087),
    [anon_sym_default] = ACTIONS(2087),
    [anon_sym_namespace] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(2085),
    [anon_sym_RBRACE] = ACTIONS(2085),
    [anon_sym_type] = ACTIONS(2087),
    [anon_sym_typeof] = ACTIONS(2087),
    [anon_sym_import] = ACTIONS(2087),
    [anon_sym_var] = ACTIONS(2087),
    [anon_sym_let] = ACTIONS(2087),
    [anon_sym_const] = ACTIONS(2087),
    [anon_sym_BANG] = ACTIONS(2085),
    [anon_sym_else] = ACTIONS(2087),
    [anon_sym_if] = ACTIONS(2087),
    [anon_sym_switch] = ACTIONS(2087),
    [anon_sym_for] = ACTIONS(2087),
    [anon_sym_LPAREN] = ACTIONS(2085),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_while] = ACTIONS(2087),
    [anon_sym_do] = ACTIONS(2087),
    [anon_sym_try] = ACTIONS(2087),
    [anon_sym_with] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2087),
    [anon_sym_continue] = ACTIONS(2087),
    [anon_sym_debugger] = ACTIONS(2087),
    [anon_sym_return] = ACTIONS(2087),
    [anon_sym_throw] = ACTIONS(2087),
    [anon_sym_SEMI] = ACTIONS(2085),
    [anon_sym_case] = ACTIONS(2087),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_LBRACK] = ACTIONS(2085),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2087),
    [anon_sym_class] = ACTIONS(2087),
    [anon_sym_async] = ACTIONS(2087),
    [anon_sym_function] = ACTIONS(2087),
    [anon_sym_new] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2087),
    [anon_sym_DASH] = ACTIONS(2087),
    [anon_sym_TILDE] = ACTIONS(2085),
    [anon_sym_void] = ACTIONS(2087),
    [anon_sym_delete] = ACTIONS(2087),
    [anon_sym_PLUS_PLUS] = ACTIONS(2085),
    [anon_sym_DASH_DASH] = ACTIONS(2085),
    [anon_sym_DQUOTE] = ACTIONS(2085),
    [anon_sym_SQUOTE] = ACTIONS(2085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2085),
    [sym_number] = ACTIONS(2085),
    [sym_this] = ACTIONS(2087),
    [sym_super] = ACTIONS(2087),
    [sym_true] = ACTIONS(2087),
    [sym_false] = ACTIONS(2087),
    [sym_null] = ACTIONS(2087),
    [sym_undefined] = ACTIONS(2087),
    [anon_sym_AT] = ACTIONS(2085),
    [anon_sym_static] = ACTIONS(2087),
    [anon_sym_abstract] = ACTIONS(2087),
    [anon_sym_get] = ACTIONS(2087),
    [anon_sym_set] = ACTIONS(2087),
    [anon_sym_declare] = ACTIONS(2087),
    [anon_sym_public] = ACTIONS(2087),
    [anon_sym_private] = ACTIONS(2087),
    [anon_sym_protected] = ACTIONS(2087),
    [anon_sym_module] = ACTIONS(2087),
    [anon_sym_any] = ACTIONS(2087),
    [anon_sym_number] = ACTIONS(2087),
    [anon_sym_boolean] = ACTIONS(2087),
    [anon_sym_string] = ACTIONS(2087),
    [anon_sym_symbol] = ACTIONS(2087),
    [anon_sym_interface] = ACTIONS(2087),
    [anon_sym_enum] = ACTIONS(2087),
    [sym_readonly] = ACTIONS(2087),
  },
  [610] = {
    [ts_builtin_sym_end] = ACTIONS(2089),
    [sym_identifier] = ACTIONS(2091),
    [anon_sym_export] = ACTIONS(2091),
    [anon_sym_default] = ACTIONS(2091),
    [anon_sym_namespace] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(2089),
    [anon_sym_RBRACE] = ACTIONS(2089),
    [anon_sym_type] = ACTIONS(2091),
    [anon_sym_typeof] = ACTIONS(2091),
    [anon_sym_import] = ACTIONS(2091),
    [anon_sym_var] = ACTIONS(2091),
    [anon_sym_let] = ACTIONS(2091),
    [anon_sym_const] = ACTIONS(2091),
    [anon_sym_BANG] = ACTIONS(2089),
    [anon_sym_else] = ACTIONS(2091),
    [anon_sym_if] = ACTIONS(2091),
    [anon_sym_switch] = ACTIONS(2091),
    [anon_sym_for] = ACTIONS(2091),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_await] = ACTIONS(2091),
    [anon_sym_while] = ACTIONS(2091),
    [anon_sym_do] = ACTIONS(2091),
    [anon_sym_try] = ACTIONS(2091),
    [anon_sym_with] = ACTIONS(2091),
    [anon_sym_break] = ACTIONS(2091),
    [anon_sym_continue] = ACTIONS(2091),
    [anon_sym_debugger] = ACTIONS(2091),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_throw] = ACTIONS(2091),
    [anon_sym_SEMI] = ACTIONS(2089),
    [anon_sym_case] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2091),
    [anon_sym_LBRACK] = ACTIONS(2089),
    [anon_sym_LT] = ACTIONS(2089),
    [anon_sym_SLASH] = ACTIONS(2091),
    [anon_sym_class] = ACTIONS(2091),
    [anon_sym_async] = ACTIONS(2091),
    [anon_sym_function] = ACTIONS(2091),
    [anon_sym_new] = ACTIONS(2091),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_TILDE] = ACTIONS(2089),
    [anon_sym_void] = ACTIONS(2091),
    [anon_sym_delete] = ACTIONS(2091),
    [anon_sym_PLUS_PLUS] = ACTIONS(2089),
    [anon_sym_DASH_DASH] = ACTIONS(2089),
    [anon_sym_DQUOTE] = ACTIONS(2089),
    [anon_sym_SQUOTE] = ACTIONS(2089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2089),
    [sym_number] = ACTIONS(2089),
    [sym_this] = ACTIONS(2091),
    [sym_super] = ACTIONS(2091),
    [sym_true] = ACTIONS(2091),
    [sym_false] = ACTIONS(2091),
    [sym_null] = ACTIONS(2091),
    [sym_undefined] = ACTIONS(2091),
    [anon_sym_AT] = ACTIONS(2089),
    [anon_sym_static] = ACTIONS(2091),
    [anon_sym_abstract] = ACTIONS(2091),
    [anon_sym_get] = ACTIONS(2091),
    [anon_sym_set] = ACTIONS(2091),
    [anon_sym_declare] = ACTIONS(2091),
    [anon_sym_public] = ACTIONS(2091),
    [anon_sym_private] = ACTIONS(2091),
    [anon_sym_protected] = ACTIONS(2091),
    [anon_sym_module] = ACTIONS(2091),
    [anon_sym_any] = ACTIONS(2091),
    [anon_sym_number] = ACTIONS(2091),
    [anon_sym_boolean] = ACTIONS(2091),
    [anon_sym_string] = ACTIONS(2091),
    [anon_sym_symbol] = ACTIONS(2091),
    [anon_sym_interface] = ACTIONS(2091),
    [anon_sym_enum] = ACTIONS(2091),
    [sym_readonly] = ACTIONS(2091),
  },
  [611] = {
    [ts_builtin_sym_end] = ACTIONS(2093),
    [sym_identifier] = ACTIONS(2095),
    [anon_sym_export] = ACTIONS(2095),
    [anon_sym_default] = ACTIONS(2095),
    [anon_sym_namespace] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(2093),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_type] = ACTIONS(2095),
    [anon_sym_typeof] = ACTIONS(2095),
    [anon_sym_import] = ACTIONS(2095),
    [anon_sym_var] = ACTIONS(2095),
    [anon_sym_let] = ACTIONS(2095),
    [anon_sym_const] = ACTIONS(2095),
    [anon_sym_BANG] = ACTIONS(2093),
    [anon_sym_else] = ACTIONS(2095),
    [anon_sym_if] = ACTIONS(2095),
    [anon_sym_switch] = ACTIONS(2095),
    [anon_sym_for] = ACTIONS(2095),
    [anon_sym_LPAREN] = ACTIONS(2093),
    [anon_sym_await] = ACTIONS(2095),
    [anon_sym_while] = ACTIONS(2095),
    [anon_sym_do] = ACTIONS(2095),
    [anon_sym_try] = ACTIONS(2095),
    [anon_sym_with] = ACTIONS(2095),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_continue] = ACTIONS(2095),
    [anon_sym_debugger] = ACTIONS(2095),
    [anon_sym_return] = ACTIONS(2095),
    [anon_sym_throw] = ACTIONS(2095),
    [anon_sym_SEMI] = ACTIONS(2093),
    [anon_sym_case] = ACTIONS(2095),
    [anon_sym_yield] = ACTIONS(2095),
    [anon_sym_LBRACK] = ACTIONS(2093),
    [anon_sym_LT] = ACTIONS(2093),
    [anon_sym_SLASH] = ACTIONS(2095),
    [anon_sym_class] = ACTIONS(2095),
    [anon_sym_async] = ACTIONS(2095),
    [anon_sym_function] = ACTIONS(2095),
    [anon_sym_new] = ACTIONS(2095),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_DASH] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2093),
    [anon_sym_void] = ACTIONS(2095),
    [anon_sym_delete] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2093),
    [anon_sym_DASH_DASH] = ACTIONS(2093),
    [anon_sym_DQUOTE] = ACTIONS(2093),
    [anon_sym_SQUOTE] = ACTIONS(2093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2093),
    [sym_number] = ACTIONS(2093),
    [sym_this] = ACTIONS(2095),
    [sym_super] = ACTIONS(2095),
    [sym_true] = ACTIONS(2095),
    [sym_false] = ACTIONS(2095),
    [sym_null] = ACTIONS(2095),
    [sym_undefined] = ACTIONS(2095),
    [anon_sym_AT] = ACTIONS(2093),
    [anon_sym_static] = ACTIONS(2095),
    [anon_sym_abstract] = ACTIONS(2095),
    [anon_sym_get] = ACTIONS(2095),
    [anon_sym_set] = ACTIONS(2095),
    [anon_sym_declare] = ACTIONS(2095),
    [anon_sym_public] = ACTIONS(2095),
    [anon_sym_private] = ACTIONS(2095),
    [anon_sym_protected] = ACTIONS(2095),
    [anon_sym_module] = ACTIONS(2095),
    [anon_sym_any] = ACTIONS(2095),
    [anon_sym_number] = ACTIONS(2095),
    [anon_sym_boolean] = ACTIONS(2095),
    [anon_sym_string] = ACTIONS(2095),
    [anon_sym_symbol] = ACTIONS(2095),
    [anon_sym_interface] = ACTIONS(2095),
    [anon_sym_enum] = ACTIONS(2095),
    [sym_readonly] = ACTIONS(2095),
  },
  [612] = {
    [ts_builtin_sym_end] = ACTIONS(2097),
    [sym_identifier] = ACTIONS(2099),
    [anon_sym_export] = ACTIONS(2099),
    [anon_sym_default] = ACTIONS(2099),
    [anon_sym_namespace] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_RBRACE] = ACTIONS(2097),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_typeof] = ACTIONS(2099),
    [anon_sym_import] = ACTIONS(2099),
    [anon_sym_var] = ACTIONS(2099),
    [anon_sym_let] = ACTIONS(2099),
    [anon_sym_const] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2097),
    [anon_sym_else] = ACTIONS(2099),
    [anon_sym_if] = ACTIONS(2099),
    [anon_sym_switch] = ACTIONS(2099),
    [anon_sym_for] = ACTIONS(2099),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_await] = ACTIONS(2099),
    [anon_sym_while] = ACTIONS(2099),
    [anon_sym_do] = ACTIONS(2099),
    [anon_sym_try] = ACTIONS(2099),
    [anon_sym_with] = ACTIONS(2099),
    [anon_sym_break] = ACTIONS(2099),
    [anon_sym_continue] = ACTIONS(2099),
    [anon_sym_debugger] = ACTIONS(2099),
    [anon_sym_return] = ACTIONS(2099),
    [anon_sym_throw] = ACTIONS(2099),
    [anon_sym_SEMI] = ACTIONS(2097),
    [anon_sym_case] = ACTIONS(2099),
    [anon_sym_yield] = ACTIONS(2099),
    [anon_sym_LBRACK] = ACTIONS(2097),
    [anon_sym_LT] = ACTIONS(2097),
    [anon_sym_SLASH] = ACTIONS(2099),
    [anon_sym_class] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(2099),
    [anon_sym_function] = ACTIONS(2099),
    [anon_sym_new] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2099),
    [anon_sym_DASH] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(2097),
    [anon_sym_void] = ACTIONS(2099),
    [anon_sym_delete] = ACTIONS(2099),
    [anon_sym_PLUS_PLUS] = ACTIONS(2097),
    [anon_sym_DASH_DASH] = ACTIONS(2097),
    [anon_sym_DQUOTE] = ACTIONS(2097),
    [anon_sym_SQUOTE] = ACTIONS(2097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2097),
    [sym_number] = ACTIONS(2097),
    [sym_this] = ACTIONS(2099),
    [sym_super] = ACTIONS(2099),
    [sym_true] = ACTIONS(2099),
    [sym_false] = ACTIONS(2099),
    [sym_null] = ACTIONS(2099),
    [sym_undefined] = ACTIONS(2099),
    [anon_sym_AT] = ACTIONS(2097),
    [anon_sym_static] = ACTIONS(2099),
    [anon_sym_abstract] = ACTIONS(2099),
    [anon_sym_get] = ACTIONS(2099),
    [anon_sym_set] = ACTIONS(2099),
    [anon_sym_declare] = ACTIONS(2099),
    [anon_sym_public] = ACTIONS(2099),
    [anon_sym_private] = ACTIONS(2099),
    [anon_sym_protected] = ACTIONS(2099),
    [anon_sym_module] = ACTIONS(2099),
    [anon_sym_any] = ACTIONS(2099),
    [anon_sym_number] = ACTIONS(2099),
    [anon_sym_boolean] = ACTIONS(2099),
    [anon_sym_string] = ACTIONS(2099),
    [anon_sym_symbol] = ACTIONS(2099),
    [anon_sym_interface] = ACTIONS(2099),
    [anon_sym_enum] = ACTIONS(2099),
    [sym_readonly] = ACTIONS(2099),
  },
  [613] = {
    [ts_builtin_sym_end] = ACTIONS(2101),
    [sym_identifier] = ACTIONS(2103),
    [anon_sym_export] = ACTIONS(2103),
    [anon_sym_default] = ACTIONS(2103),
    [anon_sym_namespace] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2101),
    [anon_sym_RBRACE] = ACTIONS(2101),
    [anon_sym_type] = ACTIONS(2103),
    [anon_sym_typeof] = ACTIONS(2103),
    [anon_sym_import] = ACTIONS(2103),
    [anon_sym_var] = ACTIONS(2103),
    [anon_sym_let] = ACTIONS(2103),
    [anon_sym_const] = ACTIONS(2103),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_else] = ACTIONS(2103),
    [anon_sym_if] = ACTIONS(2103),
    [anon_sym_switch] = ACTIONS(2103),
    [anon_sym_for] = ACTIONS(2103),
    [anon_sym_LPAREN] = ACTIONS(2101),
    [anon_sym_await] = ACTIONS(2103),
    [anon_sym_while] = ACTIONS(2103),
    [anon_sym_do] = ACTIONS(2103),
    [anon_sym_try] = ACTIONS(2103),
    [anon_sym_with] = ACTIONS(2103),
    [anon_sym_break] = ACTIONS(2103),
    [anon_sym_continue] = ACTIONS(2103),
    [anon_sym_debugger] = ACTIONS(2103),
    [anon_sym_return] = ACTIONS(2103),
    [anon_sym_throw] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2101),
    [anon_sym_case] = ACTIONS(2103),
    [anon_sym_yield] = ACTIONS(2103),
    [anon_sym_LBRACK] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(2101),
    [anon_sym_SLASH] = ACTIONS(2103),
    [anon_sym_class] = ACTIONS(2103),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_function] = ACTIONS(2103),
    [anon_sym_new] = ACTIONS(2103),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2101),
    [anon_sym_void] = ACTIONS(2103),
    [anon_sym_delete] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(2101),
    [anon_sym_DASH_DASH] = ACTIONS(2101),
    [anon_sym_DQUOTE] = ACTIONS(2101),
    [anon_sym_SQUOTE] = ACTIONS(2101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2101),
    [sym_number] = ACTIONS(2101),
    [sym_this] = ACTIONS(2103),
    [sym_super] = ACTIONS(2103),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [sym_null] = ACTIONS(2103),
    [sym_undefined] = ACTIONS(2103),
    [anon_sym_AT] = ACTIONS(2101),
    [anon_sym_static] = ACTIONS(2103),
    [anon_sym_abstract] = ACTIONS(2103),
    [anon_sym_get] = ACTIONS(2103),
    [anon_sym_set] = ACTIONS(2103),
    [anon_sym_declare] = ACTIONS(2103),
    [anon_sym_public] = ACTIONS(2103),
    [anon_sym_private] = ACTIONS(2103),
    [anon_sym_protected] = ACTIONS(2103),
    [anon_sym_module] = ACTIONS(2103),
    [anon_sym_any] = ACTIONS(2103),
    [anon_sym_number] = ACTIONS(2103),
    [anon_sym_boolean] = ACTIONS(2103),
    [anon_sym_string] = ACTIONS(2103),
    [anon_sym_symbol] = ACTIONS(2103),
    [anon_sym_interface] = ACTIONS(2103),
    [anon_sym_enum] = ACTIONS(2103),
    [sym_readonly] = ACTIONS(2103),
  },
  [614] = {
    [ts_builtin_sym_end] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2107),
    [anon_sym_export] = ACTIONS(2107),
    [anon_sym_default] = ACTIONS(2107),
    [anon_sym_namespace] = ACTIONS(2107),
    [anon_sym_LBRACE] = ACTIONS(2105),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_type] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2107),
    [anon_sym_import] = ACTIONS(2107),
    [anon_sym_var] = ACTIONS(2107),
    [anon_sym_let] = ACTIONS(2107),
    [anon_sym_const] = ACTIONS(2107),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_else] = ACTIONS(2107),
    [anon_sym_if] = ACTIONS(2107),
    [anon_sym_switch] = ACTIONS(2107),
    [anon_sym_for] = ACTIONS(2107),
    [anon_sym_LPAREN] = ACTIONS(2105),
    [anon_sym_await] = ACTIONS(2107),
    [anon_sym_while] = ACTIONS(2107),
    [anon_sym_do] = ACTIONS(2107),
    [anon_sym_try] = ACTIONS(2107),
    [anon_sym_with] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2107),
    [anon_sym_continue] = ACTIONS(2107),
    [anon_sym_debugger] = ACTIONS(2107),
    [anon_sym_return] = ACTIONS(2107),
    [anon_sym_throw] = ACTIONS(2107),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym_case] = ACTIONS(2107),
    [anon_sym_yield] = ACTIONS(2107),
    [anon_sym_LBRACK] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2107),
    [anon_sym_async] = ACTIONS(2107),
    [anon_sym_function] = ACTIONS(2107),
    [anon_sym_new] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2107),
    [anon_sym_DASH] = ACTIONS(2107),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_void] = ACTIONS(2107),
    [anon_sym_delete] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2105),
    [anon_sym_SQUOTE] = ACTIONS(2105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2105),
    [sym_number] = ACTIONS(2105),
    [sym_this] = ACTIONS(2107),
    [sym_super] = ACTIONS(2107),
    [sym_true] = ACTIONS(2107),
    [sym_false] = ACTIONS(2107),
    [sym_null] = ACTIONS(2107),
    [sym_undefined] = ACTIONS(2107),
    [anon_sym_AT] = ACTIONS(2105),
    [anon_sym_static] = ACTIONS(2107),
    [anon_sym_abstract] = ACTIONS(2107),
    [anon_sym_get] = ACTIONS(2107),
    [anon_sym_set] = ACTIONS(2107),
    [anon_sym_declare] = ACTIONS(2107),
    [anon_sym_public] = ACTIONS(2107),
    [anon_sym_private] = ACTIONS(2107),
    [anon_sym_protected] = ACTIONS(2107),
    [anon_sym_module] = ACTIONS(2107),
    [anon_sym_any] = ACTIONS(2107),
    [anon_sym_number] = ACTIONS(2107),
    [anon_sym_boolean] = ACTIONS(2107),
    [anon_sym_string] = ACTIONS(2107),
    [anon_sym_symbol] = ACTIONS(2107),
    [anon_sym_interface] = ACTIONS(2107),
    [anon_sym_enum] = ACTIONS(2107),
    [sym_readonly] = ACTIONS(2107),
  },
  [615] = {
    [ts_builtin_sym_end] = ACTIONS(2109),
    [sym_identifier] = ACTIONS(2111),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_default] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2109),
    [anon_sym_RBRACE] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2111),
    [anon_sym_var] = ACTIONS(2111),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_const] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_else] = ACTIONS(2111),
    [anon_sym_if] = ACTIONS(2111),
    [anon_sym_switch] = ACTIONS(2111),
    [anon_sym_for] = ACTIONS(2111),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_await] = ACTIONS(2111),
    [anon_sym_while] = ACTIONS(2111),
    [anon_sym_do] = ACTIONS(2111),
    [anon_sym_try] = ACTIONS(2111),
    [anon_sym_with] = ACTIONS(2111),
    [anon_sym_break] = ACTIONS(2111),
    [anon_sym_continue] = ACTIONS(2111),
    [anon_sym_debugger] = ACTIONS(2111),
    [anon_sym_return] = ACTIONS(2111),
    [anon_sym_throw] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [anon_sym_case] = ACTIONS(2111),
    [anon_sym_yield] = ACTIONS(2111),
    [anon_sym_LBRACK] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_class] = ACTIONS(2111),
    [anon_sym_async] = ACTIONS(2111),
    [anon_sym_function] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_TILDE] = ACTIONS(2109),
    [anon_sym_void] = ACTIONS(2111),
    [anon_sym_delete] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2109),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2109),
    [anon_sym_SQUOTE] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2109),
    [sym_number] = ACTIONS(2109),
    [sym_this] = ACTIONS(2111),
    [sym_super] = ACTIONS(2111),
    [sym_true] = ACTIONS(2111),
    [sym_false] = ACTIONS(2111),
    [sym_null] = ACTIONS(2111),
    [sym_undefined] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2109),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_abstract] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_interface] = ACTIONS(2111),
    [anon_sym_enum] = ACTIONS(2111),
    [sym_readonly] = ACTIONS(2111),
  },
  [616] = {
    [ts_builtin_sym_end] = ACTIONS(2113),
    [sym_identifier] = ACTIONS(2115),
    [anon_sym_export] = ACTIONS(2115),
    [anon_sym_default] = ACTIONS(2115),
    [anon_sym_namespace] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_RBRACE] = ACTIONS(2113),
    [anon_sym_type] = ACTIONS(2115),
    [anon_sym_typeof] = ACTIONS(2115),
    [anon_sym_import] = ACTIONS(2115),
    [anon_sym_var] = ACTIONS(2115),
    [anon_sym_let] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(2115),
    [anon_sym_BANG] = ACTIONS(2113),
    [anon_sym_else] = ACTIONS(2115),
    [anon_sym_if] = ACTIONS(2115),
    [anon_sym_switch] = ACTIONS(2115),
    [anon_sym_for] = ACTIONS(2115),
    [anon_sym_LPAREN] = ACTIONS(2113),
    [anon_sym_await] = ACTIONS(2115),
    [anon_sym_while] = ACTIONS(2115),
    [anon_sym_do] = ACTIONS(2115),
    [anon_sym_try] = ACTIONS(2115),
    [anon_sym_with] = ACTIONS(2115),
    [anon_sym_break] = ACTIONS(2115),
    [anon_sym_continue] = ACTIONS(2115),
    [anon_sym_debugger] = ACTIONS(2115),
    [anon_sym_return] = ACTIONS(2115),
    [anon_sym_throw] = ACTIONS(2115),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_case] = ACTIONS(2115),
    [anon_sym_yield] = ACTIONS(2115),
    [anon_sym_LBRACK] = ACTIONS(2113),
    [anon_sym_LT] = ACTIONS(2113),
    [anon_sym_SLASH] = ACTIONS(2115),
    [anon_sym_class] = ACTIONS(2115),
    [anon_sym_async] = ACTIONS(2115),
    [anon_sym_function] = ACTIONS(2115),
    [anon_sym_new] = ACTIONS(2115),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_TILDE] = ACTIONS(2113),
    [anon_sym_void] = ACTIONS(2115),
    [anon_sym_delete] = ACTIONS(2115),
    [anon_sym_PLUS_PLUS] = ACTIONS(2113),
    [anon_sym_DASH_DASH] = ACTIONS(2113),
    [anon_sym_DQUOTE] = ACTIONS(2113),
    [anon_sym_SQUOTE] = ACTIONS(2113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2113),
    [sym_number] = ACTIONS(2113),
    [sym_this] = ACTIONS(2115),
    [sym_super] = ACTIONS(2115),
    [sym_true] = ACTIONS(2115),
    [sym_false] = ACTIONS(2115),
    [sym_null] = ACTIONS(2115),
    [sym_undefined] = ACTIONS(2115),
    [anon_sym_AT] = ACTIONS(2113),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_abstract] = ACTIONS(2115),
    [anon_sym_get] = ACTIONS(2115),
    [anon_sym_set] = ACTIONS(2115),
    [anon_sym_declare] = ACTIONS(2115),
    [anon_sym_public] = ACTIONS(2115),
    [anon_sym_private] = ACTIONS(2115),
    [anon_sym_protected] = ACTIONS(2115),
    [anon_sym_module] = ACTIONS(2115),
    [anon_sym_any] = ACTIONS(2115),
    [anon_sym_number] = ACTIONS(2115),
    [anon_sym_boolean] = ACTIONS(2115),
    [anon_sym_string] = ACTIONS(2115),
    [anon_sym_symbol] = ACTIONS(2115),
    [anon_sym_interface] = ACTIONS(2115),
    [anon_sym_enum] = ACTIONS(2115),
    [sym_readonly] = ACTIONS(2115),
  },
  [617] = {
    [ts_builtin_sym_end] = ACTIONS(2117),
    [sym_identifier] = ACTIONS(2119),
    [anon_sym_export] = ACTIONS(2119),
    [anon_sym_default] = ACTIONS(2119),
    [anon_sym_namespace] = ACTIONS(2119),
    [anon_sym_LBRACE] = ACTIONS(2117),
    [anon_sym_RBRACE] = ACTIONS(2117),
    [anon_sym_type] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2119),
    [anon_sym_import] = ACTIONS(2119),
    [anon_sym_var] = ACTIONS(2119),
    [anon_sym_let] = ACTIONS(2119),
    [anon_sym_const] = ACTIONS(2119),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_else] = ACTIONS(2119),
    [anon_sym_if] = ACTIONS(2119),
    [anon_sym_switch] = ACTIONS(2119),
    [anon_sym_for] = ACTIONS(2119),
    [anon_sym_LPAREN] = ACTIONS(2117),
    [anon_sym_await] = ACTIONS(2119),
    [anon_sym_while] = ACTIONS(2119),
    [anon_sym_do] = ACTIONS(2119),
    [anon_sym_try] = ACTIONS(2119),
    [anon_sym_with] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2119),
    [anon_sym_continue] = ACTIONS(2119),
    [anon_sym_debugger] = ACTIONS(2119),
    [anon_sym_return] = ACTIONS(2119),
    [anon_sym_throw] = ACTIONS(2119),
    [anon_sym_SEMI] = ACTIONS(2117),
    [anon_sym_case] = ACTIONS(2119),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_LT] = ACTIONS(2117),
    [anon_sym_SLASH] = ACTIONS(2119),
    [anon_sym_class] = ACTIONS(2119),
    [anon_sym_async] = ACTIONS(2119),
    [anon_sym_function] = ACTIONS(2119),
    [anon_sym_new] = ACTIONS(2119),
    [anon_sym_PLUS] = ACTIONS(2119),
    [anon_sym_DASH] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_void] = ACTIONS(2119),
    [anon_sym_delete] = ACTIONS(2119),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_DQUOTE] = ACTIONS(2117),
    [anon_sym_SQUOTE] = ACTIONS(2117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2117),
    [sym_number] = ACTIONS(2117),
    [sym_this] = ACTIONS(2119),
    [sym_super] = ACTIONS(2119),
    [sym_true] = ACTIONS(2119),
    [sym_false] = ACTIONS(2119),
    [sym_null] = ACTIONS(2119),
    [sym_undefined] = ACTIONS(2119),
    [anon_sym_AT] = ACTIONS(2117),
    [anon_sym_static] = ACTIONS(2119),
    [anon_sym_abstract] = ACTIONS(2119),
    [anon_sym_get] = ACTIONS(2119),
    [anon_sym_set] = ACTIONS(2119),
    [anon_sym_declare] = ACTIONS(2119),
    [anon_sym_public] = ACTIONS(2119),
    [anon_sym_private] = ACTIONS(2119),
    [anon_sym_protected] = ACTIONS(2119),
    [anon_sym_module] = ACTIONS(2119),
    [anon_sym_any] = ACTIONS(2119),
    [anon_sym_number] = ACTIONS(2119),
    [anon_sym_boolean] = ACTIONS(2119),
    [anon_sym_string] = ACTIONS(2119),
    [anon_sym_symbol] = ACTIONS(2119),
    [anon_sym_interface] = ACTIONS(2119),
    [anon_sym_enum] = ACTIONS(2119),
    [sym_readonly] = ACTIONS(2119),
  },
  [618] = {
    [ts_builtin_sym_end] = ACTIONS(2121),
    [sym_identifier] = ACTIONS(2123),
    [anon_sym_export] = ACTIONS(2123),
    [anon_sym_default] = ACTIONS(2123),
    [anon_sym_namespace] = ACTIONS(2123),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_RBRACE] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2123),
    [anon_sym_import] = ACTIONS(2123),
    [anon_sym_var] = ACTIONS(2123),
    [anon_sym_let] = ACTIONS(2123),
    [anon_sym_const] = ACTIONS(2123),
    [anon_sym_BANG] = ACTIONS(2121),
    [anon_sym_else] = ACTIONS(2123),
    [anon_sym_if] = ACTIONS(2123),
    [anon_sym_switch] = ACTIONS(2123),
    [anon_sym_for] = ACTIONS(2123),
    [anon_sym_LPAREN] = ACTIONS(2121),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_while] = ACTIONS(2123),
    [anon_sym_do] = ACTIONS(2123),
    [anon_sym_try] = ACTIONS(2123),
    [anon_sym_with] = ACTIONS(2123),
    [anon_sym_break] = ACTIONS(2123),
    [anon_sym_continue] = ACTIONS(2123),
    [anon_sym_debugger] = ACTIONS(2123),
    [anon_sym_return] = ACTIONS(2123),
    [anon_sym_throw] = ACTIONS(2123),
    [anon_sym_SEMI] = ACTIONS(2121),
    [anon_sym_case] = ACTIONS(2123),
    [anon_sym_yield] = ACTIONS(2123),
    [anon_sym_LBRACK] = ACTIONS(2121),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_SLASH] = ACTIONS(2123),
    [anon_sym_class] = ACTIONS(2123),
    [anon_sym_async] = ACTIONS(2123),
    [anon_sym_function] = ACTIONS(2123),
    [anon_sym_new] = ACTIONS(2123),
    [anon_sym_PLUS] = ACTIONS(2123),
    [anon_sym_DASH] = ACTIONS(2123),
    [anon_sym_TILDE] = ACTIONS(2121),
    [anon_sym_void] = ACTIONS(2123),
    [anon_sym_delete] = ACTIONS(2123),
    [anon_sym_PLUS_PLUS] = ACTIONS(2121),
    [anon_sym_DASH_DASH] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2121),
    [anon_sym_SQUOTE] = ACTIONS(2121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2121),
    [sym_number] = ACTIONS(2121),
    [sym_this] = ACTIONS(2123),
    [sym_super] = ACTIONS(2123),
    [sym_true] = ACTIONS(2123),
    [sym_false] = ACTIONS(2123),
    [sym_null] = ACTIONS(2123),
    [sym_undefined] = ACTIONS(2123),
    [anon_sym_AT] = ACTIONS(2121),
    [anon_sym_static] = ACTIONS(2123),
    [anon_sym_abstract] = ACTIONS(2123),
    [anon_sym_get] = ACTIONS(2123),
    [anon_sym_set] = ACTIONS(2123),
    [anon_sym_declare] = ACTIONS(2123),
    [anon_sym_public] = ACTIONS(2123),
    [anon_sym_private] = ACTIONS(2123),
    [anon_sym_protected] = ACTIONS(2123),
    [anon_sym_module] = ACTIONS(2123),
    [anon_sym_any] = ACTIONS(2123),
    [anon_sym_number] = ACTIONS(2123),
    [anon_sym_boolean] = ACTIONS(2123),
    [anon_sym_string] = ACTIONS(2123),
    [anon_sym_symbol] = ACTIONS(2123),
    [anon_sym_interface] = ACTIONS(2123),
    [anon_sym_enum] = ACTIONS(2123),
    [sym_readonly] = ACTIONS(2123),
  },
  [619] = {
    [ts_builtin_sym_end] = ACTIONS(2125),
    [sym_identifier] = ACTIONS(2127),
    [anon_sym_export] = ACTIONS(2127),
    [anon_sym_default] = ACTIONS(2127),
    [anon_sym_namespace] = ACTIONS(2127),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2127),
    [anon_sym_typeof] = ACTIONS(2127),
    [anon_sym_import] = ACTIONS(2127),
    [anon_sym_var] = ACTIONS(2127),
    [anon_sym_let] = ACTIONS(2127),
    [anon_sym_const] = ACTIONS(2127),
    [anon_sym_BANG] = ACTIONS(2125),
    [anon_sym_else] = ACTIONS(2127),
    [anon_sym_if] = ACTIONS(2127),
    [anon_sym_switch] = ACTIONS(2127),
    [anon_sym_for] = ACTIONS(2127),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_await] = ACTIONS(2127),
    [anon_sym_while] = ACTIONS(2127),
    [anon_sym_do] = ACTIONS(2127),
    [anon_sym_try] = ACTIONS(2127),
    [anon_sym_with] = ACTIONS(2127),
    [anon_sym_break] = ACTIONS(2127),
    [anon_sym_continue] = ACTIONS(2127),
    [anon_sym_debugger] = ACTIONS(2127),
    [anon_sym_return] = ACTIONS(2127),
    [anon_sym_throw] = ACTIONS(2127),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_case] = ACTIONS(2127),
    [anon_sym_yield] = ACTIONS(2127),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_SLASH] = ACTIONS(2127),
    [anon_sym_class] = ACTIONS(2127),
    [anon_sym_async] = ACTIONS(2127),
    [anon_sym_function] = ACTIONS(2127),
    [anon_sym_new] = ACTIONS(2127),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_TILDE] = ACTIONS(2125),
    [anon_sym_void] = ACTIONS(2127),
    [anon_sym_delete] = ACTIONS(2127),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2125),
    [sym_number] = ACTIONS(2125),
    [sym_this] = ACTIONS(2127),
    [sym_super] = ACTIONS(2127),
    [sym_true] = ACTIONS(2127),
    [sym_false] = ACTIONS(2127),
    [sym_null] = ACTIONS(2127),
    [sym_undefined] = ACTIONS(2127),
    [anon_sym_AT] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2127),
    [anon_sym_abstract] = ACTIONS(2127),
    [anon_sym_get] = ACTIONS(2127),
    [anon_sym_set] = ACTIONS(2127),
    [anon_sym_declare] = ACTIONS(2127),
    [anon_sym_public] = ACTIONS(2127),
    [anon_sym_private] = ACTIONS(2127),
    [anon_sym_protected] = ACTIONS(2127),
    [anon_sym_module] = ACTIONS(2127),
    [anon_sym_any] = ACTIONS(2127),
    [anon_sym_number] = ACTIONS(2127),
    [anon_sym_boolean] = ACTIONS(2127),
    [anon_sym_string] = ACTIONS(2127),
    [anon_sym_symbol] = ACTIONS(2127),
    [anon_sym_interface] = ACTIONS(2127),
    [anon_sym_enum] = ACTIONS(2127),
    [sym_readonly] = ACTIONS(2127),
  },
  [620] = {
    [ts_builtin_sym_end] = ACTIONS(2129),
    [sym_identifier] = ACTIONS(2131),
    [anon_sym_export] = ACTIONS(2131),
    [anon_sym_default] = ACTIONS(2131),
    [anon_sym_namespace] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_type] = ACTIONS(2131),
    [anon_sym_typeof] = ACTIONS(2131),
    [anon_sym_import] = ACTIONS(2131),
    [anon_sym_var] = ACTIONS(2131),
    [anon_sym_let] = ACTIONS(2131),
    [anon_sym_const] = ACTIONS(2131),
    [anon_sym_BANG] = ACTIONS(2129),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2129),
    [anon_sym_await] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_do] = ACTIONS(2131),
    [anon_sym_try] = ACTIONS(2131),
    [anon_sym_with] = ACTIONS(2131),
    [anon_sym_break] = ACTIONS(2131),
    [anon_sym_continue] = ACTIONS(2131),
    [anon_sym_debugger] = ACTIONS(2131),
    [anon_sym_return] = ACTIONS(2131),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_case] = ACTIONS(2131),
    [anon_sym_yield] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2129),
    [anon_sym_LT] = ACTIONS(2129),
    [anon_sym_SLASH] = ACTIONS(2131),
    [anon_sym_class] = ACTIONS(2131),
    [anon_sym_async] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2129),
    [anon_sym_void] = ACTIONS(2131),
    [anon_sym_delete] = ACTIONS(2131),
    [anon_sym_PLUS_PLUS] = ACTIONS(2129),
    [anon_sym_DASH_DASH] = ACTIONS(2129),
    [anon_sym_DQUOTE] = ACTIONS(2129),
    [anon_sym_SQUOTE] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2129),
    [sym_number] = ACTIONS(2129),
    [sym_this] = ACTIONS(2131),
    [sym_super] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [sym_null] = ACTIONS(2131),
    [sym_undefined] = ACTIONS(2131),
    [anon_sym_AT] = ACTIONS(2129),
    [anon_sym_static] = ACTIONS(2131),
    [anon_sym_abstract] = ACTIONS(2131),
    [anon_sym_get] = ACTIONS(2131),
    [anon_sym_set] = ACTIONS(2131),
    [anon_sym_declare] = ACTIONS(2131),
    [anon_sym_public] = ACTIONS(2131),
    [anon_sym_private] = ACTIONS(2131),
    [anon_sym_protected] = ACTIONS(2131),
    [anon_sym_module] = ACTIONS(2131),
    [anon_sym_any] = ACTIONS(2131),
    [anon_sym_number] = ACTIONS(2131),
    [anon_sym_boolean] = ACTIONS(2131),
    [anon_sym_string] = ACTIONS(2131),
    [anon_sym_symbol] = ACTIONS(2131),
    [anon_sym_interface] = ACTIONS(2131),
    [anon_sym_enum] = ACTIONS(2131),
    [sym_readonly] = ACTIONS(2131),
  },
  [621] = {
    [ts_builtin_sym_end] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2135),
    [anon_sym_export] = ACTIONS(2135),
    [anon_sym_default] = ACTIONS(2135),
    [anon_sym_namespace] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(2133),
    [anon_sym_RBRACE] = ACTIONS(2133),
    [anon_sym_type] = ACTIONS(2135),
    [anon_sym_typeof] = ACTIONS(2135),
    [anon_sym_import] = ACTIONS(2135),
    [anon_sym_var] = ACTIONS(2135),
    [anon_sym_let] = ACTIONS(2135),
    [anon_sym_const] = ACTIONS(2135),
    [anon_sym_BANG] = ACTIONS(2133),
    [anon_sym_else] = ACTIONS(2135),
    [anon_sym_if] = ACTIONS(2135),
    [anon_sym_switch] = ACTIONS(2135),
    [anon_sym_for] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(2133),
    [anon_sym_await] = ACTIONS(2135),
    [anon_sym_while] = ACTIONS(2135),
    [anon_sym_do] = ACTIONS(2135),
    [anon_sym_try] = ACTIONS(2135),
    [anon_sym_with] = ACTIONS(2135),
    [anon_sym_break] = ACTIONS(2135),
    [anon_sym_continue] = ACTIONS(2135),
    [anon_sym_debugger] = ACTIONS(2135),
    [anon_sym_return] = ACTIONS(2135),
    [anon_sym_throw] = ACTIONS(2135),
    [anon_sym_SEMI] = ACTIONS(2133),
    [anon_sym_case] = ACTIONS(2135),
    [anon_sym_yield] = ACTIONS(2135),
    [anon_sym_LBRACK] = ACTIONS(2133),
    [anon_sym_LT] = ACTIONS(2133),
    [anon_sym_SLASH] = ACTIONS(2135),
    [anon_sym_class] = ACTIONS(2135),
    [anon_sym_async] = ACTIONS(2135),
    [anon_sym_function] = ACTIONS(2135),
    [anon_sym_new] = ACTIONS(2135),
    [anon_sym_PLUS] = ACTIONS(2135),
    [anon_sym_DASH] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2133),
    [anon_sym_void] = ACTIONS(2135),
    [anon_sym_delete] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(2133),
    [anon_sym_SQUOTE] = ACTIONS(2133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2133),
    [sym_number] = ACTIONS(2133),
    [sym_this] = ACTIONS(2135),
    [sym_super] = ACTIONS(2135),
    [sym_true] = ACTIONS(2135),
    [sym_false] = ACTIONS(2135),
    [sym_null] = ACTIONS(2135),
    [sym_undefined] = ACTIONS(2135),
    [anon_sym_AT] = ACTIONS(2133),
    [anon_sym_static] = ACTIONS(2135),
    [anon_sym_abstract] = ACTIONS(2135),
    [anon_sym_get] = ACTIONS(2135),
    [anon_sym_set] = ACTIONS(2135),
    [anon_sym_declare] = ACTIONS(2135),
    [anon_sym_public] = ACTIONS(2135),
    [anon_sym_private] = ACTIONS(2135),
    [anon_sym_protected] = ACTIONS(2135),
    [anon_sym_module] = ACTIONS(2135),
    [anon_sym_any] = ACTIONS(2135),
    [anon_sym_number] = ACTIONS(2135),
    [anon_sym_boolean] = ACTIONS(2135),
    [anon_sym_string] = ACTIONS(2135),
    [anon_sym_symbol] = ACTIONS(2135),
    [anon_sym_interface] = ACTIONS(2135),
    [anon_sym_enum] = ACTIONS(2135),
    [sym_readonly] = ACTIONS(2135),
  },
  [622] = {
    [ts_builtin_sym_end] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_export] = ACTIONS(2139),
    [anon_sym_default] = ACTIONS(2139),
    [anon_sym_namespace] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2137),
    [anon_sym_RBRACE] = ACTIONS(2137),
    [anon_sym_type] = ACTIONS(2139),
    [anon_sym_typeof] = ACTIONS(2139),
    [anon_sym_import] = ACTIONS(2139),
    [anon_sym_var] = ACTIONS(2139),
    [anon_sym_let] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_BANG] = ACTIONS(2137),
    [anon_sym_else] = ACTIONS(2139),
    [anon_sym_if] = ACTIONS(2139),
    [anon_sym_switch] = ACTIONS(2139),
    [anon_sym_for] = ACTIONS(2139),
    [anon_sym_LPAREN] = ACTIONS(2137),
    [anon_sym_await] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(2139),
    [anon_sym_do] = ACTIONS(2139),
    [anon_sym_try] = ACTIONS(2139),
    [anon_sym_with] = ACTIONS(2139),
    [anon_sym_break] = ACTIONS(2139),
    [anon_sym_continue] = ACTIONS(2139),
    [anon_sym_debugger] = ACTIONS(2139),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_SEMI] = ACTIONS(2137),
    [anon_sym_case] = ACTIONS(2139),
    [anon_sym_yield] = ACTIONS(2139),
    [anon_sym_LBRACK] = ACTIONS(2137),
    [anon_sym_LT] = ACTIONS(2137),
    [anon_sym_SLASH] = ACTIONS(2139),
    [anon_sym_class] = ACTIONS(2139),
    [anon_sym_async] = ACTIONS(2139),
    [anon_sym_function] = ACTIONS(2139),
    [anon_sym_new] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(2139),
    [anon_sym_DASH] = ACTIONS(2139),
    [anon_sym_TILDE] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2139),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_PLUS_PLUS] = ACTIONS(2137),
    [anon_sym_DASH_DASH] = ACTIONS(2137),
    [anon_sym_DQUOTE] = ACTIONS(2137),
    [anon_sym_SQUOTE] = ACTIONS(2137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2137),
    [sym_number] = ACTIONS(2137),
    [sym_this] = ACTIONS(2139),
    [sym_super] = ACTIONS(2139),
    [sym_true] = ACTIONS(2139),
    [sym_false] = ACTIONS(2139),
    [sym_null] = ACTIONS(2139),
    [sym_undefined] = ACTIONS(2139),
    [anon_sym_AT] = ACTIONS(2137),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_abstract] = ACTIONS(2139),
    [anon_sym_get] = ACTIONS(2139),
    [anon_sym_set] = ACTIONS(2139),
    [anon_sym_declare] = ACTIONS(2139),
    [anon_sym_public] = ACTIONS(2139),
    [anon_sym_private] = ACTIONS(2139),
    [anon_sym_protected] = ACTIONS(2139),
    [anon_sym_module] = ACTIONS(2139),
    [anon_sym_any] = ACTIONS(2139),
    [anon_sym_number] = ACTIONS(2139),
    [anon_sym_boolean] = ACTIONS(2139),
    [anon_sym_string] = ACTIONS(2139),
    [anon_sym_symbol] = ACTIONS(2139),
    [anon_sym_interface] = ACTIONS(2139),
    [anon_sym_enum] = ACTIONS(2139),
    [sym_readonly] = ACTIONS(2139),
  },
  [623] = {
    [ts_builtin_sym_end] = ACTIONS(2141),
    [sym_identifier] = ACTIONS(2143),
    [anon_sym_export] = ACTIONS(2143),
    [anon_sym_default] = ACTIONS(2143),
    [anon_sym_namespace] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(2141),
    [anon_sym_RBRACE] = ACTIONS(2141),
    [anon_sym_type] = ACTIONS(2143),
    [anon_sym_typeof] = ACTIONS(2143),
    [anon_sym_import] = ACTIONS(2143),
    [anon_sym_var] = ACTIONS(2143),
    [anon_sym_let] = ACTIONS(2143),
    [anon_sym_const] = ACTIONS(2143),
    [anon_sym_BANG] = ACTIONS(2141),
    [anon_sym_else] = ACTIONS(2143),
    [anon_sym_if] = ACTIONS(2143),
    [anon_sym_switch] = ACTIONS(2143),
    [anon_sym_for] = ACTIONS(2143),
    [anon_sym_LPAREN] = ACTIONS(2141),
    [anon_sym_await] = ACTIONS(2143),
    [anon_sym_while] = ACTIONS(2143),
    [anon_sym_do] = ACTIONS(2143),
    [anon_sym_try] = ACTIONS(2143),
    [anon_sym_with] = ACTIONS(2143),
    [anon_sym_break] = ACTIONS(2143),
    [anon_sym_continue] = ACTIONS(2143),
    [anon_sym_debugger] = ACTIONS(2143),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_throw] = ACTIONS(2143),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym_case] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2143),
    [anon_sym_LBRACK] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2141),
    [anon_sym_SLASH] = ACTIONS(2143),
    [anon_sym_class] = ACTIONS(2143),
    [anon_sym_async] = ACTIONS(2143),
    [anon_sym_function] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2143),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_TILDE] = ACTIONS(2141),
    [anon_sym_void] = ACTIONS(2143),
    [anon_sym_delete] = ACTIONS(2143),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_DQUOTE] = ACTIONS(2141),
    [anon_sym_SQUOTE] = ACTIONS(2141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2141),
    [sym_number] = ACTIONS(2141),
    [sym_this] = ACTIONS(2143),
    [sym_super] = ACTIONS(2143),
    [sym_true] = ACTIONS(2143),
    [sym_false] = ACTIONS(2143),
    [sym_null] = ACTIONS(2143),
    [sym_undefined] = ACTIONS(2143),
    [anon_sym_AT] = ACTIONS(2141),
    [anon_sym_static] = ACTIONS(2143),
    [anon_sym_abstract] = ACTIONS(2143),
    [anon_sym_get] = ACTIONS(2143),
    [anon_sym_set] = ACTIONS(2143),
    [anon_sym_declare] = ACTIONS(2143),
    [anon_sym_public] = ACTIONS(2143),
    [anon_sym_private] = ACTIONS(2143),
    [anon_sym_protected] = ACTIONS(2143),
    [anon_sym_module] = ACTIONS(2143),
    [anon_sym_any] = ACTIONS(2143),
    [anon_sym_number] = ACTIONS(2143),
    [anon_sym_boolean] = ACTIONS(2143),
    [anon_sym_string] = ACTIONS(2143),
    [anon_sym_symbol] = ACTIONS(2143),
    [anon_sym_interface] = ACTIONS(2143),
    [anon_sym_enum] = ACTIONS(2143),
    [sym_readonly] = ACTIONS(2143),
  },
  [624] = {
    [ts_builtin_sym_end] = ACTIONS(2145),
    [sym_identifier] = ACTIONS(2147),
    [anon_sym_export] = ACTIONS(2147),
    [anon_sym_default] = ACTIONS(2147),
    [anon_sym_namespace] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_type] = ACTIONS(2147),
    [anon_sym_typeof] = ACTIONS(2147),
    [anon_sym_import] = ACTIONS(2147),
    [anon_sym_var] = ACTIONS(2147),
    [anon_sym_let] = ACTIONS(2147),
    [anon_sym_const] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2147),
    [anon_sym_if] = ACTIONS(2147),
    [anon_sym_switch] = ACTIONS(2147),
    [anon_sym_for] = ACTIONS(2147),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2147),
    [anon_sym_while] = ACTIONS(2147),
    [anon_sym_do] = ACTIONS(2147),
    [anon_sym_try] = ACTIONS(2147),
    [anon_sym_with] = ACTIONS(2147),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_continue] = ACTIONS(2147),
    [anon_sym_debugger] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2147),
    [anon_sym_throw] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_case] = ACTIONS(2147),
    [anon_sym_yield] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_class] = ACTIONS(2147),
    [anon_sym_async] = ACTIONS(2147),
    [anon_sym_function] = ACTIONS(2147),
    [anon_sym_new] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_delete] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [sym_number] = ACTIONS(2145),
    [sym_this] = ACTIONS(2147),
    [sym_super] = ACTIONS(2147),
    [sym_true] = ACTIONS(2147),
    [sym_false] = ACTIONS(2147),
    [sym_null] = ACTIONS(2147),
    [sym_undefined] = ACTIONS(2147),
    [anon_sym_AT] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2147),
    [anon_sym_abstract] = ACTIONS(2147),
    [anon_sym_get] = ACTIONS(2147),
    [anon_sym_set] = ACTIONS(2147),
    [anon_sym_declare] = ACTIONS(2147),
    [anon_sym_public] = ACTIONS(2147),
    [anon_sym_private] = ACTIONS(2147),
    [anon_sym_protected] = ACTIONS(2147),
    [anon_sym_module] = ACTIONS(2147),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_boolean] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_interface] = ACTIONS(2147),
    [anon_sym_enum] = ACTIONS(2147),
    [sym_readonly] = ACTIONS(2147),
  },
  [625] = {
    [ts_builtin_sym_end] = ACTIONS(2149),
    [sym_identifier] = ACTIONS(2151),
    [anon_sym_export] = ACTIONS(2151),
    [anon_sym_default] = ACTIONS(2151),
    [anon_sym_namespace] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(2149),
    [anon_sym_RBRACE] = ACTIONS(2149),
    [anon_sym_type] = ACTIONS(2151),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_import] = ACTIONS(2151),
    [anon_sym_var] = ACTIONS(2151),
    [anon_sym_let] = ACTIONS(2151),
    [anon_sym_const] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2149),
    [anon_sym_else] = ACTIONS(2151),
    [anon_sym_if] = ACTIONS(2151),
    [anon_sym_switch] = ACTIONS(2151),
    [anon_sym_for] = ACTIONS(2151),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_await] = ACTIONS(2151),
    [anon_sym_while] = ACTIONS(2151),
    [anon_sym_do] = ACTIONS(2151),
    [anon_sym_try] = ACTIONS(2151),
    [anon_sym_with] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2151),
    [anon_sym_continue] = ACTIONS(2151),
    [anon_sym_debugger] = ACTIONS(2151),
    [anon_sym_return] = ACTIONS(2151),
    [anon_sym_throw] = ACTIONS(2151),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_case] = ACTIONS(2151),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2151),
    [anon_sym_class] = ACTIONS(2151),
    [anon_sym_async] = ACTIONS(2151),
    [anon_sym_function] = ACTIONS(2151),
    [anon_sym_new] = ACTIONS(2151),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(2149),
    [anon_sym_void] = ACTIONS(2151),
    [anon_sym_delete] = ACTIONS(2151),
    [anon_sym_PLUS_PLUS] = ACTIONS(2149),
    [anon_sym_DASH_DASH] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(2149),
    [anon_sym_SQUOTE] = ACTIONS(2149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2149),
    [sym_number] = ACTIONS(2149),
    [sym_this] = ACTIONS(2151),
    [sym_super] = ACTIONS(2151),
    [sym_true] = ACTIONS(2151),
    [sym_false] = ACTIONS(2151),
    [sym_null] = ACTIONS(2151),
    [sym_undefined] = ACTIONS(2151),
    [anon_sym_AT] = ACTIONS(2149),
    [anon_sym_static] = ACTIONS(2151),
    [anon_sym_abstract] = ACTIONS(2151),
    [anon_sym_get] = ACTIONS(2151),
    [anon_sym_set] = ACTIONS(2151),
    [anon_sym_declare] = ACTIONS(2151),
    [anon_sym_public] = ACTIONS(2151),
    [anon_sym_private] = ACTIONS(2151),
    [anon_sym_protected] = ACTIONS(2151),
    [anon_sym_module] = ACTIONS(2151),
    [anon_sym_any] = ACTIONS(2151),
    [anon_sym_number] = ACTIONS(2151),
    [anon_sym_boolean] = ACTIONS(2151),
    [anon_sym_string] = ACTIONS(2151),
    [anon_sym_symbol] = ACTIONS(2151),
    [anon_sym_interface] = ACTIONS(2151),
    [anon_sym_enum] = ACTIONS(2151),
    [sym_readonly] = ACTIONS(2151),
  },
  [626] = {
    [ts_builtin_sym_end] = ACTIONS(2153),
    [sym_identifier] = ACTIONS(2155),
    [anon_sym_export] = ACTIONS(2155),
    [anon_sym_default] = ACTIONS(2155),
    [anon_sym_namespace] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(2153),
    [anon_sym_RBRACE] = ACTIONS(2153),
    [anon_sym_type] = ACTIONS(2155),
    [anon_sym_typeof] = ACTIONS(2155),
    [anon_sym_import] = ACTIONS(2155),
    [anon_sym_var] = ACTIONS(2155),
    [anon_sym_let] = ACTIONS(2155),
    [anon_sym_const] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_else] = ACTIONS(2155),
    [anon_sym_if] = ACTIONS(2155),
    [anon_sym_switch] = ACTIONS(2155),
    [anon_sym_for] = ACTIONS(2155),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_await] = ACTIONS(2155),
    [anon_sym_while] = ACTIONS(2155),
    [anon_sym_do] = ACTIONS(2155),
    [anon_sym_try] = ACTIONS(2155),
    [anon_sym_with] = ACTIONS(2155),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_continue] = ACTIONS(2155),
    [anon_sym_debugger] = ACTIONS(2155),
    [anon_sym_return] = ACTIONS(2155),
    [anon_sym_throw] = ACTIONS(2155),
    [anon_sym_SEMI] = ACTIONS(2153),
    [anon_sym_case] = ACTIONS(2155),
    [anon_sym_yield] = ACTIONS(2155),
    [anon_sym_LBRACK] = ACTIONS(2153),
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_SLASH] = ACTIONS(2155),
    [anon_sym_class] = ACTIONS(2155),
    [anon_sym_async] = ACTIONS(2155),
    [anon_sym_function] = ACTIONS(2155),
    [anon_sym_new] = ACTIONS(2155),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2153),
    [anon_sym_void] = ACTIONS(2155),
    [anon_sym_delete] = ACTIONS(2155),
    [anon_sym_PLUS_PLUS] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(2153),
    [anon_sym_DQUOTE] = ACTIONS(2153),
    [anon_sym_SQUOTE] = ACTIONS(2153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2153),
    [sym_number] = ACTIONS(2153),
    [sym_this] = ACTIONS(2155),
    [sym_super] = ACTIONS(2155),
    [sym_true] = ACTIONS(2155),
    [sym_false] = ACTIONS(2155),
    [sym_null] = ACTIONS(2155),
    [sym_undefined] = ACTIONS(2155),
    [anon_sym_AT] = ACTIONS(2153),
    [anon_sym_static] = ACTIONS(2155),
    [anon_sym_abstract] = ACTIONS(2155),
    [anon_sym_get] = ACTIONS(2155),
    [anon_sym_set] = ACTIONS(2155),
    [anon_sym_declare] = ACTIONS(2155),
    [anon_sym_public] = ACTIONS(2155),
    [anon_sym_private] = ACTIONS(2155),
    [anon_sym_protected] = ACTIONS(2155),
    [anon_sym_module] = ACTIONS(2155),
    [anon_sym_any] = ACTIONS(2155),
    [anon_sym_number] = ACTIONS(2155),
    [anon_sym_boolean] = ACTIONS(2155),
    [anon_sym_string] = ACTIONS(2155),
    [anon_sym_symbol] = ACTIONS(2155),
    [anon_sym_interface] = ACTIONS(2155),
    [anon_sym_enum] = ACTIONS(2155),
    [sym_readonly] = ACTIONS(2155),
  },
  [627] = {
    [ts_builtin_sym_end] = ACTIONS(1039),
    [sym_identifier] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_default] = ACTIONS(1041),
    [anon_sym_namespace] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_type] = ACTIONS(1041),
    [anon_sym_typeof] = ACTIONS(1041),
    [anon_sym_import] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_let] = ACTIONS(1041),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_await] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_do] = ACTIONS(1041),
    [anon_sym_try] = ACTIONS(1041),
    [anon_sym_with] = ACTIONS(1041),
    [anon_sym_break] = ACTIONS(1041),
    [anon_sym_continue] = ACTIONS(1041),
    [anon_sym_debugger] = ACTIONS(1041),
    [anon_sym_return] = ACTIONS(1041),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_case] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_class] = ACTIONS(1041),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_function] = ACTIONS(1041),
    [anon_sym_new] = ACTIONS(1041),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_void] = ACTIONS(1041),
    [anon_sym_delete] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_DASH_DASH] = ACTIONS(1039),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1039),
    [sym_number] = ACTIONS(1039),
    [sym_this] = ACTIONS(1041),
    [sym_super] = ACTIONS(1041),
    [sym_true] = ACTIONS(1041),
    [sym_false] = ACTIONS(1041),
    [sym_null] = ACTIONS(1041),
    [sym_undefined] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
    [anon_sym_static] = ACTIONS(1041),
    [anon_sym_abstract] = ACTIONS(1041),
    [anon_sym_get] = ACTIONS(1041),
    [anon_sym_set] = ACTIONS(1041),
    [anon_sym_declare] = ACTIONS(1041),
    [anon_sym_public] = ACTIONS(1041),
    [anon_sym_private] = ACTIONS(1041),
    [anon_sym_protected] = ACTIONS(1041),
    [anon_sym_module] = ACTIONS(1041),
    [anon_sym_any] = ACTIONS(1041),
    [anon_sym_number] = ACTIONS(1041),
    [anon_sym_boolean] = ACTIONS(1041),
    [anon_sym_string] = ACTIONS(1041),
    [anon_sym_symbol] = ACTIONS(1041),
    [anon_sym_interface] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [sym_readonly] = ACTIONS(1041),
  },
  [628] = {
    [ts_builtin_sym_end] = ACTIONS(2157),
    [sym_identifier] = ACTIONS(2159),
    [anon_sym_export] = ACTIONS(2159),
    [anon_sym_default] = ACTIONS(2159),
    [anon_sym_namespace] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2157),
    [anon_sym_RBRACE] = ACTIONS(2157),
    [anon_sym_type] = ACTIONS(2159),
    [anon_sym_typeof] = ACTIONS(2159),
    [anon_sym_import] = ACTIONS(2159),
    [anon_sym_var] = ACTIONS(2159),
    [anon_sym_let] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_else] = ACTIONS(2159),
    [anon_sym_if] = ACTIONS(2159),
    [anon_sym_switch] = ACTIONS(2159),
    [anon_sym_for] = ACTIONS(2159),
    [anon_sym_LPAREN] = ACTIONS(2157),
    [anon_sym_await] = ACTIONS(2159),
    [anon_sym_while] = ACTIONS(2159),
    [anon_sym_do] = ACTIONS(2159),
    [anon_sym_try] = ACTIONS(2159),
    [anon_sym_with] = ACTIONS(2159),
    [anon_sym_break] = ACTIONS(2159),
    [anon_sym_continue] = ACTIONS(2159),
    [anon_sym_debugger] = ACTIONS(2159),
    [anon_sym_return] = ACTIONS(2159),
    [anon_sym_throw] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2157),
    [anon_sym_case] = ACTIONS(2159),
    [anon_sym_yield] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2157),
    [anon_sym_LT] = ACTIONS(2157),
    [anon_sym_SLASH] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_async] = ACTIONS(2159),
    [anon_sym_function] = ACTIONS(2159),
    [anon_sym_new] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_void] = ACTIONS(2159),
    [anon_sym_delete] = ACTIONS(2159),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_DQUOTE] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(2157),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2157),
    [sym_number] = ACTIONS(2157),
    [sym_this] = ACTIONS(2159),
    [sym_super] = ACTIONS(2159),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [sym_null] = ACTIONS(2159),
    [sym_undefined] = ACTIONS(2159),
    [anon_sym_AT] = ACTIONS(2157),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_abstract] = ACTIONS(2159),
    [anon_sym_get] = ACTIONS(2159),
    [anon_sym_set] = ACTIONS(2159),
    [anon_sym_declare] = ACTIONS(2159),
    [anon_sym_public] = ACTIONS(2159),
    [anon_sym_private] = ACTIONS(2159),
    [anon_sym_protected] = ACTIONS(2159),
    [anon_sym_module] = ACTIONS(2159),
    [anon_sym_any] = ACTIONS(2159),
    [anon_sym_number] = ACTIONS(2159),
    [anon_sym_boolean] = ACTIONS(2159),
    [anon_sym_string] = ACTIONS(2159),
    [anon_sym_symbol] = ACTIONS(2159),
    [anon_sym_interface] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [sym_readonly] = ACTIONS(2159),
  },
  [629] = {
    [ts_builtin_sym_end] = ACTIONS(2161),
    [sym_identifier] = ACTIONS(2163),
    [anon_sym_export] = ACTIONS(2163),
    [anon_sym_default] = ACTIONS(2163),
    [anon_sym_namespace] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_RBRACE] = ACTIONS(2161),
    [anon_sym_type] = ACTIONS(2163),
    [anon_sym_typeof] = ACTIONS(2163),
    [anon_sym_import] = ACTIONS(2163),
    [anon_sym_var] = ACTIONS(2163),
    [anon_sym_let] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_else] = ACTIONS(2163),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2161),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_with] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_debugger] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym_case] = ACTIONS(2163),
    [anon_sym_yield] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2161),
    [anon_sym_LT] = ACTIONS(2161),
    [anon_sym_SLASH] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_async] = ACTIONS(2163),
    [anon_sym_function] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_void] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [anon_sym_SQUOTE] = ACTIONS(2161),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2161),
    [sym_number] = ACTIONS(2161),
    [sym_this] = ACTIONS(2163),
    [sym_super] = ACTIONS(2163),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [sym_null] = ACTIONS(2163),
    [sym_undefined] = ACTIONS(2163),
    [anon_sym_AT] = ACTIONS(2161),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_abstract] = ACTIONS(2163),
    [anon_sym_get] = ACTIONS(2163),
    [anon_sym_set] = ACTIONS(2163),
    [anon_sym_declare] = ACTIONS(2163),
    [anon_sym_public] = ACTIONS(2163),
    [anon_sym_private] = ACTIONS(2163),
    [anon_sym_protected] = ACTIONS(2163),
    [anon_sym_module] = ACTIONS(2163),
    [anon_sym_any] = ACTIONS(2163),
    [anon_sym_number] = ACTIONS(2163),
    [anon_sym_boolean] = ACTIONS(2163),
    [anon_sym_string] = ACTIONS(2163),
    [anon_sym_symbol] = ACTIONS(2163),
    [anon_sym_interface] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [sym_readonly] = ACTIONS(2163),
  },
  [630] = {
    [ts_builtin_sym_end] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2167),
    [anon_sym_export] = ACTIONS(2167),
    [anon_sym_default] = ACTIONS(2167),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2165),
    [anon_sym_RBRACE] = ACTIONS(2165),
    [anon_sym_type] = ACTIONS(2167),
    [anon_sym_typeof] = ACTIONS(2167),
    [anon_sym_import] = ACTIONS(2167),
    [anon_sym_var] = ACTIONS(2167),
    [anon_sym_let] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_BANG] = ACTIONS(2165),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_await] = ACTIONS(2167),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_with] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_debugger] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2165),
    [anon_sym_case] = ACTIONS(2167),
    [anon_sym_yield] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(2165),
    [anon_sym_SLASH] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_async] = ACTIONS(2167),
    [anon_sym_function] = ACTIONS(2167),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_TILDE] = ACTIONS(2165),
    [anon_sym_void] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2165),
    [anon_sym_DASH_DASH] = ACTIONS(2165),
    [anon_sym_DQUOTE] = ACTIONS(2165),
    [anon_sym_SQUOTE] = ACTIONS(2165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2165),
    [sym_number] = ACTIONS(2165),
    [sym_this] = ACTIONS(2167),
    [sym_super] = ACTIONS(2167),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [sym_null] = ACTIONS(2167),
    [sym_undefined] = ACTIONS(2167),
    [anon_sym_AT] = ACTIONS(2165),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_abstract] = ACTIONS(2167),
    [anon_sym_get] = ACTIONS(2167),
    [anon_sym_set] = ACTIONS(2167),
    [anon_sym_declare] = ACTIONS(2167),
    [anon_sym_public] = ACTIONS(2167),
    [anon_sym_private] = ACTIONS(2167),
    [anon_sym_protected] = ACTIONS(2167),
    [anon_sym_module] = ACTIONS(2167),
    [anon_sym_any] = ACTIONS(2167),
    [anon_sym_number] = ACTIONS(2167),
    [anon_sym_boolean] = ACTIONS(2167),
    [anon_sym_string] = ACTIONS(2167),
    [anon_sym_symbol] = ACTIONS(2167),
    [anon_sym_interface] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [sym_readonly] = ACTIONS(2167),
  },
  [631] = {
    [ts_builtin_sym_end] = ACTIONS(2169),
    [sym_identifier] = ACTIONS(2171),
    [anon_sym_export] = ACTIONS(2171),
    [anon_sym_default] = ACTIONS(2171),
    [anon_sym_namespace] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_type] = ACTIONS(2171),
    [anon_sym_typeof] = ACTIONS(2171),
    [anon_sym_import] = ACTIONS(2171),
    [anon_sym_var] = ACTIONS(2171),
    [anon_sym_let] = ACTIONS(2171),
    [anon_sym_const] = ACTIONS(2171),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_if] = ACTIONS(2171),
    [anon_sym_switch] = ACTIONS(2171),
    [anon_sym_for] = ACTIONS(2171),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym_await] = ACTIONS(2171),
    [anon_sym_while] = ACTIONS(2171),
    [anon_sym_do] = ACTIONS(2171),
    [anon_sym_try] = ACTIONS(2171),
    [anon_sym_with] = ACTIONS(2171),
    [anon_sym_break] = ACTIONS(2171),
    [anon_sym_continue] = ACTIONS(2171),
    [anon_sym_debugger] = ACTIONS(2171),
    [anon_sym_return] = ACTIONS(2171),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_case] = ACTIONS(2171),
    [anon_sym_yield] = ACTIONS(2171),
    [anon_sym_LBRACK] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2171),
    [anon_sym_class] = ACTIONS(2171),
    [anon_sym_async] = ACTIONS(2171),
    [anon_sym_function] = ACTIONS(2171),
    [anon_sym_new] = ACTIONS(2171),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_void] = ACTIONS(2171),
    [anon_sym_delete] = ACTIONS(2171),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2169),
    [sym_number] = ACTIONS(2169),
    [sym_this] = ACTIONS(2171),
    [sym_super] = ACTIONS(2171),
    [sym_true] = ACTIONS(2171),
    [sym_false] = ACTIONS(2171),
    [sym_null] = ACTIONS(2171),
    [sym_undefined] = ACTIONS(2171),
    [anon_sym_AT] = ACTIONS(2169),
    [anon_sym_static] = ACTIONS(2171),
    [anon_sym_abstract] = ACTIONS(2171),
    [anon_sym_get] = ACTIONS(2171),
    [anon_sym_set] = ACTIONS(2171),
    [anon_sym_declare] = ACTIONS(2171),
    [anon_sym_public] = ACTIONS(2171),
    [anon_sym_private] = ACTIONS(2171),
    [anon_sym_protected] = ACTIONS(2171),
    [anon_sym_module] = ACTIONS(2171),
    [anon_sym_any] = ACTIONS(2171),
    [anon_sym_number] = ACTIONS(2171),
    [anon_sym_boolean] = ACTIONS(2171),
    [anon_sym_string] = ACTIONS(2171),
    [anon_sym_symbol] = ACTIONS(2171),
    [anon_sym_interface] = ACTIONS(2171),
    [anon_sym_enum] = ACTIONS(2171),
    [sym_readonly] = ACTIONS(2171),
  },
  [632] = {
    [ts_builtin_sym_end] = ACTIONS(2173),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_export] = ACTIONS(2175),
    [anon_sym_default] = ACTIONS(2175),
    [anon_sym_namespace] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2173),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_type] = ACTIONS(2175),
    [anon_sym_typeof] = ACTIONS(2175),
    [anon_sym_import] = ACTIONS(2175),
    [anon_sym_var] = ACTIONS(2175),
    [anon_sym_let] = ACTIONS(2175),
    [anon_sym_const] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_else] = ACTIONS(2175),
    [anon_sym_if] = ACTIONS(2175),
    [anon_sym_switch] = ACTIONS(2175),
    [anon_sym_for] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2173),
    [anon_sym_await] = ACTIONS(2175),
    [anon_sym_while] = ACTIONS(2175),
    [anon_sym_do] = ACTIONS(2175),
    [anon_sym_try] = ACTIONS(2175),
    [anon_sym_with] = ACTIONS(2175),
    [anon_sym_break] = ACTIONS(2175),
    [anon_sym_continue] = ACTIONS(2175),
    [anon_sym_debugger] = ACTIONS(2175),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_SEMI] = ACTIONS(2173),
    [anon_sym_case] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2173),
    [anon_sym_LT] = ACTIONS(2173),
    [anon_sym_SLASH] = ACTIONS(2175),
    [anon_sym_class] = ACTIONS(2175),
    [anon_sym_async] = ACTIONS(2175),
    [anon_sym_function] = ACTIONS(2175),
    [anon_sym_new] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_void] = ACTIONS(2175),
    [anon_sym_delete] = ACTIONS(2175),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_DQUOTE] = ACTIONS(2173),
    [anon_sym_SQUOTE] = ACTIONS(2173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2173),
    [sym_number] = ACTIONS(2173),
    [sym_this] = ACTIONS(2175),
    [sym_super] = ACTIONS(2175),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_null] = ACTIONS(2175),
    [sym_undefined] = ACTIONS(2175),
    [anon_sym_AT] = ACTIONS(2173),
    [anon_sym_static] = ACTIONS(2175),
    [anon_sym_abstract] = ACTIONS(2175),
    [anon_sym_get] = ACTIONS(2175),
    [anon_sym_set] = ACTIONS(2175),
    [anon_sym_declare] = ACTIONS(2175),
    [anon_sym_public] = ACTIONS(2175),
    [anon_sym_private] = ACTIONS(2175),
    [anon_sym_protected] = ACTIONS(2175),
    [anon_sym_module] = ACTIONS(2175),
    [anon_sym_any] = ACTIONS(2175),
    [anon_sym_number] = ACTIONS(2175),
    [anon_sym_boolean] = ACTIONS(2175),
    [anon_sym_string] = ACTIONS(2175),
    [anon_sym_symbol] = ACTIONS(2175),
    [anon_sym_interface] = ACTIONS(2175),
    [anon_sym_enum] = ACTIONS(2175),
    [sym_readonly] = ACTIONS(2175),
  },
  [633] = {
    [ts_builtin_sym_end] = ACTIONS(2177),
    [sym_identifier] = ACTIONS(2179),
    [anon_sym_export] = ACTIONS(2179),
    [anon_sym_default] = ACTIONS(2179),
    [anon_sym_namespace] = ACTIONS(2179),
    [anon_sym_LBRACE] = ACTIONS(2177),
    [anon_sym_RBRACE] = ACTIONS(2177),
    [anon_sym_type] = ACTIONS(2179),
    [anon_sym_typeof] = ACTIONS(2179),
    [anon_sym_import] = ACTIONS(2179),
    [anon_sym_var] = ACTIONS(2179),
    [anon_sym_let] = ACTIONS(2179),
    [anon_sym_const] = ACTIONS(2179),
    [anon_sym_BANG] = ACTIONS(2177),
    [anon_sym_else] = ACTIONS(2179),
    [anon_sym_if] = ACTIONS(2179),
    [anon_sym_switch] = ACTIONS(2179),
    [anon_sym_for] = ACTIONS(2179),
    [anon_sym_LPAREN] = ACTIONS(2177),
    [anon_sym_await] = ACTIONS(2179),
    [anon_sym_while] = ACTIONS(2179),
    [anon_sym_do] = ACTIONS(2179),
    [anon_sym_try] = ACTIONS(2179),
    [anon_sym_with] = ACTIONS(2179),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_continue] = ACTIONS(2179),
    [anon_sym_debugger] = ACTIONS(2179),
    [anon_sym_return] = ACTIONS(2179),
    [anon_sym_throw] = ACTIONS(2179),
    [anon_sym_SEMI] = ACTIONS(2177),
    [anon_sym_case] = ACTIONS(2179),
    [anon_sym_yield] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(2177),
    [anon_sym_LT] = ACTIONS(2177),
    [anon_sym_SLASH] = ACTIONS(2179),
    [anon_sym_class] = ACTIONS(2179),
    [anon_sym_async] = ACTIONS(2179),
    [anon_sym_function] = ACTIONS(2179),
    [anon_sym_new] = ACTIONS(2179),
    [anon_sym_PLUS] = ACTIONS(2179),
    [anon_sym_DASH] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(2177),
    [anon_sym_void] = ACTIONS(2179),
    [anon_sym_delete] = ACTIONS(2179),
    [anon_sym_PLUS_PLUS] = ACTIONS(2177),
    [anon_sym_DASH_DASH] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2177),
    [anon_sym_SQUOTE] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2177),
    [sym_number] = ACTIONS(2177),
    [sym_this] = ACTIONS(2179),
    [sym_super] = ACTIONS(2179),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [sym_null] = ACTIONS(2179),
    [sym_undefined] = ACTIONS(2179),
    [anon_sym_AT] = ACTIONS(2177),
    [anon_sym_static] = ACTIONS(2179),
    [anon_sym_abstract] = ACTIONS(2179),
    [anon_sym_get] = ACTIONS(2179),
    [anon_sym_set] = ACTIONS(2179),
    [anon_sym_declare] = ACTIONS(2179),
    [anon_sym_public] = ACTIONS(2179),
    [anon_sym_private] = ACTIONS(2179),
    [anon_sym_protected] = ACTIONS(2179),
    [anon_sym_module] = ACTIONS(2179),
    [anon_sym_any] = ACTIONS(2179),
    [anon_sym_number] = ACTIONS(2179),
    [anon_sym_boolean] = ACTIONS(2179),
    [anon_sym_string] = ACTIONS(2179),
    [anon_sym_symbol] = ACTIONS(2179),
    [anon_sym_interface] = ACTIONS(2179),
    [anon_sym_enum] = ACTIONS(2179),
    [sym_readonly] = ACTIONS(2179),
  },
  [634] = {
    [ts_builtin_sym_end] = ACTIONS(2181),
    [sym_identifier] = ACTIONS(2183),
    [anon_sym_export] = ACTIONS(2183),
    [anon_sym_default] = ACTIONS(2183),
    [anon_sym_namespace] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2181),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_type] = ACTIONS(2183),
    [anon_sym_typeof] = ACTIONS(2183),
    [anon_sym_import] = ACTIONS(2183),
    [anon_sym_var] = ACTIONS(2183),
    [anon_sym_let] = ACTIONS(2183),
    [anon_sym_const] = ACTIONS(2183),
    [anon_sym_BANG] = ACTIONS(2181),
    [anon_sym_else] = ACTIONS(2183),
    [anon_sym_if] = ACTIONS(2183),
    [anon_sym_switch] = ACTIONS(2183),
    [anon_sym_for] = ACTIONS(2183),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_await] = ACTIONS(2183),
    [anon_sym_while] = ACTIONS(2183),
    [anon_sym_do] = ACTIONS(2183),
    [anon_sym_try] = ACTIONS(2183),
    [anon_sym_with] = ACTIONS(2183),
    [anon_sym_break] = ACTIONS(2183),
    [anon_sym_continue] = ACTIONS(2183),
    [anon_sym_debugger] = ACTIONS(2183),
    [anon_sym_return] = ACTIONS(2183),
    [anon_sym_throw] = ACTIONS(2183),
    [anon_sym_SEMI] = ACTIONS(2181),
    [anon_sym_case] = ACTIONS(2183),
    [anon_sym_yield] = ACTIONS(2183),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_LT] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2183),
    [anon_sym_class] = ACTIONS(2183),
    [anon_sym_async] = ACTIONS(2183),
    [anon_sym_function] = ACTIONS(2183),
    [anon_sym_new] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_void] = ACTIONS(2183),
    [anon_sym_delete] = ACTIONS(2183),
    [anon_sym_PLUS_PLUS] = ACTIONS(2181),
    [anon_sym_DASH_DASH] = ACTIONS(2181),
    [anon_sym_DQUOTE] = ACTIONS(2181),
    [anon_sym_SQUOTE] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2181),
    [sym_number] = ACTIONS(2181),
    [sym_this] = ACTIONS(2183),
    [sym_super] = ACTIONS(2183),
    [sym_true] = ACTIONS(2183),
    [sym_false] = ACTIONS(2183),
    [sym_null] = ACTIONS(2183),
    [sym_undefined] = ACTIONS(2183),
    [anon_sym_AT] = ACTIONS(2181),
    [anon_sym_static] = ACTIONS(2183),
    [anon_sym_abstract] = ACTIONS(2183),
    [anon_sym_get] = ACTIONS(2183),
    [anon_sym_set] = ACTIONS(2183),
    [anon_sym_declare] = ACTIONS(2183),
    [anon_sym_public] = ACTIONS(2183),
    [anon_sym_private] = ACTIONS(2183),
    [anon_sym_protected] = ACTIONS(2183),
    [anon_sym_module] = ACTIONS(2183),
    [anon_sym_any] = ACTIONS(2183),
    [anon_sym_number] = ACTIONS(2183),
    [anon_sym_boolean] = ACTIONS(2183),
    [anon_sym_string] = ACTIONS(2183),
    [anon_sym_symbol] = ACTIONS(2183),
    [anon_sym_interface] = ACTIONS(2183),
    [anon_sym_enum] = ACTIONS(2183),
    [sym_readonly] = ACTIONS(2183),
  },
  [635] = {
    [ts_builtin_sym_end] = ACTIONS(2185),
    [sym_identifier] = ACTIONS(2187),
    [anon_sym_export] = ACTIONS(2187),
    [anon_sym_default] = ACTIONS(2187),
    [anon_sym_namespace] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2185),
    [anon_sym_RBRACE] = ACTIONS(2185),
    [anon_sym_type] = ACTIONS(2187),
    [anon_sym_typeof] = ACTIONS(2187),
    [anon_sym_import] = ACTIONS(2187),
    [anon_sym_var] = ACTIONS(2187),
    [anon_sym_let] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2185),
    [anon_sym_else] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_switch] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_LPAREN] = ACTIONS(2185),
    [anon_sym_await] = ACTIONS(2187),
    [anon_sym_while] = ACTIONS(2187),
    [anon_sym_do] = ACTIONS(2187),
    [anon_sym_try] = ACTIONS(2187),
    [anon_sym_with] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_debugger] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_SEMI] = ACTIONS(2185),
    [anon_sym_case] = ACTIONS(2187),
    [anon_sym_yield] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2185),
    [anon_sym_LT] = ACTIONS(2185),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_class] = ACTIONS(2187),
    [anon_sym_async] = ACTIONS(2187),
    [anon_sym_function] = ACTIONS(2187),
    [anon_sym_new] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2185),
    [anon_sym_void] = ACTIONS(2187),
    [anon_sym_delete] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2185),
    [anon_sym_DASH_DASH] = ACTIONS(2185),
    [anon_sym_DQUOTE] = ACTIONS(2185),
    [anon_sym_SQUOTE] = ACTIONS(2185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2185),
    [sym_number] = ACTIONS(2185),
    [sym_this] = ACTIONS(2187),
    [sym_super] = ACTIONS(2187),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_null] = ACTIONS(2187),
    [sym_undefined] = ACTIONS(2187),
    [anon_sym_AT] = ACTIONS(2185),
    [anon_sym_static] = ACTIONS(2187),
    [anon_sym_abstract] = ACTIONS(2187),
    [anon_sym_get] = ACTIONS(2187),
    [anon_sym_set] = ACTIONS(2187),
    [anon_sym_declare] = ACTIONS(2187),
    [anon_sym_public] = ACTIONS(2187),
    [anon_sym_private] = ACTIONS(2187),
    [anon_sym_protected] = ACTIONS(2187),
    [anon_sym_module] = ACTIONS(2187),
    [anon_sym_any] = ACTIONS(2187),
    [anon_sym_number] = ACTIONS(2187),
    [anon_sym_boolean] = ACTIONS(2187),
    [anon_sym_string] = ACTIONS(2187),
    [anon_sym_symbol] = ACTIONS(2187),
    [anon_sym_interface] = ACTIONS(2187),
    [anon_sym_enum] = ACTIONS(2187),
    [sym_readonly] = ACTIONS(2187),
  },
  [636] = {
    [ts_builtin_sym_end] = ACTIONS(2189),
    [sym_identifier] = ACTIONS(2191),
    [anon_sym_export] = ACTIONS(2191),
    [anon_sym_default] = ACTIONS(2191),
    [anon_sym_namespace] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_RBRACE] = ACTIONS(2189),
    [anon_sym_type] = ACTIONS(2191),
    [anon_sym_typeof] = ACTIONS(2191),
    [anon_sym_import] = ACTIONS(2191),
    [anon_sym_var] = ACTIONS(2191),
    [anon_sym_let] = ACTIONS(2191),
    [anon_sym_const] = ACTIONS(2191),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_else] = ACTIONS(2191),
    [anon_sym_if] = ACTIONS(2191),
    [anon_sym_switch] = ACTIONS(2191),
    [anon_sym_for] = ACTIONS(2191),
    [anon_sym_LPAREN] = ACTIONS(2189),
    [anon_sym_await] = ACTIONS(2191),
    [anon_sym_while] = ACTIONS(2191),
    [anon_sym_do] = ACTIONS(2191),
    [anon_sym_try] = ACTIONS(2191),
    [anon_sym_with] = ACTIONS(2191),
    [anon_sym_break] = ACTIONS(2191),
    [anon_sym_continue] = ACTIONS(2191),
    [anon_sym_debugger] = ACTIONS(2191),
    [anon_sym_return] = ACTIONS(2191),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym_case] = ACTIONS(2191),
    [anon_sym_yield] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2191),
    [anon_sym_class] = ACTIONS(2191),
    [anon_sym_async] = ACTIONS(2191),
    [anon_sym_function] = ACTIONS(2191),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_DASH] = ACTIONS(2191),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_void] = ACTIONS(2191),
    [anon_sym_delete] = ACTIONS(2191),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_DQUOTE] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2189),
    [sym_number] = ACTIONS(2189),
    [sym_this] = ACTIONS(2191),
    [sym_super] = ACTIONS(2191),
    [sym_true] = ACTIONS(2191),
    [sym_false] = ACTIONS(2191),
    [sym_null] = ACTIONS(2191),
    [sym_undefined] = ACTIONS(2191),
    [anon_sym_AT] = ACTIONS(2189),
    [anon_sym_static] = ACTIONS(2191),
    [anon_sym_abstract] = ACTIONS(2191),
    [anon_sym_get] = ACTIONS(2191),
    [anon_sym_set] = ACTIONS(2191),
    [anon_sym_declare] = ACTIONS(2191),
    [anon_sym_public] = ACTIONS(2191),
    [anon_sym_private] = ACTIONS(2191),
    [anon_sym_protected] = ACTIONS(2191),
    [anon_sym_module] = ACTIONS(2191),
    [anon_sym_any] = ACTIONS(2191),
    [anon_sym_number] = ACTIONS(2191),
    [anon_sym_boolean] = ACTIONS(2191),
    [anon_sym_string] = ACTIONS(2191),
    [anon_sym_symbol] = ACTIONS(2191),
    [anon_sym_interface] = ACTIONS(2191),
    [anon_sym_enum] = ACTIONS(2191),
    [sym_readonly] = ACTIONS(2191),
  },
  [637] = {
    [ts_builtin_sym_end] = ACTIONS(2193),
    [sym_identifier] = ACTIONS(2195),
    [anon_sym_export] = ACTIONS(2195),
    [anon_sym_default] = ACTIONS(2195),
    [anon_sym_namespace] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(2193),
    [anon_sym_RBRACE] = ACTIONS(2193),
    [anon_sym_type] = ACTIONS(2195),
    [anon_sym_typeof] = ACTIONS(2195),
    [anon_sym_import] = ACTIONS(2195),
    [anon_sym_var] = ACTIONS(2195),
    [anon_sym_let] = ACTIONS(2195),
    [anon_sym_const] = ACTIONS(2195),
    [anon_sym_BANG] = ACTIONS(2193),
    [anon_sym_else] = ACTIONS(2195),
    [anon_sym_if] = ACTIONS(2195),
    [anon_sym_switch] = ACTIONS(2195),
    [anon_sym_for] = ACTIONS(2195),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_while] = ACTIONS(2195),
    [anon_sym_do] = ACTIONS(2195),
    [anon_sym_try] = ACTIONS(2195),
    [anon_sym_with] = ACTIONS(2195),
    [anon_sym_break] = ACTIONS(2195),
    [anon_sym_continue] = ACTIONS(2195),
    [anon_sym_debugger] = ACTIONS(2195),
    [anon_sym_return] = ACTIONS(2195),
    [anon_sym_throw] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(2193),
    [anon_sym_case] = ACTIONS(2195),
    [anon_sym_yield] = ACTIONS(2195),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_LT] = ACTIONS(2193),
    [anon_sym_SLASH] = ACTIONS(2195),
    [anon_sym_class] = ACTIONS(2195),
    [anon_sym_async] = ACTIONS(2195),
    [anon_sym_function] = ACTIONS(2195),
    [anon_sym_new] = ACTIONS(2195),
    [anon_sym_PLUS] = ACTIONS(2195),
    [anon_sym_DASH] = ACTIONS(2195),
    [anon_sym_TILDE] = ACTIONS(2193),
    [anon_sym_void] = ACTIONS(2195),
    [anon_sym_delete] = ACTIONS(2195),
    [anon_sym_PLUS_PLUS] = ACTIONS(2193),
    [anon_sym_DASH_DASH] = ACTIONS(2193),
    [anon_sym_DQUOTE] = ACTIONS(2193),
    [anon_sym_SQUOTE] = ACTIONS(2193),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2193),
    [sym_number] = ACTIONS(2193),
    [sym_this] = ACTIONS(2195),
    [sym_super] = ACTIONS(2195),
    [sym_true] = ACTIONS(2195),
    [sym_false] = ACTIONS(2195),
    [sym_null] = ACTIONS(2195),
    [sym_undefined] = ACTIONS(2195),
    [anon_sym_AT] = ACTIONS(2193),
    [anon_sym_static] = ACTIONS(2195),
    [anon_sym_abstract] = ACTIONS(2195),
    [anon_sym_get] = ACTIONS(2195),
    [anon_sym_set] = ACTIONS(2195),
    [anon_sym_declare] = ACTIONS(2195),
    [anon_sym_public] = ACTIONS(2195),
    [anon_sym_private] = ACTIONS(2195),
    [anon_sym_protected] = ACTIONS(2195),
    [anon_sym_module] = ACTIONS(2195),
    [anon_sym_any] = ACTIONS(2195),
    [anon_sym_number] = ACTIONS(2195),
    [anon_sym_boolean] = ACTIONS(2195),
    [anon_sym_string] = ACTIONS(2195),
    [anon_sym_symbol] = ACTIONS(2195),
    [anon_sym_interface] = ACTIONS(2195),
    [anon_sym_enum] = ACTIONS(2195),
    [sym_readonly] = ACTIONS(2195),
  },
  [638] = {
    [ts_builtin_sym_end] = ACTIONS(2197),
    [sym_identifier] = ACTIONS(2199),
    [anon_sym_export] = ACTIONS(2199),
    [anon_sym_default] = ACTIONS(2199),
    [anon_sym_namespace] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_RBRACE] = ACTIONS(2197),
    [anon_sym_type] = ACTIONS(2199),
    [anon_sym_typeof] = ACTIONS(2199),
    [anon_sym_import] = ACTIONS(2199),
    [anon_sym_var] = ACTIONS(2199),
    [anon_sym_let] = ACTIONS(2199),
    [anon_sym_const] = ACTIONS(2199),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_else] = ACTIONS(2199),
    [anon_sym_if] = ACTIONS(2199),
    [anon_sym_switch] = ACTIONS(2199),
    [anon_sym_for] = ACTIONS(2199),
    [anon_sym_LPAREN] = ACTIONS(2197),
    [anon_sym_await] = ACTIONS(2199),
    [anon_sym_while] = ACTIONS(2199),
    [anon_sym_do] = ACTIONS(2199),
    [anon_sym_try] = ACTIONS(2199),
    [anon_sym_with] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2199),
    [anon_sym_continue] = ACTIONS(2199),
    [anon_sym_debugger] = ACTIONS(2199),
    [anon_sym_return] = ACTIONS(2199),
    [anon_sym_throw] = ACTIONS(2199),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_case] = ACTIONS(2199),
    [anon_sym_yield] = ACTIONS(2199),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2199),
    [anon_sym_class] = ACTIONS(2199),
    [anon_sym_async] = ACTIONS(2199),
    [anon_sym_function] = ACTIONS(2199),
    [anon_sym_new] = ACTIONS(2199),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2197),
    [anon_sym_void] = ACTIONS(2199),
    [anon_sym_delete] = ACTIONS(2199),
    [anon_sym_PLUS_PLUS] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2197),
    [sym_number] = ACTIONS(2197),
    [sym_this] = ACTIONS(2199),
    [sym_super] = ACTIONS(2199),
    [sym_true] = ACTIONS(2199),
    [sym_false] = ACTIONS(2199),
    [sym_null] = ACTIONS(2199),
    [sym_undefined] = ACTIONS(2199),
    [anon_sym_AT] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2199),
    [anon_sym_abstract] = ACTIONS(2199),
    [anon_sym_get] = ACTIONS(2199),
    [anon_sym_set] = ACTIONS(2199),
    [anon_sym_declare] = ACTIONS(2199),
    [anon_sym_public] = ACTIONS(2199),
    [anon_sym_private] = ACTIONS(2199),
    [anon_sym_protected] = ACTIONS(2199),
    [anon_sym_module] = ACTIONS(2199),
    [anon_sym_any] = ACTIONS(2199),
    [anon_sym_number] = ACTIONS(2199),
    [anon_sym_boolean] = ACTIONS(2199),
    [anon_sym_string] = ACTIONS(2199),
    [anon_sym_symbol] = ACTIONS(2199),
    [anon_sym_interface] = ACTIONS(2199),
    [anon_sym_enum] = ACTIONS(2199),
    [sym_readonly] = ACTIONS(2199),
  },
  [639] = {
    [sym_identifier] = ACTIONS(2201),
    [anon_sym_export] = ACTIONS(2201),
    [anon_sym_namespace] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(2203),
    [anon_sym_type] = ACTIONS(2201),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_import] = ACTIONS(2201),
    [anon_sym_var] = ACTIONS(2201),
    [anon_sym_let] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2203),
    [anon_sym_if] = ACTIONS(2201),
    [anon_sym_switch] = ACTIONS(2201),
    [anon_sym_for] = ACTIONS(2201),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_await] = ACTIONS(2201),
    [anon_sym_while] = ACTIONS(2201),
    [anon_sym_do] = ACTIONS(2201),
    [anon_sym_try] = ACTIONS(2201),
    [anon_sym_with] = ACTIONS(2201),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_continue] = ACTIONS(2201),
    [anon_sym_debugger] = ACTIONS(2201),
    [anon_sym_return] = ACTIONS(2201),
    [anon_sym_throw] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2203),
    [anon_sym_yield] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_LT] = ACTIONS(2203),
    [anon_sym_SLASH] = ACTIONS(2201),
    [anon_sym_class] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2203),
    [anon_sym_void] = ACTIONS(2201),
    [anon_sym_delete] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2203),
    [anon_sym_DQUOTE] = ACTIONS(2203),
    [anon_sym_SQUOTE] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2203),
    [sym_number] = ACTIONS(2203),
    [sym_this] = ACTIONS(2201),
    [sym_super] = ACTIONS(2201),
    [sym_true] = ACTIONS(2201),
    [sym_false] = ACTIONS(2201),
    [sym_null] = ACTIONS(2201),
    [sym_undefined] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2203),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_declare] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_module] = ACTIONS(2201),
    [anon_sym_any] = ACTIONS(2201),
    [anon_sym_number] = ACTIONS(2201),
    [anon_sym_boolean] = ACTIONS(2201),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_symbol] = ACTIONS(2201),
    [anon_sym_interface] = ACTIONS(2201),
    [anon_sym_enum] = ACTIONS(2201),
    [sym_readonly] = ACTIONS(2201),
  },
  [640] = {
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2205),
    [anon_sym_namespace] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2207),
    [anon_sym_type] = ACTIONS(2205),
    [anon_sym_typeof] = ACTIONS(2205),
    [anon_sym_import] = ACTIONS(2205),
    [anon_sym_var] = ACTIONS(2205),
    [anon_sym_let] = ACTIONS(2205),
    [anon_sym_const] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2207),
    [anon_sym_if] = ACTIONS(2205),
    [anon_sym_switch] = ACTIONS(2205),
    [anon_sym_for] = ACTIONS(2205),
    [anon_sym_LPAREN] = ACTIONS(2207),
    [anon_sym_await] = ACTIONS(2205),
    [anon_sym_while] = ACTIONS(2205),
    [anon_sym_do] = ACTIONS(2205),
    [anon_sym_try] = ACTIONS(2205),
    [anon_sym_with] = ACTIONS(2205),
    [anon_sym_break] = ACTIONS(2205),
    [anon_sym_continue] = ACTIONS(2205),
    [anon_sym_debugger] = ACTIONS(2205),
    [anon_sym_return] = ACTIONS(2205),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_yield] = ACTIONS(2205),
    [anon_sym_LBRACK] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_SLASH] = ACTIONS(2205),
    [anon_sym_class] = ACTIONS(2205),
    [anon_sym_async] = ACTIONS(2205),
    [anon_sym_function] = ACTIONS(2205),
    [anon_sym_new] = ACTIONS(2205),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_TILDE] = ACTIONS(2207),
    [anon_sym_void] = ACTIONS(2205),
    [anon_sym_delete] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2207),
    [anon_sym_DASH_DASH] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [anon_sym_SQUOTE] = ACTIONS(2207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [sym_number] = ACTIONS(2207),
    [sym_this] = ACTIONS(2205),
    [sym_super] = ACTIONS(2205),
    [sym_true] = ACTIONS(2205),
    [sym_false] = ACTIONS(2205),
    [sym_null] = ACTIONS(2205),
    [sym_undefined] = ACTIONS(2205),
    [anon_sym_AT] = ACTIONS(2207),
    [anon_sym_static] = ACTIONS(2205),
    [anon_sym_abstract] = ACTIONS(2205),
    [anon_sym_get] = ACTIONS(2205),
    [anon_sym_set] = ACTIONS(2205),
    [anon_sym_declare] = ACTIONS(2205),
    [anon_sym_public] = ACTIONS(2205),
    [anon_sym_private] = ACTIONS(2205),
    [anon_sym_protected] = ACTIONS(2205),
    [anon_sym_module] = ACTIONS(2205),
    [anon_sym_any] = ACTIONS(2205),
    [anon_sym_number] = ACTIONS(2205),
    [anon_sym_boolean] = ACTIONS(2205),
    [anon_sym_string] = ACTIONS(2205),
    [anon_sym_symbol] = ACTIONS(2205),
    [anon_sym_interface] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2205),
    [sym_readonly] = ACTIONS(2205),
  },
  [641] = {
    [sym_identifier] = ACTIONS(2209),
    [anon_sym_export] = ACTIONS(2209),
    [anon_sym_namespace] = ACTIONS(2209),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_type] = ACTIONS(2209),
    [anon_sym_typeof] = ACTIONS(2209),
    [anon_sym_import] = ACTIONS(2209),
    [anon_sym_var] = ACTIONS(2209),
    [anon_sym_let] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2209),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(2209),
    [anon_sym_switch] = ACTIONS(2209),
    [anon_sym_for] = ACTIONS(2209),
    [anon_sym_LPAREN] = ACTIONS(2211),
    [anon_sym_await] = ACTIONS(2209),
    [anon_sym_while] = ACTIONS(2209),
    [anon_sym_do] = ACTIONS(2209),
    [anon_sym_try] = ACTIONS(2209),
    [anon_sym_with] = ACTIONS(2209),
    [anon_sym_break] = ACTIONS(2209),
    [anon_sym_continue] = ACTIONS(2209),
    [anon_sym_debugger] = ACTIONS(2209),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_throw] = ACTIONS(2209),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_yield] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_LT] = ACTIONS(2211),
    [anon_sym_SLASH] = ACTIONS(2209),
    [anon_sym_class] = ACTIONS(2209),
    [anon_sym_async] = ACTIONS(2209),
    [anon_sym_function] = ACTIONS(2209),
    [anon_sym_new] = ACTIONS(2209),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_void] = ACTIONS(2209),
    [anon_sym_delete] = ACTIONS(2209),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [anon_sym_SQUOTE] = ACTIONS(2211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2211),
    [sym_number] = ACTIONS(2211),
    [sym_this] = ACTIONS(2209),
    [sym_super] = ACTIONS(2209),
    [sym_true] = ACTIONS(2209),
    [sym_false] = ACTIONS(2209),
    [sym_null] = ACTIONS(2209),
    [sym_undefined] = ACTIONS(2209),
    [anon_sym_AT] = ACTIONS(2211),
    [anon_sym_static] = ACTIONS(2209),
    [anon_sym_abstract] = ACTIONS(2209),
    [anon_sym_get] = ACTIONS(2209),
    [anon_sym_set] = ACTIONS(2209),
    [anon_sym_declare] = ACTIONS(2209),
    [anon_sym_public] = ACTIONS(2209),
    [anon_sym_private] = ACTIONS(2209),
    [anon_sym_protected] = ACTIONS(2209),
    [anon_sym_module] = ACTIONS(2209),
    [anon_sym_any] = ACTIONS(2209),
    [anon_sym_number] = ACTIONS(2209),
    [anon_sym_boolean] = ACTIONS(2209),
    [anon_sym_string] = ACTIONS(2209),
    [anon_sym_symbol] = ACTIONS(2209),
    [anon_sym_interface] = ACTIONS(2209),
    [anon_sym_enum] = ACTIONS(2209),
    [sym_readonly] = ACTIONS(2209),
  },
  [642] = {
    [sym_identifier] = ACTIONS(2213),
    [anon_sym_export] = ACTIONS(2213),
    [anon_sym_namespace] = ACTIONS(2213),
    [anon_sym_LBRACE] = ACTIONS(2215),
    [anon_sym_type] = ACTIONS(2213),
    [anon_sym_typeof] = ACTIONS(2213),
    [anon_sym_import] = ACTIONS(2213),
    [anon_sym_var] = ACTIONS(2213),
    [anon_sym_let] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2215),
    [anon_sym_if] = ACTIONS(2213),
    [anon_sym_switch] = ACTIONS(2213),
    [anon_sym_for] = ACTIONS(2213),
    [anon_sym_LPAREN] = ACTIONS(2215),
    [anon_sym_await] = ACTIONS(2213),
    [anon_sym_while] = ACTIONS(2213),
    [anon_sym_do] = ACTIONS(2213),
    [anon_sym_try] = ACTIONS(2213),
    [anon_sym_with] = ACTIONS(2213),
    [anon_sym_break] = ACTIONS(2213),
    [anon_sym_continue] = ACTIONS(2213),
    [anon_sym_debugger] = ACTIONS(2213),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_throw] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2215),
    [anon_sym_yield] = ACTIONS(2213),
    [anon_sym_LBRACK] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_class] = ACTIONS(2213),
    [anon_sym_async] = ACTIONS(2213),
    [anon_sym_function] = ACTIONS(2213),
    [anon_sym_new] = ACTIONS(2213),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2213),
    [anon_sym_TILDE] = ACTIONS(2215),
    [anon_sym_void] = ACTIONS(2213),
    [anon_sym_delete] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2215),
    [anon_sym_DASH_DASH] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(2215),
    [anon_sym_SQUOTE] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2215),
    [sym_number] = ACTIONS(2215),
    [sym_this] = ACTIONS(2213),
    [sym_super] = ACTIONS(2213),
    [sym_true] = ACTIONS(2213),
    [sym_false] = ACTIONS(2213),
    [sym_null] = ACTIONS(2213),
    [sym_undefined] = ACTIONS(2213),
    [anon_sym_AT] = ACTIONS(2215),
    [anon_sym_static] = ACTIONS(2213),
    [anon_sym_abstract] = ACTIONS(2213),
    [anon_sym_get] = ACTIONS(2213),
    [anon_sym_set] = ACTIONS(2213),
    [anon_sym_declare] = ACTIONS(2213),
    [anon_sym_public] = ACTIONS(2213),
    [anon_sym_private] = ACTIONS(2213),
    [anon_sym_protected] = ACTIONS(2213),
    [anon_sym_module] = ACTIONS(2213),
    [anon_sym_any] = ACTIONS(2213),
    [anon_sym_number] = ACTIONS(2213),
    [anon_sym_boolean] = ACTIONS(2213),
    [anon_sym_string] = ACTIONS(2213),
    [anon_sym_symbol] = ACTIONS(2213),
    [anon_sym_interface] = ACTIONS(2213),
    [anon_sym_enum] = ACTIONS(2213),
    [sym_readonly] = ACTIONS(2213),
  },
  [643] = {
    [sym_identifier] = ACTIONS(2217),
    [anon_sym_export] = ACTIONS(2217),
    [anon_sym_namespace] = ACTIONS(2217),
    [anon_sym_LBRACE] = ACTIONS(2219),
    [anon_sym_type] = ACTIONS(2217),
    [anon_sym_typeof] = ACTIONS(2217),
    [anon_sym_import] = ACTIONS(2217),
    [anon_sym_var] = ACTIONS(2217),
    [anon_sym_let] = ACTIONS(2217),
    [anon_sym_const] = ACTIONS(2217),
    [anon_sym_BANG] = ACTIONS(2219),
    [anon_sym_if] = ACTIONS(2217),
    [anon_sym_switch] = ACTIONS(2217),
    [anon_sym_for] = ACTIONS(2217),
    [anon_sym_LPAREN] = ACTIONS(2219),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_while] = ACTIONS(2217),
    [anon_sym_do] = ACTIONS(2217),
    [anon_sym_try] = ACTIONS(2217),
    [anon_sym_with] = ACTIONS(2217),
    [anon_sym_break] = ACTIONS(2217),
    [anon_sym_continue] = ACTIONS(2217),
    [anon_sym_debugger] = ACTIONS(2217),
    [anon_sym_return] = ACTIONS(2217),
    [anon_sym_throw] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_yield] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_LT] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2217),
    [anon_sym_class] = ACTIONS(2217),
    [anon_sym_async] = ACTIONS(2217),
    [anon_sym_function] = ACTIONS(2217),
    [anon_sym_new] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2217),
    [anon_sym_TILDE] = ACTIONS(2219),
    [anon_sym_void] = ACTIONS(2217),
    [anon_sym_delete] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2219),
    [anon_sym_DASH_DASH] = ACTIONS(2219),
    [anon_sym_DQUOTE] = ACTIONS(2219),
    [anon_sym_SQUOTE] = ACTIONS(2219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2219),
    [sym_number] = ACTIONS(2219),
    [sym_this] = ACTIONS(2217),
    [sym_super] = ACTIONS(2217),
    [sym_true] = ACTIONS(2217),
    [sym_false] = ACTIONS(2217),
    [sym_null] = ACTIONS(2217),
    [sym_undefined] = ACTIONS(2217),
    [anon_sym_AT] = ACTIONS(2219),
    [anon_sym_static] = ACTIONS(2217),
    [anon_sym_abstract] = ACTIONS(2217),
    [anon_sym_get] = ACTIONS(2217),
    [anon_sym_set] = ACTIONS(2217),
    [anon_sym_declare] = ACTIONS(2217),
    [anon_sym_public] = ACTIONS(2217),
    [anon_sym_private] = ACTIONS(2217),
    [anon_sym_protected] = ACTIONS(2217),
    [anon_sym_module] = ACTIONS(2217),
    [anon_sym_any] = ACTIONS(2217),
    [anon_sym_number] = ACTIONS(2217),
    [anon_sym_boolean] = ACTIONS(2217),
    [anon_sym_string] = ACTIONS(2217),
    [anon_sym_symbol] = ACTIONS(2217),
    [anon_sym_interface] = ACTIONS(2217),
    [anon_sym_enum] = ACTIONS(2217),
    [sym_readonly] = ACTIONS(2217),
  },
  [644] = {
    [sym_identifier] = ACTIONS(2221),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2223),
    [anon_sym_type] = ACTIONS(2221),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2221),
    [anon_sym_var] = ACTIONS(2221),
    [anon_sym_let] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_LPAREN] = ACTIONS(2223),
    [anon_sym_await] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_with] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_debugger] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_yield] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2223),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_async] = ACTIONS(2221),
    [anon_sym_function] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_void] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2223),
    [anon_sym_SQUOTE] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2223),
    [sym_number] = ACTIONS(2223),
    [sym_this] = ACTIONS(2221),
    [sym_super] = ACTIONS(2221),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [sym_null] = ACTIONS(2221),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_AT] = ACTIONS(2223),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_abstract] = ACTIONS(2221),
    [anon_sym_get] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(2221),
    [anon_sym_declare] = ACTIONS(2221),
    [anon_sym_public] = ACTIONS(2221),
    [anon_sym_private] = ACTIONS(2221),
    [anon_sym_protected] = ACTIONS(2221),
    [anon_sym_module] = ACTIONS(2221),
    [anon_sym_any] = ACTIONS(2221),
    [anon_sym_number] = ACTIONS(2221),
    [anon_sym_boolean] = ACTIONS(2221),
    [anon_sym_string] = ACTIONS(2221),
    [anon_sym_symbol] = ACTIONS(2221),
    [anon_sym_interface] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [sym_readonly] = ACTIONS(2221),
  },
  [645] = {
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_export] = ACTIONS(2225),
    [anon_sym_namespace] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(2227),
    [anon_sym_type] = ACTIONS(2225),
    [anon_sym_typeof] = ACTIONS(2225),
    [anon_sym_import] = ACTIONS(2225),
    [anon_sym_var] = ACTIONS(2225),
    [anon_sym_let] = ACTIONS(2225),
    [anon_sym_const] = ACTIONS(2225),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_if] = ACTIONS(2225),
    [anon_sym_switch] = ACTIONS(2225),
    [anon_sym_for] = ACTIONS(2225),
    [anon_sym_LPAREN] = ACTIONS(2227),
    [anon_sym_await] = ACTIONS(2225),
    [anon_sym_while] = ACTIONS(2225),
    [anon_sym_do] = ACTIONS(2225),
    [anon_sym_try] = ACTIONS(2225),
    [anon_sym_with] = ACTIONS(2225),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_continue] = ACTIONS(2225),
    [anon_sym_debugger] = ACTIONS(2225),
    [anon_sym_return] = ACTIONS(2225),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(2227),
    [anon_sym_LT] = ACTIONS(2227),
    [anon_sym_SLASH] = ACTIONS(2225),
    [anon_sym_class] = ACTIONS(2225),
    [anon_sym_async] = ACTIONS(2225),
    [anon_sym_function] = ACTIONS(2225),
    [anon_sym_new] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_void] = ACTIONS(2225),
    [anon_sym_delete] = ACTIONS(2225),
    [anon_sym_PLUS_PLUS] = ACTIONS(2227),
    [anon_sym_DASH_DASH] = ACTIONS(2227),
    [anon_sym_DQUOTE] = ACTIONS(2227),
    [anon_sym_SQUOTE] = ACTIONS(2227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2227),
    [sym_number] = ACTIONS(2227),
    [sym_this] = ACTIONS(2225),
    [sym_super] = ACTIONS(2225),
    [sym_true] = ACTIONS(2225),
    [sym_false] = ACTIONS(2225),
    [sym_null] = ACTIONS(2225),
    [sym_undefined] = ACTIONS(2225),
    [anon_sym_AT] = ACTIONS(2227),
    [anon_sym_static] = ACTIONS(2225),
    [anon_sym_abstract] = ACTIONS(2225),
    [anon_sym_get] = ACTIONS(2225),
    [anon_sym_set] = ACTIONS(2225),
    [anon_sym_declare] = ACTIONS(2225),
    [anon_sym_public] = ACTIONS(2225),
    [anon_sym_private] = ACTIONS(2225),
    [anon_sym_protected] = ACTIONS(2225),
    [anon_sym_module] = ACTIONS(2225),
    [anon_sym_any] = ACTIONS(2225),
    [anon_sym_number] = ACTIONS(2225),
    [anon_sym_boolean] = ACTIONS(2225),
    [anon_sym_string] = ACTIONS(2225),
    [anon_sym_symbol] = ACTIONS(2225),
    [anon_sym_interface] = ACTIONS(2225),
    [anon_sym_enum] = ACTIONS(2225),
    [sym_readonly] = ACTIONS(2225),
  },
  [646] = {
    [sym_identifier] = ACTIONS(2229),
    [anon_sym_export] = ACTIONS(2229),
    [anon_sym_namespace] = ACTIONS(2229),
    [anon_sym_LBRACE] = ACTIONS(2231),
    [anon_sym_type] = ACTIONS(2229),
    [anon_sym_typeof] = ACTIONS(2229),
    [anon_sym_import] = ACTIONS(2229),
    [anon_sym_var] = ACTIONS(2229),
    [anon_sym_let] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2229),
    [anon_sym_BANG] = ACTIONS(2231),
    [anon_sym_if] = ACTIONS(2229),
    [anon_sym_switch] = ACTIONS(2229),
    [anon_sym_for] = ACTIONS(2229),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_while] = ACTIONS(2229),
    [anon_sym_do] = ACTIONS(2229),
    [anon_sym_try] = ACTIONS(2229),
    [anon_sym_with] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2229),
    [anon_sym_continue] = ACTIONS(2229),
    [anon_sym_debugger] = ACTIONS(2229),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_throw] = ACTIONS(2229),
    [anon_sym_SEMI] = ACTIONS(2231),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2231),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_class] = ACTIONS(2229),
    [anon_sym_async] = ACTIONS(2229),
    [anon_sym_function] = ACTIONS(2229),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2231),
    [anon_sym_void] = ACTIONS(2229),
    [anon_sym_delete] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2231),
    [anon_sym_DASH_DASH] = ACTIONS(2231),
    [anon_sym_DQUOTE] = ACTIONS(2231),
    [anon_sym_SQUOTE] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2231),
    [sym_number] = ACTIONS(2231),
    [sym_this] = ACTIONS(2229),
    [sym_super] = ACTIONS(2229),
    [sym_true] = ACTIONS(2229),
    [sym_false] = ACTIONS(2229),
    [sym_null] = ACTIONS(2229),
    [sym_undefined] = ACTIONS(2229),
    [anon_sym_AT] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2229),
    [anon_sym_abstract] = ACTIONS(2229),
    [anon_sym_get] = ACTIONS(2229),
    [anon_sym_set] = ACTIONS(2229),
    [anon_sym_declare] = ACTIONS(2229),
    [anon_sym_public] = ACTIONS(2229),
    [anon_sym_private] = ACTIONS(2229),
    [anon_sym_protected] = ACTIONS(2229),
    [anon_sym_module] = ACTIONS(2229),
    [anon_sym_any] = ACTIONS(2229),
    [anon_sym_number] = ACTIONS(2229),
    [anon_sym_boolean] = ACTIONS(2229),
    [anon_sym_string] = ACTIONS(2229),
    [anon_sym_symbol] = ACTIONS(2229),
    [anon_sym_interface] = ACTIONS(2229),
    [anon_sym_enum] = ACTIONS(2229),
    [sym_readonly] = ACTIONS(2229),
  },
  [647] = {
    [sym_identifier] = ACTIONS(2233),
    [anon_sym_export] = ACTIONS(2233),
    [anon_sym_namespace] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_type] = ACTIONS(2233),
    [anon_sym_typeof] = ACTIONS(2233),
    [anon_sym_import] = ACTIONS(2233),
    [anon_sym_var] = ACTIONS(2233),
    [anon_sym_let] = ACTIONS(2233),
    [anon_sym_const] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2233),
    [anon_sym_switch] = ACTIONS(2233),
    [anon_sym_for] = ACTIONS(2233),
    [anon_sym_LPAREN] = ACTIONS(2235),
    [anon_sym_await] = ACTIONS(2233),
    [anon_sym_while] = ACTIONS(2233),
    [anon_sym_do] = ACTIONS(2233),
    [anon_sym_try] = ACTIONS(2233),
    [anon_sym_with] = ACTIONS(2233),
    [anon_sym_break] = ACTIONS(2233),
    [anon_sym_continue] = ACTIONS(2233),
    [anon_sym_debugger] = ACTIONS(2233),
    [anon_sym_return] = ACTIONS(2233),
    [anon_sym_throw] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_yield] = ACTIONS(2233),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_LT] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_class] = ACTIONS(2233),
    [anon_sym_async] = ACTIONS(2233),
    [anon_sym_function] = ACTIONS(2233),
    [anon_sym_new] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2235),
    [anon_sym_void] = ACTIONS(2233),
    [anon_sym_delete] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2235),
    [anon_sym_DASH_DASH] = ACTIONS(2235),
    [anon_sym_DQUOTE] = ACTIONS(2235),
    [anon_sym_SQUOTE] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2235),
    [sym_number] = ACTIONS(2235),
    [sym_this] = ACTIONS(2233),
    [sym_super] = ACTIONS(2233),
    [sym_true] = ACTIONS(2233),
    [sym_false] = ACTIONS(2233),
    [sym_null] = ACTIONS(2233),
    [sym_undefined] = ACTIONS(2233),
    [anon_sym_AT] = ACTIONS(2235),
    [anon_sym_static] = ACTIONS(2233),
    [anon_sym_abstract] = ACTIONS(2233),
    [anon_sym_get] = ACTIONS(2233),
    [anon_sym_set] = ACTIONS(2233),
    [anon_sym_declare] = ACTIONS(2233),
    [anon_sym_public] = ACTIONS(2233),
    [anon_sym_private] = ACTIONS(2233),
    [anon_sym_protected] = ACTIONS(2233),
    [anon_sym_module] = ACTIONS(2233),
    [anon_sym_any] = ACTIONS(2233),
    [anon_sym_number] = ACTIONS(2233),
    [anon_sym_boolean] = ACTIONS(2233),
    [anon_sym_string] = ACTIONS(2233),
    [anon_sym_symbol] = ACTIONS(2233),
    [anon_sym_interface] = ACTIONS(2233),
    [anon_sym_enum] = ACTIONS(2233),
    [sym_readonly] = ACTIONS(2233),
  },
  [648] = {
    [sym_identifier] = ACTIONS(2237),
    [anon_sym_export] = ACTIONS(2237),
    [anon_sym_namespace] = ACTIONS(2237),
    [anon_sym_LBRACE] = ACTIONS(2239),
    [anon_sym_type] = ACTIONS(2237),
    [anon_sym_typeof] = ACTIONS(2237),
    [anon_sym_import] = ACTIONS(2237),
    [anon_sym_var] = ACTIONS(2237),
    [anon_sym_let] = ACTIONS(2237),
    [anon_sym_const] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2237),
    [anon_sym_switch] = ACTIONS(2237),
    [anon_sym_for] = ACTIONS(2237),
    [anon_sym_LPAREN] = ACTIONS(2239),
    [anon_sym_await] = ACTIONS(2237),
    [anon_sym_while] = ACTIONS(2237),
    [anon_sym_do] = ACTIONS(2237),
    [anon_sym_try] = ACTIONS(2237),
    [anon_sym_with] = ACTIONS(2237),
    [anon_sym_break] = ACTIONS(2237),
    [anon_sym_continue] = ACTIONS(2237),
    [anon_sym_debugger] = ACTIONS(2237),
    [anon_sym_return] = ACTIONS(2237),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_SEMI] = ACTIONS(2239),
    [anon_sym_yield] = ACTIONS(2237),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_LT] = ACTIONS(2239),
    [anon_sym_SLASH] = ACTIONS(2237),
    [anon_sym_class] = ACTIONS(2237),
    [anon_sym_async] = ACTIONS(2237),
    [anon_sym_function] = ACTIONS(2237),
    [anon_sym_new] = ACTIONS(2237),
    [anon_sym_PLUS] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2239),
    [anon_sym_void] = ACTIONS(2237),
    [anon_sym_delete] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2239),
    [anon_sym_DQUOTE] = ACTIONS(2239),
    [anon_sym_SQUOTE] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2239),
    [sym_number] = ACTIONS(2239),
    [sym_this] = ACTIONS(2237),
    [sym_super] = ACTIONS(2237),
    [sym_true] = ACTIONS(2237),
    [sym_false] = ACTIONS(2237),
    [sym_null] = ACTIONS(2237),
    [sym_undefined] = ACTIONS(2237),
    [anon_sym_AT] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2237),
    [anon_sym_abstract] = ACTIONS(2237),
    [anon_sym_get] = ACTIONS(2237),
    [anon_sym_set] = ACTIONS(2237),
    [anon_sym_declare] = ACTIONS(2237),
    [anon_sym_public] = ACTIONS(2237),
    [anon_sym_private] = ACTIONS(2237),
    [anon_sym_protected] = ACTIONS(2237),
    [anon_sym_module] = ACTIONS(2237),
    [anon_sym_any] = ACTIONS(2237),
    [anon_sym_number] = ACTIONS(2237),
    [anon_sym_boolean] = ACTIONS(2237),
    [anon_sym_string] = ACTIONS(2237),
    [anon_sym_symbol] = ACTIONS(2237),
    [anon_sym_interface] = ACTIONS(2237),
    [anon_sym_enum] = ACTIONS(2237),
    [sym_readonly] = ACTIONS(2237),
  },
  [649] = {
    [sym_nested_identifier] = STATE(1096),
    [sym_string] = STATE(1098),
    [sym_arguments] = STATE(1279),
    [sym__module] = STATE(1248),
    [sym_type_arguments] = STATE(1126),
    [sym_identifier] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(1693),
    [anon_sym_COMMA] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1693),
    [anon_sym_LPAREN] = ACTIONS(2243),
    [anon_sym_RPAREN] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1693),
    [anon_sym_COLON] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(1697),
    [anon_sym_RBRACK] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(1693),
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_EQ_GT] = ACTIONS(877),
    [anon_sym_QMARK_DOT] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1693),
    [anon_sym_GT_GT_GT] = ACTIONS(1693),
    [anon_sym_LT_LT] = ACTIONS(1693),
    [anon_sym_AMP] = ACTIONS(1693),
    [anon_sym_CARET] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(1693),
    [anon_sym_PERCENT] = ACTIONS(1693),
    [anon_sym_STAR_STAR] = ACTIONS(1693),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BANG_EQ] = ACTIONS(1693),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_QMARK_QMARK] = ACTIONS(1693),
    [anon_sym_instanceof] = ACTIONS(1693),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1695),
  },
  [650] = {
    [sym_nested_identifier] = STATE(1096),
    [sym_string] = STATE(1098),
    [sym_arguments] = STATE(1636),
    [sym__module] = STATE(1248),
    [sym_type_arguments] = STATE(1530),
    [sym_identifier] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(1693),
    [anon_sym_COMMA] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1693),
    [anon_sym_LPAREN] = ACTIONS(2247),
    [anon_sym_in] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(2249),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(1693),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1693),
    [anon_sym_PIPE_PIPE] = ACTIONS(1693),
    [anon_sym_GT_GT] = ACTIONS(1693),
    [anon_sym_GT_GT_GT] = ACTIONS(1693),
    [anon_sym_LT_LT] = ACTIONS(1693),
    [anon_sym_AMP] = ACTIONS(1693),
    [anon_sym_CARET] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(1693),
    [anon_sym_PERCENT] = ACTIONS(1693),
    [anon_sym_STAR_STAR] = ACTIONS(1693),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BANG_EQ] = ACTIONS(1693),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_QMARK_QMARK] = ACTIONS(1693),
    [anon_sym_instanceof] = ACTIONS(1693),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [sym__automatic_semicolon] = ACTIONS(1695),
  },
  [651] = {
    [sym_nested_identifier] = STATE(79),
    [sym_string] = STATE(78),
    [sym__module] = STATE(103),
    [aux_sym_object_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(2253),
    [anon_sym_SQUOTE] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [652] = {
    [sym_nested_identifier] = STATE(79),
    [sym_string] = STATE(78),
    [sym__module] = STATE(103),
    [aux_sym_object_repeat1] = STATE(2959),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(2253),
    [anon_sym_SQUOTE] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [653] = {
    [sym_nested_identifier] = STATE(79),
    [sym_string] = STATE(78),
    [sym__module] = STATE(103),
    [aux_sym_object_repeat1] = STATE(3011),
    [sym_identifier] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(2253),
    [anon_sym_SQUOTE] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [654] = {
    [sym_nested_identifier] = STATE(532),
    [sym_string] = STATE(547),
    [sym__module] = STATE(626),
    [aux_sym_object_repeat1] = STATE(2959),
    [sym_identifier] = ACTIONS(2257),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [655] = {
    [sym_nested_identifier] = STATE(532),
    [sym_string] = STATE(547),
    [sym__module] = STATE(626),
    [aux_sym_object_repeat1] = STATE(3011),
    [sym_identifier] = ACTIONS(2257),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
  [656] = {
    [sym_nested_identifier] = STATE(532),
    [sym_string] = STATE(547),
    [sym__module] = STATE(626),
    [aux_sym_object_repeat1] = STATE(3010),
    [sym_identifier] = ACTIONS(2257),
    [anon_sym_STAR] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(860),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(860),
    [anon_sym_SLASH] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(1286),
    [anon_sym_EQ_GT] = ACTIONS(969),
    [anon_sym_QMARK_DOT] = ACTIONS(971),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(883),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_GT_GT] = ACTIONS(860),
    [anon_sym_GT_GT_GT] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(860),
    [anon_sym_AMP] = ACTIONS(860),
    [anon_sym_CARET] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(860),
    [anon_sym_DASH] = ACTIONS(860),
    [anon_sym_PERCENT] = ACTIONS(860),
    [anon_sym_STAR_STAR] = ACTIONS(860),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_QMARK_QMARK] = ACTIONS(860),
    [anon_sym_instanceof] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_DQUOTE] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(893),
    [sym__automatic_semicolon] = ACTIONS(893),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(877), 1,
      anon_sym_EQ_GT,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(953), 1,
      anon_sym_EQ,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      sym_identifier,
    STATE(1096), 1,
      sym_nested_identifier,
    STATE(1098), 1,
      sym_string,
    STATE(1248), 1,
      sym__module,
    ACTIONS(893), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [95] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(1189), 1,
      anon_sym_EQ_GT,
    ACTIONS(1191), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1741), 1,
      anon_sym_LBRACK,
    ACTIONS(1743), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      sym_identifier,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2261), 1,
      anon_sym_LT,
    STATE(1096), 1,
      sym_nested_identifier,
    STATE(1098), 1,
      sym_string,
    STATE(1248), 1,
      sym__module,
    STATE(1710), 1,
      sym_type_arguments,
    STATE(1738), 1,
      sym_arguments,
    ACTIONS(1695), 9,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1693), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [198] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(993), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      sym_identifier,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2245), 1,
      anon_sym_LT,
    STATE(1096), 1,
      sym_nested_identifier,
    STATE(1098), 1,
      sym_string,
    STATE(1126), 1,
      sym_type_arguments,
    STATE(1248), 1,
      sym__module,
    STATE(1279), 1,
      sym_arguments,
    ACTIONS(1695), 10,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1693), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [301] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(1057), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      sym_identifier,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2245), 1,
      anon_sym_LT,
    STATE(1096), 1,
      sym_nested_identifier,
    STATE(1098), 1,
      sym_string,
    STATE(1126), 1,
      sym_type_arguments,
    STATE(1248), 1,
      sym__module,
    STATE(1279), 1,
      sym_arguments,
    ACTIONS(1695), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1693), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [404] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1332), 1,
      anon_sym_COLON,
    ACTIONS(2263), 1,
      sym_identifier,
    STATE(547), 1,
      sym_string,
    STATE(626), 1,
      sym__module,
    STATE(2885), 1,
      sym_nested_identifier,
    ACTIONS(893), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [500] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1332), 1,
      anon_sym_COLON,
    ACTIONS(2265), 1,
      sym_identifier,
    STATE(1109), 1,
      sym_string,
    STATE(1110), 1,
      sym_nested_identifier,
    STATE(1324), 1,
      sym__module,
    ACTIONS(893), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [596] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1358), 1,
      anon_sym_COLON,
    ACTIONS(2265), 1,
      sym_identifier,
    STATE(1109), 1,
      sym_string,
    STATE(1110), 1,
      sym_nested_identifier,
    STATE(1324), 1,
      sym__module,
    ACTIONS(893), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [692] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(2265), 1,
      sym_identifier,
    STATE(1109), 1,
      sym_string,
    STATE(1110), 1,
      sym_nested_identifier,
    STATE(1324), 1,
      sym__module,
    ACTIONS(893), 12,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [786] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1374), 1,
      anon_sym_COLON,
    ACTIONS(2257), 1,
      sym_identifier,
    STATE(532), 1,
      sym_nested_identifier,
    STATE(547), 1,
      sym_string,
    STATE(626), 1,
      sym__module,
    ACTIONS(893), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [882] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(1173), 1,
      anon_sym_EQ_GT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2249), 1,
      anon_sym_LT,
    STATE(1096), 1,
      sym_nested_identifier,
    STATE(1098), 1,
      sym_string,
    STATE(1248), 1,
      sym__module,
    STATE(1530), 1,
      sym_type_arguments,
    STATE(1636), 1,
      sym_arguments,
    ACTIONS(1695), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1693), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [984] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1358), 1,
      anon_sym_COLON,
    ACTIONS(2257), 1,
      sym_identifier,
    STATE(532), 1,
      sym_nested_identifier,
    STATE(547), 1,
      sym_string,
    STATE(626), 1,
      sym__module,
    ACTIONS(893), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1080] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1770), 1,
      anon_sym_in,
    ACTIONS(1773), 1,
      anon_sym_of,
    ACTIONS(2265), 1,
      sym_identifier,
    STATE(1109), 1,
      sym_string,
    STATE(1110), 1,
      sym_nested_identifier,
    STATE(1324), 1,
      sym__module,
    ACTIONS(893), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1178] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1374), 1,
      anon_sym_COLON,
    ACTIONS(2251), 1,
      sym_identifier,
    ACTIONS(2253), 1,
      anon_sym_DQUOTE,
    ACTIONS(2255), 1,
      anon_sym_SQUOTE,
    STATE(78), 1,
      sym_string,
    STATE(79), 1,
      sym_nested_identifier,
    STATE(103), 1,
      sym__module,
    ACTIONS(893), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1274] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1055), 1,
      anon_sym_EQ,
    ACTIONS(1057), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      sym_identifier,
    STATE(1096), 1,
      sym_nested_identifier,
    STATE(1098), 1,
      sym_string,
    STATE(1248), 1,
      sym__module,
    ACTIONS(893), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [1367] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(857), 1,
      anon_sym_EQ,
    ACTIONS(877), 1,
      anon_sym_EQ_GT,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1789), 1,
      anon_sym_QMARK,
    ACTIONS(1794), 1,
      anon_sym_COLON,
    ACTIONS(2241), 1,
      sym_identifier,
    STATE(1096), 1,
      sym_nested_identifier,
    STATE(1098), 1,
      sym_string,
    STATE(1248), 1,
      sym__module,
    ACTIONS(864), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(893), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1466] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(993), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      sym_identifier,
    STATE(1096), 1,
      sym_nested_identifier,
    STATE(1098), 1,
      sym_string,
    STATE(1248), 1,
      sym__module,
    ACTIONS(893), 11,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1559] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      anon_sym_DQUOTE,
    ACTIONS(577), 1,
      anon_sym_SQUOTE,
    ACTIONS(1183), 1,
      anon_sym_EQ,
    ACTIONS(1189), 1,
      anon_sym_EQ_GT,
    ACTIONS(1191), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1741), 1,
      anon_sym_LBRACK,
    ACTIONS(1743), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      sym_identifier,
    STATE(1579), 1,
      sym_nested_identifier,
    STATE(1584), 1,
      sym_string,
    STATE(1753), 1,
      sym__module,
    ACTIONS(893), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1652] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(857), 1,
      anon_sym_EQ,
    ACTIONS(877), 1,
      anon_sym_EQ_GT,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1789), 1,
      anon_sym_QMARK,
    ACTIONS(2241), 1,
      sym_identifier,
    STATE(1096), 1,
      sym_nested_identifier,
    STATE(1098), 1,
      sym_string,
    STATE(1248), 1,
      sym__module,
    ACTIONS(864), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(893), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1749] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(877), 1,
      anon_sym_EQ_GT,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(953), 1,
      anon_sym_EQ,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1792), 1,
      anon_sym_COLON,
    ACTIONS(2241), 1,
      sym_identifier,
    STATE(1096), 1,
      sym_nested_identifier,
    STATE(1098), 1,
      sym_string,
    STATE(1248), 1,
      sym__module,
    ACTIONS(893), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1844] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1171), 1,
      anon_sym_EQ,
    ACTIONS(1173), 1,
      anon_sym_EQ_GT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(2265), 1,
      sym_identifier,
    STATE(1109), 1,
      sym_string,
    STATE(1110), 1,
      sym_nested_identifier,
    STATE(1324), 1,
      sym__module,
    ACTIONS(893), 10,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1936] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(959), 1,
      sym_this,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    STATE(434), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(2269), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3018), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2823), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [2062] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2245), 1,
      anon_sym_LT,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    STATE(1120), 1,
      sym_type_arguments,
    STATE(1281), 1,
      sym_arguments,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2277), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2273), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2148] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(993), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1792), 1,
      anon_sym_COLON,
    ACTIONS(2241), 1,
      sym_identifier,
    STATE(1096), 1,
      sym_nested_identifier,
    STATE(1098), 1,
      sym_string,
    STATE(1248), 1,
      sym__module,
    ACTIONS(893), 9,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2242] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(993), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1848), 1,
      anon_sym_COLON,
    ACTIONS(2241), 1,
      sym_identifier,
    STATE(1096), 1,
      sym_nested_identifier,
    STATE(1098), 1,
      sym_string,
    STATE(1248), 1,
      sym__module,
    ACTIONS(893), 9,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2336] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2287), 1,
      anon_sym_EQ,
    ACTIONS(2291), 1,
      anon_sym_BANG,
    ACTIONS(2293), 1,
      anon_sym_in,
    ACTIONS(2296), 1,
      anon_sym_of,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2300), 1,
      anon_sym_EQ_GT,
    STATE(2705), 1,
      sym_type_annotation,
    STATE(3067), 1,
      sym__initializer,
    ACTIONS(2289), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2304), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [2496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2219), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [2563] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(993), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1854), 1,
      anon_sym_in,
    ACTIONS(1857), 1,
      anon_sym_of,
    ACTIONS(2241), 1,
      sym_identifier,
    STATE(1096), 1,
      sym_nested_identifier,
    STATE(1098), 1,
      sym_string,
    STATE(1248), 1,
      sym__module,
    ACTIONS(893), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2203), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [2725] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 1,
      anon_sym_EQ_GT,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2245), 1,
      anon_sym_LT,
    STATE(1126), 1,
      sym_type_arguments,
    STATE(1279), 1,
      sym_arguments,
    ACTIONS(1695), 14,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1693), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2812] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1275), 1,
      anon_sym_LPAREN,
    ACTIONS(1278), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1304), 1,
      anon_sym_RBRACE,
    ACTIONS(1368), 1,
      anon_sym_EQ,
    ACTIONS(2306), 1,
      sym_identifier,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(893), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2903] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(2313), 1,
      anon_sym_LT,
    ACTIONS(2316), 1,
      anon_sym_DOT,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    STATE(2091), 1,
      sym_type_arguments,
    ACTIONS(2310), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2320), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1759), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2323), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2325), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3059] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1543), 1,
      anon_sym_extends,
    ACTIONS(2337), 1,
      anon_sym_DOT,
    ACTIONS(2331), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2334), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2327), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 32,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3134] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1275), 1,
      anon_sym_LPAREN,
    ACTIONS(1278), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1308), 1,
      anon_sym_RBRACE,
    ACTIONS(1368), 1,
      anon_sym_EQ,
    ACTIONS(2306), 1,
      sym_identifier,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(893), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [3225] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    ACTIONS(1275), 1,
      anon_sym_LPAREN,
    ACTIONS(1278), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1368), 1,
      anon_sym_EQ,
    ACTIONS(2306), 1,
      sym_identifier,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(893), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [3316] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(2313), 1,
      anon_sym_LT,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    ACTIONS(2340), 1,
      anon_sym_DOT,
    STATE(2091), 1,
      sym_type_arguments,
    ACTIONS(1623), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1621), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2344), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3470] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(993), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1770), 1,
      anon_sym_in,
    ACTIONS(1773), 1,
      anon_sym_of,
    ACTIONS(2241), 1,
      sym_identifier,
    STATE(1096), 1,
      sym_nested_identifier,
    STATE(1098), 1,
      sym_string,
    STATE(1248), 1,
      sym__module,
    ACTIONS(893), 8,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [3565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2327), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2346), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2348), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3699] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_extends,
    ACTIONS(2334), 1,
      anon_sym_LT,
    ACTIONS(2337), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2350), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2327), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 32,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3774] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_extends,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(2310), 1,
      anon_sym_COMMA,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(2320), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1045), 14,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2358), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2360), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2364), 36,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3997] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2245), 1,
      anon_sym_LT,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    STATE(1120), 1,
      sym_type_arguments,
    STATE(1281), 1,
      sym_arguments,
    ACTIONS(2277), 14,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2273), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4084] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2366), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1621), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1623), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1045), 14,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4171] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 1,
      anon_sym_EQ_GT,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(953), 1,
      anon_sym_EQ,
    ACTIONS(1229), 1,
      anon_sym_extends,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(2368), 1,
      anon_sym_COMMA,
    ACTIONS(2371), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(893), 14,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4255] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2249), 1,
      anon_sym_LT,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2378), 1,
      anon_sym_EQ_GT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    STATE(1529), 1,
      sym_type_arguments,
    STATE(1639), 1,
      sym_arguments,
    ACTIONS(2277), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2273), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4341] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2378), 1,
      anon_sym_EQ_GT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2382), 1,
      anon_sym_EQ,
    ACTIONS(2384), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1621), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1623), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1045), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4427] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2386), 1,
      sym_identifier,
    ACTIONS(2388), 1,
      anon_sym_STAR,
    ACTIONS(2390), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      anon_sym_typeof,
    ACTIONS(2394), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_LBRACK,
    ACTIONS(2398), 1,
      anon_sym_new,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      anon_sym_AMP,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      sym_number,
    ACTIONS(2412), 1,
      sym_this,
    ACTIONS(2416), 1,
      sym_readonly,
    ACTIONS(2418), 1,
      anon_sym_infer,
    ACTIONS(2420), 1,
      anon_sym_keyof,
    ACTIONS(2422), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1304), 1,
      sym_nested_type_identifier,
    STATE(1555), 1,
      sym__tuple_type_body,
    STATE(1682), 1,
      sym_template_string,
    STATE(3238), 1,
      sym_type_parameters,
    STATE(3571), 1,
      sym_nested_identifier,
    STATE(3670), 1,
      sym_formal_parameters,
    ACTIONS(2406), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2414), 2,
      sym_true,
      sym_false,
    STATE(1554), 2,
      sym_string,
      sym__number,
    ACTIONS(2408), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1500), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1414), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4553] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2249), 1,
      anon_sym_LT,
    STATE(1530), 1,
      sym_type_arguments,
    STATE(1636), 1,
      sym_arguments,
    ACTIONS(1695), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1693), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4639] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2424), 1,
      sym_identifier,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2446), 1,
      sym_this,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2452), 1,
      anon_sym_asserts,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(2420), 1,
      sym_type_predicate,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2134), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4765] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      sym_identifier,
    ACTIONS(2456), 1,
      sym_this,
    ACTIONS(2458), 1,
      anon_sym_asserts,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3312), 1,
      sym_type_predicate,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2215), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [4891] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2460), 1,
      sym_identifier,
    ACTIONS(2462), 1,
      anon_sym_STAR,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_typeof,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACK,
    ACTIONS(2472), 1,
      anon_sym_new,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(2476), 1,
      anon_sym_AMP,
    ACTIONS(2478), 1,
      anon_sym_PIPE,
    ACTIONS(2484), 1,
      anon_sym_DQUOTE,
    ACTIONS(2486), 1,
      anon_sym_SQUOTE,
    ACTIONS(2488), 1,
      sym_number,
    ACTIONS(2490), 1,
      sym_this,
    ACTIONS(2494), 1,
      sym_readonly,
    ACTIONS(2496), 1,
      anon_sym_asserts,
    ACTIONS(2498), 1,
      anon_sym_infer,
    ACTIONS(2500), 1,
      anon_sym_keyof,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2143), 1,
      sym_nested_type_identifier,
    STATE(2271), 1,
      sym__tuple_type_body,
    STATE(2894), 1,
      sym_type_predicate,
    STATE(3350), 1,
      sym_type_parameters,
    STATE(3439), 1,
      sym_nested_identifier,
    STATE(3589), 1,
      sym_formal_parameters,
    ACTIONS(2480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2492), 2,
      sym_true,
      sym_false,
    STATE(2260), 2,
      sym_string,
      sym__number,
    ACTIONS(2482), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2356), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2275), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5017] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      anon_sym_DQUOTE,
    ACTIONS(577), 1,
      anon_sym_SQUOTE,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_STAR,
    ACTIONS(2508), 1,
      anon_sym_LBRACE,
    ACTIONS(2510), 1,
      anon_sym_typeof,
    ACTIONS(2512), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACK,
    ACTIONS(2516), 1,
      anon_sym_new,
    ACTIONS(2518), 1,
      anon_sym_QMARK,
    ACTIONS(2520), 1,
      anon_sym_AMP,
    ACTIONS(2522), 1,
      anon_sym_PIPE,
    ACTIONS(2528), 1,
      sym_number,
    ACTIONS(2530), 1,
      sym_this,
    ACTIONS(2534), 1,
      sym_readonly,
    ACTIONS(2536), 1,
      anon_sym_infer,
    ACTIONS(2538), 1,
      anon_sym_keyof,
    ACTIONS(2540), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1533), 1,
      sym_nested_type_identifier,
    STATE(1662), 1,
      sym__tuple_type_body,
    STATE(1762), 1,
      sym_template_string,
    STATE(3342), 1,
      sym_type_parameters,
    STATE(3447), 1,
      sym_nested_identifier,
    STATE(3632), 1,
      sym_formal_parameters,
    ACTIONS(2524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2532), 2,
      sym_true,
      sym_false,
    STATE(1621), 2,
      sym_string,
      sym__number,
    ACTIONS(2526), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1672), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1674), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5143] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1275), 1,
      anon_sym_LPAREN,
    ACTIONS(1278), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1308), 1,
      anon_sym_RBRACE,
    ACTIONS(1368), 1,
      anon_sym_EQ,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(893), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5231] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1278), 1,
      anon_sym_COLON,
    ACTIONS(1308), 1,
      anon_sym_RBRACE,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2378), 1,
      anon_sym_EQ_GT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2542), 1,
      anon_sym_EQ,
    ACTIONS(2544), 1,
      anon_sym_LPAREN,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    ACTIONS(2547), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1045), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5319] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    ACTIONS(1278), 1,
      anon_sym_COLON,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2378), 1,
      anon_sym_EQ_GT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2542), 1,
      anon_sym_EQ,
    ACTIONS(2544), 1,
      anon_sym_LPAREN,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    ACTIONS(2547), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1045), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5407] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_extends,
    ACTIONS(2310), 1,
      anon_sym_COMMA,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2378), 1,
      anon_sym_EQ_GT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2382), 1,
      anon_sym_EQ,
    ACTIONS(2550), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(2320), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1045), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5495] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 1,
      anon_sym_EQ_GT,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(953), 1,
      anon_sym_EQ,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(2368), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2371), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1229), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(893), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5579] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2300), 1,
      anon_sym_EQ_GT,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2552), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1759), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2320), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1045), 13,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5665] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1278), 1,
      anon_sym_COLON,
    ACTIONS(1304), 1,
      anon_sym_RBRACE,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2378), 1,
      anon_sym_EQ_GT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2542), 1,
      anon_sym_EQ,
    ACTIONS(2544), 1,
      anon_sym_LPAREN,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    ACTIONS(2547), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1045), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5753] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1275), 1,
      anon_sym_LPAREN,
    ACTIONS(1278), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1304), 1,
      anon_sym_RBRACE,
    ACTIONS(1368), 1,
      anon_sym_EQ,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(893), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5841] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2554), 1,
      sym_identifier,
    ACTIONS(2556), 1,
      anon_sym_STAR,
    ACTIONS(2558), 1,
      anon_sym_LBRACE,
    ACTIONS(2560), 1,
      anon_sym_typeof,
    ACTIONS(2562), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LBRACK,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2568), 1,
      anon_sym_QMARK,
    ACTIONS(2570), 1,
      anon_sym_AMP,
    ACTIONS(2572), 1,
      anon_sym_PIPE,
    ACTIONS(2578), 1,
      sym_number,
    ACTIONS(2580), 1,
      sym_this,
    ACTIONS(2584), 1,
      sym_readonly,
    ACTIONS(2586), 1,
      anon_sym_infer,
    ACTIONS(2588), 1,
      anon_sym_keyof,
    ACTIONS(2590), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1061), 1,
      sym_nested_type_identifier,
    STATE(1084), 1,
      sym__tuple_type_body,
    STATE(1263), 1,
      sym_template_string,
    STATE(3360), 1,
      sym_type_parameters,
    STATE(3409), 1,
      sym_nested_identifier,
    STATE(3538), 1,
      sym_formal_parameters,
    ACTIONS(2574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2582), 2,
      sym_true,
      sym_false,
    STATE(1093), 2,
      sym_string,
      sym__number,
    ACTIONS(2576), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1087), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5967] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    ACTIONS(1275), 1,
      anon_sym_LPAREN,
    ACTIONS(1278), 1,
      anon_sym_COLON,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1368), 1,
      anon_sym_EQ,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    ACTIONS(1283), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(893), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6055] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2300), 1,
      anon_sym_EQ_GT,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2592), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1621), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1623), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1045), 13,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6141] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2594), 1,
      anon_sym_GT,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6264] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1332), 1,
      anon_sym_COLON,
    ACTIONS(2306), 1,
      sym_identifier,
    ACTIONS(893), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [6345] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2604), 1,
      anon_sym_RBRACK,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2861), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6468] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(993), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2245), 1,
      anon_sym_LT,
    STATE(1126), 1,
      sym_type_arguments,
    STATE(1279), 1,
      sym_arguments,
    ACTIONS(1695), 12,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1693), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6553] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2606), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6676] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2608), 1,
      anon_sym_RBRACK,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2861), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6799] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2610), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6922] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(2614), 1,
      anon_sym_DOT,
    ACTIONS(2616), 1,
      anon_sym_EQ_GT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1759), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2320), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1045), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7007] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2618), 1,
      anon_sym_EQ,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(2624), 1,
      anon_sym_DOT,
    ACTIONS(2626), 1,
      anon_sym_EQ_GT,
    STATE(428), 1,
      sym_type_arguments,
    STATE(2870), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(2620), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7094] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2628), 1,
      anon_sym_RBRACK,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2878), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7217] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1358), 1,
      anon_sym_COLON,
    ACTIONS(2306), 1,
      sym_identifier,
    ACTIONS(893), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [7298] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2366), 1,
      anon_sym_DOT,
    ACTIONS(2618), 1,
      anon_sym_EQ,
    ACTIONS(2626), 1,
      anon_sym_EQ_GT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1621), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1623), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1045), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7383] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2630), 1,
      anon_sym_RBRACK,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2876), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7506] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(1189), 1,
      anon_sym_EQ_GT,
    ACTIONS(1191), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1741), 1,
      anon_sym_LBRACK,
    ACTIONS(1743), 1,
      anon_sym_DOT,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2261), 1,
      anon_sym_LT,
    STATE(1710), 1,
      sym_type_arguments,
    STATE(1738), 1,
      sym_arguments,
    ACTIONS(1695), 11,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1693), 22,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7591] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2632), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1621), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(1623), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1045), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7676] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    ACTIONS(1045), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7753] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2636), 1,
      anon_sym_export,
    ACTIONS(2638), 1,
      anon_sym_STAR,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    ACTIONS(2642), 1,
      anon_sym_RBRACE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2646), 1,
      anon_sym_SEMI,
    ACTIONS(2648), 1,
      anon_sym_LBRACK,
    ACTIONS(2650), 1,
      anon_sym_async,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2656), 1,
      sym_number,
    ACTIONS(2658), 1,
      anon_sym_static,
    ACTIONS(2664), 1,
      sym_readonly,
    ACTIONS(2666), 1,
      anon_sym_PIPE_RBRACE,
    STATE(1986), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3021), 1,
      aux_sym_object_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(2660), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2662), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3025), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2460), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2634), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [7884] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2245), 1,
      anon_sym_LT,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2626), 1,
      anon_sym_EQ_GT,
    STATE(1120), 1,
      sym_type_arguments,
    STATE(1281), 1,
      sym_arguments,
    ACTIONS(2277), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2273), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7969] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 1,
      anon_sym_EQ_GT,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(953), 1,
      anon_sym_EQ,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(893), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(860), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8046] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2261), 1,
      anon_sym_LT,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(2672), 1,
      anon_sym_EQ_GT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    STATE(1707), 1,
      sym_type_arguments,
    STATE(1746), 1,
      sym_arguments,
    ACTIONS(2277), 11,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2273), 22,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8131] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2638), 1,
      anon_sym_STAR,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2646), 1,
      anon_sym_SEMI,
    ACTIONS(2648), 1,
      anon_sym_LBRACK,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2656), 1,
      sym_number,
    ACTIONS(2666), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2678), 1,
      anon_sym_export,
    ACTIONS(2680), 1,
      anon_sym_RBRACE,
    ACTIONS(2682), 1,
      anon_sym_async,
    ACTIONS(2684), 1,
      anon_sym_static,
    ACTIONS(2690), 1,
      sym_readonly,
    STATE(1986), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(2951), 1,
      aux_sym_object_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(2686), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2688), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2946), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2460), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2676), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [8262] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2692), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8385] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2694), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8508] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2334), 1,
      anon_sym_LT,
    ACTIONS(2350), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1059), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2337), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2327), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [8581] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2337), 1,
      anon_sym_DOT,
    ACTIONS(2331), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(2334), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1543), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2327), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [8654] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2696), 1,
      anon_sym_RBRACK,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2843), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8777] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2672), 1,
      anon_sym_EQ_GT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_EQ,
    ACTIONS(2700), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1621), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1623), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1045), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8862] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_extends,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2702), 1,
      anon_sym_EQ,
    ACTIONS(2708), 1,
      anon_sym_RPAREN,
    ACTIONS(2712), 1,
      anon_sym_DOT,
    ACTIONS(2714), 1,
      anon_sym_QMARK,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(2320), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2705), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8953] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2717), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9076] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2719), 1,
      anon_sym_RBRACK,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2861), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9199] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2721), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9322] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(2616), 1,
      anon_sym_EQ_GT,
    ACTIONS(2723), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1621), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1623), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1045), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9407] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2725), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9530] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2727), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9653] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2729), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9776] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2731), 1,
      anon_sym_RBRACK,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2861), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9899] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2733), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10022] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2735), 1,
      anon_sym_RBRACK,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2901), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10145] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2737), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10268] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2249), 1,
      anon_sym_LT,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    STATE(1529), 1,
      sym_type_arguments,
    STATE(1639), 1,
      sym_arguments,
    ACTIONS(2277), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2273), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10351] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2638), 1,
      anon_sym_STAR,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2646), 1,
      anon_sym_SEMI,
    ACTIONS(2648), 1,
      anon_sym_LBRACK,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2656), 1,
      sym_number,
    ACTIONS(2666), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2678), 1,
      anon_sym_export,
    ACTIONS(2682), 1,
      anon_sym_async,
    ACTIONS(2684), 1,
      anon_sym_static,
    ACTIONS(2690), 1,
      sym_readonly,
    ACTIONS(2739), 1,
      anon_sym_RBRACE,
    STATE(1986), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(2951), 1,
      aux_sym_object_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(2686), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2688), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2946), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2460), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2676), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [10482] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2741), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10605] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2636), 1,
      anon_sym_export,
    ACTIONS(2638), 1,
      anon_sym_STAR,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2648), 1,
      anon_sym_LBRACK,
    ACTIONS(2650), 1,
      anon_sym_async,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2656), 1,
      sym_number,
    ACTIONS(2658), 1,
      anon_sym_static,
    ACTIONS(2664), 1,
      sym_readonly,
    ACTIONS(2743), 1,
      anon_sym_COMMA,
    ACTIONS(2745), 1,
      anon_sym_RBRACE,
    ACTIONS(2747), 1,
      anon_sym_SEMI,
    ACTIONS(2749), 1,
      anon_sym_PIPE_RBRACE,
    STATE(1986), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3021), 1,
      aux_sym_object_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(2660), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2662), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3025), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2458), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2634), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [10736] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2638), 1,
      anon_sym_STAR,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2646), 1,
      anon_sym_SEMI,
    ACTIONS(2648), 1,
      anon_sym_LBRACK,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2656), 1,
      sym_number,
    ACTIONS(2666), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2753), 1,
      anon_sym_export,
    ACTIONS(2755), 1,
      anon_sym_RBRACE,
    ACTIONS(2757), 1,
      anon_sym_async,
    ACTIONS(2759), 1,
      anon_sym_static,
    ACTIONS(2765), 1,
      sym_readonly,
    STATE(1986), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(2998), 1,
      aux_sym_object_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(2761), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2763), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2996), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2460), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2751), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [10867] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_extends,
    ACTIONS(2310), 1,
      anon_sym_COMMA,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2672), 1,
      anon_sym_EQ_GT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_EQ,
    ACTIONS(2767), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(2320), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1045), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10954] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(993), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1229), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2371), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(893), 13,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11035] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2769), 1,
      anon_sym_RBRACK,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2861), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11158] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2636), 1,
      anon_sym_export,
    ACTIONS(2638), 1,
      anon_sym_STAR,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2646), 1,
      anon_sym_SEMI,
    ACTIONS(2648), 1,
      anon_sym_LBRACK,
    ACTIONS(2650), 1,
      anon_sym_async,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2656), 1,
      sym_number,
    ACTIONS(2658), 1,
      anon_sym_static,
    ACTIONS(2664), 1,
      sym_readonly,
    ACTIONS(2666), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2771), 1,
      anon_sym_RBRACE,
    STATE(1986), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3021), 1,
      aux_sym_object_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(2660), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2662), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3025), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2460), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2634), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [11289] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2773), 1,
      anon_sym_RBRACK,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2861), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11412] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2775), 1,
      anon_sym_RBRACK,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2889), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11535] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2638), 1,
      anon_sym_STAR,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2646), 1,
      anon_sym_SEMI,
    ACTIONS(2648), 1,
      anon_sym_LBRACK,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2656), 1,
      sym_number,
    ACTIONS(2666), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2779), 1,
      anon_sym_export,
    ACTIONS(2781), 1,
      anon_sym_RBRACE,
    ACTIONS(2783), 1,
      anon_sym_async,
    ACTIONS(2785), 1,
      anon_sym_static,
    ACTIONS(2791), 1,
      sym_readonly,
    STATE(1986), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3095), 1,
      aux_sym_object_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(2787), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2789), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3098), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2460), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2777), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [11666] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2793), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11789] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2795), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11912] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1374), 1,
      anon_sym_COLON,
    ACTIONS(2306), 1,
      sym_identifier,
    ACTIONS(893), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [11993] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(1057), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2245), 1,
      anon_sym_LT,
    STATE(1126), 1,
      sym_type_arguments,
    STATE(1279), 1,
      sym_arguments,
    ACTIONS(1695), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1693), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12078] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1229), 1,
      anon_sym_extends,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(2368), 1,
      anon_sym_COMMA,
    ACTIONS(2371), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(893), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12161] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2797), 1,
      anon_sym_GT,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12284] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2799), 1,
      anon_sym_RBRACK,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2861), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12407] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2620), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2672), 1,
      anon_sym_EQ_GT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_EQ,
    ACTIONS(2801), 1,
      anon_sym_LBRACE,
    ACTIONS(2803), 1,
      anon_sym_COMMA,
    ACTIONS(2805), 1,
      anon_sym_LT,
    ACTIONS(2808), 1,
      anon_sym_DOT,
    STATE(2846), 1,
      aux_sym_extends_clause_repeat1,
    STATE(3040), 1,
      sym_type_arguments,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12496] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_extends,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2310), 1,
      anon_sym_COMMA,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2618), 1,
      anon_sym_EQ,
    ACTIONS(2626), 1,
      anon_sym_EQ_GT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(2320), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1045), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12583] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2810), 1,
      sym_identifier,
    ACTIONS(2812), 1,
      sym_jsx_identifier,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2419), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12706] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2245), 1,
      anon_sym_LT,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2300), 1,
      anon_sym_EQ_GT,
    STATE(1120), 1,
      sym_type_arguments,
    STATE(1281), 1,
      sym_arguments,
    ACTIONS(2277), 12,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2273), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2327), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12855] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2564), 1,
      anon_sym_LBRACK,
    ACTIONS(2814), 1,
      sym_this,
    STATE(1158), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3018), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2830), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12975] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2095), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13095] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2820), 1,
      sym_identifier,
    ACTIONS(2822), 1,
      anon_sym_typeof,
    ACTIONS(2824), 1,
      anon_sym_new,
    ACTIONS(2826), 1,
      anon_sym_QMARK,
    ACTIONS(2828), 1,
      anon_sym_AMP,
    ACTIONS(2830), 1,
      anon_sym_PIPE,
    ACTIONS(2832), 1,
      anon_sym_keyof,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(503), 1,
      sym_nested_type_identifier,
    STATE(3344), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3608), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(457), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13215] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2820), 1,
      sym_identifier,
    ACTIONS(2822), 1,
      anon_sym_typeof,
    ACTIONS(2824), 1,
      anon_sym_new,
    ACTIONS(2826), 1,
      anon_sym_QMARK,
    ACTIONS(2828), 1,
      anon_sym_AMP,
    ACTIONS(2830), 1,
      anon_sym_PIPE,
    ACTIONS(2832), 1,
      anon_sym_keyof,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(503), 1,
      sym_nested_type_identifier,
    STATE(3344), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3608), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(459), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13335] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2820), 1,
      sym_identifier,
    ACTIONS(2822), 1,
      anon_sym_typeof,
    ACTIONS(2824), 1,
      anon_sym_new,
    ACTIONS(2826), 1,
      anon_sym_QMARK,
    ACTIONS(2828), 1,
      anon_sym_AMP,
    ACTIONS(2830), 1,
      anon_sym_PIPE,
    ACTIONS(2832), 1,
      anon_sym_keyof,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(503), 1,
      sym_nested_type_identifier,
    STATE(3344), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3608), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(525), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13455] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2462), 1,
      anon_sym_STAR,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_typeof,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACK,
    ACTIONS(2472), 1,
      anon_sym_new,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(2476), 1,
      anon_sym_AMP,
    ACTIONS(2478), 1,
      anon_sym_PIPE,
    ACTIONS(2484), 1,
      anon_sym_DQUOTE,
    ACTIONS(2486), 1,
      anon_sym_SQUOTE,
    ACTIONS(2488), 1,
      sym_number,
    ACTIONS(2494), 1,
      sym_readonly,
    ACTIONS(2498), 1,
      anon_sym_infer,
    ACTIONS(2500), 1,
      anon_sym_keyof,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2834), 1,
      sym_identifier,
    ACTIONS(2836), 1,
      sym_this,
    STATE(2143), 1,
      sym_nested_type_identifier,
    STATE(2271), 1,
      sym__tuple_type_body,
    STATE(3350), 1,
      sym_type_parameters,
    STATE(3439), 1,
      sym_nested_identifier,
    STATE(3589), 1,
      sym_formal_parameters,
    ACTIONS(2480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2492), 2,
      sym_true,
      sym_false,
    STATE(2260), 2,
      sym_string,
      sym__number,
    ACTIONS(2482), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2291), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2275), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13575] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1055), 1,
      anon_sym_EQ,
    ACTIONS(1057), 1,
      anon_sym_EQ_GT,
    ACTIONS(1229), 1,
      anon_sym_extends,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(2368), 1,
      anon_sym_COMMA,
    ACTIONS(2371), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(893), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13657] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2462), 1,
      anon_sym_STAR,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_typeof,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACK,
    ACTIONS(2472), 1,
      anon_sym_new,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(2476), 1,
      anon_sym_AMP,
    ACTIONS(2478), 1,
      anon_sym_PIPE,
    ACTIONS(2484), 1,
      anon_sym_DQUOTE,
    ACTIONS(2486), 1,
      anon_sym_SQUOTE,
    ACTIONS(2488), 1,
      sym_number,
    ACTIONS(2494), 1,
      sym_readonly,
    ACTIONS(2498), 1,
      anon_sym_infer,
    ACTIONS(2500), 1,
      anon_sym_keyof,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2834), 1,
      sym_identifier,
    ACTIONS(2836), 1,
      sym_this,
    STATE(2143), 1,
      sym_nested_type_identifier,
    STATE(2271), 1,
      sym__tuple_type_body,
    STATE(3350), 1,
      sym_type_parameters,
    STATE(3439), 1,
      sym_nested_identifier,
    STATE(3589), 1,
      sym_formal_parameters,
    ACTIONS(2480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2492), 2,
      sym_true,
      sym_false,
    STATE(2260), 2,
      sym_string,
      sym__number,
    ACTIONS(2482), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2281), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2275), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13777] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_extends,
    ACTIONS(2334), 1,
      anon_sym_LT,
    ACTIONS(2337), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2350), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2327), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13849] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2462), 1,
      anon_sym_STAR,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_typeof,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACK,
    ACTIONS(2472), 1,
      anon_sym_new,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(2476), 1,
      anon_sym_AMP,
    ACTIONS(2478), 1,
      anon_sym_PIPE,
    ACTIONS(2484), 1,
      anon_sym_DQUOTE,
    ACTIONS(2486), 1,
      anon_sym_SQUOTE,
    ACTIONS(2488), 1,
      sym_number,
    ACTIONS(2494), 1,
      sym_readonly,
    ACTIONS(2498), 1,
      anon_sym_infer,
    ACTIONS(2500), 1,
      anon_sym_keyof,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2834), 1,
      sym_identifier,
    ACTIONS(2836), 1,
      sym_this,
    STATE(2143), 1,
      sym_nested_type_identifier,
    STATE(2271), 1,
      sym__tuple_type_body,
    STATE(3350), 1,
      sym_type_parameters,
    STATE(3439), 1,
      sym_nested_identifier,
    STATE(3589), 1,
      sym_formal_parameters,
    ACTIONS(2480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2492), 2,
      sym_true,
      sym_false,
    STATE(2260), 2,
      sym_string,
      sym__number,
    ACTIONS(2482), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2287), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2275), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13969] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2378), 1,
      anon_sym_EQ_GT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2382), 1,
      anon_sym_EQ,
    ACTIONS(1045), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14045] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2462), 1,
      anon_sym_STAR,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_typeof,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACK,
    ACTIONS(2472), 1,
      anon_sym_new,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(2476), 1,
      anon_sym_AMP,
    ACTIONS(2478), 1,
      anon_sym_PIPE,
    ACTIONS(2484), 1,
      anon_sym_DQUOTE,
    ACTIONS(2486), 1,
      anon_sym_SQUOTE,
    ACTIONS(2488), 1,
      sym_number,
    ACTIONS(2494), 1,
      sym_readonly,
    ACTIONS(2498), 1,
      anon_sym_infer,
    ACTIONS(2500), 1,
      anon_sym_keyof,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2834), 1,
      sym_identifier,
    ACTIONS(2836), 1,
      sym_this,
    STATE(2143), 1,
      sym_nested_type_identifier,
    STATE(2271), 1,
      sym__tuple_type_body,
    STATE(3350), 1,
      sym_type_parameters,
    STATE(3439), 1,
      sym_nested_identifier,
    STATE(3589), 1,
      sym_formal_parameters,
    ACTIONS(2480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2492), 2,
      sym_true,
      sym_false,
    STATE(2260), 2,
      sym_string,
      sym__number,
    ACTIONS(2482), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2274), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2275), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14165] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2386), 1,
      sym_identifier,
    ACTIONS(2388), 1,
      anon_sym_STAR,
    ACTIONS(2390), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      anon_sym_typeof,
    ACTIONS(2394), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_LBRACK,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2410), 1,
      sym_number,
    ACTIONS(2416), 1,
      sym_readonly,
    ACTIONS(2420), 1,
      anon_sym_keyof,
    ACTIONS(2422), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2838), 1,
      sym_this,
    STATE(1304), 1,
      sym_nested_type_identifier,
    STATE(1555), 1,
      sym__tuple_type_body,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3565), 1,
      sym_formal_parameters,
    STATE(3571), 1,
      sym_nested_identifier,
    ACTIONS(2406), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2414), 2,
      sym_true,
      sym_false,
    STATE(1554), 2,
      sym_string,
      sym__number,
    ACTIONS(2408), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3139), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1522), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14285] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2386), 1,
      sym_identifier,
    ACTIONS(2388), 1,
      anon_sym_STAR,
    ACTIONS(2390), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      anon_sym_typeof,
    ACTIONS(2394), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_LBRACK,
    ACTIONS(2398), 1,
      anon_sym_new,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      anon_sym_AMP,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      sym_number,
    ACTIONS(2412), 1,
      sym_this,
    ACTIONS(2416), 1,
      sym_readonly,
    ACTIONS(2418), 1,
      anon_sym_infer,
    ACTIONS(2420), 1,
      anon_sym_keyof,
    ACTIONS(2422), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1304), 1,
      sym_nested_type_identifier,
    STATE(1555), 1,
      sym__tuple_type_body,
    STATE(3238), 1,
      sym_type_parameters,
    STATE(3571), 1,
      sym_nested_identifier,
    STATE(3670), 1,
      sym_formal_parameters,
    ACTIONS(2406), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2414), 2,
      sym_true,
      sym_false,
    STATE(1554), 2,
      sym_string,
      sym__number,
    ACTIONS(2408), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1521), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1414), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14405] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2419), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14525] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2386), 1,
      sym_identifier,
    ACTIONS(2388), 1,
      anon_sym_STAR,
    ACTIONS(2390), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      anon_sym_typeof,
    ACTIONS(2394), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_LBRACK,
    ACTIONS(2398), 1,
      anon_sym_new,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      anon_sym_AMP,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      sym_number,
    ACTIONS(2412), 1,
      sym_this,
    ACTIONS(2416), 1,
      sym_readonly,
    ACTIONS(2418), 1,
      anon_sym_infer,
    ACTIONS(2420), 1,
      anon_sym_keyof,
    ACTIONS(2422), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1304), 1,
      sym_nested_type_identifier,
    STATE(1555), 1,
      sym__tuple_type_body,
    STATE(3238), 1,
      sym_type_parameters,
    STATE(3571), 1,
      sym_nested_identifier,
    STATE(3670), 1,
      sym_formal_parameters,
    ACTIONS(2406), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2414), 2,
      sym_true,
      sym_false,
    STATE(1554), 2,
      sym_string,
      sym__number,
    ACTIONS(2408), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1519), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1414), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14645] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2860), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14765] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2462), 1,
      anon_sym_STAR,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_typeof,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACK,
    ACTIONS(2472), 1,
      anon_sym_new,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(2476), 1,
      anon_sym_AMP,
    ACTIONS(2478), 1,
      anon_sym_PIPE,
    ACTIONS(2484), 1,
      anon_sym_DQUOTE,
    ACTIONS(2486), 1,
      anon_sym_SQUOTE,
    ACTIONS(2488), 1,
      sym_number,
    ACTIONS(2494), 1,
      sym_readonly,
    ACTIONS(2498), 1,
      anon_sym_infer,
    ACTIONS(2500), 1,
      anon_sym_keyof,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2834), 1,
      sym_identifier,
    ACTIONS(2836), 1,
      sym_this,
    STATE(2143), 1,
      sym_nested_type_identifier,
    STATE(2271), 1,
      sym__tuple_type_body,
    STATE(3350), 1,
      sym_type_parameters,
    STATE(3439), 1,
      sym_nested_identifier,
    STATE(3589), 1,
      sym_formal_parameters,
    ACTIONS(2480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2492), 2,
      sym_true,
      sym_false,
    STATE(2260), 2,
      sym_string,
      sym__number,
    ACTIONS(2482), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2264), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2275), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14885] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2462), 1,
      anon_sym_STAR,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_typeof,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACK,
    ACTIONS(2472), 1,
      anon_sym_new,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(2476), 1,
      anon_sym_AMP,
    ACTIONS(2478), 1,
      anon_sym_PIPE,
    ACTIONS(2484), 1,
      anon_sym_DQUOTE,
    ACTIONS(2486), 1,
      anon_sym_SQUOTE,
    ACTIONS(2488), 1,
      sym_number,
    ACTIONS(2494), 1,
      sym_readonly,
    ACTIONS(2498), 1,
      anon_sym_infer,
    ACTIONS(2500), 1,
      anon_sym_keyof,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2834), 1,
      sym_identifier,
    ACTIONS(2836), 1,
      sym_this,
    STATE(2143), 1,
      sym_nested_type_identifier,
    STATE(2271), 1,
      sym__tuple_type_body,
    STATE(3350), 1,
      sym_type_parameters,
    STATE(3439), 1,
      sym_nested_identifier,
    STATE(3589), 1,
      sym_formal_parameters,
    ACTIONS(2480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2492), 2,
      sym_true,
      sym_false,
    STATE(2260), 2,
      sym_string,
      sym__number,
    ACTIONS(2482), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2263), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2275), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15005] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2462), 1,
      anon_sym_STAR,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_typeof,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACK,
    ACTIONS(2472), 1,
      anon_sym_new,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(2476), 1,
      anon_sym_AMP,
    ACTIONS(2478), 1,
      anon_sym_PIPE,
    ACTIONS(2484), 1,
      anon_sym_DQUOTE,
    ACTIONS(2486), 1,
      anon_sym_SQUOTE,
    ACTIONS(2488), 1,
      sym_number,
    ACTIONS(2494), 1,
      sym_readonly,
    ACTIONS(2498), 1,
      anon_sym_infer,
    ACTIONS(2500), 1,
      anon_sym_keyof,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2834), 1,
      sym_identifier,
    ACTIONS(2836), 1,
      sym_this,
    STATE(2143), 1,
      sym_nested_type_identifier,
    STATE(2271), 1,
      sym__tuple_type_body,
    STATE(3350), 1,
      sym_type_parameters,
    STATE(3439), 1,
      sym_nested_identifier,
    STATE(3589), 1,
      sym_formal_parameters,
    ACTIONS(2480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2492), 2,
      sym_true,
      sym_false,
    STATE(2260), 2,
      sym_string,
      sym__number,
    ACTIONS(2482), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2270), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2275), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15125] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2854), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15245] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      anon_sym_DQUOTE,
    ACTIONS(577), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_STAR,
    ACTIONS(2508), 1,
      anon_sym_LBRACE,
    ACTIONS(2510), 1,
      anon_sym_typeof,
    ACTIONS(2512), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACK,
    ACTIONS(2516), 1,
      anon_sym_new,
    ACTIONS(2518), 1,
      anon_sym_QMARK,
    ACTIONS(2520), 1,
      anon_sym_AMP,
    ACTIONS(2522), 1,
      anon_sym_PIPE,
    ACTIONS(2528), 1,
      sym_number,
    ACTIONS(2530), 1,
      sym_this,
    ACTIONS(2534), 1,
      sym_readonly,
    ACTIONS(2536), 1,
      anon_sym_infer,
    ACTIONS(2538), 1,
      anon_sym_keyof,
    ACTIONS(2540), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1533), 1,
      sym_nested_type_identifier,
    STATE(1662), 1,
      sym__tuple_type_body,
    STATE(3342), 1,
      sym_type_parameters,
    STATE(3447), 1,
      sym_nested_identifier,
    STATE(3632), 1,
      sym_formal_parameters,
    ACTIONS(2524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2532), 2,
      sym_true,
      sym_false,
    STATE(1621), 2,
      sym_string,
      sym__number,
    ACTIONS(2526), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1597), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1674), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15365] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      anon_sym_DQUOTE,
    ACTIONS(577), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_STAR,
    ACTIONS(2508), 1,
      anon_sym_LBRACE,
    ACTIONS(2510), 1,
      anon_sym_typeof,
    ACTIONS(2512), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACK,
    ACTIONS(2516), 1,
      anon_sym_new,
    ACTIONS(2518), 1,
      anon_sym_QMARK,
    ACTIONS(2520), 1,
      anon_sym_AMP,
    ACTIONS(2522), 1,
      anon_sym_PIPE,
    ACTIONS(2528), 1,
      sym_number,
    ACTIONS(2530), 1,
      sym_this,
    ACTIONS(2534), 1,
      sym_readonly,
    ACTIONS(2536), 1,
      anon_sym_infer,
    ACTIONS(2538), 1,
      anon_sym_keyof,
    ACTIONS(2540), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1533), 1,
      sym_nested_type_identifier,
    STATE(1662), 1,
      sym__tuple_type_body,
    STATE(3342), 1,
      sym_type_parameters,
    STATE(3447), 1,
      sym_nested_identifier,
    STATE(3632), 1,
      sym_formal_parameters,
    ACTIONS(2524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2532), 2,
      sym_true,
      sym_false,
    STATE(1621), 2,
      sym_string,
      sym__number,
    ACTIONS(2526), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1631), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1674), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15485] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(575), 1,
      anon_sym_DQUOTE,
    ACTIONS(577), 1,
      anon_sym_SQUOTE,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_STAR,
    ACTIONS(2508), 1,
      anon_sym_LBRACE,
    ACTIONS(2510), 1,
      anon_sym_typeof,
    ACTIONS(2512), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACK,
    ACTIONS(2518), 1,
      anon_sym_QMARK,
    ACTIONS(2528), 1,
      sym_number,
    ACTIONS(2534), 1,
      sym_readonly,
    ACTIONS(2538), 1,
      anon_sym_keyof,
    ACTIONS(2540), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2840), 1,
      sym_this,
    STATE(1533), 1,
      sym_nested_type_identifier,
    STATE(1662), 1,
      sym__tuple_type_body,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3447), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(2524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2532), 2,
      sym_true,
      sym_false,
    STATE(1621), 2,
      sym_string,
      sym__number,
    ACTIONS(2526), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3099), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1644), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15605] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2850), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15725] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2554), 1,
      sym_identifier,
    ACTIONS(2556), 1,
      anon_sym_STAR,
    ACTIONS(2558), 1,
      anon_sym_LBRACE,
    ACTIONS(2560), 1,
      anon_sym_typeof,
    ACTIONS(2562), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LBRACK,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2568), 1,
      anon_sym_QMARK,
    ACTIONS(2570), 1,
      anon_sym_AMP,
    ACTIONS(2572), 1,
      anon_sym_PIPE,
    ACTIONS(2578), 1,
      sym_number,
    ACTIONS(2580), 1,
      sym_this,
    ACTIONS(2584), 1,
      sym_readonly,
    ACTIONS(2586), 1,
      anon_sym_infer,
    ACTIONS(2588), 1,
      anon_sym_keyof,
    ACTIONS(2590), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1061), 1,
      sym_nested_type_identifier,
    STATE(1084), 1,
      sym__tuple_type_body,
    STATE(3360), 1,
      sym_type_parameters,
    STATE(3409), 1,
      sym_nested_identifier,
    STATE(3538), 1,
      sym_formal_parameters,
    ACTIONS(2574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2582), 2,
      sym_true,
      sym_false,
    STATE(1093), 2,
      sym_string,
      sym__number,
    ACTIONS(2576), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1117), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15845] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1770), 1,
      anon_sym_in,
    ACTIONS(2842), 1,
      anon_sym_of,
    ACTIONS(893), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15925] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2844), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3141), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2097), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16045] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2921), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16165] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2554), 1,
      sym_identifier,
    ACTIONS(2556), 1,
      anon_sym_STAR,
    ACTIONS(2558), 1,
      anon_sym_LBRACE,
    ACTIONS(2560), 1,
      anon_sym_typeof,
    ACTIONS(2562), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LBRACK,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2568), 1,
      anon_sym_QMARK,
    ACTIONS(2570), 1,
      anon_sym_AMP,
    ACTIONS(2572), 1,
      anon_sym_PIPE,
    ACTIONS(2578), 1,
      sym_number,
    ACTIONS(2580), 1,
      sym_this,
    ACTIONS(2584), 1,
      sym_readonly,
    ACTIONS(2586), 1,
      anon_sym_infer,
    ACTIONS(2588), 1,
      anon_sym_keyof,
    ACTIONS(2590), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1061), 1,
      sym_nested_type_identifier,
    STATE(1084), 1,
      sym__tuple_type_body,
    STATE(3360), 1,
      sym_type_parameters,
    STATE(3409), 1,
      sym_nested_identifier,
    STATE(3538), 1,
      sym_formal_parameters,
    ACTIONS(2574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2582), 2,
      sym_true,
      sym_false,
    STATE(1093), 2,
      sym_string,
      sym__number,
    ACTIONS(2576), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1115), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16285] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(1045), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16359] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2554), 1,
      sym_identifier,
    ACTIONS(2556), 1,
      anon_sym_STAR,
    ACTIONS(2558), 1,
      anon_sym_LBRACE,
    ACTIONS(2560), 1,
      anon_sym_typeof,
    ACTIONS(2562), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LBRACK,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2568), 1,
      anon_sym_QMARK,
    ACTIONS(2570), 1,
      anon_sym_AMP,
    ACTIONS(2572), 1,
      anon_sym_PIPE,
    ACTIONS(2578), 1,
      sym_number,
    ACTIONS(2580), 1,
      sym_this,
    ACTIONS(2584), 1,
      sym_readonly,
    ACTIONS(2586), 1,
      anon_sym_infer,
    ACTIONS(2588), 1,
      anon_sym_keyof,
    ACTIONS(2590), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1061), 1,
      sym_nested_type_identifier,
    STATE(1084), 1,
      sym__tuple_type_body,
    STATE(3360), 1,
      sym_type_parameters,
    STATE(3409), 1,
      sym_nested_identifier,
    STATE(3538), 1,
      sym_formal_parameters,
    ACTIONS(2574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2582), 2,
      sym_true,
      sym_false,
    STATE(1093), 2,
      sym_string,
      sym__number,
    ACTIONS(2576), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1116), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16479] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2437), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16599] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2554), 1,
      sym_identifier,
    ACTIONS(2556), 1,
      anon_sym_STAR,
    ACTIONS(2558), 1,
      anon_sym_LBRACE,
    ACTIONS(2560), 1,
      anon_sym_typeof,
    ACTIONS(2562), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LBRACK,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2568), 1,
      anon_sym_QMARK,
    ACTIONS(2570), 1,
      anon_sym_AMP,
    ACTIONS(2572), 1,
      anon_sym_PIPE,
    ACTIONS(2578), 1,
      sym_number,
    ACTIONS(2580), 1,
      sym_this,
    ACTIONS(2584), 1,
      sym_readonly,
    ACTIONS(2586), 1,
      anon_sym_infer,
    ACTIONS(2588), 1,
      anon_sym_keyof,
    ACTIONS(2590), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1061), 1,
      sym_nested_type_identifier,
    STATE(1084), 1,
      sym__tuple_type_body,
    STATE(3360), 1,
      sym_type_parameters,
    STATE(3409), 1,
      sym_nested_identifier,
    STATE(3538), 1,
      sym_formal_parameters,
    ACTIONS(2574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2582), 2,
      sym_true,
      sym_false,
    STATE(1093), 2,
      sym_string,
      sym__number,
    ACTIONS(2576), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1128), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16719] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2776), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16839] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2554), 1,
      sym_identifier,
    ACTIONS(2556), 1,
      anon_sym_STAR,
    ACTIONS(2558), 1,
      anon_sym_LBRACE,
    ACTIONS(2560), 1,
      anon_sym_typeof,
    ACTIONS(2562), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LBRACK,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2568), 1,
      anon_sym_QMARK,
    ACTIONS(2570), 1,
      anon_sym_AMP,
    ACTIONS(2572), 1,
      anon_sym_PIPE,
    ACTIONS(2578), 1,
      sym_number,
    ACTIONS(2580), 1,
      sym_this,
    ACTIONS(2584), 1,
      sym_readonly,
    ACTIONS(2586), 1,
      anon_sym_infer,
    ACTIONS(2588), 1,
      anon_sym_keyof,
    ACTIONS(2590), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1061), 1,
      sym_nested_type_identifier,
    STATE(1084), 1,
      sym__tuple_type_body,
    STATE(3360), 1,
      sym_type_parameters,
    STATE(3409), 1,
      sym_nested_identifier,
    STATE(3538), 1,
      sym_formal_parameters,
    ACTIONS(2574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2582), 2,
      sym_true,
      sym_false,
    STATE(1093), 2,
      sym_string,
      sym__number,
    ACTIONS(2576), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1144), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16959] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2810), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17079] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17147] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2684), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17267] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(438), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17387] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2554), 1,
      sym_identifier,
    ACTIONS(2556), 1,
      anon_sym_STAR,
    ACTIONS(2558), 1,
      anon_sym_LBRACE,
    ACTIONS(2560), 1,
      anon_sym_typeof,
    ACTIONS(2562), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LBRACK,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2568), 1,
      anon_sym_QMARK,
    ACTIONS(2570), 1,
      anon_sym_AMP,
    ACTIONS(2572), 1,
      anon_sym_PIPE,
    ACTIONS(2578), 1,
      sym_number,
    ACTIONS(2580), 1,
      sym_this,
    ACTIONS(2584), 1,
      sym_readonly,
    ACTIONS(2586), 1,
      anon_sym_infer,
    ACTIONS(2588), 1,
      anon_sym_keyof,
    ACTIONS(2590), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1061), 1,
      sym_nested_type_identifier,
    STATE(1084), 1,
      sym__tuple_type_body,
    STATE(3360), 1,
      sym_type_parameters,
    STATE(3409), 1,
      sym_nested_identifier,
    STATE(3538), 1,
      sym_formal_parameters,
    ACTIONS(2574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2582), 2,
      sym_true,
      sym_false,
    STATE(1093), 2,
      sym_string,
      sym__number,
    ACTIONS(2576), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1146), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17507] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2820), 1,
      sym_identifier,
    ACTIONS(2822), 1,
      anon_sym_typeof,
    ACTIONS(2824), 1,
      anon_sym_new,
    ACTIONS(2826), 1,
      anon_sym_QMARK,
    ACTIONS(2828), 1,
      anon_sym_AMP,
    ACTIONS(2830), 1,
      anon_sym_PIPE,
    ACTIONS(2832), 1,
      anon_sym_keyof,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(503), 1,
      sym_nested_type_identifier,
    STATE(3344), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3608), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(518), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17627] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2554), 1,
      sym_identifier,
    ACTIONS(2556), 1,
      anon_sym_STAR,
    ACTIONS(2558), 1,
      anon_sym_LBRACE,
    ACTIONS(2560), 1,
      anon_sym_typeof,
    ACTIONS(2562), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LBRACK,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2568), 1,
      anon_sym_QMARK,
    ACTIONS(2570), 1,
      anon_sym_AMP,
    ACTIONS(2572), 1,
      anon_sym_PIPE,
    ACTIONS(2578), 1,
      sym_number,
    ACTIONS(2580), 1,
      sym_this,
    ACTIONS(2584), 1,
      sym_readonly,
    ACTIONS(2586), 1,
      anon_sym_infer,
    ACTIONS(2588), 1,
      anon_sym_keyof,
    ACTIONS(2590), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1061), 1,
      sym_nested_type_identifier,
    STATE(1084), 1,
      sym__tuple_type_body,
    STATE(3360), 1,
      sym_type_parameters,
    STATE(3409), 1,
      sym_nested_identifier,
    STATE(3538), 1,
      sym_formal_parameters,
    ACTIONS(2574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2582), 2,
      sym_true,
      sym_false,
    STATE(1093), 2,
      sym_string,
      sym__number,
    ACTIONS(2576), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1111), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17747] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2249), 1,
      anon_sym_LT,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2616), 1,
      anon_sym_EQ_GT,
    STATE(1529), 1,
      sym_type_arguments,
    STATE(1639), 1,
      sym_arguments,
    ACTIONS(2277), 11,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2273), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17831] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2920), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17951] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2820), 1,
      sym_identifier,
    ACTIONS(2822), 1,
      anon_sym_typeof,
    ACTIONS(2826), 1,
      anon_sym_QMARK,
    ACTIONS(2832), 1,
      anon_sym_keyof,
    ACTIONS(2846), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(503), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3146), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(442), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18071] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2918), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18191] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2820), 1,
      sym_identifier,
    ACTIONS(2822), 1,
      anon_sym_typeof,
    ACTIONS(2824), 1,
      anon_sym_new,
    ACTIONS(2826), 1,
      anon_sym_QMARK,
    ACTIONS(2828), 1,
      anon_sym_AMP,
    ACTIONS(2830), 1,
      anon_sym_PIPE,
    ACTIONS(2832), 1,
      anon_sym_keyof,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(503), 1,
      sym_nested_type_identifier,
    STATE(3344), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3608), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(440), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18311] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2037), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18431] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2820), 1,
      sym_identifier,
    ACTIONS(2822), 1,
      anon_sym_typeof,
    ACTIONS(2824), 1,
      anon_sym_new,
    ACTIONS(2826), 1,
      anon_sym_QMARK,
    ACTIONS(2828), 1,
      anon_sym_AMP,
    ACTIONS(2830), 1,
      anon_sym_PIPE,
    ACTIONS(2832), 1,
      anon_sym_keyof,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(503), 1,
      sym_nested_type_identifier,
    STATE(3344), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3608), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(437), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18551] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2733), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18671] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(459), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18791] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(457), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18911] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2849), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19031] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2396), 1,
      anon_sym_LBRACK,
    ACTIONS(2848), 1,
      sym_this,
    STATE(1516), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3018), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2826), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19151] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(437), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19271] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2820), 1,
      sym_identifier,
    ACTIONS(2822), 1,
      anon_sym_typeof,
    ACTIONS(2824), 1,
      anon_sym_new,
    ACTIONS(2826), 1,
      anon_sym_QMARK,
    ACTIONS(2828), 1,
      anon_sym_AMP,
    ACTIONS(2830), 1,
      anon_sym_PIPE,
    ACTIONS(2832), 1,
      anon_sym_keyof,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(503), 1,
      sym_nested_type_identifier,
    STATE(3344), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3608), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(438), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19391] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1113), 1,
      sym_this,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(2090), 1,
      sym__tuple_type_body,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3018), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2869), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19511] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 1,
      anon_sym_EQ,
    ACTIONS(1189), 1,
      anon_sym_EQ_GT,
    ACTIONS(1191), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1229), 1,
      anon_sym_extends,
    ACTIONS(1741), 1,
      anon_sym_LBRACK,
    ACTIONS(1743), 1,
      anon_sym_DOT,
    ACTIONS(2368), 1,
      anon_sym_COMMA,
    ACTIONS(2371), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(893), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19593] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(440), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19713] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2845), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19833] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2846), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3140), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(442), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19953] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2820), 1,
      sym_identifier,
    ACTIONS(2822), 1,
      anon_sym_typeof,
    ACTIONS(2824), 1,
      anon_sym_new,
    ACTIONS(2826), 1,
      anon_sym_QMARK,
    ACTIONS(2828), 1,
      anon_sym_AMP,
    ACTIONS(2830), 1,
      anon_sym_PIPE,
    ACTIONS(2832), 1,
      anon_sym_keyof,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(503), 1,
      sym_nested_type_identifier,
    STATE(3344), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3608), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(523), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20073] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2233), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20193] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2462), 1,
      anon_sym_STAR,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_typeof,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACK,
    ACTIONS(2472), 1,
      anon_sym_new,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(2476), 1,
      anon_sym_AMP,
    ACTIONS(2478), 1,
      anon_sym_PIPE,
    ACTIONS(2484), 1,
      anon_sym_DQUOTE,
    ACTIONS(2486), 1,
      anon_sym_SQUOTE,
    ACTIONS(2488), 1,
      sym_number,
    ACTIONS(2494), 1,
      sym_readonly,
    ACTIONS(2498), 1,
      anon_sym_infer,
    ACTIONS(2500), 1,
      anon_sym_keyof,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2834), 1,
      sym_identifier,
    ACTIONS(2836), 1,
      sym_this,
    STATE(2143), 1,
      sym_nested_type_identifier,
    STATE(2271), 1,
      sym__tuple_type_body,
    STATE(3350), 1,
      sym_type_parameters,
    STATE(3439), 1,
      sym_nested_identifier,
    STATE(3589), 1,
      sym_formal_parameters,
    ACTIONS(2480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2492), 2,
      sym_true,
      sym_false,
    STATE(2260), 2,
      sym_string,
      sym__number,
    ACTIONS(2482), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2251), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2275), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20313] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2462), 1,
      anon_sym_STAR,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_typeof,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACK,
    ACTIONS(2472), 1,
      anon_sym_new,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(2476), 1,
      anon_sym_AMP,
    ACTIONS(2478), 1,
      anon_sym_PIPE,
    ACTIONS(2484), 1,
      anon_sym_DQUOTE,
    ACTIONS(2486), 1,
      anon_sym_SQUOTE,
    ACTIONS(2488), 1,
      sym_number,
    ACTIONS(2494), 1,
      sym_readonly,
    ACTIONS(2498), 1,
      anon_sym_infer,
    ACTIONS(2500), 1,
      anon_sym_keyof,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2834), 1,
      sym_identifier,
    ACTIONS(2836), 1,
      sym_this,
    STATE(2143), 1,
      sym_nested_type_identifier,
    STATE(2271), 1,
      sym__tuple_type_body,
    STATE(3350), 1,
      sym_type_parameters,
    STATE(3439), 1,
      sym_nested_identifier,
    STATE(3589), 1,
      sym_formal_parameters,
    ACTIONS(2480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2492), 2,
      sym_true,
      sym_false,
    STATE(2260), 2,
      sym_string,
      sym__number,
    ACTIONS(2482), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2247), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2275), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20433] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2462), 1,
      anon_sym_STAR,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_typeof,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACK,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(2484), 1,
      anon_sym_DQUOTE,
    ACTIONS(2486), 1,
      anon_sym_SQUOTE,
    ACTIONS(2488), 1,
      sym_number,
    ACTIONS(2494), 1,
      sym_readonly,
    ACTIONS(2500), 1,
      anon_sym_keyof,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2834), 1,
      sym_identifier,
    ACTIONS(2850), 1,
      sym_this,
    STATE(2143), 1,
      sym_nested_type_identifier,
    STATE(2271), 1,
      sym__tuple_type_body,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3439), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(2480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2492), 2,
      sym_true,
      sym_false,
    STATE(2260), 2,
      sym_string,
      sym__number,
    ACTIONS(2482), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3143), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2254), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20553] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      anon_sym_DQUOTE,
    ACTIONS(577), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_STAR,
    ACTIONS(2508), 1,
      anon_sym_LBRACE,
    ACTIONS(2510), 1,
      anon_sym_typeof,
    ACTIONS(2512), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACK,
    ACTIONS(2516), 1,
      anon_sym_new,
    ACTIONS(2518), 1,
      anon_sym_QMARK,
    ACTIONS(2520), 1,
      anon_sym_AMP,
    ACTIONS(2522), 1,
      anon_sym_PIPE,
    ACTIONS(2528), 1,
      sym_number,
    ACTIONS(2530), 1,
      sym_this,
    ACTIONS(2534), 1,
      sym_readonly,
    ACTIONS(2536), 1,
      anon_sym_infer,
    ACTIONS(2538), 1,
      anon_sym_keyof,
    ACTIONS(2540), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1533), 1,
      sym_nested_type_identifier,
    STATE(1662), 1,
      sym__tuple_type_body,
    STATE(3342), 1,
      sym_type_parameters,
    STATE(3447), 1,
      sym_nested_identifier,
    STATE(3632), 1,
      sym_formal_parameters,
    ACTIONS(2524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2532), 2,
      sym_true,
      sym_false,
    STATE(1621), 2,
      sym_string,
      sym__number,
    ACTIONS(2526), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1688), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1674), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20673] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      anon_sym_DQUOTE,
    ACTIONS(577), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_STAR,
    ACTIONS(2508), 1,
      anon_sym_LBRACE,
    ACTIONS(2510), 1,
      anon_sym_typeof,
    ACTIONS(2512), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACK,
    ACTIONS(2516), 1,
      anon_sym_new,
    ACTIONS(2518), 1,
      anon_sym_QMARK,
    ACTIONS(2520), 1,
      anon_sym_AMP,
    ACTIONS(2522), 1,
      anon_sym_PIPE,
    ACTIONS(2528), 1,
      sym_number,
    ACTIONS(2530), 1,
      sym_this,
    ACTIONS(2534), 1,
      sym_readonly,
    ACTIONS(2536), 1,
      anon_sym_infer,
    ACTIONS(2538), 1,
      anon_sym_keyof,
    ACTIONS(2540), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1533), 1,
      sym_nested_type_identifier,
    STATE(1662), 1,
      sym__tuple_type_body,
    STATE(3342), 1,
      sym_type_parameters,
    STATE(3447), 1,
      sym_nested_identifier,
    STATE(3632), 1,
      sym_formal_parameters,
    ACTIONS(2524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2532), 2,
      sym_true,
      sym_false,
    STATE(1621), 2,
      sym_string,
      sym__number,
    ACTIONS(2526), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1570), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1674), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20793] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      anon_sym_DQUOTE,
    ACTIONS(577), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_STAR,
    ACTIONS(2508), 1,
      anon_sym_LBRACE,
    ACTIONS(2510), 1,
      anon_sym_typeof,
    ACTIONS(2512), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACK,
    ACTIONS(2516), 1,
      anon_sym_new,
    ACTIONS(2518), 1,
      anon_sym_QMARK,
    ACTIONS(2520), 1,
      anon_sym_AMP,
    ACTIONS(2522), 1,
      anon_sym_PIPE,
    ACTIONS(2528), 1,
      sym_number,
    ACTIONS(2530), 1,
      sym_this,
    ACTIONS(2534), 1,
      sym_readonly,
    ACTIONS(2536), 1,
      anon_sym_infer,
    ACTIONS(2538), 1,
      anon_sym_keyof,
    ACTIONS(2540), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1533), 1,
      sym_nested_type_identifier,
    STATE(1662), 1,
      sym__tuple_type_body,
    STATE(3342), 1,
      sym_type_parameters,
    STATE(3447), 1,
      sym_nested_identifier,
    STATE(3632), 1,
      sym_formal_parameters,
    ACTIONS(2524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2532), 2,
      sym_true,
      sym_false,
    STATE(1621), 2,
      sym_string,
      sym__number,
    ACTIONS(2526), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1578), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1674), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20913] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2215), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21033] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2514), 1,
      anon_sym_LBRACK,
    ACTIONS(2852), 1,
      sym_this,
    STATE(1563), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3018), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2804), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21153] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2096), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21273] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2848), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21393] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2207), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21513] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2884), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21633] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2093), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21753] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2892), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21873] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1332), 1,
      anon_sym_COLON,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2378), 1,
      anon_sym_EQ_GT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2382), 1,
      anon_sym_EQ,
    ACTIONS(1045), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21951] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      anon_sym_DQUOTE,
    ACTIONS(577), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_STAR,
    ACTIONS(2508), 1,
      anon_sym_LBRACE,
    ACTIONS(2510), 1,
      anon_sym_typeof,
    ACTIONS(2512), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACK,
    ACTIONS(2516), 1,
      anon_sym_new,
    ACTIONS(2518), 1,
      anon_sym_QMARK,
    ACTIONS(2520), 1,
      anon_sym_AMP,
    ACTIONS(2522), 1,
      anon_sym_PIPE,
    ACTIONS(2528), 1,
      sym_number,
    ACTIONS(2530), 1,
      sym_this,
    ACTIONS(2534), 1,
      sym_readonly,
    ACTIONS(2536), 1,
      anon_sym_infer,
    ACTIONS(2538), 1,
      anon_sym_keyof,
    ACTIONS(2540), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1533), 1,
      sym_nested_type_identifier,
    STATE(1662), 1,
      sym__tuple_type_body,
    STATE(3342), 1,
      sym_type_parameters,
    STATE(3447), 1,
      sym_nested_identifier,
    STATE(3632), 1,
      sym_formal_parameters,
    ACTIONS(2524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2532), 2,
      sym_true,
      sym_false,
    STATE(1621), 2,
      sym_string,
      sym__number,
    ACTIONS(2526), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1600), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1674), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22071] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2245), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22191] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2284), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2304), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22375] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2386), 1,
      sym_identifier,
    ACTIONS(2388), 1,
      anon_sym_STAR,
    ACTIONS(2390), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      anon_sym_typeof,
    ACTIONS(2394), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_LBRACK,
    ACTIONS(2398), 1,
      anon_sym_new,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      anon_sym_AMP,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      sym_number,
    ACTIONS(2412), 1,
      sym_this,
    ACTIONS(2416), 1,
      sym_readonly,
    ACTIONS(2418), 1,
      anon_sym_infer,
    ACTIONS(2420), 1,
      anon_sym_keyof,
    ACTIONS(2422), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1304), 1,
      sym_nested_type_identifier,
    STATE(1555), 1,
      sym__tuple_type_body,
    STATE(3238), 1,
      sym_type_parameters,
    STATE(3571), 1,
      sym_nested_identifier,
    STATE(3670), 1,
      sym_formal_parameters,
    ACTIONS(2406), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2414), 2,
      sym_true,
      sym_false,
    STATE(1554), 2,
      sym_string,
      sym__number,
    ACTIONS(2408), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1477), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1414), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22495] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2691), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22615] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2123), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22735] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2386), 1,
      sym_identifier,
    ACTIONS(2388), 1,
      anon_sym_STAR,
    ACTIONS(2390), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      anon_sym_typeof,
    ACTIONS(2394), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_LBRACK,
    ACTIONS(2398), 1,
      anon_sym_new,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      anon_sym_AMP,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      sym_number,
    ACTIONS(2412), 1,
      sym_this,
    ACTIONS(2416), 1,
      sym_readonly,
    ACTIONS(2418), 1,
      anon_sym_infer,
    ACTIONS(2420), 1,
      anon_sym_keyof,
    ACTIONS(2422), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1304), 1,
      sym_nested_type_identifier,
    STATE(1555), 1,
      sym__tuple_type_body,
    STATE(3238), 1,
      sym_type_parameters,
    STATE(3571), 1,
      sym_nested_identifier,
    STATE(3670), 1,
      sym_formal_parameters,
    ACTIONS(2406), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2414), 2,
      sym_true,
      sym_false,
    STATE(1554), 2,
      sym_string,
      sym__number,
    ACTIONS(2408), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1476), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1414), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22855] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2386), 1,
      sym_identifier,
    ACTIONS(2388), 1,
      anon_sym_STAR,
    ACTIONS(2390), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      anon_sym_typeof,
    ACTIONS(2394), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_LBRACK,
    ACTIONS(2398), 1,
      anon_sym_new,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      anon_sym_AMP,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      sym_number,
    ACTIONS(2412), 1,
      sym_this,
    ACTIONS(2416), 1,
      sym_readonly,
    ACTIONS(2418), 1,
      anon_sym_infer,
    ACTIONS(2420), 1,
      anon_sym_keyof,
    ACTIONS(2422), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1304), 1,
      sym_nested_type_identifier,
    STATE(1555), 1,
      sym__tuple_type_body,
    STATE(3238), 1,
      sym_type_parameters,
    STATE(3571), 1,
      sym_nested_identifier,
    STATE(3670), 1,
      sym_formal_parameters,
    ACTIONS(2406), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2414), 2,
      sym_true,
      sym_false,
    STATE(1554), 2,
      sym_string,
      sym__number,
    ACTIONS(2408), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1475), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1414), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22975] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      anon_sym_DQUOTE,
    ACTIONS(577), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_STAR,
    ACTIONS(2508), 1,
      anon_sym_LBRACE,
    ACTIONS(2510), 1,
      anon_sym_typeof,
    ACTIONS(2512), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACK,
    ACTIONS(2516), 1,
      anon_sym_new,
    ACTIONS(2518), 1,
      anon_sym_QMARK,
    ACTIONS(2520), 1,
      anon_sym_AMP,
    ACTIONS(2522), 1,
      anon_sym_PIPE,
    ACTIONS(2528), 1,
      sym_number,
    ACTIONS(2530), 1,
      sym_this,
    ACTIONS(2534), 1,
      sym_readonly,
    ACTIONS(2536), 1,
      anon_sym_infer,
    ACTIONS(2538), 1,
      anon_sym_keyof,
    ACTIONS(2540), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1533), 1,
      sym_nested_type_identifier,
    STATE(1662), 1,
      sym__tuple_type_body,
    STATE(3342), 1,
      sym_type_parameters,
    STATE(3447), 1,
      sym_nested_identifier,
    STATE(3632), 1,
      sym_formal_parameters,
    ACTIONS(2524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2532), 2,
      sym_true,
      sym_false,
    STATE(1621), 2,
      sym_string,
      sym__number,
    ACTIONS(2526), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1640), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1674), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23095] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2935), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23215] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2337), 1,
      anon_sym_DOT,
    ACTIONS(1543), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2334), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2327), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 29,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23287] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2394), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23407] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2102), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23527] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1332), 1,
      anon_sym_COLON,
    ACTIONS(893), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23605] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2916), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23725] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2395), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23845] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2895), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [23965] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      anon_sym_DQUOTE,
    ACTIONS(577), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_STAR,
    ACTIONS(2508), 1,
      anon_sym_LBRACE,
    ACTIONS(2510), 1,
      anon_sym_typeof,
    ACTIONS(2512), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACK,
    ACTIONS(2516), 1,
      anon_sym_new,
    ACTIONS(2518), 1,
      anon_sym_QMARK,
    ACTIONS(2520), 1,
      anon_sym_AMP,
    ACTIONS(2522), 1,
      anon_sym_PIPE,
    ACTIONS(2528), 1,
      sym_number,
    ACTIONS(2530), 1,
      sym_this,
    ACTIONS(2534), 1,
      sym_readonly,
    ACTIONS(2536), 1,
      anon_sym_infer,
    ACTIONS(2538), 1,
      anon_sym_keyof,
    ACTIONS(2540), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1533), 1,
      sym_nested_type_identifier,
    STATE(1662), 1,
      sym__tuple_type_body,
    STATE(3342), 1,
      sym_type_parameters,
    STATE(3447), 1,
      sym_nested_identifier,
    STATE(3632), 1,
      sym_formal_parameters,
    ACTIONS(2524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2532), 2,
      sym_true,
      sym_false,
    STATE(1621), 2,
      sym_string,
      sym__number,
    ACTIONS(2526), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1612), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1674), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24085] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2405), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24205] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(1173), 1,
      anon_sym_EQ_GT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2249), 1,
      anon_sym_LT,
    STATE(1530), 1,
      sym_type_arguments,
    STATE(1636), 1,
      sym_arguments,
    ACTIONS(1695), 11,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1693), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2203), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24353] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2462), 1,
      anon_sym_STAR,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_typeof,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACK,
    ACTIONS(2472), 1,
      anon_sym_new,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(2476), 1,
      anon_sym_AMP,
    ACTIONS(2478), 1,
      anon_sym_PIPE,
    ACTIONS(2484), 1,
      anon_sym_DQUOTE,
    ACTIONS(2486), 1,
      anon_sym_SQUOTE,
    ACTIONS(2488), 1,
      sym_number,
    ACTIONS(2494), 1,
      sym_readonly,
    ACTIONS(2498), 1,
      anon_sym_infer,
    ACTIONS(2500), 1,
      anon_sym_keyof,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2834), 1,
      sym_identifier,
    ACTIONS(2836), 1,
      sym_this,
    STATE(2143), 1,
      sym_nested_type_identifier,
    STATE(2271), 1,
      sym__tuple_type_body,
    STATE(3350), 1,
      sym_type_parameters,
    STATE(3439), 1,
      sym_nested_identifier,
    STATE(3589), 1,
      sym_formal_parameters,
    ACTIONS(2480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2492), 2,
      sym_true,
      sym_false,
    STATE(2260), 2,
      sym_string,
      sym__number,
    ACTIONS(2482), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2360), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2275), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24473] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      anon_sym_DQUOTE,
    ACTIONS(577), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_STAR,
    ACTIONS(2508), 1,
      anon_sym_LBRACE,
    ACTIONS(2510), 1,
      anon_sym_typeof,
    ACTIONS(2512), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACK,
    ACTIONS(2516), 1,
      anon_sym_new,
    ACTIONS(2518), 1,
      anon_sym_QMARK,
    ACTIONS(2520), 1,
      anon_sym_AMP,
    ACTIONS(2522), 1,
      anon_sym_PIPE,
    ACTIONS(2528), 1,
      sym_number,
    ACTIONS(2530), 1,
      sym_this,
    ACTIONS(2534), 1,
      sym_readonly,
    ACTIONS(2536), 1,
      anon_sym_infer,
    ACTIONS(2538), 1,
      anon_sym_keyof,
    ACTIONS(2540), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1533), 1,
      sym_nested_type_identifier,
    STATE(1662), 1,
      sym__tuple_type_body,
    STATE(3342), 1,
      sym_type_parameters,
    STATE(3447), 1,
      sym_nested_identifier,
    STATE(3632), 1,
      sym_formal_parameters,
    ACTIONS(2524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2532), 2,
      sym_true,
      sym_false,
    STATE(1621), 2,
      sym_string,
      sym__number,
    ACTIONS(2526), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1633), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1674), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24593] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2111), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24713] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2851), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24833] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2917), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [24953] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2386), 1,
      sym_identifier,
    ACTIONS(2388), 1,
      anon_sym_STAR,
    ACTIONS(2390), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      anon_sym_typeof,
    ACTIONS(2394), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_LBRACK,
    ACTIONS(2398), 1,
      anon_sym_new,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      anon_sym_AMP,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      sym_number,
    ACTIONS(2412), 1,
      sym_this,
    ACTIONS(2416), 1,
      sym_readonly,
    ACTIONS(2418), 1,
      anon_sym_infer,
    ACTIONS(2420), 1,
      anon_sym_keyof,
    ACTIONS(2422), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1304), 1,
      sym_nested_type_identifier,
    STATE(1555), 1,
      sym__tuple_type_body,
    STATE(3238), 1,
      sym_type_parameters,
    STATE(3571), 1,
      sym_nested_identifier,
    STATE(3670), 1,
      sym_formal_parameters,
    ACTIONS(2406), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2414), 2,
      sym_true,
      sym_false,
    STATE(1554), 2,
      sym_string,
      sym__number,
    ACTIONS(2408), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1442), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1414), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25073] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2386), 1,
      sym_identifier,
    ACTIONS(2388), 1,
      anon_sym_STAR,
    ACTIONS(2390), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      anon_sym_typeof,
    ACTIONS(2394), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_LBRACK,
    ACTIONS(2398), 1,
      anon_sym_new,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      anon_sym_AMP,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      sym_number,
    ACTIONS(2412), 1,
      sym_this,
    ACTIONS(2416), 1,
      sym_readonly,
    ACTIONS(2418), 1,
      anon_sym_infer,
    ACTIONS(2420), 1,
      anon_sym_keyof,
    ACTIONS(2422), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1304), 1,
      sym_nested_type_identifier,
    STATE(1555), 1,
      sym__tuple_type_body,
    STATE(3238), 1,
      sym_type_parameters,
    STATE(3571), 1,
      sym_nested_identifier,
    STATE(3670), 1,
      sym_formal_parameters,
    ACTIONS(2406), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2414), 2,
      sym_true,
      sym_false,
    STATE(1554), 2,
      sym_string,
      sym__number,
    ACTIONS(2408), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1438), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1414), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25193] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2422), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25313] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2029), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25433] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2334), 1,
      anon_sym_LT,
    ACTIONS(1059), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2337), 2,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2350), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2327), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 29,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25505] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2912), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25625] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_EQ,
    ACTIONS(877), 1,
      anon_sym_EQ_GT,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1229), 1,
      anon_sym_extends,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1789), 1,
      anon_sym_QMARK,
    ACTIONS(2854), 1,
      anon_sym_RPAREN,
    ACTIONS(864), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2371), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(893), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25711] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2911), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [25831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2323), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2325), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25895] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2470), 1,
      anon_sym_LBRACK,
    ACTIONS(2858), 1,
      sym_this,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(2248), 1,
      sym__tuple_type_body,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3018), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2809), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26015] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2103), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26135] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2107), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26255] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2672), 1,
      anon_sym_EQ_GT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_EQ,
    ACTIONS(2805), 1,
      anon_sym_LT,
    ACTIONS(2808), 1,
      anon_sym_DOT,
    ACTIONS(2860), 1,
      anon_sym_LBRACE,
    STATE(3040), 1,
      sym_type_arguments,
    ACTIONS(2862), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26339] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2464), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26459] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(459), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26579] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2108), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26699] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2859), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [26819] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1543), 1,
      anon_sym_extends,
    ACTIONS(2337), 1,
      anon_sym_DOT,
    ACTIONS(2331), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2334), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2327), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26891] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2820), 1,
      sym_identifier,
    ACTIONS(2822), 1,
      anon_sym_typeof,
    ACTIONS(2824), 1,
      anon_sym_new,
    ACTIONS(2826), 1,
      anon_sym_QMARK,
    ACTIONS(2828), 1,
      anon_sym_AMP,
    ACTIONS(2830), 1,
      anon_sym_PIPE,
    ACTIONS(2832), 1,
      anon_sym_keyof,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(503), 1,
      sym_nested_type_identifier,
    STATE(3344), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3608), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(449), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27011] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(457), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27131] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2565), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27251] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2378), 1,
      anon_sym_EQ_GT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2382), 1,
      anon_sym_EQ,
    ACTIONS(2864), 1,
      anon_sym_in,
    ACTIONS(2867), 1,
      anon_sym_of,
    ACTIONS(1045), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27331] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2445), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27451] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2523), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27571] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(893), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27647] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2586), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27767] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2908), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [27887] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2799), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28007] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2462), 1,
      anon_sym_STAR,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_typeof,
    ACTIONS(2468), 1,
      anon_sym_LPAREN,
    ACTIONS(2470), 1,
      anon_sym_LBRACK,
    ACTIONS(2472), 1,
      anon_sym_new,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(2476), 1,
      anon_sym_AMP,
    ACTIONS(2478), 1,
      anon_sym_PIPE,
    ACTIONS(2484), 1,
      anon_sym_DQUOTE,
    ACTIONS(2486), 1,
      anon_sym_SQUOTE,
    ACTIONS(2488), 1,
      sym_number,
    ACTIONS(2494), 1,
      sym_readonly,
    ACTIONS(2498), 1,
      anon_sym_infer,
    ACTIONS(2500), 1,
      anon_sym_keyof,
    ACTIONS(2502), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2834), 1,
      sym_identifier,
    ACTIONS(2836), 1,
      sym_this,
    STATE(2143), 1,
      sym_nested_type_identifier,
    STATE(2271), 1,
      sym__tuple_type_body,
    STATE(3350), 1,
      sym_type_parameters,
    STATE(3439), 1,
      sym_nested_identifier,
    STATE(3589), 1,
      sym_formal_parameters,
    ACTIONS(2480), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2492), 2,
      sym_true,
      sym_false,
    STATE(2260), 2,
      sym_string,
      sym__number,
    ACTIONS(2482), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2375), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2275), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28127] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2601), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28247] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    ACTIONS(2869), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1045), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28325] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2462), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28445] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2386), 1,
      sym_identifier,
    ACTIONS(2388), 1,
      anon_sym_STAR,
    ACTIONS(2390), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      anon_sym_typeof,
    ACTIONS(2394), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_LBRACK,
    ACTIONS(2398), 1,
      anon_sym_new,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      anon_sym_AMP,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      sym_number,
    ACTIONS(2412), 1,
      sym_this,
    ACTIONS(2416), 1,
      sym_readonly,
    ACTIONS(2418), 1,
      anon_sym_infer,
    ACTIONS(2420), 1,
      anon_sym_keyof,
    ACTIONS(2422), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1304), 1,
      sym_nested_type_identifier,
    STATE(1555), 1,
      sym__tuple_type_body,
    STATE(3238), 1,
      sym_type_parameters,
    STATE(3571), 1,
      sym_nested_identifier,
    STATE(3670), 1,
      sym_formal_parameters,
    ACTIONS(2406), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2414), 2,
      sym_true,
      sym_false,
    STATE(1554), 2,
      sym_string,
      sym__number,
    ACTIONS(2408), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1426), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1414), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28565] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2261), 1,
      anon_sym_LT,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    STATE(1707), 1,
      sym_type_arguments,
    STATE(1746), 1,
      sym_arguments,
    ACTIONS(2277), 11,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2273), 22,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28647] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2378), 1,
      anon_sym_EQ_GT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2382), 1,
      anon_sym_EQ,
    ACTIONS(2871), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1045), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28725] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2846), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3018), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(442), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28845] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_DQUOTE,
    ACTIONS(83), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2386), 1,
      sym_identifier,
    ACTIONS(2388), 1,
      anon_sym_STAR,
    ACTIONS(2390), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      anon_sym_typeof,
    ACTIONS(2394), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_LBRACK,
    ACTIONS(2398), 1,
      anon_sym_new,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      anon_sym_AMP,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2410), 1,
      sym_number,
    ACTIONS(2412), 1,
      sym_this,
    ACTIONS(2416), 1,
      sym_readonly,
    ACTIONS(2418), 1,
      anon_sym_infer,
    ACTIONS(2420), 1,
      anon_sym_keyof,
    ACTIONS(2422), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1304), 1,
      sym_nested_type_identifier,
    STATE(1555), 1,
      sym__tuple_type_body,
    STATE(3238), 1,
      sym_type_parameters,
    STATE(3571), 1,
      sym_nested_identifier,
    STATE(3670), 1,
      sym_formal_parameters,
    ACTIONS(2406), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2414), 2,
      sym_true,
      sym_false,
    STATE(1554), 2,
      sym_string,
      sym__number,
    ACTIONS(2408), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1421), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1414), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [28965] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(440), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [29085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2364), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [29149] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      anon_sym_COLON,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2378), 1,
      anon_sym_EQ_GT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2382), 1,
      anon_sym_EQ,
    ACTIONS(1045), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [29227] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1171), 1,
      anon_sym_EQ,
    ACTIONS(1173), 1,
      anon_sym_EQ_GT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1229), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2371), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(893), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [29307] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1358), 1,
      anon_sym_COLON,
    ACTIONS(893), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [29385] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2134), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [29505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2344), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [29569] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    ACTIONS(2820), 1,
      sym_identifier,
    ACTIONS(2822), 1,
      anon_sym_typeof,
    ACTIONS(2824), 1,
      anon_sym_new,
    ACTIONS(2826), 1,
      anon_sym_QMARK,
    ACTIONS(2828), 1,
      anon_sym_AMP,
    ACTIONS(2830), 1,
      anon_sym_PIPE,
    ACTIONS(2832), 1,
      anon_sym_keyof,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(503), 1,
      sym_nested_type_identifier,
    STATE(3344), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3608), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [29689] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2471), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [29809] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(963), 1,
      anon_sym_EQ,
    ACTIONS(969), 1,
      anon_sym_EQ_GT,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(1374), 1,
      anon_sym_COLON,
    ACTIONS(893), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [29887] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2667), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [30007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2346), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2348), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [30071] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    ACTIONS(2876), 1,
      anon_sym_COLON,
    ACTIONS(2873), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30151] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_COLON,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2378), 1,
      anon_sym_EQ_GT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2382), 1,
      anon_sym_EQ,
    ACTIONS(1045), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [30229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2358), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2360), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [30293] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2856), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [30413] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(437), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [30533] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2554), 1,
      sym_identifier,
    ACTIONS(2556), 1,
      anon_sym_STAR,
    ACTIONS(2558), 1,
      anon_sym_LBRACE,
    ACTIONS(2560), 1,
      anon_sym_typeof,
    ACTIONS(2562), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LBRACK,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2568), 1,
      anon_sym_QMARK,
    ACTIONS(2570), 1,
      anon_sym_AMP,
    ACTIONS(2572), 1,
      anon_sym_PIPE,
    ACTIONS(2578), 1,
      sym_number,
    ACTIONS(2580), 1,
      sym_this,
    ACTIONS(2584), 1,
      sym_readonly,
    ACTIONS(2586), 1,
      anon_sym_infer,
    ACTIONS(2588), 1,
      anon_sym_keyof,
    ACTIONS(2590), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1061), 1,
      sym_nested_type_identifier,
    STATE(1084), 1,
      sym__tuple_type_body,
    STATE(3360), 1,
      sym_type_parameters,
    STATE(3409), 1,
      sym_nested_identifier,
    STATE(3538), 1,
      sym_formal_parameters,
    ACTIONS(2574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2582), 2,
      sym_true,
      sym_false,
    STATE(1093), 2,
      sym_string,
      sym__number,
    ACTIONS(2576), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1152), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [30653] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2554), 1,
      sym_identifier,
    ACTIONS(2556), 1,
      anon_sym_STAR,
    ACTIONS(2558), 1,
      anon_sym_LBRACE,
    ACTIONS(2560), 1,
      anon_sym_typeof,
    ACTIONS(2562), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LBRACK,
    ACTIONS(2566), 1,
      anon_sym_new,
    ACTIONS(2568), 1,
      anon_sym_QMARK,
    ACTIONS(2570), 1,
      anon_sym_AMP,
    ACTIONS(2572), 1,
      anon_sym_PIPE,
    ACTIONS(2578), 1,
      sym_number,
    ACTIONS(2580), 1,
      sym_this,
    ACTIONS(2584), 1,
      sym_readonly,
    ACTIONS(2586), 1,
      anon_sym_infer,
    ACTIONS(2588), 1,
      anon_sym_keyof,
    ACTIONS(2590), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1061), 1,
      sym_nested_type_identifier,
    STATE(1084), 1,
      sym__tuple_type_body,
    STATE(3360), 1,
      sym_type_parameters,
    STATE(3409), 1,
      sym_nested_identifier,
    STATE(3538), 1,
      sym_formal_parameters,
    ACTIONS(2574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2582), 2,
      sym_true,
      sym_false,
    STATE(1093), 2,
      sym_string,
      sym__number,
    ACTIONS(2576), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1151), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1123), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [30773] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(501), 1,
      anon_sym_DQUOTE,
    ACTIONS(503), 1,
      anon_sym_SQUOTE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2554), 1,
      sym_identifier,
    ACTIONS(2556), 1,
      anon_sym_STAR,
    ACTIONS(2558), 1,
      anon_sym_LBRACE,
    ACTIONS(2560), 1,
      anon_sym_typeof,
    ACTIONS(2562), 1,
      anon_sym_LPAREN,
    ACTIONS(2564), 1,
      anon_sym_LBRACK,
    ACTIONS(2568), 1,
      anon_sym_QMARK,
    ACTIONS(2578), 1,
      sym_number,
    ACTIONS(2584), 1,
      sym_readonly,
    ACTIONS(2588), 1,
      anon_sym_keyof,
    ACTIONS(2590), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2878), 1,
      sym_this,
    STATE(1061), 1,
      sym_nested_type_identifier,
    STATE(1084), 1,
      sym__tuple_type_body,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3409), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(2574), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2582), 2,
      sym_true,
      sym_false,
    STATE(1093), 2,
      sym_string,
      sym__number,
    ACTIONS(2576), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3142), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(1149), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [30893] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(449), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31013] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2353), 1,
      anon_sym_LT,
    ACTIONS(2618), 1,
      anon_sym_EQ,
    ACTIONS(2624), 1,
      anon_sym_DOT,
    ACTIONS(2626), 1,
      anon_sym_EQ_GT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(2862), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [31095] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2030), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31215] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2474), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31335] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2255), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31455] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 1,
      anon_sym_STAR,
    ACTIONS(683), 1,
      anon_sym_QMARK,
    ACTIONS(685), 1,
      anon_sym_AMP,
    ACTIONS(687), 1,
      anon_sym_PIPE,
    ACTIONS(703), 1,
      anon_sym_infer,
    ACTIONS(705), 1,
      anon_sym_keyof,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_new,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2444), 1,
      sym_number,
    ACTIONS(2450), 1,
      sym_readonly,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      sym_this,
    STATE(2053), 1,
      sym_nested_type_identifier,
    STATE(2129), 1,
      sym__tuple_type_body,
    STATE(3381), 1,
      sym_type_parameters,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(3470), 1,
      sym_formal_parameters,
    ACTIONS(2436), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2448), 2,
      sym_true,
      sym_false,
    STATE(2106), 2,
      sym_string,
      sym__number,
    ACTIONS(2438), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2607), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2130), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2219), 33,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [31639] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(438), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31759] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(959), 1,
      sym_this,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    STATE(434), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(3018), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(2823), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31879] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(449), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31999] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(487), 1,
      anon_sym_QMARK,
    ACTIONS(489), 1,
      anon_sym_AMP,
    ACTIONS(491), 1,
      anon_sym_PIPE,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_new,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(901), 1,
      sym_number,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(3565), 1,
      sym_formal_parameters,
    ACTIONS(905), 2,
      sym_true,
      sym_false,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(453), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2863), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32119] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 1,
      anon_sym_STAR,
    ACTIONS(521), 1,
      anon_sym_infer,
    ACTIONS(523), 1,
      anon_sym_keyof,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(561), 1,
      anon_sym_QMARK,
    ACTIONS(563), 1,
      anon_sym_AMP,
    ACTIONS(565), 1,
      anon_sym_PIPE,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(869), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(951), 1,
      sym_identifier,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(961), 1,
      sym_readonly,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2271), 1,
      anon_sym_LBRACK,
    ACTIONS(2596), 1,
      anon_sym_new,
    ACTIONS(2598), 1,
      sym_number,
    ACTIONS(2600), 1,
      sym_this,
    STATE(461), 1,
      sym__tuple_type_body,
    STATE(2023), 1,
      sym_nested_type_identifier,
    STATE(3374), 1,
      sym_type_parameters,
    STATE(3413), 1,
      sym_formal_parameters,
    STATE(3514), 1,
      sym_nested_identifier,
    ACTIONS(1713), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2602), 2,
      sym_true,
      sym_false,
    STATE(2390), 2,
      sym_string,
      sym__number,
    ACTIONS(895), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2477), 6,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    STATE(433), 14,
      sym__primary_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32239] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2382), 1,
      anon_sym_EQ,
    ACTIONS(2864), 1,
      anon_sym_in,
    ACTIONS(2867), 1,
      anon_sym_of,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1045), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [32310] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1543), 1,
      anon_sym_extends,
    ACTIONS(2337), 1,
      anon_sym_DOT,
    ACTIONS(2331), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2334), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2327), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [32381] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(2672), 1,
      anon_sym_EQ_GT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_EQ,
    ACTIONS(1045), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [32456] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACK,
    ACTIONS(2337), 1,
      anon_sym_DOT,
    ACTIONS(1543), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2334), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2327), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [32527] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1543), 1,
      anon_sym_extends,
    ACTIONS(2337), 1,
      anon_sym_DOT,
    ACTIONS(2331), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2334), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2327), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 28,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [32598] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(993), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(893), 13,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [32673] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    ACTIONS(2702), 1,
      anon_sym_EQ,
    ACTIONS(2714), 1,
      anon_sym_QMARK,
    ACTIONS(2705), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [32752] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2618), 1,
      anon_sym_EQ,
    ACTIONS(2626), 1,
      anon_sym_EQ_GT,
    ACTIONS(1045), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [32827] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 1,
      anon_sym_EQ,
    ACTIONS(1189), 1,
      anon_sym_EQ_GT,
    ACTIONS(1191), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1741), 1,
      anon_sym_LBRACK,
    ACTIONS(1743), 1,
      anon_sym_DOT,
    ACTIONS(893), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [32902] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2382), 1,
      anon_sym_EQ,
    ACTIONS(2864), 1,
      anon_sym_in,
    ACTIONS(2867), 1,
      anon_sym_of,
    ACTIONS(1045), 13,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [32979] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(877), 1,
      anon_sym_EQ_GT,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(953), 1,
      anon_sym_EQ,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1792), 1,
      anon_sym_COLON,
    ACTIONS(893), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33056] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_extends,
    ACTIONS(2334), 1,
      anon_sym_LT,
    ACTIONS(2350), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2337), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2327), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 28,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33127] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    ACTIONS(2880), 1,
      anon_sym_in,
    ACTIONS(2882), 1,
      anon_sym_COLON,
    ACTIONS(1045), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33206] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    ACTIONS(2702), 1,
      anon_sym_EQ,
    ACTIONS(2714), 1,
      anon_sym_QMARK,
    ACTIONS(2884), 1,
      anon_sym_COLON,
    ACTIONS(2705), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33287] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2308), 1,
      anon_sym_EQ,
    ACTIONS(2318), 1,
      anon_sym_EQ_GT,
    ACTIONS(2889), 1,
      anon_sym_COLON,
    ACTIONS(2891), 1,
      anon_sym_QMARK,
    ACTIONS(2886), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33368] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2382), 1,
      anon_sym_EQ,
    ACTIONS(1045), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33441] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_EQ,
    ACTIONS(877), 1,
      anon_sym_EQ_GT,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1789), 1,
      anon_sym_QMARK,
    ACTIONS(864), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(893), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2382), 1,
      anon_sym_EQ,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1045), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33587] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_EQ,
    ACTIONS(877), 1,
      anon_sym_EQ_GT,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1789), 1,
      anon_sym_QMARK,
    ACTIONS(1794), 1,
      anon_sym_COLON,
    ACTIONS(864), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(893), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33668] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2334), 1,
      anon_sym_LT,
    ACTIONS(1059), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2337), 2,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2350), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2327), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33739] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_extends,
    ACTIONS(2334), 1,
      anon_sym_LT,
    ACTIONS(2337), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(2350), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2327), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [33810] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1055), 1,
      anon_sym_EQ,
    ACTIONS(1057), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(893), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33885] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2300), 1,
      anon_sym_EQ_GT,
    ACTIONS(1045), 13,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [33960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2344), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [34022] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2337), 1,
      anon_sym_DOT,
    ACTIONS(2331), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2334), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(2327), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34090] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2638), 1,
      anon_sym_STAR,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2648), 1,
      anon_sym_LBRACK,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2656), 1,
      sym_number,
    ACTIONS(2896), 1,
      anon_sym_export,
    ACTIONS(2900), 1,
      anon_sym_async,
    ACTIONS(2902), 1,
      anon_sym_static,
    ACTIONS(2908), 1,
      sym_readonly,
    STATE(1986), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(2898), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2904), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2906), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3309), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2409), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2894), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34210] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2618), 1,
      anon_sym_EQ,
    ACTIONS(1045), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [34282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2327), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [34344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2304), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [34406] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1045), 13,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [34478] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_EQ,
    ACTIONS(1045), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [34550] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2698), 1,
      anon_sym_EQ,
    ACTIONS(1045), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 23,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [34616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2323), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2325), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [34678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2346), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2348), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [34740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2358), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2360), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [34802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2203), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [34864] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1045), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [34930] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2618), 1,
      anon_sym_EQ,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1045), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [34996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2364), 31,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35058] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(993), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1848), 1,
      anon_sym_COLON,
    ACTIONS(893), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [35134] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1171), 1,
      anon_sym_EQ,
    ACTIONS(1173), 1,
      anon_sym_EQ_GT,
    ACTIONS(1281), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DOT,
    ACTIONS(893), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [35208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2219), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [35270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 24,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2364), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [35332] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(2616), 1,
      anon_sym_EQ_GT,
    ACTIONS(1045), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [35406] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2638), 1,
      anon_sym_STAR,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2648), 1,
      anon_sym_LBRACK,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2656), 1,
      sym_number,
    ACTIONS(2896), 1,
      anon_sym_export,
    ACTIONS(2900), 1,
      anon_sym_async,
    ACTIONS(2902), 1,
      anon_sym_static,
    ACTIONS(2908), 1,
      sym_readonly,
    STATE(1986), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(2898), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2904), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2906), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2060), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3309), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2454), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2894), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35526] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(993), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1792), 1,
      anon_sym_COLON,
    ACTIONS(893), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [35602] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2300), 1,
      anon_sym_EQ_GT,
    ACTIONS(2880), 1,
      anon_sym_in,
    ACTIONS(2882), 1,
      anon_sym_COLON,
    ACTIONS(1045), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [35680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2364), 31,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35742] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2334), 1,
      anon_sym_LT,
    ACTIONS(2337), 1,
      anon_sym_DOT,
    ACTIONS(2331), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(2327), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COLON,
    ACTIONS(2362), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2364), 30,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [35874] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2300), 1,
      anon_sym_EQ_GT,
    ACTIONS(2880), 1,
      anon_sym_in,
    ACTIONS(2912), 1,
      anon_sym_COLON,
    ACTIONS(1045), 11,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [35952] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(993), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1770), 1,
      anon_sym_in,
    ACTIONS(2842), 1,
      anon_sym_of,
    ACTIONS(893), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [36029] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2300), 1,
      anon_sym_EQ_GT,
    ACTIONS(2864), 1,
      anon_sym_in,
    ACTIONS(2867), 1,
      anon_sym_of,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [36106] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(1045), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [36177] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 1,
      anon_sym_EQ,
    ACTIONS(1045), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [36242] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(991), 1,
      anon_sym_EQ,
    ACTIONS(993), 1,
      anon_sym_EQ_GT,
    ACTIONS(1697), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_DOT,
    ACTIONS(1854), 1,
      anon_sym_in,
    ACTIONS(2914), 1,
      anon_sym_of,
    ACTIONS(893), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(883), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(860), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [36319] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_in,
    ACTIONS(2296), 1,
      anon_sym_of,
    ACTIONS(2300), 1,
      anon_sym_EQ_GT,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [36396] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2864), 1,
      anon_sym_in,
    ACTIONS(2867), 1,
      anon_sym_of,
    ACTIONS(1045), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [36464] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2293), 1,
      anon_sym_in,
    ACTIONS(2296), 1,
      anon_sym_of,
    ACTIONS(1045), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [36532] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2293), 1,
      anon_sym_in,
    ACTIONS(2296), 1,
      anon_sym_of,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [36606] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_EQ,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2864), 1,
      anon_sym_in,
    ACTIONS(2867), 1,
      anon_sym_of,
    ACTIONS(1045), 10,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2285), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1043), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [36680] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_STAR,
    ACTIONS(2922), 1,
      anon_sym_LBRACE,
    STATE(3250), 1,
      sym_import_clause,
    ACTIONS(2926), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(3253), 2,
      sym_string,
      sym_import_require_clause,
    STATE(3542), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(2920), 15,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(2924), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36755] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1261), 1,
      anon_sym_LBRACE,
    ACTIONS(2928), 1,
      anon_sym_STAR,
    ACTIONS(2930), 1,
      anon_sym_default,
    ACTIONS(2932), 1,
      anon_sym_EQ,
    ACTIONS(2934), 1,
      anon_sym_as,
    ACTIONS(2936), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_type,
    ACTIONS(2942), 1,
      anon_sym_import,
    ACTIONS(2944), 1,
      anon_sym_var,
    ACTIONS(2946), 1,
      anon_sym_let,
    ACTIONS(2948), 1,
      anon_sym_const,
    ACTIONS(2950), 1,
      anon_sym_class,
    ACTIONS(2952), 1,
      anon_sym_async,
    ACTIONS(2954), 1,
      anon_sym_function,
    ACTIONS(2956), 1,
      anon_sym_abstract,
    ACTIONS(2958), 1,
      anon_sym_declare,
    ACTIONS(2960), 1,
      anon_sym_module,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    STATE(1994), 1,
      sym_decorator,
    STATE(2670), 1,
      sym__declaration,
    STATE(2671), 1,
      sym_function_signature,
    STATE(2673), 1,
      sym_internal_module,
    STATE(2769), 1,
      aux_sym_export_statement_repeat1,
    STATE(2937), 1,
      sym_export_clause,
    STATE(2963), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2637), 12,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [36865] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1261), 1,
      anon_sym_LBRACE,
    ACTIONS(2928), 1,
      anon_sym_STAR,
    ACTIONS(2930), 1,
      anon_sym_default,
    ACTIONS(2932), 1,
      anon_sym_EQ,
    ACTIONS(2934), 1,
      anon_sym_as,
    ACTIONS(2936), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_type,
    ACTIONS(2942), 1,
      anon_sym_import,
    ACTIONS(2944), 1,
      anon_sym_var,
    ACTIONS(2946), 1,
      anon_sym_let,
    ACTIONS(2948), 1,
      anon_sym_const,
    ACTIONS(2950), 1,
      anon_sym_class,
    ACTIONS(2952), 1,
      anon_sym_async,
    ACTIONS(2954), 1,
      anon_sym_function,
    ACTIONS(2956), 1,
      anon_sym_abstract,
    ACTIONS(2958), 1,
      anon_sym_declare,
    ACTIONS(2960), 1,
      anon_sym_module,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    STATE(1994), 1,
      sym_decorator,
    STATE(2670), 1,
      sym__declaration,
    STATE(2671), 1,
      sym_function_signature,
    STATE(2673), 1,
      sym_internal_module,
    STATE(2769), 1,
      aux_sym_export_statement_repeat1,
    STATE(2937), 1,
      sym_export_clause,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2637), 12,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [36975] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1261), 1,
      anon_sym_LBRACE,
    ACTIONS(2928), 1,
      anon_sym_STAR,
    ACTIONS(2930), 1,
      anon_sym_default,
    ACTIONS(2932), 1,
      anon_sym_EQ,
    ACTIONS(2934), 1,
      anon_sym_as,
    ACTIONS(2936), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_type,
    ACTIONS(2942), 1,
      anon_sym_import,
    ACTIONS(2944), 1,
      anon_sym_var,
    ACTIONS(2946), 1,
      anon_sym_let,
    ACTIONS(2948), 1,
      anon_sym_const,
    ACTIONS(2950), 1,
      anon_sym_class,
    ACTIONS(2952), 1,
      anon_sym_async,
    ACTIONS(2954), 1,
      anon_sym_function,
    ACTIONS(2956), 1,
      anon_sym_abstract,
    ACTIONS(2958), 1,
      anon_sym_declare,
    ACTIONS(2960), 1,
      anon_sym_module,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    STATE(1994), 1,
      sym_decorator,
    STATE(2670), 1,
      sym__declaration,
    STATE(2671), 1,
      sym_function_signature,
    STATE(2673), 1,
      sym_internal_module,
    STATE(2769), 1,
      aux_sym_export_statement_repeat1,
    STATE(2937), 1,
      sym_export_clause,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2637), 12,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [37085] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2972), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2974), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2404), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37191] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2990), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2992), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2443), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37297] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2747), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2749), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2458), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37403] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2994), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2996), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2421), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37509] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2646), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2666), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2460), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37615] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1261), 1,
      anon_sym_LBRACE,
    ACTIONS(2928), 1,
      anon_sym_STAR,
    ACTIONS(2930), 1,
      anon_sym_default,
    ACTIONS(2932), 1,
      anon_sym_EQ,
    ACTIONS(2934), 1,
      anon_sym_as,
    ACTIONS(2936), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_type,
    ACTIONS(2942), 1,
      anon_sym_import,
    ACTIONS(2944), 1,
      anon_sym_var,
    ACTIONS(2946), 1,
      anon_sym_let,
    ACTIONS(2948), 1,
      anon_sym_const,
    ACTIONS(2950), 1,
      anon_sym_class,
    ACTIONS(2952), 1,
      anon_sym_async,
    ACTIONS(2954), 1,
      anon_sym_function,
    ACTIONS(2956), 1,
      anon_sym_abstract,
    ACTIONS(2958), 1,
      anon_sym_declare,
    ACTIONS(2960), 1,
      anon_sym_module,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    STATE(1994), 1,
      sym_decorator,
    STATE(2670), 1,
      sym__declaration,
    STATE(2671), 1,
      sym_function_signature,
    STATE(2673), 1,
      sym_internal_module,
    STATE(2769), 1,
      aux_sym_export_statement_repeat1,
    STATE(2937), 1,
      sym_export_clause,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2637), 12,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [37725] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2998), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3000), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2510), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37831] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1261), 1,
      anon_sym_LBRACE,
    ACTIONS(2928), 1,
      anon_sym_STAR,
    ACTIONS(2930), 1,
      anon_sym_default,
    ACTIONS(2932), 1,
      anon_sym_EQ,
    ACTIONS(2934), 1,
      anon_sym_as,
    ACTIONS(2936), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_type,
    ACTIONS(2942), 1,
      anon_sym_import,
    ACTIONS(2944), 1,
      anon_sym_var,
    ACTIONS(2946), 1,
      anon_sym_let,
    ACTIONS(2948), 1,
      anon_sym_const,
    ACTIONS(2950), 1,
      anon_sym_class,
    ACTIONS(2952), 1,
      anon_sym_async,
    ACTIONS(2954), 1,
      anon_sym_function,
    ACTIONS(2956), 1,
      anon_sym_abstract,
    ACTIONS(2958), 1,
      anon_sym_declare,
    ACTIONS(2960), 1,
      anon_sym_module,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    STATE(1994), 1,
      sym_decorator,
    STATE(2670), 1,
      sym__declaration,
    STATE(2671), 1,
      sym_function_signature,
    STATE(2673), 1,
      sym_internal_module,
    STATE(2769), 1,
      aux_sym_export_statement_repeat1,
    STATE(2937), 1,
      sym_export_clause,
    ACTIONS(3002), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2938), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2637), 12,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [37940] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1261), 1,
      anon_sym_LBRACE,
    ACTIONS(2928), 1,
      anon_sym_STAR,
    ACTIONS(2930), 1,
      anon_sym_default,
    ACTIONS(2934), 1,
      anon_sym_as,
    ACTIONS(2936), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_type,
    ACTIONS(2942), 1,
      anon_sym_import,
    ACTIONS(2944), 1,
      anon_sym_var,
    ACTIONS(2946), 1,
      anon_sym_let,
    ACTIONS(2948), 1,
      anon_sym_const,
    ACTIONS(2950), 1,
      anon_sym_class,
    ACTIONS(2952), 1,
      anon_sym_async,
    ACTIONS(2954), 1,
      anon_sym_function,
    ACTIONS(2956), 1,
      anon_sym_abstract,
    ACTIONS(2958), 1,
      anon_sym_declare,
    ACTIONS(2960), 1,
      anon_sym_module,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    STATE(1994), 1,
      sym_decorator,
    STATE(2670), 1,
      sym__declaration,
    STATE(2671), 1,
      sym_function_signature,
    STATE(2673), 1,
      sym_internal_module,
    STATE(2769), 1,
      aux_sym_export_statement_repeat1,
    STATE(2937), 1,
      sym_export_clause,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2637), 12,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [38047] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3007), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38149] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3009), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38251] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3011), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38353] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3013), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38455] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3015), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38557] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3017), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38659] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3019), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38761] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3021), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38863] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3023), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [38965] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3025), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [39067] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3027), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [39169] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3029), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [39271] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3031), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [39373] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3033), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [39475] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3035), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [39577] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3037), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [39679] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3039), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [39781] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3041), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [39883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1049), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1047), 31,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [39936] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2245), 1,
      anon_sym_LT,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3043), 1,
      anon_sym_EQ,
    STATE(1120), 1,
      sym_type_arguments,
    STATE(1281), 1,
      sym_arguments,
    ACTIONS(2273), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2277), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40005] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2245), 1,
      anon_sym_LT,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3045), 1,
      anon_sym_EQ,
    STATE(1120), 1,
      sym_type_arguments,
    STATE(1281), 1,
      sym_arguments,
    ACTIONS(2273), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2277), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1163), 31,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [40127] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3047), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3049), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3055), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3059), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3061), 1,
      anon_sym_LT,
    STATE(1165), 1,
      sym_type_arguments,
    ACTIONS(1800), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1798), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3064), 1,
      anon_sym_DOT,
    STATE(1122), 1,
      sym_type_arguments,
    ACTIONS(1623), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40406] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2245), 1,
      anon_sym_LT,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    STATE(1120), 1,
      sym_type_arguments,
    STATE(1281), 1,
      sym_arguments,
    ACTIONS(2273), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2277), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40472] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1677), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1679), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(977), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(979), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40528] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2409), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [40626] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3066), 1,
      anon_sym_LT,
    ACTIONS(3069), 1,
      anon_sym_DOT,
    STATE(1122), 1,
      sym_type_arguments,
    ACTIONS(1761), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1759), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [40684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3071), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3073), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3075), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3077), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40788] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2454), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [40886] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2563), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [40984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3079), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3081), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41036] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_extends,
    ACTIONS(3087), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3090), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3083), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3085), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41094] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2440), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [41192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(979), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41244] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2400), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [41342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_DOT,
    STATE(1122), 1,
      sym_type_arguments,
    ACTIONS(1777), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1775), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [41398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3093), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2910), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41450] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2417), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [41548] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 1,
      anon_sym_EQ,
    ACTIONS(3095), 1,
      sym__automatic_semicolon,
    ACTIONS(975), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(973), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1165), 1,
      sym_type_arguments,
    ACTIONS(1603), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1601), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [41658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3083), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3085), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41710] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(2652), 1,
      anon_sym_new,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2968), 1,
      anon_sym_export,
    ACTIONS(2970), 1,
      anon_sym_STAR,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(2978), 1,
      anon_sym_async,
    ACTIONS(2980), 1,
      sym_number,
    ACTIONS(2982), 1,
      anon_sym_static,
    ACTIONS(2988), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(1994), 1,
      sym_decorator,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2888), 1,
      aux_sym_export_statement_repeat1,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(2984), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2061), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2502), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2966), 10,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [41808] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3107), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3099), 9,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [41895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1675), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1673), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [41946] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3125), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [42041] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3135), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [42114] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_AMP,
    ACTIONS(3144), 1,
      anon_sym_PIPE,
    ACTIONS(3146), 1,
      anon_sym_extends,
    ACTIONS(3138), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3140), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42171] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3150), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42268] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3152), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1557), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1555), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [42372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [42423] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3107), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [42502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1645), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [42553] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_extends,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(3161), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1563), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [42667] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_LBRACE,
    ACTIONS(3166), 1,
      anon_sym_DOT,
    STATE(1244), 1,
      sym_statement_block,
    ACTIONS(985), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(983), 26,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42724] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1798), 1,
      anon_sym_extends,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3168), 1,
      anon_sym_COMMA,
    ACTIONS(3171), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42787] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_LBRACE,
    STATE(1244), 1,
      sym_statement_block,
    ACTIONS(985), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(983), 27,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42842] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3107), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3099), 10,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [42925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1163), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [42976] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(3174), 1,
      anon_sym_EQ,
    ACTIONS(3178), 1,
      anon_sym_in,
    ACTIONS(3181), 1,
      anon_sym_of,
    STATE(2683), 1,
      sym_type_annotation,
    STATE(3074), 1,
      sym__initializer,
    ACTIONS(3176), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1043), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43047] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3135), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3107), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [43124] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3135), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [43195] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3107), 1,
      anon_sym_QMARK,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3099), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [43286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1619), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1617), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [43337] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3183), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3095), 1,
      sym__automatic_semicolon,
    ACTIONS(975), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(973), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43485] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3185), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43580] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1381), 1,
      sym_statement_block,
    ACTIONS(985), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(983), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43635] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    ACTIONS(3189), 1,
      anon_sym_DOT,
    STATE(1381), 1,
      sym_statement_block,
    ACTIONS(985), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(983), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43692] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_AMP,
    ACTIONS(3144), 1,
      anon_sym_PIPE,
    ACTIONS(3146), 1,
      anon_sym_extends,
    ACTIONS(1846), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1844), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43749] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3191), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43844] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3193), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1631), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1629), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [43990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1597), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [44041] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_AMP,
    ACTIONS(3144), 1,
      anon_sym_PIPE,
    ACTIONS(3146), 1,
      anon_sym_extends,
    ACTIONS(1826), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1824), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_AMP,
    ACTIONS(3144), 1,
      anon_sym_PIPE,
    ACTIONS(1840), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1838), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [44153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1627), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1625), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [44204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1229), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [44255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    STATE(1198), 1,
      sym_arguments,
    ACTIONS(3195), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3197), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1651), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1649), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [44361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1551), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [44412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3199), 1,
      anon_sym_LBRACK,
    ACTIONS(1573), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1571), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [44465] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3201), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [44560] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1587), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1583), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1581), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    STATE(1199), 1,
      sym_arguments,
    ACTIONS(3203), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3205), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1049), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1047), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [44721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1633), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [44772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1671), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1669), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [44823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1567), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [44874] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3207), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [44969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1677), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [45020] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3209), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45115] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3211), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45210] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3213), 1,
      anon_sym_LT,
    ACTIONS(1061), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1059), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [45263] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3216), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45358] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3218), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45453] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3220), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3064), 1,
      anon_sym_DOT,
    ACTIONS(1623), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [45601] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3226), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [45670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3229), 1,
      sym__automatic_semicolon,
    ACTIONS(1095), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1093), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45723] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3231), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1585), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [45869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1659), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1657), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [45920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [45971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1667), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1665), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [46022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1805), 1,
      anon_sym_DOT,
    ACTIONS(1545), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1543), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [46075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1615), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1613), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [46126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3199), 1,
      anon_sym_LBRACK,
    ACTIONS(1611), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1609), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [46179] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3233), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [46274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1605), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [46325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1593), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [46376] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1661), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1663), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 24,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1663), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1661), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [46488] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3235), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [46583] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3226), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [46654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1643), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1641), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [46705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1579), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1577), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [46756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1591), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1589), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [46807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1639), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1637), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [46858] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3226), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [46929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1655), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1653), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [46980] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(3237), 1,
      anon_sym_EQ,
    ACTIONS(3241), 1,
      anon_sym_in,
    ACTIONS(3244), 1,
      anon_sym_of,
    STATE(2681), 1,
      sym_type_annotation,
    STATE(3084), 1,
      sym__initializer,
    ACTIONS(3239), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1043), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1603), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1601), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [47102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1547), 29,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
      anon_sym_extends,
  [47153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3246), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3248), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3250), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3252), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47253] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47309] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3258), 1,
      anon_sym_COMMA,
    ACTIONS(3261), 1,
      anon_sym_RBRACE,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3201), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3293), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3295), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3297), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3299), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3301), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3303), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47607] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3305), 1,
      anon_sym_RPAREN,
    ACTIONS(3307), 1,
      anon_sym_COLON,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(3577), 1,
      sym_type_annotation,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1139), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1141), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1155), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1077), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1079), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47857] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3309), 1,
      anon_sym_COMMA,
    ACTIONS(3312), 1,
      anon_sym_RBRACE,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3183), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1069), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3314), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3316), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3318), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3320), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3322), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3324), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48155] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3307), 1,
      anon_sym_COLON,
    ACTIONS(3326), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(3445), 1,
      sym_type_annotation,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3075), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3077), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48305] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    ACTIONS(3331), 1,
      anon_sym_RBRACE,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3185), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3335), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3339), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2920), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2924), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3341), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3343), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48603] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3235), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1107), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1035), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3347), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48847] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3191), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3349), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3351), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1121), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3071), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3073), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3355), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3359), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49191] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3261), 1,
      anon_sym_RBRACE,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3361), 1,
      anon_sym_COMMA,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3218), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3366), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1131), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1013), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1015), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3370), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3372), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3374), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49539] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    STATE(2836), 1,
      sym_type_arguments,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3047), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3049), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49599] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3376), 1,
      anon_sym_LT,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [49667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3379), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3220), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1025), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3381), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3209), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1005), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3207), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3391), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1051), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50067] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2871), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3395), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50165] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3218), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1059), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50309] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3216), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3055), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3423), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3427), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3079), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3081), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(995), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3431), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3433), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3435), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50753] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2249), 1,
      anon_sym_LT,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3045), 1,
      anon_sym_EQ,
    STATE(1529), 1,
      sym_type_arguments,
    STATE(1639), 1,
      sym_arguments,
    ACTIONS(2273), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2277), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3093), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2910), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1089), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3439), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3443), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3445), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3447), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51069] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3449), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3216), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3453), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3457), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51313] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3211), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3459), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3461), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3465), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1095), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1093), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51557] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3193), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51651] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3087), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(1613), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3083), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3085), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3059), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1099), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1097), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51807] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3185), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51901] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3183), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51995] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2249), 1,
      anon_sym_LT,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3043), 1,
      anon_sym_EQ,
    STATE(1529), 1,
      sym_type_arguments,
    STATE(1639), 1,
      sym_arguments,
    ACTIONS(2273), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2277), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1159), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [52111] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3220), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(979), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52255] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3209), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52349] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3107), 1,
      anon_sym_QMARK,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3099), 6,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [52439] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3376), 1,
      anon_sym_LT,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52509] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3467), 1,
      anon_sym_LT,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1145), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [52629] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3207), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52723] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3467), 1,
      anon_sym_LT,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3107), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52799] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3201), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52893] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1677), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(977), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(979), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [52997] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3107), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3099), 8,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [53083] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(2803), 1,
      anon_sym_COMMA,
    ACTIONS(3395), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3474), 1,
      anon_sym_LBRACE,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    STATE(2805), 1,
      sym_type_arguments,
    STATE(2842), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3138), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3140), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53233] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3307), 1,
      anon_sym_COLON,
    ACTIONS(3506), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(3532), 1,
      sym_type_annotation,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3510), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53433] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3376), 1,
      anon_sym_LT,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3514), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3516), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53553] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3099), 9,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [53635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1059), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3518), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3520), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53735] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3125), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3522), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3524), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53879] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3467), 1,
      anon_sym_LT,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53951] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3307), 1,
      anon_sym_COLON,
    ACTIONS(3526), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(3618), 1,
      sym_type_annotation,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54051] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3107), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 14,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [54129] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3233), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54223] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3307), 1,
      anon_sym_COLON,
    ACTIONS(3528), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(3429), 1,
      sym_type_annotation,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3530), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3532), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [54373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3534), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3536), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [54423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3538), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3540), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [54473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3083), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3085), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54523] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3231), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54617] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3542), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54710] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3544), 1,
      anon_sym_LBRACE,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3231), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54805] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3546), 1,
      anon_sym_LT,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [54872] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3387), 1,
      anon_sym_LBRACE,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3207), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54967] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3381), 1,
      anon_sym_LBRACE,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3209), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55062] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3549), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(2967), 1,
      aux_sym_array_repeat1,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55159] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3551), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [55230] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3554), 1,
      anon_sym_COMMA,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3556), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55325] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3554), 1,
      anon_sym_COMMA,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3558), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55420] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3560), 1,
      anon_sym_COMMA,
    ACTIONS(3562), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(2967), 1,
      aux_sym_array_repeat1,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55517] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3564), 1,
      anon_sym_LBRACE,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3201), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55612] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3554), 1,
      anon_sym_COMMA,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3150), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55707] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3566), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(3002), 1,
      aux_sym_array_repeat1,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55804] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3568), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(2967), 1,
      aux_sym_array_repeat1,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55901] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3158), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3161), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1645), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1043), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55962] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3168), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3171), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1798), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1043), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56023] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2261), 1,
      anon_sym_LT,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3043), 1,
      anon_sym_EQ,
    STATE(1707), 1,
      sym_type_arguments,
    STATE(1746), 1,
      sym_arguments,
    ACTIONS(2273), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2277), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [56088] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3570), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(3014), 1,
      aux_sym_array_repeat1,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56185] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3379), 1,
      anon_sym_LBRACE,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3220), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56280] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3572), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(3037), 1,
      aux_sym_array_repeat1,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3574), 1,
      anon_sym_LT,
    STATE(1511), 1,
      sym_type_arguments,
    ACTIONS(1800), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1798), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56430] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 1,
      anon_sym_LT,
    ACTIONS(3580), 1,
      anon_sym_DOT,
    STATE(1517), 1,
      sym_type_arguments,
    ACTIONS(1761), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1759), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56485] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3582), 1,
      anon_sym_LBRACE,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3193), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56580] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3584), 1,
      anon_sym_LBRACE,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3235), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56675] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3233), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56770] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    STATE(2805), 1,
      sym_type_arguments,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3047), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3049), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [56829] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56922] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3216), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57015] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3211), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57108] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3201), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57201] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3125), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57294] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3546), 1,
      anon_sym_LT,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [57363] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3107), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [57440] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3588), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(2986), 1,
      aux_sym_array_repeat1,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57537] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3183), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 1,
      sym_regex_flags,
    ACTIONS(3616), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3618), 24,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57681] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3453), 1,
      anon_sym_LBRACE,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3191), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(995), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57825] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3622), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [57894] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3622), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [57963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1159), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3152), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58063] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3235), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58156] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3625), 1,
      anon_sym_LBRACE,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3185), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58251] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3220), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58344] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3209), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58437] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3207), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58530] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3099), 8,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [58611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3627), 1,
      sym__automatic_semicolon,
    ACTIONS(1095), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1093), 26,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1095), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1093), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58711] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3107), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3099), 7,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [58796] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3629), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58889] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3233), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58982] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3231), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59075] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3193), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59168] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3631), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59261] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3191), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59354] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3551), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3107), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [59429] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3551), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [59498] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3622), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [59565] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3107), 1,
      anon_sym_QMARK,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 5,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59654] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3183), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1051), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59796] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3185), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59889] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2249), 1,
      anon_sym_LT,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    STATE(1529), 1,
      sym_type_arguments,
    STATE(1639), 1,
      sym_arguments,
    ACTIONS(2273), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2277), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59952] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3633), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(3037), 1,
      aux_sym_array_repeat1,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60049] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3546), 1,
      anon_sym_LT,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [60118] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3185), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60211] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3107), 1,
      anon_sym_QMARK,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 5,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60300] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3191), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60393] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3193), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60486] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3207), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60579] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3209), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60672] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3635), 1,
      anon_sym_DOT,
    STATE(1517), 1,
      sym_type_arguments,
    ACTIONS(1623), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60725] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3637), 1,
      anon_sym_LBRACE,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3183), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60820] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3220), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60913] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3639), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [60982] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3235), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61075] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3639), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3107), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 13,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [61150] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3107), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3099), 7,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [61235] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3099), 8,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [61316] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3107), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 13,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [61393] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3580), 1,
      anon_sym_DOT,
    STATE(1517), 1,
      sym_type_arguments,
    ACTIONS(1777), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1775), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61446] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3554), 1,
      anon_sym_COMMA,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3642), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61541] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3639), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [61612] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3125), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61705] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3107), 2,
      anon_sym_LBRACE,
      anon_sym_QMARK,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3099), 4,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61794] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3644), 1,
      anon_sym_LT,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [61863] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3644), 1,
      anon_sym_LT,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3107), 10,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [61938] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3647), 1,
      anon_sym_LBRACE,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3218), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62033] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3201), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62126] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3211), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1145), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62268] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3451), 1,
      anon_sym_LBRACE,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3216), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62363] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3216), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62456] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3218), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1511), 1,
      sym_type_arguments,
    ACTIONS(1603), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1601), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1099), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1097), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62649] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 3,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3099), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
  [62734] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3107), 4,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3099), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
  [62815] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3542), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62908] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3649), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [62977] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3560), 1,
      anon_sym_COMMA,
    ACTIONS(3652), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(2967), 1,
      aux_sym_array_repeat1,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63074] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3649), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [63143] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3233), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63236] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3542), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63329] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3107), 8,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 12,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [63406] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3399), 1,
      anon_sym_LT,
    ACTIONS(3401), 1,
      anon_sym_QMARK,
    ACTIONS(3403), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    ACTIONS(3415), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3419), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3405), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3231), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3393), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3407), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3397), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3417), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63499] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3644), 1,
      anon_sym_LT,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [63570] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3512), 1,
      anon_sym_LBRACE,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3125), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63665] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3542), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63758] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3654), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(2970), 1,
      aux_sym_array_repeat1,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63855] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3649), 1,
      anon_sym_LT,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [63922] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3656), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(3122), 1,
      aux_sym_array_repeat1,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(981), 1,
      sym__automatic_semicolon,
    ACTIONS(973), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(977), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(979), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64072] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1677), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1679), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(977), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(979), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3658), 1,
      sym__automatic_semicolon,
    ACTIONS(975), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(973), 26,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64176] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3660), 1,
      anon_sym_LBRACE,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3211), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64271] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3662), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(2967), 1,
      aux_sym_array_repeat1,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64368] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3472), 1,
      anon_sym_as,
    ACTIONS(3476), 1,
      anon_sym_BANG,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3484), 1,
      anon_sym_QMARK,
    ACTIONS(3486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3492), 1,
      anon_sym_AMP,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3498), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3502), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3664), 1,
      anon_sym_LBRACE,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3488), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3496), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3629), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3470), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3490), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3478), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3500), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64463] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3666), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(3105), 1,
      aux_sym_array_repeat1,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64560] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_extends,
    ACTIONS(3087), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3090), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3083), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3085), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64615] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3668), 1,
      anon_sym_EQ,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64672] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3670), 1,
      anon_sym_EQ,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64729] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1663), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1661), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1043), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64788] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2261), 1,
      anon_sym_LT,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3045), 1,
      anon_sym_EQ,
    STATE(1707), 1,
      sym_type_arguments,
    STATE(1746), 1,
      sym_arguments,
    ACTIONS(2273), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2277), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64853] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(1613), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3090), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3083), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3085), 23,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64908] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3672), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    STATE(3150), 1,
      aux_sym_array_repeat1,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65005] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3267), 1,
      anon_sym_LT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3271), 1,
      anon_sym_QMARK,
    ACTIONS(3273), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3279), 1,
      anon_sym_AMP,
    ACTIONS(3281), 1,
      anon_sym_PIPE,
    ACTIONS(3285), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3289), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3275), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3283), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3254), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3277), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3542), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3265), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3287), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65098] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3678), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3702), 1,
      anon_sym_LBRACK,
    ACTIONS(1573), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1571), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65240] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3704), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65334] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 1,
      anon_sym_EQ,
    ACTIONS(3658), 1,
      sym__automatic_semicolon,
    ACTIONS(975), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(973), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65386] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3706), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65478] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3218), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65570] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3708), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65664] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3216), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 1,
      anon_sym_AMP,
    ACTIONS(3712), 1,
      anon_sym_PIPE,
    ACTIONS(1840), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1838), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1619), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1617), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65856] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3714), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65950] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3716), 1,
      anon_sym_EQ,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66006] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3718), 1,
      anon_sym_EQ,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1597), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1627), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1625), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66158] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3211), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66250] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1007), 1,
      sym__automatic_semicolon,
    ACTIONS(999), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1003), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1005), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66302] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3720), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1563), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66444] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3201), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66536] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 1,
      anon_sym_EQ,
    ACTIONS(3722), 1,
      sym__automatic_semicolon,
    ACTIONS(975), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(973), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66588] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3125), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66680] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3724), 1,
      anon_sym_LT,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [66750] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3107), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [66826] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1027), 1,
      sym__automatic_semicolon,
    ACTIONS(1019), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1023), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1025), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66878] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 1,
      anon_sym_AMP,
    ACTIONS(3712), 1,
      anon_sym_PIPE,
    ACTIONS(3727), 1,
      anon_sym_extends,
    ACTIONS(1826), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1824), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1651), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1649), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67030] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1587), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1583), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1581), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1633), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67130] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1798), 1,
      anon_sym_extends,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2714), 1,
      anon_sym_QMARK,
    ACTIONS(3729), 1,
      anon_sym_EQ,
    ACTIONS(3731), 1,
      anon_sym_RPAREN,
    ACTIONS(2705), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3171), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1671), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1669), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1567), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67292] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3099), 7,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [67372] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3107), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3099), 6,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [67456] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1677), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(977), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(979), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67508] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3724), 1,
      anon_sym_LT,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3107), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 12,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [67582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3152), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67632] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3724), 1,
      anon_sym_LT,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3107), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3099), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [67700] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3107), 1,
      anon_sym_QMARK,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3099), 4,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67788] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3183), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67880] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3185), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67972] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3735), 1,
      anon_sym_RBRACE,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68066] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      sym__automatic_semicolon,
    ACTIONS(1009), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1013), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1015), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68118] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1133), 1,
      sym__automatic_semicolon,
    ACTIONS(1125), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1129), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1131), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68170] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3191), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68262] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1661), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1663), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68320] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3193), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68412] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3737), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68554] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3207), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68646] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_extends,
    ACTIONS(3087), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3090), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3083), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3085), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68700] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3209), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68792] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3220), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68884] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3739), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68978] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3741), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69070] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1123), 1,
      sym__automatic_semicolon,
    ACTIONS(1115), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1119), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1121), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69122] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1037), 1,
      sym__automatic_semicolon,
    ACTIONS(1029), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1033), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1035), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69174] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3743), 1,
      anon_sym_LPAREN,
    ACTIONS(3746), 1,
      anon_sym_COLON,
    ACTIONS(3748), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3093), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2910), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69228] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3751), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1585), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69368] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3753), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1659), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1657), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1667), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1665), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69558] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 1,
      anon_sym_AMP,
    ACTIONS(3712), 1,
      anon_sym_PIPE,
    ACTIONS(3727), 1,
      anon_sym_extends,
    ACTIONS(1846), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1844), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69612] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1805), 1,
      anon_sym_DOT,
    ACTIONS(1545), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1543), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69662] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_extends,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(3161), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1643), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1641), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1639), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1637), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1655), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1653), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3213), 1,
      anon_sym_LT,
    ACTIONS(1061), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1059), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69916] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 1,
      anon_sym_extends,
    ACTIONS(3087), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(3090), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3083), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3085), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1109), 1,
      sym__automatic_semicolon,
    ACTIONS(1101), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1105), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1107), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70022] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3235), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70114] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2261), 1,
      anon_sym_LT,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    STATE(1707), 1,
      sym_type_arguments,
    STATE(1746), 1,
      sym_arguments,
    ACTIONS(2273), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2277), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70176] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3755), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70270] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1677), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1679), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(977), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(979), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70322] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1143), 1,
      sym__automatic_semicolon,
    ACTIONS(1135), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1139), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1141), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70374] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3757), 1,
      anon_sym_RBRACE,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70468] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3261), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70560] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3312), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1557), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1555), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [70700] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3331), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70792] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1798), 1,
      anon_sym_extends,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3168), 1,
      anon_sym_COMMA,
    ACTIONS(3171), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70852] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3759), 1,
      anon_sym_RBRACE,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70946] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3761), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71040] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3763), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71134] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 1,
      anon_sym_AMP,
    ACTIONS(3712), 1,
      anon_sym_PIPE,
    ACTIONS(3727), 1,
      anon_sym_extends,
    ACTIONS(3138), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3140), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71188] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3765), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1701), 1,
      sym_type_arguments,
    ACTIONS(1603), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1601), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [71332] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3767), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71426] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 1,
      sym__automatic_semicolon,
    ACTIONS(1149), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1153), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1155), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    STATE(1670), 1,
      sym_type_arguments,
    ACTIONS(1777), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1775), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [71530] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3771), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71624] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3631), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71716] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3773), 1,
      anon_sym_DOT,
    STATE(1670), 1,
      sym_type_arguments,
    ACTIONS(1623), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [71768] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3775), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71862] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3777), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1547), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1603), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1601), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72052] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3779), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72146] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3781), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1591), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1589), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1579), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1577), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1551), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1663), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1661), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1593), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72480] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3783), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1605), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3702), 1,
      anon_sym_LBRACK,
    ACTIONS(1611), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1609), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1615), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1613), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3635), 1,
      anon_sym_DOT,
    ACTIONS(1623), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1677), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72864] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1081), 1,
      sym__automatic_semicolon,
    ACTIONS(1073), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1077), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1079), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72916] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1071), 1,
      sym__automatic_semicolon,
    ACTIONS(1063), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1067), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1069), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72968] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    STATE(1603), 1,
      sym_arguments,
    ACTIONS(3195), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3197), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73020] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    STATE(1616), 1,
      sym_arguments,
    ACTIONS(3203), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3205), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73072] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1645), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3161), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 21,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73130] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1798), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3171), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 21,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73188] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3785), 1,
      anon_sym_LT,
    STATE(1701), 1,
      sym_type_arguments,
    ACTIONS(1800), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1798), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [73240] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3788), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73334] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3769), 1,
      anon_sym_DOT,
    ACTIONS(3790), 1,
      anon_sym_LT,
    STATE(1670), 1,
      sym_type_arguments,
    ACTIONS(1761), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1759), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [73388] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3793), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73482] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3795), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73576] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      sym_regex_flags,
    ACTIONS(3616), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3618), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73626] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3799), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73720] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3801), 1,
      anon_sym_LT,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [73788] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3804), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73882] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3801), 1,
      anon_sym_LT,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [73950] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3806), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74044] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3233), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74136] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3256), 1,
      anon_sym_as,
    ACTIONS(3263), 1,
      anon_sym_BANG,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3680), 1,
      anon_sym_LT,
    ACTIONS(3682), 1,
      anon_sym_QMARK,
    ACTIONS(3684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3690), 1,
      anon_sym_AMP,
    ACTIONS(3692), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3700), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3231), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3686), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3694), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3674), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3688), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3676), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74228] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3801), 1,
      anon_sym_LT,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3291), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3222), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [74294] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3718), 1,
      anon_sym_EQ,
    ACTIONS(3808), 1,
      anon_sym_in,
    ACTIONS(3811), 1,
      anon_sym_of,
    ACTIONS(1043), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1091), 1,
      sym__automatic_semicolon,
    ACTIONS(1083), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1087), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1089), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1631), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1629), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [74454] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3716), 1,
      anon_sym_EQ,
    ACTIONS(3813), 1,
      anon_sym_in,
    ACTIONS(3816), 1,
      anon_sym_of,
    ACTIONS(1043), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74514] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3818), 1,
      anon_sym_COLON,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74608] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3105), 1,
      anon_sym_LT,
    ACTIONS(3109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3113), 1,
      anon_sym_AMP,
    ACTIONS(3117), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3127), 1,
      anon_sym_QMARK,
    ACTIONS(3131), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3148), 1,
      anon_sym_COMMA,
    ACTIONS(3820), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3129), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3097), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3111), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3103), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3119), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1229), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [74750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1645), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [74798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1675), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1673), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [74846] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3087), 1,
      anon_sym_LBRACK,
    ACTIONS(1613), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3090), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3083), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3085), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74900] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3822), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74991] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3824), 1,
      anon_sym_EQ,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 21,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [75046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3433), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3435), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75093] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(3828), 1,
      anon_sym_RBRACE,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3832), 1,
      anon_sym_async,
    ACTIONS(3834), 1,
      sym_number,
    ACTIONS(3836), 1,
      anon_sym_static,
    ACTIONS(3842), 1,
      sym_readonly,
    STATE(1984), 1,
      sym_accessibility_modifier,
    STATE(2993), 1,
      aux_sym_object_repeat1,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(3838), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3840), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2353), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2988), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3826), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75178] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(3844), 1,
      anon_sym_STAR,
    ACTIONS(3846), 1,
      anon_sym_RBRACE,
    ACTIONS(3848), 1,
      anon_sym_async,
    ACTIONS(3850), 1,
      sym_number,
    ACTIONS(3852), 1,
      anon_sym_static,
    ACTIONS(3854), 1,
      anon_sym_abstract,
    ACTIONS(3858), 1,
      sym_readonly,
    STATE(1954), 1,
      sym_method_definition,
    STATE(1975), 1,
      sym_accessibility_modifier,
    ACTIONS(3856), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1591), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2043), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3055), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2966), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3439), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1579), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1577), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [75355] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1661), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(1663), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1655), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1653), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [75459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1639), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1637), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [75506] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3860), 1,
      anon_sym_EQ,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 21,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [75561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1643), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1641), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [75608] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1667), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1665), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [75708] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3449), 1,
      anon_sym_RBRACE,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3314), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3316), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75846] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3862), 1,
      anon_sym_EQ,
    ACTIONS(1043), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1025), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75948] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3864), 1,
      anon_sym_EQ,
    ACTIONS(1043), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1005), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3349), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3351), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1659), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1657), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [76144] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3866), 1,
      anon_sym_LBRACE,
    ACTIONS(3868), 1,
      anon_sym_DOT,
    STATE(1755), 1,
      sym_statement_block,
    ACTIONS(985), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(983), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3335), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1585), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [76338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3347), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3866), 1,
      anon_sym_LBRACE,
    STATE(1755), 1,
      sym_statement_block,
    ACTIONS(985), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(983), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1603), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1601), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [76483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1591), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1589), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [76530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3445), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3447), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1139), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1141), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76624] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_STAR,
    ACTIONS(3876), 1,
      anon_sym_RBRACE,
    ACTIONS(3878), 1,
      anon_sym_LBRACK,
    ACTIONS(3881), 1,
      anon_sym_async,
    ACTIONS(3884), 1,
      anon_sym_DASH,
    ACTIONS(3887), 1,
      anon_sym_DQUOTE,
    ACTIONS(3890), 1,
      anon_sym_SQUOTE,
    ACTIONS(3893), 1,
      sym_number,
    ACTIONS(3896), 1,
      anon_sym_AT,
    ACTIONS(3899), 1,
      anon_sym_static,
    ACTIONS(3902), 1,
      anon_sym_abstract,
    ACTIONS(3911), 1,
      sym_readonly,
    STATE(1954), 1,
      sym_method_definition,
    STATE(1975), 1,
      sym_accessibility_modifier,
    ACTIONS(3905), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1589), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3908), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2043), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3055), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3870), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1663), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1661), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [76754] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(3844), 1,
      anon_sym_STAR,
    ACTIONS(3848), 1,
      anon_sym_async,
    ACTIONS(3850), 1,
      sym_number,
    ACTIONS(3852), 1,
      anon_sym_static,
    ACTIONS(3854), 1,
      anon_sym_abstract,
    ACTIONS(3858), 1,
      sym_readonly,
    ACTIONS(3914), 1,
      anon_sym_RBRACE,
    STATE(1954), 1,
      sym_method_definition,
    STATE(1975), 1,
      sym_accessibility_modifier,
    ACTIONS(3856), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1589), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2043), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3055), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2966), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3213), 1,
      anon_sym_LT,
    ACTIONS(1061), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1059), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [76886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3459), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3461), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3216), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1567), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [77027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1671), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1669), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [77074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1593), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [77121] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3916), 1,
      anon_sym_COLON,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77212] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3918), 1,
      anon_sym_LPAREN,
    ACTIONS(3921), 1,
      anon_sym_COLON,
    ACTIONS(3923), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1043), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1633), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [77318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1805), 1,
      anon_sym_DOT,
    ACTIONS(1545), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1543), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [77367] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3926), 1,
      anon_sym_EQ,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3355), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77469] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(3844), 1,
      anon_sym_STAR,
    ACTIONS(3848), 1,
      anon_sym_async,
    ACTIONS(3850), 1,
      sym_number,
    ACTIONS(3852), 1,
      anon_sym_static,
    ACTIONS(3854), 1,
      anon_sym_abstract,
    ACTIONS(3858), 1,
      sym_readonly,
    ACTIONS(3928), 1,
      anon_sym_RBRACE,
    STATE(1954), 1,
      sym_method_definition,
    STATE(1975), 1,
      sym_accessibility_modifier,
    ACTIONS(3856), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1589), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2043), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3055), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2966), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77552] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(3844), 1,
      anon_sym_STAR,
    ACTIONS(3848), 1,
      anon_sym_async,
    ACTIONS(3850), 1,
      sym_number,
    ACTIONS(3852), 1,
      anon_sym_static,
    ACTIONS(3854), 1,
      anon_sym_abstract,
    ACTIONS(3858), 1,
      sym_readonly,
    ACTIONS(3930), 1,
      anon_sym_RBRACE,
    STATE(1954), 1,
      sym_method_definition,
    STATE(1975), 1,
      sym_accessibility_modifier,
    ACTIONS(3856), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1604), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2043), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3055), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2966), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77635] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3932), 1,
      anon_sym_EQ,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77690] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 2,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1587), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1583), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1581), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1651), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1649), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [77788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3083), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3085), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1627), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1625), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [77882] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3834), 1,
      sym_number,
    ACTIONS(3936), 1,
      anon_sym_RBRACE,
    ACTIONS(3938), 1,
      anon_sym_async,
    ACTIONS(3940), 1,
      anon_sym_static,
    ACTIONS(3946), 1,
      sym_readonly,
    STATE(1984), 1,
      sym_accessibility_modifier,
    STATE(3095), 1,
      aux_sym_object_repeat1,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(3942), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3944), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2353), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3098), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3934), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1597), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [78014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2920), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2924), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78061] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(3844), 1,
      anon_sym_STAR,
    ACTIONS(3848), 1,
      anon_sym_async,
    ACTIONS(3850), 1,
      sym_number,
    ACTIONS(3852), 1,
      anon_sym_static,
    ACTIONS(3854), 1,
      anon_sym_abstract,
    ACTIONS(3858), 1,
      sym_readonly,
    ACTIONS(3948), 1,
      anon_sym_RBRACE,
    STATE(1954), 1,
      sym_method_definition,
    STATE(1975), 1,
      sym_accessibility_modifier,
    ACTIONS(3856), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1589), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2043), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3055), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2966), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1619), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1617), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [78191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3359), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78238] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(3844), 1,
      anon_sym_STAR,
    ACTIONS(3848), 1,
      anon_sym_async,
    ACTIONS(3850), 1,
      sym_number,
    ACTIONS(3852), 1,
      anon_sym_static,
    ACTIONS(3854), 1,
      anon_sym_abstract,
    ACTIONS(3858), 1,
      sym_readonly,
    ACTIONS(3950), 1,
      anon_sym_RBRACE,
    STATE(1954), 1,
      sym_method_definition,
    STATE(1975), 1,
      sym_accessibility_modifier,
    ACTIONS(3856), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1614), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2043), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3055), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2966), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78321] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3834), 1,
      sym_number,
    ACTIONS(3954), 1,
      anon_sym_RBRACE,
    ACTIONS(3956), 1,
      anon_sym_async,
    ACTIONS(3958), 1,
      anon_sym_static,
    ACTIONS(3964), 1,
      sym_readonly,
    STATE(1984), 1,
      sym_accessibility_modifier,
    STATE(2998), 1,
      aux_sym_object_repeat1,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(3960), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3962), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2353), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2996), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3952), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78406] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2714), 1,
      anon_sym_QMARK,
    ACTIONS(3729), 1,
      anon_sym_EQ,
    ACTIONS(2705), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1043), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3722), 1,
      sym__automatic_semicolon,
    ACTIONS(975), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(973), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1645), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [78561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3510), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3522), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3524), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1155), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78702] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(3844), 1,
      anon_sym_STAR,
    ACTIONS(3848), 1,
      anon_sym_async,
    ACTIONS(3850), 1,
      sym_number,
    ACTIONS(3852), 1,
      anon_sym_static,
    ACTIONS(3854), 1,
      anon_sym_abstract,
    ACTIONS(3858), 1,
      sym_readonly,
    ACTIONS(3966), 1,
      anon_sym_RBRACE,
    STATE(1954), 1,
      sym_method_definition,
    STATE(1975), 1,
      sym_accessibility_modifier,
    ACTIONS(3856), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1589), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2043), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3055), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2966), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78785] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3968), 1,
      anon_sym_EQ,
    ACTIONS(3974), 1,
      anon_sym_QMARK,
    ACTIONS(3971), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1043), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78844] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(3844), 1,
      anon_sym_STAR,
    ACTIONS(3848), 1,
      anon_sym_async,
    ACTIONS(3850), 1,
      sym_number,
    ACTIONS(3852), 1,
      anon_sym_static,
    ACTIONS(3854), 1,
      anon_sym_abstract,
    ACTIONS(3858), 1,
      sym_readonly,
    ACTIONS(3977), 1,
      anon_sym_RBRACE,
    STATE(1954), 1,
      sym_method_definition,
    STATE(1975), 1,
      sym_accessibility_modifier,
    ACTIONS(3856), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1589), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2043), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3055), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2966), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3301), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3303), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78974] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_extends,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3158), 1,
      anon_sym_COMMA,
    ACTIONS(3161), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79033] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(3844), 1,
      anon_sym_STAR,
    ACTIONS(3848), 1,
      anon_sym_async,
    ACTIONS(3850), 1,
      sym_number,
    ACTIONS(3852), 1,
      anon_sym_static,
    ACTIONS(3854), 1,
      anon_sym_abstract,
    ACTIONS(3858), 1,
      sym_readonly,
    ACTIONS(3979), 1,
      anon_sym_RBRACE,
    STATE(1954), 1,
      sym_method_definition,
    STATE(1975), 1,
      sym_accessibility_modifier,
    ACTIONS(3856), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1625), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2043), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3055), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2966), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1605), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [79163] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3834), 1,
      sym_number,
    ACTIONS(3983), 1,
      anon_sym_RBRACE,
    ACTIONS(3985), 1,
      anon_sym_async,
    ACTIONS(3987), 1,
      anon_sym_static,
    ACTIONS(3993), 1,
      sym_readonly,
    STATE(1984), 1,
      sym_accessibility_modifier,
    STATE(2951), 1,
      aux_sym_object_repeat1,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(3989), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3991), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2353), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2946), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3981), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79248] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(1840), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1838), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [79299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3250), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3252), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79346] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3999), 1,
      anon_sym_COLON,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3530), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3532), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1563), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [79531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3534), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3536), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3538), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3540), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79625] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_extends,
    ACTIONS(1826), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1824), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1089), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3297), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3299), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [79819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4003), 1,
      anon_sym_LBRACK,
    ACTIONS(1611), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1609), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [79868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1615), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1613), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [79915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3518), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3520), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1077), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1079), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [80056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3773), 1,
      anon_sym_DOT,
    ACTIONS(1623), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1621), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [80105] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4005), 1,
      anon_sym_COLON,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80196] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4007), 1,
      anon_sym_EQ,
    ACTIONS(4013), 1,
      anon_sym_QMARK,
    ACTIONS(4010), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1043), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3339), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3246), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3248), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3055), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3366), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3059), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1677), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [80537] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4016), 1,
      sym__automatic_semicolon,
    ACTIONS(1095), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1093), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80586] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1798), 1,
      anon_sym_extends,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3168), 1,
      anon_sym_COMMA,
    ACTIONS(3171), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3293), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3295), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1069), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1675), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1673), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [80786] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4018), 1,
      anon_sym_COLON,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3514), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3516), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(977), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(979), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81018] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3045), 1,
      anon_sym_EQ,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 21,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3372), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3374), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3370), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1551), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [81214] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(3844), 1,
      anon_sym_STAR,
    ACTIONS(3848), 1,
      anon_sym_async,
    ACTIONS(3850), 1,
      sym_number,
    ACTIONS(3852), 1,
      anon_sym_static,
    ACTIONS(3854), 1,
      anon_sym_abstract,
    ACTIONS(3858), 1,
      sym_readonly,
    ACTIONS(4020), 1,
      anon_sym_RBRACE,
    STATE(1954), 1,
      sym_method_definition,
    STATE(1975), 1,
      sym_accessibility_modifier,
    ACTIONS(3856), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1589), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2043), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3055), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2966), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81297] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_extends,
    ACTIONS(3138), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3140), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81350] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3043), 1,
      anon_sym_EQ,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 21,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4003), 1,
      anon_sym_LBRACK,
    ACTIONS(1573), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1571), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [81454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1229), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [81501] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(3844), 1,
      anon_sym_STAR,
    ACTIONS(3848), 1,
      anon_sym_async,
    ACTIONS(3850), 1,
      sym_number,
    ACTIONS(3852), 1,
      anon_sym_static,
    ACTIONS(3854), 1,
      anon_sym_abstract,
    ACTIONS(3858), 1,
      sym_readonly,
    ACTIONS(4022), 1,
      anon_sym_RBRACE,
    STATE(1954), 1,
      sym_method_definition,
    STATE(1975), 1,
      sym_accessibility_modifier,
    ACTIONS(3856), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1627), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2043), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3055), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2966), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3379), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3220), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81631] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2714), 1,
      anon_sym_QMARK,
    ACTIONS(2884), 1,
      anon_sym_COLON,
    ACTIONS(3729), 1,
      anon_sym_EQ,
    ACTIONS(2705), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1043), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 1,
      anon_sym_EQ_GT,
    ACTIONS(3152), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3093), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2910), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1631), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1629), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [81835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3138), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3140), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3341), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3343), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81929] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4024), 1,
      anon_sym_RBRACK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82020] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2654), 1,
      anon_sym_DASH,
    ACTIONS(2976), 1,
      anon_sym_LBRACK,
    ACTIONS(3844), 1,
      anon_sym_STAR,
    ACTIONS(3848), 1,
      anon_sym_async,
    ACTIONS(3850), 1,
      sym_number,
    ACTIONS(3852), 1,
      anon_sym_static,
    ACTIONS(3854), 1,
      anon_sym_abstract,
    ACTIONS(3858), 1,
      sym_readonly,
    ACTIONS(4026), 1,
      anon_sym_RBRACE,
    STATE(1954), 1,
      sym_method_definition,
    STATE(1975), 1,
      sym_accessibility_modifier,
    ACTIONS(3856), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1671), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(2986), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2043), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3055), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(2966), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3322), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3324), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82197] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3995), 1,
      anon_sym_AMP,
    ACTIONS(3997), 1,
      anon_sym_PIPE,
    ACTIONS(4001), 1,
      anon_sym_extends,
    ACTIONS(1846), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1844), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [82250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1557), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1555), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [82297] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3834), 1,
      sym_number,
    ACTIONS(4030), 1,
      anon_sym_RBRACE,
    ACTIONS(4032), 1,
      anon_sym_async,
    ACTIONS(4034), 1,
      anon_sym_static,
    ACTIONS(4040), 1,
      sym_readonly,
    STATE(1984), 1,
      sym_accessibility_modifier,
    STATE(3021), 1,
      aux_sym_object_repeat1,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(4036), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4038), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2353), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3025), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4028), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82382] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3968), 1,
      anon_sym_EQ,
    ACTIONS(3974), 1,
      anon_sym_QMARK,
    ACTIONS(4042), 1,
      anon_sym_COLON,
    ACTIONS(3971), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1043), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3431), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82490] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4007), 1,
      anon_sym_EQ,
    ACTIONS(4013), 1,
      anon_sym_QMARK,
    ACTIONS(4044), 1,
      anon_sym_COLON,
    ACTIONS(4010), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1043), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1013), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1015), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82598] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4046), 1,
      anon_sym_COLON,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3465), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3381), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3209), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3318), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3320), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1131), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1121), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1547), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [82971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3207), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3457), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1035), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3453), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    STATE(1792), 1,
      sym_arguments,
    ACTIONS(3195), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3197), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83257] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1645), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3161), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3391), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    STATE(1793), 1,
      sym_arguments,
    ACTIONS(3203), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3205), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3071), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3073), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1107), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1049), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1047), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [83553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3423), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83600] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4048), 1,
      anon_sym_COLON,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4050), 1,
      sym_regex_flags,
    ACTIONS(3616), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3618), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3075), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3077), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3443), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3079), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3081), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [83881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1163), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [83928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3427), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3620), 1,
      sym_regex_flags,
    ACTIONS(3616), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
    ACTIONS(3618), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84024] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1798), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3171), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84081] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1661), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(1663), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84138] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_extends,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3158), 1,
      anon_sym_RPAREN,
    ACTIONS(3161), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1043), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84197] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4056), 1,
      anon_sym_LBRACK,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4060), 1,
      sym_number,
    STATE(2963), 1,
      aux_sym_object_repeat1,
    ACTIONS(4062), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3457), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84355] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3269), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2836), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1562), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3433), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3435), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3510), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3301), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3303), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3297), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3299), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3522), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3524), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3293), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3295), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3250), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3252), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84765] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4064), 1,
      anon_sym_EQ,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3530), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3532), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3216), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3423), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [84957] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4056), 1,
      anon_sym_LBRACK,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4060), 1,
      sym_number,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    ACTIONS(4062), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1069), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85069] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4060), 1,
      sym_number,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4068), 1,
      sym_readonly,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    ACTIONS(4062), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85137] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4072), 1,
      sym_number,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    ACTIONS(4074), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3534), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3536), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3538), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3540), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3518), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3520), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3514), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3516), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3339), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3370), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3372), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3374), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1077), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1079), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1159), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1099), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1097), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85707] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3482), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2805), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1770), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1145), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85841] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4056), 1,
      anon_sym_LBRACK,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4060), 1,
      sym_number,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    ACTIONS(4062), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3318), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3320), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [85953] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4060), 1,
      sym_number,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4068), 1,
      sym_readonly,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    ACTIONS(4062), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86021] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4072), 1,
      sym_number,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    ACTIONS(4074), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3138), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3140), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1005), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1023), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1025), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(997), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(995), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1013), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1015), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1131), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1121), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1033), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1035), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3439), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3347), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1105), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1107), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3341), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3343), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3459), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3461), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2920), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2924), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86729] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      anon_sym_DOT,
    ACTIONS(2380), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4076), 1,
      anon_sym_EQ,
    ACTIONS(1043), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [86783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1051), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [86829] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4060), 1,
      sym_number,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4068), 1,
      sym_readonly,
    STATE(2963), 1,
      aux_sym_object_repeat1,
    ACTIONS(4062), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86897] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4072), 1,
      sym_number,
    STATE(2963), 1,
      aux_sym_object_repeat1,
    ACTIONS(4074), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1059), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3445), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3447), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3427), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3314), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3316), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3465), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3431), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1095), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1093), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3453), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3191), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3322), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3324), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3349), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3351), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87421] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(3051), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3101), 1,
      anon_sym_BANG,
    ACTIONS(3123), 1,
      anon_sym_as,
    ACTIONS(3594), 1,
      anon_sym_LT,
    ACTIONS(3596), 1,
      anon_sym_QMARK,
    ACTIONS(3598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3604), 1,
      anon_sym_AMP,
    ACTIONS(3606), 1,
      anon_sym_PIPE,
    ACTIONS(3610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3614), 1,
      anon_sym_QMARK_QMARK,
    STATE(2882), 1,
      sym_type_arguments,
    ACTIONS(3121), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3608), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1230), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3590), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3602), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3592), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3612), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3443), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3355), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3359), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87647] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(109), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3834), 1,
      sym_number,
    ACTIONS(4080), 1,
      anon_sym_async,
    ACTIONS(4082), 1,
      anon_sym_static,
    ACTIONS(4088), 1,
      sym_readonly,
    STATE(1984), 1,
      sym_accessibility_modifier,
    STATE(3501), 1,
      sym_object,
    STATE(3502), 1,
      sym_array,
    ACTIONS(2898), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4084), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4086), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2353), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3309), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4078), 11,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87727] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4056), 1,
      anon_sym_LBRACK,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4060), 1,
      sym_number,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    ACTIONS(4062), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3335), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1089), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3246), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3248), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3366), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [87977] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4060), 1,
      sym_number,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4068), 1,
      sym_readonly,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    ACTIONS(4062), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3379), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3220), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [88091] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4072), 1,
      sym_number,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    ACTIONS(4074), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3391), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [88201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3207), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [88247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1043), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [88293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [88339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1139), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1141), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [88385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3381), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3209), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [88431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1155), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [88477] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_LBRACK,
    ACTIONS(2670), 1,
      anon_sym_DOT,
    ACTIONS(2674), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1043), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [88529] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4072), 1,
      sym_number,
    ACTIONS(3002), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4074), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88592] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4060), 1,
      sym_number,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4068), 1,
      sym_readonly,
    ACTIONS(3002), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4062), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88659] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4090), 1,
      anon_sym_STAR,
    ACTIONS(4092), 1,
      anon_sym_async,
    ACTIONS(4094), 1,
      sym_number,
    ACTIONS(4096), 1,
      anon_sym_abstract,
    ACTIONS(4098), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2046), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88722] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4072), 1,
      sym_number,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88781] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3045), 1,
      anon_sym_EQ,
    ACTIONS(3808), 1,
      anon_sym_in,
    ACTIONS(3811), 1,
      anon_sym_of,
    ACTIONS(1043), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88838] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3043), 1,
      anon_sym_EQ,
    ACTIONS(3813), 1,
      anon_sym_in,
    ACTIONS(3816), 1,
      anon_sym_of,
    ACTIONS(1043), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88895] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3043), 1,
      anon_sym_EQ,
    ACTIONS(3178), 1,
      anon_sym_in,
    ACTIONS(3181), 1,
      anon_sym_of,
    ACTIONS(1043), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88952] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4056), 1,
      anon_sym_LBRACK,
    ACTIONS(4100), 1,
      anon_sym_STAR,
    ACTIONS(4102), 1,
      anon_sym_async,
    ACTIONS(4104), 1,
      sym_number,
    ACTIONS(4106), 1,
      anon_sym_abstract,
    ACTIONS(4108), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2048), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89015] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_LBRACK,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(2283), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3045), 1,
      anon_sym_EQ,
    ACTIONS(3241), 1,
      anon_sym_in,
    ACTIONS(3244), 1,
      anon_sym_of,
    ACTIONS(1043), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1045), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [89072] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4056), 1,
      anon_sym_LBRACK,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4060), 1,
      sym_number,
    ACTIONS(3002), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4062), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89137] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4072), 1,
      sym_number,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89196] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4072), 1,
      sym_number,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89255] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4072), 1,
      sym_number,
    STATE(2963), 1,
      aux_sym_object_repeat1,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89314] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4110), 1,
      anon_sym_STAR,
    ACTIONS(4112), 1,
      sym_number,
    ACTIONS(4114), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89372] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4116), 1,
      anon_sym_STAR,
    ACTIONS(4118), 1,
      sym_number,
    ACTIONS(4120), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2436), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89430] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4122), 1,
      anon_sym_STAR,
    ACTIONS(4124), 1,
      sym_number,
    ACTIONS(4126), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2450), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89488] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4090), 1,
      anon_sym_STAR,
    ACTIONS(4128), 1,
      sym_number,
    ACTIONS(4130), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2389), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89546] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4122), 1,
      anon_sym_STAR,
    ACTIONS(4132), 1,
      anon_sym_async,
    ACTIONS(4134), 1,
      sym_number,
    ACTIONS(4136), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2042), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89606] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4138), 1,
      anon_sym_STAR,
    ACTIONS(4140), 1,
      anon_sym_async,
    ACTIONS(4142), 1,
      sym_number,
    ACTIONS(4144), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2056), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89666] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4146), 1,
      anon_sym_STAR,
    ACTIONS(4148), 1,
      anon_sym_async,
    ACTIONS(4150), 1,
      sym_number,
    ACTIONS(4154), 1,
      sym_readonly,
    ACTIONS(4152), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2058), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89728] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4138), 1,
      anon_sym_STAR,
    ACTIONS(4156), 1,
      sym_number,
    ACTIONS(4158), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2485), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89786] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4146), 1,
      anon_sym_STAR,
    ACTIONS(4160), 1,
      sym_number,
    ACTIONS(4162), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2407), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89844] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4164), 1,
      anon_sym_STAR,
    ACTIONS(4166), 1,
      sym_number,
    ACTIONS(4168), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2432), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89902] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4170), 1,
      anon_sym_STAR,
    ACTIONS(4172), 1,
      anon_sym_async,
    ACTIONS(4174), 1,
      sym_number,
    ACTIONS(4178), 1,
      sym_readonly,
    ACTIONS(4176), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2051), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89964] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4072), 1,
      sym_number,
    ACTIONS(3002), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90022] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4090), 1,
      anon_sym_STAR,
    ACTIONS(4092), 1,
      anon_sym_async,
    ACTIONS(4094), 1,
      sym_number,
    ACTIONS(4098), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2046), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90082] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4056), 1,
      anon_sym_LBRACK,
    ACTIONS(4146), 1,
      anon_sym_STAR,
    ACTIONS(4148), 1,
      anon_sym_async,
    ACTIONS(4150), 1,
      sym_number,
    ACTIONS(4152), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2058), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90142] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4100), 1,
      anon_sym_STAR,
    ACTIONS(4180), 1,
      sym_number,
    ACTIONS(4182), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2402), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90200] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4100), 1,
      anon_sym_STAR,
    ACTIONS(4102), 1,
      anon_sym_async,
    ACTIONS(4104), 1,
      sym_number,
    ACTIONS(4184), 1,
      sym_readonly,
    ACTIONS(4108), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2048), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2966), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90262] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4170), 1,
      anon_sym_STAR,
    ACTIONS(4172), 1,
      anon_sym_async,
    ACTIONS(4174), 1,
      sym_number,
    ACTIONS(4176), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2051), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90322] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4186), 1,
      anon_sym_STAR,
    ACTIONS(4188), 1,
      sym_number,
    ACTIONS(4190), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2385), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90380] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4186), 1,
      anon_sym_STAR,
    ACTIONS(4192), 1,
      anon_sym_async,
    ACTIONS(4194), 1,
      sym_number,
    ACTIONS(4196), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2059), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90440] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4090), 1,
      anon_sym_STAR,
    ACTIONS(4092), 1,
      anon_sym_async,
    ACTIONS(4094), 1,
      sym_number,
    ACTIONS(4198), 1,
      sym_readonly,
    ACTIONS(4098), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2046), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2966), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90502] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4170), 1,
      anon_sym_STAR,
    ACTIONS(4200), 1,
      sym_number,
    ACTIONS(4202), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2431), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1731), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2938), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1729), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90606] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4204), 1,
      anon_sym_STAR,
    ACTIONS(4206), 1,
      sym_number,
    ACTIONS(4208), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2508), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90664] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4164), 1,
      anon_sym_STAR,
    ACTIONS(4210), 1,
      anon_sym_async,
    ACTIONS(4212), 1,
      sym_number,
    ACTIONS(4214), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2055), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90724] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4186), 1,
      anon_sym_STAR,
    ACTIONS(4192), 1,
      anon_sym_async,
    ACTIONS(4194), 1,
      sym_number,
    ACTIONS(4216), 1,
      sym_readonly,
    ACTIONS(4196), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2059), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2966), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90786] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4220), 1,
      anon_sym_RPAREN,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    STATE(1911), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3379), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90859] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(1683), 1,
      anon_sym_async,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    ACTIONS(4228), 1,
      anon_sym_RBRACE,
    STATE(3124), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90926] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4128), 1,
      sym_number,
    STATE(2389), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90979] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    ACTIONS(4230), 1,
      anon_sym_RPAREN,
    STATE(1911), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3379), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91052] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    ACTIONS(4232), 1,
      anon_sym_RPAREN,
    STATE(1899), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3019), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91125] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4124), 1,
      sym_number,
    STATE(2450), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91178] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    ACTIONS(4234), 1,
      anon_sym_RPAREN,
    STATE(1911), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3379), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91251] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(465), 1,
      anon_sym_RPAREN,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    STATE(1906), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2999), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91324] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(1683), 1,
      anon_sym_async,
    ACTIONS(1687), 1,
      sym_readonly,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    ACTIONS(4228), 1,
      anon_sym_RBRACE,
    STATE(3124), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91393] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4240), 1,
      anon_sym_LPAREN,
    ACTIONS(4242), 1,
      anon_sym_DOT,
    STATE(1930), 1,
      sym_arguments,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4236), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91442] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    ACTIONS(4244), 1,
      anon_sym_RPAREN,
    STATE(1902), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2976), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91515] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4180), 1,
      sym_number,
    STATE(2402), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91568] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(1683), 1,
      anon_sym_async,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    ACTIONS(4246), 1,
      anon_sym_RBRACE,
    STATE(2963), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91635] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    ACTIONS(4248), 1,
      anon_sym_RPAREN,
    STATE(1911), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3379), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91708] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    ACTIONS(1731), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1729), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91757] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4156), 1,
      sym_number,
    STATE(2485), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91810] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1308), 1,
      anon_sym_RBRACE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(1683), 1,
      anon_sym_async,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91877] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    ACTIONS(4228), 1,
      anon_sym_RBRACE,
    STATE(3124), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91942] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4112), 1,
      sym_number,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [91995] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4200), 1,
      sym_number,
    STATE(2431), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92048] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    ACTIONS(4250), 1,
      anon_sym_RPAREN,
    STATE(1911), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3379), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92121] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(1683), 1,
      anon_sym_async,
    ACTIONS(1687), 1,
      sym_readonly,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    ACTIONS(4246), 1,
      anon_sym_RBRACE,
    STATE(2963), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92190] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    ACTIONS(4252), 1,
      anon_sym_RPAREN,
    STATE(1911), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3379), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92263] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    ACTIONS(4254), 1,
      anon_sym_class,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3147), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92336] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    ACTIONS(4246), 1,
      anon_sym_RBRACE,
    STATE(2963), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92401] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4256), 1,
      sym_number,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2966), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92454] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4258), 1,
      sym_number,
    STATE(2408), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92507] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4206), 1,
      sym_number,
    STATE(2508), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92560] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4118), 1,
      sym_number,
    STATE(2436), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92613] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    ACTIONS(1731), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1729), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92662] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1304), 1,
      anon_sym_RBRACE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(1683), 1,
      anon_sym_async,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92729] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    ACTIONS(4260), 1,
      anon_sym_RPAREN,
    STATE(1911), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3379), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92802] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4262), 1,
      sym_number,
    STATE(2393), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [92855] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    ACTIONS(4264), 1,
      anon_sym_RPAREN,
    STATE(1911), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3379), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92928] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1308), 1,
      anon_sym_RBRACE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(1683), 1,
      anon_sym_async,
    ACTIONS(1687), 1,
      sym_readonly,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92997] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4266), 1,
      sym_number,
    STATE(2177), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2966), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93050] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(1683), 1,
      anon_sym_async,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93117] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1308), 1,
      anon_sym_RBRACE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93182] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4160), 1,
      sym_number,
    STATE(2407), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93235] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    ACTIONS(4268), 1,
      anon_sym_RPAREN,
    STATE(1911), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3379), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93308] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93373] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4166), 1,
      sym_number,
    STATE(2432), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93426] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(1683), 1,
      anon_sym_async,
    ACTIONS(1687), 1,
      sym_readonly,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93495] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    STATE(2963), 1,
      aux_sym_object_repeat1,
    ACTIONS(1731), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1729), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93544] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1304), 1,
      anon_sym_RBRACE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93609] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1304), 1,
      anon_sym_RBRACE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(1683), 1,
      anon_sym_async,
    ACTIONS(1687), 1,
      sym_readonly,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93678] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4188), 1,
      sym_number,
    STATE(2385), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93731] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    ACTIONS(1731), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1729), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93780] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(1683), 1,
      anon_sym_async,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93842] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [93902] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3003), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93972] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(3002), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1731), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2938), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1729), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94020] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(1683), 1,
      anon_sym_async,
    ACTIONS(1687), 1,
      sym_readonly,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94084] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3154), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94154] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1304), 1,
      anon_sym_RBRACE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94214] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4228), 1,
      anon_sym_RBRACE,
    STATE(3124), 1,
      aux_sym_object_repeat1,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94274] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94334] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3147), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94404] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    STATE(1911), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3379), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4274), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4272), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94516] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4246), 1,
      anon_sym_RBRACE,
    STATE(2963), 1,
      aux_sym_object_repeat1,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94576] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1308), 1,
      anon_sym_RBRACE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94636] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      sym_readonly,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    STATE(2015), 1,
      sym_accessibility_modifier,
    STATE(2342), 1,
      sym__parameter_name,
    STATE(2537), 1,
      sym_array,
    STATE(2538), 1,
      sym_object,
    STATE(2829), 1,
      sym__rest_identifier,
    ACTIONS(4218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1717), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3263), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(1705), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94706] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1265), 1,
      anon_sym_type,
    ACTIONS(1267), 1,
      anon_sym_import,
    ACTIONS(1269), 1,
      anon_sym_var,
    ACTIONS(1271), 1,
      anon_sym_let,
    ACTIONS(1273), 1,
      anon_sym_const,
    ACTIONS(1288), 1,
      anon_sym_class,
    ACTIONS(1290), 1,
      anon_sym_async,
    ACTIONS(1292), 1,
      anon_sym_function,
    ACTIONS(1294), 1,
      anon_sym_abstract,
    ACTIONS(1300), 1,
      anon_sym_interface,
    ACTIONS(1302), 1,
      anon_sym_enum,
    ACTIONS(1330), 1,
      anon_sym_namespace,
    ACTIONS(1334), 1,
      anon_sym_declare,
    ACTIONS(1372), 1,
      anon_sym_global,
    ACTIONS(1394), 1,
      anon_sym_module,
    STATE(575), 1,
      sym_internal_module,
    STATE(625), 1,
      sym__declaration,
    STATE(1994), 1,
      sym_decorator,
    STATE(2655), 1,
      aux_sym_export_statement_repeat1,
    STATE(627), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [94785] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2936), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_type,
    ACTIONS(2942), 1,
      anon_sym_import,
    ACTIONS(2944), 1,
      anon_sym_var,
    ACTIONS(2946), 1,
      anon_sym_let,
    ACTIONS(2948), 1,
      anon_sym_const,
    ACTIONS(2950), 1,
      anon_sym_class,
    ACTIONS(2952), 1,
      anon_sym_async,
    ACTIONS(2954), 1,
      anon_sym_function,
    ACTIONS(2956), 1,
      anon_sym_abstract,
    ACTIONS(2958), 1,
      anon_sym_declare,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    ACTIONS(4276), 1,
      anon_sym_module,
    ACTIONS(4278), 1,
      anon_sym_global,
    STATE(1994), 1,
      sym_decorator,
    STATE(2673), 1,
      sym_internal_module,
    STATE(2769), 1,
      aux_sym_export_statement_repeat1,
    STATE(2781), 1,
      sym__declaration,
    STATE(2637), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [94864] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [94919] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(2936), 1,
      anon_sym_namespace,
    ACTIONS(2940), 1,
      anon_sym_type,
    ACTIONS(2942), 1,
      anon_sym_import,
    ACTIONS(2944), 1,
      anon_sym_var,
    ACTIONS(2946), 1,
      anon_sym_let,
    ACTIONS(2948), 1,
      anon_sym_const,
    ACTIONS(2950), 1,
      anon_sym_class,
    ACTIONS(2952), 1,
      anon_sym_async,
    ACTIONS(2954), 1,
      anon_sym_function,
    ACTIONS(2956), 1,
      anon_sym_abstract,
    ACTIONS(2958), 1,
      anon_sym_declare,
    ACTIONS(2960), 1,
      anon_sym_module,
    ACTIONS(2962), 1,
      anon_sym_interface,
    ACTIONS(2964), 1,
      anon_sym_enum,
    ACTIONS(4280), 1,
      anon_sym_default,
    STATE(1994), 1,
      sym_decorator,
    STATE(2673), 1,
      sym_internal_module,
    STATE(2769), 1,
      aux_sym_export_statement_repeat1,
    STATE(2791), 1,
      sym__declaration,
    STATE(2637), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [94998] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1259), 1,
      anon_sym_namespace,
    ACTIONS(1265), 1,
      anon_sym_type,
    ACTIONS(1267), 1,
      anon_sym_import,
    ACTIONS(1269), 1,
      anon_sym_var,
    ACTIONS(1271), 1,
      anon_sym_let,
    ACTIONS(1273), 1,
      anon_sym_const,
    ACTIONS(1288), 1,
      anon_sym_class,
    ACTIONS(1290), 1,
      anon_sym_async,
    ACTIONS(1292), 1,
      anon_sym_function,
    ACTIONS(1294), 1,
      anon_sym_abstract,
    ACTIONS(1296), 1,
      anon_sym_declare,
    ACTIONS(1300), 1,
      anon_sym_interface,
    ACTIONS(1302), 1,
      anon_sym_enum,
    ACTIONS(1370), 1,
      anon_sym_module,
    ACTIONS(1372), 1,
      anon_sym_global,
    STATE(575), 1,
      sym_internal_module,
    STATE(625), 1,
      sym__declaration,
    STATE(1994), 1,
      sym_decorator,
    STATE(2655), 1,
      aux_sym_export_statement_repeat1,
    STATE(627), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [95077] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1259), 1,
      anon_sym_namespace,
    ACTIONS(1265), 1,
      anon_sym_type,
    ACTIONS(1267), 1,
      anon_sym_import,
    ACTIONS(1269), 1,
      anon_sym_var,
    ACTIONS(1271), 1,
      anon_sym_let,
    ACTIONS(1273), 1,
      anon_sym_const,
    ACTIONS(1288), 1,
      anon_sym_class,
    ACTIONS(1290), 1,
      anon_sym_async,
    ACTIONS(1292), 1,
      anon_sym_function,
    ACTIONS(1294), 1,
      anon_sym_abstract,
    ACTIONS(1300), 1,
      anon_sym_interface,
    ACTIONS(1302), 1,
      anon_sym_enum,
    ACTIONS(1360), 1,
      anon_sym_declare,
    ACTIONS(1372), 1,
      anon_sym_global,
    ACTIONS(1496), 1,
      anon_sym_module,
    STATE(575), 1,
      sym_internal_module,
    STATE(625), 1,
      sym__declaration,
    STATE(1994), 1,
      sym_decorator,
    STATE(2655), 1,
      aux_sym_export_statement_repeat1,
    STATE(627), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [95156] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1265), 1,
      anon_sym_type,
    ACTIONS(1267), 1,
      anon_sym_import,
    ACTIONS(1269), 1,
      anon_sym_var,
    ACTIONS(1271), 1,
      anon_sym_let,
    ACTIONS(1273), 1,
      anon_sym_const,
    ACTIONS(1288), 1,
      anon_sym_class,
    ACTIONS(1290), 1,
      anon_sym_async,
    ACTIONS(1292), 1,
      anon_sym_function,
    ACTIONS(1294), 1,
      anon_sym_abstract,
    ACTIONS(1300), 1,
      anon_sym_interface,
    ACTIONS(1302), 1,
      anon_sym_enum,
    ACTIONS(1330), 1,
      anon_sym_namespace,
    ACTIONS(1334), 1,
      anon_sym_declare,
    ACTIONS(1336), 1,
      anon_sym_module,
    ACTIONS(4282), 1,
      anon_sym_default,
    STATE(575), 1,
      sym_internal_module,
    STATE(612), 1,
      sym__declaration,
    STATE(1994), 1,
      sym_decorator,
    STATE(2655), 1,
      aux_sym_export_statement_repeat1,
    STATE(627), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [95235] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1259), 1,
      anon_sym_namespace,
    ACTIONS(1265), 1,
      anon_sym_type,
    ACTIONS(1267), 1,
      anon_sym_import,
    ACTIONS(1269), 1,
      anon_sym_var,
    ACTIONS(1271), 1,
      anon_sym_let,
    ACTIONS(1273), 1,
      anon_sym_const,
    ACTIONS(1288), 1,
      anon_sym_class,
    ACTIONS(1290), 1,
      anon_sym_async,
    ACTIONS(1292), 1,
      anon_sym_function,
    ACTIONS(1294), 1,
      anon_sym_abstract,
    ACTIONS(1296), 1,
      anon_sym_declare,
    ACTIONS(1298), 1,
      anon_sym_module,
    ACTIONS(1300), 1,
      anon_sym_interface,
    ACTIONS(1302), 1,
      anon_sym_enum,
    ACTIONS(4282), 1,
      anon_sym_default,
    STATE(575), 1,
      sym_internal_module,
    STATE(612), 1,
      sym__declaration,
    STATE(1994), 1,
      sym_decorator,
    STATE(2655), 1,
      aux_sym_export_statement_repeat1,
    STATE(627), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [95314] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1259), 1,
      anon_sym_namespace,
    ACTIONS(1265), 1,
      anon_sym_type,
    ACTIONS(1267), 1,
      anon_sym_import,
    ACTIONS(1269), 1,
      anon_sym_var,
    ACTIONS(1271), 1,
      anon_sym_let,
    ACTIONS(1273), 1,
      anon_sym_const,
    ACTIONS(1288), 1,
      anon_sym_class,
    ACTIONS(1290), 1,
      anon_sym_async,
    ACTIONS(1292), 1,
      anon_sym_function,
    ACTIONS(1294), 1,
      anon_sym_abstract,
    ACTIONS(1298), 1,
      anon_sym_module,
    ACTIONS(1300), 1,
      anon_sym_interface,
    ACTIONS(1302), 1,
      anon_sym_enum,
    ACTIONS(1360), 1,
      anon_sym_declare,
    ACTIONS(4282), 1,
      anon_sym_default,
    STATE(575), 1,
      sym_internal_module,
    STATE(612), 1,
      sym__declaration,
    STATE(1994), 1,
      sym_decorator,
    STATE(2655), 1,
      aux_sym_export_statement_repeat1,
    STATE(627), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [95393] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4246), 1,
      anon_sym_RBRACE,
    STATE(2963), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1731), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1729), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4236), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95483] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1308), 1,
      anon_sym_RBRACE,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1731), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1729), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3333), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95573] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1731), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1729), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95623] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4228), 1,
      anon_sym_RBRACE,
    STATE(3124), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1731), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1729), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95673] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1304), 1,
      anon_sym_RBRACE,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1731), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1729), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3347), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3345), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3154), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3152), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4286), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4284), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95843] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1731), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(1729), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4290), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4288), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95926] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4292), 1,
      anon_sym_STAR,
    ACTIONS(4294), 1,
      sym_number,
    ACTIONS(4296), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2480), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [95978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4300), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4298), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4304), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4302), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4308), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4306), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4312), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4310), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1051), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1053), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96168] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4314), 1,
      anon_sym_STAR,
    ACTIONS(4316), 1,
      anon_sym_async,
    ACTIONS(4318), 1,
      sym_number,
    ACTIONS(4322), 1,
      sym_readonly,
    ACTIONS(4320), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2500), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96224] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4324), 1,
      anon_sym_STAR,
    ACTIONS(4326), 1,
      sym_number,
    ACTIONS(4328), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2476), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4332), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4330), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96314] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4314), 1,
      anon_sym_STAR,
    ACTIONS(4316), 1,
      anon_sym_async,
    ACTIONS(4318), 1,
      sym_number,
    ACTIONS(4320), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2500), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4334), 1,
      sym__automatic_semicolon,
    ACTIONS(973), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(975), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96408] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4292), 1,
      anon_sym_STAR,
    ACTIONS(4294), 1,
      sym_number,
    ACTIONS(4336), 1,
      anon_sym_async,
    ACTIONS(4296), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2480), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1095), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4340), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4338), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96538] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4318), 1,
      sym_number,
    ACTIONS(4342), 1,
      anon_sym_EQ_GT,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2500), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4344), 1,
      sym__automatic_semicolon,
    ACTIONS(1093), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1095), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4348), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4346), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4352), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4350), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4356), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4354), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96742] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4314), 1,
      anon_sym_STAR,
    ACTIONS(4318), 1,
      sym_number,
    ACTIONS(4320), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2500), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4360), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4358), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96832] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4366), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4364), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4362), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4370), 10,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4368), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96910] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4372), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [96957] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4112), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97004] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4206), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2508), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97051] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    STATE(2625), 1,
      sym_array,
    STATE(2635), 1,
      sym_object,
    ACTIONS(4374), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2269), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4376), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97098] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4128), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2389), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97145] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4118), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2436), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97192] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4378), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97239] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4318), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2500), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97286] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    STATE(2621), 1,
      sym_array,
    STATE(2624), 1,
      sym_object,
    ACTIONS(1783), 2,
      sym_identifier,
      sym_this,
    ACTIONS(1794), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(853), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97333] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4156), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2485), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97380] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4380), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2507), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97427] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4382), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2447), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97474] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4294), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2480), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97521] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4326), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2476), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97568] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4166), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2432), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97615] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4200), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2431), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97662] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4124), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2450), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97709] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4188), 1,
      sym_number,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2385), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97756] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4384), 1,
      anon_sym_RBRACE,
    ACTIONS(4386), 1,
      sym_number,
    STATE(3225), 1,
      sym_enum_assignment,
    STATE(2875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97804] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4100), 1,
      anon_sym_STAR,
    ACTIONS(4102), 1,
      anon_sym_async,
    ACTIONS(4104), 1,
      sym_number,
    ACTIONS(4388), 1,
      anon_sym_static,
    ACTIONS(4390), 1,
      anon_sym_abstract,
    ACTIONS(4392), 1,
      sym_readonly,
    ACTIONS(4108), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2048), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2966), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97860] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4386), 1,
      sym_number,
    ACTIONS(4394), 1,
      anon_sym_RBRACE,
    STATE(3225), 1,
      sym_enum_assignment,
    STATE(2875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97908] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4396), 1,
      anon_sym_RBRACE,
    ACTIONS(4398), 1,
      sym_number,
    STATE(3106), 1,
      sym_enum_assignment,
    STATE(2639), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3876), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4400), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [97992] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4406), 1,
      anon_sym_AT,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
    ACTIONS(4404), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4402), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98034] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4409), 1,
      anon_sym_RBRACE,
    ACTIONS(4411), 1,
      sym_number,
    STATE(3123), 1,
      sym_enum_assignment,
    STATE(2597), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98082] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4386), 1,
      sym_number,
    ACTIONS(4413), 1,
      anon_sym_RBRACE,
    STATE(3225), 1,
      sym_enum_assignment,
    STATE(2875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98130] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4386), 1,
      sym_number,
    ACTIONS(4415), 1,
      anon_sym_RBRACE,
    STATE(3225), 1,
      sym_enum_assignment,
    STATE(2875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98178] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4417), 1,
      anon_sym_STAR,
    ACTIONS(4419), 1,
      sym_number,
    ACTIONS(4423), 1,
      sym_readonly,
    ACTIONS(4421), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2045), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98227] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(1683), 1,
      anon_sym_async,
    ACTIONS(1687), 1,
      sym_readonly,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4226), 1,
      anon_sym_STAR,
    ACTIONS(4425), 1,
      anon_sym_static,
    ACTIONS(1685), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98280] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4146), 1,
      anon_sym_STAR,
    ACTIONS(4148), 1,
      anon_sym_async,
    ACTIONS(4150), 1,
      sym_number,
    ACTIONS(4154), 1,
      sym_readonly,
    ACTIONS(4427), 1,
      anon_sym_static,
    ACTIONS(4152), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2058), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2966), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98333] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4060), 1,
      sym_number,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4068), 1,
      sym_readonly,
    ACTIONS(4429), 1,
      anon_sym_static,
    ACTIONS(4062), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2966), 14,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98386] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4431), 1,
      anon_sym_STAR,
    ACTIONS(4433), 1,
      sym_number,
    ACTIONS(4437), 1,
      sym_readonly,
    ACTIONS(4435), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2047), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2966), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98435] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4386), 1,
      sym_number,
    STATE(3225), 1,
      sym_enum_assignment,
    STATE(2875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1731), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(1794), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1729), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98517] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4258), 1,
      sym_number,
    STATE(2408), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98559] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4166), 1,
      sym_number,
    STATE(2432), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98601] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4380), 1,
      sym_number,
    STATE(2507), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98643] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4206), 1,
      sym_number,
    STATE(2508), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 4,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AT,
    ACTIONS(4439), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98719] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(1539), 1,
      sym_number,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    STATE(2459), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98761] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4072), 1,
      sym_number,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98803] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4188), 1,
      sym_number,
    STATE(2385), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98845] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4378), 1,
      sym_number,
    STATE(2528), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98887] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4256), 1,
      sym_number,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2966), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98929] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4180), 1,
      sym_number,
    STATE(2402), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [98971] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4318), 1,
      sym_number,
    STATE(2500), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99013] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4326), 1,
      sym_number,
    STATE(2476), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99055] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4112), 1,
      sym_number,
    STATE(2467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99097] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4128), 1,
      sym_number,
    STATE(2389), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99139] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4294), 1,
      sym_number,
    STATE(2480), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99181] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4262), 1,
      sym_number,
    STATE(2393), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99223] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4382), 1,
      sym_number,
    STATE(2447), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99265] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4124), 1,
      sym_number,
    STATE(2450), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99307] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4066), 1,
      anon_sym_LBRACK,
    ACTIONS(4266), 1,
      sym_number,
    STATE(2177), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2966), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99349] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4200), 1,
      sym_number,
    STATE(2431), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99391] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4118), 1,
      sym_number,
    STATE(2436), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99433] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4372), 1,
      sym_number,
    STATE(2449), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99475] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4156), 1,
      sym_number,
    STATE(2485), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99517] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4070), 1,
      anon_sym_LBRACK,
    ACTIONS(4160), 1,
      sym_number,
    STATE(2407), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1681), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99559] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4443), 1,
      sym_readonly,
    STATE(2621), 1,
      sym_array,
    STATE(2624), 1,
      sym_object,
    ACTIONS(1783), 2,
      sym_identifier,
      sym_this,
    ACTIONS(853), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4445), 1,
      sym_identifier,
    STATE(3433), 1,
      sym_mapped_type_clause,
    ACTIONS(4447), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [99631] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(4449), 1,
      anon_sym_LT,
    ACTIONS(4451), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1621), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99663] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4455), 1,
      anon_sym_EQ,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4459), 1,
      anon_sym_COMMA,
    ACTIONS(4461), 1,
      anon_sym_COLON,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(4465), 1,
      anon_sym_GT,
    ACTIONS(4468), 1,
      anon_sym_SLASH,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4474), 1,
      anon_sym_extends,
    STATE(2175), 1,
      sym_type_arguments,
    STATE(2224), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2890), 1,
      sym_constraint,
    STATE(3209), 1,
      sym_default_type,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [99719] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4455), 1,
      anon_sym_EQ,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4459), 1,
      anon_sym_COMMA,
    ACTIONS(4461), 1,
      anon_sym_COLON,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(4465), 1,
      anon_sym_GT,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4474), 1,
      anon_sym_extends,
    ACTIONS(4476), 1,
      anon_sym_SLASH,
    STATE(2192), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2193), 1,
      sym_type_arguments,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2890), 1,
      sym_constraint,
    STATE(3209), 1,
      sym_default_type,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [99775] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4455), 1,
      anon_sym_EQ,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4459), 1,
      anon_sym_COMMA,
    ACTIONS(4461), 1,
      anon_sym_COLON,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(4465), 1,
      anon_sym_GT,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4474), 1,
      anon_sym_extends,
    ACTIONS(4478), 1,
      anon_sym_SLASH,
    STATE(2201), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2202), 1,
      sym_type_arguments,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2890), 1,
      sym_constraint,
    STATE(3209), 1,
      sym_default_type,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [99831] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_EQ,
    ACTIONS(4449), 1,
      anon_sym_LT,
    ACTIONS(4480), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1759), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1777), 1,
      anon_sym_EQ,
    ACTIONS(4449), 1,
      anon_sym_LT,
    ACTIONS(4480), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1775), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 1,
      anon_sym_EQ,
    ACTIONS(4449), 1,
      anon_sym_LT,
    STATE(427), 1,
      sym_type_arguments,
    ACTIONS(1798), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1603), 1,
      anon_sym_EQ,
    ACTIONS(4449), 1,
      anon_sym_LT,
    STATE(427), 1,
      sym_type_arguments,
    ACTIONS(1601), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 1,
      anon_sym_EQ,
    ACTIONS(1543), 1,
      anon_sym_LT,
    ACTIONS(1059), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [99980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1049), 1,
      anon_sym_PIPE,
    ACTIONS(1047), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_EQ,
    ACTIONS(4451), 1,
      anon_sym_DOT,
    ACTIONS(1621), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [100030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 1,
      anon_sym_PIPE,
    ACTIONS(1163), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100054] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1840), 1,
      anon_sym_EQ,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(1838), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
  [100081] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_EQ,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(1824), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [100110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4488), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [100131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4490), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [100152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4492), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [100173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4494), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [100194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4496), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [100215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4498), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [100236] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_EQ,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(1844), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [100265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_PIPE,
    ACTIONS(4500), 1,
      anon_sym_LT,
    ACTIONS(4502), 1,
      anon_sym_DOT,
    STATE(2091), 1,
      sym_type_arguments,
    ACTIONS(1759), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100293] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_PIPE,
    ACTIONS(4500), 1,
      anon_sym_LT,
    ACTIONS(4502), 1,
      anon_sym_DOT,
    ACTIONS(4504), 1,
      anon_sym_is,
    STATE(2091), 1,
      sym_type_arguments,
    ACTIONS(1759), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100323] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1777), 1,
      anon_sym_PIPE,
    ACTIONS(4500), 1,
      anon_sym_LT,
    ACTIONS(4502), 1,
      anon_sym_DOT,
    STATE(2091), 1,
      sym_type_arguments,
    ACTIONS(1775), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100351] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_extends,
    ACTIONS(4449), 1,
      anon_sym_LT,
    ACTIONS(4480), 1,
      anon_sym_DOT,
    ACTIONS(4510), 1,
      anon_sym_GT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(4506), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4508), 2,
      anon_sym_LBRACE,
      sym_jsx_identifier,
    ACTIONS(1759), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [100385] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    ACTIONS(4517), 1,
      anon_sym_BANG,
    ACTIONS(4519), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2562), 1,
      sym__call_signature,
    STATE(2720), 1,
      sym_type_annotation,
    STATE(2992), 1,
      sym__initializer,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4515), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100427] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    ACTIONS(4523), 1,
      anon_sym_BANG,
    ACTIONS(4525), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2543), 1,
      sym__call_signature,
    STATE(2775), 1,
      sym_type_annotation,
    STATE(3028), 1,
      sym__initializer,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4521), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_PIPE,
    ACTIONS(4500), 1,
      anon_sym_LT,
    ACTIONS(4527), 1,
      anon_sym_DOT,
    STATE(2091), 1,
      sym_type_arguments,
    ACTIONS(1621), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100497] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    ACTIONS(4531), 1,
      anon_sym_BANG,
    ACTIONS(4533), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2742), 1,
      sym_type_annotation,
    STATE(3035), 1,
      sym__initializer,
    STATE(3063), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4529), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100539] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    ACTIONS(4531), 1,
      anon_sym_BANG,
    ACTIONS(4535), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2679), 1,
      sym__call_signature,
    STATE(2742), 1,
      sym_type_annotation,
    STATE(3035), 1,
      sym__initializer,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4529), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100581] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    ACTIONS(4539), 1,
      anon_sym_BANG,
    ACTIONS(4541), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2534), 1,
      sym_type_annotation,
    STATE(3119), 1,
      sym__call_signature,
    STATE(3151), 1,
      sym__initializer,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4537), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100623] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    ACTIONS(4539), 1,
      anon_sym_BANG,
    ACTIONS(4543), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2534), 1,
      sym_type_annotation,
    STATE(2539), 1,
      sym__call_signature,
    STATE(3151), 1,
      sym__initializer,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4537), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100665] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(4547), 1,
      anon_sym_GT,
    ACTIONS(4549), 1,
      anon_sym_SLASH,
    STATE(2220), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2221), 1,
      sym_type_arguments,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [100706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_DOT,
    ACTIONS(1545), 1,
      anon_sym_PIPE,
    ACTIONS(1543), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100729] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4553), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2321), 1,
      sym__call_signature,
    STATE(2797), 1,
      sym_type_annotation,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4551), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 1,
      anon_sym_PIPE,
    ACTIONS(1543), 1,
      anon_sym_LT,
    ACTIONS(1059), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100787] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 1,
      anon_sym_PIPE,
    ACTIONS(4500), 1,
      anon_sym_LT,
    STATE(2120), 1,
      sym_type_arguments,
    ACTIONS(1798), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [100812] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(4547), 1,
      anon_sym_GT,
    ACTIONS(4555), 1,
      anon_sym_SLASH,
    STATE(2222), 1,
      sym_type_arguments,
    STATE(2227), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [100853] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4559), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2318), 1,
      sym__call_signature,
    STATE(2687), 1,
      sym_type_annotation,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4557), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100888] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4561), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2687), 1,
      sym_type_annotation,
    STATE(2698), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4557), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100923] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4565), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2339), 1,
      sym__call_signature,
    STATE(2558), 1,
      sym_type_annotation,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4563), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100958] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4567), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2558), 1,
      sym_type_annotation,
    STATE(2785), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4563), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100993] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4569), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2762), 1,
      sym__call_signature,
    STATE(2797), 1,
      sym_type_annotation,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4551), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101028] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4573), 1,
      anon_sym_COLON,
    ACTIONS(4575), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2354), 1,
      sym__call_signature,
    STATE(2758), 1,
      sym_type_annotation,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4571), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101063] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4577), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2746), 1,
      sym__call_signature,
    STATE(2758), 1,
      sym_type_annotation,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4571), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1603), 1,
      anon_sym_PIPE,
    ACTIONS(4500), 1,
      anon_sym_LT,
    STATE(2120), 1,
      sym_type_arguments,
    ACTIONS(1601), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101123] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4449), 1,
      anon_sym_LT,
    ACTIONS(4455), 1,
      anon_sym_EQ,
    ACTIONS(4480), 1,
      anon_sym_DOT,
    ACTIONS(4582), 1,
      anon_sym_COLON,
    ACTIONS(4584), 1,
      anon_sym_extends,
    STATE(428), 1,
      sym_type_arguments,
    STATE(2890), 1,
      sym_constraint,
    STATE(3209), 1,
      sym_default_type,
    ACTIONS(4579), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(1759), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [101160] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2744), 1,
      sym_type_annotation,
    STATE(3049), 1,
      sym__initializer,
    STATE(3064), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4587), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101196] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4478), 1,
      anon_sym_SLASH,
    ACTIONS(4547), 1,
      anon_sym_GT,
    STATE(2201), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2202), 1,
      sym_type_arguments,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [101234] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4449), 1,
      anon_sym_LT,
    ACTIONS(4480), 1,
      anon_sym_DOT,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1759), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(4589), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [101260] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2614), 1,
      sym__call_signature,
    STATE(2666), 1,
      sym_type_annotation,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4591), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101292] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2316), 1,
      sym__call_signature,
    STATE(2585), 1,
      sym_type_annotation,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4593), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101324] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2545), 1,
      sym__call_signature,
    STATE(2585), 1,
      sym_type_annotation,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4593), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101356] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4547), 1,
      anon_sym_GT,
    ACTIONS(4555), 1,
      anon_sym_SLASH,
    STATE(2222), 1,
      sym_type_arguments,
    STATE(2227), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [101394] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2542), 1,
      sym__call_signature,
    STATE(2801), 1,
      sym_type_annotation,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4595), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101426] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2295), 1,
      sym__call_signature,
    STATE(2666), 1,
      sym_type_annotation,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4591), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101458] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(4468), 1,
      anon_sym_SLASH,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4547), 1,
      anon_sym_GT,
    STATE(2175), 1,
      sym_type_arguments,
    STATE(2224), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [101496] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2744), 1,
      sym_type_annotation,
    STATE(2754), 1,
      sym__call_signature,
    STATE(3049), 1,
      sym__initializer,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4587), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101532] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2640), 1,
      sym_type_annotation,
    STATE(2650), 1,
      sym__call_signature,
    STATE(3110), 1,
      sym__initializer,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4597), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101568] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2550), 1,
      sym__call_signature,
    STATE(2571), 1,
      sym_type_annotation,
    STATE(2968), 1,
      sym__initializer,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4599), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101604] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_LT,
    ACTIONS(4603), 1,
      anon_sym_DOT,
    ACTIONS(4605), 1,
      anon_sym_is,
    STATE(2243), 1,
      sym_type_arguments,
    ACTIONS(1759), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [101630] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2320), 1,
      sym__call_signature,
    STATE(2692), 1,
      sym_type_annotation,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4607), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101662] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2325), 1,
      sym__call_signature,
    STATE(2801), 1,
      sym_type_annotation,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4595), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101694] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2692), 1,
      sym_type_annotation,
    STATE(2734), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4607), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_PIPE,
    ACTIONS(4527), 1,
      anon_sym_DOT,
    ACTIONS(1621), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101748] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2716), 1,
      sym_type_annotation,
    STATE(2729), 1,
      sym__call_signature,
    STATE(3066), 1,
      sym__initializer,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4609), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101784] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4449), 1,
      anon_sym_LT,
    ACTIONS(4480), 1,
      anon_sym_DOT,
    ACTIONS(4611), 1,
      anon_sym_RPAREN,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1759), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(2884), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [101812] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4547), 1,
      anon_sym_GT,
    ACTIONS(4549), 1,
      anon_sym_SLASH,
    STATE(2220), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2221), 1,
      sym_type_arguments,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [101850] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4476), 1,
      anon_sym_SLASH,
    ACTIONS(4547), 1,
      anon_sym_GT,
    STATE(2192), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2193), 1,
      sym_type_arguments,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [101888] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2571), 1,
      sym_type_annotation,
    STATE(2957), 1,
      sym__call_signature,
    STATE(2968), 1,
      sym__initializer,
    STATE(3320), 1,
      sym_type_parameters,
    ACTIONS(4599), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1655), 1,
      anon_sym_PIPE,
    ACTIONS(1653), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_PIPE,
    ACTIONS(1585), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1591), 1,
      anon_sym_PIPE,
    ACTIONS(1589), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [101981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1579), 1,
      anon_sym_PIPE,
    ACTIONS(1577), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 1,
      anon_sym_PIPE,
    ACTIONS(1551), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1663), 1,
      anon_sym_PIPE,
    ACTIONS(1661), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_AMP,
    ACTIONS(4616), 1,
      anon_sym_PIPE,
    ACTIONS(1838), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [102080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 1,
      anon_sym_PIPE,
    ACTIONS(1593), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 1,
      anon_sym_PIPE,
    ACTIONS(1605), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(4618), 1,
      anon_sym_LBRACK,
    ACTIONS(1609), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1615), 1,
      anon_sym_PIPE,
    ACTIONS(1613), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 1,
      anon_sym_PIPE,
    ACTIONS(1563), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 1,
      anon_sym_PIPE,
    ACTIONS(1677), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_AMP,
    ACTIONS(4616), 1,
      anon_sym_PIPE,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(1824), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [102238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1659), 1,
      anon_sym_PIPE,
    ACTIONS(1657), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_PIPE,
    ACTIONS(1559), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 1,
      anon_sym_PIPE,
    ACTIONS(4504), 1,
      anon_sym_is,
    ACTIONS(1798), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_PIPE,
    ACTIONS(1645), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1667), 1,
      anon_sym_PIPE,
    ACTIONS(1665), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_AMP,
    ACTIONS(4616), 1,
      anon_sym_PIPE,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(1844), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [102358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1619), 1,
      anon_sym_PIPE,
    ACTIONS(1617), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1627), 1,
      anon_sym_PIPE,
    ACTIONS(1625), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_PIPE,
    ACTIONS(1633), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_LT,
    ACTIONS(4603), 1,
      anon_sym_DOT,
    STATE(2243), 1,
      sym_type_arguments,
    ACTIONS(1775), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_PIPE,
    ACTIONS(1585), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
    ACTIONS(1581), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_LT,
    ACTIONS(4622), 1,
      anon_sym_DOT,
    STATE(2243), 1,
      sym_type_arguments,
    ACTIONS(1621), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1557), 1,
      anon_sym_PIPE,
    ACTIONS(1555), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1671), 1,
      anon_sym_PIPE,
    ACTIONS(1669), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1651), 1,
      anon_sym_PIPE,
    ACTIONS(1649), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1643), 1,
      anon_sym_PIPE,
    ACTIONS(1641), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1639), 1,
      anon_sym_PIPE,
    ACTIONS(1637), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 1,
      anon_sym_PIPE,
    ACTIONS(1547), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2938), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [102613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 1,
      anon_sym_PIPE,
    ACTIONS(1567), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 1,
      anon_sym_PIPE,
    ACTIONS(1597), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1603), 1,
      anon_sym_PIPE,
    ACTIONS(1601), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102670] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_LT,
    ACTIONS(4603), 1,
      anon_sym_DOT,
    STATE(2243), 1,
      sym_type_arguments,
    ACTIONS(1759), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3746), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [102710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [102731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [102752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1675), 1,
      anon_sym_PIPE,
    ACTIONS(1673), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1573), 1,
      anon_sym_PIPE,
    ACTIONS(4618), 1,
      anon_sym_LBRACK,
    ACTIONS(1571), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    STATE(2963), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [102813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 1,
      anon_sym_PIPE,
    ACTIONS(1229), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1631), 1,
      anon_sym_PIPE,
    ACTIONS(1629), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [102851] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_AMP,
    ACTIONS(4616), 1,
      anon_sym_PIPE,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(4624), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102873] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4626), 1,
      sym_identifier,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4630), 1,
      anon_sym_implements,
    ACTIONS(4632), 1,
      anon_sym_extends,
    STATE(1622), 1,
      sym_class_body,
    STATE(2299), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3308), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [102907] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(4547), 1,
      anon_sym_GT,
    ACTIONS(4555), 1,
      anon_sym_SLASH,
    STATE(2227), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [102939] = 7,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4636), 1,
      anon_sym_LT,
    ACTIONS(4638), 1,
      sym_jsx_text,
    ACTIONS(4640), 1,
      sym_comment,
    STATE(1704), 1,
      sym_jsx_closing_element,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2230), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [102965] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4630), 1,
      anon_sym_implements,
    ACTIONS(4632), 1,
      anon_sym_extends,
    ACTIONS(4642), 1,
      sym_identifier,
    STATE(1622), 1,
      sym_class_body,
    STATE(2299), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3308), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [102999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(3002), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2938), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [103019] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4449), 1,
      anon_sym_LT,
    ACTIONS(4480), 1,
      anon_sym_DOT,
    ACTIONS(4644), 1,
      anon_sym_is,
    STATE(428), 1,
      sym_type_arguments,
    ACTIONS(1759), 6,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103043] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4648), 1,
      anon_sym_COLON,
    STATE(2424), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(4646), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103063] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4468), 1,
      anon_sym_SLASH,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(4547), 1,
      anon_sym_GT,
    STATE(2224), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [103095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_LT,
    STATE(2261), 1,
      sym_type_arguments,
    ACTIONS(1798), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103115] = 7,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LT,
    ACTIONS(4652), 1,
      sym_jsx_text,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(3091), 1,
      sym_jsx_closing_element,
    STATE(2146), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [103141] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4630), 1,
      anon_sym_implements,
    ACTIONS(4632), 1,
      anon_sym_extends,
    ACTIONS(4654), 1,
      sym_identifier,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    STATE(1740), 1,
      sym_class_body,
    STATE(2309), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3371), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [103175] = 7,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4638), 1,
      sym_jsx_text,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LT,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(3032), 1,
      sym_jsx_closing_element,
    STATE(2230), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [103201] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4630), 1,
      anon_sym_implements,
    ACTIONS(4632), 1,
      anon_sym_extends,
    ACTIONS(4658), 1,
      sym_identifier,
    STATE(1622), 1,
      sym_class_body,
    STATE(2299), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3308), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [103235] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4630), 1,
      anon_sym_implements,
    ACTIONS(4632), 1,
      anon_sym_extends,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    ACTIONS(4660), 1,
      sym_identifier,
    STATE(1731), 1,
      sym_class_body,
    STATE(2323), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3394), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [103269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_DOT,
    ACTIONS(1543), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103287] = 7,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4662), 1,
      anon_sym_LT,
    ACTIONS(4664), 1,
      sym_jsx_text,
    STATE(1781), 1,
      sym_jsx_closing_element,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2156), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [103313] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(2922), 1,
      anon_sym_LBRACE,
    ACTIONS(4666), 1,
      sym_identifier,
    ACTIONS(4668), 1,
      anon_sym_STAR,
    STATE(3244), 1,
      sym_import_clause,
    STATE(3242), 2,
      sym_string,
      sym_import_require_clause,
    STATE(3542), 2,
      sym_namespace_import,
      sym_named_imports,
  [103343] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4630), 1,
      anon_sym_implements,
    ACTIONS(4632), 1,
      anon_sym_extends,
    ACTIONS(4670), 1,
      sym_identifier,
    STATE(1714), 1,
      sym_class_body,
    STATE(2338), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3304), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [103377] = 7,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4638), 1,
      sym_jsx_text,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4672), 1,
      anon_sym_LT,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2750), 1,
      sym_jsx_closing_element,
    STATE(2230), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [103403] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4630), 1,
      anon_sym_implements,
    ACTIONS(4632), 1,
      anon_sym_extends,
    ACTIONS(4674), 1,
      sym_identifier,
    STATE(1714), 1,
      sym_class_body,
    STATE(2338), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3304), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [103437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1543), 1,
      anon_sym_LT,
    ACTIONS(1059), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103455] = 7,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4638), 1,
      sym_jsx_text,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4662), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_jsx_closing_element,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2230), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [103481] = 7,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4672), 1,
      anon_sym_LT,
    ACTIONS(4676), 1,
      sym_jsx_text,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2711), 1,
      sym_jsx_closing_element,
    STATE(2153), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [103507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_LT,
    STATE(2261), 1,
      sym_type_arguments,
    ACTIONS(1601), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [103527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4648), 1,
      anon_sym_COLON,
    STATE(2401), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(4678), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103547] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4680), 1,
      anon_sym_LT,
    ACTIONS(4682), 1,
      anon_sym_DQUOTE,
    ACTIONS(4684), 1,
      anon_sym_SQUOTE,
    STATE(2157), 1,
      sym_jsx_opening_element,
    STATE(2602), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [103573] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4680), 1,
      anon_sym_LT,
    ACTIONS(4682), 1,
      anon_sym_DQUOTE,
    ACTIONS(4684), 1,
      anon_sym_SQUOTE,
    STATE(2157), 1,
      sym_jsx_opening_element,
    STATE(2688), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [103599] = 7,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4636), 1,
      anon_sym_LT,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4686), 1,
      sym_jsx_text,
    STATE(1587), 1,
      sym_jsx_closing_element,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2137), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [103625] = 7,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4688), 1,
      anon_sym_LT,
    ACTIONS(4690), 1,
      sym_jsx_text,
    STATE(1232), 1,
      sym_jsx_closing_element,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2170), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [103651] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4630), 1,
      anon_sym_implements,
    ACTIONS(4632), 1,
      anon_sym_extends,
    ACTIONS(4692), 1,
      sym_identifier,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    STATE(1265), 1,
      sym_class_body,
    STATE(2363), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3186), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [103685] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4630), 1,
      anon_sym_implements,
    ACTIONS(4632), 1,
      anon_sym_extends,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    ACTIONS(4696), 1,
      sym_identifier,
    STATE(1221), 1,
      sym_class_body,
    STATE(2302), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3294), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [103719] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4476), 1,
      anon_sym_SLASH,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(4547), 1,
      anon_sym_GT,
    STATE(2192), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [103751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_EQ,
    ACTIONS(3746), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [103769] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(4547), 1,
      anon_sym_GT,
    ACTIONS(4549), 1,
      anon_sym_SLASH,
    STATE(2220), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [103801] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4630), 1,
      anon_sym_implements,
    ACTIONS(4632), 1,
      anon_sym_extends,
    ACTIONS(4698), 1,
      sym_identifier,
    STATE(1714), 1,
      sym_class_body,
    STATE(2338), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3304), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [103835] = 7,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4638), 1,
      sym_jsx_text,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4688), 1,
      anon_sym_LT,
    STATE(1236), 1,
      sym_jsx_closing_element,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2230), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [103861] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4478), 1,
      anon_sym_SLASH,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(4547), 1,
      anon_sym_GT,
    STATE(2201), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [103893] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1588), 1,
      sym_class_body,
    STATE(2330), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3329), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [103924] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1641), 1,
      sym_class_body,
    STATE(2369), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3182), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [103955] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4704), 1,
      sym_identifier,
    ACTIONS(4706), 1,
      anon_sym_RBRACK,
    STATE(3001), 1,
      sym__rest_identifier,
    STATE(3114), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2872), 3,
      sym_rest_identifier,
      sym_optional_identifier,
      sym__tuple_type_identifier,
  [103980] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4708), 1,
      anon_sym_GT,
    ACTIONS(4710), 1,
      anon_sym_SLASH,
    STATE(2197), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104009] = 6,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4638), 1,
      sym_jsx_text,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4712), 1,
      anon_sym_LT,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2230), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [104032] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2742), 1,
      sym_type_annotation,
    STATE(3035), 1,
      sym__initializer,
    ACTIONS(4531), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4529), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104057] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4714), 1,
      anon_sym_GT,
    ACTIONS(4716), 1,
      anon_sym_SLASH,
    STATE(2203), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104086] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4476), 1,
      anon_sym_SLASH,
    ACTIONS(4547), 1,
      anon_sym_GT,
    STATE(2192), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104115] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2349), 1,
      sym_type_parameters,
    STATE(2798), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3218), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [104146] = 6,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4638), 1,
      sym_jsx_text,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4720), 1,
      anon_sym_LT,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2230), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [104169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4722), 1,
      anon_sym_RPAREN,
    ACTIONS(1798), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(2884), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [104188] = 6,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4725), 1,
      anon_sym_LT,
    ACTIONS(4727), 1,
      sym_jsx_text,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2181), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [104211] = 6,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4638), 1,
      sym_jsx_text,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4729), 1,
      anon_sym_LT,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2230), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [104234] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1229), 1,
      sym_class_body,
    STATE(2359), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3193), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [104265] = 6,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4731), 1,
      anon_sym_LT,
    ACTIONS(4733), 1,
      sym_jsx_text,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2184), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [104288] = 6,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4638), 1,
      sym_jsx_text,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4735), 1,
      anon_sym_LT,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2230), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [104311] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2720), 1,
      sym_type_annotation,
    STATE(2992), 1,
      sym__initializer,
    ACTIONS(4517), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(4515), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104336] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4704), 1,
      sym_identifier,
    ACTIONS(4737), 1,
      anon_sym_RBRACK,
    STATE(3001), 1,
      sym__rest_identifier,
    STATE(3083), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2872), 3,
      sym_rest_identifier,
      sym_optional_identifier,
      sym__tuple_type_identifier,
  [104361] = 6,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4739), 1,
      anon_sym_LT,
    ACTIONS(4741), 1,
      sym_jsx_text,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2187), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [104384] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1490), 1,
      sym_class_body,
    STATE(2346), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3227), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [104415] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4743), 1,
      anon_sym_GT,
    ACTIONS(4745), 1,
      anon_sym_SLASH,
    STATE(2203), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104444] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4708), 1,
      anon_sym_GT,
    ACTIONS(4747), 1,
      anon_sym_SLASH,
    STATE(2204), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104473] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4478), 1,
      anon_sym_SLASH,
    ACTIONS(4547), 1,
      anon_sym_GT,
    STATE(2201), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104502] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2341), 1,
      sym_type_parameters,
    STATE(2753), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3229), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [104533] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1548), 1,
      sym_class_body,
    STATE(2380), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3158), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [104564] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4714), 1,
      anon_sym_GT,
    ACTIONS(4749), 1,
      anon_sym_SLASH,
    STATE(2203), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104593] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2362), 1,
      sym_type_parameters,
    STATE(2709), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3191), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [104624] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1175), 1,
      sym_class_body,
    STATE(2340), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3241), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [104655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4605), 1,
      anon_sym_is,
    ACTIONS(1798), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104672] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4743), 1,
      anon_sym_GT,
    ACTIONS(4751), 1,
      anon_sym_SLASH,
    STATE(2203), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104701] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4708), 1,
      anon_sym_GT,
    ACTIONS(4753), 1,
      anon_sym_SLASH,
    STATE(2209), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104730] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4755), 1,
      sym_identifier,
    ACTIONS(4758), 1,
      anon_sym_LBRACE,
    ACTIONS(4761), 1,
      anon_sym_GT,
    ACTIONS(4763), 1,
      anon_sym_SLASH,
    ACTIONS(4765), 1,
      sym_jsx_identifier,
    STATE(2203), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104759] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4714), 1,
      anon_sym_GT,
    ACTIONS(4768), 1,
      anon_sym_SLASH,
    STATE(2203), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1798), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(4589), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [104805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4770), 1,
      anon_sym_RPAREN,
    ACTIONS(1229), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(1794), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [104824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_AMP,
    ACTIONS(4616), 1,
      anon_sym_PIPE,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(4773), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104845] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(535), 1,
      sym_class_body,
    STATE(2307), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3351), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [104876] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4714), 1,
      anon_sym_GT,
    ACTIONS(4775), 1,
      anon_sym_SLASH,
    STATE(2203), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104905] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4777), 1,
      anon_sym_LBRACE,
    STATE(100), 1,
      sym_class_body,
    STATE(2350), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3236), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [104936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(2269), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [104953] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4779), 1,
      anon_sym_LBRACE,
    STATE(606), 1,
      sym_class_body,
    STATE(2355), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3198), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [104984] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4704), 1,
      sym_identifier,
    ACTIONS(4781), 1,
      anon_sym_RBRACK,
    STATE(3001), 1,
      sym__rest_identifier,
    STATE(3034), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2872), 3,
      sym_rest_identifier,
      sym_optional_identifier,
      sym__tuple_type_identifier,
  [105009] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4547), 1,
      anon_sym_GT,
    ACTIONS(4549), 1,
      anon_sym_SLASH,
    STATE(2220), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105038] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(4783), 1,
      anon_sym_EQ,
    ACTIONS(4624), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [105061] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2337), 1,
      sym_type_parameters,
    STATE(2584), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3266), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [105092] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_RBRACK,
    ACTIONS(4704), 1,
      sym_identifier,
    STATE(3001), 1,
      sym__rest_identifier,
    STATE(3013), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2872), 3,
      sym_rest_identifier,
      sym_optional_identifier,
      sym__tuple_type_identifier,
  [105117] = 6,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4785), 1,
      anon_sym_LT,
    ACTIONS(4787), 1,
      sym_jsx_text,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2176), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [105140] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4468), 1,
      anon_sym_SLASH,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4547), 1,
      anon_sym_GT,
    STATE(2224), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105169] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4743), 1,
      anon_sym_GT,
    ACTIONS(4789), 1,
      anon_sym_SLASH,
    STATE(2203), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105198] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4708), 1,
      anon_sym_GT,
    ACTIONS(4791), 1,
      anon_sym_SLASH,
    STATE(2231), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105227] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4708), 1,
      anon_sym_GT,
    ACTIONS(4793), 1,
      anon_sym_SLASH,
    STATE(2178), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105256] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4777), 1,
      anon_sym_LBRACE,
    STATE(93), 1,
      sym_class_body,
    STATE(2343), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3264), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [105287] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4743), 1,
      anon_sym_GT,
    ACTIONS(4795), 1,
      anon_sym_SLASH,
    STATE(2203), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105316] = 6,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4638), 1,
      sym_jsx_text,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_LT,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2230), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [105339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1677), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105356] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4743), 1,
      anon_sym_GT,
    ACTIONS(4799), 1,
      anon_sym_SLASH,
    STATE(2203), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3087), 1,
      anon_sym_RPAREN,
    ACTIONS(1613), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(3085), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [105404] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4704), 1,
      sym_identifier,
    ACTIONS(4801), 1,
      anon_sym_RBRACK,
    STATE(3001), 1,
      sym__rest_identifier,
    STATE(2964), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2872), 3,
      sym_rest_identifier,
      sym_optional_identifier,
      sym__tuple_type_identifier,
  [105429] = 6,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4803), 1,
      anon_sym_LBRACE,
    ACTIONS(4806), 1,
      anon_sym_LT,
    ACTIONS(4809), 1,
      sym_jsx_text,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2230), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [105452] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4714), 1,
      anon_sym_GT,
    ACTIONS(4812), 1,
      anon_sym_SLASH,
    STATE(2203), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4622), 1,
      anon_sym_DOT,
    ACTIONS(1621), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105498] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_AMP,
    ACTIONS(4616), 1,
      anon_sym_PIPE,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(4814), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105519] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1797), 1,
      sym_class_body,
    STATE(2324), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3395), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [105550] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4457), 1,
      anon_sym_LBRACE,
    ACTIONS(4470), 1,
      sym_jsx_identifier,
    ACTIONS(4547), 1,
      anon_sym_GT,
    ACTIONS(4555), 1,
      anon_sym_SLASH,
    STATE(2227), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2396), 1,
      sym_jsx_namespace_name,
    STATE(2620), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [105579] = 6,
    ACTIONS(4634), 1,
      anon_sym_LBRACE,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(4816), 1,
      anon_sym_LT,
    ACTIONS(4818), 1,
      sym_jsx_text,
    STATE(2144), 1,
      sym_jsx_opening_element,
    STATE(2225), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [105602] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1807), 1,
      sym_class_body,
    STATE(2331), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3365), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [105633] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(551), 1,
      sym_class_body,
    STATE(2296), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3295), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [105664] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4779), 1,
      anon_sym_LBRACE,
    STATE(572), 1,
      sym_class_body,
    STATE(2371), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3183), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [105695] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1227), 1,
      anon_sym_RBRACK,
    ACTIONS(4704), 1,
      sym_identifier,
    STATE(3001), 1,
      sym__rest_identifier,
    STATE(2987), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2872), 3,
      sym_rest_identifier,
      sym_optional_identifier,
      sym__tuple_type_identifier,
  [105720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1677), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(979), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [105737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1621), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1551), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1601), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_AMP,
    ACTIONS(4616), 1,
      anon_sym_PIPE,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(4820), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1661), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1605), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1589), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105855] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4228), 1,
      anon_sym_RBRACE,
    STATE(3124), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [105877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105891] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1304), 1,
      anon_sym_RBRACE,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    STATE(3010), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [105913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4822), 1,
      anon_sym_LBRACK,
    ACTIONS(1609), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105943] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_AMP,
    ACTIONS(4616), 1,
      anon_sym_PIPE,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(1834), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1637), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1641), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1547), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1677), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1665), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1657), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 3,
      anon_sym_while,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1059), 5,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_DOT,
  [106119] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1308), 1,
      anon_sym_RBRACE,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    STATE(2959), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [106141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1559), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106155] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4704), 1,
      sym_identifier,
    STATE(3001), 1,
      sym__rest_identifier,
    STATE(3210), 2,
      sym_labeled_tuple_type_member,
      sym__tuple_type_member,
    STATE(2872), 3,
      sym_rest_identifier,
      sym_optional_identifier,
      sym__tuple_type_identifier,
  [106177] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4824), 1,
      anon_sym_AMP,
    ACTIONS(4826), 1,
      anon_sym_PIPE,
    ACTIONS(4828), 1,
      anon_sym_extends,
    ACTIONS(1844), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [106197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1567), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1669), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4822), 1,
      anon_sym_LBRACK,
    ACTIONS(1571), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1581), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(1585), 4,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1649), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1563), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1625), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1617), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106369] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    ACTIONS(4830), 1,
      anon_sym_BANG,
    STATE(2705), 1,
      sym_type_annotation,
    STATE(3067), 1,
      sym__initializer,
    ACTIONS(2289), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106393] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_AMP,
    ACTIONS(4616), 1,
      anon_sym_PIPE,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(4832), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106413] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 1,
      anon_sym_LBRACE,
    ACTIONS(4836), 1,
      anon_sym_DOT,
    STATE(2615), 1,
      sym_statement_block,
    ACTIONS(983), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1629), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4824), 1,
      anon_sym_AMP,
    ACTIONS(4826), 1,
      anon_sym_PIPE,
    ACTIONS(4828), 1,
      anon_sym_extends,
    ACTIONS(1824), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [106467] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4246), 1,
      anon_sym_RBRACE,
    STATE(2963), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [106489] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(1263), 1,
      anon_sym_RBRACE,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    STATE(3011), 1,
      aux_sym_object_repeat1,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [106511] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4838), 1,
      anon_sym_COLON,
    STATE(2862), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(4678), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [106529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4824), 1,
      anon_sym_AMP,
    ACTIONS(4826), 1,
      anon_sym_PIPE,
    ACTIONS(1838), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
  [106547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4838), 1,
      anon_sym_COLON,
    STATE(2812), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(4646), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [106565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106593] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3288), 1,
      sym_statement_block,
    ACTIONS(4840), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106610] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(538), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3194), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [106635] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4842), 1,
      sym_identifier,
    ACTIONS(4844), 1,
      anon_sym_STAR,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3349), 1,
      sym__call_signature,
  [106660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 1,
      anon_sym_LBRACE,
    STATE(2615), 1,
      sym_statement_block,
    ACTIONS(983), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106677] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1698), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3246), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [106702] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2716), 1,
      sym_type_annotation,
    STATE(3066), 1,
      sym__initializer,
    ACTIONS(4609), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [106723] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4848), 1,
      sym_identifier,
    ACTIONS(4850), 1,
      anon_sym_LBRACE,
    ACTIONS(4852), 1,
      anon_sym_LBRACK,
    ACTIONS(4854), 1,
      anon_sym_enum,
    STATE(2344), 1,
      sym_array,
    STATE(2345), 1,
      sym_object,
    STATE(2877), 1,
      sym_variable_declarator,
  [106748] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1273), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3160), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [106773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4644), 1,
      anon_sym_is,
    ACTIONS(1798), 6,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [106788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3185), 1,
      sym_statement_block,
    ACTIONS(4856), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3237), 1,
      sym_statement_block,
    ACTIONS(4858), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3261), 1,
      sym_statement_block,
    ACTIONS(4860), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [106839] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(550), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3245), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [106864] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(4862), 1,
      anon_sym_LT,
    ACTIONS(4864), 1,
      anon_sym_extends,
    STATE(557), 1,
      sym_object_type,
    STATE(2792), 1,
      sym_type_parameters,
    STATE(3000), 1,
      sym_extends_clause,
  [106889] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1734), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3380), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [106914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [106927] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4866), 1,
      sym_identifier,
    ACTIONS(4868), 1,
      anon_sym_DOT,
    STATE(532), 1,
      sym_nested_identifier,
    STATE(547), 1,
      sym_string,
    STATE(626), 1,
      sym__module,
  [106952] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(4870), 1,
      sym_identifier,
    ACTIONS(4872), 1,
      anon_sym_STAR,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3384), 1,
      sym__call_signature,
  [106977] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(4874), 1,
      sym_identifier,
    ACTIONS(4876), 1,
      anon_sym_STAR,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3337), 1,
      sym__call_signature,
  [107002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3328), 1,
      sym_statement_block,
    ACTIONS(4878), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107019] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(4880), 1,
      sym_identifier,
    ACTIONS(4882), 1,
      anon_sym_STAR,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3340), 1,
      sym__call_signature,
  [107044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3334), 1,
      sym_statement_block,
    ACTIONS(4884), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4886), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [107074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3301), 1,
      sym_statement_block,
    ACTIONS(4888), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107091] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(4890), 1,
      sym_identifier,
    ACTIONS(4892), 1,
      anon_sym_STAR,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3337), 1,
      sym__call_signature,
  [107116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3279), 1,
      sym_statement_block,
    ACTIONS(4894), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3285), 1,
      sym_statement_block,
    ACTIONS(4896), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107150] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4898), 1,
      sym_identifier,
    ACTIONS(4900), 1,
      anon_sym_DOT,
    STATE(2285), 1,
      sym_nested_identifier,
    STATE(2298), 1,
      sym_string,
    STATE(2789), 1,
      sym__module,
  [107175] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1759), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3370), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [107200] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1752), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3369), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [107225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3255), 1,
      sym_statement_block,
    ACTIONS(4902), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [107255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_EQ,
    ACTIONS(4270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2938), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [107272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4904), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [107285] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(4906), 1,
      sym_identifier,
    ACTIONS(4908), 1,
      anon_sym_STAR,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3349), 1,
      sym__call_signature,
  [107310] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1694), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3324), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [107335] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1766), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3357), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [107360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4912), 1,
      anon_sym_is,
    ACTIONS(4910), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107375] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2571), 1,
      sym_type_annotation,
    STATE(2968), 1,
      sym__initializer,
    ACTIONS(4599), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107396] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(4914), 1,
      sym_identifier,
    ACTIONS(4916), 1,
      anon_sym_STAR,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3349), 1,
      sym__call_signature,
  [107421] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(4862), 1,
      anon_sym_LT,
    ACTIONS(4864), 1,
      anon_sym_extends,
    STATE(2564), 1,
      sym_type_parameters,
    STATE(2606), 1,
      sym_object_type,
    STATE(3133), 1,
      sym_extends_clause,
  [107446] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4918), 1,
      sym_identifier,
    ACTIONS(4920), 1,
      anon_sym_DOT,
    STATE(547), 1,
      sym_string,
    STATE(626), 1,
      sym__module,
    STATE(2885), 1,
      sym_nested_identifier,
  [107471] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2672), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3284), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [107496] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1623), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3332), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [107521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3364), 1,
      sym_statement_block,
    ACTIONS(4922), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107538] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1203), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3276), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [107563] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2580), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3267), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [107588] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3307), 1,
      anon_sym_COLON,
    ACTIONS(4924), 1,
      anon_sym_EQ,
    ACTIONS(4928), 1,
      anon_sym_QMARK,
    STATE(2940), 1,
      sym_type_annotation,
    STATE(3187), 1,
      sym__initializer,
    ACTIONS(4926), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [107611] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4777), 1,
      anon_sym_LBRACE,
    STATE(92), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3297), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [107636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2681), 1,
      sym_type_annotation,
    STATE(3084), 1,
      sym__initializer,
    ACTIONS(3239), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107657] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2683), 1,
      sym_type_annotation,
    STATE(3074), 1,
      sym__initializer,
    ACTIONS(3176), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107678] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1456), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3265), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [107703] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4844), 1,
      anon_sym_STAR,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(4930), 1,
      sym_identifier,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3349), 1,
      sym__call_signature,
  [107728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4932), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [107741] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2631), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3157), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [107766] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4777), 1,
      anon_sym_LBRACE,
    STATE(83), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3192), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [107791] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_EQ,
    STATE(2890), 1,
      sym_constraint,
    STATE(3209), 1,
      sym_default_type,
    ACTIONS(4459), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(4582), 2,
      anon_sym_COLON,
      anon_sym_extends,
  [107812] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(4876), 1,
      anon_sym_STAR,
    ACTIONS(4934), 1,
      sym_identifier,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3337), 1,
      sym__call_signature,
  [107837] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(4936), 1,
      anon_sym_COLON,
    ACTIONS(4938), 1,
      anon_sym_QMARK,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3298), 1,
      sym__call_signature,
  [107862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3204), 1,
      sym_statement_block,
    ACTIONS(4940), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107879] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4779), 1,
      anon_sym_LBRACE,
    STATE(611), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3275), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [107904] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4824), 1,
      anon_sym_AMP,
    ACTIONS(4826), 1,
      anon_sym_PIPE,
    ACTIONS(4828), 1,
      anon_sym_extends,
    ACTIONS(4624), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [107923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    STATE(2546), 1,
      sym_type_annotation,
    ACTIONS(4942), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [107940] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4844), 1,
      anon_sym_STAR,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(4944), 1,
      sym_identifier,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3349), 1,
      sym__call_signature,
  [107965] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1177), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3234), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [107990] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4824), 1,
      anon_sym_AMP,
    ACTIONS(4826), 1,
      anon_sym_PIPE,
    ACTIONS(4828), 1,
      anon_sym_extends,
    ACTIONS(4773), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [108009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1557), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1555), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_BQUOTE,
  [108024] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2757), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3256), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [108049] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1181), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3228), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [108074] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4866), 1,
      sym_identifier,
    ACTIONS(4920), 1,
      anon_sym_DOT,
    STATE(532), 1,
      sym_nested_identifier,
    STATE(547), 1,
      sym_string,
    STATE(626), 1,
      sym__module,
  [108099] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(4946), 1,
      sym_identifier,
    ACTIONS(4948), 1,
      anon_sym_STAR,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3164), 1,
      sym__call_signature,
    STATE(3215), 1,
      sym_type_parameters,
  [108124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1559), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_BQUOTE,
  [108139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(4952), 1,
      anon_sym_EQ,
    ACTIONS(4950), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4954), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [108158] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(4876), 1,
      anon_sym_STAR,
    ACTIONS(4956), 1,
      sym_identifier,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3337), 1,
      sym__call_signature,
  [108183] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1647), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3368), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [108208] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2744), 1,
      sym_type_annotation,
    STATE(3049), 1,
      sym__initializer,
    ACTIONS(4587), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108229] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    ACTIONS(4779), 1,
      anon_sym_LBRACE,
    STATE(633), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3199), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [108254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    STATE(2771), 1,
      sym_type_annotation,
    ACTIONS(4958), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108271] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(4960), 1,
      sym_identifier,
    ACTIONS(4962), 1,
      anon_sym_STAR,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3287), 1,
      sym__call_signature,
  [108296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [108309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4824), 1,
      anon_sym_AMP,
    ACTIONS(4826), 1,
      anon_sym_PIPE,
    ACTIONS(4828), 1,
      anon_sym_extends,
    ACTIONS(4814), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [108328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1563), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_BQUOTE,
  [108343] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2640), 1,
      sym_type_annotation,
    STATE(3110), 1,
      sym__initializer,
    ACTIONS(4597), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108364] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(4966), 1,
      sym_identifier,
    ACTIONS(4968), 1,
      anon_sym_STAR,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3337), 1,
      sym__call_signature,
  [108389] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4848), 1,
      sym_identifier,
    ACTIONS(4850), 1,
      anon_sym_LBRACE,
    ACTIONS(4852), 1,
      anon_sym_LBRACK,
    ACTIONS(4970), 1,
      anon_sym_enum,
    STATE(2344), 1,
      sym_array,
    STATE(2345), 1,
      sym_object,
    STATE(2828), 1,
      sym_variable_declarator,
  [108414] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(4702), 1,
      anon_sym_extends,
    STATE(1527), 1,
      sym_class_body,
    STATE(3053), 1,
      sym_extends_clause,
    STATE(3200), 1,
      sym_class_heritage,
    STATE(3503), 1,
      sym_implements_clause,
  [108439] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4976), 1,
      anon_sym_SLASH,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [108461] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4850), 1,
      anon_sym_LBRACE,
    ACTIONS(4852), 1,
      anon_sym_LBRACK,
    ACTIONS(4980), 1,
      sym_identifier,
    STATE(2344), 1,
      sym_array,
    STATE(2345), 1,
      sym_object,
    STATE(3038), 1,
      sym_variable_declarator,
  [108483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2383), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4985), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4982), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108499] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3307), 1,
      anon_sym_COLON,
    ACTIONS(4924), 1,
      anon_sym_EQ,
    STATE(2931), 1,
      sym_type_annotation,
    STATE(3347), 1,
      sym__initializer,
    ACTIONS(4987), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [108519] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4989), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2762), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [108541] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2383), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3011), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4991), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108557] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4993), 1,
      anon_sym_default,
    ACTIONS(4995), 1,
      anon_sym_RBRACE,
    ACTIONS(4997), 1,
      anon_sym_case,
    STATE(2466), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [108575] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4850), 1,
      anon_sym_LBRACE,
    ACTIONS(4852), 1,
      anon_sym_LBRACK,
    ACTIONS(4980), 1,
      sym_identifier,
    STATE(2344), 1,
      sym_array,
    STATE(2345), 1,
      sym_object,
    STATE(2828), 1,
      sym_variable_declarator,
  [108597] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(4999), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2679), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [108619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5001), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [108631] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4850), 1,
      anon_sym_LBRACE,
    ACTIONS(4852), 1,
      anon_sym_LBRACK,
    ACTIONS(4980), 1,
      sym_identifier,
    STATE(2344), 1,
      sym_array,
    STATE(2345), 1,
      sym_object,
    STATE(2803), 1,
      sym_variable_declarator,
  [108653] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    ACTIONS(5003), 1,
      anon_sym_SLASH,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [108675] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5005), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(3063), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [108697] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 1,
      anon_sym_COMMA,
    ACTIONS(5009), 1,
      anon_sym_GT,
    ACTIONS(5011), 1,
      anon_sym_AMP,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    ACTIONS(5015), 1,
      anon_sym_extends,
    STATE(3136), 1,
      aux_sym_implements_clause_repeat1,
  [108719] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_AMP,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    ACTIONS(5015), 1,
      anon_sym_extends,
    ACTIONS(5017), 1,
      anon_sym_COMMA,
    ACTIONS(5019), 1,
      anon_sym_GT,
    STATE(3120), 1,
      aux_sym_implements_clause_repeat1,
  [108741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5023), 1,
      anon_sym_EQ,
    ACTIONS(5021), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5025), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [108757] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2510), 1,
      anon_sym_typeof,
    ACTIONS(5027), 1,
      sym_identifier,
    STATE(1502), 1,
      sym_nested_type_identifier,
    STATE(3447), 1,
      sym_nested_identifier,
    STATE(1585), 2,
      sym_generic_type,
      sym_type_query,
  [108777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2383), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3021), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2383), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3035), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2398), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3035), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5033), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [108837] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5035), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2539), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [108859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(5037), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5039), 1,
      anon_sym_QMARK_COLON,
    STATE(2701), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [108877] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2399), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5043), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5041), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108893] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_AMP,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    ACTIONS(5015), 1,
      anon_sym_extends,
    ACTIONS(5045), 1,
      anon_sym_COMMA,
    ACTIONS(5047), 1,
      anon_sym_GT,
    STATE(3090), 1,
      aux_sym_implements_clause_repeat1,
  [108915] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5049), 1,
      sym_identifier,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3382), 1,
      sym__call_signature,
  [108937] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5051), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2785), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [108959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5053), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2994), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [108981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2386), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3013), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5055), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108997] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2822), 1,
      anon_sym_typeof,
    ACTIONS(5057), 1,
      sym_identifier,
    STATE(506), 1,
      sym_nested_type_identifier,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(439), 2,
      sym_generic_type,
      sym_type_query,
  [109017] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5059), 1,
      sym_identifier,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3170), 1,
      sym__call_signature,
    STATE(3215), 1,
      sym_type_parameters,
  [109039] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    ACTIONS(5061), 1,
      anon_sym_SLASH,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [109061] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(5037), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5039), 1,
      anon_sym_QMARK_COLON,
    STATE(2707), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [109079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2383), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3025), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5063), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109095] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5065), 1,
      sym_identifier,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3213), 1,
      sym__call_signature,
    STATE(3215), 1,
      sym_type_parameters,
  [109117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2383), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3023), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5067), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2414), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3023), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5067), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2383), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3013), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5055), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109165] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5069), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [109183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5071), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2416), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5075), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5073), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109211] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_AMP,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    ACTIONS(5015), 1,
      anon_sym_extends,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(5079), 1,
      anon_sym_GT,
    STATE(3041), 1,
      aux_sym_implements_clause_repeat1,
  [109233] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5081), 1,
      sym_identifier,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3293), 1,
      sym__call_signature,
  [109255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5083), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109267] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 1,
      anon_sym_typeof,
    ACTIONS(5085), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_nested_type_identifier,
    STATE(3439), 1,
      sym_nested_identifier,
    STATE(2244), 2,
      sym_generic_type,
      sym_type_query,
  [109287] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2392), 1,
      anon_sym_typeof,
    ACTIONS(5087), 1,
      sym_identifier,
    STATE(1380), 1,
      sym_nested_type_identifier,
    STATE(3571), 1,
      sym_nested_identifier,
    STATE(1512), 2,
      sym_generic_type,
      sym_type_query,
  [109307] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5089), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2339), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [109329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5091), 1,
      anon_sym_default,
    ACTIONS(5094), 1,
      anon_sym_RBRACE,
    ACTIONS(5096), 1,
      anon_sym_case,
    STATE(2428), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [109347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4508), 4,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [109361] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    ACTIONS(5099), 1,
      anon_sym_SLASH,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [109383] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5101), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2321), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [109405] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5103), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2318), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [109427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5107), 1,
      anon_sym_BQUOTE,
    ACTIONS(5109), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5105), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2493), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [109445] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(867), 1,
      anon_sym_typeof,
    ACTIONS(5111), 1,
      sym_identifier,
    STATE(2024), 1,
      sym_nested_type_identifier,
    STATE(3514), 1,
      sym_nested_identifier,
    STATE(439), 2,
      sym_generic_type,
      sym_type_query,
  [109465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2383), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3017), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5113), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109481] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5115), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2314), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [109503] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5117), 1,
      anon_sym_LBRACE,
    ACTIONS(5119), 1,
      anon_sym_COMMA,
    STATE(3054), 1,
      aux_sym_implements_clause_repeat1,
  [109525] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2383), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3033), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5121), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109541] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4898), 1,
      sym_identifier,
    STATE(2285), 1,
      sym_nested_identifier,
    STATE(2298), 1,
      sym_string,
    STATE(2604), 1,
      sym__module,
  [109563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2435), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3033), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5121), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109579] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(4449), 1,
      anon_sym_LT,
    STATE(427), 1,
      sym_type_arguments,
    STATE(2871), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3395), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [109599] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(5123), 1,
      sym_identifier,
    ACTIONS(5125), 1,
      anon_sym_LBRACK,
    STATE(1238), 1,
      sym_arguments,
    STATE(3195), 1,
      sym_type_arguments,
  [109621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2438), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5129), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5127), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109637] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    ACTIONS(4898), 1,
      sym_identifier,
    STATE(2285), 1,
      sym_nested_identifier,
    STATE(2298), 1,
      sym_string,
    STATE(2789), 1,
      sym__module,
  [109659] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_AMP,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    ACTIONS(5015), 1,
      anon_sym_extends,
    ACTIONS(5131), 1,
      anon_sym_COMMA,
    ACTIONS(5133), 1,
      anon_sym_GT,
    STATE(2972), 1,
      aux_sym_implements_clause_repeat1,
  [109681] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2560), 1,
      anon_sym_typeof,
    ACTIONS(5135), 1,
      sym_identifier,
    STATE(1080), 1,
      sym_nested_type_identifier,
    STATE(3409), 1,
      sym_nested_identifier,
    STATE(1164), 2,
      sym_generic_type,
      sym_type_query,
  [109701] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5137), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2305), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [109723] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_COMMA,
    ACTIONS(3395), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3474), 1,
      anon_sym_LBRACE,
    ACTIONS(5139), 1,
      anon_sym_LT,
    STATE(2842), 1,
      aux_sym_extends_clause_repeat1,
    STATE(3027), 1,
      sym_type_arguments,
  [109745] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5141), 1,
      anon_sym_QMARK,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3317), 1,
      sym__call_signature,
  [109767] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5143), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2562), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [109789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2383), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3039), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5145), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109805] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5147), 1,
      sym_identifier,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3252), 1,
      sym__call_signature,
  [109827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2383), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3031), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5149), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2451), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3031), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5149), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(5037), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5039), 1,
      anon_sym_QMARK_COLON,
    STATE(2743), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [109877] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(5037), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5039), 1,
      anon_sym_QMARK_COLON,
    STATE(2741), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [109895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 1,
      anon_sym_BQUOTE,
    ACTIONS(5156), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5151), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2457), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [109913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2453), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5161), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5159), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109929] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5163), 1,
      anon_sym_QMARK,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3278), 1,
      sym__call_signature,
  [109951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2418), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5167), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5165), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2938), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [109979] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_AMP,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    ACTIONS(5015), 1,
      anon_sym_extends,
    ACTIONS(5169), 1,
      anon_sym_COMMA,
    ACTIONS(5171), 1,
      anon_sym_GT,
    STATE(2985), 1,
      aux_sym_implements_clause_repeat1,
  [110001] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_typeof,
    ACTIONS(5173), 1,
      sym_identifier,
    STATE(2062), 1,
      sym_nested_type_identifier,
    STATE(3415), 1,
      sym_nested_identifier,
    STATE(2124), 2,
      sym_generic_type,
      sym_type_query,
  [110021] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_AMP,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    ACTIONS(5015), 1,
      anon_sym_extends,
    ACTIONS(1844), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
  [110039] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(5037), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5039), 1,
      anon_sym_QMARK_COLON,
    STATE(2732), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [110057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4993), 1,
      anon_sym_default,
    ACTIONS(4997), 1,
      anon_sym_case,
    ACTIONS(5175), 1,
      anon_sym_RBRACE,
    STATE(2428), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [110075] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5177), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2721), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [110097] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(5179), 1,
      sym_identifier,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    STATE(1748), 1,
      sym_arguments,
    STATE(3388), 1,
      sym_type_arguments,
  [110119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5185), 1,
      anon_sym_BQUOTE,
    ACTIONS(5183), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2457), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [110137] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5187), 1,
      sym_identifier,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3386), 1,
      sym__call_signature,
  [110159] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_AMP,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    ACTIONS(5015), 1,
      anon_sym_extends,
    ACTIONS(5189), 1,
      anon_sym_COMMA,
    ACTIONS(5191), 1,
      anon_sym_GT,
    STATE(3109), 1,
      aux_sym_implements_clause_repeat1,
  [110181] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(5193), 1,
      sym_identifier,
    ACTIONS(5195), 1,
      anon_sym_LBRACK,
    STATE(1774), 1,
      sym_arguments,
    STATE(3353), 1,
      sym_type_arguments,
  [110203] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5199), 1,
      anon_sym_BQUOTE,
    ACTIONS(5197), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2469), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [110221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_AMP,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    ACTIONS(5015), 1,
      anon_sym_extends,
    ACTIONS(1824), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
  [110239] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    ACTIONS(5201), 1,
      anon_sym_SLASH,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [110261] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5203), 1,
      anon_sym_QMARK,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3303), 1,
      sym__call_signature,
  [110283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_AMP,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    ACTIONS(1838), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_extends,
  [110299] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4850), 1,
      anon_sym_LBRACE,
    ACTIONS(4852), 1,
      anon_sym_LBRACK,
    ACTIONS(4980), 1,
      sym_identifier,
    STATE(2344), 1,
      sym_array,
    STATE(2345), 1,
      sym_object,
    STATE(2877), 1,
      sym_variable_declarator,
  [110321] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    ACTIONS(5205), 1,
      anon_sym_SLASH,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [110343] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5207), 1,
      anon_sym_QMARK,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3291), 1,
      sym__call_signature,
  [110365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_COLON,
    ACTIONS(4646), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3310), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [110381] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    ACTIONS(5211), 1,
      anon_sym_SLASH,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [110403] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    ACTIONS(5213), 1,
      anon_sym_SLASH,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [110425] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    ACTIONS(5215), 1,
      anon_sym_SLASH,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [110447] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2698), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [110469] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    ACTIONS(5219), 1,
      anon_sym_SLASH,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [110491] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    ACTIONS(5221), 1,
      anon_sym_SLASH,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [110513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3746), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [110525] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(5223), 1,
      sym_identifier,
    ACTIONS(5225), 1,
      anon_sym_LBRACK,
    STATE(1664), 1,
      sym_arguments,
    STATE(3389), 1,
      sym_type_arguments,
  [110547] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5227), 1,
      anon_sym_BQUOTE,
    ACTIONS(5183), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2457), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [110565] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      sym_identifier,
    ACTIONS(5231), 1,
      anon_sym_GT,
    ACTIONS(5233), 1,
      sym_jsx_identifier,
    STATE(2085), 1,
      sym_nested_identifier,
    STATE(2179), 1,
      sym_jsx_namespace_name,
    STATE(3070), 1,
      sym_type_parameter,
  [110587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2383), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3019), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5235), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110603] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5237), 1,
      anon_sym_BQUOTE,
    ACTIONS(5183), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2457), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [110621] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5239), 1,
      sym_identifier,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3293), 1,
      sym__call_signature,
  [110643] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(5241), 1,
      sym_identifier,
    ACTIONS(5243), 1,
      anon_sym_LBRACK,
    STATE(1268), 1,
      sym_arguments,
    STATE(3176), 1,
      sym_type_arguments,
  [110665] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5245), 1,
      anon_sym_export,
    ACTIONS(5247), 1,
      anon_sym_class,
    ACTIONS(5249), 1,
      anon_sym_abstract,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
  [110687] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4918), 1,
      sym_identifier,
    STATE(547), 1,
      sym_string,
    STATE(581), 1,
      sym__module,
    STATE(2885), 1,
      sym_nested_identifier,
  [110709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4918), 1,
      sym_identifier,
    STATE(547), 1,
      sym_string,
    STATE(626), 1,
      sym__module,
    STATE(2885), 1,
      sym_nested_identifier,
  [110731] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5251), 1,
      sym_identifier,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3293), 1,
      sym__call_signature,
  [110753] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_QMARK,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3393), 1,
      sym__call_signature,
  [110775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2383), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3009), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5255), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2492), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3009), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5255), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110807] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    ACTIONS(5257), 1,
      anon_sym_SLASH,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [110829] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5259), 1,
      sym_identifier,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3252), 1,
      sym__call_signature,
  [110851] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(5037), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5039), 1,
      anon_sym_QMARK_COLON,
    STATE(2657), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [110869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(5037), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5039), 1,
      anon_sym_QMARK_COLON,
    STATE(2652), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [110887] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5261), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2626), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [110909] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5263), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2560), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [110931] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4850), 1,
      anon_sym_LBRACE,
    ACTIONS(4852), 1,
      anon_sym_LBRACK,
    ACTIONS(4980), 1,
      sym_identifier,
    STATE(2344), 1,
      sym_array,
    STATE(2345), 1,
      sym_object,
    STATE(2881), 1,
      sym_variable_declarator,
  [110953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2501), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5267), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5265), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110969] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5269), 1,
      sym_identifier,
    ACTIONS(5271), 1,
      anon_sym_COMMA,
    ACTIONS(5273), 1,
      anon_sym_RBRACE,
    STATE(3039), 1,
      sym__import_export_specifier,
    ACTIONS(5275), 2,
      anon_sym_type,
      anon_sym_typeof,
  [110989] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(5037), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5039), 1,
      anon_sym_QMARK_COLON,
    STATE(2588), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [111007] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(5037), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(5039), 1,
      anon_sym_QMARK_COLON,
    STATE(2590), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [111025] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4866), 1,
      sym_identifier,
    STATE(532), 1,
      sym_nested_identifier,
    STATE(547), 1,
      sym_string,
    STATE(626), 1,
      sym__module,
  [111047] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    ACTIONS(4463), 1,
      anon_sym_LT,
    ACTIONS(5277), 1,
      sym_identifier,
    ACTIONS(5279), 1,
      anon_sym_LBRACK,
    STATE(1593), 1,
      sym_arguments,
    STATE(3322), 1,
      sym_type_arguments,
  [111069] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5269), 1,
      sym_identifier,
    ACTIONS(5281), 1,
      anon_sym_COMMA,
    ACTIONS(5283), 1,
      anon_sym_RBRACE,
    STATE(2948), 1,
      sym__import_export_specifier,
    ACTIONS(5275), 2,
      anon_sym_type,
      anon_sym_typeof,
  [111089] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4866), 1,
      sym_identifier,
    STATE(532), 1,
      sym_nested_identifier,
    STATE(547), 1,
      sym_string,
    STATE(581), 1,
      sym__module,
  [111111] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5249), 1,
      anon_sym_abstract,
    ACTIONS(5285), 1,
      anon_sym_export,
    ACTIONS(5287), 1,
      anon_sym_class,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
  [111133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_COLON,
    ACTIONS(4678), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3390), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [111149] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 1,
      sym_identifier,
    ACTIONS(5291), 1,
      anon_sym_GT,
    ACTIONS(5293), 1,
      sym_jsx_identifier,
    STATE(2065), 1,
      sym_nested_identifier,
    STATE(2194), 1,
      sym_jsx_namespace_name,
    STATE(3070), 1,
      sym_type_parameter,
  [111171] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5247), 1,
      anon_sym_class,
    ACTIONS(5249), 1,
      anon_sym_abstract,
    ACTIONS(5295), 1,
      anon_sym_export,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
  [111193] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    ACTIONS(5297), 1,
      anon_sym_SLASH,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [111215] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_AMP,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    ACTIONS(5015), 1,
      anon_sym_extends,
    ACTIONS(5299), 1,
      anon_sym_COMMA,
    ACTIONS(5301), 1,
      anon_sym_GT,
    STATE(3102), 1,
      aux_sym_implements_clause_repeat1,
  [111237] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    ACTIONS(5303), 1,
      anon_sym_SLASH,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [111259] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    ACTIONS(5305), 1,
      sym_identifier,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3252), 1,
      sym__call_signature,
  [111281] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    ACTIONS(5307), 1,
      anon_sym_SLASH,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [111303] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5311), 1,
      anon_sym_BQUOTE,
    ACTIONS(5309), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2490), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [111321] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    ACTIONS(5313), 1,
      anon_sym_QMARK,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2622), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [111343] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5315), 1,
      sym_identifier,
    ACTIONS(5317), 1,
      anon_sym_GT,
    ACTIONS(5319), 1,
      sym_jsx_identifier,
    STATE(2073), 1,
      sym_nested_identifier,
    STATE(2219), 1,
      sym_jsx_namespace_name,
    STATE(3070), 1,
      sym_type_parameter,
  [111365] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3232), 1,
      sym__call_signature,
  [111384] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2957), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [111403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [111414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2125), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(3056), 1,
      sym__initializer,
    ACTIONS(5321), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4449), 1,
      anon_sym_LT,
    STATE(427), 1,
      sym_type_arguments,
    ACTIONS(3629), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [111455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2117), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4044), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [111477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [111488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(1934), 1,
      sym_statement_block,
    ACTIONS(4922), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1794), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [111514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(999), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4902), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(1932), 1,
      sym_statement_block,
    ACTIONS(4940), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
  [111562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4884), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4958), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111584] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3331), 1,
      sym__call_signature,
  [111603] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(5325), 1,
      anon_sym_LPAREN,
    STATE(2290), 1,
      sym_formal_parameters,
    STATE(2722), 1,
      sym__call_signature,
    STATE(3292), 1,
      sym_type_parameters,
  [111622] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3338), 1,
      sym__call_signature,
  [111641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(1950), 1,
      sym_statement_block,
    ACTIONS(4894), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3339), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [111669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3370), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [111682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5327), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [111704] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2729), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [111723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1504), 1,
      sym_statement_block,
    ACTIONS(5329), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [111738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5331), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3372), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3374), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [111773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4878), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2041), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(1935), 1,
      sym_statement_block,
    ACTIONS(4888), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4985), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111821] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    ACTIONS(4864), 1,
      anon_sym_extends,
    STATE(2796), 1,
      sym_object_type,
    STATE(3107), 1,
      sym_extends_clause,
  [111840] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(1834), 2,
      anon_sym_else,
      anon_sym_while,
  [111857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3073), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [111879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1913), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_EQ,
    ACTIONS(3746), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [111903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(3065), 1,
      sym__initializer,
    ACTIONS(5333), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1905), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3077), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [111951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_COLON,
    ACTIONS(5335), 1,
      anon_sym_EQ_GT,
    STATE(3390), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [111966] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5269), 1,
      sym_identifier,
    ACTIONS(5337), 1,
      anon_sym_RBRACE,
    STATE(3311), 1,
      sym__import_export_specifier,
    ACTIONS(5275), 2,
      anon_sym_type,
      anon_sym_typeof,
  [111983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4886), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
  [111994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_COLON,
    ACTIONS(5339), 1,
      anon_sym_EQ_GT,
    STATE(3310), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [112009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2105), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1009), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1125), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1101), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1705), 1,
      sym_statement_block,
    ACTIONS(5341), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [112079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2073), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5343), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112101] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(4773), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [112118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1893), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5345), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2001), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5347), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112173] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(5325), 1,
      anon_sym_LPAREN,
    STATE(2290), 1,
      sym_formal_parameters,
    STATE(2766), 1,
      sym__call_signature,
    STATE(3292), 1,
      sym_type_parameters,
  [112192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1997), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112203] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(5325), 1,
      anon_sym_LPAREN,
    STATE(2290), 1,
      sym_formal_parameters,
    STATE(2675), 1,
      sym__call_signature,
    STATE(3292), 1,
      sym_type_parameters,
  [112222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [112233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 1,
      anon_sym_LBRACE,
    STATE(2664), 1,
      sym_statement_block,
    ACTIONS(5349), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [112248] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 1,
      anon_sym_EQ,
    ACTIONS(5351), 1,
      anon_sym_COMMA,
    ACTIONS(5353), 1,
      anon_sym_RBRACE,
    STATE(3125), 1,
      aux_sym_enum_body_repeat1,
    STATE(3197), 1,
      sym__initializer,
  [112267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112278] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3316), 1,
      sym__call_signature,
  [112297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1989), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_AMP,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(5357), 1,
      anon_sym_PIPE,
    ACTIONS(5355), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5359), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5361), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [112338] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 1,
      anon_sym_LBRACE,
    STATE(102), 1,
      sym_statement_block,
    ACTIONS(5329), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [112353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112364] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(5325), 1,
      anon_sym_LPAREN,
    STATE(2290), 1,
      sym_formal_parameters,
    STATE(2556), 1,
      sym__call_signature,
    STATE(3292), 1,
      sym_type_parameters,
  [112383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112394] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_AMP,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(5357), 1,
      anon_sym_PIPE,
    ACTIONS(5363), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3293), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3295), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [112424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4932), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
  [112435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3297), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3299), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [112459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(1949), 1,
      sym_statement_block,
    ACTIONS(4856), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3301), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3303), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [112487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4840), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1097), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_COLON,
    ACTIONS(5365), 1,
      anon_sym_EQ_GT,
    STATE(3390), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [112524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4860), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112535] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2623), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [112554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [112565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5367), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5369), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [112578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5371), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [112589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4858), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4856), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [112622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5375), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [112633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(1937), 1,
      sym_statement_block,
    ACTIONS(4858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2053), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4589), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [112670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1470), 1,
      sym_statement_block,
    ACTIONS(5377), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [112685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2177), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_COLON,
    ACTIONS(5379), 1,
      anon_sym_EQ_GT,
    STATE(3310), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [112722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2013), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112733] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2612), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [112752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [112763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3059), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [112774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_COLON,
    ACTIONS(5383), 1,
      anon_sym_EQ_GT,
    STATE(3310), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [112800] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 1,
      anon_sym_EQ,
    ACTIONS(5385), 1,
      anon_sym_COMMA,
    ACTIONS(5387), 1,
      anon_sym_RBRACE,
    STATE(3077), 1,
      aux_sym_enum_body_repeat1,
    STATE(3197), 1,
      sym__initializer,
  [112819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(3069), 1,
      sym__initializer,
    ACTIONS(5389), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5391), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [112845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3055), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [112856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2113), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2049), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112878] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1705), 1,
      sym_statement_block,
    ACTIONS(5377), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [112893] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5269), 1,
      sym_identifier,
    ACTIONS(5393), 1,
      anon_sym_RBRACE,
    STATE(3311), 1,
      sym__import_export_specifier,
    ACTIONS(5275), 2,
      anon_sym_type,
      anon_sym_typeof,
  [112910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_COLON,
    ACTIONS(5395), 1,
      anon_sym_EQ_GT,
    STATE(3390), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [112925] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2754), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [112944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5397), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(1946), 1,
      sym_statement_block,
    ACTIONS(4840), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112970] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_COLON,
    ACTIONS(5399), 1,
      anon_sym_EQ_GT,
    STATE(3310), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [112985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5401), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2269), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [113007] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3333), 1,
      sym__call_signature,
  [113026] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5249), 1,
      anon_sym_abstract,
    ACTIONS(5403), 1,
      anon_sym_class,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
  [113045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3664), 1,
      anon_sym_LBRACE,
    ACTIONS(5139), 1,
      anon_sym_LT,
    STATE(3027), 1,
      sym_type_arguments,
    ACTIONS(3629), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [113062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5405), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113073] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3206), 1,
      sym__call_signature,
    STATE(3215), 1,
      sym_type_parameters,
  [113092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(1936), 1,
      sym_statement_block,
    ACTIONS(4860), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113107] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(5407), 1,
      sym_identifier,
    STATE(3578), 1,
      sym_object,
    STATE(3579), 1,
      sym_array,
  [113126] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(5325), 1,
      anon_sym_LPAREN,
    STATE(2290), 1,
      sym_formal_parameters,
    STATE(2583), 1,
      sym__call_signature,
    STATE(3292), 1,
      sym_type_parameters,
  [113145] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4972), 1,
      sym_identifier,
    ACTIONS(4974), 1,
      anon_sym_GT,
    ACTIONS(4978), 1,
      sym_jsx_identifier,
    STATE(2070), 1,
      sym_nested_identifier,
    STATE(2235), 1,
      sym_jsx_namespace_name,
  [113164] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 1,
      anon_sym_LBRACE,
    STATE(2696), 1,
      sym_statement_block,
    ACTIONS(5341), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [113179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5409), 1,
      sym__automatic_semicolon,
    ACTIONS(1149), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113192] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3396), 1,
      sym__call_signature,
  [113211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113222] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_AMP,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(5357), 1,
      anon_sym_PIPE,
    ACTIONS(5413), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [113239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5415), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [113250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1049), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1047), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [113263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1981), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1965), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2093), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_COLON,
    ACTIONS(5417), 1,
      anon_sym_EQ_GT,
    STATE(3310), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [113322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 1,
      anon_sym_LBRACE,
    STATE(85), 1,
      sym_statement_block,
    ACTIONS(5377), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [113337] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2542), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [113356] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3201), 1,
      sym__call_signature,
    STATE(3215), 1,
      sym_type_parameters,
  [113375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_DOT,
    ACTIONS(1545), 1,
      anon_sym_LBRACE,
    ACTIONS(1543), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [113390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(1953), 1,
      sym_statement_block,
    ACTIONS(4896), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113405] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(5325), 1,
      anon_sym_LPAREN,
    STATE(2290), 1,
      sym_formal_parameters,
    STATE(2645), 1,
      sym__call_signature,
    STATE(3292), 1,
      sym_type_parameters,
  [113424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(3008), 1,
      sym__initializer,
    ACTIONS(5419), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_COLON,
    ACTIONS(5421), 1,
      anon_sym_EQ_GT,
    STATE(3390), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [113454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(3100), 1,
      sym__initializer,
    ACTIONS(5423), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113469] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_AMP,
    ACTIONS(4620), 1,
      anon_sym_extends,
    ACTIONS(5357), 1,
      anon_sym_PIPE,
    ACTIONS(5425), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [113486] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3367), 1,
      sym__call_signature,
  [113505] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2550), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [113524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5427), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5429), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5431), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [113548] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(5325), 1,
      anon_sym_LPAREN,
    STATE(2290), 1,
      sym_formal_parameters,
    STATE(2596), 1,
      sym__call_signature,
    STATE(3292), 1,
      sym_type_parameters,
  [113567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_COLON,
    ACTIONS(5433), 1,
      anon_sym_EQ_GT,
    STATE(3310), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [113582] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_AMP,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    ACTIONS(5015), 1,
      anon_sym_extends,
    ACTIONS(5435), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [113599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5437), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3433), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3435), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [113623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [113634] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3366), 1,
      sym__call_signature,
  [113653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 1,
      sym__automatic_semicolon,
    ACTIONS(1029), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5441), 1,
      sym__automatic_semicolon,
    ACTIONS(1115), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4888), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5443), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [113701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3085), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [113712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5445), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113723] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2545), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [113742] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2617), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [113761] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3363), 1,
      sym__call_signature,
  [113780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(3046), 1,
      sym__initializer,
    ACTIONS(5447), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113795] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3196), 1,
      sym__call_signature,
    STATE(3215), 1,
      sym_type_parameters,
  [113814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5449), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__automatic_semicolon,
    ACTIONS(1019), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1083), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113849] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3358), 1,
      sym__call_signature,
  [113868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3445), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3447), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [113881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2304), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [113911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
  [113922] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2306), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [113941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(3112), 1,
      sym__initializer,
    ACTIONS(5453), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113956] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2316), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [113975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5455), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5457), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [113988] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3286), 1,
      sym__call_signature,
  [114007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(3071), 1,
      sym__initializer,
    ACTIONS(5459), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(1951), 1,
      sym_statement_block,
    ACTIONS(4878), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 1,
      anon_sym_LBRACE,
    STATE(548), 1,
      sym_statement_block,
    ACTIONS(5329), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [114052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4904), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
  [114063] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3345), 1,
      sym__call_signature,
  [114082] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(5325), 1,
      anon_sym_LPAREN,
    STATE(2290), 1,
      sym_formal_parameters,
    STATE(2795), 1,
      sym__call_signature,
    STATE(3292), 1,
      sym_type_parameters,
  [114101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3085), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [114112] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2659), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [114131] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3283), 1,
      sym__call_signature,
  [114150] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(1941), 1,
      sym_statement_block,
    ACTIONS(4884), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114165] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(3073), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [114184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5269), 1,
      sym_identifier,
    ACTIONS(5461), 1,
      anon_sym_RBRACE,
    STATE(3321), 1,
      sym__import_export_specifier,
    ACTIONS(5275), 2,
      anon_sym_type,
      anon_sym_typeof,
  [114201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5463), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114212] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5435), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [114229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_COLON,
    ACTIONS(5465), 1,
      anon_sym_EQ_GT,
    STATE(3390), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [114255] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(5325), 1,
      anon_sym_LPAREN,
    STATE(2290), 1,
      sym_formal_parameters,
    STATE(2777), 1,
      sym__call_signature,
    STATE(3292), 1,
      sym_type_parameters,
  [114274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3055), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [114285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3077), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [114296] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2734), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [114315] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3277), 1,
      sym__call_signature,
  [114334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5467), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114345] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2961), 1,
      sym__initializer,
    ACTIONS(5469), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(2952), 1,
      sym__initializer,
    ACTIONS(5473), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3262), 1,
      sym__call_signature,
  [114405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4940), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2069), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3073), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [114438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3059), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [114449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3457), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [114462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2057), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114473] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(5325), 1,
      anon_sym_LPAREN,
    STATE(2290), 1,
      sym_formal_parameters,
    STATE(2629), 1,
      sym__call_signature,
    STATE(3292), 1,
      sym_type_parameters,
  [114492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114503] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_LBRACE,
    STATE(1955), 1,
      sym_statement_block,
    ACTIONS(4902), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(979), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [114529] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3214), 1,
      sym__call_signature,
    STATE(3215), 1,
      sym_type_parameters,
  [114548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1073), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1163), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [114594] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3248), 1,
      sym__call_signature,
  [114613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4896), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114624] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(5325), 1,
      anon_sym_LPAREN,
    STATE(2290), 1,
      sym_formal_parameters,
    STATE(2663), 1,
      sym__call_signature,
    STATE(3292), 1,
      sym_type_parameters,
  [114643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114654] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5269), 1,
      sym_identifier,
    ACTIONS(5477), 1,
      anon_sym_RBRACE,
    STATE(3321), 1,
      sym__import_export_specifier,
    ACTIONS(5275), 2,
      anon_sym_type,
      anon_sym_typeof,
  [114671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1624), 1,
      sym_statement_block,
    ACTIONS(5349), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [114686] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3159), 1,
      sym__call_signature,
    STATE(3215), 1,
      sym_type_parameters,
  [114705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 1,
      anon_sym_is,
    ACTIONS(4910), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [114718] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5481), 1,
      anon_sym_class,
    ACTIONS(5483), 1,
      anon_sym_abstract,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
  [114737] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3239), 1,
      sym__call_signature,
  [114756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      anon_sym_COLON,
    ACTIONS(5487), 1,
      anon_sym_EQ_GT,
    STATE(3390), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [114782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5491), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [114795] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3240), 1,
      sym__call_signature,
  [114814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 1,
      anon_sym_EQ,
    STATE(3093), 1,
      sym__initializer,
    ACTIONS(5493), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114829] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_AMP,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    ACTIONS(5015), 1,
      anon_sym_extends,
    ACTIONS(5495), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [114846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1624), 1,
      sym_statement_block,
    ACTIONS(5329), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [114861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114872] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2320), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [114891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [114902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2149), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114913] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
    STATE(2325), 1,
      sym__call_signature,
    STATE(3320), 1,
      sym_type_parameters,
  [114932] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(5325), 1,
      anon_sym_LPAREN,
    STATE(2290), 1,
      sym_formal_parameters,
    STATE(2603), 1,
      sym__call_signature,
    STATE(3292), 1,
      sym_type_parameters,
  [114951] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3268), 1,
      sym__call_signature,
  [114970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [114981] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3339), 1,
      sym__call_signature,
  [115000] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2519), 1,
      sym_formal_parameters,
    STATE(3215), 1,
      sym_type_parameters,
    STATE(3243), 1,
      sym__call_signature,
  [115019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1985), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5497), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [115052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2097), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115063] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(4864), 1,
      anon_sym_extends,
    STATE(576), 1,
      sym_object_type,
    STATE(3082), 1,
      sym_extends_clause,
  [115082] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      sym_identifier,
    ACTIONS(5501), 1,
      anon_sym_GT,
    ACTIONS(5503), 1,
      sym_jsx_identifier,
    STATE(2084), 1,
      sym_nested_identifier,
    STATE(2214), 1,
      sym_jsx_namespace_name,
  [115101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 1,
      anon_sym_LBRACE,
    STATE(543), 1,
      sym_statement_block,
    ACTIONS(5377), 3,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_SEMI,
  [115127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5505), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1949), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(4814), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [115177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1957), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [115199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    STATE(2827), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5511), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    STATE(2927), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5513), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5515), 1,
      anon_sym_LBRACK,
    ACTIONS(1571), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(579), 1,
      anon_sym_BQUOTE,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    STATE(1784), 2,
      sym_template_string,
      sym_arguments,
  [115253] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_DQUOTE,
    ACTIONS(5519), 1,
      aux_sym_string_token1,
    ACTIONS(5521), 1,
      sym_escape_sequence,
    STATE(2906), 1,
      aux_sym_string_repeat1,
  [115269] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3348), 1,
      sym_type_parameters,
    STATE(3599), 1,
      sym_formal_parameters,
  [115285] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3341), 1,
      sym_type_parameters,
    STATE(3633), 1,
      sym_formal_parameters,
  [115301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(1571), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5525), 1,
      anon_sym_COLON,
  [115329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3343), 1,
      sym_type_parameters,
    STATE(3619), 1,
      sym_formal_parameters,
  [115345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5083), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [115355] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5527), 1,
      anon_sym_SQUOTE,
    ACTIONS(5529), 1,
      aux_sym_string_token2,
    ACTIONS(5531), 1,
      sym_escape_sequence,
    STATE(2903), 1,
      aux_sym_string_repeat2,
  [115371] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5529), 1,
      aux_sym_string_token2,
    ACTIONS(5531), 1,
      sym_escape_sequence,
    ACTIONS(5533), 1,
      anon_sym_SQUOTE,
    STATE(2903), 1,
      aux_sym_string_repeat2,
  [115387] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5519), 1,
      aux_sym_string_token1,
    ACTIONS(5521), 1,
      sym_escape_sequence,
    ACTIONS(5533), 1,
      anon_sym_DQUOTE,
    STATE(2906), 1,
      aux_sym_string_repeat1,
  [115403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5535), 1,
      sym_identifier,
    ACTIONS(5537), 1,
      sym_jsx_identifier,
    STATE(3165), 1,
      sym_nested_identifier,
    STATE(3567), 1,
      sym_jsx_namespace_name,
  [115419] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3355), 1,
      sym_type_parameters,
    STATE(3552), 1,
      sym_formal_parameters,
  [115435] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5519), 1,
      aux_sym_string_token1,
    ACTIONS(5521), 1,
      sym_escape_sequence,
    ACTIONS(5527), 1,
      anon_sym_DQUOTE,
    STATE(2906), 1,
      aux_sym_string_repeat1,
  [115451] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5539), 1,
      sym_identifier,
    STATE(445), 1,
      sym_generic_type,
    STATE(2027), 1,
      sym_nested_identifier,
    STATE(3156), 1,
      sym_nested_type_identifier,
  [115467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3359), 1,
      sym_type_parameters,
    STATE(3617), 1,
      sym_formal_parameters,
  [115483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5541), 1,
      sym_identifier,
    STATE(2232), 1,
      sym_nested_identifier,
    STATE(2242), 1,
      sym_generic_type,
    STATE(3258), 1,
      sym_nested_type_identifier,
  [115499] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5543), 1,
      anon_sym_SQUOTE,
    ACTIONS(5545), 1,
      aux_sym_string_token2,
    ACTIONS(5547), 1,
      sym_escape_sequence,
    STATE(2868), 1,
      aux_sym_string_repeat2,
  [115515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5549), 1,
      anon_sym_LBRACK,
    ACTIONS(1571), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5269), 1,
      sym_identifier,
    STATE(3311), 1,
      sym__import_export_specifier,
    ACTIONS(5275), 2,
      anon_sym_type,
      anon_sym_typeof,
  [115541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5551), 1,
      sym_identifier,
    STATE(2081), 1,
      sym_nested_identifier,
    STATE(2099), 1,
      sym_generic_type,
    STATE(3391), 1,
      sym_nested_type_identifier,
  [115557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5553), 1,
      anon_sym_LBRACK,
    ACTIONS(1571), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5555), 1,
      anon_sym_COMMA,
    STATE(2827), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5558), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    STATE(2929), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5560), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [115597] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3307), 1,
      anon_sym_COLON,
    STATE(3180), 1,
      sym_type_annotation,
    ACTIONS(5562), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [115611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_LBRACK,
    ACTIONS(1571), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5566), 1,
      anon_sym_RPAREN,
  [115639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5568), 1,
      anon_sym_RPAREN,
  [115655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5570), 1,
      anon_sym_QMARK,
    ACTIONS(2889), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [115667] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5572), 1,
      sym_identifier,
    ACTIONS(5574), 1,
      sym_jsx_identifier,
    STATE(3307), 1,
      sym_nested_identifier,
    STATE(3504), 1,
      sym_jsx_namespace_name,
  [115683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3373), 1,
      sym_type_parameters,
    STATE(3491), 1,
      sym_formal_parameters,
  [115699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_BQUOTE,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    STATE(1696), 2,
      sym_template_string,
      sym_arguments,
  [115713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      sym_identifier,
    ACTIONS(5578), 1,
      sym_jsx_identifier,
    STATE(3224), 1,
      sym_nested_identifier,
    STATE(3580), 1,
      sym_jsx_namespace_name,
  [115729] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_SQUOTE,
    ACTIONS(5582), 1,
      aux_sym_string_token2,
    ACTIONS(5584), 1,
      sym_escape_sequence,
    STATE(2873), 1,
      aux_sym_string_repeat2,
  [115745] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_DQUOTE,
    ACTIONS(5586), 1,
      aux_sym_string_token1,
    ACTIONS(5588), 1,
      sym_escape_sequence,
    STATE(2806), 1,
      aux_sym_string_repeat1,
  [115761] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2922), 1,
      anon_sym_LBRACE,
    ACTIONS(4668), 1,
      anon_sym_STAR,
    STATE(3540), 2,
      sym_namespace_import,
      sym_named_imports,
  [115775] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3269), 1,
      sym_type_parameters,
    STATE(3614), 1,
      sym_formal_parameters,
  [115791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_COMMA,
    ACTIONS(5590), 1,
      anon_sym_LBRACE,
    ACTIONS(5592), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2897), 1,
      aux_sym_extends_clause_repeat1,
  [115807] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5594), 1,
      anon_sym_RBRACK,
  [115823] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5596), 1,
      anon_sym_SQUOTE,
    ACTIONS(5598), 1,
      aux_sym_string_token2,
    ACTIONS(5600), 1,
      sym_escape_sequence,
    STATE(2814), 1,
      aux_sym_string_repeat2,
  [115839] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5602), 1,
      anon_sym_RBRACK,
  [115855] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_COMMA,
    ACTIONS(5604), 1,
      anon_sym_LBRACE,
    ACTIONS(5606), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2897), 1,
      aux_sym_extends_clause_repeat1,
  [115871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5608), 1,
      anon_sym_EQ_GT,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [115883] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5610), 1,
      anon_sym_RBRACK,
  [115899] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5612), 1,
      anon_sym_QMARK,
  [115915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5614), 1,
      anon_sym_RBRACK,
  [115931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5616), 1,
      anon_sym_COLON,
  [115947] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5596), 1,
      anon_sym_DQUOTE,
    ACTIONS(5618), 1,
      aux_sym_string_token1,
    ACTIONS(5620), 1,
      sym_escape_sequence,
    STATE(2815), 1,
      aux_sym_string_repeat1,
  [115963] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5622), 1,
      anon_sym_DQUOTE,
    ACTIONS(5624), 1,
      aux_sym_string_token1,
    ACTIONS(5626), 1,
      sym_escape_sequence,
    STATE(2857), 1,
      aux_sym_string_repeat1,
  [115979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5628), 1,
      anon_sym_RBRACK,
  [115995] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5622), 1,
      anon_sym_SQUOTE,
    ACTIONS(5630), 1,
      aux_sym_string_token2,
    ACTIONS(5632), 1,
      sym_escape_sequence,
    STATE(2858), 1,
      aux_sym_string_repeat2,
  [116011] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
  [116027] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5519), 1,
      aux_sym_string_token1,
    ACTIONS(5521), 1,
      sym_escape_sequence,
    ACTIONS(5636), 1,
      anon_sym_DQUOTE,
    STATE(2906), 1,
      aux_sym_string_repeat1,
  [116043] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5529), 1,
      aux_sym_string_token2,
    ACTIONS(5531), 1,
      sym_escape_sequence,
    ACTIONS(5636), 1,
      anon_sym_SQUOTE,
    STATE(2903), 1,
      aux_sym_string_repeat2,
  [116059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5638), 1,
      anon_sym_COLON,
  [116075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5640), 1,
      anon_sym_RBRACK,
  [116091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5642), 1,
      anon_sym_RBRACK,
  [116107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5033), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [116117] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5644), 1,
      anon_sym_COLON,
  [116133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 1,
      sym_identifier,
    STATE(445), 1,
      sym_generic_type,
    STATE(504), 1,
      sym_nested_identifier,
    STATE(3156), 1,
      sym_nested_type_identifier,
  [116149] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2803), 1,
      anon_sym_COMMA,
    ACTIONS(3395), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3474), 1,
      anon_sym_LBRACE,
    STATE(2842), 1,
      aux_sym_extends_clause_repeat1,
  [116165] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5519), 1,
      aux_sym_string_token1,
    ACTIONS(5521), 1,
      sym_escape_sequence,
    ACTIONS(5648), 1,
      anon_sym_DQUOTE,
    STATE(2906), 1,
      aux_sym_string_repeat1,
  [116181] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5650), 1,
      anon_sym_RPAREN,
  [116197] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5529), 1,
      aux_sym_string_token2,
    ACTIONS(5531), 1,
      sym_escape_sequence,
    ACTIONS(5648), 1,
      anon_sym_SQUOTE,
    STATE(2903), 1,
      aux_sym_string_repeat2,
  [116213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_LBRACK,
    ACTIONS(1571), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [116225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    STATE(2904), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5606), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [116239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    STATE(2904), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5592), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [116253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3307), 1,
      anon_sym_COLON,
    STATE(3281), 1,
      sym_type_annotation,
    ACTIONS(5654), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [116267] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5517), 1,
      anon_sym_SQUOTE,
    ACTIONS(5529), 1,
      aux_sym_string_token2,
    ACTIONS(5531), 1,
      sym_escape_sequence,
    STATE(2903), 1,
      aux_sym_string_repeat2,
  [116283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 1,
      sym_identifier,
    ACTIONS(5658), 1,
      sym_jsx_identifier,
    STATE(3226), 1,
      sym_nested_identifier,
    STATE(3669), 1,
      sym_jsx_namespace_name,
  [116299] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 1,
      anon_sym_EQ,
    STATE(3197), 1,
      sym__initializer,
    ACTIONS(5660), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [116313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5662), 1,
      anon_sym_RBRACK,
  [116329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    STATE(2887), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5664), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [116343] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5666), 1,
      anon_sym_RBRACK,
  [116359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5668), 1,
      anon_sym_RPAREN,
  [116375] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym_identifier,
    ACTIONS(5672), 1,
      sym_jsx_identifier,
    STATE(3375), 1,
      sym_nested_identifier,
    STATE(3421), 1,
      sym_jsx_namespace_name,
  [116391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    STATE(2802), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5674), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [116405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_BQUOTE,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    STATE(1239), 2,
      sym_template_string,
      sym_arguments,
  [116419] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5676), 1,
      anon_sym_class,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
  [116435] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_RBRACK,
  [116451] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(983), 1,
      anon_sym_while,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    STATE(583), 1,
      sym_statement_block,
  [116467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3385), 1,
      sym_type_parameters,
    STATE(3404), 1,
      sym_formal_parameters,
  [116483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    STATE(2827), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5680), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [116497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5682), 1,
      anon_sym_export,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
  [116513] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5684), 1,
      anon_sym_RBRACK,
  [116529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      anon_sym_EQ,
    STATE(3230), 1,
      sym_default_type,
    ACTIONS(5686), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [116543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [116553] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5688), 1,
      anon_sym_RBRACK,
  [116569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5690), 1,
      anon_sym_from,
    STATE(3362), 1,
      sym__from_clause,
    ACTIONS(5692), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [116583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5071), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [116593] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5694), 1,
      anon_sym_COLON,
  [116609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5269), 1,
      sym_identifier,
    STATE(3321), 1,
      sym__import_export_specifier,
    ACTIONS(5275), 2,
      anon_sym_type,
      anon_sym_typeof,
  [116623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3629), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3664), 1,
      anon_sym_LBRACE,
    ACTIONS(5696), 1,
      anon_sym_COMMA,
    STATE(2897), 1,
      aux_sym_extends_clause_repeat1,
  [116639] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5699), 1,
      anon_sym_DQUOTE,
    ACTIONS(5701), 1,
      aux_sym_string_token1,
    ACTIONS(5703), 1,
      sym_escape_sequence,
    STATE(2902), 1,
      aux_sym_string_repeat1,
  [116655] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5699), 1,
      anon_sym_SQUOTE,
    ACTIONS(5705), 1,
      aux_sym_string_token2,
    ACTIONS(5707), 1,
      sym_escape_sequence,
    STATE(2907), 1,
      aux_sym_string_repeat2,
  [116671] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5543), 1,
      anon_sym_DQUOTE,
    ACTIONS(5709), 1,
      aux_sym_string_token1,
    ACTIONS(5711), 1,
      sym_escape_sequence,
    STATE(2866), 1,
      aux_sym_string_repeat1,
  [116687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5713), 1,
      anon_sym_RBRACK,
  [116703] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5519), 1,
      aux_sym_string_token1,
    ACTIONS(5521), 1,
      sym_escape_sequence,
    ACTIONS(5715), 1,
      anon_sym_DQUOTE,
    STATE(2906), 1,
      aux_sym_string_repeat1,
  [116719] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5717), 1,
      anon_sym_SQUOTE,
    ACTIONS(5719), 1,
      aux_sym_string_token2,
    ACTIONS(5722), 1,
      sym_escape_sequence,
    STATE(2903), 1,
      aux_sym_string_repeat2,
  [116735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5725), 1,
      anon_sym_COMMA,
    STATE(2904), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3629), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [116749] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5728), 1,
      anon_sym_class,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
  [116765] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5730), 1,
      anon_sym_DQUOTE,
    ACTIONS(5732), 1,
      aux_sym_string_token1,
    ACTIONS(5735), 1,
      sym_escape_sequence,
    STATE(2906), 1,
      aux_sym_string_repeat1,
  [116781] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5529), 1,
      aux_sym_string_token2,
    ACTIONS(5531), 1,
      sym_escape_sequence,
    ACTIONS(5715), 1,
      anon_sym_SQUOTE,
    STATE(2903), 1,
      aux_sym_string_repeat2,
  [116797] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5738), 1,
      anon_sym_COLON,
  [116813] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 1,
      sym_identifier,
    STATE(1648), 1,
      sym_generic_type,
    STATE(1649), 1,
      sym_nested_identifier,
    STATE(3217), 1,
      sym_nested_type_identifier,
  [116829] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5742), 1,
      anon_sym_RPAREN,
  [116845] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5744), 1,
      anon_sym_QMARK,
  [116861] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5746), 1,
      anon_sym_QMARK,
  [116877] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5748), 1,
      anon_sym_DQUOTE,
    ACTIONS(5750), 1,
      aux_sym_string_token1,
    ACTIONS(5752), 1,
      sym_escape_sequence,
    STATE(2923), 1,
      aux_sym_string_repeat1,
  [116893] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5748), 1,
      anon_sym_SQUOTE,
    ACTIONS(5754), 1,
      aux_sym_string_token2,
    ACTIONS(5756), 1,
      sym_escape_sequence,
    STATE(2924), 1,
      aux_sym_string_repeat2,
  [116909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5758), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [116919] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5760), 1,
      anon_sym_COLON,
  [116935] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5762), 1,
      anon_sym_QMARK,
  [116951] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5764), 1,
      anon_sym_QMARK,
  [116967] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5766), 1,
      anon_sym_DQUOTE,
    ACTIONS(5768), 1,
      aux_sym_string_token1,
    ACTIONS(5770), 1,
      sym_escape_sequence,
    STATE(2925), 1,
      aux_sym_string_repeat1,
  [116983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5772), 1,
      anon_sym_QMARK,
  [116999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5774), 1,
      anon_sym_QMARK,
  [117015] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5766), 1,
      anon_sym_SQUOTE,
    ACTIONS(5776), 1,
      aux_sym_string_token2,
    ACTIONS(5778), 1,
      sym_escape_sequence,
    STATE(2928), 1,
      aux_sym_string_repeat2,
  [117031] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5519), 1,
      aux_sym_string_token1,
    ACTIONS(5521), 1,
      sym_escape_sequence,
    ACTIONS(5780), 1,
      anon_sym_DQUOTE,
    STATE(2906), 1,
      aux_sym_string_repeat1,
  [117047] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5529), 1,
      aux_sym_string_token2,
    ACTIONS(5531), 1,
      sym_escape_sequence,
    ACTIONS(5780), 1,
      anon_sym_SQUOTE,
    STATE(2903), 1,
      aux_sym_string_repeat2,
  [117063] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5519), 1,
      aux_sym_string_token1,
    ACTIONS(5521), 1,
      sym_escape_sequence,
    ACTIONS(5782), 1,
      anon_sym_DQUOTE,
    STATE(2906), 1,
      aux_sym_string_repeat1,
  [117079] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5784), 1,
      anon_sym_SQUOTE,
    ACTIONS(5786), 1,
      aux_sym_string_token2,
    ACTIONS(5788), 1,
      sym_escape_sequence,
    STATE(2813), 1,
      aux_sym_string_repeat2,
  [117095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    STATE(2827), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5790), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [117109] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5529), 1,
      aux_sym_string_token2,
    ACTIONS(5531), 1,
      sym_escape_sequence,
    ACTIONS(5782), 1,
      anon_sym_SQUOTE,
    STATE(2903), 1,
      aux_sym_string_repeat2,
  [117125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    STATE(2827), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5792), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [117139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5794), 1,
      sym_identifier,
    STATE(1139), 1,
      sym_nested_identifier,
    STATE(1145), 1,
      sym_generic_type,
    STATE(3318), 1,
      sym_nested_type_identifier,
  [117155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 1,
      anon_sym_EQ,
    STATE(3233), 1,
      sym__initializer,
    ACTIONS(5796), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [117169] = 5,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5784), 1,
      anon_sym_DQUOTE,
    ACTIONS(5798), 1,
      aux_sym_string_token1,
    ACTIONS(5800), 1,
      sym_escape_sequence,
    STATE(2818), 1,
      aux_sym_string_repeat1,
  [117185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3150), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [117195] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(5802), 1,
      anon_sym_class,
    STATE(1979), 1,
      aux_sym_export_statement_repeat1,
    STATE(1994), 1,
      sym_decorator,
  [117211] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5804), 1,
      anon_sym_COLON,
  [117227] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5806), 1,
      sym_identifier,
    STATE(1524), 1,
      sym_generic_type,
    STATE(1525), 1,
      sym_nested_identifier,
    STATE(3203), 1,
      sym_nested_type_identifier,
  [117243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5690), 1,
      anon_sym_from,
    STATE(3179), 1,
      sym__from_clause,
    ACTIONS(5808), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [117257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
    ACTIONS(5810), 1,
      anon_sym_RPAREN,
  [117273] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2357), 1,
      sym_formal_parameters,
    STATE(3231), 1,
      sym_type_parameters,
  [117289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 1,
      anon_sym_EQ,
    STATE(3336), 1,
      sym__initializer,
    ACTIONS(5812), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [117303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    STATE(2871), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3395), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [117317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5814), 1,
      anon_sym_COMMA,
    STATE(2942), 1,
      aux_sym_array_repeat1,
    ACTIONS(3631), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [117331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4342), 1,
      anon_sym_EQ_GT,
    ACTIONS(2938), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [117343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [117352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3549), 1,
      anon_sym_RBRACK,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [117365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5817), 1,
      anon_sym_RBRACE,
    STATE(2965), 1,
      aux_sym_object_repeat1,
  [117378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5819), 1,
      anon_sym_as,
    ACTIONS(5821), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [117389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5823), 1,
      anon_sym_COMMA,
    ACTIONS(5825), 1,
      anon_sym_RBRACE,
    STATE(3062), 1,
      aux_sym_export_clause_repeat1,
  [117402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    ACTIONS(5829), 1,
      anon_sym_RBRACK,
    STATE(3088), 1,
      aux_sym__tuple_type_body_repeat1,
  [117415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4248), 1,
      anon_sym_RPAREN,
    ACTIONS(5831), 1,
      anon_sym_COMMA,
    STATE(2977), 1,
      aux_sym_formal_parameters_repeat1,
  [117428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5817), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [117441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117450] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3654), 1,
      anon_sym_RPAREN,
    STATE(2970), 1,
      aux_sym_array_repeat1,
  [117463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3654), 1,
      anon_sym_RPAREN,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [117476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 1,
      anon_sym_LBRACE,
    ACTIONS(5443), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [117487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [117496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5839), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117505] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(3293), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [117514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5841), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [117527] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(3297), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [117536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117545] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(3301), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [117554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5845), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [117567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    ACTIONS(5847), 1,
      anon_sym_RBRACK,
    STATE(2982), 1,
      aux_sym__tuple_type_body_repeat1,
  [117580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5849), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [117593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5851), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [117602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(5853), 1,
      anon_sym_RBRACK,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [117615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5855), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 1,
      anon_sym_LBRACE,
    ACTIONS(5415), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [117635] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(5859), 1,
      anon_sym_RPAREN,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [117648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    ACTIONS(5861), 1,
      anon_sym_RBRACK,
    STATE(3088), 1,
      aux_sym__tuple_type_body_repeat1,
  [117661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_GT,
    ACTIONS(5863), 1,
      anon_sym_COMMA,
    STATE(3079), 1,
      aux_sym_implements_clause_repeat1,
  [117674] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(3337), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [117683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(5865), 1,
      anon_sym_GT,
  [117696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3549), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_array_repeat1,
  [117709] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 1,
      anon_sym_COMMA,
    ACTIONS(5869), 1,
      anon_sym_RPAREN,
    STATE(3155), 1,
      aux_sym_formal_parameters_repeat1,
  [117722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5871), 1,
      anon_sym_COMMA,
    ACTIONS(5874), 1,
      anon_sym_RPAREN,
    STATE(2977), 1,
      aux_sym_formal_parameters_repeat1,
  [117735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5876), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [117748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      anon_sym_SQUOTE,
    STATE(3302), 1,
      sym_string,
  [117761] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 1,
      anon_sym_COMMA,
    ACTIONS(5881), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [117774] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(3368), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [117783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    ACTIONS(5883), 1,
      anon_sym_RBRACK,
    STATE(3088), 1,
      aux_sym__tuple_type_body_repeat1,
  [117796] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(3372), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [117805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(5885), 1,
      anon_sym_GT,
  [117818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 1,
      anon_sym_GT,
    ACTIONS(5887), 1,
      anon_sym_COMMA,
    STATE(3079), 1,
      aux_sym_implements_clause_repeat1,
  [117831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(5889), 1,
      anon_sym_RPAREN,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [117844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    ACTIONS(5891), 1,
      anon_sym_RBRACK,
    STATE(2949), 1,
      aux_sym__tuple_type_body_repeat1,
  [117857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5893), 1,
      anon_sym_RBRACE,
    STATE(3126), 1,
      aux_sym_object_repeat1,
  [117870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5895), 1,
      anon_sym_COMMA,
    ACTIONS(5898), 1,
      anon_sym_RBRACE,
    STATE(2989), 1,
      aux_sym_named_imports_repeat1,
  [117883] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4234), 1,
      anon_sym_RPAREN,
    ACTIONS(5900), 1,
      anon_sym_COMMA,
    STATE(2977), 1,
      aux_sym_formal_parameters_repeat1,
  [117896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4932), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [117905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5902), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5893), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [117927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3588), 1,
      anon_sym_RPAREN,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [117949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5906), 1,
      anon_sym_RBRACE,
    STATE(3012), 1,
      aux_sym_object_repeat1,
  [117962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3588), 1,
      anon_sym_RPAREN,
    STATE(2986), 1,
      aux_sym_array_repeat1,
  [117975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5906), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [117988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5908), 1,
      anon_sym_COMMA,
    ACTIONS(5910), 1,
      anon_sym_RPAREN,
    STATE(3117), 1,
      aux_sym_formal_parameters_repeat1,
  [118001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    STATE(574), 1,
      sym_object_type,
  [118014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5912), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [118023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(5914), 1,
      anon_sym_RBRACK,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [118036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4252), 1,
      anon_sym_RPAREN,
    ACTIONS(5916), 1,
      anon_sym_COMMA,
    STATE(2990), 1,
      aux_sym_formal_parameters_repeat1,
  [118049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3570), 1,
      anon_sym_RBRACK,
    STATE(3014), 1,
      aux_sym_array_repeat1,
  [118062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3570), 1,
      anon_sym_RBRACK,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [118075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4252), 1,
      anon_sym_RPAREN,
    ACTIONS(5916), 1,
      anon_sym_COMMA,
    STATE(2977), 1,
      aux_sym_formal_parameters_repeat1,
  [118088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4886), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [118097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5918), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5920), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [118119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5922), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [118132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5924), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [118145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5926), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [118158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    ACTIONS(5928), 1,
      anon_sym_RBRACK,
    STATE(2971), 1,
      aux_sym__tuple_type_body_repeat1,
  [118171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(5930), 1,
      anon_sym_RBRACK,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [118184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5932), 1,
      anon_sym_COMMA,
    ACTIONS(5935), 1,
      anon_sym_RBRACE,
    STATE(3015), 1,
      aux_sym_export_clause_repeat1,
  [118197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3566), 1,
      anon_sym_RBRACK,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [118210] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3566), 1,
      anon_sym_RBRACK,
    STATE(3002), 1,
      aux_sym_array_repeat1,
  [118223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_extends,
  [118236] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5937), 1,
      anon_sym_COMMA,
    ACTIONS(5939), 1,
      anon_sym_RPAREN,
    STATE(3006), 1,
      aux_sym_formal_parameters_repeat1,
  [118249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3656), 1,
      anon_sym_RPAREN,
    STATE(3122), 1,
      aux_sym_array_repeat1,
  [118262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5941), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [118275] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(3433), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [118293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3656), 1,
      anon_sym_RPAREN,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [118306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(5941), 1,
      anon_sym_RBRACE,
    STATE(3009), 1,
      aux_sym_object_repeat1,
  [118319] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5945), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 1,
      anon_sym_LBRACE,
    ACTIONS(1547), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [118339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5947), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3629), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [118357] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5455), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1557), 1,
      anon_sym_LBRACE,
    ACTIONS(1555), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [118377] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(3455), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(5949), 1,
      anon_sym_EQ,
    STATE(3496), 1,
      sym_type_parameters,
  [118399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    ACTIONS(5951), 1,
      anon_sym_RBRACK,
    STATE(3051), 1,
      aux_sym__tuple_type_body_repeat1,
  [118412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5660), 1,
      anon_sym_RBRACE,
    ACTIONS(5955), 1,
      anon_sym_COMMA,
    STATE(3036), 1,
      aux_sym_enum_body_repeat1,
  [118434] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(5958), 1,
      anon_sym_RBRACK,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [118447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5558), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(5962), 1,
      anon_sym_RBRACE,
    STATE(3130), 1,
      aux_sym_named_imports_repeat1,
  [118469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 1,
      anon_sym_LBRACE,
    ACTIONS(1551), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [118480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 1,
      anon_sym_GT,
    ACTIONS(5964), 1,
      anon_sym_COMMA,
    STATE(3079), 1,
      aux_sym_implements_clause_repeat1,
  [118493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym_EQ,
    ACTIONS(5968), 1,
      anon_sym_COMMA,
    ACTIONS(5970), 1,
      anon_sym_from,
  [118506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(5972), 1,
      anon_sym_GT,
  [118519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [118528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5976), 1,
      sym_identifier,
    ACTIONS(5978), 1,
      anon_sym_require,
    STATE(3086), 1,
      sym_nested_identifier,
  [118541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118550] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3672), 1,
      anon_sym_RBRACK,
    STATE(3150), 1,
      aux_sym_array_repeat1,
  [118563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3672), 1,
      anon_sym_RBRACK,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [118576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118585] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5984), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [118594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    ACTIONS(5986), 1,
      anon_sym_RBRACK,
    STATE(3088), 1,
      aux_sym__tuple_type_body_repeat1,
  [118607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      anon_sym_COMMA,
    ACTIONS(5990), 1,
      anon_sym_GT,
    STATE(3144), 1,
      aux_sym_type_parameters_repeat1,
  [118620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_implements,
    ACTIONS(5992), 1,
      anon_sym_LBRACE,
    STATE(3476), 1,
      sym_implements_clause,
  [118633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5119), 1,
      anon_sym_COMMA,
    ACTIONS(5994), 1,
      anon_sym_LBRACE,
    STATE(3058), 1,
      aux_sym_implements_clause_repeat1,
  [118646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4366), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4904), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [118673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5435), 1,
      anon_sym_LBRACE,
    ACTIONS(5998), 1,
      anon_sym_COMMA,
    STATE(3058), 1,
      aux_sym_implements_clause_repeat1,
  [118686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6001), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6003), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [118704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6005), 1,
      anon_sym_as,
    ACTIONS(6007), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [118715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5461), 1,
      anon_sym_RBRACE,
    ACTIONS(6009), 1,
      anon_sym_COMMA,
    STATE(3015), 1,
      aux_sym_export_clause_repeat1,
  [118728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6013), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6015), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_while,
    ACTIONS(6021), 1,
      anon_sym_else,
    STATE(580), 1,
      sym_else_clause,
  [118786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6023), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6025), 1,
      anon_sym_COMMA,
    ACTIONS(6027), 1,
      anon_sym_GT,
    STATE(3089), 1,
      aux_sym_type_parameters_repeat1,
  [118808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6031), 1,
      anon_sym_LBRACE,
    ACTIONS(5327), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [118828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6033), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3633), 1,
      anon_sym_RBRACK,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [118859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3633), 1,
      anon_sym_RBRACK,
    STATE(3037), 1,
      aux_sym_array_repeat1,
  [118872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_RBRACE,
    ACTIONS(6037), 1,
      anon_sym_COMMA,
    STATE(3036), 1,
      aux_sym_enum_body_repeat1,
  [118885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6039), 1,
      sym_identifier,
    ACTIONS(6041), 1,
      anon_sym_GT,
    STATE(3220), 1,
      sym_type_parameter,
  [118898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5435), 1,
      anon_sym_GT,
    ACTIONS(6043), 1,
      anon_sym_COMMA,
    STATE(3079), 1,
      aux_sym_implements_clause_repeat1,
  [118911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6046), 1,
      anon_sym_COMMA,
    ACTIONS(6049), 1,
      anon_sym_GT,
    STATE(3080), 1,
      aux_sym_type_parameters_repeat1,
  [118924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_LBRACE,
    ACTIONS(1559), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [118935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    STATE(610), 1,
      sym_object_type,
  [118948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    ACTIONS(6051), 1,
      anon_sym_RBRACK,
    STATE(3094), 1,
      aux_sym__tuple_type_body_repeat1,
  [118961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6053), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118970] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    ACTIONS(6055), 1,
      anon_sym_RBRACK,
    STATE(3088), 1,
      aux_sym__tuple_type_body_repeat1,
  [118983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_DOT,
    ACTIONS(6057), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [118994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_COMMA,
    ACTIONS(5970), 1,
      anon_sym_from,
    ACTIONS(6059), 1,
      anon_sym_EQ,
  [119007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_COMMA,
    ACTIONS(6064), 1,
      anon_sym_RBRACK,
    STATE(3088), 1,
      aux_sym__tuple_type_body_repeat1,
  [119020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6066), 1,
      anon_sym_COMMA,
    ACTIONS(6068), 1,
      anon_sym_GT,
    STATE(3080), 1,
      aux_sym_type_parameters_repeat1,
  [119033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2795), 1,
      anon_sym_GT,
    ACTIONS(6070), 1,
      anon_sym_COMMA,
    STATE(3079), 1,
      aux_sym_implements_clause_repeat1,
  [119046] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(3445), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [119055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_LT,
    ACTIONS(6072), 1,
      anon_sym_EQ,
    STATE(3511), 1,
      sym_type_parameters,
  [119068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6074), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    ACTIONS(6076), 1,
      anon_sym_RBRACK,
    STATE(3088), 1,
      aux_sym__tuple_type_body_repeat1,
  [119090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(6078), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [119103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6039), 1,
      sym_identifier,
    ACTIONS(6068), 1,
      anon_sym_GT,
    STATE(3220), 1,
      sym_type_parameter,
  [119116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6080), 1,
      anon_sym_is,
    ACTIONS(4910), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [119127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(6078), 1,
      anon_sym_RBRACE,
    STATE(2978), 1,
      aux_sym_object_repeat1,
  [119140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4001), 1,
      anon_sym_extends,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
  [119153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6082), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(6084), 1,
      anon_sym_GT,
  [119175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2793), 1,
      anon_sym_GT,
    ACTIONS(6086), 1,
      anon_sym_COMMA,
    STATE(3079), 1,
      aux_sym_implements_clause_repeat1,
  [119188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3664), 1,
      anon_sym_LBRACE,
    ACTIONS(3629), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [119199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(6088), 1,
      anon_sym_GT,
  [119212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(6090), 1,
      anon_sym_RPAREN,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [119225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5385), 1,
      anon_sym_COMMA,
    ACTIONS(5387), 1,
      anon_sym_RBRACE,
    STATE(3077), 1,
      aux_sym_enum_body_repeat1,
  [119238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    STATE(2630), 1,
      sym_object_type,
  [119251] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(5489), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [119260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2692), 1,
      anon_sym_GT,
    ACTIONS(6092), 1,
      anon_sym_COMMA,
    STATE(3079), 1,
      aux_sym_implements_clause_repeat1,
  [119273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6094), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6096), 1,
      anon_sym_LPAREN,
    ACTIONS(6098), 1,
      anon_sym_await,
    STATE(30), 1,
      sym__for_header,
  [119295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6100), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_while,
    ACTIONS(6102), 1,
      anon_sym_else,
    STATE(580), 1,
      sym_else_clause,
  [119317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 1,
      anon_sym_COMMA,
    ACTIONS(6104), 1,
      anon_sym_RBRACK,
    STATE(3085), 1,
      aux_sym__tuple_type_body_repeat1,
  [119330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6039), 1,
      sym_identifier,
    ACTIONS(6106), 1,
      anon_sym_GT,
    STATE(3220), 1,
      sym_type_parameter,
  [119343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [119352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_RPAREN,
    ACTIONS(6108), 1,
      anon_sym_COMMA,
    STATE(2977), 1,
      aux_sym_formal_parameters_repeat1,
  [119365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4264), 1,
      anon_sym_RPAREN,
    ACTIONS(6110), 1,
      anon_sym_COMMA,
    STATE(2977), 1,
      aux_sym_formal_parameters_repeat1,
  [119378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6112), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2741), 1,
      anon_sym_GT,
    ACTIONS(6114), 1,
      anon_sym_COMMA,
    STATE(3079), 1,
      aux_sym_implements_clause_repeat1,
  [119400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 1,
      anon_sym_DOT,
    ACTIONS(6116), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [119411] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(6118), 1,
      anon_sym_RPAREN,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [119424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5351), 1,
      anon_sym_COMMA,
    ACTIONS(5353), 1,
      anon_sym_RBRACE,
    STATE(3125), 1,
      aux_sym_enum_body_repeat1,
  [119437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(6120), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [119450] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4384), 1,
      anon_sym_RBRACE,
    ACTIONS(6122), 1,
      anon_sym_COMMA,
    STATE(3036), 1,
      aux_sym_enum_body_repeat1,
  [119463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_COMMA,
    ACTIONS(6124), 1,
      anon_sym_RBRACE,
    STATE(2980), 1,
      aux_sym_object_repeat1,
  [119476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6126), 1,
      sym_identifier,
    STATE(1858), 1,
      sym_decorator_member_expression,
    STATE(1922), 1,
      sym_decorator_call_expression,
  [119489] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3666), 1,
      anon_sym_RPAREN,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [119502] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(6128), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [119511] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5337), 1,
      anon_sym_RBRACE,
    ACTIONS(6130), 1,
      anon_sym_COMMA,
    STATE(2989), 1,
      aux_sym_named_imports_repeat1,
  [119524] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(6132), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [119533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(3666), 1,
      anon_sym_RPAREN,
    STATE(3105), 1,
      aux_sym_array_repeat1,
  [119546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(707), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2426), 1,
      anon_sym_LBRACE,
    STATE(2800), 1,
      sym_object_type,
  [119559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6134), 1,
      sym_identifier,
    ACTIONS(6136), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [119570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6138), 1,
      sym_identifier,
    ACTIONS(6140), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [119581] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2729), 1,
      anon_sym_GT,
    ACTIONS(6142), 1,
      anon_sym_COMMA,
    STATE(3079), 1,
      aux_sym_implements_clause_repeat1,
  [119594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6144), 1,
      anon_sym_LPAREN,
    ACTIONS(6146), 1,
      anon_sym_await,
    STATE(39), 1,
      sym__for_header,
  [119607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 1,
      anon_sym_LBRACE,
    ACTIONS(1563), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [119618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3727), 1,
      anon_sym_extends,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
  [119631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(5015), 1,
      anon_sym_extends,
  [119644] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4620), 1,
      anon_sym_extends,
  [119657] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3146), 1,
      anon_sym_extends,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
  [119670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(4828), 1,
      anon_sym_extends,
  [119683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 1,
      anon_sym_COMMA,
    ACTIONS(6150), 1,
      anon_sym_GT,
    STATE(3080), 1,
      aux_sym_type_parameters_repeat1,
  [119696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6039), 1,
      sym_identifier,
    ACTIONS(6150), 1,
      anon_sym_GT,
    STATE(3220), 1,
      sym_type_parameter,
  [119709] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_AMP,
    ACTIONS(4484), 1,
      anon_sym_PIPE,
    ACTIONS(6152), 1,
      anon_sym_extends,
  [119722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_RPAREN,
    ACTIONS(6108), 1,
      anon_sym_COMMA,
    STATE(2950), 1,
      aux_sym_formal_parameters_repeat1,
  [119735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    ACTIONS(6154), 1,
      anon_sym_LPAREN,
    STATE(554), 1,
      sym_statement_block,
  [119748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3631), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [119757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1177), 1,
      anon_sym_COMMA,
    ACTIONS(6156), 1,
      anon_sym_RBRACK,
    STATE(2942), 1,
      aux_sym_array_repeat1,
  [119770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6158), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6160), 1,
      anon_sym_LPAREN,
    ACTIONS(6162), 1,
      anon_sym_await,
    STATE(50), 1,
      sym__for_header,
  [119792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(897), 1,
      anon_sym_DQUOTE,
    ACTIONS(899), 1,
      anon_sym_SQUOTE,
    STATE(3474), 1,
      sym_string,
  [119805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_RPAREN,
    ACTIONS(6164), 1,
      anon_sym_COMMA,
    STATE(3118), 1,
      aux_sym_formal_parameters_repeat1,
  [119818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_RPAREN,
    ACTIONS(6164), 1,
      anon_sym_COMMA,
    STATE(2977), 1,
      aux_sym_formal_parameters_repeat1,
  [119831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4449), 1,
      anon_sym_LT,
    STATE(427), 1,
      sym_type_arguments,
  [119841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2566), 1,
      sym_class_body,
  [119851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    STATE(1528), 1,
      sym_class_body,
  [119861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1624), 1,
      sym_statement_block,
  [119871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    STATE(1214), 1,
      sym_class_body,
  [119881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 1,
      anon_sym_LPAREN,
    STATE(42), 1,
      sym_parenthesized_expression,
  [119891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 1,
      anon_sym_LPAREN,
    STATE(53), 1,
      sym_parenthesized_expression,
  [119901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 1,
      anon_sym_LPAREN,
    STATE(46), 1,
      sym_parenthesized_expression,
  [119911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_LBRACE,
    STATE(1211), 1,
      sym_statement_block,
  [119921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(5972), 1,
      anon_sym_GT,
  [119931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 1,
      anon_sym_LPAREN,
    STATE(40), 1,
      sym_parenthesized_expression,
  [119941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(622), 1,
      sym_statement_block,
  [119951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 1,
      anon_sym_LPAREN,
    STATE(3259), 1,
      sym_parenthesized_expression,
  [119961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6168), 1,
      anon_sym_LPAREN,
    STATE(3325), 1,
      sym_parenthesized_expression,
  [119971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_LBRACE,
    STATE(1201), 1,
      sym_statement_block,
  [119981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 1,
      anon_sym_LPAREN,
    STATE(31), 1,
      sym_parenthesized_expression,
  [119991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(509), 1,
      sym_statement_block,
  [120001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5690), 1,
      anon_sym_from,
    STATE(3179), 1,
      sym__from_clause,
  [120011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 1,
      anon_sym_LPAREN,
    STATE(55), 1,
      sym_parenthesized_expression,
  [120021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym_parenthesized_expression,
  [120031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    STATE(1195), 1,
      sym_arguments,
  [120041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6170), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6039), 1,
      sym_identifier,
    STATE(3220), 1,
      sym_type_parameter,
  [120059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2869), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6172), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [120075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6174), 1,
      anon_sym_LBRACE,
    STATE(2600), 1,
      sym_enum_body,
  [120085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    STATE(1661), 1,
      sym_class_body,
  [120095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4779), 1,
      anon_sym_LBRACE,
    STATE(632), 1,
      sym_class_body,
  [120105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6176), 2,
      sym_identifier,
      sym_this,
  [120113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4348), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    STATE(1182), 1,
      sym_class_body,
  [120131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6178), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [120139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6180), 1,
      anon_sym_LPAREN,
    STATE(32), 1,
      sym__for_header,
  [120149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2812), 1,
      sym_jsx_identifier,
    ACTIONS(6182), 1,
      sym_identifier,
  [120159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6184), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2759), 1,
      sym_class_body,
  [120177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4777), 1,
      anon_sym_LBRACE,
    STATE(82), 1,
      sym_class_body,
  [120187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    STATE(1179), 1,
      sym_class_body,
  [120197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(553), 1,
      sym_class_body,
  [120207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_LPAREN,
    STATE(1231), 1,
      sym_arguments,
  [120217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_LBRACE,
    STATE(1176), 1,
      sym_statement_block,
  [120227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6186), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4779), 1,
      anon_sym_LBRACE,
    STATE(624), 1,
      sym_class_body,
  [120245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4779), 1,
      anon_sym_LBRACE,
    STATE(595), 1,
      sym_class_body,
  [120255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    STATE(1485), 1,
      sym_class_body,
  [120265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 1,
      anon_sym_LBRACE,
    STATE(84), 1,
      sym_statement_block,
  [120275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2577), 1,
      sym_formal_parameters,
  [120285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6188), 1,
      anon_sym_LT,
    STATE(1511), 1,
      sym_type_arguments,
  [120295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4290), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6180), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym__for_header,
  [120313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3288), 1,
      sym_statement_block,
  [120323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3642), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 1,
      anon_sym_LPAREN,
    STATE(48), 1,
      sym_parenthesized_expression,
  [120341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5686), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [120349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6064), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [120357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 1,
      anon_sym_LPAREN,
    STATE(49), 1,
      sym_parenthesized_expression,
  [120367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6190), 1,
      anon_sym_LBRACE,
    STATE(585), 1,
      sym_enum_body,
  [120377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_LBRACE,
    STATE(1180), 1,
      sym_statement_block,
  [120387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1469), 1,
      sym_statement_block,
  [120397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2481), 1,
      sym_formal_parameters,
  [120407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5690), 1,
      anon_sym_from,
    STATE(3362), 1,
      sym__from_clause,
  [120417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6192), 1,
      anon_sym_LT,
    STATE(1701), 1,
      sym_type_arguments,
  [120427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2553), 1,
      sym_class_body,
  [120437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(6088), 1,
      anon_sym_GT,
  [120447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [120455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6194), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6196), 1,
      sym_identifier,
    ACTIONS(6198), 1,
      anon_sym_STAR,
  [120473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(6084), 1,
      anon_sym_GT,
  [120483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(6084), 1,
      anon_sym_GT,
  [120493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5660), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(6088), 1,
      anon_sym_GT,
  [120511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    STATE(1457), 1,
      sym_class_body,
  [120521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    STATE(1189), 1,
      sym_class_body,
  [120531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2581), 1,
      sym_class_body,
  [120541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6200), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [120549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2372), 1,
      sym_formal_parameters,
  [120559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 1,
      anon_sym_LBRACE,
    STATE(98), 1,
      sym_statement_block,
  [120569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [120577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    STATE(1191), 1,
      sym_class_body,
  [120587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    STATE(3059), 1,
      sym_type_annotation,
  [120597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4777), 1,
      anon_sym_LBRACE,
    STATE(99), 1,
      sym_class_body,
  [120607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4312), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3610), 1,
      sym_formal_parameters,
  [120625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_LBRACE,
    STATE(1192), 1,
      sym_statement_block,
  [120635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_LBRACE,
    STATE(1196), 1,
      sym_statement_block,
  [120645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    STATE(1202), 1,
      sym_class_body,
  [120655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6204), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 1,
      anon_sym_LBRACE,
    STATE(541), 1,
      sym_statement_block,
  [120673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5690), 1,
      anon_sym_from,
    STATE(3249), 1,
      sym__from_clause,
  [120683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(546), 1,
      sym_class_body,
  [120693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    STATE(1683), 1,
      sym_class_body,
  [120703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(5972), 1,
      anon_sym_GT,
  [120713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3185), 1,
      sym_statement_block,
  [120723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5690), 1,
      anon_sym_from,
    STATE(3242), 1,
      sym__from_clause,
  [120741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2651), 1,
      sym_formal_parameters,
  [120751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1572), 1,
      sym_statement_block,
  [120761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6208), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      sym_identifier,
    ACTIONS(5243), 1,
      anon_sym_LBRACK,
  [120779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4370), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2582), 1,
      sym_class_body,
  [120797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6210), 1,
      sym_identifier,
    STATE(3121), 1,
      sym_nested_identifier,
  [120807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_LT,
    STATE(2261), 1,
      sym_type_arguments,
  [120817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6212), 1,
      anon_sym_LBRACE,
    STATE(603), 1,
      sym_switch_body,
  [120827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6180), 1,
      anon_sym_LPAREN,
    STATE(45), 1,
      sym__for_header,
  [120837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4308), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [120845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3279), 1,
      sym_statement_block,
  [120855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6214), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [120863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4777), 1,
      anon_sym_LBRACE,
    STATE(91), 1,
      sym_class_body,
  [120873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    STATE(1429), 1,
      sym_class_body,
  [120883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2557), 1,
      sym_class_body,
  [120893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2541), 1,
      sym_class_body,
  [120903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_LBRACE,
    STATE(1209), 1,
      sym_statement_block,
  [120913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3554), 1,
      sym_formal_parameters,
  [120923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6216), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3558), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3556), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [120955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2690), 1,
      sym_formal_parameters,
  [120965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4779), 1,
      anon_sym_LBRACE,
    STATE(638), 1,
      sym_class_body,
  [120975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    STATE(1212), 1,
      sym_class_body,
  [120985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 1,
      anon_sym_LBRACE,
    STATE(2697), 1,
      sym_statement_block,
  [120995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3364), 1,
      sym_statement_block,
  [121005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4352), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6174), 1,
      anon_sym_LBRACE,
    STATE(2568), 1,
      sym_enum_body,
  [121023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6220), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [121031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 1,
      anon_sym_LBRACE,
    STATE(2610), 1,
      sym_statement_block,
  [121041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 1,
      anon_sym_LBRACE,
    STATE(2708), 1,
      sym_statement_block,
  [121051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(2578), 1,
      sym_class_body,
  [121061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4360), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3334), 1,
      sym_statement_block,
  [121079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 1,
      anon_sym_LBRACE,
    STATE(1167), 1,
      sym_statement_block,
  [121089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4340), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6039), 1,
      sym_identifier,
    STATE(3070), 1,
      sym_type_parameter,
  [121107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3301), 1,
      sym_statement_block,
  [121125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5325), 1,
      anon_sym_LPAREN,
    STATE(2292), 1,
      sym_formal_parameters,
  [121135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1655), 1,
      sym_statement_block,
  [121145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 1,
      anon_sym_LBRACE,
    STATE(1265), 1,
      sym_class_body,
  [121155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(552), 1,
      sym_class_body,
  [121165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      sym_identifier,
    STATE(3086), 1,
      sym_nested_identifier,
  [121175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4777), 1,
      anon_sym_LBRACE,
    STATE(96), 1,
      sym_class_body,
  [121185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3204), 1,
      sym_statement_block,
  [121195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3500), 1,
      sym_formal_parameters,
  [121205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6224), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4304), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6226), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3328), 1,
      sym_statement_block,
  [121239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    STATE(1622), 1,
      sym_class_body,
  [121249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6039), 1,
      sym_identifier,
    STATE(3052), 1,
      sym_type_parameter,
  [121259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6228), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(5865), 1,
      anon_sym_GT,
  [121277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    STATE(1687), 1,
      sym_class_body,
  [121287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5881), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5083), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [121303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6230), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5071), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [121319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(5865), 1,
      anon_sym_GT,
  [121329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6232), 2,
      sym_identifier,
      sym_this,
  [121337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      sym_identifier,
    ACTIONS(6236), 1,
      anon_sym_STAR,
  [121347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1574), 1,
      sym_statement_block,
  [121357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3237), 1,
      sym_statement_block,
  [121367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6238), 1,
      anon_sym_LT,
    STATE(1165), 1,
      sym_type_arguments,
  [121377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6240), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2644), 1,
      anon_sym_LPAREN,
    STATE(2141), 1,
      sym_formal_parameters,
  [121395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6242), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    STATE(1718), 1,
      sym_arguments,
  [121413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(540), 1,
      sym_statement_block,
  [121423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    STATE(1576), 1,
      sym_class_body,
  [121433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6244), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2632), 1,
      sym_formal_parameters,
  [121451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6246), 1,
      sym_identifier,
    ACTIONS(6248), 1,
      anon_sym_STAR,
  [121461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4356), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    STATE(1699), 1,
      sym_class_body,
  [121479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6250), 1,
      sym_identifier,
    ACTIONS(6252), 1,
      anon_sym_STAR,
  [121489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1700), 1,
      sym_statement_block,
  [121499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    STATE(1709), 1,
      sym_class_body,
  [121509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3261), 1,
      sym_statement_block,
  [121519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4332), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3150), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6254), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [121543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1634), 1,
      sym_statement_block,
  [121553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1705), 1,
      sym_statement_block,
  [121563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1437), 1,
      sym_statement_block,
  [121573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6256), 1,
      anon_sym_LBRACE,
    STATE(1736), 1,
      sym_statement_block,
  [121583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3644), 1,
      sym_formal_parameters,
  [121593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3637), 1,
      sym_formal_parameters,
  [121603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3630), 1,
      sym_formal_parameters,
  [121613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3621), 1,
      sym_formal_parameters,
  [121623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 1,
      anon_sym_LBRACE,
    STATE(549), 1,
      sym_statement_block,
  [121633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 1,
      sym_identifier,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
  [121643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6258), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [121651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3605), 1,
      sym_formal_parameters,
  [121661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(1702), 1,
      sym_statement_block,
  [121671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3602), 1,
      sym_formal_parameters,
  [121681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4718), 1,
      anon_sym_LBRACE,
    STATE(536), 1,
      sym_class_body,
  [121691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(561), 1,
      sym_statement_block,
  [121701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    STATE(1791), 1,
      sym_arguments,
  [121711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(534), 1,
      sym_statement_block,
  [121721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3570), 1,
      sym_formal_parameters,
  [121731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6260), 1,
      anon_sym_in,
    ACTIONS(6262), 1,
      anon_sym_COLON,
  [121741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    STATE(1763), 1,
      sym_class_body,
  [121751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6256), 1,
      anon_sym_LBRACE,
    STATE(1764), 1,
      sym_statement_block,
  [121761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3423), 1,
      sym_formal_parameters,
  [121771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3557), 1,
      sym_formal_parameters,
  [121781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6190), 1,
      anon_sym_LBRACE,
    STATE(560), 1,
      sym_enum_body,
  [121791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2871), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3255), 1,
      sym_statement_block,
  [121809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4300), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [121817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    STATE(1767), 1,
      sym_class_body,
  [121827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6256), 1,
      anon_sym_LBRACE,
    STATE(1768), 1,
      sym_statement_block,
  [121837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6256), 1,
      anon_sym_LBRACE,
    STATE(1769), 1,
      sym_statement_block,
  [121847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_LBRACE,
    STATE(1712), 1,
      sym_class_body,
  [121857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    STATE(1772), 1,
      sym_class_body,
  [121867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    STATE(1773), 1,
      sym_class_body,
  [121877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    STATE(1731), 1,
      sym_class_body,
  [121887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5223), 1,
      sym_identifier,
    ACTIONS(5225), 1,
      anon_sym_LBRACK,
  [121897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3510), 1,
      sym_formal_parameters,
  [121907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3407), 1,
      sym_formal_parameters,
  [121917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_DOT,
    ACTIONS(5885), 1,
      anon_sym_GT,
  [121927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [121935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2674), 1,
      sym_formal_parameters,
  [121945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4545), 1,
      anon_sym_COLON,
    ACTIONS(5885), 1,
      anon_sym_GT,
  [121955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6264), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [121963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    STATE(1803), 1,
      sym_class_body,
  [121973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3495), 1,
      sym_formal_parameters,
  [121983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6256), 1,
      anon_sym_LBRACE,
    STATE(1783), 1,
      sym_statement_block,
  [121993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(539), 1,
      sym_statement_block,
  [122003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6256), 1,
      anon_sym_LBRACE,
    STATE(1806), 1,
      sym_statement_block,
  [122013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(3432), 1,
      sym_formal_parameters,
  [122023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6256), 1,
      anon_sym_LBRACE,
    STATE(1799), 1,
      sym_statement_block,
  [122033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_LPAREN,
    STATE(2638), 1,
      sym_formal_parameters,
  [122043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    STATE(1789), 1,
      sym_arguments,
  [122053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_LPAREN,
    STATE(1577), 1,
      sym_arguments,
  [122063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5033), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [122071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4500), 1,
      anon_sym_LT,
    STATE(2120), 1,
      sym_type_arguments,
  [122081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6266), 2,
      sym_identifier,
      sym_this,
  [122089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_LBRACE,
    STATE(3285), 1,
      sym_statement_block,
  [122099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    STATE(1788), 1,
      sym_class_body,
  [122109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_LBRACE,
    STATE(1742), 1,
      sym_class_body,
  [122119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6256), 1,
      anon_sym_LBRACE,
    STATE(1809), 1,
      sym_statement_block,
  [122129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6268), 1,
      anon_sym_GT,
  [122136] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(6270), 1,
      sym_regex_pattern,
  [122143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_RBRACK,
  [122150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6272), 1,
      anon_sym_GT,
  [122157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6274), 1,
      anon_sym_GT,
  [122164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_RBRACK,
  [122171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6276), 1,
      anon_sym_from,
  [122178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_EQ_GT,
  [122185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      anon_sym_RBRACK,
  [122192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6278), 1,
      sym_identifier,
  [122199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5379), 1,
      anon_sym_EQ_GT,
  [122206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6280), 1,
      sym_identifier,
  [122213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_DOT,
  [122220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3781), 1,
      anon_sym_RBRACK,
  [122227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6282), 1,
      anon_sym_COLON,
  [122234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6284), 1,
      sym_identifier,
  [122241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 1,
      anon_sym_EQ_GT,
  [122248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6286), 1,
      sym_identifier,
  [122255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4502), 1,
      anon_sym_DOT,
  [122262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6288), 1,
      sym_identifier,
  [122269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6290), 1,
      sym_number,
  [122276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6292), 1,
      anon_sym_COLON,
  [122283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6294), 1,
      sym_identifier,
  [122290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6296), 1,
      anon_sym_COLON,
  [122297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5885), 1,
      anon_sym_GT,
  [122304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6298), 1,
      anon_sym_class,
  [122311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5433), 1,
      anon_sym_EQ_GT,
  [122318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym_GT,
  [122325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6302), 1,
      anon_sym_GT,
  [122332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6304), 1,
      anon_sym_GT,
  [122339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6306), 1,
      anon_sym_DOT,
  [122346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3759), 1,
      anon_sym_RBRACE,
  [122353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6308), 1,
      anon_sym_RPAREN,
  [122360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3767), 1,
      anon_sym_RPAREN,
  [122367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6310), 1,
      sym_identifier,
  [122374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_EQ_GT,
  [122381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6312), 1,
      anon_sym_RBRACK,
  [122388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 1,
      sym_identifier,
  [122395] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(6316), 1,
      sym_regex_pattern,
  [122402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5825), 1,
      anon_sym_RBRACE,
  [122409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6318), 1,
      sym_identifier,
  [122416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 1,
      anon_sym_RBRACK,
  [122423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4603), 1,
      anon_sym_DOT,
  [122430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3326), 1,
      anon_sym_RPAREN,
  [122437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3765), 1,
      anon_sym_RPAREN,
  [122444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_SLASH2,
  [122451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_RPAREN,
  [122458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 1,
      sym_identifier,
  [122465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6324), 1,
      anon_sym_RPAREN,
  [122472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3305), 1,
      anon_sym_RPAREN,
  [122479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3769), 1,
      anon_sym_DOT,
  [122486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6326), 1,
      anon_sym_GT,
  [122493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6328), 1,
      sym_number,
  [122500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5223), 1,
      sym_identifier,
  [122507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 1,
      sym_identifier,
  [122514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6330), 1,
      anon_sym_target,
  [122521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      sym_identifier,
  [122528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6334), 1,
      anon_sym_EQ_GT,
  [122535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_EQ_GT,
  [122542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6338), 1,
      anon_sym_EQ_GT,
  [122549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6340), 1,
      anon_sym_EQ_GT,
  [122556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6342), 1,
      anon_sym_EQ_GT,
  [122563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 1,
      anon_sym_target,
  [122570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      anon_sym_EQ_GT,
  [122577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6348), 1,
      anon_sym_SLASH2,
  [122584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6350), 1,
      anon_sym_EQ_GT,
  [122591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6352), 1,
      sym_identifier,
  [122598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      sym_identifier,
  [122605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6356), 1,
      anon_sym_class,
  [122612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 1,
      anon_sym_EQ_GT,
  [122619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3761), 1,
      anon_sym_RPAREN,
  [122626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6360), 1,
      anon_sym_EQ,
  [122633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_EQ_GT,
  [122640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5465), 1,
      anon_sym_EQ_GT,
  [122647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5608), 1,
      anon_sym_EQ_GT,
  [122654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3528), 1,
      anon_sym_RPAREN,
  [122661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_namespace,
  [122668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6366), 1,
      anon_sym_RPAREN,
  [122675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3788), 1,
      anon_sym_RBRACK,
  [122682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6368), 1,
      anon_sym_LBRACE,
  [122689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym_from,
  [122696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6372), 1,
      sym_identifier,
  [122703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_GT,
  [122710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3757), 1,
      anon_sym_RBRACE,
  [122717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6376), 1,
      anon_sym_GT,
  [122724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6378), 1,
      sym_identifier,
  [122731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6380), 1,
      anon_sym_EQ_GT,
  [122738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5193), 1,
      sym_identifier,
  [122745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6382), 1,
      anon_sym_EQ_GT,
  [122752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6384), 1,
      anon_sym_EQ_GT,
  [122759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6386), 1,
      sym_identifier,
  [122766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4342), 1,
      anon_sym_EQ_GT,
  [122773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6388), 1,
      anon_sym_EQ_GT,
  [122780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6390), 1,
      anon_sym_GT,
  [122787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 1,
      anon_sym_EQ_GT,
  [122794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 1,
      anon_sym_class,
  [122801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6394), 1,
      sym_identifier,
  [122808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_EQ,
  [122815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 1,
      anon_sym_EQ_GT,
  [122822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 1,
      anon_sym_EQ,
  [122829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6400), 1,
      sym_identifier,
  [122836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6402), 1,
      anon_sym_SLASH2,
  [122843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6404), 1,
      anon_sym_from,
  [122850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      anon_sym_EQ_GT,
  [122857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6406), 1,
      anon_sym_EQ,
  [122864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      anon_sym_EQ,
  [122871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5992), 1,
      anon_sym_LBRACE,
  [122878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5865), 1,
      anon_sym_GT,
  [122885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6410), 1,
      anon_sym_GT,
  [122892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 1,
      sym_identifier,
  [122899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6414), 1,
      anon_sym_GT,
  [122906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      sym_identifier,
  [122913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6416), 1,
      sym_identifier,
  [122920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_EQ_GT,
  [122927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6418), 1,
      anon_sym_EQ,
  [122934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6420), 1,
      anon_sym_GT,
  [122941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6422), 1,
      sym_identifier,
  [122948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4480), 1,
      anon_sym_DOT,
  [122955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3755), 1,
      anon_sym_RBRACK,
  [122962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6424), 1,
      sym_identifier,
  [122969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6426), 1,
      sym_identifier,
  [122976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6428), 1,
      anon_sym_EQ_GT,
  [122983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6430), 1,
      anon_sym_EQ_GT,
  [122990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6432), 1,
      sym_identifier,
  [122997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6434), 1,
      anon_sym_EQ_GT,
  [123004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6436), 1,
      anon_sym_SLASH2,
  [123011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6438), 1,
      anon_sym_EQ_GT,
  [123018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6440), 1,
      sym_number,
  [123025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6442), 1,
      anon_sym_target,
  [123032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3818), 1,
      anon_sym_COLON,
  [123039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3506), 1,
      anon_sym_RPAREN,
  [123046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      sym_identifier,
  [123053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3806), 1,
      anon_sym_RPAREN,
  [123060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3820), 1,
      anon_sym_RPAREN,
  [123067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6444), 1,
      sym_identifier,
  [123074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6446), 1,
      anon_sym_RPAREN,
  [123081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6448), 1,
      anon_sym_GT,
  [123088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3804), 1,
      anon_sym_RPAREN,
  [123095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6450), 1,
      sym_number,
  [123102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6452), 1,
      sym_identifier,
  [123109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6454), 1,
      anon_sym_while,
  [123116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6456), 1,
      anon_sym_EQ_GT,
  [123123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 1,
      anon_sym_RPAREN,
  [123130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6458), 1,
      anon_sym_from,
  [123137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3795), 1,
      anon_sym_RPAREN,
  [123144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5970), 1,
      anon_sym_from,
  [123151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3526), 1,
      anon_sym_RPAREN,
  [123158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_RPAREN,
  [123165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6460), 1,
      anon_sym_GT,
  [123172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6462), 1,
      anon_sym_GT,
  [123179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6464), 1,
      sym_identifier,
  [123186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6466), 1,
      sym_identifier,
  [123193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6468), 1,
      anon_sym_GT,
  [123200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_GT,
  [123207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6472), 1,
      sym_identifier,
  [123214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_EQ_GT,
  [123221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6476), 1,
      anon_sym_LPAREN,
  [123228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6478), 1,
      anon_sym_EQ_GT,
  [123235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6480), 1,
      sym_identifier,
  [123242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6482), 1,
      sym_identifier,
  [123249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6484), 1,
      anon_sym_EQ_GT,
  [123256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6486), 1,
      sym_identifier,
  [123263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6488), 1,
      sym_identifier,
  [123270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6490), 1,
      anon_sym_RBRACE,
  [123277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 1,
      anon_sym_from,
  [123284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6494), 1,
      anon_sym_GT,
  [123291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6496), 1,
      anon_sym_as,
  [123298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6498), 1,
      anon_sym_GT,
  [123305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5335), 1,
      anon_sym_EQ_GT,
  [123312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6500), 1,
      sym_identifier,
  [123319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5972), 1,
      anon_sym_GT,
  [123326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6502), 1,
      anon_sym_GT,
  [123333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6504), 1,
      anon_sym_GT,
  [123340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6506), 1,
      anon_sym_EQ_GT,
  [123347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3580), 1,
      anon_sym_DOT,
  [123354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6508), 1,
      anon_sym_GT,
  [123361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6510), 1,
      sym_identifier,
  [123368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6512), 1,
      anon_sym_require,
  [123375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_RPAREN,
  [123382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6516), 1,
      sym_number,
  [123389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6518), 1,
      anon_sym_RPAREN,
  [123396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_RPAREN,
  [123403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6522), 1,
      anon_sym_RPAREN,
  [123410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6084), 1,
      anon_sym_GT,
  [123417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      sym_readonly,
  [123424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6526), 1,
      anon_sym_GT,
  [123431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6528), 1,
      sym_identifier,
  [123438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6530), 1,
      sym_identifier,
  [123445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_function,
  [123452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6534), 1,
      sym_identifier,
  [123459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5277), 1,
      sym_identifier,
  [123466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6536), 1,
      anon_sym_EQ_GT,
  [123473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_EQ_GT,
  [123480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      sym_identifier,
  [123487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 1,
      sym_identifier,
  [123494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6544), 1,
      sym_identifier,
  [123501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6546), 1,
      anon_sym_COLON,
  [123508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_EQ_GT,
  [123515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6550), 1,
      anon_sym_EQ_GT,
  [123522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6552), 1,
      anon_sym_EQ_GT,
  [123529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6554), 1,
      anon_sym_namespace,
  [123536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6556), 1,
      sym_identifier,
  [123543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6558), 1,
      anon_sym_EQ_GT,
  [123550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3739), 1,
      anon_sym_RBRACK,
  [123557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6560), 1,
      sym_identifier,
  [123564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6562), 1,
      anon_sym_EQ_GT,
  [123571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6564), 1,
      sym_identifier,
  [123578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 1,
      sym_identifier,
  [123585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      anon_sym_EQ_GT,
  [123592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_RBRACK,
  [123599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6572), 1,
      sym_identifier,
  [123606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6574), 1,
      anon_sym_EQ_GT,
  [123613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6576), 1,
      anon_sym_EQ_GT,
  [123620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6578), 1,
      anon_sym_EQ_GT,
  [123627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6580), 1,
      anon_sym_RBRACK,
  [123634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6582), 1,
      sym_identifier,
  [123641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6584), 1,
      sym_identifier,
  [123648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6586), 1,
      anon_sym_EQ_GT,
  [123655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6588), 1,
      anon_sym_LBRACK,
  [123662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3714), 1,
      anon_sym_RPAREN,
  [123669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_EQ_GT,
  [123676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 1,
      anon_sym_RPAREN,
  [123683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 1,
      anon_sym_EQ_GT,
  [123690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6594), 1,
      sym_identifier,
  [123697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6596), 1,
      anon_sym_EQ_GT,
  [123704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6598), 1,
      anon_sym_GT,
  [123711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6600), 1,
      anon_sym_GT,
  [123718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6602), 1,
      anon_sym_GT,
  [123725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6604), 1,
      ts_builtin_sym_end,
  [123732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6606), 1,
      sym_identifier,
  [123739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6608), 1,
      sym_identifier,
  [123746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3708), 1,
      anon_sym_RBRACK,
  [123753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6610), 1,
      sym_identifier,
  [123760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_EQ_GT,
  [123767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6614), 1,
      anon_sym_GT,
  [123774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6616), 1,
      anon_sym_EQ_GT,
  [123781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 1,
      anon_sym_EQ_GT,
  [123788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6620), 1,
      sym_identifier,
  [123795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6622), 1,
      sym_identifier,
  [123802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3737), 1,
      anon_sym_RBRACK,
  [123809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6624), 1,
      anon_sym_EQ_GT,
  [123816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6626), 1,
      sym_identifier,
  [123823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6628), 1,
      sym_identifier,
  [123830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6630), 1,
      sym_identifier,
  [123837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6632), 1,
      anon_sym_function,
  [123844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6634), 1,
      anon_sym_GT,
  [123851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 1,
      anon_sym_class,
  [123858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_EQ_GT,
  [123865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6640), 1,
      anon_sym_from,
  [123872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6642), 1,
      sym_identifier,
  [123879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      sym_identifier,
  [123886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6646), 1,
      sym_identifier,
  [123893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3704), 1,
      anon_sym_RBRACK,
  [123900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6648), 1,
      sym_identifier,
  [123907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6650), 1,
      sym_identifier,
  [123914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3735), 1,
      anon_sym_RBRACE,
  [123921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6652), 1,
      sym_identifier,
  [123928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6654), 1,
      anon_sym_COLON,
  [123935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6656), 1,
      sym_identifier,
  [123942] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(6658), 1,
      sym_regex_pattern,
  [123949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      sym_identifier,
  [123956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6662), 1,
      sym_identifier,
  [123963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6664), 1,
      sym_identifier,
  [123970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3720), 1,
      anon_sym_RBRACK,
  [123977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6666), 1,
      sym_identifier,
  [123984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6668), 1,
      sym_identifier,
  [123991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6670), 1,
      sym_identifier,
  [123998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6672), 1,
      sym_identifier,
  [124005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6674), 1,
      sym_identifier,
  [124012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6676), 1,
      sym_identifier,
  [124019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6678), 1,
      sym_identifier,
  [124026] = 2,
    ACTIONS(4640), 1,
      sym_comment,
    ACTIONS(6680), 1,
      sym_regex_pattern,
  [124033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6088), 1,
      anon_sym_GT,
  [124040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6682), 1,
      anon_sym_EQ_GT,
  [124047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 1,
      sym_identifier,
  [124054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6686), 1,
      sym_number,
  [124061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6688), 1,
      sym_identifier,
  [124068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6690), 1,
      anon_sym_from,
  [124075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6692), 1,
      sym_identifier,
  [124082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_GT,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(657)] = 0,
  [SMALL_STATE(658)] = 95,
  [SMALL_STATE(659)] = 198,
  [SMALL_STATE(660)] = 301,
  [SMALL_STATE(661)] = 404,
  [SMALL_STATE(662)] = 500,
  [SMALL_STATE(663)] = 596,
  [SMALL_STATE(664)] = 692,
  [SMALL_STATE(665)] = 786,
  [SMALL_STATE(666)] = 882,
  [SMALL_STATE(667)] = 984,
  [SMALL_STATE(668)] = 1080,
  [SMALL_STATE(669)] = 1178,
  [SMALL_STATE(670)] = 1274,
  [SMALL_STATE(671)] = 1367,
  [SMALL_STATE(672)] = 1466,
  [SMALL_STATE(673)] = 1559,
  [SMALL_STATE(674)] = 1652,
  [SMALL_STATE(675)] = 1749,
  [SMALL_STATE(676)] = 1844,
  [SMALL_STATE(677)] = 1936,
  [SMALL_STATE(678)] = 2062,
  [SMALL_STATE(679)] = 2148,
  [SMALL_STATE(680)] = 2242,
  [SMALL_STATE(681)] = 2336,
  [SMALL_STATE(682)] = 2429,
  [SMALL_STATE(683)] = 2496,
  [SMALL_STATE(684)] = 2563,
  [SMALL_STATE(685)] = 2658,
  [SMALL_STATE(686)] = 2725,
  [SMALL_STATE(687)] = 2812,
  [SMALL_STATE(688)] = 2903,
  [SMALL_STATE(689)] = 2992,
  [SMALL_STATE(690)] = 3059,
  [SMALL_STATE(691)] = 3134,
  [SMALL_STATE(692)] = 3225,
  [SMALL_STATE(693)] = 3316,
  [SMALL_STATE(694)] = 3403,
  [SMALL_STATE(695)] = 3470,
  [SMALL_STATE(696)] = 3565,
  [SMALL_STATE(697)] = 3632,
  [SMALL_STATE(698)] = 3699,
  [SMALL_STATE(699)] = 3774,
  [SMALL_STATE(700)] = 3863,
  [SMALL_STATE(701)] = 3930,
  [SMALL_STATE(702)] = 3997,
  [SMALL_STATE(703)] = 4084,
  [SMALL_STATE(704)] = 4171,
  [SMALL_STATE(705)] = 4255,
  [SMALL_STATE(706)] = 4341,
  [SMALL_STATE(707)] = 4427,
  [SMALL_STATE(708)] = 4553,
  [SMALL_STATE(709)] = 4639,
  [SMALL_STATE(710)] = 4765,
  [SMALL_STATE(711)] = 4891,
  [SMALL_STATE(712)] = 5017,
  [SMALL_STATE(713)] = 5143,
  [SMALL_STATE(714)] = 5231,
  [SMALL_STATE(715)] = 5319,
  [SMALL_STATE(716)] = 5407,
  [SMALL_STATE(717)] = 5495,
  [SMALL_STATE(718)] = 5579,
  [SMALL_STATE(719)] = 5665,
  [SMALL_STATE(720)] = 5753,
  [SMALL_STATE(721)] = 5841,
  [SMALL_STATE(722)] = 5967,
  [SMALL_STATE(723)] = 6055,
  [SMALL_STATE(724)] = 6141,
  [SMALL_STATE(725)] = 6264,
  [SMALL_STATE(726)] = 6345,
  [SMALL_STATE(727)] = 6468,
  [SMALL_STATE(728)] = 6553,
  [SMALL_STATE(729)] = 6676,
  [SMALL_STATE(730)] = 6799,
  [SMALL_STATE(731)] = 6922,
  [SMALL_STATE(732)] = 7007,
  [SMALL_STATE(733)] = 7094,
  [SMALL_STATE(734)] = 7217,
  [SMALL_STATE(735)] = 7298,
  [SMALL_STATE(736)] = 7383,
  [SMALL_STATE(737)] = 7506,
  [SMALL_STATE(738)] = 7591,
  [SMALL_STATE(739)] = 7676,
  [SMALL_STATE(740)] = 7753,
  [SMALL_STATE(741)] = 7884,
  [SMALL_STATE(742)] = 7969,
  [SMALL_STATE(743)] = 8046,
  [SMALL_STATE(744)] = 8131,
  [SMALL_STATE(745)] = 8262,
  [SMALL_STATE(746)] = 8385,
  [SMALL_STATE(747)] = 8508,
  [SMALL_STATE(748)] = 8581,
  [SMALL_STATE(749)] = 8654,
  [SMALL_STATE(750)] = 8777,
  [SMALL_STATE(751)] = 8862,
  [SMALL_STATE(752)] = 8953,
  [SMALL_STATE(753)] = 9076,
  [SMALL_STATE(754)] = 9199,
  [SMALL_STATE(755)] = 9322,
  [SMALL_STATE(756)] = 9407,
  [SMALL_STATE(757)] = 9530,
  [SMALL_STATE(758)] = 9653,
  [SMALL_STATE(759)] = 9776,
  [SMALL_STATE(760)] = 9899,
  [SMALL_STATE(761)] = 10022,
  [SMALL_STATE(762)] = 10145,
  [SMALL_STATE(763)] = 10268,
  [SMALL_STATE(764)] = 10351,
  [SMALL_STATE(765)] = 10482,
  [SMALL_STATE(766)] = 10605,
  [SMALL_STATE(767)] = 10736,
  [SMALL_STATE(768)] = 10867,
  [SMALL_STATE(769)] = 10954,
  [SMALL_STATE(770)] = 11035,
  [SMALL_STATE(771)] = 11158,
  [SMALL_STATE(772)] = 11289,
  [SMALL_STATE(773)] = 11412,
  [SMALL_STATE(774)] = 11535,
  [SMALL_STATE(775)] = 11666,
  [SMALL_STATE(776)] = 11789,
  [SMALL_STATE(777)] = 11912,
  [SMALL_STATE(778)] = 11993,
  [SMALL_STATE(779)] = 12078,
  [SMALL_STATE(780)] = 12161,
  [SMALL_STATE(781)] = 12284,
  [SMALL_STATE(782)] = 12407,
  [SMALL_STATE(783)] = 12496,
  [SMALL_STATE(784)] = 12583,
  [SMALL_STATE(785)] = 12706,
  [SMALL_STATE(786)] = 12791,
  [SMALL_STATE(787)] = 12855,
  [SMALL_STATE(788)] = 12975,
  [SMALL_STATE(789)] = 13095,
  [SMALL_STATE(790)] = 13215,
  [SMALL_STATE(791)] = 13335,
  [SMALL_STATE(792)] = 13455,
  [SMALL_STATE(793)] = 13575,
  [SMALL_STATE(794)] = 13657,
  [SMALL_STATE(795)] = 13777,
  [SMALL_STATE(796)] = 13849,
  [SMALL_STATE(797)] = 13969,
  [SMALL_STATE(798)] = 14045,
  [SMALL_STATE(799)] = 14165,
  [SMALL_STATE(800)] = 14285,
  [SMALL_STATE(801)] = 14405,
  [SMALL_STATE(802)] = 14525,
  [SMALL_STATE(803)] = 14645,
  [SMALL_STATE(804)] = 14765,
  [SMALL_STATE(805)] = 14885,
  [SMALL_STATE(806)] = 15005,
  [SMALL_STATE(807)] = 15125,
  [SMALL_STATE(808)] = 15245,
  [SMALL_STATE(809)] = 15365,
  [SMALL_STATE(810)] = 15485,
  [SMALL_STATE(811)] = 15605,
  [SMALL_STATE(812)] = 15725,
  [SMALL_STATE(813)] = 15845,
  [SMALL_STATE(814)] = 15925,
  [SMALL_STATE(815)] = 16045,
  [SMALL_STATE(816)] = 16165,
  [SMALL_STATE(817)] = 16285,
  [SMALL_STATE(818)] = 16359,
  [SMALL_STATE(819)] = 16479,
  [SMALL_STATE(820)] = 16599,
  [SMALL_STATE(821)] = 16719,
  [SMALL_STATE(822)] = 16839,
  [SMALL_STATE(823)] = 16959,
  [SMALL_STATE(824)] = 17079,
  [SMALL_STATE(825)] = 17147,
  [SMALL_STATE(826)] = 17267,
  [SMALL_STATE(827)] = 17387,
  [SMALL_STATE(828)] = 17507,
  [SMALL_STATE(829)] = 17627,
  [SMALL_STATE(830)] = 17747,
  [SMALL_STATE(831)] = 17831,
  [SMALL_STATE(832)] = 17951,
  [SMALL_STATE(833)] = 18071,
  [SMALL_STATE(834)] = 18191,
  [SMALL_STATE(835)] = 18311,
  [SMALL_STATE(836)] = 18431,
  [SMALL_STATE(837)] = 18551,
  [SMALL_STATE(838)] = 18671,
  [SMALL_STATE(839)] = 18791,
  [SMALL_STATE(840)] = 18911,
  [SMALL_STATE(841)] = 19031,
  [SMALL_STATE(842)] = 19151,
  [SMALL_STATE(843)] = 19271,
  [SMALL_STATE(844)] = 19391,
  [SMALL_STATE(845)] = 19511,
  [SMALL_STATE(846)] = 19593,
  [SMALL_STATE(847)] = 19713,
  [SMALL_STATE(848)] = 19833,
  [SMALL_STATE(849)] = 19953,
  [SMALL_STATE(850)] = 20073,
  [SMALL_STATE(851)] = 20193,
  [SMALL_STATE(852)] = 20313,
  [SMALL_STATE(853)] = 20433,
  [SMALL_STATE(854)] = 20553,
  [SMALL_STATE(855)] = 20673,
  [SMALL_STATE(856)] = 20793,
  [SMALL_STATE(857)] = 20913,
  [SMALL_STATE(858)] = 21033,
  [SMALL_STATE(859)] = 21153,
  [SMALL_STATE(860)] = 21273,
  [SMALL_STATE(861)] = 21393,
  [SMALL_STATE(862)] = 21513,
  [SMALL_STATE(863)] = 21633,
  [SMALL_STATE(864)] = 21753,
  [SMALL_STATE(865)] = 21873,
  [SMALL_STATE(866)] = 21951,
  [SMALL_STATE(867)] = 22071,
  [SMALL_STATE(868)] = 22191,
  [SMALL_STATE(869)] = 22311,
  [SMALL_STATE(870)] = 22375,
  [SMALL_STATE(871)] = 22495,
  [SMALL_STATE(872)] = 22615,
  [SMALL_STATE(873)] = 22735,
  [SMALL_STATE(874)] = 22855,
  [SMALL_STATE(875)] = 22975,
  [SMALL_STATE(876)] = 23095,
  [SMALL_STATE(877)] = 23215,
  [SMALL_STATE(878)] = 23287,
  [SMALL_STATE(879)] = 23407,
  [SMALL_STATE(880)] = 23527,
  [SMALL_STATE(881)] = 23605,
  [SMALL_STATE(882)] = 23725,
  [SMALL_STATE(883)] = 23845,
  [SMALL_STATE(884)] = 23965,
  [SMALL_STATE(885)] = 24085,
  [SMALL_STATE(886)] = 24205,
  [SMALL_STATE(887)] = 24289,
  [SMALL_STATE(888)] = 24353,
  [SMALL_STATE(889)] = 24473,
  [SMALL_STATE(890)] = 24593,
  [SMALL_STATE(891)] = 24713,
  [SMALL_STATE(892)] = 24833,
  [SMALL_STATE(893)] = 24953,
  [SMALL_STATE(894)] = 25073,
  [SMALL_STATE(895)] = 25193,
  [SMALL_STATE(896)] = 25313,
  [SMALL_STATE(897)] = 25433,
  [SMALL_STATE(898)] = 25505,
  [SMALL_STATE(899)] = 25625,
  [SMALL_STATE(900)] = 25711,
  [SMALL_STATE(901)] = 25831,
  [SMALL_STATE(902)] = 25895,
  [SMALL_STATE(903)] = 26015,
  [SMALL_STATE(904)] = 26135,
  [SMALL_STATE(905)] = 26255,
  [SMALL_STATE(906)] = 26339,
  [SMALL_STATE(907)] = 26459,
  [SMALL_STATE(908)] = 26579,
  [SMALL_STATE(909)] = 26699,
  [SMALL_STATE(910)] = 26819,
  [SMALL_STATE(911)] = 26891,
  [SMALL_STATE(912)] = 27011,
  [SMALL_STATE(913)] = 27131,
  [SMALL_STATE(914)] = 27251,
  [SMALL_STATE(915)] = 27331,
  [SMALL_STATE(916)] = 27451,
  [SMALL_STATE(917)] = 27571,
  [SMALL_STATE(918)] = 27647,
  [SMALL_STATE(919)] = 27767,
  [SMALL_STATE(920)] = 27887,
  [SMALL_STATE(921)] = 28007,
  [SMALL_STATE(922)] = 28127,
  [SMALL_STATE(923)] = 28247,
  [SMALL_STATE(924)] = 28325,
  [SMALL_STATE(925)] = 28445,
  [SMALL_STATE(926)] = 28565,
  [SMALL_STATE(927)] = 28647,
  [SMALL_STATE(928)] = 28725,
  [SMALL_STATE(929)] = 28845,
  [SMALL_STATE(930)] = 28965,
  [SMALL_STATE(931)] = 29085,
  [SMALL_STATE(932)] = 29149,
  [SMALL_STATE(933)] = 29227,
  [SMALL_STATE(934)] = 29307,
  [SMALL_STATE(935)] = 29385,
  [SMALL_STATE(936)] = 29505,
  [SMALL_STATE(937)] = 29569,
  [SMALL_STATE(938)] = 29689,
  [SMALL_STATE(939)] = 29809,
  [SMALL_STATE(940)] = 29887,
  [SMALL_STATE(941)] = 30007,
  [SMALL_STATE(942)] = 30071,
  [SMALL_STATE(943)] = 30151,
  [SMALL_STATE(944)] = 30229,
  [SMALL_STATE(945)] = 30293,
  [SMALL_STATE(946)] = 30413,
  [SMALL_STATE(947)] = 30533,
  [SMALL_STATE(948)] = 30653,
  [SMALL_STATE(949)] = 30773,
  [SMALL_STATE(950)] = 30893,
  [SMALL_STATE(951)] = 31013,
  [SMALL_STATE(952)] = 31095,
  [SMALL_STATE(953)] = 31215,
  [SMALL_STATE(954)] = 31335,
  [SMALL_STATE(955)] = 31455,
  [SMALL_STATE(956)] = 31575,
  [SMALL_STATE(957)] = 31639,
  [SMALL_STATE(958)] = 31759,
  [SMALL_STATE(959)] = 31879,
  [SMALL_STATE(960)] = 31999,
  [SMALL_STATE(961)] = 32119,
  [SMALL_STATE(962)] = 32239,
  [SMALL_STATE(963)] = 32310,
  [SMALL_STATE(964)] = 32381,
  [SMALL_STATE(965)] = 32456,
  [SMALL_STATE(966)] = 32527,
  [SMALL_STATE(967)] = 32598,
  [SMALL_STATE(968)] = 32673,
  [SMALL_STATE(969)] = 32752,
  [SMALL_STATE(970)] = 32827,
  [SMALL_STATE(971)] = 32902,
  [SMALL_STATE(972)] = 32979,
  [SMALL_STATE(973)] = 33056,
  [SMALL_STATE(974)] = 33127,
  [SMALL_STATE(975)] = 33206,
  [SMALL_STATE(976)] = 33287,
  [SMALL_STATE(977)] = 33368,
  [SMALL_STATE(978)] = 33441,
  [SMALL_STATE(979)] = 33520,
  [SMALL_STATE(980)] = 33587,
  [SMALL_STATE(981)] = 33668,
  [SMALL_STATE(982)] = 33739,
  [SMALL_STATE(983)] = 33810,
  [SMALL_STATE(984)] = 33885,
  [SMALL_STATE(985)] = 33960,
  [SMALL_STATE(986)] = 34022,
  [SMALL_STATE(987)] = 34090,
  [SMALL_STATE(988)] = 34210,
  [SMALL_STATE(989)] = 34282,
  [SMALL_STATE(990)] = 34344,
  [SMALL_STATE(991)] = 34406,
  [SMALL_STATE(992)] = 34478,
  [SMALL_STATE(993)] = 34550,
  [SMALL_STATE(994)] = 34616,
  [SMALL_STATE(995)] = 34678,
  [SMALL_STATE(996)] = 34740,
  [SMALL_STATE(997)] = 34802,
  [SMALL_STATE(998)] = 34864,
  [SMALL_STATE(999)] = 34930,
  [SMALL_STATE(1000)] = 34996,
  [SMALL_STATE(1001)] = 35058,
  [SMALL_STATE(1002)] = 35134,
  [SMALL_STATE(1003)] = 35208,
  [SMALL_STATE(1004)] = 35270,
  [SMALL_STATE(1005)] = 35332,
  [SMALL_STATE(1006)] = 35406,
  [SMALL_STATE(1007)] = 35526,
  [SMALL_STATE(1008)] = 35602,
  [SMALL_STATE(1009)] = 35680,
  [SMALL_STATE(1010)] = 35742,
  [SMALL_STATE(1011)] = 35810,
  [SMALL_STATE(1012)] = 35874,
  [SMALL_STATE(1013)] = 35952,
  [SMALL_STATE(1014)] = 36029,
  [SMALL_STATE(1015)] = 36106,
  [SMALL_STATE(1016)] = 36177,
  [SMALL_STATE(1017)] = 36242,
  [SMALL_STATE(1018)] = 36319,
  [SMALL_STATE(1019)] = 36396,
  [SMALL_STATE(1020)] = 36464,
  [SMALL_STATE(1021)] = 36532,
  [SMALL_STATE(1022)] = 36606,
  [SMALL_STATE(1023)] = 36680,
  [SMALL_STATE(1024)] = 36755,
  [SMALL_STATE(1025)] = 36865,
  [SMALL_STATE(1026)] = 36975,
  [SMALL_STATE(1027)] = 37085,
  [SMALL_STATE(1028)] = 37191,
  [SMALL_STATE(1029)] = 37297,
  [SMALL_STATE(1030)] = 37403,
  [SMALL_STATE(1031)] = 37509,
  [SMALL_STATE(1032)] = 37615,
  [SMALL_STATE(1033)] = 37725,
  [SMALL_STATE(1034)] = 37831,
  [SMALL_STATE(1035)] = 37940,
  [SMALL_STATE(1036)] = 38047,
  [SMALL_STATE(1037)] = 38149,
  [SMALL_STATE(1038)] = 38251,
  [SMALL_STATE(1039)] = 38353,
  [SMALL_STATE(1040)] = 38455,
  [SMALL_STATE(1041)] = 38557,
  [SMALL_STATE(1042)] = 38659,
  [SMALL_STATE(1043)] = 38761,
  [SMALL_STATE(1044)] = 38863,
  [SMALL_STATE(1045)] = 38965,
  [SMALL_STATE(1046)] = 39067,
  [SMALL_STATE(1047)] = 39169,
  [SMALL_STATE(1048)] = 39271,
  [SMALL_STATE(1049)] = 39373,
  [SMALL_STATE(1050)] = 39475,
  [SMALL_STATE(1051)] = 39577,
  [SMALL_STATE(1052)] = 39679,
  [SMALL_STATE(1053)] = 39781,
  [SMALL_STATE(1054)] = 39883,
  [SMALL_STATE(1055)] = 39936,
  [SMALL_STATE(1056)] = 40005,
  [SMALL_STATE(1057)] = 40074,
  [SMALL_STATE(1058)] = 40127,
  [SMALL_STATE(1059)] = 40190,
  [SMALL_STATE(1060)] = 40242,
  [SMALL_STATE(1061)] = 40294,
  [SMALL_STATE(1062)] = 40350,
  [SMALL_STATE(1063)] = 40406,
  [SMALL_STATE(1064)] = 40472,
  [SMALL_STATE(1065)] = 40528,
  [SMALL_STATE(1066)] = 40626,
  [SMALL_STATE(1067)] = 40684,
  [SMALL_STATE(1068)] = 40736,
  [SMALL_STATE(1069)] = 40788,
  [SMALL_STATE(1070)] = 40886,
  [SMALL_STATE(1071)] = 40984,
  [SMALL_STATE(1072)] = 41036,
  [SMALL_STATE(1073)] = 41094,
  [SMALL_STATE(1074)] = 41192,
  [SMALL_STATE(1075)] = 41244,
  [SMALL_STATE(1076)] = 41342,
  [SMALL_STATE(1077)] = 41398,
  [SMALL_STATE(1078)] = 41450,
  [SMALL_STATE(1079)] = 41548,
  [SMALL_STATE(1080)] = 41604,
  [SMALL_STATE(1081)] = 41658,
  [SMALL_STATE(1082)] = 41710,
  [SMALL_STATE(1083)] = 41808,
  [SMALL_STATE(1084)] = 41895,
  [SMALL_STATE(1085)] = 41946,
  [SMALL_STATE(1086)] = 42041,
  [SMALL_STATE(1087)] = 42114,
  [SMALL_STATE(1088)] = 42171,
  [SMALL_STATE(1089)] = 42268,
  [SMALL_STATE(1090)] = 42321,
  [SMALL_STATE(1091)] = 42372,
  [SMALL_STATE(1092)] = 42423,
  [SMALL_STATE(1093)] = 42502,
  [SMALL_STATE(1094)] = 42553,
  [SMALL_STATE(1095)] = 42616,
  [SMALL_STATE(1096)] = 42667,
  [SMALL_STATE(1097)] = 42724,
  [SMALL_STATE(1098)] = 42787,
  [SMALL_STATE(1099)] = 42842,
  [SMALL_STATE(1100)] = 42925,
  [SMALL_STATE(1101)] = 42976,
  [SMALL_STATE(1102)] = 43047,
  [SMALL_STATE(1103)] = 43124,
  [SMALL_STATE(1104)] = 43195,
  [SMALL_STATE(1105)] = 43286,
  [SMALL_STATE(1106)] = 43337,
  [SMALL_STATE(1107)] = 43432,
  [SMALL_STATE(1108)] = 43485,
  [SMALL_STATE(1109)] = 43580,
  [SMALL_STATE(1110)] = 43635,
  [SMALL_STATE(1111)] = 43692,
  [SMALL_STATE(1112)] = 43749,
  [SMALL_STATE(1113)] = 43844,
  [SMALL_STATE(1114)] = 43939,
  [SMALL_STATE(1115)] = 43990,
  [SMALL_STATE(1116)] = 44041,
  [SMALL_STATE(1117)] = 44098,
  [SMALL_STATE(1118)] = 44153,
  [SMALL_STATE(1119)] = 44204,
  [SMALL_STATE(1120)] = 44255,
  [SMALL_STATE(1121)] = 44310,
  [SMALL_STATE(1122)] = 44361,
  [SMALL_STATE(1123)] = 44412,
  [SMALL_STATE(1124)] = 44465,
  [SMALL_STATE(1125)] = 44560,
  [SMALL_STATE(1126)] = 44615,
  [SMALL_STATE(1127)] = 44670,
  [SMALL_STATE(1128)] = 44721,
  [SMALL_STATE(1129)] = 44772,
  [SMALL_STATE(1130)] = 44823,
  [SMALL_STATE(1131)] = 44874,
  [SMALL_STATE(1132)] = 44969,
  [SMALL_STATE(1133)] = 45020,
  [SMALL_STATE(1134)] = 45115,
  [SMALL_STATE(1135)] = 45210,
  [SMALL_STATE(1136)] = 45263,
  [SMALL_STATE(1137)] = 45358,
  [SMALL_STATE(1138)] = 45453,
  [SMALL_STATE(1139)] = 45548,
  [SMALL_STATE(1140)] = 45601,
  [SMALL_STATE(1141)] = 45670,
  [SMALL_STATE(1142)] = 45723,
  [SMALL_STATE(1143)] = 45818,
  [SMALL_STATE(1144)] = 45869,
  [SMALL_STATE(1145)] = 45920,
  [SMALL_STATE(1146)] = 45971,
  [SMALL_STATE(1147)] = 46022,
  [SMALL_STATE(1148)] = 46075,
  [SMALL_STATE(1149)] = 46126,
  [SMALL_STATE(1150)] = 46179,
  [SMALL_STATE(1151)] = 46274,
  [SMALL_STATE(1152)] = 46325,
  [SMALL_STATE(1153)] = 46376,
  [SMALL_STATE(1154)] = 46437,
  [SMALL_STATE(1155)] = 46488,
  [SMALL_STATE(1156)] = 46583,
  [SMALL_STATE(1157)] = 46654,
  [SMALL_STATE(1158)] = 46705,
  [SMALL_STATE(1159)] = 46756,
  [SMALL_STATE(1160)] = 46807,
  [SMALL_STATE(1161)] = 46858,
  [SMALL_STATE(1162)] = 46929,
  [SMALL_STATE(1163)] = 46980,
  [SMALL_STATE(1164)] = 47051,
  [SMALL_STATE(1165)] = 47102,
  [SMALL_STATE(1166)] = 47153,
  [SMALL_STATE(1167)] = 47203,
  [SMALL_STATE(1168)] = 47253,
  [SMALL_STATE(1169)] = 47309,
  [SMALL_STATE(1170)] = 47407,
  [SMALL_STATE(1171)] = 47457,
  [SMALL_STATE(1172)] = 47507,
  [SMALL_STATE(1173)] = 47557,
  [SMALL_STATE(1174)] = 47607,
  [SMALL_STATE(1175)] = 47707,
  [SMALL_STATE(1176)] = 47757,
  [SMALL_STATE(1177)] = 47807,
  [SMALL_STATE(1178)] = 47857,
  [SMALL_STATE(1179)] = 47955,
  [SMALL_STATE(1180)] = 48005,
  [SMALL_STATE(1181)] = 48055,
  [SMALL_STATE(1182)] = 48105,
  [SMALL_STATE(1183)] = 48155,
  [SMALL_STATE(1184)] = 48255,
  [SMALL_STATE(1185)] = 48305,
  [SMALL_STATE(1186)] = 48403,
  [SMALL_STATE(1187)] = 48453,
  [SMALL_STATE(1188)] = 48503,
  [SMALL_STATE(1189)] = 48553,
  [SMALL_STATE(1190)] = 48603,
  [SMALL_STATE(1191)] = 48697,
  [SMALL_STATE(1192)] = 48747,
  [SMALL_STATE(1193)] = 48797,
  [SMALL_STATE(1194)] = 48847,
  [SMALL_STATE(1195)] = 48941,
  [SMALL_STATE(1196)] = 48991,
  [SMALL_STATE(1197)] = 49041,
  [SMALL_STATE(1198)] = 49091,
  [SMALL_STATE(1199)] = 49141,
  [SMALL_STATE(1200)] = 49191,
  [SMALL_STATE(1201)] = 49289,
  [SMALL_STATE(1202)] = 49339,
  [SMALL_STATE(1203)] = 49389,
  [SMALL_STATE(1204)] = 49439,
  [SMALL_STATE(1205)] = 49489,
  [SMALL_STATE(1206)] = 49539,
  [SMALL_STATE(1207)] = 49599,
  [SMALL_STATE(1208)] = 49667,
  [SMALL_STATE(1209)] = 49717,
  [SMALL_STATE(1210)] = 49767,
  [SMALL_STATE(1211)] = 49817,
  [SMALL_STATE(1212)] = 49867,
  [SMALL_STATE(1213)] = 49917,
  [SMALL_STATE(1214)] = 49967,
  [SMALL_STATE(1215)] = 50017,
  [SMALL_STATE(1216)] = 50067,
  [SMALL_STATE(1217)] = 50165,
  [SMALL_STATE(1218)] = 50259,
  [SMALL_STATE(1219)] = 50309,
  [SMALL_STATE(1220)] = 50403,
  [SMALL_STATE(1221)] = 50453,
  [SMALL_STATE(1222)] = 50503,
  [SMALL_STATE(1223)] = 50553,
  [SMALL_STATE(1224)] = 50603,
  [SMALL_STATE(1225)] = 50653,
  [SMALL_STATE(1226)] = 50703,
  [SMALL_STATE(1227)] = 50753,
  [SMALL_STATE(1228)] = 50819,
  [SMALL_STATE(1229)] = 50869,
  [SMALL_STATE(1230)] = 50919,
  [SMALL_STATE(1231)] = 50969,
  [SMALL_STATE(1232)] = 51019,
  [SMALL_STATE(1233)] = 51069,
  [SMALL_STATE(1234)] = 51163,
  [SMALL_STATE(1235)] = 51213,
  [SMALL_STATE(1236)] = 51263,
  [SMALL_STATE(1237)] = 51313,
  [SMALL_STATE(1238)] = 51407,
  [SMALL_STATE(1239)] = 51457,
  [SMALL_STATE(1240)] = 51507,
  [SMALL_STATE(1241)] = 51557,
  [SMALL_STATE(1242)] = 51651,
  [SMALL_STATE(1243)] = 51707,
  [SMALL_STATE(1244)] = 51757,
  [SMALL_STATE(1245)] = 51807,
  [SMALL_STATE(1246)] = 51901,
  [SMALL_STATE(1247)] = 51995,
  [SMALL_STATE(1248)] = 52061,
  [SMALL_STATE(1249)] = 52111,
  [SMALL_STATE(1250)] = 52205,
  [SMALL_STATE(1251)] = 52255,
  [SMALL_STATE(1252)] = 52349,
  [SMALL_STATE(1253)] = 52439,
  [SMALL_STATE(1254)] = 52509,
  [SMALL_STATE(1255)] = 52579,
  [SMALL_STATE(1256)] = 52629,
  [SMALL_STATE(1257)] = 52723,
  [SMALL_STATE(1258)] = 52799,
  [SMALL_STATE(1259)] = 52893,
  [SMALL_STATE(1260)] = 52947,
  [SMALL_STATE(1261)] = 52997,
  [SMALL_STATE(1262)] = 53083,
  [SMALL_STATE(1263)] = 53183,
  [SMALL_STATE(1264)] = 53233,
  [SMALL_STATE(1265)] = 53333,
  [SMALL_STATE(1266)] = 53383,
  [SMALL_STATE(1267)] = 53433,
  [SMALL_STATE(1268)] = 53503,
  [SMALL_STATE(1269)] = 53553,
  [SMALL_STATE(1270)] = 53635,
  [SMALL_STATE(1271)] = 53685,
  [SMALL_STATE(1272)] = 53735,
  [SMALL_STATE(1273)] = 53829,
  [SMALL_STATE(1274)] = 53879,
  [SMALL_STATE(1275)] = 53951,
  [SMALL_STATE(1276)] = 54051,
  [SMALL_STATE(1277)] = 54129,
  [SMALL_STATE(1278)] = 54223,
  [SMALL_STATE(1279)] = 54323,
  [SMALL_STATE(1280)] = 54373,
  [SMALL_STATE(1281)] = 54423,
  [SMALL_STATE(1282)] = 54473,
  [SMALL_STATE(1283)] = 54523,
  [SMALL_STATE(1284)] = 54617,
  [SMALL_STATE(1285)] = 54710,
  [SMALL_STATE(1286)] = 54805,
  [SMALL_STATE(1287)] = 54872,
  [SMALL_STATE(1288)] = 54967,
  [SMALL_STATE(1289)] = 55062,
  [SMALL_STATE(1290)] = 55159,
  [SMALL_STATE(1291)] = 55230,
  [SMALL_STATE(1292)] = 55325,
  [SMALL_STATE(1293)] = 55420,
  [SMALL_STATE(1294)] = 55517,
  [SMALL_STATE(1295)] = 55612,
  [SMALL_STATE(1296)] = 55707,
  [SMALL_STATE(1297)] = 55804,
  [SMALL_STATE(1298)] = 55901,
  [SMALL_STATE(1299)] = 55962,
  [SMALL_STATE(1300)] = 56023,
  [SMALL_STATE(1301)] = 56088,
  [SMALL_STATE(1302)] = 56185,
  [SMALL_STATE(1303)] = 56280,
  [SMALL_STATE(1304)] = 56377,
  [SMALL_STATE(1305)] = 56430,
  [SMALL_STATE(1306)] = 56485,
  [SMALL_STATE(1307)] = 56580,
  [SMALL_STATE(1308)] = 56675,
  [SMALL_STATE(1309)] = 56770,
  [SMALL_STATE(1310)] = 56829,
  [SMALL_STATE(1311)] = 56922,
  [SMALL_STATE(1312)] = 57015,
  [SMALL_STATE(1313)] = 57108,
  [SMALL_STATE(1314)] = 57201,
  [SMALL_STATE(1315)] = 57294,
  [SMALL_STATE(1316)] = 57363,
  [SMALL_STATE(1317)] = 57440,
  [SMALL_STATE(1318)] = 57537,
  [SMALL_STATE(1319)] = 57630,
  [SMALL_STATE(1320)] = 57681,
  [SMALL_STATE(1321)] = 57776,
  [SMALL_STATE(1322)] = 57825,
  [SMALL_STATE(1323)] = 57894,
  [SMALL_STATE(1324)] = 57963,
  [SMALL_STATE(1325)] = 58012,
  [SMALL_STATE(1326)] = 58063,
  [SMALL_STATE(1327)] = 58156,
  [SMALL_STATE(1328)] = 58251,
  [SMALL_STATE(1329)] = 58344,
  [SMALL_STATE(1330)] = 58437,
  [SMALL_STATE(1331)] = 58530,
  [SMALL_STATE(1332)] = 58611,
  [SMALL_STATE(1333)] = 58662,
  [SMALL_STATE(1334)] = 58711,
  [SMALL_STATE(1335)] = 58796,
  [SMALL_STATE(1336)] = 58889,
  [SMALL_STATE(1337)] = 58982,
  [SMALL_STATE(1338)] = 59075,
  [SMALL_STATE(1339)] = 59168,
  [SMALL_STATE(1340)] = 59261,
  [SMALL_STATE(1341)] = 59354,
  [SMALL_STATE(1342)] = 59429,
  [SMALL_STATE(1343)] = 59498,
  [SMALL_STATE(1344)] = 59565,
  [SMALL_STATE(1345)] = 59654,
  [SMALL_STATE(1346)] = 59747,
  [SMALL_STATE(1347)] = 59796,
  [SMALL_STATE(1348)] = 59889,
  [SMALL_STATE(1349)] = 59952,
  [SMALL_STATE(1350)] = 60049,
  [SMALL_STATE(1351)] = 60118,
  [SMALL_STATE(1352)] = 60211,
  [SMALL_STATE(1353)] = 60300,
  [SMALL_STATE(1354)] = 60393,
  [SMALL_STATE(1355)] = 60486,
  [SMALL_STATE(1356)] = 60579,
  [SMALL_STATE(1357)] = 60672,
  [SMALL_STATE(1358)] = 60725,
  [SMALL_STATE(1359)] = 60820,
  [SMALL_STATE(1360)] = 60913,
  [SMALL_STATE(1361)] = 60982,
  [SMALL_STATE(1362)] = 61075,
  [SMALL_STATE(1363)] = 61150,
  [SMALL_STATE(1364)] = 61235,
  [SMALL_STATE(1365)] = 61316,
  [SMALL_STATE(1366)] = 61393,
  [SMALL_STATE(1367)] = 61446,
  [SMALL_STATE(1368)] = 61541,
  [SMALL_STATE(1369)] = 61612,
  [SMALL_STATE(1370)] = 61705,
  [SMALL_STATE(1371)] = 61794,
  [SMALL_STATE(1372)] = 61863,
  [SMALL_STATE(1373)] = 61938,
  [SMALL_STATE(1374)] = 62033,
  [SMALL_STATE(1375)] = 62126,
  [SMALL_STATE(1376)] = 62219,
  [SMALL_STATE(1377)] = 62268,
  [SMALL_STATE(1378)] = 62363,
  [SMALL_STATE(1379)] = 62456,
  [SMALL_STATE(1380)] = 62549,
  [SMALL_STATE(1381)] = 62600,
  [SMALL_STATE(1382)] = 62649,
  [SMALL_STATE(1383)] = 62734,
  [SMALL_STATE(1384)] = 62815,
  [SMALL_STATE(1385)] = 62908,
  [SMALL_STATE(1386)] = 62977,
  [SMALL_STATE(1387)] = 63074,
  [SMALL_STATE(1388)] = 63143,
  [SMALL_STATE(1389)] = 63236,
  [SMALL_STATE(1390)] = 63329,
  [SMALL_STATE(1391)] = 63406,
  [SMALL_STATE(1392)] = 63499,
  [SMALL_STATE(1393)] = 63570,
  [SMALL_STATE(1394)] = 63665,
  [SMALL_STATE(1395)] = 63758,
  [SMALL_STATE(1396)] = 63855,
  [SMALL_STATE(1397)] = 63922,
  [SMALL_STATE(1398)] = 64019,
  [SMALL_STATE(1399)] = 64072,
  [SMALL_STATE(1400)] = 64125,
  [SMALL_STATE(1401)] = 64176,
  [SMALL_STATE(1402)] = 64271,
  [SMALL_STATE(1403)] = 64368,
  [SMALL_STATE(1404)] = 64463,
  [SMALL_STATE(1405)] = 64560,
  [SMALL_STATE(1406)] = 64615,
  [SMALL_STATE(1407)] = 64672,
  [SMALL_STATE(1408)] = 64729,
  [SMALL_STATE(1409)] = 64788,
  [SMALL_STATE(1410)] = 64853,
  [SMALL_STATE(1411)] = 64908,
  [SMALL_STATE(1412)] = 65005,
  [SMALL_STATE(1413)] = 65098,
  [SMALL_STATE(1414)] = 65190,
  [SMALL_STATE(1415)] = 65240,
  [SMALL_STATE(1416)] = 65334,
  [SMALL_STATE(1417)] = 65386,
  [SMALL_STATE(1418)] = 65478,
  [SMALL_STATE(1419)] = 65570,
  [SMALL_STATE(1420)] = 65664,
  [SMALL_STATE(1421)] = 65756,
  [SMALL_STATE(1422)] = 65808,
  [SMALL_STATE(1423)] = 65856,
  [SMALL_STATE(1424)] = 65950,
  [SMALL_STATE(1425)] = 66006,
  [SMALL_STATE(1426)] = 66062,
  [SMALL_STATE(1427)] = 66110,
  [SMALL_STATE(1428)] = 66158,
  [SMALL_STATE(1429)] = 66250,
  [SMALL_STATE(1430)] = 66302,
  [SMALL_STATE(1431)] = 66396,
  [SMALL_STATE(1432)] = 66444,
  [SMALL_STATE(1433)] = 66536,
  [SMALL_STATE(1434)] = 66588,
  [SMALL_STATE(1435)] = 66680,
  [SMALL_STATE(1436)] = 66750,
  [SMALL_STATE(1437)] = 66826,
  [SMALL_STATE(1438)] = 66878,
  [SMALL_STATE(1439)] = 66932,
  [SMALL_STATE(1440)] = 66982,
  [SMALL_STATE(1441)] = 67030,
  [SMALL_STATE(1442)] = 67082,
  [SMALL_STATE(1443)] = 67130,
  [SMALL_STATE(1444)] = 67196,
  [SMALL_STATE(1445)] = 67244,
  [SMALL_STATE(1446)] = 67292,
  [SMALL_STATE(1447)] = 67372,
  [SMALL_STATE(1448)] = 67456,
  [SMALL_STATE(1449)] = 67508,
  [SMALL_STATE(1450)] = 67582,
  [SMALL_STATE(1451)] = 67632,
  [SMALL_STATE(1452)] = 67700,
  [SMALL_STATE(1453)] = 67788,
  [SMALL_STATE(1454)] = 67880,
  [SMALL_STATE(1455)] = 67972,
  [SMALL_STATE(1456)] = 68066,
  [SMALL_STATE(1457)] = 68118,
  [SMALL_STATE(1458)] = 68170,
  [SMALL_STATE(1459)] = 68262,
  [SMALL_STATE(1460)] = 68320,
  [SMALL_STATE(1461)] = 68412,
  [SMALL_STATE(1462)] = 68506,
  [SMALL_STATE(1463)] = 68554,
  [SMALL_STATE(1464)] = 68646,
  [SMALL_STATE(1465)] = 68700,
  [SMALL_STATE(1466)] = 68792,
  [SMALL_STATE(1467)] = 68884,
  [SMALL_STATE(1468)] = 68978,
  [SMALL_STATE(1469)] = 69070,
  [SMALL_STATE(1470)] = 69122,
  [SMALL_STATE(1471)] = 69174,
  [SMALL_STATE(1472)] = 69228,
  [SMALL_STATE(1473)] = 69320,
  [SMALL_STATE(1474)] = 69368,
  [SMALL_STATE(1475)] = 69462,
  [SMALL_STATE(1476)] = 69510,
  [SMALL_STATE(1477)] = 69558,
  [SMALL_STATE(1478)] = 69612,
  [SMALL_STATE(1479)] = 69662,
  [SMALL_STATE(1480)] = 69722,
  [SMALL_STATE(1481)] = 69770,
  [SMALL_STATE(1482)] = 69818,
  [SMALL_STATE(1483)] = 69866,
  [SMALL_STATE(1484)] = 69916,
  [SMALL_STATE(1485)] = 69970,
  [SMALL_STATE(1486)] = 70022,
  [SMALL_STATE(1487)] = 70114,
  [SMALL_STATE(1488)] = 70176,
  [SMALL_STATE(1489)] = 70270,
  [SMALL_STATE(1490)] = 70322,
  [SMALL_STATE(1491)] = 70374,
  [SMALL_STATE(1492)] = 70468,
  [SMALL_STATE(1493)] = 70560,
  [SMALL_STATE(1494)] = 70652,
  [SMALL_STATE(1495)] = 70700,
  [SMALL_STATE(1496)] = 70792,
  [SMALL_STATE(1497)] = 70852,
  [SMALL_STATE(1498)] = 70946,
  [SMALL_STATE(1499)] = 71040,
  [SMALL_STATE(1500)] = 71134,
  [SMALL_STATE(1501)] = 71188,
  [SMALL_STATE(1502)] = 71282,
  [SMALL_STATE(1503)] = 71332,
  [SMALL_STATE(1504)] = 71426,
  [SMALL_STATE(1505)] = 71478,
  [SMALL_STATE(1506)] = 71530,
  [SMALL_STATE(1507)] = 71624,
  [SMALL_STATE(1508)] = 71716,
  [SMALL_STATE(1509)] = 71768,
  [SMALL_STATE(1510)] = 71862,
  [SMALL_STATE(1511)] = 71956,
  [SMALL_STATE(1512)] = 72004,
  [SMALL_STATE(1513)] = 72052,
  [SMALL_STATE(1514)] = 72146,
  [SMALL_STATE(1515)] = 72240,
  [SMALL_STATE(1516)] = 72288,
  [SMALL_STATE(1517)] = 72336,
  [SMALL_STATE(1518)] = 72384,
  [SMALL_STATE(1519)] = 72432,
  [SMALL_STATE(1520)] = 72480,
  [SMALL_STATE(1521)] = 72572,
  [SMALL_STATE(1522)] = 72620,
  [SMALL_STATE(1523)] = 72670,
  [SMALL_STATE(1524)] = 72718,
  [SMALL_STATE(1525)] = 72766,
  [SMALL_STATE(1526)] = 72816,
  [SMALL_STATE(1527)] = 72864,
  [SMALL_STATE(1528)] = 72916,
  [SMALL_STATE(1529)] = 72968,
  [SMALL_STATE(1530)] = 73020,
  [SMALL_STATE(1531)] = 73072,
  [SMALL_STATE(1532)] = 73130,
  [SMALL_STATE(1533)] = 73188,
  [SMALL_STATE(1534)] = 73240,
  [SMALL_STATE(1535)] = 73334,
  [SMALL_STATE(1536)] = 73388,
  [SMALL_STATE(1537)] = 73482,
  [SMALL_STATE(1538)] = 73576,
  [SMALL_STATE(1539)] = 73626,
  [SMALL_STATE(1540)] = 73720,
  [SMALL_STATE(1541)] = 73788,
  [SMALL_STATE(1542)] = 73882,
  [SMALL_STATE(1543)] = 73950,
  [SMALL_STATE(1544)] = 74044,
  [SMALL_STATE(1545)] = 74136,
  [SMALL_STATE(1546)] = 74228,
  [SMALL_STATE(1547)] = 74294,
  [SMALL_STATE(1548)] = 74354,
  [SMALL_STATE(1549)] = 74406,
  [SMALL_STATE(1550)] = 74454,
  [SMALL_STATE(1551)] = 74514,
  [SMALL_STATE(1552)] = 74608,
  [SMALL_STATE(1553)] = 74702,
  [SMALL_STATE(1554)] = 74750,
  [SMALL_STATE(1555)] = 74798,
  [SMALL_STATE(1556)] = 74846,
  [SMALL_STATE(1557)] = 74900,
  [SMALL_STATE(1558)] = 74991,
  [SMALL_STATE(1559)] = 75046,
  [SMALL_STATE(1560)] = 75093,
  [SMALL_STATE(1561)] = 75178,
  [SMALL_STATE(1562)] = 75261,
  [SMALL_STATE(1563)] = 75308,
  [SMALL_STATE(1564)] = 75355,
  [SMALL_STATE(1565)] = 75412,
  [SMALL_STATE(1566)] = 75459,
  [SMALL_STATE(1567)] = 75506,
  [SMALL_STATE(1568)] = 75561,
  [SMALL_STATE(1569)] = 75608,
  [SMALL_STATE(1570)] = 75661,
  [SMALL_STATE(1571)] = 75708,
  [SMALL_STATE(1572)] = 75799,
  [SMALL_STATE(1573)] = 75846,
  [SMALL_STATE(1574)] = 75901,
  [SMALL_STATE(1575)] = 75948,
  [SMALL_STATE(1576)] = 76003,
  [SMALL_STATE(1577)] = 76050,
  [SMALL_STATE(1578)] = 76097,
  [SMALL_STATE(1579)] = 76144,
  [SMALL_STATE(1580)] = 76197,
  [SMALL_STATE(1581)] = 76244,
  [SMALL_STATE(1582)] = 76291,
  [SMALL_STATE(1583)] = 76338,
  [SMALL_STATE(1584)] = 76385,
  [SMALL_STATE(1585)] = 76436,
  [SMALL_STATE(1586)] = 76483,
  [SMALL_STATE(1587)] = 76530,
  [SMALL_STATE(1588)] = 76577,
  [SMALL_STATE(1589)] = 76624,
  [SMALL_STATE(1590)] = 76707,
  [SMALL_STATE(1591)] = 76754,
  [SMALL_STATE(1592)] = 76837,
  [SMALL_STATE(1593)] = 76886,
  [SMALL_STATE(1594)] = 76933,
  [SMALL_STATE(1595)] = 76980,
  [SMALL_STATE(1596)] = 77027,
  [SMALL_STATE(1597)] = 77074,
  [SMALL_STATE(1598)] = 77121,
  [SMALL_STATE(1599)] = 77212,
  [SMALL_STATE(1600)] = 77271,
  [SMALL_STATE(1601)] = 77318,
  [SMALL_STATE(1602)] = 77367,
  [SMALL_STATE(1603)] = 77422,
  [SMALL_STATE(1604)] = 77469,
  [SMALL_STATE(1605)] = 77552,
  [SMALL_STATE(1606)] = 77635,
  [SMALL_STATE(1607)] = 77690,
  [SMALL_STATE(1608)] = 77741,
  [SMALL_STATE(1609)] = 77788,
  [SMALL_STATE(1610)] = 77835,
  [SMALL_STATE(1611)] = 77882,
  [SMALL_STATE(1612)] = 77967,
  [SMALL_STATE(1613)] = 78014,
  [SMALL_STATE(1614)] = 78061,
  [SMALL_STATE(1615)] = 78144,
  [SMALL_STATE(1616)] = 78191,
  [SMALL_STATE(1617)] = 78238,
  [SMALL_STATE(1618)] = 78321,
  [SMALL_STATE(1619)] = 78406,
  [SMALL_STATE(1620)] = 78465,
  [SMALL_STATE(1621)] = 78514,
  [SMALL_STATE(1622)] = 78561,
  [SMALL_STATE(1623)] = 78608,
  [SMALL_STATE(1624)] = 78655,
  [SMALL_STATE(1625)] = 78702,
  [SMALL_STATE(1626)] = 78785,
  [SMALL_STATE(1627)] = 78844,
  [SMALL_STATE(1628)] = 78927,
  [SMALL_STATE(1629)] = 78974,
  [SMALL_STATE(1630)] = 79033,
  [SMALL_STATE(1631)] = 79116,
  [SMALL_STATE(1632)] = 79163,
  [SMALL_STATE(1633)] = 79248,
  [SMALL_STATE(1634)] = 79299,
  [SMALL_STATE(1635)] = 79346,
  [SMALL_STATE(1636)] = 79437,
  [SMALL_STATE(1637)] = 79484,
  [SMALL_STATE(1638)] = 79531,
  [SMALL_STATE(1639)] = 79578,
  [SMALL_STATE(1640)] = 79625,
  [SMALL_STATE(1641)] = 79678,
  [SMALL_STATE(1642)] = 79725,
  [SMALL_STATE(1643)] = 79772,
  [SMALL_STATE(1644)] = 79819,
  [SMALL_STATE(1645)] = 79868,
  [SMALL_STATE(1646)] = 79915,
  [SMALL_STATE(1647)] = 79962,
  [SMALL_STATE(1648)] = 80009,
  [SMALL_STATE(1649)] = 80056,
  [SMALL_STATE(1650)] = 80105,
  [SMALL_STATE(1651)] = 80196,
  [SMALL_STATE(1652)] = 80255,
  [SMALL_STATE(1653)] = 80302,
  [SMALL_STATE(1654)] = 80349,
  [SMALL_STATE(1655)] = 80396,
  [SMALL_STATE(1656)] = 80443,
  [SMALL_STATE(1657)] = 80490,
  [SMALL_STATE(1658)] = 80537,
  [SMALL_STATE(1659)] = 80586,
  [SMALL_STATE(1660)] = 80645,
  [SMALL_STATE(1661)] = 80692,
  [SMALL_STATE(1662)] = 80739,
  [SMALL_STATE(1663)] = 80786,
  [SMALL_STATE(1664)] = 80877,
  [SMALL_STATE(1665)] = 80924,
  [SMALL_STATE(1666)] = 80971,
  [SMALL_STATE(1667)] = 81018,
  [SMALL_STATE(1668)] = 81073,
  [SMALL_STATE(1669)] = 81120,
  [SMALL_STATE(1670)] = 81167,
  [SMALL_STATE(1671)] = 81214,
  [SMALL_STATE(1672)] = 81297,
  [SMALL_STATE(1673)] = 81350,
  [SMALL_STATE(1674)] = 81405,
  [SMALL_STATE(1675)] = 81454,
  [SMALL_STATE(1676)] = 81501,
  [SMALL_STATE(1677)] = 81584,
  [SMALL_STATE(1678)] = 81631,
  [SMALL_STATE(1679)] = 81692,
  [SMALL_STATE(1680)] = 81741,
  [SMALL_STATE(1681)] = 81788,
  [SMALL_STATE(1682)] = 81835,
  [SMALL_STATE(1683)] = 81882,
  [SMALL_STATE(1684)] = 81929,
  [SMALL_STATE(1685)] = 82020,
  [SMALL_STATE(1686)] = 82103,
  [SMALL_STATE(1687)] = 82150,
  [SMALL_STATE(1688)] = 82197,
  [SMALL_STATE(1689)] = 82250,
  [SMALL_STATE(1690)] = 82297,
  [SMALL_STATE(1691)] = 82382,
  [SMALL_STATE(1692)] = 82443,
  [SMALL_STATE(1693)] = 82490,
  [SMALL_STATE(1694)] = 82551,
  [SMALL_STATE(1695)] = 82598,
  [SMALL_STATE(1696)] = 82689,
  [SMALL_STATE(1697)] = 82736,
  [SMALL_STATE(1698)] = 82783,
  [SMALL_STATE(1699)] = 82830,
  [SMALL_STATE(1700)] = 82877,
  [SMALL_STATE(1701)] = 82924,
  [SMALL_STATE(1702)] = 82971,
  [SMALL_STATE(1703)] = 83018,
  [SMALL_STATE(1704)] = 83065,
  [SMALL_STATE(1705)] = 83112,
  [SMALL_STATE(1706)] = 83159,
  [SMALL_STATE(1707)] = 83206,
  [SMALL_STATE(1708)] = 83257,
  [SMALL_STATE(1709)] = 83314,
  [SMALL_STATE(1710)] = 83361,
  [SMALL_STATE(1711)] = 83412,
  [SMALL_STATE(1712)] = 83459,
  [SMALL_STATE(1713)] = 83506,
  [SMALL_STATE(1714)] = 83553,
  [SMALL_STATE(1715)] = 83600,
  [SMALL_STATE(1716)] = 83691,
  [SMALL_STATE(1717)] = 83740,
  [SMALL_STATE(1718)] = 83787,
  [SMALL_STATE(1719)] = 83834,
  [SMALL_STATE(1720)] = 83881,
  [SMALL_STATE(1721)] = 83928,
  [SMALL_STATE(1722)] = 83975,
  [SMALL_STATE(1723)] = 84024,
  [SMALL_STATE(1724)] = 84081,
  [SMALL_STATE(1725)] = 84138,
  [SMALL_STATE(1726)] = 84197,
  [SMALL_STATE(1727)] = 84263,
  [SMALL_STATE(1728)] = 84309,
  [SMALL_STATE(1729)] = 84355,
  [SMALL_STATE(1730)] = 84443,
  [SMALL_STATE(1731)] = 84489,
  [SMALL_STATE(1732)] = 84535,
  [SMALL_STATE(1733)] = 84581,
  [SMALL_STATE(1734)] = 84627,
  [SMALL_STATE(1735)] = 84673,
  [SMALL_STATE(1736)] = 84719,
  [SMALL_STATE(1737)] = 84765,
  [SMALL_STATE(1738)] = 84819,
  [SMALL_STATE(1739)] = 84865,
  [SMALL_STATE(1740)] = 84911,
  [SMALL_STATE(1741)] = 84957,
  [SMALL_STATE(1742)] = 85023,
  [SMALL_STATE(1743)] = 85069,
  [SMALL_STATE(1744)] = 85137,
  [SMALL_STATE(1745)] = 85201,
  [SMALL_STATE(1746)] = 85247,
  [SMALL_STATE(1747)] = 85293,
  [SMALL_STATE(1748)] = 85339,
  [SMALL_STATE(1749)] = 85385,
  [SMALL_STATE(1750)] = 85431,
  [SMALL_STATE(1751)] = 85477,
  [SMALL_STATE(1752)] = 85523,
  [SMALL_STATE(1753)] = 85569,
  [SMALL_STATE(1754)] = 85615,
  [SMALL_STATE(1755)] = 85661,
  [SMALL_STATE(1756)] = 85707,
  [SMALL_STATE(1757)] = 85795,
  [SMALL_STATE(1758)] = 85841,
  [SMALL_STATE(1759)] = 85907,
  [SMALL_STATE(1760)] = 85953,
  [SMALL_STATE(1761)] = 86021,
  [SMALL_STATE(1762)] = 86085,
  [SMALL_STATE(1763)] = 86131,
  [SMALL_STATE(1764)] = 86177,
  [SMALL_STATE(1765)] = 86223,
  [SMALL_STATE(1766)] = 86269,
  [SMALL_STATE(1767)] = 86315,
  [SMALL_STATE(1768)] = 86361,
  [SMALL_STATE(1769)] = 86407,
  [SMALL_STATE(1770)] = 86453,
  [SMALL_STATE(1771)] = 86499,
  [SMALL_STATE(1772)] = 86545,
  [SMALL_STATE(1773)] = 86591,
  [SMALL_STATE(1774)] = 86637,
  [SMALL_STATE(1775)] = 86683,
  [SMALL_STATE(1776)] = 86729,
  [SMALL_STATE(1777)] = 86783,
  [SMALL_STATE(1778)] = 86829,
  [SMALL_STATE(1779)] = 86897,
  [SMALL_STATE(1780)] = 86961,
  [SMALL_STATE(1781)] = 87007,
  [SMALL_STATE(1782)] = 87053,
  [SMALL_STATE(1783)] = 87099,
  [SMALL_STATE(1784)] = 87145,
  [SMALL_STATE(1785)] = 87191,
  [SMALL_STATE(1786)] = 87237,
  [SMALL_STATE(1787)] = 87283,
  [SMALL_STATE(1788)] = 87329,
  [SMALL_STATE(1789)] = 87375,
  [SMALL_STATE(1790)] = 87421,
  [SMALL_STATE(1791)] = 87509,
  [SMALL_STATE(1792)] = 87555,
  [SMALL_STATE(1793)] = 87601,
  [SMALL_STATE(1794)] = 87647,
  [SMALL_STATE(1795)] = 87727,
  [SMALL_STATE(1796)] = 87793,
  [SMALL_STATE(1797)] = 87839,
  [SMALL_STATE(1798)] = 87885,
  [SMALL_STATE(1799)] = 87931,
  [SMALL_STATE(1800)] = 87977,
  [SMALL_STATE(1801)] = 88045,
  [SMALL_STATE(1802)] = 88091,
  [SMALL_STATE(1803)] = 88155,
  [SMALL_STATE(1804)] = 88201,
  [SMALL_STATE(1805)] = 88247,
  [SMALL_STATE(1806)] = 88293,
  [SMALL_STATE(1807)] = 88339,
  [SMALL_STATE(1808)] = 88385,
  [SMALL_STATE(1809)] = 88431,
  [SMALL_STATE(1810)] = 88477,
  [SMALL_STATE(1811)] = 88529,
  [SMALL_STATE(1812)] = 88592,
  [SMALL_STATE(1813)] = 88659,
  [SMALL_STATE(1814)] = 88722,
  [SMALL_STATE(1815)] = 88781,
  [SMALL_STATE(1816)] = 88838,
  [SMALL_STATE(1817)] = 88895,
  [SMALL_STATE(1818)] = 88952,
  [SMALL_STATE(1819)] = 89015,
  [SMALL_STATE(1820)] = 89072,
  [SMALL_STATE(1821)] = 89137,
  [SMALL_STATE(1822)] = 89196,
  [SMALL_STATE(1823)] = 89255,
  [SMALL_STATE(1824)] = 89314,
  [SMALL_STATE(1825)] = 89372,
  [SMALL_STATE(1826)] = 89430,
  [SMALL_STATE(1827)] = 89488,
  [SMALL_STATE(1828)] = 89546,
  [SMALL_STATE(1829)] = 89606,
  [SMALL_STATE(1830)] = 89666,
  [SMALL_STATE(1831)] = 89728,
  [SMALL_STATE(1832)] = 89786,
  [SMALL_STATE(1833)] = 89844,
  [SMALL_STATE(1834)] = 89902,
  [SMALL_STATE(1835)] = 89964,
  [SMALL_STATE(1836)] = 90022,
  [SMALL_STATE(1837)] = 90082,
  [SMALL_STATE(1838)] = 90142,
  [SMALL_STATE(1839)] = 90200,
  [SMALL_STATE(1840)] = 90262,
  [SMALL_STATE(1841)] = 90322,
  [SMALL_STATE(1842)] = 90380,
  [SMALL_STATE(1843)] = 90440,
  [SMALL_STATE(1844)] = 90502,
  [SMALL_STATE(1845)] = 90560,
  [SMALL_STATE(1846)] = 90606,
  [SMALL_STATE(1847)] = 90664,
  [SMALL_STATE(1848)] = 90724,
  [SMALL_STATE(1849)] = 90786,
  [SMALL_STATE(1850)] = 90859,
  [SMALL_STATE(1851)] = 90926,
  [SMALL_STATE(1852)] = 90979,
  [SMALL_STATE(1853)] = 91052,
  [SMALL_STATE(1854)] = 91125,
  [SMALL_STATE(1855)] = 91178,
  [SMALL_STATE(1856)] = 91251,
  [SMALL_STATE(1857)] = 91324,
  [SMALL_STATE(1858)] = 91393,
  [SMALL_STATE(1859)] = 91442,
  [SMALL_STATE(1860)] = 91515,
  [SMALL_STATE(1861)] = 91568,
  [SMALL_STATE(1862)] = 91635,
  [SMALL_STATE(1863)] = 91708,
  [SMALL_STATE(1864)] = 91757,
  [SMALL_STATE(1865)] = 91810,
  [SMALL_STATE(1866)] = 91877,
  [SMALL_STATE(1867)] = 91942,
  [SMALL_STATE(1868)] = 91995,
  [SMALL_STATE(1869)] = 92048,
  [SMALL_STATE(1870)] = 92121,
  [SMALL_STATE(1871)] = 92190,
  [SMALL_STATE(1872)] = 92263,
  [SMALL_STATE(1873)] = 92336,
  [SMALL_STATE(1874)] = 92401,
  [SMALL_STATE(1875)] = 92454,
  [SMALL_STATE(1876)] = 92507,
  [SMALL_STATE(1877)] = 92560,
  [SMALL_STATE(1878)] = 92613,
  [SMALL_STATE(1879)] = 92662,
  [SMALL_STATE(1880)] = 92729,
  [SMALL_STATE(1881)] = 92802,
  [SMALL_STATE(1882)] = 92855,
  [SMALL_STATE(1883)] = 92928,
  [SMALL_STATE(1884)] = 92997,
  [SMALL_STATE(1885)] = 93050,
  [SMALL_STATE(1886)] = 93117,
  [SMALL_STATE(1887)] = 93182,
  [SMALL_STATE(1888)] = 93235,
  [SMALL_STATE(1889)] = 93308,
  [SMALL_STATE(1890)] = 93373,
  [SMALL_STATE(1891)] = 93426,
  [SMALL_STATE(1892)] = 93495,
  [SMALL_STATE(1893)] = 93544,
  [SMALL_STATE(1894)] = 93609,
  [SMALL_STATE(1895)] = 93678,
  [SMALL_STATE(1896)] = 93731,
  [SMALL_STATE(1897)] = 93780,
  [SMALL_STATE(1898)] = 93842,
  [SMALL_STATE(1899)] = 93902,
  [SMALL_STATE(1900)] = 93972,
  [SMALL_STATE(1901)] = 94020,
  [SMALL_STATE(1902)] = 94084,
  [SMALL_STATE(1903)] = 94154,
  [SMALL_STATE(1904)] = 94214,
  [SMALL_STATE(1905)] = 94274,
  [SMALL_STATE(1906)] = 94334,
  [SMALL_STATE(1907)] = 94404,
  [SMALL_STATE(1908)] = 94474,
  [SMALL_STATE(1909)] = 94516,
  [SMALL_STATE(1910)] = 94576,
  [SMALL_STATE(1911)] = 94636,
  [SMALL_STATE(1912)] = 94706,
  [SMALL_STATE(1913)] = 94785,
  [SMALL_STATE(1914)] = 94864,
  [SMALL_STATE(1915)] = 94919,
  [SMALL_STATE(1916)] = 94998,
  [SMALL_STATE(1917)] = 95077,
  [SMALL_STATE(1918)] = 95156,
  [SMALL_STATE(1919)] = 95235,
  [SMALL_STATE(1920)] = 95314,
  [SMALL_STATE(1921)] = 95393,
  [SMALL_STATE(1922)] = 95443,
  [SMALL_STATE(1923)] = 95483,
  [SMALL_STATE(1924)] = 95533,
  [SMALL_STATE(1925)] = 95573,
  [SMALL_STATE(1926)] = 95623,
  [SMALL_STATE(1927)] = 95673,
  [SMALL_STATE(1928)] = 95723,
  [SMALL_STATE(1929)] = 95763,
  [SMALL_STATE(1930)] = 95803,
  [SMALL_STATE(1931)] = 95843,
  [SMALL_STATE(1932)] = 95888,
  [SMALL_STATE(1933)] = 95926,
  [SMALL_STATE(1934)] = 95978,
  [SMALL_STATE(1935)] = 96016,
  [SMALL_STATE(1936)] = 96054,
  [SMALL_STATE(1937)] = 96092,
  [SMALL_STATE(1938)] = 96130,
  [SMALL_STATE(1939)] = 96168,
  [SMALL_STATE(1940)] = 96224,
  [SMALL_STATE(1941)] = 96276,
  [SMALL_STATE(1942)] = 96314,
  [SMALL_STATE(1943)] = 96368,
  [SMALL_STATE(1944)] = 96408,
  [SMALL_STATE(1945)] = 96462,
  [SMALL_STATE(1946)] = 96500,
  [SMALL_STATE(1947)] = 96538,
  [SMALL_STATE(1948)] = 96588,
  [SMALL_STATE(1949)] = 96628,
  [SMALL_STATE(1950)] = 96666,
  [SMALL_STATE(1951)] = 96704,
  [SMALL_STATE(1952)] = 96742,
  [SMALL_STATE(1953)] = 96794,
  [SMALL_STATE(1954)] = 96832,
  [SMALL_STATE(1955)] = 96872,
  [SMALL_STATE(1956)] = 96910,
  [SMALL_STATE(1957)] = 96957,
  [SMALL_STATE(1958)] = 97004,
  [SMALL_STATE(1959)] = 97051,
  [SMALL_STATE(1960)] = 97098,
  [SMALL_STATE(1961)] = 97145,
  [SMALL_STATE(1962)] = 97192,
  [SMALL_STATE(1963)] = 97239,
  [SMALL_STATE(1964)] = 97286,
  [SMALL_STATE(1965)] = 97333,
  [SMALL_STATE(1966)] = 97380,
  [SMALL_STATE(1967)] = 97427,
  [SMALL_STATE(1968)] = 97474,
  [SMALL_STATE(1969)] = 97521,
  [SMALL_STATE(1970)] = 97568,
  [SMALL_STATE(1971)] = 97615,
  [SMALL_STATE(1972)] = 97662,
  [SMALL_STATE(1973)] = 97709,
  [SMALL_STATE(1974)] = 97756,
  [SMALL_STATE(1975)] = 97804,
  [SMALL_STATE(1976)] = 97860,
  [SMALL_STATE(1977)] = 97908,
  [SMALL_STATE(1978)] = 97956,
  [SMALL_STATE(1979)] = 97992,
  [SMALL_STATE(1980)] = 98034,
  [SMALL_STATE(1981)] = 98082,
  [SMALL_STATE(1982)] = 98130,
  [SMALL_STATE(1983)] = 98178,
  [SMALL_STATE(1984)] = 98227,
  [SMALL_STATE(1985)] = 98280,
  [SMALL_STATE(1986)] = 98333,
  [SMALL_STATE(1987)] = 98386,
  [SMALL_STATE(1988)] = 98435,
  [SMALL_STATE(1989)] = 98480,
  [SMALL_STATE(1990)] = 98517,
  [SMALL_STATE(1991)] = 98559,
  [SMALL_STATE(1992)] = 98601,
  [SMALL_STATE(1993)] = 98643,
  [SMALL_STATE(1994)] = 98685,
  [SMALL_STATE(1995)] = 98719,
  [SMALL_STATE(1996)] = 98761,
  [SMALL_STATE(1997)] = 98803,
  [SMALL_STATE(1998)] = 98845,
  [SMALL_STATE(1999)] = 98887,
  [SMALL_STATE(2000)] = 98929,
  [SMALL_STATE(2001)] = 98971,
  [SMALL_STATE(2002)] = 99013,
  [SMALL_STATE(2003)] = 99055,
  [SMALL_STATE(2004)] = 99097,
  [SMALL_STATE(2005)] = 99139,
  [SMALL_STATE(2006)] = 99181,
  [SMALL_STATE(2007)] = 99223,
  [SMALL_STATE(2008)] = 99265,
  [SMALL_STATE(2009)] = 99307,
  [SMALL_STATE(2010)] = 99349,
  [SMALL_STATE(2011)] = 99391,
  [SMALL_STATE(2012)] = 99433,
  [SMALL_STATE(2013)] = 99475,
  [SMALL_STATE(2014)] = 99517,
  [SMALL_STATE(2015)] = 99559,
  [SMALL_STATE(2016)] = 99601,
  [SMALL_STATE(2017)] = 99631,
  [SMALL_STATE(2018)] = 99663,
  [SMALL_STATE(2019)] = 99719,
  [SMALL_STATE(2020)] = 99775,
  [SMALL_STATE(2021)] = 99831,
  [SMALL_STATE(2022)] = 99863,
  [SMALL_STATE(2023)] = 99895,
  [SMALL_STATE(2024)] = 99924,
  [SMALL_STATE(2025)] = 99953,
  [SMALL_STATE(2026)] = 99980,
  [SMALL_STATE(2027)] = 100004,
  [SMALL_STATE(2028)] = 100030,
  [SMALL_STATE(2029)] = 100054,
  [SMALL_STATE(2030)] = 100081,
  [SMALL_STATE(2031)] = 100110,
  [SMALL_STATE(2032)] = 100131,
  [SMALL_STATE(2033)] = 100152,
  [SMALL_STATE(2034)] = 100173,
  [SMALL_STATE(2035)] = 100194,
  [SMALL_STATE(2036)] = 100215,
  [SMALL_STATE(2037)] = 100236,
  [SMALL_STATE(2038)] = 100265,
  [SMALL_STATE(2039)] = 100293,
  [SMALL_STATE(2040)] = 100323,
  [SMALL_STATE(2041)] = 100351,
  [SMALL_STATE(2042)] = 100385,
  [SMALL_STATE(2043)] = 100427,
  [SMALL_STATE(2044)] = 100469,
  [SMALL_STATE(2045)] = 100497,
  [SMALL_STATE(2046)] = 100539,
  [SMALL_STATE(2047)] = 100581,
  [SMALL_STATE(2048)] = 100623,
  [SMALL_STATE(2049)] = 100665,
  [SMALL_STATE(2050)] = 100706,
  [SMALL_STATE(2051)] = 100729,
  [SMALL_STATE(2052)] = 100764,
  [SMALL_STATE(2053)] = 100787,
  [SMALL_STATE(2054)] = 100812,
  [SMALL_STATE(2055)] = 100853,
  [SMALL_STATE(2056)] = 100888,
  [SMALL_STATE(2057)] = 100923,
  [SMALL_STATE(2058)] = 100958,
  [SMALL_STATE(2059)] = 100993,
  [SMALL_STATE(2060)] = 101028,
  [SMALL_STATE(2061)] = 101063,
  [SMALL_STATE(2062)] = 101098,
  [SMALL_STATE(2063)] = 101123,
  [SMALL_STATE(2064)] = 101160,
  [SMALL_STATE(2065)] = 101196,
  [SMALL_STATE(2066)] = 101234,
  [SMALL_STATE(2067)] = 101260,
  [SMALL_STATE(2068)] = 101292,
  [SMALL_STATE(2069)] = 101324,
  [SMALL_STATE(2070)] = 101356,
  [SMALL_STATE(2071)] = 101394,
  [SMALL_STATE(2072)] = 101426,
  [SMALL_STATE(2073)] = 101458,
  [SMALL_STATE(2074)] = 101496,
  [SMALL_STATE(2075)] = 101532,
  [SMALL_STATE(2076)] = 101568,
  [SMALL_STATE(2077)] = 101604,
  [SMALL_STATE(2078)] = 101630,
  [SMALL_STATE(2079)] = 101662,
  [SMALL_STATE(2080)] = 101694,
  [SMALL_STATE(2081)] = 101726,
  [SMALL_STATE(2082)] = 101748,
  [SMALL_STATE(2083)] = 101784,
  [SMALL_STATE(2084)] = 101812,
  [SMALL_STATE(2085)] = 101850,
  [SMALL_STATE(2086)] = 101888,
  [SMALL_STATE(2087)] = 101924,
  [SMALL_STATE(2088)] = 101943,
  [SMALL_STATE(2089)] = 101962,
  [SMALL_STATE(2090)] = 101981,
  [SMALL_STATE(2091)] = 102000,
  [SMALL_STATE(2092)] = 102019,
  [SMALL_STATE(2093)] = 102038,
  [SMALL_STATE(2094)] = 102059,
  [SMALL_STATE(2095)] = 102080,
  [SMALL_STATE(2096)] = 102099,
  [SMALL_STATE(2097)] = 102118,
  [SMALL_STATE(2098)] = 102139,
  [SMALL_STATE(2099)] = 102158,
  [SMALL_STATE(2100)] = 102177,
  [SMALL_STATE(2101)] = 102196,
  [SMALL_STATE(2102)] = 102215,
  [SMALL_STATE(2103)] = 102238,
  [SMALL_STATE(2104)] = 102257,
  [SMALL_STATE(2105)] = 102276,
  [SMALL_STATE(2106)] = 102297,
  [SMALL_STATE(2107)] = 102316,
  [SMALL_STATE(2108)] = 102335,
  [SMALL_STATE(2109)] = 102358,
  [SMALL_STATE(2110)] = 102377,
  [SMALL_STATE(2111)] = 102396,
  [SMALL_STATE(2112)] = 102415,
  [SMALL_STATE(2113)] = 102438,
  [SMALL_STATE(2114)] = 102459,
  [SMALL_STATE(2115)] = 102482,
  [SMALL_STATE(2116)] = 102501,
  [SMALL_STATE(2117)] = 102520,
  [SMALL_STATE(2118)] = 102539,
  [SMALL_STATE(2119)] = 102558,
  [SMALL_STATE(2120)] = 102577,
  [SMALL_STATE(2121)] = 102596,
  [SMALL_STATE(2122)] = 102613,
  [SMALL_STATE(2123)] = 102632,
  [SMALL_STATE(2124)] = 102651,
  [SMALL_STATE(2125)] = 102670,
  [SMALL_STATE(2126)] = 102693,
  [SMALL_STATE(2127)] = 102710,
  [SMALL_STATE(2128)] = 102731,
  [SMALL_STATE(2129)] = 102752,
  [SMALL_STATE(2130)] = 102771,
  [SMALL_STATE(2131)] = 102792,
  [SMALL_STATE(2132)] = 102813,
  [SMALL_STATE(2133)] = 102832,
  [SMALL_STATE(2134)] = 102851,
  [SMALL_STATE(2135)] = 102873,
  [SMALL_STATE(2136)] = 102907,
  [SMALL_STATE(2137)] = 102939,
  [SMALL_STATE(2138)] = 102965,
  [SMALL_STATE(2139)] = 102999,
  [SMALL_STATE(2140)] = 103019,
  [SMALL_STATE(2141)] = 103043,
  [SMALL_STATE(2142)] = 103063,
  [SMALL_STATE(2143)] = 103095,
  [SMALL_STATE(2144)] = 103115,
  [SMALL_STATE(2145)] = 103141,
  [SMALL_STATE(2146)] = 103175,
  [SMALL_STATE(2147)] = 103201,
  [SMALL_STATE(2148)] = 103235,
  [SMALL_STATE(2149)] = 103269,
  [SMALL_STATE(2150)] = 103287,
  [SMALL_STATE(2151)] = 103313,
  [SMALL_STATE(2152)] = 103343,
  [SMALL_STATE(2153)] = 103377,
  [SMALL_STATE(2154)] = 103403,
  [SMALL_STATE(2155)] = 103437,
  [SMALL_STATE(2156)] = 103455,
  [SMALL_STATE(2157)] = 103481,
  [SMALL_STATE(2158)] = 103507,
  [SMALL_STATE(2159)] = 103527,
  [SMALL_STATE(2160)] = 103547,
  [SMALL_STATE(2161)] = 103573,
  [SMALL_STATE(2162)] = 103599,
  [SMALL_STATE(2163)] = 103625,
  [SMALL_STATE(2164)] = 103651,
  [SMALL_STATE(2165)] = 103685,
  [SMALL_STATE(2166)] = 103719,
  [SMALL_STATE(2167)] = 103751,
  [SMALL_STATE(2168)] = 103769,
  [SMALL_STATE(2169)] = 103801,
  [SMALL_STATE(2170)] = 103835,
  [SMALL_STATE(2171)] = 103861,
  [SMALL_STATE(2172)] = 103893,
  [SMALL_STATE(2173)] = 103924,
  [SMALL_STATE(2174)] = 103955,
  [SMALL_STATE(2175)] = 103980,
  [SMALL_STATE(2176)] = 104009,
  [SMALL_STATE(2177)] = 104032,
  [SMALL_STATE(2178)] = 104057,
  [SMALL_STATE(2179)] = 104086,
  [SMALL_STATE(2180)] = 104115,
  [SMALL_STATE(2181)] = 104146,
  [SMALL_STATE(2182)] = 104169,
  [SMALL_STATE(2183)] = 104188,
  [SMALL_STATE(2184)] = 104211,
  [SMALL_STATE(2185)] = 104234,
  [SMALL_STATE(2186)] = 104265,
  [SMALL_STATE(2187)] = 104288,
  [SMALL_STATE(2188)] = 104311,
  [SMALL_STATE(2189)] = 104336,
  [SMALL_STATE(2190)] = 104361,
  [SMALL_STATE(2191)] = 104384,
  [SMALL_STATE(2192)] = 104415,
  [SMALL_STATE(2193)] = 104444,
  [SMALL_STATE(2194)] = 104473,
  [SMALL_STATE(2195)] = 104502,
  [SMALL_STATE(2196)] = 104533,
  [SMALL_STATE(2197)] = 104564,
  [SMALL_STATE(2198)] = 104593,
  [SMALL_STATE(2199)] = 104624,
  [SMALL_STATE(2200)] = 104655,
  [SMALL_STATE(2201)] = 104672,
  [SMALL_STATE(2202)] = 104701,
  [SMALL_STATE(2203)] = 104730,
  [SMALL_STATE(2204)] = 104759,
  [SMALL_STATE(2205)] = 104788,
  [SMALL_STATE(2206)] = 104805,
  [SMALL_STATE(2207)] = 104824,
  [SMALL_STATE(2208)] = 104845,
  [SMALL_STATE(2209)] = 104876,
  [SMALL_STATE(2210)] = 104905,
  [SMALL_STATE(2211)] = 104936,
  [SMALL_STATE(2212)] = 104953,
  [SMALL_STATE(2213)] = 104984,
  [SMALL_STATE(2214)] = 105009,
  [SMALL_STATE(2215)] = 105038,
  [SMALL_STATE(2216)] = 105061,
  [SMALL_STATE(2217)] = 105092,
  [SMALL_STATE(2218)] = 105117,
  [SMALL_STATE(2219)] = 105140,
  [SMALL_STATE(2220)] = 105169,
  [SMALL_STATE(2221)] = 105198,
  [SMALL_STATE(2222)] = 105227,
  [SMALL_STATE(2223)] = 105256,
  [SMALL_STATE(2224)] = 105287,
  [SMALL_STATE(2225)] = 105316,
  [SMALL_STATE(2226)] = 105339,
  [SMALL_STATE(2227)] = 105356,
  [SMALL_STATE(2228)] = 105385,
  [SMALL_STATE(2229)] = 105404,
  [SMALL_STATE(2230)] = 105429,
  [SMALL_STATE(2231)] = 105452,
  [SMALL_STATE(2232)] = 105481,
  [SMALL_STATE(2233)] = 105498,
  [SMALL_STATE(2234)] = 105519,
  [SMALL_STATE(2235)] = 105550,
  [SMALL_STATE(2236)] = 105579,
  [SMALL_STATE(2237)] = 105602,
  [SMALL_STATE(2238)] = 105633,
  [SMALL_STATE(2239)] = 105664,
  [SMALL_STATE(2240)] = 105695,
  [SMALL_STATE(2241)] = 105720,
  [SMALL_STATE(2242)] = 105737,
  [SMALL_STATE(2243)] = 105751,
  [SMALL_STATE(2244)] = 105765,
  [SMALL_STATE(2245)] = 105779,
  [SMALL_STATE(2246)] = 105799,
  [SMALL_STATE(2247)] = 105813,
  [SMALL_STATE(2248)] = 105827,
  [SMALL_STATE(2249)] = 105841,
  [SMALL_STATE(2250)] = 105855,
  [SMALL_STATE(2251)] = 105877,
  [SMALL_STATE(2252)] = 105891,
  [SMALL_STATE(2253)] = 105913,
  [SMALL_STATE(2254)] = 105927,
  [SMALL_STATE(2255)] = 105943,
  [SMALL_STATE(2256)] = 105963,
  [SMALL_STATE(2257)] = 105977,
  [SMALL_STATE(2258)] = 105991,
  [SMALL_STATE(2259)] = 106005,
  [SMALL_STATE(2260)] = 106019,
  [SMALL_STATE(2261)] = 106033,
  [SMALL_STATE(2262)] = 106047,
  [SMALL_STATE(2263)] = 106061,
  [SMALL_STATE(2264)] = 106075,
  [SMALL_STATE(2265)] = 106089,
  [SMALL_STATE(2266)] = 106103,
  [SMALL_STATE(2267)] = 106119,
  [SMALL_STATE(2268)] = 106141,
  [SMALL_STATE(2269)] = 106155,
  [SMALL_STATE(2270)] = 106177,
  [SMALL_STATE(2271)] = 106197,
  [SMALL_STATE(2272)] = 106211,
  [SMALL_STATE(2273)] = 106225,
  [SMALL_STATE(2274)] = 106239,
  [SMALL_STATE(2275)] = 106253,
  [SMALL_STATE(2276)] = 106269,
  [SMALL_STATE(2277)] = 106285,
  [SMALL_STATE(2278)] = 106299,
  [SMALL_STATE(2279)] = 106313,
  [SMALL_STATE(2280)] = 106327,
  [SMALL_STATE(2281)] = 106341,
  [SMALL_STATE(2282)] = 106355,
  [SMALL_STATE(2283)] = 106369,
  [SMALL_STATE(2284)] = 106393,
  [SMALL_STATE(2285)] = 106413,
  [SMALL_STATE(2286)] = 106433,
  [SMALL_STATE(2287)] = 106447,
  [SMALL_STATE(2288)] = 106467,
  [SMALL_STATE(2289)] = 106489,
  [SMALL_STATE(2290)] = 106511,
  [SMALL_STATE(2291)] = 106529,
  [SMALL_STATE(2292)] = 106547,
  [SMALL_STATE(2293)] = 106565,
  [SMALL_STATE(2294)] = 106579,
  [SMALL_STATE(2295)] = 106593,
  [SMALL_STATE(2296)] = 106610,
  [SMALL_STATE(2297)] = 106635,
  [SMALL_STATE(2298)] = 106660,
  [SMALL_STATE(2299)] = 106677,
  [SMALL_STATE(2300)] = 106702,
  [SMALL_STATE(2301)] = 106723,
  [SMALL_STATE(2302)] = 106748,
  [SMALL_STATE(2303)] = 106773,
  [SMALL_STATE(2304)] = 106788,
  [SMALL_STATE(2305)] = 106805,
  [SMALL_STATE(2306)] = 106822,
  [SMALL_STATE(2307)] = 106839,
  [SMALL_STATE(2308)] = 106864,
  [SMALL_STATE(2309)] = 106889,
  [SMALL_STATE(2310)] = 106914,
  [SMALL_STATE(2311)] = 106927,
  [SMALL_STATE(2312)] = 106952,
  [SMALL_STATE(2313)] = 106977,
  [SMALL_STATE(2314)] = 107002,
  [SMALL_STATE(2315)] = 107019,
  [SMALL_STATE(2316)] = 107044,
  [SMALL_STATE(2317)] = 107061,
  [SMALL_STATE(2318)] = 107074,
  [SMALL_STATE(2319)] = 107091,
  [SMALL_STATE(2320)] = 107116,
  [SMALL_STATE(2321)] = 107133,
  [SMALL_STATE(2322)] = 107150,
  [SMALL_STATE(2323)] = 107175,
  [SMALL_STATE(2324)] = 107200,
  [SMALL_STATE(2325)] = 107225,
  [SMALL_STATE(2326)] = 107242,
  [SMALL_STATE(2327)] = 107255,
  [SMALL_STATE(2328)] = 107272,
  [SMALL_STATE(2329)] = 107285,
  [SMALL_STATE(2330)] = 107310,
  [SMALL_STATE(2331)] = 107335,
  [SMALL_STATE(2332)] = 107360,
  [SMALL_STATE(2333)] = 107375,
  [SMALL_STATE(2334)] = 107396,
  [SMALL_STATE(2335)] = 107421,
  [SMALL_STATE(2336)] = 107446,
  [SMALL_STATE(2337)] = 107471,
  [SMALL_STATE(2338)] = 107496,
  [SMALL_STATE(2339)] = 107521,
  [SMALL_STATE(2340)] = 107538,
  [SMALL_STATE(2341)] = 107563,
  [SMALL_STATE(2342)] = 107588,
  [SMALL_STATE(2343)] = 107611,
  [SMALL_STATE(2344)] = 107636,
  [SMALL_STATE(2345)] = 107657,
  [SMALL_STATE(2346)] = 107678,
  [SMALL_STATE(2347)] = 107703,
  [SMALL_STATE(2348)] = 107728,
  [SMALL_STATE(2349)] = 107741,
  [SMALL_STATE(2350)] = 107766,
  [SMALL_STATE(2351)] = 107791,
  [SMALL_STATE(2352)] = 107812,
  [SMALL_STATE(2353)] = 107837,
  [SMALL_STATE(2354)] = 107862,
  [SMALL_STATE(2355)] = 107879,
  [SMALL_STATE(2356)] = 107904,
  [SMALL_STATE(2357)] = 107923,
  [SMALL_STATE(2358)] = 107940,
  [SMALL_STATE(2359)] = 107965,
  [SMALL_STATE(2360)] = 107990,
  [SMALL_STATE(2361)] = 108009,
  [SMALL_STATE(2362)] = 108024,
  [SMALL_STATE(2363)] = 108049,
  [SMALL_STATE(2364)] = 108074,
  [SMALL_STATE(2365)] = 108099,
  [SMALL_STATE(2366)] = 108124,
  [SMALL_STATE(2367)] = 108139,
  [SMALL_STATE(2368)] = 108158,
  [SMALL_STATE(2369)] = 108183,
  [SMALL_STATE(2370)] = 108208,
  [SMALL_STATE(2371)] = 108229,
  [SMALL_STATE(2372)] = 108254,
  [SMALL_STATE(2373)] = 108271,
  [SMALL_STATE(2374)] = 108296,
  [SMALL_STATE(2375)] = 108309,
  [SMALL_STATE(2376)] = 108328,
  [SMALL_STATE(2377)] = 108343,
  [SMALL_STATE(2378)] = 108364,
  [SMALL_STATE(2379)] = 108389,
  [SMALL_STATE(2380)] = 108414,
  [SMALL_STATE(2381)] = 108439,
  [SMALL_STATE(2382)] = 108461,
  [SMALL_STATE(2383)] = 108483,
  [SMALL_STATE(2384)] = 108499,
  [SMALL_STATE(2385)] = 108519,
  [SMALL_STATE(2386)] = 108541,
  [SMALL_STATE(2387)] = 108557,
  [SMALL_STATE(2388)] = 108575,
  [SMALL_STATE(2389)] = 108597,
  [SMALL_STATE(2390)] = 108619,
  [SMALL_STATE(2391)] = 108631,
  [SMALL_STATE(2392)] = 108653,
  [SMALL_STATE(2393)] = 108675,
  [SMALL_STATE(2394)] = 108697,
  [SMALL_STATE(2395)] = 108719,
  [SMALL_STATE(2396)] = 108741,
  [SMALL_STATE(2397)] = 108757,
  [SMALL_STATE(2398)] = 108777,
  [SMALL_STATE(2399)] = 108793,
  [SMALL_STATE(2400)] = 108809,
  [SMALL_STATE(2401)] = 108825,
  [SMALL_STATE(2402)] = 108837,
  [SMALL_STATE(2403)] = 108859,
  [SMALL_STATE(2404)] = 108877,
  [SMALL_STATE(2405)] = 108893,
  [SMALL_STATE(2406)] = 108915,
  [SMALL_STATE(2407)] = 108937,
  [SMALL_STATE(2408)] = 108959,
  [SMALL_STATE(2409)] = 108981,
  [SMALL_STATE(2410)] = 108997,
  [SMALL_STATE(2411)] = 109017,
  [SMALL_STATE(2412)] = 109039,
  [SMALL_STATE(2413)] = 109061,
  [SMALL_STATE(2414)] = 109079,
  [SMALL_STATE(2415)] = 109095,
  [SMALL_STATE(2416)] = 109117,
  [SMALL_STATE(2417)] = 109133,
  [SMALL_STATE(2418)] = 109149,
  [SMALL_STATE(2419)] = 109165,
  [SMALL_STATE(2420)] = 109183,
  [SMALL_STATE(2421)] = 109195,
  [SMALL_STATE(2422)] = 109211,
  [SMALL_STATE(2423)] = 109233,
  [SMALL_STATE(2424)] = 109255,
  [SMALL_STATE(2425)] = 109267,
  [SMALL_STATE(2426)] = 109287,
  [SMALL_STATE(2427)] = 109307,
  [SMALL_STATE(2428)] = 109329,
  [SMALL_STATE(2429)] = 109347,
  [SMALL_STATE(2430)] = 109361,
  [SMALL_STATE(2431)] = 109383,
  [SMALL_STATE(2432)] = 109405,
  [SMALL_STATE(2433)] = 109427,
  [SMALL_STATE(2434)] = 109445,
  [SMALL_STATE(2435)] = 109465,
  [SMALL_STATE(2436)] = 109481,
  [SMALL_STATE(2437)] = 109503,
  [SMALL_STATE(2438)] = 109525,
  [SMALL_STATE(2439)] = 109541,
  [SMALL_STATE(2440)] = 109563,
  [SMALL_STATE(2441)] = 109579,
  [SMALL_STATE(2442)] = 109599,
  [SMALL_STATE(2443)] = 109621,
  [SMALL_STATE(2444)] = 109637,
  [SMALL_STATE(2445)] = 109659,
  [SMALL_STATE(2446)] = 109681,
  [SMALL_STATE(2447)] = 109701,
  [SMALL_STATE(2448)] = 109723,
  [SMALL_STATE(2449)] = 109745,
  [SMALL_STATE(2450)] = 109767,
  [SMALL_STATE(2451)] = 109789,
  [SMALL_STATE(2452)] = 109805,
  [SMALL_STATE(2453)] = 109827,
  [SMALL_STATE(2454)] = 109843,
  [SMALL_STATE(2455)] = 109859,
  [SMALL_STATE(2456)] = 109877,
  [SMALL_STATE(2457)] = 109895,
  [SMALL_STATE(2458)] = 109913,
  [SMALL_STATE(2459)] = 109929,
  [SMALL_STATE(2460)] = 109951,
  [SMALL_STATE(2461)] = 109967,
  [SMALL_STATE(2462)] = 109979,
  [SMALL_STATE(2463)] = 110001,
  [SMALL_STATE(2464)] = 110021,
  [SMALL_STATE(2465)] = 110039,
  [SMALL_STATE(2466)] = 110057,
  [SMALL_STATE(2467)] = 110075,
  [SMALL_STATE(2468)] = 110097,
  [SMALL_STATE(2469)] = 110119,
  [SMALL_STATE(2470)] = 110137,
  [SMALL_STATE(2471)] = 110159,
  [SMALL_STATE(2472)] = 110181,
  [SMALL_STATE(2473)] = 110203,
  [SMALL_STATE(2474)] = 110221,
  [SMALL_STATE(2475)] = 110239,
  [SMALL_STATE(2476)] = 110261,
  [SMALL_STATE(2477)] = 110283,
  [SMALL_STATE(2478)] = 110299,
  [SMALL_STATE(2479)] = 110321,
  [SMALL_STATE(2480)] = 110343,
  [SMALL_STATE(2481)] = 110365,
  [SMALL_STATE(2482)] = 110381,
  [SMALL_STATE(2483)] = 110403,
  [SMALL_STATE(2484)] = 110425,
  [SMALL_STATE(2485)] = 110447,
  [SMALL_STATE(2486)] = 110469,
  [SMALL_STATE(2487)] = 110491,
  [SMALL_STATE(2488)] = 110513,
  [SMALL_STATE(2489)] = 110525,
  [SMALL_STATE(2490)] = 110547,
  [SMALL_STATE(2491)] = 110565,
  [SMALL_STATE(2492)] = 110587,
  [SMALL_STATE(2493)] = 110603,
  [SMALL_STATE(2494)] = 110621,
  [SMALL_STATE(2495)] = 110643,
  [SMALL_STATE(2496)] = 110665,
  [SMALL_STATE(2497)] = 110687,
  [SMALL_STATE(2498)] = 110709,
  [SMALL_STATE(2499)] = 110731,
  [SMALL_STATE(2500)] = 110753,
  [SMALL_STATE(2501)] = 110775,
  [SMALL_STATE(2502)] = 110791,
  [SMALL_STATE(2503)] = 110807,
  [SMALL_STATE(2504)] = 110829,
  [SMALL_STATE(2505)] = 110851,
  [SMALL_STATE(2506)] = 110869,
  [SMALL_STATE(2507)] = 110887,
  [SMALL_STATE(2508)] = 110909,
  [SMALL_STATE(2509)] = 110931,
  [SMALL_STATE(2510)] = 110953,
  [SMALL_STATE(2511)] = 110969,
  [SMALL_STATE(2512)] = 110989,
  [SMALL_STATE(2513)] = 111007,
  [SMALL_STATE(2514)] = 111025,
  [SMALL_STATE(2515)] = 111047,
  [SMALL_STATE(2516)] = 111069,
  [SMALL_STATE(2517)] = 111089,
  [SMALL_STATE(2518)] = 111111,
  [SMALL_STATE(2519)] = 111133,
  [SMALL_STATE(2520)] = 111149,
  [SMALL_STATE(2521)] = 111171,
  [SMALL_STATE(2522)] = 111193,
  [SMALL_STATE(2523)] = 111215,
  [SMALL_STATE(2524)] = 111237,
  [SMALL_STATE(2525)] = 111259,
  [SMALL_STATE(2526)] = 111281,
  [SMALL_STATE(2527)] = 111303,
  [SMALL_STATE(2528)] = 111321,
  [SMALL_STATE(2529)] = 111343,
  [SMALL_STATE(2530)] = 111365,
  [SMALL_STATE(2531)] = 111384,
  [SMALL_STATE(2532)] = 111403,
  [SMALL_STATE(2533)] = 111414,
  [SMALL_STATE(2534)] = 111425,
  [SMALL_STATE(2535)] = 111440,
  [SMALL_STATE(2536)] = 111455,
  [SMALL_STATE(2537)] = 111466,
  [SMALL_STATE(2538)] = 111477,
  [SMALL_STATE(2539)] = 111488,
  [SMALL_STATE(2540)] = 111503,
  [SMALL_STATE(2541)] = 111514,
  [SMALL_STATE(2542)] = 111525,
  [SMALL_STATE(2543)] = 111536,
  [SMALL_STATE(2544)] = 111551,
  [SMALL_STATE(2545)] = 111562,
  [SMALL_STATE(2546)] = 111573,
  [SMALL_STATE(2547)] = 111584,
  [SMALL_STATE(2548)] = 111603,
  [SMALL_STATE(2549)] = 111622,
  [SMALL_STATE(2550)] = 111641,
  [SMALL_STATE(2551)] = 111656,
  [SMALL_STATE(2552)] = 111669,
  [SMALL_STATE(2553)] = 111682,
  [SMALL_STATE(2554)] = 111693,
  [SMALL_STATE(2555)] = 111704,
  [SMALL_STATE(2556)] = 111723,
  [SMALL_STATE(2557)] = 111738,
  [SMALL_STATE(2558)] = 111749,
  [SMALL_STATE(2559)] = 111760,
  [SMALL_STATE(2560)] = 111773,
  [SMALL_STATE(2561)] = 111784,
  [SMALL_STATE(2562)] = 111795,
  [SMALL_STATE(2563)] = 111810,
  [SMALL_STATE(2564)] = 111821,
  [SMALL_STATE(2565)] = 111840,
  [SMALL_STATE(2566)] = 111857,
  [SMALL_STATE(2567)] = 111868,
  [SMALL_STATE(2568)] = 111879,
  [SMALL_STATE(2569)] = 111890,
  [SMALL_STATE(2570)] = 111903,
  [SMALL_STATE(2571)] = 111914,
  [SMALL_STATE(2572)] = 111929,
  [SMALL_STATE(2573)] = 111940,
  [SMALL_STATE(2574)] = 111951,
  [SMALL_STATE(2575)] = 111966,
  [SMALL_STATE(2576)] = 111983,
  [SMALL_STATE(2577)] = 111994,
  [SMALL_STATE(2578)] = 112009,
  [SMALL_STATE(2579)] = 112020,
  [SMALL_STATE(2580)] = 112031,
  [SMALL_STATE(2581)] = 112042,
  [SMALL_STATE(2582)] = 112053,
  [SMALL_STATE(2583)] = 112064,
  [SMALL_STATE(2584)] = 112079,
  [SMALL_STATE(2585)] = 112090,
  [SMALL_STATE(2586)] = 112101,
  [SMALL_STATE(2587)] = 112118,
  [SMALL_STATE(2588)] = 112129,
  [SMALL_STATE(2589)] = 112140,
  [SMALL_STATE(2590)] = 112151,
  [SMALL_STATE(2591)] = 112162,
  [SMALL_STATE(2592)] = 112173,
  [SMALL_STATE(2593)] = 112192,
  [SMALL_STATE(2594)] = 112203,
  [SMALL_STATE(2595)] = 112222,
  [SMALL_STATE(2596)] = 112233,
  [SMALL_STATE(2597)] = 112248,
  [SMALL_STATE(2598)] = 112267,
  [SMALL_STATE(2599)] = 112278,
  [SMALL_STATE(2600)] = 112297,
  [SMALL_STATE(2601)] = 112308,
  [SMALL_STATE(2602)] = 112325,
  [SMALL_STATE(2603)] = 112338,
  [SMALL_STATE(2604)] = 112353,
  [SMALL_STATE(2605)] = 112364,
  [SMALL_STATE(2606)] = 112383,
  [SMALL_STATE(2607)] = 112394,
  [SMALL_STATE(2608)] = 112411,
  [SMALL_STATE(2609)] = 112424,
  [SMALL_STATE(2610)] = 112435,
  [SMALL_STATE(2611)] = 112446,
  [SMALL_STATE(2612)] = 112459,
  [SMALL_STATE(2613)] = 112474,
  [SMALL_STATE(2614)] = 112487,
  [SMALL_STATE(2615)] = 112498,
  [SMALL_STATE(2616)] = 112509,
  [SMALL_STATE(2617)] = 112524,
  [SMALL_STATE(2618)] = 112535,
  [SMALL_STATE(2619)] = 112554,
  [SMALL_STATE(2620)] = 112565,
  [SMALL_STATE(2621)] = 112578,
  [SMALL_STATE(2622)] = 112589,
  [SMALL_STATE(2623)] = 112600,
  [SMALL_STATE(2624)] = 112611,
  [SMALL_STATE(2625)] = 112622,
  [SMALL_STATE(2626)] = 112633,
  [SMALL_STATE(2627)] = 112648,
  [SMALL_STATE(2628)] = 112659,
  [SMALL_STATE(2629)] = 112670,
  [SMALL_STATE(2630)] = 112685,
  [SMALL_STATE(2631)] = 112696,
  [SMALL_STATE(2632)] = 112707,
  [SMALL_STATE(2633)] = 112722,
  [SMALL_STATE(2634)] = 112733,
  [SMALL_STATE(2635)] = 112752,
  [SMALL_STATE(2636)] = 112763,
  [SMALL_STATE(2637)] = 112774,
  [SMALL_STATE(2638)] = 112785,
  [SMALL_STATE(2639)] = 112800,
  [SMALL_STATE(2640)] = 112819,
  [SMALL_STATE(2641)] = 112834,
  [SMALL_STATE(2642)] = 112845,
  [SMALL_STATE(2643)] = 112856,
  [SMALL_STATE(2644)] = 112867,
  [SMALL_STATE(2645)] = 112878,
  [SMALL_STATE(2646)] = 112893,
  [SMALL_STATE(2647)] = 112910,
  [SMALL_STATE(2648)] = 112925,
  [SMALL_STATE(2649)] = 112944,
  [SMALL_STATE(2650)] = 112955,
  [SMALL_STATE(2651)] = 112970,
  [SMALL_STATE(2652)] = 112985,
  [SMALL_STATE(2653)] = 112996,
  [SMALL_STATE(2654)] = 113007,
  [SMALL_STATE(2655)] = 113026,
  [SMALL_STATE(2656)] = 113045,
  [SMALL_STATE(2657)] = 113062,
  [SMALL_STATE(2658)] = 113073,
  [SMALL_STATE(2659)] = 113092,
  [SMALL_STATE(2660)] = 113107,
  [SMALL_STATE(2661)] = 113126,
  [SMALL_STATE(2662)] = 113145,
  [SMALL_STATE(2663)] = 113164,
  [SMALL_STATE(2664)] = 113179,
  [SMALL_STATE(2665)] = 113192,
  [SMALL_STATE(2666)] = 113211,
  [SMALL_STATE(2667)] = 113222,
  [SMALL_STATE(2668)] = 113239,
  [SMALL_STATE(2669)] = 113250,
  [SMALL_STATE(2670)] = 113263,
  [SMALL_STATE(2671)] = 113274,
  [SMALL_STATE(2672)] = 113285,
  [SMALL_STATE(2673)] = 113296,
  [SMALL_STATE(2674)] = 113307,
  [SMALL_STATE(2675)] = 113322,
  [SMALL_STATE(2676)] = 113337,
  [SMALL_STATE(2677)] = 113356,
  [SMALL_STATE(2678)] = 113375,
  [SMALL_STATE(2679)] = 113390,
  [SMALL_STATE(2680)] = 113405,
  [SMALL_STATE(2681)] = 113424,
  [SMALL_STATE(2682)] = 113439,
  [SMALL_STATE(2683)] = 113454,
  [SMALL_STATE(2684)] = 113469,
  [SMALL_STATE(2685)] = 113486,
  [SMALL_STATE(2686)] = 113505,
  [SMALL_STATE(2687)] = 113524,
  [SMALL_STATE(2688)] = 113535,
  [SMALL_STATE(2689)] = 113548,
  [SMALL_STATE(2690)] = 113567,
  [SMALL_STATE(2691)] = 113582,
  [SMALL_STATE(2692)] = 113599,
  [SMALL_STATE(2693)] = 113610,
  [SMALL_STATE(2694)] = 113623,
  [SMALL_STATE(2695)] = 113634,
  [SMALL_STATE(2696)] = 113653,
  [SMALL_STATE(2697)] = 113666,
  [SMALL_STATE(2698)] = 113679,
  [SMALL_STATE(2699)] = 113690,
  [SMALL_STATE(2700)] = 113701,
  [SMALL_STATE(2701)] = 113712,
  [SMALL_STATE(2702)] = 113723,
  [SMALL_STATE(2703)] = 113742,
  [SMALL_STATE(2704)] = 113761,
  [SMALL_STATE(2705)] = 113780,
  [SMALL_STATE(2706)] = 113795,
  [SMALL_STATE(2707)] = 113814,
  [SMALL_STATE(2708)] = 113825,
  [SMALL_STATE(2709)] = 113838,
  [SMALL_STATE(2710)] = 113849,
  [SMALL_STATE(2711)] = 113868,
  [SMALL_STATE(2712)] = 113881,
  [SMALL_STATE(2713)] = 113892,
  [SMALL_STATE(2714)] = 113911,
  [SMALL_STATE(2715)] = 113922,
  [SMALL_STATE(2716)] = 113941,
  [SMALL_STATE(2717)] = 113956,
  [SMALL_STATE(2718)] = 113975,
  [SMALL_STATE(2719)] = 113988,
  [SMALL_STATE(2720)] = 114007,
  [SMALL_STATE(2721)] = 114022,
  [SMALL_STATE(2722)] = 114037,
  [SMALL_STATE(2723)] = 114052,
  [SMALL_STATE(2724)] = 114063,
  [SMALL_STATE(2725)] = 114082,
  [SMALL_STATE(2726)] = 114101,
  [SMALL_STATE(2727)] = 114112,
  [SMALL_STATE(2728)] = 114131,
  [SMALL_STATE(2729)] = 114150,
  [SMALL_STATE(2730)] = 114165,
  [SMALL_STATE(2731)] = 114184,
  [SMALL_STATE(2732)] = 114201,
  [SMALL_STATE(2733)] = 114212,
  [SMALL_STATE(2734)] = 114229,
  [SMALL_STATE(2735)] = 114240,
  [SMALL_STATE(2736)] = 114255,
  [SMALL_STATE(2737)] = 114274,
  [SMALL_STATE(2738)] = 114285,
  [SMALL_STATE(2739)] = 114296,
  [SMALL_STATE(2740)] = 114315,
  [SMALL_STATE(2741)] = 114334,
  [SMALL_STATE(2742)] = 114345,
  [SMALL_STATE(2743)] = 114360,
  [SMALL_STATE(2744)] = 114371,
  [SMALL_STATE(2745)] = 114386,
  [SMALL_STATE(2746)] = 114405,
  [SMALL_STATE(2747)] = 114416,
  [SMALL_STATE(2748)] = 114427,
  [SMALL_STATE(2749)] = 114438,
  [SMALL_STATE(2750)] = 114449,
  [SMALL_STATE(2751)] = 114462,
  [SMALL_STATE(2752)] = 114473,
  [SMALL_STATE(2753)] = 114492,
  [SMALL_STATE(2754)] = 114503,
  [SMALL_STATE(2755)] = 114518,
  [SMALL_STATE(2756)] = 114529,
  [SMALL_STATE(2757)] = 114548,
  [SMALL_STATE(2758)] = 114559,
  [SMALL_STATE(2759)] = 114570,
  [SMALL_STATE(2760)] = 114581,
  [SMALL_STATE(2761)] = 114594,
  [SMALL_STATE(2762)] = 114613,
  [SMALL_STATE(2763)] = 114624,
  [SMALL_STATE(2764)] = 114643,
  [SMALL_STATE(2765)] = 114654,
  [SMALL_STATE(2766)] = 114671,
  [SMALL_STATE(2767)] = 114686,
  [SMALL_STATE(2768)] = 114705,
  [SMALL_STATE(2769)] = 114718,
  [SMALL_STATE(2770)] = 114737,
  [SMALL_STATE(2771)] = 114756,
  [SMALL_STATE(2772)] = 114767,
  [SMALL_STATE(2773)] = 114782,
  [SMALL_STATE(2774)] = 114795,
  [SMALL_STATE(2775)] = 114814,
  [SMALL_STATE(2776)] = 114829,
  [SMALL_STATE(2777)] = 114846,
  [SMALL_STATE(2778)] = 114861,
  [SMALL_STATE(2779)] = 114872,
  [SMALL_STATE(2780)] = 114891,
  [SMALL_STATE(2781)] = 114902,
  [SMALL_STATE(2782)] = 114913,
  [SMALL_STATE(2783)] = 114932,
  [SMALL_STATE(2784)] = 114951,
  [SMALL_STATE(2785)] = 114970,
  [SMALL_STATE(2786)] = 114981,
  [SMALL_STATE(2787)] = 115000,
  [SMALL_STATE(2788)] = 115019,
  [SMALL_STATE(2789)] = 115030,
  [SMALL_STATE(2790)] = 115041,
  [SMALL_STATE(2791)] = 115052,
  [SMALL_STATE(2792)] = 115063,
  [SMALL_STATE(2793)] = 115082,
  [SMALL_STATE(2794)] = 115101,
  [SMALL_STATE(2795)] = 115112,
  [SMALL_STATE(2796)] = 115127,
  [SMALL_STATE(2797)] = 115138,
  [SMALL_STATE(2798)] = 115149,
  [SMALL_STATE(2799)] = 115160,
  [SMALL_STATE(2800)] = 115177,
  [SMALL_STATE(2801)] = 115188,
  [SMALL_STATE(2802)] = 115199,
  [SMALL_STATE(2803)] = 115213,
  [SMALL_STATE(2804)] = 115227,
  [SMALL_STATE(2805)] = 115239,
  [SMALL_STATE(2806)] = 115253,
  [SMALL_STATE(2807)] = 115269,
  [SMALL_STATE(2808)] = 115285,
  [SMALL_STATE(2809)] = 115301,
  [SMALL_STATE(2810)] = 115313,
  [SMALL_STATE(2811)] = 115329,
  [SMALL_STATE(2812)] = 115345,
  [SMALL_STATE(2813)] = 115355,
  [SMALL_STATE(2814)] = 115371,
  [SMALL_STATE(2815)] = 115387,
  [SMALL_STATE(2816)] = 115403,
  [SMALL_STATE(2817)] = 115419,
  [SMALL_STATE(2818)] = 115435,
  [SMALL_STATE(2819)] = 115451,
  [SMALL_STATE(2820)] = 115467,
  [SMALL_STATE(2821)] = 115483,
  [SMALL_STATE(2822)] = 115499,
  [SMALL_STATE(2823)] = 115515,
  [SMALL_STATE(2824)] = 115527,
  [SMALL_STATE(2825)] = 115541,
  [SMALL_STATE(2826)] = 115557,
  [SMALL_STATE(2827)] = 115569,
  [SMALL_STATE(2828)] = 115583,
  [SMALL_STATE(2829)] = 115597,
  [SMALL_STATE(2830)] = 115611,
  [SMALL_STATE(2831)] = 115623,
  [SMALL_STATE(2832)] = 115639,
  [SMALL_STATE(2833)] = 115655,
  [SMALL_STATE(2834)] = 115667,
  [SMALL_STATE(2835)] = 115683,
  [SMALL_STATE(2836)] = 115699,
  [SMALL_STATE(2837)] = 115713,
  [SMALL_STATE(2838)] = 115729,
  [SMALL_STATE(2839)] = 115745,
  [SMALL_STATE(2840)] = 115761,
  [SMALL_STATE(2841)] = 115775,
  [SMALL_STATE(2842)] = 115791,
  [SMALL_STATE(2843)] = 115807,
  [SMALL_STATE(2844)] = 115823,
  [SMALL_STATE(2845)] = 115839,
  [SMALL_STATE(2846)] = 115855,
  [SMALL_STATE(2847)] = 115871,
  [SMALL_STATE(2848)] = 115883,
  [SMALL_STATE(2849)] = 115899,
  [SMALL_STATE(2850)] = 115915,
  [SMALL_STATE(2851)] = 115931,
  [SMALL_STATE(2852)] = 115947,
  [SMALL_STATE(2853)] = 115963,
  [SMALL_STATE(2854)] = 115979,
  [SMALL_STATE(2855)] = 115995,
  [SMALL_STATE(2856)] = 116011,
  [SMALL_STATE(2857)] = 116027,
  [SMALL_STATE(2858)] = 116043,
  [SMALL_STATE(2859)] = 116059,
  [SMALL_STATE(2860)] = 116075,
  [SMALL_STATE(2861)] = 116091,
  [SMALL_STATE(2862)] = 116107,
  [SMALL_STATE(2863)] = 116117,
  [SMALL_STATE(2864)] = 116133,
  [SMALL_STATE(2865)] = 116149,
  [SMALL_STATE(2866)] = 116165,
  [SMALL_STATE(2867)] = 116181,
  [SMALL_STATE(2868)] = 116197,
  [SMALL_STATE(2869)] = 116213,
  [SMALL_STATE(2870)] = 116225,
  [SMALL_STATE(2871)] = 116239,
  [SMALL_STATE(2872)] = 116253,
  [SMALL_STATE(2873)] = 116267,
  [SMALL_STATE(2874)] = 116283,
  [SMALL_STATE(2875)] = 116299,
  [SMALL_STATE(2876)] = 116313,
  [SMALL_STATE(2877)] = 116329,
  [SMALL_STATE(2878)] = 116343,
  [SMALL_STATE(2879)] = 116359,
  [SMALL_STATE(2880)] = 116375,
  [SMALL_STATE(2881)] = 116391,
  [SMALL_STATE(2882)] = 116405,
  [SMALL_STATE(2883)] = 116419,
  [SMALL_STATE(2884)] = 116435,
  [SMALL_STATE(2885)] = 116451,
  [SMALL_STATE(2886)] = 116467,
  [SMALL_STATE(2887)] = 116483,
  [SMALL_STATE(2888)] = 116497,
  [SMALL_STATE(2889)] = 116513,
  [SMALL_STATE(2890)] = 116529,
  [SMALL_STATE(2891)] = 116543,
  [SMALL_STATE(2892)] = 116553,
  [SMALL_STATE(2893)] = 116569,
  [SMALL_STATE(2894)] = 116583,
  [SMALL_STATE(2895)] = 116593,
  [SMALL_STATE(2896)] = 116609,
  [SMALL_STATE(2897)] = 116623,
  [SMALL_STATE(2898)] = 116639,
  [SMALL_STATE(2899)] = 116655,
  [SMALL_STATE(2900)] = 116671,
  [SMALL_STATE(2901)] = 116687,
  [SMALL_STATE(2902)] = 116703,
  [SMALL_STATE(2903)] = 116719,
  [SMALL_STATE(2904)] = 116735,
  [SMALL_STATE(2905)] = 116749,
  [SMALL_STATE(2906)] = 116765,
  [SMALL_STATE(2907)] = 116781,
  [SMALL_STATE(2908)] = 116797,
  [SMALL_STATE(2909)] = 116813,
  [SMALL_STATE(2910)] = 116829,
  [SMALL_STATE(2911)] = 116845,
  [SMALL_STATE(2912)] = 116861,
  [SMALL_STATE(2913)] = 116877,
  [SMALL_STATE(2914)] = 116893,
  [SMALL_STATE(2915)] = 116909,
  [SMALL_STATE(2916)] = 116919,
  [SMALL_STATE(2917)] = 116935,
  [SMALL_STATE(2918)] = 116951,
  [SMALL_STATE(2919)] = 116967,
  [SMALL_STATE(2920)] = 116983,
  [SMALL_STATE(2921)] = 116999,
  [SMALL_STATE(2922)] = 117015,
  [SMALL_STATE(2923)] = 117031,
  [SMALL_STATE(2924)] = 117047,
  [SMALL_STATE(2925)] = 117063,
  [SMALL_STATE(2926)] = 117079,
  [SMALL_STATE(2927)] = 117095,
  [SMALL_STATE(2928)] = 117109,
  [SMALL_STATE(2929)] = 117125,
  [SMALL_STATE(2930)] = 117139,
  [SMALL_STATE(2931)] = 117155,
  [SMALL_STATE(2932)] = 117169,
  [SMALL_STATE(2933)] = 117185,
  [SMALL_STATE(2934)] = 117195,
  [SMALL_STATE(2935)] = 117211,
  [SMALL_STATE(2936)] = 117227,
  [SMALL_STATE(2937)] = 117243,
  [SMALL_STATE(2938)] = 117257,
  [SMALL_STATE(2939)] = 117273,
  [SMALL_STATE(2940)] = 117289,
  [SMALL_STATE(2941)] = 117303,
  [SMALL_STATE(2942)] = 117317,
  [SMALL_STATE(2943)] = 117331,
  [SMALL_STATE(2944)] = 117343,
  [SMALL_STATE(2945)] = 117352,
  [SMALL_STATE(2946)] = 117365,
  [SMALL_STATE(2947)] = 117378,
  [SMALL_STATE(2948)] = 117389,
  [SMALL_STATE(2949)] = 117402,
  [SMALL_STATE(2950)] = 117415,
  [SMALL_STATE(2951)] = 117428,
  [SMALL_STATE(2952)] = 117441,
  [SMALL_STATE(2953)] = 117450,
  [SMALL_STATE(2954)] = 117463,
  [SMALL_STATE(2955)] = 117476,
  [SMALL_STATE(2956)] = 117487,
  [SMALL_STATE(2957)] = 117496,
  [SMALL_STATE(2958)] = 117505,
  [SMALL_STATE(2959)] = 117514,
  [SMALL_STATE(2960)] = 117527,
  [SMALL_STATE(2961)] = 117536,
  [SMALL_STATE(2962)] = 117545,
  [SMALL_STATE(2963)] = 117554,
  [SMALL_STATE(2964)] = 117567,
  [SMALL_STATE(2965)] = 117580,
  [SMALL_STATE(2966)] = 117593,
  [SMALL_STATE(2967)] = 117602,
  [SMALL_STATE(2968)] = 117615,
  [SMALL_STATE(2969)] = 117624,
  [SMALL_STATE(2970)] = 117635,
  [SMALL_STATE(2971)] = 117648,
  [SMALL_STATE(2972)] = 117661,
  [SMALL_STATE(2973)] = 117674,
  [SMALL_STATE(2974)] = 117683,
  [SMALL_STATE(2975)] = 117696,
  [SMALL_STATE(2976)] = 117709,
  [SMALL_STATE(2977)] = 117722,
  [SMALL_STATE(2978)] = 117735,
  [SMALL_STATE(2979)] = 117748,
  [SMALL_STATE(2980)] = 117761,
  [SMALL_STATE(2981)] = 117774,
  [SMALL_STATE(2982)] = 117783,
  [SMALL_STATE(2983)] = 117796,
  [SMALL_STATE(2984)] = 117805,
  [SMALL_STATE(2985)] = 117818,
  [SMALL_STATE(2986)] = 117831,
  [SMALL_STATE(2987)] = 117844,
  [SMALL_STATE(2988)] = 117857,
  [SMALL_STATE(2989)] = 117870,
  [SMALL_STATE(2990)] = 117883,
  [SMALL_STATE(2991)] = 117896,
  [SMALL_STATE(2992)] = 117905,
  [SMALL_STATE(2993)] = 117914,
  [SMALL_STATE(2994)] = 117927,
  [SMALL_STATE(2995)] = 117936,
  [SMALL_STATE(2996)] = 117949,
  [SMALL_STATE(2997)] = 117962,
  [SMALL_STATE(2998)] = 117975,
  [SMALL_STATE(2999)] = 117988,
  [SMALL_STATE(3000)] = 118001,
  [SMALL_STATE(3001)] = 118014,
  [SMALL_STATE(3002)] = 118023,
  [SMALL_STATE(3003)] = 118036,
  [SMALL_STATE(3004)] = 118049,
  [SMALL_STATE(3005)] = 118062,
  [SMALL_STATE(3006)] = 118075,
  [SMALL_STATE(3007)] = 118088,
  [SMALL_STATE(3008)] = 118097,
  [SMALL_STATE(3009)] = 118106,
  [SMALL_STATE(3010)] = 118119,
  [SMALL_STATE(3011)] = 118132,
  [SMALL_STATE(3012)] = 118145,
  [SMALL_STATE(3013)] = 118158,
  [SMALL_STATE(3014)] = 118171,
  [SMALL_STATE(3015)] = 118184,
  [SMALL_STATE(3016)] = 118197,
  [SMALL_STATE(3017)] = 118210,
  [SMALL_STATE(3018)] = 118223,
  [SMALL_STATE(3019)] = 118236,
  [SMALL_STATE(3020)] = 118249,
  [SMALL_STATE(3021)] = 118262,
  [SMALL_STATE(3022)] = 118275,
  [SMALL_STATE(3023)] = 118284,
  [SMALL_STATE(3024)] = 118293,
  [SMALL_STATE(3025)] = 118306,
  [SMALL_STATE(3026)] = 118319,
  [SMALL_STATE(3027)] = 118328,
  [SMALL_STATE(3028)] = 118339,
  [SMALL_STATE(3029)] = 118348,
  [SMALL_STATE(3030)] = 118357,
  [SMALL_STATE(3031)] = 118366,
  [SMALL_STATE(3032)] = 118377,
  [SMALL_STATE(3033)] = 118386,
  [SMALL_STATE(3034)] = 118399,
  [SMALL_STATE(3035)] = 118412,
  [SMALL_STATE(3036)] = 118421,
  [SMALL_STATE(3037)] = 118434,
  [SMALL_STATE(3038)] = 118447,
  [SMALL_STATE(3039)] = 118456,
  [SMALL_STATE(3040)] = 118469,
  [SMALL_STATE(3041)] = 118480,
  [SMALL_STATE(3042)] = 118493,
  [SMALL_STATE(3043)] = 118506,
  [SMALL_STATE(3044)] = 118519,
  [SMALL_STATE(3045)] = 118528,
  [SMALL_STATE(3046)] = 118541,
  [SMALL_STATE(3047)] = 118550,
  [SMALL_STATE(3048)] = 118563,
  [SMALL_STATE(3049)] = 118576,
  [SMALL_STATE(3050)] = 118585,
  [SMALL_STATE(3051)] = 118594,
  [SMALL_STATE(3052)] = 118607,
  [SMALL_STATE(3053)] = 118620,
  [SMALL_STATE(3054)] = 118633,
  [SMALL_STATE(3055)] = 118646,
  [SMALL_STATE(3056)] = 118655,
  [SMALL_STATE(3057)] = 118664,
  [SMALL_STATE(3058)] = 118673,
  [SMALL_STATE(3059)] = 118686,
  [SMALL_STATE(3060)] = 118695,
  [SMALL_STATE(3061)] = 118704,
  [SMALL_STATE(3062)] = 118715,
  [SMALL_STATE(3063)] = 118728,
  [SMALL_STATE(3064)] = 118737,
  [SMALL_STATE(3065)] = 118746,
  [SMALL_STATE(3066)] = 118755,
  [SMALL_STATE(3067)] = 118764,
  [SMALL_STATE(3068)] = 118773,
  [SMALL_STATE(3069)] = 118786,
  [SMALL_STATE(3070)] = 118795,
  [SMALL_STATE(3071)] = 118808,
  [SMALL_STATE(3072)] = 118817,
  [SMALL_STATE(3073)] = 118828,
  [SMALL_STATE(3074)] = 118837,
  [SMALL_STATE(3075)] = 118846,
  [SMALL_STATE(3076)] = 118859,
  [SMALL_STATE(3077)] = 118872,
  [SMALL_STATE(3078)] = 118885,
  [SMALL_STATE(3079)] = 118898,
  [SMALL_STATE(3080)] = 118911,
  [SMALL_STATE(3081)] = 118924,
  [SMALL_STATE(3082)] = 118935,
  [SMALL_STATE(3083)] = 118948,
  [SMALL_STATE(3084)] = 118961,
  [SMALL_STATE(3085)] = 118970,
  [SMALL_STATE(3086)] = 118983,
  [SMALL_STATE(3087)] = 118994,
  [SMALL_STATE(3088)] = 119007,
  [SMALL_STATE(3089)] = 119020,
  [SMALL_STATE(3090)] = 119033,
  [SMALL_STATE(3091)] = 119046,
  [SMALL_STATE(3092)] = 119055,
  [SMALL_STATE(3093)] = 119068,
  [SMALL_STATE(3094)] = 119077,
  [SMALL_STATE(3095)] = 119090,
  [SMALL_STATE(3096)] = 119103,
  [SMALL_STATE(3097)] = 119116,
  [SMALL_STATE(3098)] = 119127,
  [SMALL_STATE(3099)] = 119140,
  [SMALL_STATE(3100)] = 119153,
  [SMALL_STATE(3101)] = 119162,
  [SMALL_STATE(3102)] = 119175,
  [SMALL_STATE(3103)] = 119188,
  [SMALL_STATE(3104)] = 119199,
  [SMALL_STATE(3105)] = 119212,
  [SMALL_STATE(3106)] = 119225,
  [SMALL_STATE(3107)] = 119238,
  [SMALL_STATE(3108)] = 119251,
  [SMALL_STATE(3109)] = 119260,
  [SMALL_STATE(3110)] = 119273,
  [SMALL_STATE(3111)] = 119282,
  [SMALL_STATE(3112)] = 119295,
  [SMALL_STATE(3113)] = 119304,
  [SMALL_STATE(3114)] = 119317,
  [SMALL_STATE(3115)] = 119330,
  [SMALL_STATE(3116)] = 119343,
  [SMALL_STATE(3117)] = 119352,
  [SMALL_STATE(3118)] = 119365,
  [SMALL_STATE(3119)] = 119378,
  [SMALL_STATE(3120)] = 119387,
  [SMALL_STATE(3121)] = 119400,
  [SMALL_STATE(3122)] = 119411,
  [SMALL_STATE(3123)] = 119424,
  [SMALL_STATE(3124)] = 119437,
  [SMALL_STATE(3125)] = 119450,
  [SMALL_STATE(3126)] = 119463,
  [SMALL_STATE(3127)] = 119476,
  [SMALL_STATE(3128)] = 119489,
  [SMALL_STATE(3129)] = 119502,
  [SMALL_STATE(3130)] = 119511,
  [SMALL_STATE(3131)] = 119524,
  [SMALL_STATE(3132)] = 119533,
  [SMALL_STATE(3133)] = 119546,
  [SMALL_STATE(3134)] = 119559,
  [SMALL_STATE(3135)] = 119570,
  [SMALL_STATE(3136)] = 119581,
  [SMALL_STATE(3137)] = 119594,
  [SMALL_STATE(3138)] = 119607,
  [SMALL_STATE(3139)] = 119618,
  [SMALL_STATE(3140)] = 119631,
  [SMALL_STATE(3141)] = 119644,
  [SMALL_STATE(3142)] = 119657,
  [SMALL_STATE(3143)] = 119670,
  [SMALL_STATE(3144)] = 119683,
  [SMALL_STATE(3145)] = 119696,
  [SMALL_STATE(3146)] = 119709,
  [SMALL_STATE(3147)] = 119722,
  [SMALL_STATE(3148)] = 119735,
  [SMALL_STATE(3149)] = 119748,
  [SMALL_STATE(3150)] = 119757,
  [SMALL_STATE(3151)] = 119770,
  [SMALL_STATE(3152)] = 119779,
  [SMALL_STATE(3153)] = 119792,
  [SMALL_STATE(3154)] = 119805,
  [SMALL_STATE(3155)] = 119818,
  [SMALL_STATE(3156)] = 119831,
  [SMALL_STATE(3157)] = 119841,
  [SMALL_STATE(3158)] = 119851,
  [SMALL_STATE(3159)] = 119861,
  [SMALL_STATE(3160)] = 119871,
  [SMALL_STATE(3161)] = 119881,
  [SMALL_STATE(3162)] = 119891,
  [SMALL_STATE(3163)] = 119901,
  [SMALL_STATE(3164)] = 119911,
  [SMALL_STATE(3165)] = 119921,
  [SMALL_STATE(3166)] = 119931,
  [SMALL_STATE(3167)] = 119941,
  [SMALL_STATE(3168)] = 119951,
  [SMALL_STATE(3169)] = 119961,
  [SMALL_STATE(3170)] = 119971,
  [SMALL_STATE(3171)] = 119981,
  [SMALL_STATE(3172)] = 119991,
  [SMALL_STATE(3173)] = 120001,
  [SMALL_STATE(3174)] = 120011,
  [SMALL_STATE(3175)] = 120021,
  [SMALL_STATE(3176)] = 120031,
  [SMALL_STATE(3177)] = 120041,
  [SMALL_STATE(3178)] = 120049,
  [SMALL_STATE(3179)] = 120059,
  [SMALL_STATE(3180)] = 120067,
  [SMALL_STATE(3181)] = 120075,
  [SMALL_STATE(3182)] = 120085,
  [SMALL_STATE(3183)] = 120095,
  [SMALL_STATE(3184)] = 120105,
  [SMALL_STATE(3185)] = 120113,
  [SMALL_STATE(3186)] = 120121,
  [SMALL_STATE(3187)] = 120131,
  [SMALL_STATE(3188)] = 120139,
  [SMALL_STATE(3189)] = 120149,
  [SMALL_STATE(3190)] = 120159,
  [SMALL_STATE(3191)] = 120167,
  [SMALL_STATE(3192)] = 120177,
  [SMALL_STATE(3193)] = 120187,
  [SMALL_STATE(3194)] = 120197,
  [SMALL_STATE(3195)] = 120207,
  [SMALL_STATE(3196)] = 120217,
  [SMALL_STATE(3197)] = 120227,
  [SMALL_STATE(3198)] = 120235,
  [SMALL_STATE(3199)] = 120245,
  [SMALL_STATE(3200)] = 120255,
  [SMALL_STATE(3201)] = 120265,
  [SMALL_STATE(3202)] = 120275,
  [SMALL_STATE(3203)] = 120285,
  [SMALL_STATE(3204)] = 120295,
  [SMALL_STATE(3205)] = 120303,
  [SMALL_STATE(3206)] = 120313,
  [SMALL_STATE(3207)] = 120323,
  [SMALL_STATE(3208)] = 120331,
  [SMALL_STATE(3209)] = 120341,
  [SMALL_STATE(3210)] = 120349,
  [SMALL_STATE(3211)] = 120357,
  [SMALL_STATE(3212)] = 120367,
  [SMALL_STATE(3213)] = 120377,
  [SMALL_STATE(3214)] = 120387,
  [SMALL_STATE(3215)] = 120397,
  [SMALL_STATE(3216)] = 120407,
  [SMALL_STATE(3217)] = 120417,
  [SMALL_STATE(3218)] = 120427,
  [SMALL_STATE(3219)] = 120437,
  [SMALL_STATE(3220)] = 120447,
  [SMALL_STATE(3221)] = 120455,
  [SMALL_STATE(3222)] = 120463,
  [SMALL_STATE(3223)] = 120473,
  [SMALL_STATE(3224)] = 120483,
  [SMALL_STATE(3225)] = 120493,
  [SMALL_STATE(3226)] = 120501,
  [SMALL_STATE(3227)] = 120511,
  [SMALL_STATE(3228)] = 120521,
  [SMALL_STATE(3229)] = 120531,
  [SMALL_STATE(3230)] = 120541,
  [SMALL_STATE(3231)] = 120549,
  [SMALL_STATE(3232)] = 120559,
  [SMALL_STATE(3233)] = 120569,
  [SMALL_STATE(3234)] = 120577,
  [SMALL_STATE(3235)] = 120587,
  [SMALL_STATE(3236)] = 120597,
  [SMALL_STATE(3237)] = 120607,
  [SMALL_STATE(3238)] = 120615,
  [SMALL_STATE(3239)] = 120625,
  [SMALL_STATE(3240)] = 120635,
  [SMALL_STATE(3241)] = 120645,
  [SMALL_STATE(3242)] = 120655,
  [SMALL_STATE(3243)] = 120663,
  [SMALL_STATE(3244)] = 120673,
  [SMALL_STATE(3245)] = 120683,
  [SMALL_STATE(3246)] = 120693,
  [SMALL_STATE(3247)] = 120703,
  [SMALL_STATE(3248)] = 120713,
  [SMALL_STATE(3249)] = 120723,
  [SMALL_STATE(3250)] = 120731,
  [SMALL_STATE(3251)] = 120741,
  [SMALL_STATE(3252)] = 120751,
  [SMALL_STATE(3253)] = 120761,
  [SMALL_STATE(3254)] = 120769,
  [SMALL_STATE(3255)] = 120779,
  [SMALL_STATE(3256)] = 120787,
  [SMALL_STATE(3257)] = 120797,
  [SMALL_STATE(3258)] = 120807,
  [SMALL_STATE(3259)] = 120817,
  [SMALL_STATE(3260)] = 120827,
  [SMALL_STATE(3261)] = 120837,
  [SMALL_STATE(3262)] = 120845,
  [SMALL_STATE(3263)] = 120855,
  [SMALL_STATE(3264)] = 120863,
  [SMALL_STATE(3265)] = 120873,
  [SMALL_STATE(3266)] = 120883,
  [SMALL_STATE(3267)] = 120893,
  [SMALL_STATE(3268)] = 120903,
  [SMALL_STATE(3269)] = 120913,
  [SMALL_STATE(3270)] = 120923,
  [SMALL_STATE(3271)] = 120931,
  [SMALL_STATE(3272)] = 120939,
  [SMALL_STATE(3273)] = 120947,
  [SMALL_STATE(3274)] = 120955,
  [SMALL_STATE(3275)] = 120965,
  [SMALL_STATE(3276)] = 120975,
  [SMALL_STATE(3277)] = 120985,
  [SMALL_STATE(3278)] = 120995,
  [SMALL_STATE(3279)] = 121005,
  [SMALL_STATE(3280)] = 121013,
  [SMALL_STATE(3281)] = 121023,
  [SMALL_STATE(3282)] = 121031,
  [SMALL_STATE(3283)] = 121041,
  [SMALL_STATE(3284)] = 121051,
  [SMALL_STATE(3285)] = 121061,
  [SMALL_STATE(3286)] = 121069,
  [SMALL_STATE(3287)] = 121079,
  [SMALL_STATE(3288)] = 121089,
  [SMALL_STATE(3289)] = 121097,
  [SMALL_STATE(3290)] = 121107,
  [SMALL_STATE(3291)] = 121115,
  [SMALL_STATE(3292)] = 121125,
  [SMALL_STATE(3293)] = 121135,
  [SMALL_STATE(3294)] = 121145,
  [SMALL_STATE(3295)] = 121155,
  [SMALL_STATE(3296)] = 121165,
  [SMALL_STATE(3297)] = 121175,
  [SMALL_STATE(3298)] = 121185,
  [SMALL_STATE(3299)] = 121195,
  [SMALL_STATE(3300)] = 121205,
  [SMALL_STATE(3301)] = 121213,
  [SMALL_STATE(3302)] = 121221,
  [SMALL_STATE(3303)] = 121229,
  [SMALL_STATE(3304)] = 121239,
  [SMALL_STATE(3305)] = 121249,
  [SMALL_STATE(3306)] = 121259,
  [SMALL_STATE(3307)] = 121267,
  [SMALL_STATE(3308)] = 121277,
  [SMALL_STATE(3309)] = 121287,
  [SMALL_STATE(3310)] = 121295,
  [SMALL_STATE(3311)] = 121303,
  [SMALL_STATE(3312)] = 121311,
  [SMALL_STATE(3313)] = 121319,
  [SMALL_STATE(3314)] = 121329,
  [SMALL_STATE(3315)] = 121337,
  [SMALL_STATE(3316)] = 121347,
  [SMALL_STATE(3317)] = 121357,
  [SMALL_STATE(3318)] = 121367,
  [SMALL_STATE(3319)] = 121377,
  [SMALL_STATE(3320)] = 121385,
  [SMALL_STATE(3321)] = 121395,
  [SMALL_STATE(3322)] = 121403,
  [SMALL_STATE(3323)] = 121413,
  [SMALL_STATE(3324)] = 121423,
  [SMALL_STATE(3325)] = 121433,
  [SMALL_STATE(3326)] = 121441,
  [SMALL_STATE(3327)] = 121451,
  [SMALL_STATE(3328)] = 121461,
  [SMALL_STATE(3329)] = 121469,
  [SMALL_STATE(3330)] = 121479,
  [SMALL_STATE(3331)] = 121489,
  [SMALL_STATE(3332)] = 121499,
  [SMALL_STATE(3333)] = 121509,
  [SMALL_STATE(3334)] = 121519,
  [SMALL_STATE(3335)] = 121527,
  [SMALL_STATE(3336)] = 121535,
  [SMALL_STATE(3337)] = 121543,
  [SMALL_STATE(3338)] = 121553,
  [SMALL_STATE(3339)] = 121563,
  [SMALL_STATE(3340)] = 121573,
  [SMALL_STATE(3341)] = 121583,
  [SMALL_STATE(3342)] = 121593,
  [SMALL_STATE(3343)] = 121603,
  [SMALL_STATE(3344)] = 121613,
  [SMALL_STATE(3345)] = 121623,
  [SMALL_STATE(3346)] = 121633,
  [SMALL_STATE(3347)] = 121643,
  [SMALL_STATE(3348)] = 121651,
  [SMALL_STATE(3349)] = 121661,
  [SMALL_STATE(3350)] = 121671,
  [SMALL_STATE(3351)] = 121681,
  [SMALL_STATE(3352)] = 121691,
  [SMALL_STATE(3353)] = 121701,
  [SMALL_STATE(3354)] = 121711,
  [SMALL_STATE(3355)] = 121721,
  [SMALL_STATE(3356)] = 121731,
  [SMALL_STATE(3357)] = 121741,
  [SMALL_STATE(3358)] = 121751,
  [SMALL_STATE(3359)] = 121761,
  [SMALL_STATE(3360)] = 121771,
  [SMALL_STATE(3361)] = 121781,
  [SMALL_STATE(3362)] = 121791,
  [SMALL_STATE(3363)] = 121799,
  [SMALL_STATE(3364)] = 121809,
  [SMALL_STATE(3365)] = 121817,
  [SMALL_STATE(3366)] = 121827,
  [SMALL_STATE(3367)] = 121837,
  [SMALL_STATE(3368)] = 121847,
  [SMALL_STATE(3369)] = 121857,
  [SMALL_STATE(3370)] = 121867,
  [SMALL_STATE(3371)] = 121877,
  [SMALL_STATE(3372)] = 121887,
  [SMALL_STATE(3373)] = 121897,
  [SMALL_STATE(3374)] = 121907,
  [SMALL_STATE(3375)] = 121917,
  [SMALL_STATE(3376)] = 121927,
  [SMALL_STATE(3377)] = 121935,
  [SMALL_STATE(3378)] = 121945,
  [SMALL_STATE(3379)] = 121955,
  [SMALL_STATE(3380)] = 121963,
  [SMALL_STATE(3381)] = 121973,
  [SMALL_STATE(3382)] = 121983,
  [SMALL_STATE(3383)] = 121993,
  [SMALL_STATE(3384)] = 122003,
  [SMALL_STATE(3385)] = 122013,
  [SMALL_STATE(3386)] = 122023,
  [SMALL_STATE(3387)] = 122033,
  [SMALL_STATE(3388)] = 122043,
  [SMALL_STATE(3389)] = 122053,
  [SMALL_STATE(3390)] = 122063,
  [SMALL_STATE(3391)] = 122071,
  [SMALL_STATE(3392)] = 122081,
  [SMALL_STATE(3393)] = 122089,
  [SMALL_STATE(3394)] = 122099,
  [SMALL_STATE(3395)] = 122109,
  [SMALL_STATE(3396)] = 122119,
  [SMALL_STATE(3397)] = 122129,
  [SMALL_STATE(3398)] = 122136,
  [SMALL_STATE(3399)] = 122143,
  [SMALL_STATE(3400)] = 122150,
  [SMALL_STATE(3401)] = 122157,
  [SMALL_STATE(3402)] = 122164,
  [SMALL_STATE(3403)] = 122171,
  [SMALL_STATE(3404)] = 122178,
  [SMALL_STATE(3405)] = 122185,
  [SMALL_STATE(3406)] = 122192,
  [SMALL_STATE(3407)] = 122199,
  [SMALL_STATE(3408)] = 122206,
  [SMALL_STATE(3409)] = 122213,
  [SMALL_STATE(3410)] = 122220,
  [SMALL_STATE(3411)] = 122227,
  [SMALL_STATE(3412)] = 122234,
  [SMALL_STATE(3413)] = 122241,
  [SMALL_STATE(3414)] = 122248,
  [SMALL_STATE(3415)] = 122255,
  [SMALL_STATE(3416)] = 122262,
  [SMALL_STATE(3417)] = 122269,
  [SMALL_STATE(3418)] = 122276,
  [SMALL_STATE(3419)] = 122283,
  [SMALL_STATE(3420)] = 122290,
  [SMALL_STATE(3421)] = 122297,
  [SMALL_STATE(3422)] = 122304,
  [SMALL_STATE(3423)] = 122311,
  [SMALL_STATE(3424)] = 122318,
  [SMALL_STATE(3425)] = 122325,
  [SMALL_STATE(3426)] = 122332,
  [SMALL_STATE(3427)] = 122339,
  [SMALL_STATE(3428)] = 122346,
  [SMALL_STATE(3429)] = 122353,
  [SMALL_STATE(3430)] = 122360,
  [SMALL_STATE(3431)] = 122367,
  [SMALL_STATE(3432)] = 122374,
  [SMALL_STATE(3433)] = 122381,
  [SMALL_STATE(3434)] = 122388,
  [SMALL_STATE(3435)] = 122395,
  [SMALL_STATE(3436)] = 122402,
  [SMALL_STATE(3437)] = 122409,
  [SMALL_STATE(3438)] = 122416,
  [SMALL_STATE(3439)] = 122423,
  [SMALL_STATE(3440)] = 122430,
  [SMALL_STATE(3441)] = 122437,
  [SMALL_STATE(3442)] = 122444,
  [SMALL_STATE(3443)] = 122451,
  [SMALL_STATE(3444)] = 122458,
  [SMALL_STATE(3445)] = 122465,
  [SMALL_STATE(3446)] = 122472,
  [SMALL_STATE(3447)] = 122479,
  [SMALL_STATE(3448)] = 122486,
  [SMALL_STATE(3449)] = 122493,
  [SMALL_STATE(3450)] = 122500,
  [SMALL_STATE(3451)] = 122507,
  [SMALL_STATE(3452)] = 122514,
  [SMALL_STATE(3453)] = 122521,
  [SMALL_STATE(3454)] = 122528,
  [SMALL_STATE(3455)] = 122535,
  [SMALL_STATE(3456)] = 122542,
  [SMALL_STATE(3457)] = 122549,
  [SMALL_STATE(3458)] = 122556,
  [SMALL_STATE(3459)] = 122563,
  [SMALL_STATE(3460)] = 122570,
  [SMALL_STATE(3461)] = 122577,
  [SMALL_STATE(3462)] = 122584,
  [SMALL_STATE(3463)] = 122591,
  [SMALL_STATE(3464)] = 122598,
  [SMALL_STATE(3465)] = 122605,
  [SMALL_STATE(3466)] = 122612,
  [SMALL_STATE(3467)] = 122619,
  [SMALL_STATE(3468)] = 122626,
  [SMALL_STATE(3469)] = 122633,
  [SMALL_STATE(3470)] = 122640,
  [SMALL_STATE(3471)] = 122647,
  [SMALL_STATE(3472)] = 122654,
  [SMALL_STATE(3473)] = 122661,
  [SMALL_STATE(3474)] = 122668,
  [SMALL_STATE(3475)] = 122675,
  [SMALL_STATE(3476)] = 122682,
  [SMALL_STATE(3477)] = 122689,
  [SMALL_STATE(3478)] = 122696,
  [SMALL_STATE(3479)] = 122703,
  [SMALL_STATE(3480)] = 122710,
  [SMALL_STATE(3481)] = 122717,
  [SMALL_STATE(3482)] = 122724,
  [SMALL_STATE(3483)] = 122731,
  [SMALL_STATE(3484)] = 122738,
  [SMALL_STATE(3485)] = 122745,
  [SMALL_STATE(3486)] = 122752,
  [SMALL_STATE(3487)] = 122759,
  [SMALL_STATE(3488)] = 122766,
  [SMALL_STATE(3489)] = 122773,
  [SMALL_STATE(3490)] = 122780,
  [SMALL_STATE(3491)] = 122787,
  [SMALL_STATE(3492)] = 122794,
  [SMALL_STATE(3493)] = 122801,
  [SMALL_STATE(3494)] = 122808,
  [SMALL_STATE(3495)] = 122815,
  [SMALL_STATE(3496)] = 122822,
  [SMALL_STATE(3497)] = 122829,
  [SMALL_STATE(3498)] = 122836,
  [SMALL_STATE(3499)] = 122843,
  [SMALL_STATE(3500)] = 122850,
  [SMALL_STATE(3501)] = 122857,
  [SMALL_STATE(3502)] = 122864,
  [SMALL_STATE(3503)] = 122871,
  [SMALL_STATE(3504)] = 122878,
  [SMALL_STATE(3505)] = 122885,
  [SMALL_STATE(3506)] = 122892,
  [SMALL_STATE(3507)] = 122899,
  [SMALL_STATE(3508)] = 122906,
  [SMALL_STATE(3509)] = 122913,
  [SMALL_STATE(3510)] = 122920,
  [SMALL_STATE(3511)] = 122927,
  [SMALL_STATE(3512)] = 122934,
  [SMALL_STATE(3513)] = 122941,
  [SMALL_STATE(3514)] = 122948,
  [SMALL_STATE(3515)] = 122955,
  [SMALL_STATE(3516)] = 122962,
  [SMALL_STATE(3517)] = 122969,
  [SMALL_STATE(3518)] = 122976,
  [SMALL_STATE(3519)] = 122983,
  [SMALL_STATE(3520)] = 122990,
  [SMALL_STATE(3521)] = 122997,
  [SMALL_STATE(3522)] = 123004,
  [SMALL_STATE(3523)] = 123011,
  [SMALL_STATE(3524)] = 123018,
  [SMALL_STATE(3525)] = 123025,
  [SMALL_STATE(3526)] = 123032,
  [SMALL_STATE(3527)] = 123039,
  [SMALL_STATE(3528)] = 123046,
  [SMALL_STATE(3529)] = 123053,
  [SMALL_STATE(3530)] = 123060,
  [SMALL_STATE(3531)] = 123067,
  [SMALL_STATE(3532)] = 123074,
  [SMALL_STATE(3533)] = 123081,
  [SMALL_STATE(3534)] = 123088,
  [SMALL_STATE(3535)] = 123095,
  [SMALL_STATE(3536)] = 123102,
  [SMALL_STATE(3537)] = 123109,
  [SMALL_STATE(3538)] = 123116,
  [SMALL_STATE(3539)] = 123123,
  [SMALL_STATE(3540)] = 123130,
  [SMALL_STATE(3541)] = 123137,
  [SMALL_STATE(3542)] = 123144,
  [SMALL_STATE(3543)] = 123151,
  [SMALL_STATE(3544)] = 123158,
  [SMALL_STATE(3545)] = 123165,
  [SMALL_STATE(3546)] = 123172,
  [SMALL_STATE(3547)] = 123179,
  [SMALL_STATE(3548)] = 123186,
  [SMALL_STATE(3549)] = 123193,
  [SMALL_STATE(3550)] = 123200,
  [SMALL_STATE(3551)] = 123207,
  [SMALL_STATE(3552)] = 123214,
  [SMALL_STATE(3553)] = 123221,
  [SMALL_STATE(3554)] = 123228,
  [SMALL_STATE(3555)] = 123235,
  [SMALL_STATE(3556)] = 123242,
  [SMALL_STATE(3557)] = 123249,
  [SMALL_STATE(3558)] = 123256,
  [SMALL_STATE(3559)] = 123263,
  [SMALL_STATE(3560)] = 123270,
  [SMALL_STATE(3561)] = 123277,
  [SMALL_STATE(3562)] = 123284,
  [SMALL_STATE(3563)] = 123291,
  [SMALL_STATE(3564)] = 123298,
  [SMALL_STATE(3565)] = 123305,
  [SMALL_STATE(3566)] = 123312,
  [SMALL_STATE(3567)] = 123319,
  [SMALL_STATE(3568)] = 123326,
  [SMALL_STATE(3569)] = 123333,
  [SMALL_STATE(3570)] = 123340,
  [SMALL_STATE(3571)] = 123347,
  [SMALL_STATE(3572)] = 123354,
  [SMALL_STATE(3573)] = 123361,
  [SMALL_STATE(3574)] = 123368,
  [SMALL_STATE(3575)] = 123375,
  [SMALL_STATE(3576)] = 123382,
  [SMALL_STATE(3577)] = 123389,
  [SMALL_STATE(3578)] = 123396,
  [SMALL_STATE(3579)] = 123403,
  [SMALL_STATE(3580)] = 123410,
  [SMALL_STATE(3581)] = 123417,
  [SMALL_STATE(3582)] = 123424,
  [SMALL_STATE(3583)] = 123431,
  [SMALL_STATE(3584)] = 123438,
  [SMALL_STATE(3585)] = 123445,
  [SMALL_STATE(3586)] = 123452,
  [SMALL_STATE(3587)] = 123459,
  [SMALL_STATE(3588)] = 123466,
  [SMALL_STATE(3589)] = 123473,
  [SMALL_STATE(3590)] = 123480,
  [SMALL_STATE(3591)] = 123487,
  [SMALL_STATE(3592)] = 123494,
  [SMALL_STATE(3593)] = 123501,
  [SMALL_STATE(3594)] = 123508,
  [SMALL_STATE(3595)] = 123515,
  [SMALL_STATE(3596)] = 123522,
  [SMALL_STATE(3597)] = 123529,
  [SMALL_STATE(3598)] = 123536,
  [SMALL_STATE(3599)] = 123543,
  [SMALL_STATE(3600)] = 123550,
  [SMALL_STATE(3601)] = 123557,
  [SMALL_STATE(3602)] = 123564,
  [SMALL_STATE(3603)] = 123571,
  [SMALL_STATE(3604)] = 123578,
  [SMALL_STATE(3605)] = 123585,
  [SMALL_STATE(3606)] = 123592,
  [SMALL_STATE(3607)] = 123599,
  [SMALL_STATE(3608)] = 123606,
  [SMALL_STATE(3609)] = 123613,
  [SMALL_STATE(3610)] = 123620,
  [SMALL_STATE(3611)] = 123627,
  [SMALL_STATE(3612)] = 123634,
  [SMALL_STATE(3613)] = 123641,
  [SMALL_STATE(3614)] = 123648,
  [SMALL_STATE(3615)] = 123655,
  [SMALL_STATE(3616)] = 123662,
  [SMALL_STATE(3617)] = 123669,
  [SMALL_STATE(3618)] = 123676,
  [SMALL_STATE(3619)] = 123683,
  [SMALL_STATE(3620)] = 123690,
  [SMALL_STATE(3621)] = 123697,
  [SMALL_STATE(3622)] = 123704,
  [SMALL_STATE(3623)] = 123711,
  [SMALL_STATE(3624)] = 123718,
  [SMALL_STATE(3625)] = 123725,
  [SMALL_STATE(3626)] = 123732,
  [SMALL_STATE(3627)] = 123739,
  [SMALL_STATE(3628)] = 123746,
  [SMALL_STATE(3629)] = 123753,
  [SMALL_STATE(3630)] = 123760,
  [SMALL_STATE(3631)] = 123767,
  [SMALL_STATE(3632)] = 123774,
  [SMALL_STATE(3633)] = 123781,
  [SMALL_STATE(3634)] = 123788,
  [SMALL_STATE(3635)] = 123795,
  [SMALL_STATE(3636)] = 123802,
  [SMALL_STATE(3637)] = 123809,
  [SMALL_STATE(3638)] = 123816,
  [SMALL_STATE(3639)] = 123823,
  [SMALL_STATE(3640)] = 123830,
  [SMALL_STATE(3641)] = 123837,
  [SMALL_STATE(3642)] = 123844,
  [SMALL_STATE(3643)] = 123851,
  [SMALL_STATE(3644)] = 123858,
  [SMALL_STATE(3645)] = 123865,
  [SMALL_STATE(3646)] = 123872,
  [SMALL_STATE(3647)] = 123879,
  [SMALL_STATE(3648)] = 123886,
  [SMALL_STATE(3649)] = 123893,
  [SMALL_STATE(3650)] = 123900,
  [SMALL_STATE(3651)] = 123907,
  [SMALL_STATE(3652)] = 123914,
  [SMALL_STATE(3653)] = 123921,
  [SMALL_STATE(3654)] = 123928,
  [SMALL_STATE(3655)] = 123935,
  [SMALL_STATE(3656)] = 123942,
  [SMALL_STATE(3657)] = 123949,
  [SMALL_STATE(3658)] = 123956,
  [SMALL_STATE(3659)] = 123963,
  [SMALL_STATE(3660)] = 123970,
  [SMALL_STATE(3661)] = 123977,
  [SMALL_STATE(3662)] = 123984,
  [SMALL_STATE(3663)] = 123991,
  [SMALL_STATE(3664)] = 123998,
  [SMALL_STATE(3665)] = 124005,
  [SMALL_STATE(3666)] = 124012,
  [SMALL_STATE(3667)] = 124019,
  [SMALL_STATE(3668)] = 124026,
  [SMALL_STATE(3669)] = 124033,
  [SMALL_STATE(3670)] = 124040,
  [SMALL_STATE(3671)] = 124047,
  [SMALL_STATE(3672)] = 124054,
  [SMALL_STATE(3673)] = 124061,
  [SMALL_STATE(3674)] = 124068,
  [SMALL_STATE(3675)] = 124075,
  [SMALL_STATE(3676)] = 124082,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2509),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2478),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3166),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3168),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3137),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3171),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3172),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3175),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3135),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3134),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3656),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2378),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1569),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3643),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3627),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3626),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(943),
  [202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(174),
  [205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(669),
  [210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(777),
  [216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(278),
  [219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1023),
  [222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2509),
  [225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2478),
  [228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2301),
  [231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(286),
  [234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3166),
  [237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3168),
  [240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3137),
  [243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(120),
  [246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(288),
  [249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3171),
  [252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(56),
  [255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3172),
  [258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3175),
  [261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3135),
  [264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3134),
  [267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3177),
  [270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(177),
  [273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(183),
  [276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(545),
  [279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(69),
  [282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(145),
  [285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2529),
  [288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3656),
  [291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2154),
  [294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(490),
  [297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2378),
  [300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(202),
  [303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(290),
  [306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(293),
  [309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2932),
  [312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2926),
  [315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2527),
  [318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1569),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1569),
  [324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3127),
  [327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(939),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3643),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(224),
  [336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(665),
  [339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3627),
  [342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3626),
  [345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 83),
  [351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 83),
  [353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3),
  [355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 83),
  [359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 83),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3174),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3111),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3211),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3208),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2319),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3161),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3152),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3162),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3163),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3668),
  [477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2373),
  [483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2434),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1613),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3414),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2463),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1532),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3435),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2529),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2653),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 1), SHIFT(281),
  [860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2819),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3289),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3508),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2820),
  [883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, .production_id = 1),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3524),
  [893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2520),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2823),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3587),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, .production_id = 5),
  [985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, .production_id = 5),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3487),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 169),
  [1001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 169),
  [1003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, .production_id = 169),
  [1005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, .production_id = 169),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [1009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 146),
  [1011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 146),
  [1013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 146),
  [1015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 146),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 166),
  [1021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 166),
  [1023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 166),
  [1025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 166),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [1029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 139),
  [1031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 139),
  [1033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 139),
  [1035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 139),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 1),
  [1041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration, 1),
  [1043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [1045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [1047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [1053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [1061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [1063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 101),
  [1065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 101),
  [1067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 101),
  [1069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 101),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 102),
  [1075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 102),
  [1077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 102),
  [1079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 102),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [1083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 51),
  [1085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 51),
  [1087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 51),
  [1089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 51),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [1093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [1095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [1097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, .production_id = 28),
  [1099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, .production_id = 28),
  [1101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 135),
  [1103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 135),
  [1105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 135),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 135),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2869),
  [1115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 139),
  [1117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 139),
  [1119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 139),
  [1121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 139),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [1125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 145),
  [1127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 145),
  [1129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 145),
  [1131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 145),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [1135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 116),
  [1137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 116),
  [1139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 116),
  [1141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 116),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [1145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [1147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [1149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 110),
  [1151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 110),
  [1153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 110),
  [1155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 110),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3484),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1),
  [1231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [1245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3216),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3597),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [1275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(54),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [1304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [1306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [1316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [1338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [1340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [1342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [1344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [1346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [1348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [1350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [1354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [1356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [1362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [1364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [1366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [1368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [1378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [1382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [1400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [1402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [1404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3525),
  [1406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [1410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [1412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [1414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [1416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [1418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3452),
  [1420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [1422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [1426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [1428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [1430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [1432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [1434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [1436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [1438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [1440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [1442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3459),
  [1444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [1446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [1450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [1452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [1454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [1456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [1458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [1460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [1462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [1464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [1466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [1468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [1470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [1472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [1474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [1476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [1478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [1480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [1482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [1484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [1486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [1488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [1490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [1492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [1494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2313),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [1498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [1502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [1510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [1514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [1518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2847),
  [1522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2943),
  [1524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(2001),
  [1527] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1856),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1533] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(3289),
  [1537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2329),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [1543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 136),
  [1545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 136),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2),
  [1549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2),
  [1551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [1553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [1555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [1557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [1559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [1561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [1563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [1565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [1567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4),
  [1569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [1573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [1577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [1579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 4),
  [1583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 4),
  [1585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [1587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [1589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 2, .production_id = 52),
  [1591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 2, .production_id = 52),
  [1593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [1595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [1597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5),
  [1599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5),
  [1601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2),
  [1603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2),
  [1605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [1607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [1609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2),
  [1611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2),
  [1613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_body, 2),
  [1615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tuple_type_body, 2),
  [1617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6),
  [1619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6),
  [1621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2),
  [1623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2),
  [1625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5),
  [1627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5),
  [1629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1),
  [1631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1),
  [1633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4),
  [1635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4),
  [1637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [1639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [1641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_body, 3),
  [1643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tuple_type_body, 3),
  [1645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1),
  [1647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1),
  [1649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4),
  [1651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4),
  [1653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3),
  [1655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3),
  [1657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [1659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [1661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, .production_id = 8),
  [1663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, .production_id = 8),
  [1665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3),
  [1667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3),
  [1669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_body, 4),
  [1671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tuple_type_body, 4),
  [1673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 1),
  [1675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 1),
  [1677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2),
  [1679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2461),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3521),
  [1691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [1693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [1695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [1701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2365),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2540),
  [1707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [1717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [1719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [1721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [1723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3471),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3488),
  [1727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [1729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1),
  [1731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3595),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3594),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3457),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3458),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [1747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1856),
  [1750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(3289),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3455),
  [1755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3460),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [1759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [1761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [1763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(915),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3464),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3665),
  [1770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(257),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [1775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2, .production_id = 52),
  [1777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2, .production_id = 52),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3485),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3483),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2628),
  [1785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [1794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 1),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1),
  [1800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1),
  [1802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1), SHIFT(915),
  [1805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 136),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [1812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3148),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4),
  [1826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [1832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 6, .production_id = 168),
  [1836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 6, .production_id = 168),
  [1838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, .production_id = 204),
  [1840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, .production_id = 204),
  [1842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [1844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3),
  [1846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [1850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 44),
  [1852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 44),
  [1854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(207),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [1859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3431),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 178),
  [1865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 178),
  [1867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [1869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [1871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 180),
  [1873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 180),
  [1875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 179),
  [1877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 179),
  [1879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 36),
  [1881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 36),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [1885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [1887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [1889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [1891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [1893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 144),
  [1895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 144),
  [1897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 75),
  [1899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 75),
  [1901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 51),
  [1903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 51),
  [1905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 139),
  [1907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 139),
  [1909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 45),
  [1911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 45),
  [1913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 64),
  [1915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 64),
  [1917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3),
  [1919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3),
  [1921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 116),
  [1923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 116),
  [1925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 46),
  [1927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 46),
  [1929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 47),
  [1931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 47),
  [1933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 47),
  [1935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 47),
  [1937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [1939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [1941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 109),
  [1943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 109),
  [1945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 135),
  [1947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 135),
  [1949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 115),
  [1951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 115),
  [1953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [1955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [1957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 101),
  [1959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 101),
  [1961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 102),
  [1963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 102),
  [1965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2),
  [1967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2),
  [1969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [1971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [1973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [1975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [1977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 89),
  [1979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 89),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [1983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [1985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [1987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [1989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 88),
  [1991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 88),
  [1993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4),
  [1995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4),
  [1997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [1999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3),
  [2003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3),
  [2005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [2007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [2009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 51),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 51),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5),
  [2015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [2019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 177),
  [2023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 177),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4),
  [2027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 167),
  [2031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 167),
  [2033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 139),
  [2035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 139),
  [2037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 43),
  [2039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 43),
  [2041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [2043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [2045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, .production_id = 138),
  [2051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, .production_id = 138),
  [2053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [2055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [2057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 123),
  [2059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 123),
  [2061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 37),
  [2063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 37),
  [2065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, .production_id = 124),
  [2067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, .production_id = 124),
  [2069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5),
  [2071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5),
  [2073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 148),
  [2075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 148),
  [2077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [2079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [2081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [2083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [2085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [2087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [2089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 135),
  [2091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 135),
  [2093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 171),
  [2095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 171),
  [2097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 73),
  [2099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 73),
  [2101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [2103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [2105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 151),
  [2107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 151),
  [2109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 154),
  [2111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 154),
  [2113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 110),
  [2115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 110),
  [2117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 166),
  [2119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 166),
  [2121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 101),
  [2123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 101),
  [2125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5),
  [2127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5),
  [2129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 95),
  [2131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 95),
  [2133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 76),
  [2135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 76),
  [2137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 38),
  [2143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 38),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 170),
  [2147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 170),
  [2149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2),
  [2151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2),
  [2153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, .production_id = 6),
  [2155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, .production_id = 6),
  [2157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 146),
  [2159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 146),
  [2161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [2163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [2165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 90),
  [2167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 90),
  [2169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 128),
  [2171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 128),
  [2173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 141),
  [2175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 141),
  [2177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 142),
  [2179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 142),
  [2181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 102),
  [2183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 102),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [2187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [2189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 169),
  [2191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 169),
  [2193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 145),
  [2195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 145),
  [2197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 189),
  [2199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 189),
  [2201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 153),
  [2207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 153),
  [2209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 155),
  [2211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 155),
  [2213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 156),
  [2215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 156),
  [2217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4),
  [2219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4),
  [2221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 176),
  [2223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 176),
  [2225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 175),
  [2227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 175),
  [2229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 174),
  [2231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 174),
  [2233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 173),
  [2235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 173),
  [2237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 152),
  [2239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 152),
  [2241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [2245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [2257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2885),
  [2265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [2267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [2269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 39),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [2273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [2275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [2277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [2285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1),
  [2287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [2289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [2291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3235),
  [2293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(206),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [2302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 113),
  [2304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 113),
  [2306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3092),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [2310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [2313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(895),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [2320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [2323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2),
  [2325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2),
  [2327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 60),
  [2329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 60),
  [2331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 60), REDUCE(sym_nested_type_identifier, 3, .production_id = 136),
  [2334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 60), REDUCE(sym_nested_type_identifier, 3, .production_id = 136),
  [2337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 60),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [2342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 25),
  [2344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 25),
  [2346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 140),
  [2348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 140),
  [2350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 60),
  [2353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(915),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [2358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 121),
  [2360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 121),
  [2362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 77),
  [2364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 77),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [2368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [2382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [2386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [2390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [2392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2936),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [2398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2841),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [2408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [2412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [2414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [2416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [2418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3671),
  [2420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [2424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [2426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [2428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2825),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2835),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [2448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [2450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [2452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3392),
  [2454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [2456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3314),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [2464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [2466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2821),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [2472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2807),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [2482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2278),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [2490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [2492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [2494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [2498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3536),
  [2500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [2504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [2508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [2510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2909),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [2516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2808),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3576),
  [2526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [2530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [2532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [2534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [2536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3584),
  [2538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2397),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [2544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [2554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [2558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2930),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [2566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [2576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [2582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [2584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [2586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3463),
  [2588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [2596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2886),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [2600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [2602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2390),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [2612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [2620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, .production_id = 52),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [2634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [2636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [2650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [2652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2939),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [2658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [2660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [2662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [2664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [2678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [2686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [2702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1), SHIFT(311),
  [2705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [2708] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [2714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [2741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [2751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [2753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [2757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [2759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1760),
  [2761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [2763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [2765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [2777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2127),
  [2779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [2783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [2785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [2787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [2789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [2791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [2801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 2, .production_id = 52),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(885),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [2810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [2814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2830),
  [2816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [2818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [2820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [2822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2864),
  [2824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2410),
  [2834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [2836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2275),
  [2838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [2840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [2846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [2848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2826),
  [2850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [2852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2804),
  [2854] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2809),
  [2860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 52),
  [2862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 52),
  [2864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(266),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [2873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__rest_identifier, 2),
  [2876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rest_identifier, 2),
  [2878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [2880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [2884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1),
  [2886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__tuple_type_identifier, 1),
  [2889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_identifier, 1),
  [2891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(3023),
  [2894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [2896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [2898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [2902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1812),
  [2904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [2906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [2908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [2910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3087),
  [2918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [2920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [2924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [2926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [2934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3473),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [2938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [2958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [2964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [2966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [2968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [2970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [2972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [2974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [2978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [2982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [2984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [2986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [2988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [2992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [2994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [2996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [2998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [3000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [3002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 29),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [3043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [3045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [3047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [3053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 29),
  [3055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 29),
  [3057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [3059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [3061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(924),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [3066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(924),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [3071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 29),
  [3073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 29),
  [3075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [3077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [3079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [3081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [3083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [3085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [3087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym__tuple_type_body, 2),
  [3090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym__tuple_type_body, 2),
  [3093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [3097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [3099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 65),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [3105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [3107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [3115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [3125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 63),
  [3127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [3131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [3135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(62),
  [3138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3),
  [3140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3),
  [3142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [3144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [3148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [3150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 62),
  [3152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [3154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [3156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [3158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [3168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [3171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [3174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [3176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 9),
  [3178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(205),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [3183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 68),
  [3185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 69),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [3191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 71),
  [3193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 62),
  [3195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 59),
  [3197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 59),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [3201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [3203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 57),
  [3205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 57),
  [3207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 105),
  [3209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 107),
  [3211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [3213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 136),
  [3216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 26),
  [3218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [3220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 108),
  [3222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(62),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [3231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [3233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [3235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 143),
  [3237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [3239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 10),
  [3241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(204),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [3246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 99),
  [3248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 99),
  [3250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 55),
  [3252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 55),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [3258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 79), REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [3261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 79),
  [3263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [3265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [3267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [3269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [3271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [3279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [3281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [3283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [3285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [3293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 5, .dynamic_precedence = -1, .production_id = 98),
  [3295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 5, .dynamic_precedence = -1, .production_id = 98),
  [3297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 5, .dynamic_precedence = -1, .production_id = 96),
  [3299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 5, .dynamic_precedence = -1, .production_id = 96),
  [3301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_fragment, 5),
  [3303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_fragment, 5),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [3309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 68), REDUCE(sym_assignment_expression, 3, .production_id = 68),
  [3312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 68),
  [3314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 137),
  [3316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 137),
  [3318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 118),
  [3320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 118),
  [3322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 117),
  [3324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 117),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [3328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 69), REDUCE(sym_assignment_expression, 3, .production_id = 69),
  [3331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 69),
  [3333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [3335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [3337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_closing_element, 4, .production_id = 130),
  [3339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_closing_element, 4, .production_id = 130),
  [3341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 147),
  [3343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 147),
  [3345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [3347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [3349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 114),
  [3351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 114),
  [3353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 112),
  [3355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 112),
  [3357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 111),
  [3359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 111),
  [3361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 79), REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [3364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 106),
  [3366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 106),
  [3368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_fragment, 6),
  [3370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_fragment, 6),
  [3372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 6, .dynamic_precedence = -1, .production_id = 129),
  [3374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 6, .dynamic_precedence = -1, .production_id = 129),
  [3376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(67),
  [3379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 108),
  [3381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 107),
  [3383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 106),
  [3385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 106),
  [3387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 105),
  [3389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 104),
  [3391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 104),
  [3393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [3395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2),
  [3397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [3399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [3401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [3409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [3411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [3413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [3415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [3419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [3421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 13),
  [3423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 13),
  [3425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [3427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [3429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 17),
  [3431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 17),
  [3433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 4, .dynamic_precedence = -1, .production_id = 48),
  [3435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 4, .dynamic_precedence = -1, .production_id = 48),
  [3437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 18),
  [3439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 18),
  [3441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 78),
  [3443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 78),
  [3445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_element, 2, .production_id = 19),
  [3447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_element, 2, .production_id = 19),
  [3449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [3451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 26),
  [3453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 71),
  [3455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_element, 3, .production_id = 70),
  [3457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_element, 3, .production_id = 70),
  [3459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 27),
  [3461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 27),
  [3463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 67),
  [3465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 67),
  [3467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(67),
  [3470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [3474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 2),
  [3476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [3478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [3480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [3484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [3492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [3494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [3496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [3508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 53),
  [3510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 53),
  [3512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 63),
  [3514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 61),
  [3516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 61),
  [3518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [3520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [3522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 54),
  [3524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 54),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [3530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [3532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [3534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [3536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [3538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 58),
  [3540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 58),
  [3542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 83),
  [3544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2),
  [3546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(61),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [3551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(66),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [3564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [3572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [3574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(916),
  [3577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(916),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [3582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 62),
  [3584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, .production_id = 143),
  [3586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [3590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [3592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [3594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [3596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [3604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [3606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [3608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [3616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 50),
  [3618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 50),
  [3620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [3622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(65),
  [3625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 69),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [3629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [3631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [3637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 68),
  [3639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(65),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [3644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(61),
  [3647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [3649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(66),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [3660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 3),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [3664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [3668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [3670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [3674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [3676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [3680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [3682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [3690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [3692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [3694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [3712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [3716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [3718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [3724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 65), SHIFT(63),
  [3727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [3729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1),
  [3731] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [3735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [3737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [3741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 80),
  [3743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [3746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [3748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [3785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(878),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [3790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(878),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [3795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [3797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [3799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [3801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(63),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [3808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(203),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [3813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(231),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [3824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [3826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [3832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [3834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [3836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [3838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [3840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1926),
  [3842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [3844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [3848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [3850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [3852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [3854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [3856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [3858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [3860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [3862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [3864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [3866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [3870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2121),
  [3873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2000),
  [3876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [3878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(201),
  [3881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1838),
  [3884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3581),
  [3887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2839),
  [3890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2838),
  [3893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2043),
  [3896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3127),
  [3899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1839),
  [3902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1987),
  [3905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1860),
  [3908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1845),
  [3911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1818),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [3921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [3923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [3926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [3932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [3934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2267),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [3938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [3940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [3942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [3944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [3946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [3952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [3956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [3958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [3960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [3962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [3964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [3968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 11), SHIFT(374),
  [3971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [3974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [3981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [3983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [3985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [3987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [3989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [3991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [3993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [3995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [3997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [4007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 12), SHIFT(376),
  [4010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [4018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [4028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2252),
  [4030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [4032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [4036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [4038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [4040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [4042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [4050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [4058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [4062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [4064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [4068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [4074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [4076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [4078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2327),
  [4080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [4082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [4084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [4086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [4088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [4092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [4096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [4098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [4102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [4106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2009),
  [4108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [4114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [4120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [4126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [4130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [4132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [4136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [4140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [4142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [4144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [4148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [4152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [4154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [4158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [4162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [4168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [4172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [4176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [4178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [4182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [4184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [4190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [4192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [4196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [4198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [4202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [4208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [4210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [4214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [4216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [4218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [4224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [4236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [4238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [4242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3416),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [4254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [4258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [4270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 29),
  [4272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 60),
  [4274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 60),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 18),
  [4286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 18),
  [4288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 81),
  [4290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 81),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [4296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [4298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 110),
  [4300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 110),
  [4302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 166),
  [4304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 166),
  [4306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 199),
  [4308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 199),
  [4310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 200),
  [4312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 200),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [4316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [4320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [4322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [4328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [4330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 190),
  [4332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 190),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [4336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [4338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 122),
  [4340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 122),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [4346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 205),
  [4348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 205),
  [4350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 172),
  [4352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 172),
  [4354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 191),
  [4356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 191),
  [4358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 139),
  [4360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 139),
  [4362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [4368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 150),
  [4370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 150),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [4374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2790),
  [4376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2641),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [4388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [4390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [4392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [4400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22),
  [4404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22),
  [4406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22), SHIFT_REPEAT(3127),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [4421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [4423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [4425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [4427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [4429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [4435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [4437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [4439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [4441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [4443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [4445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [4447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3418),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [4453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2367),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [4457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [4459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 14),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [4465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 14), SHIFT(3129),
  [4468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3631),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [4474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [4476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3676),
  [4478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3448),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [4506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_namespace_name, 3),
  [4508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_namespace_name, 3),
  [4510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14), REDUCE(sym_jsx_namespace_name, 3),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [4515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 165),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [4521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [4529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 130),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [4537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 48),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [4547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [4549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3533),
  [4551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 130),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [4555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3426),
  [4557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 165),
  [4559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [4563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 48),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [4571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [4579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14), REDUCE(sym_type_parameter, 1, .production_id = 14),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [4584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(801),
  [4587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 48),
  [4589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2),
  [4591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [4593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 165),
  [4595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 48),
  [4597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [4599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 130),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [4607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 130),
  [4609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 165),
  [4611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [4616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [4624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [4626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [4630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [4632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [4634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [4636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [4638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2230),
  [4640] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [4642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [4646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 21),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [4650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2522),
  [4652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [4654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [4658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [4660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2237),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2524),
  [4664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [4670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [4672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [4674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [4676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [4678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [4686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [4688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2503),
  [4690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [4692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [4696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [4698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [4710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3572),
  [4712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [4716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3425),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [4720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2487),
  [4722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [4725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2486),
  [4727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [4729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2484),
  [4731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2483),
  [4733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [4735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2479),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [4739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2475),
  [4741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [4745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3623),
  [4747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3622),
  [4749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3642),
  [4751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3481),
  [4753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3490),
  [4755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 97), SHIFT_REPEAT(2367),
  [4758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 97), SHIFT_REPEAT(154),
  [4761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 97),
  [4763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 97),
  [4765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 97), SHIFT_REPEAT(2367),
  [4768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3562),
  [4770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [4773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3),
  [4775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3507),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [4783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2),
  [4785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2392),
  [4787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [4789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [4791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3550),
  [4793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3401),
  [4795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3545),
  [4797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [4799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3400),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [4803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(158),
  [4806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(2662),
  [4809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(2230),
  [4812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3569),
  [4814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 5),
  [4816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2412),
  [4818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [4820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [4832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [4838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [4840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 134),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [4844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [4846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [4848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2283),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [4852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [4854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3551),
  [4856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 207),
  [4858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 202),
  [4860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 201),
  [4862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [4874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [4878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 194),
  [4880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [4884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 193),
  [4886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 6, .production_id = 157),
  [4888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 182),
  [4890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [4894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 181),
  [4896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 138),
  [4898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [4902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 158),
  [4904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, .production_id = 126),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [4910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 3),
  [4912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [4914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [4916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [4922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 109),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1),
  [4928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [4932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [4940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, .production_id = 100),
  [4942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [4950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 1, .production_id = 7),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [4954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 1, .production_id = 7),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [4958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3),
  [4960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [4964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [4968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [4970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3648),
  [4972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [4976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3564),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [4982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(1070),
  [4985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2),
  [4987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [5001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, .production_id = 66),
  [5003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3512),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [5021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 1),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [5025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 1),
  [5027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [5033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 20),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [5057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [5061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3624),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [5069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [5071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [5083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, .production_id = 72),
  [5085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [5087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [5091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(3420),
  [5094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [5096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(237),
  [5099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3582),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [5107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [5111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [5115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [5117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [5131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [5135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [5137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [5139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [5141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [5151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(2457),
  [5154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [5156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(234),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [5161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [5173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [5201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [5205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3424),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [5211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2874),
  [5213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3479),
  [5215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3505),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [5219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3546),
  [5221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3568),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [5229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [5231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [5249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [5255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [5257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [5259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [5261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [5263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [5267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [5269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2947),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3561),
  [5275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [5279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [5281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [5285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [5287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [5289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [5297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2880),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [5303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [5307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2816),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [5315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [5321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 132),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [5327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [5331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 132),
  [5333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 184),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [5343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 197),
  [5345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 206),
  [5347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 192),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [5359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 3),
  [5361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 3),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [5367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 1, .production_id = 49),
  [5369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 1, .production_id = 49),
  [5371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 41),
  [5373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 40),
  [5375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 93),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [5381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 92),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [5389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 84),
  [5391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 91),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [5397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, .production_id = 103),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [5401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [5405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 91),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3575),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [5411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 84),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [5415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [5419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 35),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [5423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 33),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [5427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 188),
  [5429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 3, .production_id = 7),
  [5431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 3, .production_id = 7),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [5435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [5437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 184),
  [5439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [5443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [5445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4),
  [5447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 31),
  [5449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [5453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 197),
  [5455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_expression, 2),
  [5457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_expression, 2),
  [5459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 188),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [5463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 192),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [5467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6),
  [5469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 160),
  [5471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 39),
  [5473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 162),
  [5475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 31),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [5481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [5485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [5489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_expression, 3),
  [5491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_expression, 3),
  [5493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 31),
  [5495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2),
  [5497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3),
  [5499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [5503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [5505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 160),
  [5507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 162),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [5513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [5517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [5521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2906),
  [5523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [5527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [5531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [5533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [5535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3043),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [5543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [5545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [5547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2868),
  [5549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [5551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [5553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [5555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2382),
  [5558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [5562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 1),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [5572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2974),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [5576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3101),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [5580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [5584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2873),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [5588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [5590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 3),
  [5592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [5596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [5600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2814),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [5604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 3, .production_id = 52),
  [5606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 52),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [5620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2815),
  [5622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [5626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2857),
  [5628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, .production_id = 14),
  [5630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [5632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2858),
  [5634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [5636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [5648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [5654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1),
  [5656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3104),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [5660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [5670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2984),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [5686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 14),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [5696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(164),
  [5699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [5701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [5703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2902),
  [5705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [5707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2907),
  [5709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [5711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2866),
  [5713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [5715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2669),
  [5717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [5719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2903),
  [5722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2903),
  [5725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(163),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [5730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [5732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2906),
  [5735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2906),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [5748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [5752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2923),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [5756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2924),
  [5758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [5766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [5770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2925),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [5778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2928),
  [5780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [5782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2294),
  [5784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [5788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2813),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [5796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [5800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2818),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [5808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [5810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [5812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2),
  [5814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(139),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [5821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [5829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [5833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 186),
  [5835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [5837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, .production_id = 120),
  [5839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 181),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [5843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 185),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [5849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [5851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [5853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [5855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 183),
  [5857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [5859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [5861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [5863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [5865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [5867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [5869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [5871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(1907),
  [5874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 22),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [5878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(1794),
  [5881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [5883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [5885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [5887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [5889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [5891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [5893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [5895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2824),
  [5898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [5902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 187),
  [5904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 182),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [5912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_identifier, 1),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [5918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 87),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [5932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(2896),
  [5935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [5937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [5939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [5941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [5943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_identifier, 2),
  [5945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 96),
  [5947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 30),
  [5949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [5953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 159),
  [5955] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1988),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [5970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [5974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, .production_id = 120),
  [5976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3086),
  [5978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3553),
  [5980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 85),
  [5982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 161),
  [5984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 98),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [5988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [5992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1),
  [5994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3),
  [5996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 163),
  [5998] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(837),
  [6001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 84),
  [6003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [6007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 2, .production_id = 48),
  [6009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [6011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 138),
  [6013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 158),
  [6015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 195),
  [6017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 196),
  [6019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 30),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [6023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 164),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [6029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 198),
  [6031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [6033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, .production_id = 193),
  [6035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 32),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [6043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(871),
  [6046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(3178),
  [6049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [6053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 34),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [6061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__tuple_type_body_repeat1, 2), SHIFT_REPEAT(2269),
  [6064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__tuple_type_body_repeat1, 2),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [6074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 85),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [6082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 86),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [6094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 133),
  [6096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [6100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 203),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [6112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, .production_id = 109),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [6128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 3, .dynamic_precedence = -1, .production_id = 48),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [6132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 5, .dynamic_precedence = -1, .production_id = 129),
  [6134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [6140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [6144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [6148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [6158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 131),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [6164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [6170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [6172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 2),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [6176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [6178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 42),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [6182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [6186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, .production_id = 42),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [6194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 4, .production_id = 149),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [6200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 14),
  [6202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, .production_id = 127),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [6206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [6214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 3, .production_id = 125),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [6220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_tuple_type_member, 2),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [6226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 74),
  [6228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6),
  [6230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 82),
  [6232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3097),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [6236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [6240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 3, .production_id = 119),
  [6242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 120),
  [6244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [6254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, .production_id = 94),
  [6256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [6258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 94),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [6264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [6266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [6270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [6274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [6276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [6278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [6292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [6304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [6310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [6316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3461),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [6320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [6334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [6336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [6348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [6368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [6370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, .production_id = 82),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [6402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [6404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, .production_id = 82),
  [6406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [6408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [6410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [6412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [6416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [6428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [6430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [6432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [6434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [6436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [6442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [6448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [6450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [6454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [6456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [6458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [6468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [6470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [6472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [6480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [6482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [6484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [6486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [6488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [6490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [6492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [6494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [6496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [6498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [6500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [6502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [6504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [6508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [6510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [6514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [6516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [6520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [6522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [6526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [6528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [6532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [6536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [6538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [6540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [6542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [6544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [6546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [6548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [6550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [6552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [6554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [6560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [6564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [6568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [6572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [6584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [6586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [6588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [6592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [6594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [6602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [6604] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [6606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [6608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [6610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [6612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [6614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [6616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [6618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [6620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [6622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [6624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [6626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [6632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [6634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [6638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [6640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, .production_id = 82),
  [6642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [6644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [6646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [6648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [6650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [6652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [6654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [6656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [6658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3522),
  [6660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [6670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [6672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [6674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [6678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [6680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3498),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [6690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import, 3),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_tsx_external_scanner_create(void);
void tree_sitter_tsx_external_scanner_destroy(void *);
bool tree_sitter_tsx_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_tsx_external_scanner_serialize(void *, char *);
void tree_sitter_tsx_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_tsx(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const uint16_t *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_tsx_external_scanner_create,
      tree_sitter_tsx_external_scanner_destroy,
      tree_sitter_tsx_external_scanner_scan,
      tree_sitter_tsx_external_scanner_serialize,
      tree_sitter_tsx_external_scanner_deserialize,
    },
    .field_count = FIELD_COUNT,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .field_names = ts_field_names,
    .large_state_count = LARGE_STATE_COUNT,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .state_count = STATE_COUNT,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
